/*! For license information please see module.js.LICENSE.txt */
define(["@grafana/data","rxjs","@grafana/runtime","lodash","react","@grafana/ui","@emotion/css","moment","redux","react-redux"],((e,t,r,n,o,i,a,s,l,u)=>(()=>{var c={8572:(e,t,r)=>{"use strict";r.r(t),r.d(t,{AND:()=>h,AS:()=>f,ASC:()=>c,BY:()=>l,COMPARISON_OPERATORS:()=>E,DESC:()=>u,EQUALS:()=>m,FROM:()=>o,GROUP:()=>a,LIMIT:()=>d,LOGICAL_OPERATORS:()=>y,NOT_EQUALS:()=>b,OR:()=>g,ORDER:()=>s,SCHEMA:()=>v,SELECT:()=>n,STD_OPERATORS:()=>O,WHERE:()=>i,WITH:()=>p,conf:()=>S,language:()=>T});const n="select",o="from",i="where",a="group",s="order",l="by",u="desc",c="asc",d="limit",p="with",f="as",v="schema",h="AND",g="OR",y=[h,g],m="=",b="!=",E=[m,b],O=[...E],S={comments:{lineComment:"--",blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"],["(",")"]],autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}],surroundingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}]},T={defaultToken:"",tokenPostfix:".sql",ignoreCase:!0,brackets:[{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"}],keywords:["ABORT","ABSOLUTE","ACTION","ADA","ADD","AFTER","ALL","ALLOCATE","ALTER","ALWAYS","ANALYZE","AND","ANY","ARE","AS","ASC","ASSERTION","AT","ATTACH","AUTHORIZATION","AUTOINCREMENT","AVG","BACKUP","BEFORE","BEGIN","BETWEEN","BIT","BIT_LENGTH","BOTH","BREAK","BROWSE","BULK","BY","CASCADE","CASCADED","CASE","CAST","CATALOG","CHAR","CHARACTER","CHARACTER_LENGTH","CHAR_LENGTH","CHECK","CHECKPOINT","CLOSE","CLUSTERED","COALESCE","COLLATE","COLLATION","COLUMN","COMMIT","COMPUTE","CONFLICT","CONNECT","CONNECTION","CONSTRAINT","CONSTRAINTS","CONTAINS","CONTAINSTABLE","CONTINUE","CONVERT","CORRESPONDING","COUNT","CREATE","CROSS","CURRENT","CURRENT_DATE","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_USER","CURSOR","DATABASE","DATE","DAY","DBCC","DEALLOCATE","DEC","DECIMAL","DECLARE","DEFAULT","DEFERRABLE","DEFERRED","DELETE","DENY","DESC","DESCRIBE","DESCRIPTOR","DETACH","DIAGNOSTICS","DISCONNECT","DISK","DISTINCT","DISTRIBUTED","DO","DOMAIN","DOUBLE","DROP","DUMP","EACH","ELSE","END","END-EXEC","ERRLVL","ESCAPE","EXCEPT","EXCEPTION","EXCLUDE","EXCLUSIVE","EXEC","EXECUTE","EXISTS","EXIT","EXPLAIN","EXTERNAL","EXTRACT","FAIL","FALSE","FETCH","FILE","FILLFACTOR","FILTER","FIRST","FLOAT","FOLLOWING","FOR","FOREIGN","FORTRAN","FOUND","FREETEXT","FREETEXTTABLE","FROM","FULL","FUNCTION","GENERATED","GET","GLOB","GLOBAL","GO","GOTO","GRANT","GROUP","GROUPS","HAVING","HOLDLOCK","HOUR","IDENTITY","IDENTITYCOL","IDENTITY_INSERT","IF","IGNORE","IMMEDIATE","IN","INCLUDE","INDEX","INDEXED","INDICATOR","INITIALLY","INNER","INPUT","INSENSITIVE","INSERT","INSTEAD","INT","INTEGER","INTERSECT","INTERVAL","INTO","IS","ISNULL","ISOLATION","JOIN","KEY","KILL","LANGUAGE","LAST","LEADING","LEFT","LEVEL","LIKE","LIMIT","LINENO","LOAD","LOCAL","LOWER","MATCH","MATERIALIZED","MAX","MERGE","MIN","MINUTE","MODULE","MONTH","NAMES","NATIONAL","NATURAL","NCHAR","NEXT","NO","NOCHECK","NONCLUSTERED","NONE","NOT","NOTHING","NOTNULL","NULL","NULLIF","NULLS","NUMERIC","OCTET_LENGTH","OF","OFF","OFFSET","OFFSETS","ON","ONLY","OPEN","OPENDATASOURCE","OPENQUERY","OPENROWSET","OPENXML","OPTION","OR","ORDER","OTHERS","OUTER","OUTPUT","OVER","OVERLAPS","PAD","PARTIAL","PARTITION","PASCAL","PERCENT","PIVOT","PLAN","POSITION","PRAGMA","PRECEDING","PRECISION","PREPARE","PRESERVE","PRIMARY","PRINT","PRIOR","PRIVILEGES","PROC","PROCEDURE","PUBLIC","QUERY","RAISE","RAISERROR","RANGE","READ","READTEXT","REAL","RECONFIGURE","RECURSIVE","REFERENCES","REGEXP","REINDEX","RELATIVE","RELEASE","RENAME","REPLACE","REPLICATION","RESTORE","RESTRICT","RETURN","RETURNING","REVERT","REVOKE","RIGHT","ROLLBACK","ROW","ROWCOUNT","ROWGUIDCOL","ROWS","RULE","SAVE","SAVEPOINT","SCHEMA","SCROLL","SECOND","SECTION","SECURITYAUDIT","SELECT","SEMANTICKEYPHRASETABLE","SEMANTICSIMILARITYDETAILSTABLE","SEMANTICSIMILARITYTABLE","SESSION","SESSION_USER","SET","SETUSER","SHUTDOWN","SIZE","SMALLINT","SOME","SPACE","SQL","SQLCA","SQLCODE","SQLERROR","SQLSTATE","SQLWARNING","STATISTICS","SUBSTRING","SUM","SYSTEM_USER","TABLE","TABLESAMPLE","TEMP","TEMPORARY","TEXTSIZE","THEN","TIES","TIME","TIMESTAMP","TIMEZONE_HOUR","TIMEZONE_MINUTE","TO","TOP","TRAILING","TRAN","TRANSACTION","TRANSLATE","TRANSLATION","TRIGGER","TRIM","TRUE","TRUNCATE","TRY_CONVERT","TSEQUAL","UNBOUNDED","UNION","UNIQUE","UNKNOWN","UNPIVOT","UPDATE","UPDATETEXT","UPPER","USAGE","USE","USER","USING","VACUUM","VALUE","VALUES","VARCHAR","VARYING","VIEW","VIRTUAL","WAITFOR","WHEN","WHENEVER","WHERE","WHILE","WINDOW","WITH","WITHIN GROUP","WITHOUT","WORK","WRITE","WRITETEXT","YEAR","ZONE"],operators:["EXCEPT","INTERSECT","UNION","APPLY","CROSS","FULL","INNER","JOIN","LEFT","OUTER","RIGHT","CONTAINS","FREETEXT","IS","NULL","PIVOT","UNPIVOT","MATCHED"],logicalOperators:["ALL","AND","ANY","BETWEEN","EXISTS","IN","LIKE","NOT","OR","SOME"],comparisonOperators:["<>",">","<",">=","<=","=","!=","&","~","^","%"],builtinFunctions:["AVG","CHECKSUM_AGG","COUNT","COUNT_BIG","GROUPING","GROUPING_ID","MAX","MIN","SUM","STDEV","STDEVP","VAR","VARP","CUME_DIST","FIRST_VALUE","LAG","LAST_VALUE","LEAD","PERCENTILE_CONT","PERCENTILE_DISC","PERCENT_RANK","COLLATE","COLLATIONPROPERTY","TERTIARY_WEIGHTS","FEDERATION_FILTERING_VALUE","CAST","CONVERT","PARSE","TRY_CAST","TRY_CONVERT","TRY_PARSE","ASYMKEY_ID","ASYMKEYPROPERTY","CERTPROPERTY","CERT_ID","CRYPT_GEN_RANDOM","DECRYPTBYASYMKEY","DECRYPTBYCERT","DECRYPTBYKEY","DECRYPTBYKEYAUTOASYMKEY","DECRYPTBYKEYAUTOCERT","DECRYPTBYPASSPHRASE","ENCRYPTBYASYMKEY","ENCRYPTBYCERT","ENCRYPTBYKEY","ENCRYPTBYPASSPHRASE","HASHBYTES","IS_OBJECTSIGNED","KEY_GUID","KEY_ID","KEY_NAME","SIGNBYASYMKEY","SIGNBYCERT","SYMKEYPROPERTY","VERIFYSIGNEDBYCERT","VERIFYSIGNEDBYASYMKEY","CURSOR_STATUS","DATALENGTH","IDENT_CURRENT","IDENT_INCR","IDENT_SEED","IDENTITY","SQL_VARIANT_PROPERTY","CURRENT_TIMESTAMP","DATEADD","DATEDIFF","DATEFROMPARTS","DATENAME","DATEPART","DATETIME2FROMPARTS","DATETIMEFROMPARTS","DATETIMEOFFSETFROMPARTS","DAY","EOMONTH","GETDATE","GETUTCDATE","ISDATE","MONTH","SMALLDATETIMEFROMPARTS","SWITCHOFFSET","SYSDATETIME","SYSDATETIMEOFFSET","SYSUTCDATETIME","TIMEFROMPARTS","TODATETIMEOFFSET","YEAR","CHOOSE","COALESCE","IIF","NULLIF","ABS","ACOS","ASIN","ATAN","ATN2","CEILING","COS","COT","DEGREES","EXP","FLOOR","LOG","LOG10","PI","POWER","RADIANS","RAND","ROUND","SIGN","SIN","SQRT","SQUARE","TAN","APP_NAME","APPLOCK_MODE","APPLOCK_TEST","ASSEMBLYPROPERTY","COL_LENGTH","COL_NAME","COLUMNPROPERTY","DATABASE_PRINCIPAL_ID","DATABASEPROPERTYEX","DB_ID","DB_NAME","FILE_ID","FILE_IDEX","FILE_NAME","FILEGROUP_ID","FILEGROUP_NAME","FILEGROUPPROPERTY","FILEPROPERTY","FULLTEXTCATALOGPROPERTY","FULLTEXTSERVICEPROPERTY","INDEX_COL","INDEXKEY_PROPERTY","INDEXPROPERTY","OBJECT_DEFINITION","OBJECT_ID","OBJECT_NAME","OBJECT_SCHEMA_NAME","OBJECTPROPERTY","OBJECTPROPERTYEX","ORIGINAL_DB_NAME","PARSENAME","SCHEMA_ID","SCHEMA_NAME","SCOPE_IDENTITY","SERVERPROPERTY","STATS_DATE","TYPE_ID","TYPE_NAME","TYPEPROPERTY","DENSE_RANK","NTILE","RANK","ROW_NUMBER","PUBLISHINGSERVERNAME","OPENDATASOURCE","OPENQUERY","OPENROWSET","OPENXML","CERTENCODED","CERTPRIVATEKEY","CURRENT_USER","HAS_DBACCESS","HAS_PERMS_BY_NAME","IS_MEMBER","IS_ROLEMEMBER","IS_SRVROLEMEMBER","LOGINPROPERTY","ORIGINAL_LOGIN","PERMISSIONS","PWDENCRYPT","PWDCOMPARE","SESSION_USER","SESSIONPROPERTY","SUSER_ID","SUSER_NAME","SUSER_SID","SUSER_SNAME","SYSTEM_USER","USER","USER_ID","USER_NAME","ASCII","CHAR","CHARINDEX","CONCAT","DIFFERENCE","FORMAT","LEFT","LEN","LOWER","LTRIM","NCHAR","PATINDEX","QUOTENAME","REPLACE","REPLICATE","REVERSE","RIGHT","RTRIM","SOUNDEX","SPACE","STR","STUFF","SUBSTRING","UNICODE","UPPER","BINARY_CHECKSUM","CHECKSUM","CONNECTIONPROPERTY","CONTEXT_INFO","CURRENT_REQUEST_ID","ERROR_LINE","ERROR_NUMBER","ERROR_MESSAGE","ERROR_PROCEDURE","ERROR_SEVERITY","ERROR_STATE","FORMATMESSAGE","GETANSINULL","GET_FILESTREAM_TRANSACTION_CONTEXT","HOST_ID","HOST_NAME","ISNULL","ISNUMERIC","MIN_ACTIVE_ROWVERSION","NEWID","NEWSEQUENTIALID","ROWCOUNT_BIG","XACT_STATE","TEXTPTR","TEXTVALID","COLUMNS_UPDATED","EVENTDATA","TRIGGER_NESTLEVEL","UPDATE","CHANGETABLE","CHANGE_TRACKING_CONTEXT","CHANGE_TRACKING_CURRENT_VERSION","CHANGE_TRACKING_IS_COLUMN_IN_MASK","CHANGE_TRACKING_MIN_VALID_VERSION","CONTAINSTABLE","FREETEXTTABLE","SEMANTICKEYPHRASETABLE","SEMANTICSIMILARITYDETAILSTABLE","SEMANTICSIMILARITYTABLE","FILETABLEROOTPATH","GETFILENAMESPACEPATH","GETPATHLOCATOR","PATHNAME","GET_TRANSMISSION_STATUS"],builtinVariables:["@@DATEFIRST","@@DBTS","@@LANGID","@@LANGUAGE","@@LOCK_TIMEOUT","@@MAX_CONNECTIONS","@@MAX_PRECISION","@@NESTLEVEL","@@OPTIONS","@@REMSERVER","@@SERVERNAME","@@SERVICENAME","@@SPID","@@TEXTSIZE","@@VERSION","@@CURSOR_ROWS","@@FETCH_STATUS","@@DATEFIRST","@@PROCID","@@ERROR","@@IDENTITY","@@ROWCOUNT","@@TRANCOUNT","@@CONNECTIONS","@@CPU_BUSY","@@IDLE","@@IO_BUSY","@@PACKET_ERRORS","@@PACK_RECEIVED","@@PACK_SENT","@@TIMETICKS","@@TOTAL_ERRORS","@@TOTAL_READ","@@TOTAL_WRITE"],pseudoColumns:["$ACTION","$IDENTITY","$ROWGUID","$PARTITION"],tokenizer:{root:[{include:"@templateVariables"},{include:"@macros"},{include:"@comments"},{include:"@whitespace"},{include:"@pseudoColumns"},{include:"@numbers"},{include:"@strings"},{include:"@complexIdentifiers"},{include:"@scopes"},{include:"@schemaTable"},[/[;,.]/,"delimiter"],[/[()]/,"@brackets"],[/[\w@#$|<|>|=|!|%|&|+|\|-|*|/|~|^]+/,{cases:{"@operators":"operator","@comparisonOperators":"operator","@logicalOperators":"operator","@builtinVariables":"predefined","@builtinFunctions":"predefined","@keywords":"keyword","@default":"identifier"}}]],templateVariables:[[/\$[a-zA-Z0-9]+/,"variable"]],macros:[[/\$__[a-zA-Z0-9-_]+/,"type"]],schemaTable:[[/(\w+)\./,"identifier"],[/(\w+\.\w+)/,"identifier"]],whitespace:[[/\s+/,"white"]],comments:[[/--+.*/,"comment"],[/\/\*/,{token:"comment.quote",next:"@comment"}]],comment:[[/[^*/]+/,"comment"],[/\*\//,{token:"comment.quote",next:"@pop"}],[/./,"comment"]],pseudoColumns:[[/[$][A-Za-z_][\w@#$]*/,{cases:{"@pseudoColumns":"predefined","@default":"identifier"}}]],numbers:[[/0[xX][0-9a-fA-F]*/,"number"],[/[$][+-]*\d*(\.\d*)?/,"number"],[/((\d+(\.\d*)?)|(\.\d+))([eE][\-+]?\d+)?/,"number"]],strings:[[/N'/,{token:"string",next:"@string"}],[/'/,{token:"string",next:"@string"}]],string:[[/[^']+/,"string"],[/''/,"string"],[/'/,{token:"string",next:"@pop"}]],complexIdentifiers:[[/\[/,{token:"identifier.quote",next:"@bracketedIdentifier"}],[/"/,{token:"identifier.quote",next:"@quotedIdentifier"}]],bracketedIdentifier:[[/[^\]]+/,"identifier"],[/]]/,"identifier"],[/]/,{token:"identifier.quote",next:"@pop"}]],quotedIdentifier:[[/[^"]+/,"identifier"],[/""/,"identifier"],[/"/,{token:"identifier.quote",next:"@pop"}]],scopes:[[/BEGIN\s+(DISTRIBUTED\s+)?TRAN(SACTION)?\b/i,"keyword"],[/BEGIN\s+TRY\b/i,{token:"keyword.try"}],[/END\s+TRY\b/i,{token:"keyword.try"}],[/BEGIN\s+CATCH\b/i,{token:"keyword.catch"}],[/END\s+CATCH\b/i,{token:"keyword.catch"}],[/(BEGIN|CASE)\b/i,{token:"keyword.block"}],[/END\b/i,{token:"keyword.block"}],[/WHEN\b/i,{token:"keyword.choice"}],[/THEN\b/i,{token:"keyword.choice"}]]}}},3523:e=>{var t=function(){"use strict";function e(e,t){return null!=t&&e instanceof t}var t,r,n;try{t=Map}catch(e){t=function(){}}try{r=Set}catch(e){r=function(){}}try{n=Promise}catch(e){n=function(){}}function o(i,s,l,u,c){"object"==typeof s&&(l=s.depth,u=s.prototype,c=s.includeNonEnumerable,s=s.circular);var d=[],p=[],f="undefined"!=typeof Buffer;return void 0===s&&(s=!0),void 0===l&&(l=1/0),function i(l,v){if(null===l)return null;if(0===v)return l;var h,g;if("object"!=typeof l)return l;if(e(l,t))h=new t;else if(e(l,r))h=new r;else if(e(l,n))h=new n((function(e,t){l.then((function(t){e(i(t,v-1))}),(function(e){t(i(e,v-1))}))}));else if(o.__isArray(l))h=[];else if(o.__isRegExp(l))h=new RegExp(l.source,a(l)),l.lastIndex&&(h.lastIndex=l.lastIndex);else if(o.__isDate(l))h=new Date(l.getTime());else{if(f&&Buffer.isBuffer(l))return h=Buffer.allocUnsafe?Buffer.allocUnsafe(l.length):new Buffer(l.length),l.copy(h),h;e(l,Error)?h=Object.create(l):void 0===u?(g=Object.getPrototypeOf(l),h=Object.create(g)):(h=Object.create(u),g=u)}if(s){var y=d.indexOf(l);if(-1!=y)return p[y];d.push(l),p.push(h)}for(var m in e(l,t)&&l.forEach((function(e,t){var r=i(t,v-1),n=i(e,v-1);h.set(r,n)})),e(l,r)&&l.forEach((function(e){var t=i(e,v-1);h.add(t)})),l){var b;g&&(b=Object.getOwnPropertyDescriptor(g,m)),b&&null==b.set||(h[m]=i(l[m],v-1))}if(Object.getOwnPropertySymbols){var E=Object.getOwnPropertySymbols(l);for(m=0;m<E.length;m++){var O=E[m];(!(T=Object.getOwnPropertyDescriptor(l,O))||T.enumerable||c)&&(h[O]=i(l[O],v-1),T.enumerable||Object.defineProperty(h,O,{enumerable:!1}))}}if(c){var S=Object.getOwnPropertyNames(l);for(m=0;m<S.length;m++){var T,_=S[m];(T=Object.getOwnPropertyDescriptor(l,_))&&T.enumerable||(h[_]=i(l[_],v-1),Object.defineProperty(h,_,{enumerable:!1}))}}return h}(i,l)}function i(e){return Object.prototype.toString.call(e)}function a(e){var t="";return e.global&&(t+="g"),e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),t}return o.clonePrototype=function(e){if(null===e)return null;var t=function(){};return t.prototype=e,new t},o.__objToStr=i,o.__isDate=function(e){return"object"==typeof e&&"[object Date]"===i(e)},o.__isArray=function(e){return"object"==typeof e&&"[object Array]"===i(e)},o.__isRegExp=function(e){return"object"==typeof e&&"[object RegExp]"===i(e)},o.__getRegExpFlags=a,o}();e.exports&&(e.exports=t)},4221:(e,t,r)=>{"use strict";var n=r(1882),o={"text/plain":"Text","text/html":"Url",default:"Text"};e.exports=function(e,t){var r,i,a,s,l,u,c=!1;t||(t={}),r=t.debug||!1;try{if(a=n(),s=document.createRange(),l=document.getSelection(),(u=document.createElement("span")).textContent=e,u.style.all="unset",u.style.position="fixed",u.style.top=0,u.style.clip="rect(0, 0, 0, 0)",u.style.whiteSpace="pre",u.style.webkitUserSelect="text",u.style.MozUserSelect="text",u.style.msUserSelect="text",u.style.userSelect="text",u.addEventListener("copy",(function(n){if(n.stopPropagation(),t.format)if(n.preventDefault(),void 0===n.clipboardData){r&&console.warn("unable to use e.clipboardData"),r&&console.warn("trying IE specific stuff"),window.clipboardData.clearData();var i=o[t.format]||o.default;window.clipboardData.setData(i,e)}else n.clipboardData.clearData(),n.clipboardData.setData(t.format,e);t.onCopy&&(n.preventDefault(),t.onCopy(n.clipboardData))})),document.body.appendChild(u),s.selectNodeContents(u),l.addRange(s),!document.execCommand("copy"))throw new Error("copy command was unsuccessful");c=!0}catch(n){r&&console.error("unable to copy using execCommand: ",n),r&&console.warn("trying IE specific stuff");try{window.clipboardData.setData(t.format||"text",e),t.onCopy&&t.onCopy(window.clipboardData),c=!0}catch(n){r&&console.error("unable to copy using clipboardData: ",n),r&&console.error("falling back to prompt"),i=function(e){var t=(/mac os x/i.test(navigator.userAgent)?"⌘":"Ctrl")+"+C";return e.replace(/#{\s*key\s*}/g,t)}("message"in t?t.message:"Copy to clipboard: #{key}, Enter"),window.prompt(i,e)}}finally{l&&("function"==typeof l.removeRange?l.removeRange(s):l.removeAllRanges()),u&&document.body.removeChild(u),a()}return c}},502:function(e,t,r){var n,o;n=function(){"use strict";Array.isArray||(Array.isArray=function(e){return"[object Array]"===Object.prototype.toString.call(e)});var e={},t={"==":function(e,t){return e==t},"===":function(e,t){return e===t},"!=":function(e,t){return e!=t},"!==":function(e,t){return e!==t},">":function(e,t){return e>t},">=":function(e,t){return e>=t},"<":function(e,t,r){return void 0===r?e<t:e<t&&t<r},"<=":function(e,t,r){return void 0===r?e<=t:e<=t&&t<=r},"!!":function(t){return e.truthy(t)},"!":function(t){return!e.truthy(t)},"%":function(e,t){return e%t},log:function(e){return console.log(e),e},in:function(e,t){return!(!t||void 0===t.indexOf)&&-1!==t.indexOf(e)},cat:function(){return Array.prototype.join.call(arguments,"")},substr:function(e,t,r){if(r<0){var n=String(e).substr(t);return n.substr(0,n.length+r)}return String(e).substr(t,r)},"+":function(){return Array.prototype.reduce.call(arguments,(function(e,t){return parseFloat(e,10)+parseFloat(t,10)}),0)},"*":function(){return Array.prototype.reduce.call(arguments,(function(e,t){return parseFloat(e,10)*parseFloat(t,10)}))},"-":function(e,t){return void 0===t?-e:e-t},"/":function(e,t){return e/t},min:function(){return Math.min.apply(this,arguments)},max:function(){return Math.max.apply(this,arguments)},merge:function(){return Array.prototype.reduce.call(arguments,(function(e,t){return e.concat(t)}),[])},var:function(e,t){var r=void 0===t?null:t,n=this;if(void 0===e||""===e||null===e)return n;for(var o=String(e).split("."),i=0;i<o.length;i++){if(null==n)return r;if(void 0===(n=n[o[i]]))return r}return n},missing:function(){for(var t=[],r=Array.isArray(arguments[0])?arguments[0]:arguments,n=0;n<r.length;n++){var o=r[n],i=e.apply({var:o},this);null!==i&&""!==i||t.push(o)}return t},missing_some:function(t,r){var n=e.apply({missing:r},this);return r.length-n.length>=t?[]:n}};return e.is_logic=function(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)&&1===Object.keys(e).length},e.truthy=function(e){return!(Array.isArray(e)&&0===e.length||!e)},e.get_operator=function(e){return Object.keys(e)[0]},e.get_values=function(t){return t[e.get_operator(t)]},e.apply=function(r,n){if(Array.isArray(r))return r.map((function(t){return e.apply(t,n)}));if(!e.is_logic(r))return r;var o,i,a,s,l,u=e.get_operator(r),c=r[u];if(Array.isArray(c)||(c=[c]),"if"===u||"?:"==u){for(o=0;o<c.length-1;o+=2)if(e.truthy(e.apply(c[o],n)))return e.apply(c[o+1],n);return c.length===o+1?e.apply(c[o],n):null}if("and"===u){for(o=0;o<c.length;o+=1)if(i=e.apply(c[o],n),!e.truthy(i))return i;return i}if("or"===u){for(o=0;o<c.length;o+=1)if(i=e.apply(c[o],n),e.truthy(i))return i;return i}if("filter"===u)return s=e.apply(c[0],n),a=c[1],Array.isArray(s)?s.filter((function(t){return e.truthy(e.apply(a,t))})):[];if("map"===u)return s=e.apply(c[0],n),a=c[1],Array.isArray(s)?s.map((function(t){return e.apply(a,t)})):[];if("reduce"===u)return s=e.apply(c[0],n),a=c[1],l=void 0!==c[2]?c[2]:null,Array.isArray(s)?s.reduce((function(t,r){return e.apply(a,{current:r,accumulator:t})}),l):l;if("all"===u){if(s=e.apply(c[0],n),a=c[1],!Array.isArray(s)||!s.length)return!1;for(o=0;o<s.length;o+=1)if(!e.truthy(e.apply(a,s[o])))return!1;return!0}if("none"===u){if(s=e.apply(c[0],n),a=c[1],!Array.isArray(s)||!s.length)return!0;for(o=0;o<s.length;o+=1)if(e.truthy(e.apply(a,s[o])))return!1;return!0}if("some"===u){if(s=e.apply(c[0],n),a=c[1],!Array.isArray(s)||!s.length)return!1;for(o=0;o<s.length;o+=1)if(e.truthy(e.apply(a,s[o])))return!0;return!1}if(c=c.map((function(t){return e.apply(t,n)})),t.hasOwnProperty(u)&&"function"==typeof t[u])return t[u].apply(n,c);if(u.indexOf(".")>0){var d=String(u).split("."),p=t;for(o=0;o<d.length;o++){if(!p.hasOwnProperty(d[o]))throw new Error("Unrecognized operation "+u+" (failed at "+d.slice(0,o+1).join(".")+")");p=p[d[o]]}return p.apply(n,c)}throw new Error("Unrecognized operation "+u)},e.uses_data=function(t){var r=[];if(e.is_logic(t)){var n=e.get_operator(t),o=t[n];Array.isArray(o)||(o=[o]),"var"===n?r.push(o[0]):o.forEach((function(t){r.push.apply(r,e.uses_data(t))}))}return function(e){for(var t=[],r=0,n=e.length;r<n;r++)-1===t.indexOf(e[r])&&t.push(e[r]);return t}(r)},e.add_operation=function(e,r){t[e]=r},e.rm_operation=function(e){delete t[e]},e.rule_like=function(t,r){if(r===t)return!0;if("@"===r)return!0;if("number"===r)return"number"==typeof t;if("string"===r)return"string"==typeof t;if("array"===r)return Array.isArray(t)&&!e.is_logic(t);if(e.is_logic(r)){if(e.is_logic(t)){var n=e.get_operator(r),o=e.get_operator(t);if("@"===n||n===o)return e.rule_like(e.get_values(t,!1),e.get_values(r,!1))}return!1}if(Array.isArray(r)){if(Array.isArray(t)){if(r.length!==t.length)return!1;for(var i=0;i<r.length;i+=1)if(!e.rule_like(t[i],r[i]))return!1;return!0}return!1}return!1},e},void 0===(o=n.call(t,r,t,e))||(e.exports=o)},5948:(e,t,r)=>{var n=r(2062)(r(9965),"DataView");e.exports=n},4845:(e,t,r)=>{var n=r(5504),o=r(5270),i=r(4769),a=r(2637),s=r(1077);function l(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}l.prototype.clear=n,l.prototype.delete=o,l.prototype.get=i,l.prototype.has=a,l.prototype.set=s,e.exports=l},1999:(e,t,r)=>{var n=r(7718),o=r(4272),i=r(5107),a=r(1055),s=r(4647);function l(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}l.prototype.clear=n,l.prototype.delete=o,l.prototype.get=i,l.prototype.has=a,l.prototype.set=s,e.exports=l},5455:(e,t,r)=>{var n=r(2062)(r(9965),"Map");e.exports=n},1549:(e,t,r)=>{var n=r(6400),o=r(7014),i=r(1793),a=r(6429),s=r(821);function l(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}l.prototype.clear=n,l.prototype.delete=o,l.prototype.get=i,l.prototype.has=a,l.prototype.set=s,e.exports=l},6420:(e,t,r)=>{var n=r(2062)(r(9965),"Promise");e.exports=n},2833:(e,t,r)=>{var n=r(2062)(r(9965),"Set");e.exports=n},8283:(e,t,r)=>{var n=r(1549),o=r(228),i=r(3683);function a(e){var t=-1,r=null==e?0:e.length;for(this.__data__=new n;++t<r;)this.add(e[t])}a.prototype.add=a.prototype.push=o,a.prototype.has=i,e.exports=a},8545:(e,t,r)=>{var n=r(1999),o=r(5052),i=r(4250),a=r(4773),s=r(6921),l=r(5745);function u(e){var t=this.__data__=new n(e);this.size=t.size}u.prototype.clear=o,u.prototype.delete=i,u.prototype.get=a,u.prototype.has=s,u.prototype.set=l,e.exports=u},2609:(e,t,r)=>{var n=r(9965).Symbol;e.exports=n},3604:(e,t,r)=>{var n=r(9965).Uint8Array;e.exports=n},8143:(e,t,r)=>{var n=r(2062)(r(9965),"WeakMap");e.exports=n},1929:e=>{e.exports=function(e,t,r){switch(r.length){case 0:return e.call(t);case 1:return e.call(t,r[0]);case 2:return e.call(t,r[0],r[1]);case 3:return e.call(t,r[0],r[1],r[2])}return e.apply(t,r)}},6433:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length;++r<n&&!1!==t(e[r],r,e););return e}},9386:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length,o=0,i=[];++r<n;){var a=e[r];t(a,r,e)&&(i[o++]=a)}return i}},6791:(e,t,r)=>{var n=r(2784),o=r(5196),i=r(4913),a=r(4264),s=r(6665),l=r(5087),u=Object.prototype.hasOwnProperty;e.exports=function(e,t){var r=i(e),c=!r&&o(e),d=!r&&!c&&a(e),p=!r&&!c&&!d&&l(e),f=r||c||d||p,v=f?n(e.length,String):[],h=v.length;for(var g in e)!t&&!u.call(e,g)||f&&("length"==g||d&&("offset"==g||"parent"==g)||p&&("buffer"==g||"byteLength"==g||"byteOffset"==g)||s(g,h))||v.push(g);return v}},1428:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length,o=Array(n);++r<n;)o[r]=t(e[r],r,e);return o}},8256:e=>{e.exports=function(e,t){for(var r=-1,n=t.length,o=e.length;++r<n;)e[o+r]=t[r];return e}},9272:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length;++r<n;)if(t(e[r],r,e))return!0;return!1}},237:(e,t,r)=>{var n=r(2464),o=r(6424);e.exports=function(e,t,r){(void 0!==r&&!o(e[t],r)||void 0===r&&!(t in e))&&n(e,t,r)}},8131:(e,t,r)=>{var n=r(2464),o=r(6424),i=Object.prototype.hasOwnProperty;e.exports=function(e,t,r){var a=e[t];i.call(e,t)&&o(a,r)&&(void 0!==r||t in e)||n(e,t,r)}},3481:(e,t,r)=>{var n=r(6424);e.exports=function(e,t){for(var r=e.length;r--;)if(n(e[r][0],t))return r;return-1}},4861:(e,t,r)=>{var n=r(4735),o=r(3790);e.exports=function(e,t){return e&&n(t,o(t),e)}},7838:(e,t,r)=>{var n=r(4735),o=r(5961);e.exports=function(e,t){return e&&n(t,o(t),e)}},2464:(e,t,r)=>{var n=r(9611);e.exports=function(e,t,r){"__proto__"==t&&n?n(e,t,{configurable:!0,enumerable:!0,value:r,writable:!0}):e[t]=r}},5725:e=>{e.exports=function(e,t,r){return e==e&&(void 0!==r&&(e=e<=r?e:r),void 0!==t&&(e=e>=t?e:t)),e}},6575:(e,t,r)=>{var n=r(8545),o=r(6433),i=r(8131),a=r(4861),s=r(7838),l=r(8986),u=r(1231),c=r(1711),d=r(1476),p=r(7749),f=r(869),v=r(6053),h=r(509),g=r(1343),y=r(1225),m=r(4913),b=r(4264),E=r(146),O=r(9834),S=r(8696),T=r(3790),_=r(5961),w="[object Arguments]",R="[object Function]",I="[object Object]",A={};A[w]=A["[object Array]"]=A["[object ArrayBuffer]"]=A["[object DataView]"]=A["[object Boolean]"]=A["[object Date]"]=A["[object Float32Array]"]=A["[object Float64Array]"]=A["[object Int8Array]"]=A["[object Int16Array]"]=A["[object Int32Array]"]=A["[object Map]"]=A["[object Number]"]=A[I]=A["[object RegExp]"]=A["[object Set]"]=A["[object String]"]=A["[object Symbol]"]=A["[object Uint8Array]"]=A["[object Uint8ClampedArray]"]=A["[object Uint16Array]"]=A["[object Uint32Array]"]=!0,A["[object Error]"]=A[R]=A["[object WeakMap]"]=!1,e.exports=function e(t,r,C,N,L,P){var x,j=1&r,F=2&r,D=4&r;if(C&&(x=L?C(t,N,L,P):C(t)),void 0!==x)return x;if(!O(t))return t;var k=m(t);if(k){if(x=h(t),!j)return u(t,x)}else{var M=v(t),V=M==R||"[object GeneratorFunction]"==M;if(b(t))return l(t,j);if(M==I||M==w||V&&!L){if(x=F||V?{}:y(t),!j)return F?d(t,s(x,t)):c(t,a(x,t))}else{if(!A[M])return L?t:{};x=g(t,M,j)}}P||(P=new n);var U=P.get(t);if(U)return U;P.set(t,x),S(t)?t.forEach((function(n){x.add(e(n,r,C,n,t,P))})):E(t)&&t.forEach((function(n,o){x.set(o,e(n,r,C,o,t,P))}));var B=k?void 0:(D?F?f:p:F?_:T)(t);return o(B||t,(function(n,o){B&&(n=t[o=n]),i(x,o,e(n,r,C,o,t,P))})),x}},3088:(e,t,r)=>{var n=r(9834),o=Object.create,i=function(){function e(){}return function(t){if(!n(t))return{};if(o)return o(t);e.prototype=t;var r=new e;return e.prototype=void 0,r}}();e.exports=i},3323:e=>{e.exports=function(e,t,r,n){for(var o=e.length,i=r+(n?1:-1);n?i--:++i<o;)if(t(e[i],i,e))return i;return-1}},1360:(e,t,r)=>{var n=r(8256),o=r(5043);e.exports=function e(t,r,i,a,s){var l=-1,u=t.length;for(i||(i=o),s||(s=[]);++l<u;){var c=t[l];r>0&&i(c)?r>1?e(c,r-1,i,a,s):n(s,c):a||(s[s.length]=c)}return s}},6057:(e,t,r)=>{var n=r(5845)();e.exports=n},5473:(e,t,r)=>{var n=r(6057),o=r(3790);e.exports=function(e,t){return e&&n(e,t,o)}},2718:(e,t,r)=>{var n=r(2361),o=r(8197);e.exports=function(e,t){for(var r=0,i=(t=n(t,e)).length;null!=e&&r<i;)e=e[o(t[r++])];return r&&r==i?e:void 0}},8359:(e,t,r)=>{var n=r(8256),o=r(4913);e.exports=function(e,t,r){var i=t(e);return o(e)?i:n(i,r(e))}},9048:(e,t,r)=>{var n=r(2609),o=r(2899),i=r(7222),a=n?n.toStringTag:void 0;e.exports=function(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":a&&a in Object(e)?o(e):i(e)}},3613:e=>{e.exports=function(e,t){return null!=e&&t in Object(e)}},9555:(e,t,r)=>{var n=r(3323),o=r(8967),i=r(5951);e.exports=function(e,t,r){return t==t?i(e,t,r):n(e,o,r)}},3070:(e,t,r)=>{var n=r(9048),o=r(9466);e.exports=function(e){return o(e)&&"[object Arguments]"==n(e)}},590:(e,t,r)=>{var n=r(9132),o=r(9466);e.exports=function e(t,r,i,a,s){return t===r||(null==t||null==r||!o(t)&&!o(r)?t!=t&&r!=r:n(t,r,i,a,e,s))}},9132:(e,t,r)=>{var n=r(8545),o=r(4807),i=r(898),a=r(3409),s=r(6053),l=r(4913),u=r(4264),c=r(5087),d="[object Arguments]",p="[object Array]",f="[object Object]",v=Object.prototype.hasOwnProperty;e.exports=function(e,t,r,h,g,y){var m=l(e),b=l(t),E=m?p:s(e),O=b?p:s(t),S=(E=E==d?f:E)==f,T=(O=O==d?f:O)==f,_=E==O;if(_&&u(e)){if(!u(t))return!1;m=!0,S=!1}if(_&&!S)return y||(y=new n),m||c(e)?o(e,t,r,h,g,y):i(e,t,E,r,h,g,y);if(!(1&r)){var w=S&&v.call(e,"__wrapped__"),R=T&&v.call(t,"__wrapped__");if(w||R){var I=w?e.value():e,A=R?t.value():t;return y||(y=new n),g(I,A,r,h,y)}}return!!_&&(y||(y=new n),a(e,t,r,h,g,y))}},2052:(e,t,r)=>{var n=r(6053),o=r(9466);e.exports=function(e){return o(e)&&"[object Map]"==n(e)}},7799:(e,t,r)=>{var n=r(8545),o=r(590);e.exports=function(e,t,r,i){var a=r.length,s=a,l=!i;if(null==e)return!s;for(e=Object(e);a--;){var u=r[a];if(l&&u[2]?u[1]!==e[u[0]]:!(u[0]in e))return!1}for(;++a<s;){var c=(u=r[a])[0],d=e[c],p=u[1];if(l&&u[2]){if(void 0===d&&!(c in e))return!1}else{var f=new n;if(i)var v=i(d,p,c,e,t,f);if(!(void 0===v?o(p,d,3,i,f):v))return!1}}return!0}},8967:e=>{e.exports=function(e){return e!=e}},4363:(e,t,r)=>{var n=r(1866),o=r(3248),i=r(9834),a=r(3761),s=/^\[object .+?Constructor\]$/,l=Function.prototype,u=Object.prototype,c=l.toString,d=u.hasOwnProperty,p=RegExp("^"+c.call(d).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");e.exports=function(e){return!(!i(e)||o(e))&&(n(e)?p:s).test(a(e))}},5206:(e,t,r)=>{var n=r(6053),o=r(9466);e.exports=function(e){return o(e)&&"[object Set]"==n(e)}},9653:(e,t,r)=>{var n=r(9048),o=r(582),i=r(9466),a={};a["[object Float32Array]"]=a["[object Float64Array]"]=a["[object Int8Array]"]=a["[object Int16Array]"]=a["[object Int32Array]"]=a["[object Uint8Array]"]=a["[object Uint8ClampedArray]"]=a["[object Uint16Array]"]=a["[object Uint32Array]"]=!0,a["[object Arguments]"]=a["[object Array]"]=a["[object ArrayBuffer]"]=a["[object Boolean]"]=a["[object DataView]"]=a["[object Date]"]=a["[object Error]"]=a["[object Function]"]=a["[object Map]"]=a["[object Number]"]=a["[object Object]"]=a["[object RegExp]"]=a["[object Set]"]=a["[object String]"]=a["[object WeakMap]"]=!1,e.exports=function(e){return i(e)&&o(e.length)&&!!a[n(e)]}},3245:(e,t,r)=>{var n=r(8271),o=r(4458),i=r(912),a=r(4913),s=r(6711);e.exports=function(e){return"function"==typeof e?e:null==e?i:"object"==typeof e?a(e)?o(e[0],e[1]):n(e):s(e)}},6504:(e,t,r)=>{var n=r(5735),o=r(9458),i=Object.prototype.hasOwnProperty;e.exports=function(e){if(!n(e))return o(e);var t=[];for(var r in Object(e))i.call(e,r)&&"constructor"!=r&&t.push(r);return t}},9399:(e,t,r)=>{var n=r(9834),o=r(5735),i=r(2693),a=Object.prototype.hasOwnProperty;e.exports=function(e){if(!n(e))return i(e);var t=o(e),r=[];for(var s in e)("constructor"!=s||!t&&a.call(e,s))&&r.push(s);return r}},8271:(e,t,r)=>{var n=r(7799),o=r(520),i=r(7405);e.exports=function(e){var t=o(e);return 1==t.length&&t[0][2]?i(t[0][0],t[0][1]):function(r){return r===e||n(r,e,t)}}},4458:(e,t,r)=>{var n=r(590),o=r(5612),i=r(4055),a=r(6394),s=r(2308),l=r(7405),u=r(8197);e.exports=function(e,t){return a(e)&&s(t)?l(u(e),t):function(r){var a=o(r,e);return void 0===a&&a===t?i(r,e):n(t,a,3)}}},9058:(e,t,r)=>{var n=r(8545),o=r(237),i=r(6057),a=r(8120),s=r(9834),l=r(5961),u=r(4302);e.exports=function e(t,r,c,d,p){t!==r&&i(r,(function(i,l){if(p||(p=new n),s(i))a(t,r,l,c,e,d,p);else{var f=d?d(u(t,l),i,l+"",t,r,p):void 0;void 0===f&&(f=i),o(t,l,f)}}),l)}},8120:(e,t,r)=>{var n=r(237),o=r(8986),i=r(7961),a=r(1231),s=r(1225),l=r(5196),u=r(4913),c=r(7965),d=r(4264),p=r(1866),f=r(9834),v=r(5219),h=r(5087),g=r(4302),y=r(5148);e.exports=function(e,t,r,m,b,E,O){var S=g(e,r),T=g(t,r),_=O.get(T);if(_)n(e,r,_);else{var w=E?E(S,T,r+"",e,t,O):void 0,R=void 0===w;if(R){var I=u(T),A=!I&&d(T),C=!I&&!A&&h(T);w=T,I||A||C?u(S)?w=S:c(S)?w=a(S):A?(R=!1,w=o(T,!0)):C?(R=!1,w=i(T,!0)):w=[]:v(T)||l(T)?(w=S,l(S)?w=y(S):f(S)&&!p(S)||(w=s(T))):R=!1}R&&(O.set(T,w),b(w,T,m,E,O),O.delete(T)),n(e,r,w)}}},1:(e,t,r)=>{var n=r(9916),o=r(4055);e.exports=function(e,t){return n(e,t,(function(t,r){return o(e,r)}))}},9916:(e,t,r)=>{var n=r(2718),o=r(3746),i=r(2361);e.exports=function(e,t,r){for(var a=-1,s=t.length,l={};++a<s;){var u=t[a],c=n(e,u);r(c,u)&&o(l,i(u,e),c)}return l}},645:e=>{e.exports=function(e){return function(t){return null==t?void 0:t[e]}}},5319:(e,t,r)=>{var n=r(2718);e.exports=function(e){return function(t){return n(t,e)}}},9383:e=>{var t=Math.ceil,r=Math.max;e.exports=function(e,n,o,i){for(var a=-1,s=r(t((n-e)/(o||1)),0),l=Array(s);s--;)l[i?s:++a]=e,e+=o;return l}},1459:e=>{var t=Math.floor;e.exports=function(e,r){var n="";if(!e||r<1||r>9007199254740991)return n;do{r%2&&(n+=e),(r=t(r/2))&&(e+=e)}while(r);return n}},1110:(e,t,r)=>{var n=r(912),o=r(3090),i=r(7281);e.exports=function(e,t){return i(o(e,t,n),e+"")}},3746:(e,t,r)=>{var n=r(8131),o=r(2361),i=r(6665),a=r(9834),s=r(8197);e.exports=function(e,t,r,l){if(!a(e))return e;for(var u=-1,c=(t=o(t,e)).length,d=c-1,p=e;null!=p&&++u<c;){var f=s(t[u]),v=r;if("__proto__"===f||"constructor"===f||"prototype"===f)return e;if(u!=d){var h=p[f];void 0===(v=l?l(h,f,p):void 0)&&(v=a(h)?h:i(t[u+1])?[]:{})}n(p,f,v),p=p[f]}return e}},4450:(e,t,r)=>{var n=r(6534),o=r(9611),i=r(912),a=o?function(e,t){return o(e,"toString",{configurable:!0,enumerable:!1,value:n(t),writable:!0})}:i;e.exports=a},312:e=>{e.exports=function(e,t,r){var n=-1,o=e.length;t<0&&(t=-t>o?0:o+t),(r=r>o?o:r)<0&&(r+=o),o=t>r?0:r-t>>>0,t>>>=0;for(var i=Array(o);++n<o;)i[n]=e[n+t];return i}},2784:e=>{e.exports=function(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}},9764:(e,t,r)=>{var n=r(2609),o=r(1428),i=r(4913),a=r(7386),s=n?n.prototype:void 0,l=s?s.toString:void 0;e.exports=function e(t){if("string"==typeof t)return t;if(i(t))return o(t,e)+"";if(a(t))return l?l.call(t):"";var r=t+"";return"0"==r&&1/t==-1/0?"-0":r}},7248:(e,t,r)=>{var n=r(1272),o=/^\s+/;e.exports=function(e){return e?e.slice(0,n(e)+1).replace(o,""):e}},277:e=>{e.exports=function(e){return function(t){return e(t)}}},6744:(e,t,r)=>{var n=r(2361),o=r(8906),i=r(2473),a=r(8197);e.exports=function(e,t){return t=n(t,e),null==(e=i(e,t))||delete e[a(o(t))]}},1282:(e,t,r)=>{var n=r(1428);e.exports=function(e,t){return n(t,(function(t){return e[t]}))}},3840:e=>{e.exports=function(e,t){return e.has(t)}},2361:(e,t,r)=>{var n=r(4913),o=r(6394),i=r(266),a=r(3158);e.exports=function(e,t){return n(e)?e:o(e,t)?[e]:i(a(e))}},2511:(e,t,r)=>{var n=r(3604);e.exports=function(e){var t=new e.constructor(e.byteLength);return new n(t).set(new n(e)),t}},8986:(e,t,r)=>{e=r.nmd(e);var n=r(9965),o=t&&!t.nodeType&&t,i=o&&e&&!e.nodeType&&e,a=i&&i.exports===o?n.Buffer:void 0,s=a?a.allocUnsafe:void 0;e.exports=function(e,t){if(t)return e.slice();var r=e.length,n=s?s(r):new e.constructor(r);return e.copy(n),n}},3081:(e,t,r)=>{var n=r(2511);e.exports=function(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}},6945:e=>{var t=/\w*$/;e.exports=function(e){var r=new e.constructor(e.source,t.exec(e));return r.lastIndex=e.lastIndex,r}},6952:(e,t,r)=>{var n=r(2609),o=n?n.prototype:void 0,i=o?o.valueOf:void 0;e.exports=function(e){return i?Object(i.call(e)):{}}},7961:(e,t,r)=>{var n=r(2511);e.exports=function(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}},1231:e=>{e.exports=function(e,t){var r=-1,n=e.length;for(t||(t=Array(n));++r<n;)t[r]=e[r];return t}},4735:(e,t,r)=>{var n=r(8131),o=r(2464);e.exports=function(e,t,r,i){var a=!r;r||(r={});for(var s=-1,l=t.length;++s<l;){var u=t[s],c=i?i(r[u],e[u],u,r,e):void 0;void 0===c&&(c=e[u]),a?o(r,u,c):n(r,u,c)}return r}},1711:(e,t,r)=>{var n=r(4735),o=r(6600);e.exports=function(e,t){return n(e,o(e),t)}},1476:(e,t,r)=>{var n=r(4735),o=r(8455);e.exports=function(e,t){return n(e,o(e),t)}},2489:(e,t,r)=>{var n=r(9965)["__core-js_shared__"];e.exports=n},9511:(e,t,r)=>{var n=r(1110),o=r(3632);e.exports=function(e){return n((function(t,r){var n=-1,i=r.length,a=i>1?r[i-1]:void 0,s=i>2?r[2]:void 0;for(a=e.length>3&&"function"==typeof a?(i--,a):void 0,s&&o(r[0],r[1],s)&&(a=i<3?void 0:a,i=1),t=Object(t);++n<i;){var l=r[n];l&&e(t,l,n,a)}return t}))}},5845:e=>{e.exports=function(e){return function(t,r,n){for(var o=-1,i=Object(t),a=n(t),s=a.length;s--;){var l=a[e?s:++o];if(!1===r(i[l],l,i))break}return t}}},8580:(e,t,r)=>{var n=r(9383),o=r(3632),i=r(1144);e.exports=function(e){return function(t,r,a){return a&&"number"!=typeof a&&o(t,r,a)&&(r=a=void 0),t=i(t),void 0===r?(r=t,t=0):r=i(r),a=void 0===a?t<r?1:-1:i(a),n(t,r,a,e)}}},2050:(e,t,r)=>{var n=r(5219);e.exports=function(e){return n(e)?void 0:e}},9611:(e,t,r)=>{var n=r(2062),o=function(){try{var e=n(Object,"defineProperty");return e({},"",{}),e}catch(e){}}();e.exports=o},4807:(e,t,r)=>{var n=r(8283),o=r(9272),i=r(3840);e.exports=function(e,t,r,a,s,l){var u=1&r,c=e.length,d=t.length;if(c!=d&&!(u&&d>c))return!1;var p=l.get(e),f=l.get(t);if(p&&f)return p==t&&f==e;var v=-1,h=!0,g=2&r?new n:void 0;for(l.set(e,t),l.set(t,e);++v<c;){var y=e[v],m=t[v];if(a)var b=u?a(m,y,v,t,e,l):a(y,m,v,e,t,l);if(void 0!==b){if(b)continue;h=!1;break}if(g){if(!o(t,(function(e,t){if(!i(g,t)&&(y===e||s(y,e,r,a,l)))return g.push(t)}))){h=!1;break}}else if(y!==m&&!s(y,m,r,a,l)){h=!1;break}}return l.delete(e),l.delete(t),h}},898:(e,t,r)=>{var n=r(2609),o=r(3604),i=r(6424),a=r(4807),s=r(9885),l=r(6295),u=n?n.prototype:void 0,c=u?u.valueOf:void 0;e.exports=function(e,t,r,n,u,d,p){switch(r){case"[object DataView]":if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case"[object ArrayBuffer]":return!(e.byteLength!=t.byteLength||!d(new o(e),new o(t)));case"[object Boolean]":case"[object Date]":case"[object Number]":return i(+e,+t);case"[object Error]":return e.name==t.name&&e.message==t.message;case"[object RegExp]":case"[object String]":return e==t+"";case"[object Map]":var f=s;case"[object Set]":var v=1&n;if(f||(f=l),e.size!=t.size&&!v)return!1;var h=p.get(e);if(h)return h==t;n|=2,p.set(e,t);var g=a(f(e),f(t),n,u,d,p);return p.delete(e),g;case"[object Symbol]":if(c)return c.call(e)==c.call(t)}return!1}},3409:(e,t,r)=>{var n=r(7749),o=Object.prototype.hasOwnProperty;e.exports=function(e,t,r,i,a,s){var l=1&r,u=n(e),c=u.length;if(c!=n(t).length&&!l)return!1;for(var d=c;d--;){var p=u[d];if(!(l?p in t:o.call(t,p)))return!1}var f=s.get(e),v=s.get(t);if(f&&v)return f==t&&v==e;var h=!0;s.set(e,t),s.set(t,e);for(var g=l;++d<c;){var y=e[p=u[d]],m=t[p];if(i)var b=l?i(m,y,p,t,e,s):i(y,m,p,e,t,s);if(!(void 0===b?y===m||a(y,m,r,i,s):b)){h=!1;break}g||(g="constructor"==p)}if(h&&!g){var E=e.constructor,O=t.constructor;E==O||!("constructor"in e)||!("constructor"in t)||"function"==typeof E&&E instanceof E&&"function"==typeof O&&O instanceof O||(h=!1)}return s.delete(e),s.delete(t),h}},8496:(e,t,r)=>{var n=r(9234),o=r(3090),i=r(7281);e.exports=function(e){return i(o(e,void 0,n),e+"")}},6392:(e,t,r)=>{var n="object"==typeof r.g&&r.g&&r.g.Object===Object&&r.g;e.exports=n},7749:(e,t,r)=>{var n=r(8359),o=r(6600),i=r(3790);e.exports=function(e){return n(e,i,o)}},869:(e,t,r)=>{var n=r(8359),o=r(8455),i=r(5961);e.exports=function(e){return n(e,i,o)}},3707:(e,t,r)=>{var n=r(9178);e.exports=function(e,t){var r=e.__data__;return n(t)?r["string"==typeof t?"string":"hash"]:r.map}},520:(e,t,r)=>{var n=r(2308),o=r(3790);e.exports=function(e){for(var t=o(e),r=t.length;r--;){var i=t[r],a=e[i];t[r]=[i,a,n(a)]}return t}},2062:(e,t,r)=>{var n=r(4363),o=r(5240);e.exports=function(e,t){var r=o(e,t);return n(r)?r:void 0}},6607:(e,t,r)=>{var n=r(8303)(Object.getPrototypeOf,Object);e.exports=n},2899:(e,t,r)=>{var n=r(2609),o=Object.prototype,i=o.hasOwnProperty,a=o.toString,s=n?n.toStringTag:void 0;e.exports=function(e){var t=i.call(e,s),r=e[s];try{e[s]=void 0;var n=!0}catch(e){}var o=a.call(e);return n&&(t?e[s]=r:delete e[s]),o}},6600:(e,t,r)=>{var n=r(9386),o=r(8721),i=Object.prototype.propertyIsEnumerable,a=Object.getOwnPropertySymbols,s=a?function(e){return null==e?[]:(e=Object(e),n(a(e),(function(t){return i.call(e,t)})))}:o;e.exports=s},8455:(e,t,r)=>{var n=r(8256),o=r(6607),i=r(6600),a=r(8721),s=Object.getOwnPropertySymbols?function(e){for(var t=[];e;)n(t,i(e)),e=o(e);return t}:a;e.exports=s},6053:(e,t,r)=>{var n=r(5948),o=r(5455),i=r(6420),a=r(2833),s=r(8143),l=r(9048),u=r(3761),c="[object Map]",d="[object Promise]",p="[object Set]",f="[object WeakMap]",v="[object DataView]",h=u(n),g=u(o),y=u(i),m=u(a),b=u(s),E=l;(n&&E(new n(new ArrayBuffer(1)))!=v||o&&E(new o)!=c||i&&E(i.resolve())!=d||a&&E(new a)!=p||s&&E(new s)!=f)&&(E=function(e){var t=l(e),r="[object Object]"==t?e.constructor:void 0,n=r?u(r):"";if(n)switch(n){case h:return v;case g:return c;case y:return d;case m:return p;case b:return f}return t}),e.exports=E},5240:e=>{e.exports=function(e,t){return null==e?void 0:e[t]}},1518:(e,t,r)=>{var n=r(2361),o=r(5196),i=r(4913),a=r(6665),s=r(582),l=r(8197);e.exports=function(e,t,r){for(var u=-1,c=(t=n(t,e)).length,d=!1;++u<c;){var p=l(t[u]);if(!(d=null!=e&&r(e,p)))break;e=e[p]}return d||++u!=c?d:!!(c=null==e?0:e.length)&&s(c)&&a(p,c)&&(i(e)||o(e))}},5504:(e,t,r)=>{var n=r(8034);e.exports=function(){this.__data__=n?n(null):{},this.size=0}},5270:e=>{e.exports=function(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t}},4769:(e,t,r)=>{var n=r(8034),o=Object.prototype.hasOwnProperty;e.exports=function(e){var t=this.__data__;if(n){var r=t[e];return"__lodash_hash_undefined__"===r?void 0:r}return o.call(t,e)?t[e]:void 0}},2637:(e,t,r)=>{var n=r(8034),o=Object.prototype.hasOwnProperty;e.exports=function(e){var t=this.__data__;return n?void 0!==t[e]:o.call(t,e)}},1077:(e,t,r)=>{var n=r(8034);e.exports=function(e,t){var r=this.__data__;return this.size+=this.has(e)?0:1,r[e]=n&&void 0===t?"__lodash_hash_undefined__":t,this}},509:e=>{var t=Object.prototype.hasOwnProperty;e.exports=function(e){var r=e.length,n=new e.constructor(r);return r&&"string"==typeof e[0]&&t.call(e,"index")&&(n.index=e.index,n.input=e.input),n}},1343:(e,t,r)=>{var n=r(2511),o=r(3081),i=r(6945),a=r(6952),s=r(7961);e.exports=function(e,t,r){var l=e.constructor;switch(t){case"[object ArrayBuffer]":return n(e);case"[object Boolean]":case"[object Date]":return new l(+e);case"[object DataView]":return o(e,r);case"[object Float32Array]":case"[object Float64Array]":case"[object Int8Array]":case"[object Int16Array]":case"[object Int32Array]":case"[object Uint8Array]":case"[object Uint8ClampedArray]":case"[object Uint16Array]":case"[object Uint32Array]":return s(e,r);case"[object Map]":case"[object Set]":return new l;case"[object Number]":case"[object String]":return new l(e);case"[object RegExp]":return i(e);case"[object Symbol]":return a(e)}}},1225:(e,t,r)=>{var n=r(3088),o=r(6607),i=r(5735);e.exports=function(e){return"function"!=typeof e.constructor||i(e)?{}:n(o(e))}},5043:(e,t,r)=>{var n=r(2609),o=r(5196),i=r(4913),a=n?n.isConcatSpreadable:void 0;e.exports=function(e){return i(e)||o(e)||!!(a&&e&&e[a])}},6665:e=>{var t=/^(?:0|[1-9]\d*)$/;e.exports=function(e,r){var n=typeof e;return!!(r=null==r?9007199254740991:r)&&("number"==n||"symbol"!=n&&t.test(e))&&e>-1&&e%1==0&&e<r}},3632:(e,t,r)=>{var n=r(6424),o=r(7134),i=r(6665),a=r(9834);e.exports=function(e,t,r){if(!a(r))return!1;var s=typeof t;return!!("number"==s?o(r)&&i(t,r.length):"string"==s&&t in r)&&n(r[t],e)}},6394:(e,t,r)=>{var n=r(4913),o=r(7386),i=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,a=/^\w*$/;e.exports=function(e,t){if(n(e))return!1;var r=typeof e;return!("number"!=r&&"symbol"!=r&&"boolean"!=r&&null!=e&&!o(e))||a.test(e)||!i.test(e)||null!=t&&e in Object(t)}},9178:e=>{e.exports=function(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}},3248:(e,t,r)=>{var n,o=r(2489),i=(n=/[^.]+$/.exec(o&&o.keys&&o.keys.IE_PROTO||""))?"Symbol(src)_1."+n:"";e.exports=function(e){return!!i&&i in e}},5735:e=>{var t=Object.prototype;e.exports=function(e){var r=e&&e.constructor;return e===("function"==typeof r&&r.prototype||t)}},2308:(e,t,r)=>{var n=r(9834);e.exports=function(e){return e==e&&!n(e)}},7718:e=>{e.exports=function(){this.__data__=[],this.size=0}},4272:(e,t,r)=>{var n=r(3481),o=Array.prototype.splice;e.exports=function(e){var t=this.__data__,r=n(t,e);return!(r<0||(r==t.length-1?t.pop():o.call(t,r,1),--this.size,0))}},5107:(e,t,r)=>{var n=r(3481);e.exports=function(e){var t=this.__data__,r=n(t,e);return r<0?void 0:t[r][1]}},1055:(e,t,r)=>{var n=r(3481);e.exports=function(e){return n(this.__data__,e)>-1}},4647:(e,t,r)=>{var n=r(3481);e.exports=function(e,t){var r=this.__data__,o=n(r,e);return o<0?(++this.size,r.push([e,t])):r[o][1]=t,this}},6400:(e,t,r)=>{var n=r(4845),o=r(1999),i=r(5455);e.exports=function(){this.size=0,this.__data__={hash:new n,map:new(i||o),string:new n}}},7014:(e,t,r)=>{var n=r(3707);e.exports=function(e){var t=n(this,e).delete(e);return this.size-=t?1:0,t}},1793:(e,t,r)=>{var n=r(3707);e.exports=function(e){return n(this,e).get(e)}},6429:(e,t,r)=>{var n=r(3707);e.exports=function(e){return n(this,e).has(e)}},821:(e,t,r)=>{var n=r(3707);e.exports=function(e,t){var r=n(this,e),o=r.size;return r.set(e,t),this.size+=r.size==o?0:1,this}},9885:e=>{e.exports=function(e){var t=-1,r=Array(e.size);return e.forEach((function(e,n){r[++t]=[n,e]})),r}},7405:e=>{e.exports=function(e,t){return function(r){return null!=r&&r[e]===t&&(void 0!==t||e in Object(r))}}},2848:(e,t,r)=>{var n=r(3272);e.exports=function(e){var t=n(e,(function(e){return 500===r.size&&r.clear(),e})),r=t.cache;return t}},8034:(e,t,r)=>{var n=r(2062)(Object,"create");e.exports=n},9458:(e,t,r)=>{var n=r(8303)(Object.keys,Object);e.exports=n},2693:e=>{e.exports=function(e){var t=[];if(null!=e)for(var r in Object(e))t.push(r);return t}},1977:(e,t,r)=>{e=r.nmd(e);var n=r(6392),o=t&&!t.nodeType&&t,i=o&&e&&!e.nodeType&&e,a=i&&i.exports===o&&n.process,s=function(){try{return i&&i.require&&i.require("util").types||a&&a.binding&&a.binding("util")}catch(e){}}();e.exports=s},7222:e=>{var t=Object.prototype.toString;e.exports=function(e){return t.call(e)}},8303:e=>{e.exports=function(e,t){return function(r){return e(t(r))}}},3090:(e,t,r)=>{var n=r(1929),o=Math.max;e.exports=function(e,t,r){return t=o(void 0===t?e.length-1:t,0),function(){for(var i=arguments,a=-1,s=o(i.length-t,0),l=Array(s);++a<s;)l[a]=i[t+a];a=-1;for(var u=Array(t+1);++a<t;)u[a]=i[a];return u[t]=r(l),n(e,this,u)}}},2473:(e,t,r)=>{var n=r(2718),o=r(312);e.exports=function(e,t){return t.length<2?e:n(e,o(t,0,-1))}},9965:(e,t,r)=>{var n=r(6392),o="object"==typeof self&&self&&self.Object===Object&&self,i=n||o||Function("return this")();e.exports=i},4302:e=>{e.exports=function(e,t){if(("constructor"!==t||"function"!=typeof e[t])&&"__proto__"!=t)return e[t]}},228:e=>{e.exports=function(e){return this.__data__.set(e,"__lodash_hash_undefined__"),this}},3683:e=>{e.exports=function(e){return this.__data__.has(e)}},6295:e=>{e.exports=function(e){var t=-1,r=Array(e.size);return e.forEach((function(e){r[++t]=e})),r}},7281:(e,t,r)=>{var n=r(4450),o=r(435)(n);e.exports=o},435:e=>{var t=Date.now;e.exports=function(e){var r=0,n=0;return function(){var o=t(),i=16-(o-n);if(n=o,i>0){if(++r>=800)return arguments[0]}else r=0;return e.apply(void 0,arguments)}}},5052:(e,t,r)=>{var n=r(1999);e.exports=function(){this.__data__=new n,this.size=0}},4250:e=>{e.exports=function(e){var t=this.__data__,r=t.delete(e);return this.size=t.size,r}},4773:e=>{e.exports=function(e){return this.__data__.get(e)}},6921:e=>{e.exports=function(e){return this.__data__.has(e)}},5745:(e,t,r)=>{var n=r(1999),o=r(5455),i=r(1549);e.exports=function(e,t){var r=this.__data__;if(r instanceof n){var a=r.__data__;if(!o||a.length<199)return a.push([e,t]),this.size=++r.size,this;r=this.__data__=new i(a)}return r.set(e,t),this.size=r.size,this}},5951:e=>{e.exports=function(e,t,r){for(var n=r-1,o=e.length;++n<o;)if(e[n]===t)return n;return-1}},266:(e,t,r)=>{var n=r(2848),o=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,i=/\\(\\)?/g,a=n((function(e){var t=[];return 46===e.charCodeAt(0)&&t.push(""),e.replace(o,(function(e,r,n,o){t.push(n?o.replace(i,"$1"):r||e)})),t}));e.exports=a},8197:(e,t,r)=>{var n=r(7386);e.exports=function(e){if("string"==typeof e||n(e))return e;var t=e+"";return"0"==t&&1/e==-1/0?"-0":t}},3761:e=>{var t=Function.prototype.toString;e.exports=function(e){if(null!=e){try{return t.call(e)}catch(e){}try{return e+""}catch(e){}}return""}},1272:e=>{var t=/\s/;e.exports=function(e){for(var r=e.length;r--&&t.test(e.charAt(r)););return r}},6534:e=>{e.exports=function(e){return function(){return e}}},9517:(e,t,r)=>{var n=r(9834),o=r(2220),i=r(3662),a=Math.max,s=Math.min;e.exports=function(e,t,r){var l,u,c,d,p,f,v=0,h=!1,g=!1,y=!0;if("function"!=typeof e)throw new TypeError("Expected a function");function m(t){var r=l,n=u;return l=u=void 0,v=t,d=e.apply(n,r)}function b(e){var r=e-f;return void 0===f||r>=t||r<0||g&&e-v>=c}function E(){var e=o();if(b(e))return O(e);p=setTimeout(E,function(e){var r=t-(e-f);return g?s(r,c-(e-v)):r}(e))}function O(e){return p=void 0,y&&l?m(e):(l=u=void 0,d)}function S(){var e=o(),r=b(e);if(l=arguments,u=this,f=e,r){if(void 0===p)return function(e){return v=e,p=setTimeout(E,t),h?m(e):d}(f);if(g)return clearTimeout(p),p=setTimeout(E,t),m(f)}return void 0===p&&(p=setTimeout(E,t)),d}return t=i(t)||0,n(r)&&(h=!!r.leading,c=(g="maxWait"in r)?a(i(r.maxWait)||0,t):c,y="trailing"in r?!!r.trailing:y),S.cancel=function(){void 0!==p&&clearTimeout(p),v=0,l=f=u=p=void 0},S.flush=function(){return void 0===p?d:O(o())},S}},6424:e=>{e.exports=function(e,t){return e===t||e!=e&&t!=t}},8472:(e,t,r)=>{var n=r(3158),o=/[\\^$.*+?()[\]{}|]/g,i=RegExp(o.source);e.exports=function(e){return(e=n(e))&&i.test(e)?e.replace(o,"\\$&"):e}},9234:(e,t,r)=>{var n=r(1360);e.exports=function(e){return null!=e&&e.length?n(e,1):[]}},5612:(e,t,r)=>{var n=r(2718);e.exports=function(e,t,r){var o=null==e?void 0:n(e,t);return void 0===o?r:o}},4055:(e,t,r)=>{var n=r(3613),o=r(1518);e.exports=function(e,t){return null!=e&&o(e,t,n)}},912:e=>{e.exports=function(e){return e}},1283:(e,t,r)=>{var n=r(9555),o=r(7134),i=r(8951),a=r(5729),s=r(1624),l=Math.max;e.exports=function(e,t,r,u){e=o(e)?e:s(e),r=r&&!u?a(r):0;var c=e.length;return r<0&&(r=l(c+r,0)),i(e)?r<=c&&e.indexOf(t,r)>-1:!!c&&n(e,t,r)>-1}},5196:(e,t,r)=>{var n=r(3070),o=r(9466),i=Object.prototype,a=i.hasOwnProperty,s=i.propertyIsEnumerable,l=n(function(){return arguments}())?n:function(e){return o(e)&&a.call(e,"callee")&&!s.call(e,"callee")};e.exports=l},4913:e=>{var t=Array.isArray;e.exports=t},7134:(e,t,r)=>{var n=r(1866),o=r(582);e.exports=function(e){return null!=e&&o(e.length)&&!n(e)}},7965:(e,t,r)=>{var n=r(7134),o=r(9466);e.exports=function(e){return o(e)&&n(e)}},4264:(e,t,r)=>{e=r.nmd(e);var n=r(9965),o=r(9375),i=t&&!t.nodeType&&t,a=i&&e&&!e.nodeType&&e,s=a&&a.exports===i?n.Buffer:void 0,l=(s?s.isBuffer:void 0)||o;e.exports=l},7969:(e,t,r)=>{var n=r(6504),o=r(6053),i=r(5196),a=r(4913),s=r(7134),l=r(4264),u=r(5735),c=r(5087),d=Object.prototype.hasOwnProperty;e.exports=function(e){if(null==e)return!0;if(s(e)&&(a(e)||"string"==typeof e||"function"==typeof e.splice||l(e)||c(e)||i(e)))return!e.length;var t=o(e);if("[object Map]"==t||"[object Set]"==t)return!e.size;if(u(e))return!n(e).length;for(var r in e)if(d.call(e,r))return!1;return!0}},1866:(e,t,r)=>{var n=r(9048),o=r(9834);e.exports=function(e){if(!o(e))return!1;var t=n(e);return"[object Function]"==t||"[object GeneratorFunction]"==t||"[object AsyncFunction]"==t||"[object Proxy]"==t}},582:e=>{e.exports=function(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=9007199254740991}},146:(e,t,r)=>{var n=r(2052),o=r(277),i=r(1977),a=i&&i.isMap,s=a?o(a):n;e.exports=s},9834:e=>{e.exports=function(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}},9466:e=>{e.exports=function(e){return null!=e&&"object"==typeof e}},5219:(e,t,r)=>{var n=r(9048),o=r(6607),i=r(9466),a=Function.prototype,s=Object.prototype,l=a.toString,u=s.hasOwnProperty,c=l.call(Object);e.exports=function(e){if(!i(e)||"[object Object]"!=n(e))return!1;var t=o(e);if(null===t)return!0;var r=u.call(t,"constructor")&&t.constructor;return"function"==typeof r&&r instanceof r&&l.call(r)==c}},8696:(e,t,r)=>{var n=r(5206),o=r(277),i=r(1977),a=i&&i.isSet,s=a?o(a):n;e.exports=s},8951:(e,t,r)=>{var n=r(9048),o=r(4913),i=r(9466);e.exports=function(e){return"string"==typeof e||!o(e)&&i(e)&&"[object String]"==n(e)}},7386:(e,t,r)=>{var n=r(9048),o=r(9466);e.exports=function(e){return"symbol"==typeof e||o(e)&&"[object Symbol]"==n(e)}},5087:(e,t,r)=>{var n=r(9653),o=r(277),i=r(1977),a=i&&i.isTypedArray,s=a?o(a):n;e.exports=s},3790:(e,t,r)=>{var n=r(6791),o=r(6504),i=r(7134);e.exports=function(e){return i(e)?n(e):o(e)}},5961:(e,t,r)=>{var n=r(6791),o=r(9399),i=r(7134);e.exports=function(e){return i(e)?n(e,!0):o(e)}},8906:e=>{e.exports=function(e){var t=null==e?0:e.length;return t?e[t-1]:void 0}},1612:(e,t,r)=>{var n=r(2464),o=r(5473),i=r(3245);e.exports=function(e,t){var r={};return t=i(t,3),o(e,(function(e,o,i){n(r,o,t(e,o,i))})),r}},3272:(e,t,r)=>{var n=r(1549);function o(e,t){if("function"!=typeof e||null!=t&&"function"!=typeof t)throw new TypeError("Expected a function");var r=function(){var n=arguments,o=t?t.apply(this,n):n[0],i=r.cache;if(i.has(o))return i.get(o);var a=e.apply(this,n);return r.cache=i.set(o,a)||i,a};return r.cache=new(o.Cache||n),r}o.Cache=n,e.exports=o},4308:(e,t,r)=>{var n=r(9058),o=r(9511)((function(e,t,r){n(e,t,r)}));e.exports=o},2815:(e,t,r)=>{var n=r(9058),o=r(9511)((function(e,t,r,o){n(e,t,r,o)}));e.exports=o},2220:(e,t,r)=>{var n=r(9965);e.exports=function(){return n.Date.now()}},7027:(e,t,r)=>{var n=r(1428),o=r(6575),i=r(6744),a=r(2361),s=r(4735),l=r(2050),u=r(8496),c=r(869),d=u((function(e,t){var r={};if(null==e)return r;var u=!1;t=n(t,(function(t){return t=a(t,e),u||(u=t.length>1),t})),s(e,c(e),r),u&&(r=o(r,7,l));for(var d=t.length;d--;)i(r,t[d]);return r}));e.exports=d},8831:(e,t,r)=>{var n=r(1),o=r(8496)((function(e,t){return null==e?{}:n(e,t)}));e.exports=o},350:(e,t,r)=>{var n=r(1428),o=r(3245),i=r(9916),a=r(869);e.exports=function(e,t){if(null==e)return{};var r=n(a(e),(function(e){return[e]}));return t=o(t),i(e,r,(function(e,r){return t(e,r[0])}))}},6711:(e,t,r)=>{var n=r(645),o=r(5319),i=r(6394),a=r(8197);e.exports=function(e){return i(e)?n(a(e)):o(e)}},2285:(e,t,r)=>{var n=r(8580)();e.exports=n},9901:(e,t,r)=>{var n=r(1459),o=r(3632),i=r(5729),a=r(3158);e.exports=function(e,t,r){return t=(r?o(e,t,r):void 0===t)?1:i(t),n(a(e),t)}},3547:(e,t,r)=>{var n=r(5725),o=r(9764),i=r(5729),a=r(3158);e.exports=function(e,t,r){return e=a(e),r=null==r?0:n(i(r),0,e.length),t=o(t),e.slice(r,r+t.length)==t}},8721:e=>{e.exports=function(){return[]}},9375:e=>{e.exports=function(){return!1}},1144:(e,t,r)=>{var n=r(3662),o=1/0;e.exports=function(e){return e?(e=n(e))===o||e===-1/0?17976931348623157e292*(e<0?-1:1):e==e?e:0:0===e?e:0}},5729:(e,t,r)=>{var n=r(1144);e.exports=function(e){var t=n(e),r=t%1;return t==t?r?t-r:t:0}},3662:(e,t,r)=>{var n=r(7248),o=r(9834),i=r(7386),a=/^[-+]0x[0-9a-f]+$/i,s=/^0b[01]+$/i,l=/^0o[0-7]+$/i,u=parseInt;e.exports=function(e){if("number"==typeof e)return e;if(i(e))return NaN;if(o(e)){var t="function"==typeof e.valueOf?e.valueOf():e;e=o(t)?t+"":t}if("string"!=typeof e)return 0===e?e:+e;e=n(e);var r=s.test(e);return r||l.test(e)?u(e.slice(2),r?2:8):a.test(e)?NaN:+e}},5148:(e,t,r)=>{var n=r(4735),o=r(5961);e.exports=function(e){return n(e,o(e))}},3158:(e,t,r)=>{var n=r(9764);e.exports=function(e){return null==e?"":n(e)}},1624:(e,t,r)=>{var n=r(1282),o=r(3790);e.exports=function(e){return null==e?[]:n(e,o(e))}},4790:(e,t,r)=>{"use strict";var n=r(4621);function o(){}function i(){}i.resetWarningCache=o,e.exports=function(){function e(e,t,r,o,i,a){if(a!==n){var s=new Error("Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types");throw s.name="Invariant Violation",s}}function t(){return e}e.isRequired=e;var r={array:e,bigint:e,bool:e,func:e,number:e,object:e,string:e,symbol:e,any:e,arrayOf:t,element:e,elementType:e,instanceOf:t,node:e,objectOf:t,oneOf:t,oneOfType:t,shape:t,exact:t,checkPropTypes:i,resetWarningCache:o};return r.PropTypes=r,r}},7028:(e,t,r)=>{e.exports=r(4790)()},4621:e=>{"use strict";e.exports="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED"},1777:(e,t,r)=>{"use strict";var n=r(7016),o=r(5959),i=n.__importDefault(r(5053));t.A=function(e,t){void 0===t&&(t=[]);var r=i.default(e,t,{loading:!0}),n=r[0],a=r[1];return o.useEffect((function(){a()}),[a]),n}},5053:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(7016),o=r(5959),i=n.__importDefault(r(9812));t.default=function(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var a=o.useRef(0),s=i.default(),l=o.useState(r),u=l[0],c=l[1],d=o.useCallback((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var o=++a.current;return u.loading||c((function(e){return n.__assign(n.__assign({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return s()&&o===a.current&&c({value:e,loading:!1}),e}),(function(e){return s()&&o===a.current&&c({error:e,loading:!1}),e}))}),t);return[u,d]}},990:(e,t,r)=>{"use strict";var n=r(7016),o=r(5959),i=n.__importDefault(r(1854));t.A=function(e,t,r){void 0===t&&(t=0),void 0===r&&(r=[]);var n=i.default(e,t),a=n[0],s=n[1],l=n[2];return o.useEffect(l,r),[a,s]}},9812:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5959);t.default=function(){var e=n.useRef(!1),t=n.useCallback((function(){return e.current}),[]);return n.useEffect((function(){return e.current=!0,function(){e.current=!1}}),[]),t}},1854:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5959);t.default=function(e,t){void 0===t&&(t=0);var r=n.useRef(!1),o=n.useRef(),i=n.useRef(e),a=n.useCallback((function(){return r.current}),[]),s=n.useCallback((function(){r.current=!1,o.current&&clearTimeout(o.current),o.current=setTimeout((function(){r.current=!0,i.current()}),t)}),[t]),l=n.useCallback((function(){r.current=null,o.current&&clearTimeout(o.current)}),[]);return n.useEffect((function(){i.current=e}),[e]),n.useEffect((function(){return s(),l}),[t]),[a,l,s]}},8044:(e,t,r)=>{"use strict";var n=r(5959),o=Symbol.for("react.element"),i=Symbol.for("react.fragment"),a=Object.prototype.hasOwnProperty,s=n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,l={key:!0,ref:!0,__self:!0,__source:!0};function u(e,t,r){var n,i={},u=null,c=null;for(n in void 0!==r&&(u=""+r),void 0!==t.key&&(u=""+t.key),void 0!==t.ref&&(c=t.ref),t)a.call(t,n)&&!l.hasOwnProperty(n)&&(i[n]=t[n]);if(e&&e.defaultProps)for(n in t=e.defaultProps)void 0===i[n]&&(i[n]=t[n]);return{$$typeof:o,type:e,key:u,ref:c,props:i,_owner:s.current}}t.Fragment=i,t.jsx=u,t.jsxs=u},9728:(e,t,r)=>{"use strict";e.exports=r(8044)},9264:(e,t,r)=>{const n=Symbol("SemVer ANY");class o{static get ANY(){return n}constructor(e,t){if(t=i(t),e instanceof o){if(e.loose===!!t.loose)return e;e=e.value}e=e.trim().split(/\s+/).join(" "),u("comparator",e,t),this.options=t,this.loose=!!t.loose,this.parse(e),this.semver===n?this.value="":this.value=this.operator+this.semver.version,u("comp",this)}parse(e){const t=this.options.loose?a[s.COMPARATORLOOSE]:a[s.COMPARATOR],r=e.match(t);if(!r)throw new TypeError(`Invalid comparator: ${e}`);this.operator=void 0!==r[1]?r[1]:"","="===this.operator&&(this.operator=""),r[2]?this.semver=new c(r[2],this.options.loose):this.semver=n}toString(){return this.value}test(e){if(u("Comparator.test",e,this.options.loose),this.semver===n||e===n)return!0;if("string"==typeof e)try{e=new c(e,this.options)}catch(e){return!1}return l(e,this.operator,this.semver,this.options)}intersects(e,t){if(!(e instanceof o))throw new TypeError("a Comparator is required");return""===this.operator?""===this.value||new d(e.value,t).test(this.value):""===e.operator?""===e.value||new d(this.value,t).test(e.semver):!((t=i(t)).includePrerelease&&("<0.0.0-0"===this.value||"<0.0.0-0"===e.value)||!t.includePrerelease&&(this.value.startsWith("<0.0.0")||e.value.startsWith("<0.0.0"))||(!this.operator.startsWith(">")||!e.operator.startsWith(">"))&&(!this.operator.startsWith("<")||!e.operator.startsWith("<"))&&(this.semver.version!==e.semver.version||!this.operator.includes("=")||!e.operator.includes("="))&&!(l(this.semver,"<",e.semver,t)&&this.operator.startsWith(">")&&e.operator.startsWith("<"))&&!(l(this.semver,">",e.semver,t)&&this.operator.startsWith("<")&&e.operator.startsWith(">")))}}e.exports=o;const i=r(9547),{safeRe:a,t:s}=r(5750),l=r(4991),u=r(1064),c=r(4708),d=r(2839)},2839:(e,t,r)=>{const n=/\s+/g;class o{constructor(e,t){if(t=a(t),e instanceof o)return e.loose===!!t.loose&&e.includePrerelease===!!t.includePrerelease?e:new o(e.raw,t);if(e instanceof s)return this.raw=e.value,this.set=[[e]],this.formatted=void 0,this;if(this.options=t,this.loose=!!t.loose,this.includePrerelease=!!t.includePrerelease,this.raw=e.trim().replace(n," "),this.set=this.raw.split("||").map((e=>this.parseRange(e.trim()))).filter((e=>e.length)),!this.set.length)throw new TypeError(`Invalid SemVer Range: ${this.raw}`);if(this.set.length>1){const e=this.set[0];if(this.set=this.set.filter((e=>!y(e[0]))),0===this.set.length)this.set=[e];else if(this.set.length>1)for(const e of this.set)if(1===e.length&&m(e[0])){this.set=[e];break}}this.formatted=void 0}get range(){if(void 0===this.formatted){this.formatted="";for(let e=0;e<this.set.length;e++){e>0&&(this.formatted+="||");const t=this.set[e];for(let e=0;e<t.length;e++)e>0&&(this.formatted+=" "),this.formatted+=t[e].toString().trim()}}return this.formatted}format(){return this.range}toString(){return this.range}parseRange(e){const t=((this.options.includePrerelease&&h)|(this.options.loose&&g))+":"+e,r=i.get(t);if(r)return r;const n=this.options.loose,o=n?c[d.HYPHENRANGELOOSE]:c[d.HYPHENRANGE];e=e.replace(o,N(this.options.includePrerelease)),l("hyphen replace",e),e=e.replace(c[d.COMPARATORTRIM],p),l("comparator trim",e),e=e.replace(c[d.TILDETRIM],f),l("tilde trim",e),e=e.replace(c[d.CARETTRIM],v),l("caret trim",e);let a=e.split(" ").map((e=>E(e,this.options))).join(" ").split(/\s+/).map((e=>C(e,this.options)));n&&(a=a.filter((e=>(l("loose invalid filter",e,this.options),!!e.match(c[d.COMPARATORLOOSE]))))),l("range list",a);const u=new Map,m=a.map((e=>new s(e,this.options)));for(const e of m){if(y(e))return[e];u.set(e.value,e)}u.size>1&&u.has("")&&u.delete("");const b=[...u.values()];return i.set(t,b),b}intersects(e,t){if(!(e instanceof o))throw new TypeError("a Range is required");return this.set.some((r=>b(r,t)&&e.set.some((e=>b(e,t)&&r.every((r=>e.every((e=>r.intersects(e,t)))))))))}test(e){if(!e)return!1;if("string"==typeof e)try{e=new u(e,this.options)}catch(e){return!1}for(let t=0;t<this.set.length;t++)if(L(this.set[t],e,this.options))return!0;return!1}}e.exports=o;const i=new(r(122)),a=r(9547),s=r(9264),l=r(1064),u=r(4708),{safeRe:c,t:d,comparatorTrimReplace:p,tildeTrimReplace:f,caretTrimReplace:v}=r(5750),{FLAG_INCLUDE_PRERELEASE:h,FLAG_LOOSE:g}=r(2074),y=e=>"<0.0.0-0"===e.value,m=e=>""===e.value,b=(e,t)=>{let r=!0;const n=e.slice();let o=n.pop();for(;r&&n.length;)r=n.every((e=>o.intersects(e,t))),o=n.pop();return r},E=(e,t)=>(l("comp",e,t),e=_(e,t),l("caret",e),e=S(e,t),l("tildes",e),e=R(e,t),l("xrange",e),e=A(e,t),l("stars",e),e),O=e=>!e||"x"===e.toLowerCase()||"*"===e,S=(e,t)=>e.trim().split(/\s+/).map((e=>T(e,t))).join(" "),T=(e,t)=>{const r=t.loose?c[d.TILDELOOSE]:c[d.TILDE];return e.replace(r,((t,r,n,o,i)=>{let a;return l("tilde",e,t,r,n,o,i),O(r)?a="":O(n)?a=`>=${r}.0.0 <${+r+1}.0.0-0`:O(o)?a=`>=${r}.${n}.0 <${r}.${+n+1}.0-0`:i?(l("replaceTilde pr",i),a=`>=${r}.${n}.${o}-${i} <${r}.${+n+1}.0-0`):a=`>=${r}.${n}.${o} <${r}.${+n+1}.0-0`,l("tilde return",a),a}))},_=(e,t)=>e.trim().split(/\s+/).map((e=>w(e,t))).join(" "),w=(e,t)=>{l("caret",e,t);const r=t.loose?c[d.CARETLOOSE]:c[d.CARET],n=t.includePrerelease?"-0":"";return e.replace(r,((t,r,o,i,a)=>{let s;return l("caret",e,t,r,o,i,a),O(r)?s="":O(o)?s=`>=${r}.0.0${n} <${+r+1}.0.0-0`:O(i)?s="0"===r?`>=${r}.${o}.0${n} <${r}.${+o+1}.0-0`:`>=${r}.${o}.0${n} <${+r+1}.0.0-0`:a?(l("replaceCaret pr",a),s="0"===r?"0"===o?`>=${r}.${o}.${i}-${a} <${r}.${o}.${+i+1}-0`:`>=${r}.${o}.${i}-${a} <${r}.${+o+1}.0-0`:`>=${r}.${o}.${i}-${a} <${+r+1}.0.0-0`):(l("no pr"),s="0"===r?"0"===o?`>=${r}.${o}.${i}${n} <${r}.${o}.${+i+1}-0`:`>=${r}.${o}.${i}${n} <${r}.${+o+1}.0-0`:`>=${r}.${o}.${i} <${+r+1}.0.0-0`),l("caret return",s),s}))},R=(e,t)=>(l("replaceXRanges",e,t),e.split(/\s+/).map((e=>I(e,t))).join(" ")),I=(e,t)=>{e=e.trim();const r=t.loose?c[d.XRANGELOOSE]:c[d.XRANGE];return e.replace(r,((r,n,o,i,a,s)=>{l("xRange",e,r,n,o,i,a,s);const u=O(o),c=u||O(i),d=c||O(a),p=d;return"="===n&&p&&(n=""),s=t.includePrerelease?"-0":"",u?r=">"===n||"<"===n?"<0.0.0-0":"*":n&&p?(c&&(i=0),a=0,">"===n?(n=">=",c?(o=+o+1,i=0,a=0):(i=+i+1,a=0)):"<="===n&&(n="<",c?o=+o+1:i=+i+1),"<"===n&&(s="-0"),r=`${n+o}.${i}.${a}${s}`):c?r=`>=${o}.0.0${s} <${+o+1}.0.0-0`:d&&(r=`>=${o}.${i}.0${s} <${o}.${+i+1}.0-0`),l("xRange return",r),r}))},A=(e,t)=>(l("replaceStars",e,t),e.trim().replace(c[d.STAR],"")),C=(e,t)=>(l("replaceGTE0",e,t),e.trim().replace(c[t.includePrerelease?d.GTE0PRE:d.GTE0],"")),N=e=>(t,r,n,o,i,a,s,l,u,c,d,p)=>`${r=O(n)?"":O(o)?`>=${n}.0.0${e?"-0":""}`:O(i)?`>=${n}.${o}.0${e?"-0":""}`:a?`>=${r}`:`>=${r}${e?"-0":""}`} ${l=O(u)?"":O(c)?`<${+u+1}.0.0-0`:O(d)?`<${u}.${+c+1}.0-0`:p?`<=${u}.${c}.${d}-${p}`:e?`<${u}.${c}.${+d+1}-0`:`<=${l}`}`.trim(),L=(e,t,r)=>{for(let r=0;r<e.length;r++)if(!e[r].test(t))return!1;if(t.prerelease.length&&!r.includePrerelease){for(let r=0;r<e.length;r++)if(l(e[r].semver),e[r].semver!==s.ANY&&e[r].semver.prerelease.length>0){const n=e[r].semver;if(n.major===t.major&&n.minor===t.minor&&n.patch===t.patch)return!0}return!1}return!0}},4708:(e,t,r)=>{const n=r(1064),{MAX_LENGTH:o,MAX_SAFE_INTEGER:i}=r(2074),{safeRe:a,t:s}=r(5750),l=r(9547),{compareIdentifiers:u}=r(1427);class c{constructor(e,t){if(t=l(t),e instanceof c){if(e.loose===!!t.loose&&e.includePrerelease===!!t.includePrerelease)return e;e=e.version}else if("string"!=typeof e)throw new TypeError(`Invalid version. Must be a string. Got type "${typeof e}".`);if(e.length>o)throw new TypeError(`version is longer than ${o} characters`);n("SemVer",e,t),this.options=t,this.loose=!!t.loose,this.includePrerelease=!!t.includePrerelease;const r=e.trim().match(t.loose?a[s.LOOSE]:a[s.FULL]);if(!r)throw new TypeError(`Invalid Version: ${e}`);if(this.raw=e,this.major=+r[1],this.minor=+r[2],this.patch=+r[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");r[4]?this.prerelease=r[4].split(".").map((e=>{if(/^[0-9]+$/.test(e)){const t=+e;if(t>=0&&t<i)return t}return e})):this.prerelease=[],this.build=r[5]?r[5].split("."):[],this.format()}format(){return this.version=`${this.major}.${this.minor}.${this.patch}`,this.prerelease.length&&(this.version+=`-${this.prerelease.join(".")}`),this.version}toString(){return this.version}compare(e){if(n("SemVer.compare",this.version,this.options,e),!(e instanceof c)){if("string"==typeof e&&e===this.version)return 0;e=new c(e,this.options)}return e.version===this.version?0:this.compareMain(e)||this.comparePre(e)}compareMain(e){return e instanceof c||(e=new c(e,this.options)),u(this.major,e.major)||u(this.minor,e.minor)||u(this.patch,e.patch)}comparePre(e){if(e instanceof c||(e=new c(e,this.options)),this.prerelease.length&&!e.prerelease.length)return-1;if(!this.prerelease.length&&e.prerelease.length)return 1;if(!this.prerelease.length&&!e.prerelease.length)return 0;let t=0;do{const r=this.prerelease[t],o=e.prerelease[t];if(n("prerelease compare",t,r,o),void 0===r&&void 0===o)return 0;if(void 0===o)return 1;if(void 0===r)return-1;if(r!==o)return u(r,o)}while(++t)}compareBuild(e){e instanceof c||(e=new c(e,this.options));let t=0;do{const r=this.build[t],o=e.build[t];if(n("build compare",t,r,o),void 0===r&&void 0===o)return 0;if(void 0===o)return 1;if(void 0===r)return-1;if(r!==o)return u(r,o)}while(++t)}inc(e,t,r){switch(e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",t,r);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",t,r);break;case"prepatch":this.prerelease.length=0,this.inc("patch",t,r),this.inc("pre",t,r);break;case"prerelease":0===this.prerelease.length&&this.inc("patch",t,r),this.inc("pre",t,r);break;case"major":0===this.minor&&0===this.patch&&0!==this.prerelease.length||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":0===this.patch&&0!==this.prerelease.length||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":0===this.prerelease.length&&this.patch++,this.prerelease=[];break;case"pre":{const e=Number(r)?1:0;if(!t&&!1===r)throw new Error("invalid increment argument: identifier is empty");if(0===this.prerelease.length)this.prerelease=[e];else{let n=this.prerelease.length;for(;--n>=0;)"number"==typeof this.prerelease[n]&&(this.prerelease[n]++,n=-2);if(-1===n){if(t===this.prerelease.join(".")&&!1===r)throw new Error("invalid increment argument: identifier already exists");this.prerelease.push(e)}}if(t){let n=[t,e];!1===r&&(n=[t]),0===u(this.prerelease[0],t)?isNaN(this.prerelease[1])&&(this.prerelease=n):this.prerelease=n}break}default:throw new Error(`invalid increment argument: ${e}`)}return this.raw=this.format(),this.build.length&&(this.raw+=`+${this.build.join(".")}`),this}}e.exports=c},8854:(e,t,r)=>{const n=r(4256);e.exports=(e,t)=>{const r=n(e.trim().replace(/^[=v]+/,""),t);return r?r.version:null}},4991:(e,t,r)=>{const n=r(1409),o=r(6031),i=r(9308),a=r(3833),s=r(2083),l=r(4624);e.exports=(e,t,r,u)=>{switch(t){case"===":return"object"==typeof e&&(e=e.version),"object"==typeof r&&(r=r.version),e===r;case"!==":return"object"==typeof e&&(e=e.version),"object"==typeof r&&(r=r.version),e!==r;case"":case"=":case"==":return n(e,r,u);case"!=":return o(e,r,u);case">":return i(e,r,u);case">=":return a(e,r,u);case"<":return s(e,r,u);case"<=":return l(e,r,u);default:throw new TypeError(`Invalid operator: ${t}`)}}},362:(e,t,r)=>{const n=r(4708),o=r(4256),{safeRe:i,t:a}=r(5750);e.exports=(e,t)=>{if(e instanceof n)return e;if("number"==typeof e&&(e=String(e)),"string"!=typeof e)return null;let r=null;if((t=t||{}).rtl){const n=t.includePrerelease?i[a.COERCERTLFULL]:i[a.COERCERTL];let o;for(;(o=n.exec(e))&&(!r||r.index+r[0].length!==e.length);)r&&o.index+o[0].length===r.index+r[0].length||(r=o),n.lastIndex=o.index+o[1].length+o[2].length;n.lastIndex=-1}else r=e.match(t.includePrerelease?i[a.COERCEFULL]:i[a.COERCE]);if(null===r)return null;const s=r[2],l=r[3]||"0",u=r[4]||"0",c=t.includePrerelease&&r[5]?`-${r[5]}`:"",d=t.includePrerelease&&r[6]?`+${r[6]}`:"";return o(`${s}.${l}.${u}${c}${d}`,t)}},7565:(e,t,r)=>{const n=r(4708);e.exports=(e,t,r)=>{const o=new n(e,r),i=new n(t,r);return o.compare(i)||o.compareBuild(i)}},5699:(e,t,r)=>{const n=r(3440);e.exports=(e,t)=>n(e,t,!0)},3440:(e,t,r)=>{const n=r(4708);e.exports=(e,t,r)=>new n(e,r).compare(new n(t,r))},4952:(e,t,r)=>{const n=r(4256);e.exports=(e,t)=>{const r=n(e,null,!0),o=n(t,null,!0),i=r.compare(o);if(0===i)return null;const a=i>0,s=a?r:o,l=a?o:r,u=!!s.prerelease.length;if(l.prerelease.length&&!u)return l.patch||l.minor?s.patch?"patch":s.minor?"minor":"major":"major";const c=u?"pre":"";return r.major!==o.major?c+"major":r.minor!==o.minor?c+"minor":r.patch!==o.patch?c+"patch":"prerelease"}},1409:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>0===n(e,t,r)},9308:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>n(e,t,r)>0},3833:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>n(e,t,r)>=0},2479:(e,t,r)=>{const n=r(4708);e.exports=(e,t,r,o,i)=>{"string"==typeof r&&(i=o,o=r,r=void 0);try{return new n(e instanceof n?e.version:e,r).inc(t,o,i).version}catch(e){return null}}},2083:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>n(e,t,r)<0},4624:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>n(e,t,r)<=0},1034:(e,t,r)=>{const n=r(4708);e.exports=(e,t)=>new n(e,t).major},9406:(e,t,r)=>{const n=r(4708);e.exports=(e,t)=>new n(e,t).minor},6031:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>0!==n(e,t,r)},4256:(e,t,r)=>{const n=r(4708);e.exports=(e,t,r=!1)=>{if(e instanceof n)return e;try{return new n(e,t)}catch(e){if(!r)return null;throw e}}},5229:(e,t,r)=>{const n=r(4708);e.exports=(e,t)=>new n(e,t).patch},6513:(e,t,r)=>{const n=r(4256);e.exports=(e,t)=>{const r=n(e,t);return r&&r.prerelease.length?r.prerelease:null}},7618:(e,t,r)=>{const n=r(3440);e.exports=(e,t,r)=>n(t,e,r)},1173:(e,t,r)=>{const n=r(7565);e.exports=(e,t)=>e.sort(((e,r)=>n(r,e,t)))},3238:(e,t,r)=>{const n=r(2839);e.exports=(e,t,r)=>{try{t=new n(t,r)}catch(e){return!1}return t.test(e)}},3559:(e,t,r)=>{const n=r(7565);e.exports=(e,t)=>e.sort(((e,r)=>n(e,r,t)))},9881:(e,t,r)=>{const n=r(4256);e.exports=(e,t)=>{const r=n(e,t);return r?r.version:null}},709:(e,t,r)=>{const n=r(5750),o=r(2074),i=r(4708),a=r(1427),s=r(4256),l=r(9881),u=r(8854),c=r(2479),d=r(4952),p=r(1034),f=r(9406),v=r(5229),h=r(6513),g=r(3440),y=r(7618),m=r(5699),b=r(7565),E=r(3559),O=r(1173),S=r(9308),T=r(2083),_=r(1409),w=r(6031),R=r(3833),I=r(4624),A=r(4991),C=r(362),N=r(9264),L=r(2839),P=r(3238),x=r(3327),j=r(6988),F=r(2366),D=r(7453),k=r(130),M=r(7715),V=r(7379),U=r(110),B=r(284),G=r(8285),$=r(2008);e.exports={parse:s,valid:l,clean:u,inc:c,diff:d,major:p,minor:f,patch:v,prerelease:h,compare:g,rcompare:y,compareLoose:m,compareBuild:b,sort:E,rsort:O,gt:S,lt:T,eq:_,neq:w,gte:R,lte:I,cmp:A,coerce:C,Comparator:N,Range:L,satisfies:P,toComparators:x,maxSatisfying:j,minSatisfying:F,minVersion:D,validRange:k,outside:M,gtr:V,ltr:U,intersects:B,simplifyRange:G,subset:$,SemVer:i,re:n.re,src:n.src,tokens:n.t,SEMVER_SPEC_VERSION:o.SEMVER_SPEC_VERSION,RELEASE_TYPES:o.RELEASE_TYPES,compareIdentifiers:a.compareIdentifiers,rcompareIdentifiers:a.rcompareIdentifiers}},2074:e=>{const t=Number.MAX_SAFE_INTEGER||9007199254740991;e.exports={MAX_LENGTH:256,MAX_SAFE_COMPONENT_LENGTH:16,MAX_SAFE_BUILD_LENGTH:250,MAX_SAFE_INTEGER:t,RELEASE_TYPES:["major","premajor","minor","preminor","patch","prepatch","prerelease"],SEMVER_SPEC_VERSION:"2.0.0",FLAG_INCLUDE_PRERELEASE:1,FLAG_LOOSE:2}},1064:e=>{const t="object"==typeof process&&process.env&&process.env.NODE_DEBUG&&/\bsemver\b/i.test(process.env.NODE_DEBUG)?(...e)=>console.error("SEMVER",...e):()=>{};e.exports=t},1427:e=>{const t=/^[0-9]+$/,r=(e,r)=>{const n=t.test(e),o=t.test(r);return n&&o&&(e=+e,r=+r),e===r?0:n&&!o?-1:o&&!n?1:e<r?-1:1};e.exports={compareIdentifiers:r,rcompareIdentifiers:(e,t)=>r(t,e)}},122:e=>{e.exports=class{constructor(){this.max=1e3,this.map=new Map}get(e){const t=this.map.get(e);return void 0===t?void 0:(this.map.delete(e),this.map.set(e,t),t)}delete(e){return this.map.delete(e)}set(e,t){if(!this.delete(e)&&void 0!==t){if(this.map.size>=this.max){const e=this.map.keys().next().value;this.delete(e)}this.map.set(e,t)}return this}}},9547:e=>{const t=Object.freeze({loose:!0}),r=Object.freeze({});e.exports=e=>e?"object"!=typeof e?t:e:r},5750:(e,t,r)=>{const{MAX_SAFE_COMPONENT_LENGTH:n,MAX_SAFE_BUILD_LENGTH:o,MAX_LENGTH:i}=r(2074),a=r(1064),s=(t=e.exports={}).re=[],l=t.safeRe=[],u=t.src=[],c=t.t={};let d=0;const p="[a-zA-Z0-9-]",f=[["\\s",1],["\\d",i],[p,o]],v=(e,t,r)=>{const n=(e=>{for(const[t,r]of f)e=e.split(`${t}*`).join(`${t}{0,${r}}`).split(`${t}+`).join(`${t}{1,${r}}`);return e})(t),o=d++;a(e,o,t),c[e]=o,u[o]=t,s[o]=new RegExp(t,r?"g":void 0),l[o]=new RegExp(n,r?"g":void 0)};v("NUMERICIDENTIFIER","0|[1-9]\\d*"),v("NUMERICIDENTIFIERLOOSE","\\d+"),v("NONNUMERICIDENTIFIER",`\\d*[a-zA-Z-]${p}*`),v("MAINVERSION",`(${u[c.NUMERICIDENTIFIER]})\\.(${u[c.NUMERICIDENTIFIER]})\\.(${u[c.NUMERICIDENTIFIER]})`),v("MAINVERSIONLOOSE",`(${u[c.NUMERICIDENTIFIERLOOSE]})\\.(${u[c.NUMERICIDENTIFIERLOOSE]})\\.(${u[c.NUMERICIDENTIFIERLOOSE]})`),v("PRERELEASEIDENTIFIER",`(?:${u[c.NUMERICIDENTIFIER]}|${u[c.NONNUMERICIDENTIFIER]})`),v("PRERELEASEIDENTIFIERLOOSE",`(?:${u[c.NUMERICIDENTIFIERLOOSE]}|${u[c.NONNUMERICIDENTIFIER]})`),v("PRERELEASE",`(?:-(${u[c.PRERELEASEIDENTIFIER]}(?:\\.${u[c.PRERELEASEIDENTIFIER]})*))`),v("PRERELEASELOOSE",`(?:-?(${u[c.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${u[c.PRERELEASEIDENTIFIERLOOSE]})*))`),v("BUILDIDENTIFIER",`${p}+`),v("BUILD",`(?:\\+(${u[c.BUILDIDENTIFIER]}(?:\\.${u[c.BUILDIDENTIFIER]})*))`),v("FULLPLAIN",`v?${u[c.MAINVERSION]}${u[c.PRERELEASE]}?${u[c.BUILD]}?`),v("FULL",`^${u[c.FULLPLAIN]}$`),v("LOOSEPLAIN",`[v=\\s]*${u[c.MAINVERSIONLOOSE]}${u[c.PRERELEASELOOSE]}?${u[c.BUILD]}?`),v("LOOSE",`^${u[c.LOOSEPLAIN]}$`),v("GTLT","((?:<|>)?=?)"),v("XRANGEIDENTIFIERLOOSE",`${u[c.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`),v("XRANGEIDENTIFIER",`${u[c.NUMERICIDENTIFIER]}|x|X|\\*`),v("XRANGEPLAIN",`[v=\\s]*(${u[c.XRANGEIDENTIFIER]})(?:\\.(${u[c.XRANGEIDENTIFIER]})(?:\\.(${u[c.XRANGEIDENTIFIER]})(?:${u[c.PRERELEASE]})?${u[c.BUILD]}?)?)?`),v("XRANGEPLAINLOOSE",`[v=\\s]*(${u[c.XRANGEIDENTIFIERLOOSE]})(?:\\.(${u[c.XRANGEIDENTIFIERLOOSE]})(?:\\.(${u[c.XRANGEIDENTIFIERLOOSE]})(?:${u[c.PRERELEASELOOSE]})?${u[c.BUILD]}?)?)?`),v("XRANGE",`^${u[c.GTLT]}\\s*${u[c.XRANGEPLAIN]}$`),v("XRANGELOOSE",`^${u[c.GTLT]}\\s*${u[c.XRANGEPLAINLOOSE]}$`),v("COERCEPLAIN",`(^|[^\\d])(\\d{1,${n}})(?:\\.(\\d{1,${n}}))?(?:\\.(\\d{1,${n}}))?`),v("COERCE",`${u[c.COERCEPLAIN]}(?:$|[^\\d])`),v("COERCEFULL",u[c.COERCEPLAIN]+`(?:${u[c.PRERELEASE]})?`+`(?:${u[c.BUILD]})?(?:$|[^\\d])`),v("COERCERTL",u[c.COERCE],!0),v("COERCERTLFULL",u[c.COERCEFULL],!0),v("LONETILDE","(?:~>?)"),v("TILDETRIM",`(\\s*)${u[c.LONETILDE]}\\s+`,!0),t.tildeTrimReplace="$1~",v("TILDE",`^${u[c.LONETILDE]}${u[c.XRANGEPLAIN]}$`),v("TILDELOOSE",`^${u[c.LONETILDE]}${u[c.XRANGEPLAINLOOSE]}$`),v("LONECARET","(?:\\^)"),v("CARETTRIM",`(\\s*)${u[c.LONECARET]}\\s+`,!0),t.caretTrimReplace="$1^",v("CARET",`^${u[c.LONECARET]}${u[c.XRANGEPLAIN]}$`),v("CARETLOOSE",`^${u[c.LONECARET]}${u[c.XRANGEPLAINLOOSE]}$`),v("COMPARATORLOOSE",`^${u[c.GTLT]}\\s*(${u[c.LOOSEPLAIN]})$|^$`),v("COMPARATOR",`^${u[c.GTLT]}\\s*(${u[c.FULLPLAIN]})$|^$`),v("COMPARATORTRIM",`(\\s*)${u[c.GTLT]}\\s*(${u[c.LOOSEPLAIN]}|${u[c.XRANGEPLAIN]})`,!0),t.comparatorTrimReplace="$1$2$3",v("HYPHENRANGE",`^\\s*(${u[c.XRANGEPLAIN]})\\s+-\\s+(${u[c.XRANGEPLAIN]})\\s*$`),v("HYPHENRANGELOOSE",`^\\s*(${u[c.XRANGEPLAINLOOSE]})\\s+-\\s+(${u[c.XRANGEPLAINLOOSE]})\\s*$`),v("STAR","(<|>)?=?\\s*\\*"),v("GTE0","^\\s*>=\\s*0\\.0\\.0\\s*$"),v("GTE0PRE","^\\s*>=\\s*0\\.0\\.0-0\\s*$")},7379:(e,t,r)=>{const n=r(7715);e.exports=(e,t,r)=>n(e,t,">",r)},284:(e,t,r)=>{const n=r(2839);e.exports=(e,t,r)=>(e=new n(e,r),t=new n(t,r),e.intersects(t,r))},110:(e,t,r)=>{const n=r(7715);e.exports=(e,t,r)=>n(e,t,"<",r)},6988:(e,t,r)=>{const n=r(4708),o=r(2839);e.exports=(e,t,r)=>{let i=null,a=null,s=null;try{s=new o(t,r)}catch(e){return null}return e.forEach((e=>{s.test(e)&&(i&&-1!==a.compare(e)||(i=e,a=new n(i,r)))})),i}},2366:(e,t,r)=>{const n=r(4708),o=r(2839);e.exports=(e,t,r)=>{let i=null,a=null,s=null;try{s=new o(t,r)}catch(e){return null}return e.forEach((e=>{s.test(e)&&(i&&1!==a.compare(e)||(i=e,a=new n(i,r)))})),i}},7453:(e,t,r)=>{const n=r(4708),o=r(2839),i=r(9308);e.exports=(e,t)=>{e=new o(e,t);let r=new n("0.0.0");if(e.test(r))return r;if(r=new n("0.0.0-0"),e.test(r))return r;r=null;for(let t=0;t<e.set.length;++t){const o=e.set[t];let a=null;o.forEach((e=>{const t=new n(e.semver.version);switch(e.operator){case">":0===t.prerelease.length?t.patch++:t.prerelease.push(0),t.raw=t.format();case"":case">=":a&&!i(t,a)||(a=t);break;case"<":case"<=":break;default:throw new Error(`Unexpected operation: ${e.operator}`)}})),!a||r&&!i(r,a)||(r=a)}return r&&e.test(r)?r:null}},7715:(e,t,r)=>{const n=r(4708),o=r(9264),{ANY:i}=o,a=r(2839),s=r(3238),l=r(9308),u=r(2083),c=r(4624),d=r(3833);e.exports=(e,t,r,p)=>{let f,v,h,g,y;switch(e=new n(e,p),t=new a(t,p),r){case">":f=l,v=c,h=u,g=">",y=">=";break;case"<":f=u,v=d,h=l,g="<",y="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(s(e,t,p))return!1;for(let r=0;r<t.set.length;++r){const n=t.set[r];let a=null,s=null;if(n.forEach((e=>{e.semver===i&&(e=new o(">=0.0.0")),a=a||e,s=s||e,f(e.semver,a.semver,p)?a=e:h(e.semver,s.semver,p)&&(s=e)})),a.operator===g||a.operator===y)return!1;if((!s.operator||s.operator===g)&&v(e,s.semver))return!1;if(s.operator===y&&h(e,s.semver))return!1}return!0}},8285:(e,t,r)=>{const n=r(3238),o=r(3440);e.exports=(e,t,r)=>{const i=[];let a=null,s=null;const l=e.sort(((e,t)=>o(e,t,r)));for(const e of l)n(e,t,r)?(s=e,a||(a=e)):(s&&i.push([a,s]),s=null,a=null);a&&i.push([a,null]);const u=[];for(const[e,t]of i)e===t?u.push(e):t||e!==l[0]?t?e===l[0]?u.push(`<=${t}`):u.push(`${e} - ${t}`):u.push(`>=${e}`):u.push("*");const c=u.join(" || "),d="string"==typeof t.raw?t.raw:String(t);return c.length<d.length?c:t}},2008:(e,t,r)=>{const n=r(2839),o=r(9264),{ANY:i}=o,a=r(3238),s=r(3440),l=[new o(">=0.0.0-0")],u=[new o(">=0.0.0")],c=(e,t,r)=>{if(e===t)return!0;if(1===e.length&&e[0].semver===i){if(1===t.length&&t[0].semver===i)return!0;e=r.includePrerelease?l:u}if(1===t.length&&t[0].semver===i){if(r.includePrerelease)return!0;t=u}const n=new Set;let o,c,f,v,h,g,y;for(const t of e)">"===t.operator||">="===t.operator?o=d(o,t,r):"<"===t.operator||"<="===t.operator?c=p(c,t,r):n.add(t.semver);if(n.size>1)return null;if(o&&c){if(f=s(o.semver,c.semver,r),f>0)return null;if(0===f&&(">="!==o.operator||"<="!==c.operator))return null}for(const e of n){if(o&&!a(e,String(o),r))return null;if(c&&!a(e,String(c),r))return null;for(const n of t)if(!a(e,String(n),r))return!1;return!0}let m=!(!c||r.includePrerelease||!c.semver.prerelease.length)&&c.semver,b=!(!o||r.includePrerelease||!o.semver.prerelease.length)&&o.semver;m&&1===m.prerelease.length&&"<"===c.operator&&0===m.prerelease[0]&&(m=!1);for(const e of t){if(y=y||">"===e.operator||">="===e.operator,g=g||"<"===e.operator||"<="===e.operator,o)if(b&&e.semver.prerelease&&e.semver.prerelease.length&&e.semver.major===b.major&&e.semver.minor===b.minor&&e.semver.patch===b.patch&&(b=!1),">"===e.operator||">="===e.operator){if(v=d(o,e,r),v===e&&v!==o)return!1}else if(">="===o.operator&&!a(o.semver,String(e),r))return!1;if(c)if(m&&e.semver.prerelease&&e.semver.prerelease.length&&e.semver.major===m.major&&e.semver.minor===m.minor&&e.semver.patch===m.patch&&(m=!1),"<"===e.operator||"<="===e.operator){if(h=p(c,e,r),h===e&&h!==c)return!1}else if("<="===c.operator&&!a(c.semver,String(e),r))return!1;if(!e.operator&&(c||o)&&0!==f)return!1}return!(o&&g&&!c&&0!==f||c&&y&&!o&&0!==f||b||m)},d=(e,t,r)=>{if(!e)return t;const n=s(e.semver,t.semver,r);return n>0?e:n<0||">"===t.operator&&">="===e.operator?t:e},p=(e,t,r)=>{if(!e)return t;const n=s(e.semver,t.semver,r);return n<0?e:n>0||"<"===t.operator&&"<="===e.operator?t:e};e.exports=(e,t,r={})=>{if(e===t)return!0;e=new n(e,r),t=new n(t,r);let o=!1;e:for(const n of e.set){for(const e of t.set){const t=c(n,e,r);if(o=o||null!==t,t)continue e}if(o)return!1}return!0}},3327:(e,t,r)=>{const n=r(2839);e.exports=(e,t)=>new n(e,t).set.map((e=>e.map((e=>e.value)).join(" ").trim().split(" ")))},130:(e,t,r)=>{const n=r(2839);e.exports=(e,t)=>{try{return new n(e,t).range||"*"}catch(e){return null}}},138:function(e){var t;t=function(){return function(e){var t={};function r(n){if(t[n])return t[n].exports;var o=t[n]={i:n,l:!1,exports:{}};return e[n].call(o.exports,o,o.exports,r),o.l=!0,o.exports}return r.m=e,r.c=t,r.d=function(e,t,n){r.o(e,t)||Object.defineProperty(e,t,{configurable:!1,enumerable:!0,get:n})},r.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return r.d(t,"a",t),t},r.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},r.p="",r(r.s=3)}([function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelNode={create:function(e,t){var r,n={},o=e||"Abstract",i=[],a=null;if(n._type=o,n.getType=function(){return o},n.setType=function(e){o=e},n.getChildren=function(){return i},n.addChild=function(e){if(e){if(!e.setParent)throw{name:"Error",message:"Trying to add a child which is not a node: "+JSON.stringify(e)};e.setParent(n),i.push(e)}},n.getParent=function(){return a},n.setParent=function(e){a=e},n.getContext=function(e){return r||e.activeContext.peek()},n.setContext=function(e){r=e},n.getStartPosition=function(){return t>>16},n.getEndPosition=function(){return 65535&t},n.getValue=function(){throw{name:"MethodNotImplementedException",message:"SpelNode#getValue() must be overridden."}},n.toString=function(){var e="Kind: "+n.getType();e+=", Children: [";for(var t=0,r=n.getChildren().length;t<r;t+=1)e+="{"+n.getChildren()[t]+"}, ";return e+"]"},0===t)throw{name:"Error",message:"Position cannot be 0"};for(var s=arguments.length,l=Array(s>2?s-2:0),u=2;u<s;u++)l[u-2]=arguments[u];return l&&l.forEach((function(e){n.addChild(e)})),n}}},function(e,t,r){"use strict";function n(e){this.elements=e||[]}Object.defineProperty(t,"__esModule",{value:!0}),t.Stack=n,n.prototype.push=function(e){return this.elements.push(e),e},n.prototype.pop=function(){return this.elements.pop()},n.prototype.peek=function(){return this.elements[this.elements.length-1]},n.prototype.empty=function(){return this.elements.length>0},n.prototype.search=function(e){return this.elements.length-this.elements.indexOf(e)}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n={LITERAL_INT:1,LITERAL_LONG:2,LITERAL_HEXINT:3,LITERAL_HEXLONG:4,LITERAL_STRING:5,LITERAL_REAL:6,LITERAL_REAL_FLOAT:7,LPAREN:"(",RPAREN:")",COMMA:",",IDENTIFIER:0,COLON:":",HASH:"#",RSQUARE:"]",LSQUARE:"[",LCURLY:"{",RCURLY:"}",DOT:".",PLUS:"+",STAR:"*",MINUS:"-",SELECT_FIRST:"^[",SELECT_LAST:"$[",QMARK:"?",PROJECT:"![",DIV:"/",GE:">=",GT:">",LE:"<=",LT:"<",EQ:"==",NE:"!=",MOD:"%",NOT:"!",ASSIGN:"=",INSTANCEOF:"instanceof",MATCHES:"matches",BETWEEN:"between",SELECT:"?[",POWER:"^",ELVIS:"?:",SAFE_NAVI:"?.",BEAN_REF:"@",SYMBOLIC_OR:"||",SYMBOLIC_AND:"&&",INC:"++",DEC:"--"};function o(e){this.type=e,this.tokenChars=n[e],this._hasPayload="string"!=typeof n[e],"number"==typeof n[e]&&(this._ordinal=n[e])}for(var i in n)n.hasOwnProperty(i)&&(o[i]=new o(i));o.prototype.toString=function(){return this.type+(0!==this.tokenChars.length?"("+this.tokenChars+")":"")},o.prototype.getLength=function(){return this.tokenChars.length},o.prototype.hasPayload=function(){return this._hasPayload},o.prototype.valueOf=function(e){for(var t in n)if(n.hasOwnProperty(t)&&n[t]===e)return o[t]},o.prototype.ordinal=function(){return this._ordinal},t.TokenKind=o},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardContext=t.SpelExpressionEvaluator=void 0;var n=r(4),o=r(50);t.SpelExpressionEvaluator=n.SpelExpressionEvaluator,t.StandardContext=o.StandardContext},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelExpressionEvaluator=void 0;var n=r(5),o=r(1),i={compile:function(e){var t=(0,n.SpelExpressionParser)().parse(e);return{eval:function(e,r){return function(e,t,r){var n,i=new o.Stack;return t||(t={}),i.push(t),n={rootContext:t,activeContext:i,locals:r},e.getValue(n)}(t,e,r)},_compiledExpression:t}},eval:function(e,t,r){return i.compile(e).eval(t,r)}};t.SpelExpressionEvaluator=i},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelExpressionParser=void 0;var n=r(2),o=r(6),i=r(8),a=r(9),s=r(10),l=r(11),u=r(12),c=r(13),d=r(14),p=r(15),f=r(16),v=r(17),h=r(18),g=r(19),y=r(20),m=r(21),b=r(22),E=r(23),O=r(24),S=r(25),T=r(26),_=r(27),w=r(28),R=r(29),I=r(30),A=r(31),C=r(32),N=r(33),L=r(34),P=r(35),x=r(36),j=r(37),F=r(38),D=r(39),k=r(40),M=r(41),V=r(42),U=r(43),B=r(44),G=r(45),$=r(46),q=r(47),K=r(48),W=r(49);t.SpelExpressionParser=function(){var e,t,r,z,H=new RegExp("[\\p{L}\\p{N}_$]+"),Y=[];function Q(){var e=X();if(Se()){var t=_e();if(t.getKind()===n.TokenKind.ASSIGN){null===e&&(e=l.NullLiteral.create(Ce(t.startPos-1,t.endPos-1))),Te();var r=X();return h.Assign.create(Ae(t),e,r)}if(t.getKind()===n.TokenKind.ELVIS){null===e&&(e=l.NullLiteral.create(Ce(t.startPos-1,t.endPos-2))),Te();var o=Q();return null===o&&(o=l.NullLiteral.create(Ce(t.startPos+1,t.endPos+1))),F.Elvis.create(Ae(t),e,o)}if(t.getKind()===n.TokenKind.QMARK){null===e&&(e=l.NullLiteral.create(Ce(t.startPos-1,t.endPos-1))),Te();var i=Q();ye(n.TokenKind.COLON);var a=Q();return j.Ternary.create(Ae(t),e,i,a)}}return e}function X(){for(var e=J();Oe("or")||me(n.TokenKind.SYMBOLIC_OR);){var t=Te(),r=J();Re(t,e,r),e=P.OpOr.create(Ae(t),e,r)}return e}function J(){for(var e=Z();Oe("and")||me(n.TokenKind.SYMBOLIC_AND);){var t=Te(),r=Z();Re(t,e,r),e=L.OpAnd.create(Ae(t),e,r)}return e}function Z(){var e=ee(),t=function(){var e=_e();if(null===e)return null;if(e.isNumericRelationalOperator())return e;if(e.isIdentifier()){var t=e.stringValue();if("instanceof"===t.toLowerCase())return e.asInstanceOfToken();if("matches"===t.toLowerCase())return e.asMatchesToken();if("between"===t.toLowerCase())return e.asBetweenToken()}return null}();if(null!==t){var r=Te(),o=ee();Re(r,e,o);var i=t.kind;if(t.isNumericRelationalOperator()){var a=Ae(r);return i===n.TokenKind.GT?b.OpGT.create(a,e,o):i===n.TokenKind.LT?O.OpLT.create(a,e,o):i===n.TokenKind.LE?E.OpLE.create(a,e,o):i===n.TokenKind.GE?m.OpGE.create(a,e,o):i===n.TokenKind.EQ?g.OpEQ.create(a,e,o):y.OpNE.create(a,e,o)}return i===n.TokenKind.INSTANCEOF?U.OpInstanceof.create(Ae(r),e,o):i===n.TokenKind.MATCHES?x.OpMatches.create(Ae(r),e,o):B.OpBetween.create(Ae(r),e,o)}return e}function ee(){for(var e=te();Ee(n.TokenKind.PLUS,n.TokenKind.MINUS,n.TokenKind.INC);){var t=Te(),r=te();Ie(t,r),t.getKind()===n.TokenKind.PLUS?e=S.OpPlus.create(Ae(t),e,r):t.getKind()===n.TokenKind.MINUS&&(e=T.OpMinus.create(Ae(t),e,r))}return e}function te(){for(var e=re();Ee(n.TokenKind.STAR,n.TokenKind.DIV,n.TokenKind.MOD);){var t=Te(),r=re();Re(t,e,r),e=t.getKind()===n.TokenKind.STAR?_.OpMultiply.create(Ae(t),e,r):t.getKind()===n.TokenKind.DIV?w.OpDivide.create(Ae(t),e,r):R.OpModulus.create(Ae(t),e,r)}return e}function re(){var e,t=ne();if(me(n.TokenKind.POWER)){e=Te();var r=ne();return Ie(e,r),I.OpPower.create(Ae(e),t,r)}return null!==t&&Ee(n.TokenKind.INC,n.TokenKind.DEC)?(e=Te()).getKind()===n.TokenKind.INC?A.OpInc.create(Ae(e),!0,t):C.OpDec.create(Ae(e),!0,t):t}function ne(){var e,t;return Ee(n.TokenKind.PLUS,n.TokenKind.MINUS,n.TokenKind.NOT)?(e=Te(),t=ne(),e.getKind()===n.TokenKind.NOT?N.OpNot.create(Ae(e),t):e.getKind()===n.TokenKind.PLUS?S.OpPlus.create(Ae(e),t):T.OpMinus.create(Ae(e),t)):Ee(n.TokenKind.INC,n.TokenKind.DEC)?(e=Te(),t=ne(),e.getKind()===n.TokenKind.INC?A.OpInc.create(Ae(e),!1,t):C.OpDec.create(Ae(e),!1,t)):function(){var e=[],t=function(){var e=_e();if(null===e)return!1;if(e.getKind()===n.TokenKind.LITERAL_INT||e.getKind()===n.TokenKind.LITERAL_LONG)he(a.NumberLiteral.create(parseInt(e.stringValue(),10),Ae(e)));else if(e.getKind()===n.TokenKind.LITERAL_REAL||e.getKind()===n.TokenKind.LITERAL_REAL_FLOAT)he(a.NumberLiteral.create(parseFloat(e.stringValue()),Ae(e)));else if(e.getKind()===n.TokenKind.LITERAL_HEXINT||e.getKind()===n.TokenKind.LITERAL_HEXLONG)he(a.NumberLiteral.create(parseInt(e.stringValue(),16),Ae(e)));else if(Oe("true"))he(i.BooleanLiteral.create(!0,Ae(e)));else if(Oe("false"))he(i.BooleanLiteral.create(!1,Ae(e)));else{if(e.getKind()!==n.TokenKind.LITERAL_STRING)return!1;he(s.StringLiteral.create(e.stringValue(),Ae(e)))}return Te(),!0}()||function(){if(me(n.TokenKind.LPAREN)){Te();var e=Q();return ye(n.TokenKind.RPAREN),he(e),!0}return!1}()||function(){if(me(n.TokenKind.IDENTIFIER)){var e=_e();if("T"!==e.stringValue())return!1;var t=Te();if(me(n.TokenKind.RSQUARE))return he(d.PropertyReference.create(t.stringValue(),Ae(t))),!0;ye(n.TokenKind.LPAREN);for(var r=pe(),o=0;be(n.TokenKind.LSQUARE,!0);)ye(n.TokenKind.RSQUARE),o++;return ye(n.TokenKind.RPAREN),he(G.TypeReference.create(Ae(e),r,o)),!0}return!1}()||function(){if(me(n.TokenKind.IDENTIFIER)){var e=_e();return"null"===e.stringValue().toLowerCase()&&(Te(),he(l.NullLiteral.create(Ae(e))),!0)}return!1}()||function(){if(Oe("new")){var e=Te();if(me(n.TokenKind.RSQUARE))return he(d.PropertyReference.create(e.stringValue(),Ae(e))),!0;var t=pe(),r=[];if(r.push(t),me(n.TokenKind.LSQUARE)){for(var o=[];be(n.TokenKind.LSQUARE,!0);)me(n.TokenKind.RSQUARE)?o.push(null):o.push(Q()),ye(n.TokenKind.RSQUARE);ue()&&r.push(ge()),he(W.ConstructorReference.create(Ae(e),o,r))}else i=r,me(n.TokenKind.LPAREN)||we(Ae(_e()),"MISSING_CONSTRUCTOR_ARGS"),se(i),ye(n.TokenKind.RPAREN),he(W.ConstructorReference.create(Ae(e),r));return!0}var i;return!1}()||ve(!1)||ie()||function(){if(me(n.TokenKind.BEAN_REF)){var e=Te(),t=null,r=null;return me(n.TokenKind.IDENTIFIER)?r=(t=ye(n.TokenKind.IDENTIFIER)).data:me(n.TokenKind.LITERAL_STRING)?r=(r=(t=ye(n.TokenKind.LITERAL_STRING)).stringValue()).substring(1,r.length()-1):we(e.startPos,"INVALID_BEAN_REFERENCE"),he($.BeanReference.create(Ae(t),r)),!0}return!1}()||le(!1)||de(!1)||ce()||ue()?ge():null;for(e.push(t);oe();)e.push(ge());return 1===e.length?e[0]:f.CompoundExpression.create(Ce(t.getStartPosition(),e[e.length-1].getEndPosition()),e)}()}function oe(){var e,t,r;return null!==(r=Ee(n.TokenKind.DOT,n.TokenKind.SAFE_NAVI)?ve(t=(e=Te()).getKind()===n.TokenKind.SAFE_NAVI)||ie()||le(t)||de(t)?ge():(null===_e()?we(e.startPos,"OOD"):we(e.startPos,"UNEXPECTED_DATA_AFTER_DOT",function(e){return e.getKind().hasPayload()?e.stringValue():e.getKind().toString().toLowerCase()}(_e())),null):me(n.TokenKind.LSQUARE)&&ce()?ge():null)&&(he(r),!0)}function ie(){if(!me(n.TokenKind.HASH))return!1;var e=Te(),t=ye(n.TokenKind.IDENTIFIER),r=ae();return null===r?(he(p.VariableReference.create(t.data,Ce(e.startPos,t.endPos))),!0):(he(u.FunctionReference.create(t.data,Ce(e.startPos,t.endPos),r)),!0)}function ae(){if(!me(n.TokenKind.LPAREN))return null;var e=[];return se(e),ye(n.TokenKind.RPAREN),e}function se(e){var t,r=_e().startPos;do{Te();var o=_e();null===o&&we(r,"RUN_OUT_OF_ARGUMENTS"),o.getKind()!==n.TokenKind.RPAREN&&e.push(Q()),t=_e()}while(null!==t&&t.kind===n.TokenKind.COMMA);null===t&&we(r,"RUN_OUT_OF_ARGUMENTS")}function le(e){var t=_e();if(!be(n.TokenKind.PROJECT,!0))return!1;var r=Q();return ye(n.TokenKind.RSQUARE),he(V.Projection.create(e,Ae(t),r)),!0}function ue(){var e=_e(),t=[];if(!be(n.TokenKind.LCURLY,!0))return!1;var r=null,o=_e();if(be(n.TokenKind.RCURLY,!0))r=D.InlineList.create(Ce(e.startPos,o.endPos));else if(be(n.TokenKind.COLON,!0))o=ye(n.TokenKind.RCURLY),r=k.InlineMap.create(Ce(e.startPos,o.endPos));else{var i=Q();if(me(n.TokenKind.RCURLY))t.push(i),o=ye(n.TokenKind.RCURLY),r=D.InlineList.create(Ce(e.startPos,o.endPos),t);else if(be(n.TokenKind.COMMA,!0)){t.push(i);do{t.push(Q())}while(be(n.TokenKind.COMMA,!0));o=ye(n.TokenKind.RCURLY),r=D.InlineList.create(Ae(e.startPos,o.endPos),t)}else if(be(n.TokenKind.COLON,!0)){var a=[];for(a.push(i),a.push(Q());be(n.TokenKind.COMMA,!0);)a.push(Q()),ye(n.TokenKind.COLON),a.push(Q());o=ye(n.TokenKind.RCURLY),r=k.InlineMap.create(Ce(e.startPos,o.endPos),a)}else we(e.startPos,"OOD")}return he(r),!0}function ce(){var e=_e();if(!be(n.TokenKind.LSQUARE,!0))return!1;var t=Q();return ye(n.TokenKind.RSQUARE),he(v.Indexer.create(Ae(e),t)),!0}function de(e){var t=_e();if(!function(){if(!Se())return!1;var e=_e();return e.getKind()===n.TokenKind.SELECT||e.getKind()===n.TokenKind.SELECT_FIRST||e.getKind()===n.TokenKind.SELECT_LAST}())return!1;Te();var r=Q();return null===r&&we(Ae(t),"MISSING_SELECTION_EXPRESSION"),ye(n.TokenKind.RSQUARE),t.getKind()===n.TokenKind.SELECT_FIRST?he(M.Selection.create(e,M.Selection.FIRST,Ae(t),r)):t.getKind()===n.TokenKind.SELECT_LAST?he(M.Selection.create(e,M.Selection.LAST,Ae(t),r)):he(M.Selection.create(e,M.Selection.ALL,Ae(t),r)),!0}function pe(){for(var t=[],r=_e();fe(r);)Te(),r.kind!==n.TokenKind.DOT&&t.push(q.Identifier.create(r.stringValue(),Ae(r))),r=_e();t.length||(null===r&&we(e.length(),"OOD"),we(r.startPos,"NOT_EXPECTED_TOKEN","qualified ID",r.getKind().toString().toLowerCase()));var o=Ce(t[0].getStartPosition(),t[t.length-1].getEndPosition());return K.QualifiedIdentifier.create(o,t)}function fe(e){if(null===e||e.kind===n.TokenKind.LITERAL_STRING)return!1;if(e.kind===n.TokenKind.DOT||e.kind===n.TokenKind.IDENTIFIER)return!0;var t=e.stringValue();return t&&t.length&&H.test(t)}function ve(e){if(me(n.TokenKind.IDENTIFIER)){var t=Te(),r=ae();return null===r?(he(d.PropertyReference.create(e,t.stringValue(),Ae(t))),!0):(he(c.MethodReference.create(e,t.stringValue(),Ae(t),r)),!0)}return!1}function he(e){Y.push(e)}function ge(){return Y.pop()}function ye(t){var r=Te();return null===r&&we(e.length,"OOD"),r.getKind()!==t&&we(r.startPos,"NOT_EXPECTED_TOKEN",t.toString().toLowerCase(),r.getKind().toString().toLowerCase()),r}function me(e){return be(e,!1)}function be(e,t){if(!Se())return!1;var r=_e();return r.getKind()===e?(t&&z++,!0):e===n.TokenKind.IDENTIFIER&&r.getKind().ordinal()>=n.TokenKind.DIV.ordinal()&&r.getKind().ordinal()<=n.TokenKind.NOT.ordinal()&&null!==r.data}function Ee(){if(!Se())return!1;for(var e=_e(),t=Array.prototype.slice.call(arguments),r=0,n=t.length;r<n;r+=1)if(e.getKind()===t[r])return!0;return!1}function Oe(e){if(!Se())return!1;var t=_e();return t.getKind()===n.TokenKind.IDENTIFIER&&t.stringValue().toLowerCase()===e.toLowerCase()}function Se(){return z<t.length}function Te(){return z>=r?null:t[z++]}function _e(){return z>=r?null:t[z]}function we(t,r,n,o){throw n&&(r+="\nExpected: "+n),o&&(r+="\nActual: "+o),{name:"InternalParseException",message:"Error occurred while attempting to parse expression '"+e+"' at position "+t+". Message: "+r}}function Re(e,t,r){!function(e,t){null===t&&we(e.startPos,"LEFT_OPERAND_PROBLEM")}(e,t),Ie(e,r)}function Ie(e,t){null===t&&we(e.startPos,"RIGHT_OPERAND_PROBLEM")}function Ae(e){return(e.startPos<<16)+e.endPos}function Ce(e,t){return(e<<16)+t}return{setConfiguration:function(e){},parse:function(n,i){try{e=n,t=o.Tokenizer.tokenize(n),r=t.length,z=0,Y=[];var a=Q();return Se()&&we(_e().startPos,"MORE_INPUT",Te().toString()),a}catch(e){throw e.message}}}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Tokenizer=void 0;var n=r(7),o=r(2),i=["DIV","EQ","GE","GT","LE","LT","MOD","NE","NOT"],a=[];!function(){var e;for(e="0".charCodeAt(0);e<="9".charCodeAt(0);e+=1)a[e]|=3;for(e="A".charCodeAt(0);e<="F".charCodeAt(0);e+=1)a[e]|=2;for(e="a".charCodeAt(0);e<="f".charCodeAt(0);e+=1)a[e]|=2;for(e="A".charCodeAt(0);e<="Z".charCodeAt(0);e+=1)a[e]|=4;for(e="a".charCodeAt(0);e<="z".charCodeAt(0);e+=1)a[e]|=4}(),t.Tokenizer={tokenize:function(e){var t=e,r=e+"\0",s=r.length,l=0,u=[];function c(){for(var e,i=l,a=!1;!a;)if("'"===(e=r[l+=1])&&("'"===r[l+1]?l+=1:a=!0),0===e.charCodeAt(0))throw{name:"SpelParseException",message:"Non-terminating quoted string in expression ("+t+") at position "+l};l+=1,u.push(new n.Token(o.TokenKind.LITERAL_STRING,y(i,l),i,l))}function d(){for(var e,i=l,a=!1;!a;)if('"'===(e=r[l+=1])&&('"'===r[l+1]?l+=1:a=!0),0===e.charCodeAt(0))throw{name:"SpelParseException",message:"Non-terminating double-quoted string in expression ("+t+") at position "+l};l+=1,u.push(new n.Token(o.TokenKind.LITERAL_STRING,y(i,l),i,l))}function p(e){var n,o,i,a=!1,s=l,u=r[l+1];if(!e||"x"!==u&&"X"!==u){do{l+=1}while(_(r[l]));if("."===(u=r[l])){a=!0,n=l;do{l+=1}while(_(r[l]));if(l===n+1)return void v(y(s,l=n),!1,s,l)}if(o=l,O("L","l")){if(a)throw{name:"SpelParseException",message:"Real cannot be long in expression ("+t+") at position "+l};v(y(s,o),!0,s,o),l+=1}else if(function(e){return"e"===e||"E"===e}(r[l])){a=!0,function(e){return"+"===e||"-"===e}(r[l+=1])&&(l+=1);do{l+=1}while(_(r[l]));i=!1,S(r[l])?(i=!0,o=l+=1):T(r[l])&&(o=l+=1),g(y(s,l),i,s,l)}else i=!1,S(u=r[l])?(a=!0,i=!0,o=l+=1):T(u)&&(a=!0,o=l+=1),a?g(y(s,o),i,s,o):v(y(s,o),!1,s,o)}else{l+=1;do{l+=1}while(R(r[l]));O("L","l")?(h(y(s+2,l),!0,s,l),l+=1):h(y(s+2,l),!1,s,l)}}function f(){var e,t,a,s=l;do{l+=1}while(w(a=r[l])||_(a)||"_"===a||"$"===a);e=y(s,l),(l-s==2||l-s==3)&&(t=e.toUpperCase(),i.indexOf(t)>=0)?function(e,t,r){u.push(new n.Token(e,r,t,t+e.getLength()))}(o.TokenKind.valueOf(t),s,e):u.push(new n.Token(o.TokenKind.IDENTIFIER,e.replace("\0",""),s,l))}function v(e,t,r,i){t?u.push(new n.Token(o.TokenKind.LITERAL_LONG,e,r,i)):u.push(new n.Token(o.TokenKind.LITERAL_INT,e,r,i))}function h(e,r,i,a){if(0===e.length)throw r?{name:"SpelParseException",message:"Not a long in expression ("+t+") at position "+l}:{name:"SpelParseException",message:"Not an int in expression ("+t+") at position "+l};r?u.push(new n.Token(o.TokenKind.LITERAL_HEXLONG,e,i,a)):u.push(new n.Token(o.TokenKind.LITERAL_HEXINT,e,i,a))}function g(e,t,r,i){t?u.push(new n.Token(o.TokenKind.LITERAL_REAL_FLOAT,e,r,i)):u.push(new n.Token(o.TokenKind.LITERAL_REAL,e,r,i))}function y(e,t){return r.substring(e,t)}function m(e){return 2===e.tokenChars.length&&r[l]===e.tokenChars[0]&&r[l+1]===e.tokenChars[1]}function b(e){u.push(new n.Token(e,null,l,l+1)),l+=1}function E(e){u.push(new n.Token(e,null,l,l+2)),l+=2}function O(e,t){var n=r[l];return n===e||n===t}function S(e){return"f"===e||"F"===e}function T(e){return"d"===e||"D"===e}function _(e){return!(e.charCodeAt(0)>255||!(1&a[e.charCodeAt(0)]))}function w(e){return!(e.charCodeAt(0)>255||!(4&a[e.charCodeAt(0)]))}function R(e){return!(e.charCodeAt(0)>255||!(2&a[e.charCodeAt(0)]))}return function(){for(var e;l<s;)if(w(e=r[l]))f();else switch(e){case"+":m(o.TokenKind.INC)?E(o.TokenKind.INC):b(o.TokenKind.PLUS);break;case"_":f();break;case"-":m(o.TokenKind.DEC)?E(o.TokenKind.DEC):b(o.TokenKind.MINUS);break;case":":b(o.TokenKind.COLON);break;case".":b(o.TokenKind.DOT);break;case",":b(o.TokenKind.COMMA);break;case"*":b(o.TokenKind.STAR);break;case"/":b(o.TokenKind.DIV);break;case"%":b(o.TokenKind.MOD);break;case"(":b(o.TokenKind.LPAREN);break;case")":b(o.TokenKind.RPAREN);break;case"[":b(o.TokenKind.LSQUARE);break;case"#":b(o.TokenKind.HASH);break;case"]":b(o.TokenKind.RSQUARE);break;case"{":b(o.TokenKind.LCURLY);break;case"}":b(o.TokenKind.RCURLY);break;case"@":b(o.TokenKind.BEAN_REF);break;case"^":m(o.TokenKind.SELECT_FIRST)?E(o.TokenKind.SELECT_FIRST):b(o.TokenKind.POWER);break;case"!":m(o.TokenKind.NE)?E(o.TokenKind.NE):m(o.TokenKind.PROJECT)?E(o.TokenKind.PROJECT):b(o.TokenKind.NOT);break;case"=":m(o.TokenKind.EQ)?E(o.TokenKind.EQ):b(o.TokenKind.ASSIGN);break;case"&":if(!m(o.TokenKind.SYMBOLIC_AND))throw{name:"SpelParseException",message:"Missing character '&' in expression ("+t+") at position "+l};E(o.TokenKind.SYMBOLIC_AND);break;case"|":if(!m(o.TokenKind.SYMBOLIC_OR))throw{name:"SpelParseException",message:"Missing character '|' in expression ("+t+") at position "+l};E(o.TokenKind.SYMBOLIC_OR);break;case"?":m(o.TokenKind.SELECT)?E(o.TokenKind.SELECT):m(o.TokenKind.ELVIS)?E(o.TokenKind.ELVIS):m(o.TokenKind.SAFE_NAVI)?E(o.TokenKind.SAFE_NAVI):b(o.TokenKind.QMARK);break;case"$":m(o.TokenKind.SELECT_LAST)?E(o.TokenKind.SELECT_LAST):f();break;case">":m(o.TokenKind.GE)?E(o.TokenKind.GE):b(o.TokenKind.GT);break;case"<":m(o.TokenKind.LE)?E(o.TokenKind.LE):b(o.TokenKind.LT);break;case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":p("0"===e);break;case" ":case"\t":case"\r":case"\n":case"\0":l+=1;break;case"'":c();break;case'"':d();break;case"\\":throw{name:"SpelParseException",message:"Unexpected escape character in expression ("+t+") at position "+l};default:throw{name:"SpelParseException",message:"Cannot handle character '"+e+"' in expression ("+t+") at position "+l}}}(),u}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Token=void 0;var n=r(2);function o(e,t,r,n){this.kind=e,this.startPos=r,this.endPos=n,t&&(this.data=t)}o.prototype.getKind=function(){return this.kind},o.prototype.toString=function(){var e="[";return e+=this.kind.toString(),this.kind.hasPayload()&&(e+=":"+this.data),(e+="]")+"("+this.startPos+","+this.endPos+")"},o.prototype.isIdentifier=function(){return this.kind===n.TokenKind.IDENTIFIER},o.prototype.isNumericRelationalOperator=function(){return this.kind===n.TokenKind.GT||this.kind===n.TokenKind.GE||this.kind===n.TokenKind.LT||this.kind===n.TokenKind.LE||this.kind===n.TokenKind.EQ||this.kind===n.TokenKind.NE},o.prototype.stringValue=function(){return this.data},o.prototype.asInstanceOfToken=function(){return new o(n.TokenKind.INSTANCEOF,this.startPos,this.endPos)},o.prototype.asMatchesToken=function(){return new o(n.TokenKind.MATCHES,this.startPos,this.endPos)},o.prototype.asBetweenToken=function(){return new o(n.TokenKind.BETWEEN,this.startPos,this.endPos)},o.prototype.getStartPosition=function(){return this.startPos},o.prototype.getEndPosition=function(){return this.endPos},t.Token=o},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BooleanLiteral=void 0;var n=r(0);t.BooleanLiteral={create:function(e,t){var r=n.SpelNode.create("boolean",t);return r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NumberLiteral=void 0;var n=r(0);t.NumberLiteral={create:function(e,t){var r=n.SpelNode.create("number",t);return r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringLiteral=void 0;var n=r(0);t.StringLiteral={create:function(e,t){var r=n.SpelNode.create("string",t);return e=function(e){return("'"===e[0]&&"'"===e[e.length-1]||'"'===e[0]&&'"'===e[e.length-1])&&(e=e.substring(1,e.length-1)),e.replace(/''/g,"'").replace(/""/g,'"')}(e),r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullLiteral=void 0;var n=r(0);t.NullLiteral={create:function(e,t){var r=n.SpelNode.create("null",t);return r.getValue=function(){return null},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FunctionReference=void 0;var n=r(0),o=r(1);t.FunctionReference={create:function(e,t,r){var i=n.SpelNode.create("function",t);return i.getRaw=function(){return{functionName:e,args:r}},i.getValue=function(t){var n=t.locals||{},i=t.rootContext,a=[];if(r.forEach((function(e){var r=t.activeContext;t.activeContext=new o.Stack,t.activeContext.push(t.rootContext),a.push(e.getValue(t)),t.activeContext=r})),n[e])return n[e].apply(i,a);throw{name:"FunctionDoesNotExistException",message:"Function '"+e+"' does not exist."}},i}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MethodReference=void 0;var n=r(0),o=r(1);t.MethodReference={create:function(e,t,r,i){var a=n.SpelNode.create("method",r);return a.getRaw=function(){return{methodName:t,args:i}},a.getValue=function(r){var n,a=r.activeContext.peek(),s=[];if(!a)throw{name:"ContextDoesNotExistException",message:"Attempting to look up property '"+t+"' for an undefined context."};function l(r){if(null==r){if(e)return null;throw{name:"NullPointerException",message:"Method "+t+" does not exist."}}return r}if(i.forEach((function(e){var t=r.activeContext;r.activeContext=new o.Stack,r.activeContext.push(r.rootContext),s.push(e.getValue(r)),r.activeContext=t})),"get"===t.substr(0,3)&&!a[t])return l(a[t.charAt(3).toLowerCase()+t.substring(4)]);if("set"===t.substr(0,3)&&!a[t])return a[t.charAt(3).toLowerCase()+t.substring(4)]=s[0];if(Array.isArray(a)){if("size"===t)return a.length;if("contains"===t)return a.includes(s[0])}return(n=l(a[t]))?n.apply(a,s):null},a}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PropertyReference=void 0;var n=r(0);t.PropertyReference={create:function(e,t,r){var o=n.SpelNode.create("property",r);return o.getRaw=function(){return t},o.getValue=function(r){var n=r.activeContext.peek();if(!n){if(e)return null;throw{name:"ContextDoesNotExistException",message:"Attempting to look up property '"+t+"' for an undefined context."}}if(void 0===n[t]||null===n[t]){if(e)return null;if("size"===t&&Array.isArray(n))return n.length;throw{name:"NullPointerException",message:"Property '"+t+"' does not exist."}}return n[t]},o.setValue=function(e,r){var n=r.activeContext.peek();if(!n)throw{name:"ContextDoesNotExistException",message:"Attempting to assign property '"+t+"' for an undefined context."};return n[t]=e},o.getName=function(){return t},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VariableReference=void 0;var n=r(0);t.VariableReference={create:function(e,t){var r=n.SpelNode.create("variable",t);return r.getRaw=function(){return e},r.getValue=function(t){var r=t.activeContext.peek(),n=t.locals;if(!r)throw{name:"ContextDoesNotExistException",message:"Attempting to look up variable '"+e+"' for an undefined context."};return"this"===e?r:"root"===e?t.rootContext:n[e]},r.setValue=function(t,r){return r.locals[e]=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CompoundExpression=void 0;var n=r(0);t.CompoundExpression={create:function(e,t){var r=n.SpelNode.create.apply(null,["compound",e].concat(t));function o(e){var t,n=r.getChildren().length;for(t=0;t<n;t+=1)"indexer"===r.getChildren()[t].getType()?e.activeContext.push(e.activeContext.peek()[r.getChildren()[t].getValue(e)]):e.activeContext.push(r.getChildren()[t].getValue(e));return function(){for(t=0;t<n;t+=1)e.activeContext.pop()}}return r.getValue=function(e){var t;if(!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to evaluate compound expression with an undefined context."};var r=o(e);return t=e.activeContext.peek(),r(),t},r.setValue=function(e,t){var n=o(t),i=r.getChildren().length;return t.activeContext.pop(),e=r.getChildren()[i-1].setValue(e,t),t.activeContext.push(null),n(),e},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Indexer=void 0;var n=r(0),o=r(1);t.Indexer={create:function(e,t){var r=n.SpelNode.create.apply(null,["indexer",e].concat(t));return r.getValue=function(e){var t,n,i=e.activeContext,a=r.getChildren().length;if(e.activeContext=new o.Stack,e.activeContext.push(e.rootContext),!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to evaluate compound expression with an undefined context."};for(t=0;t<a;t+=1)e.activeContext.push(r.getChildren()[t].getValue(e));for(n=e.activeContext.peek(),t=0;t<a;t+=1)e.activeContext.pop();return e.activeContext=i,n},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Assign=void 0;var n=r(0);t.Assign={create:function(e,t,r){var o=n.SpelNode.create("assign",e,t,r);return o.getValue=function(e){if(!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to assign property '"+t.getValue(e)+"' for an undefined context."};return t.setValue(r.getValue(e),e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpEQ=void 0;var n=r(0);t.OpEQ={create:function(e,t,r){var o=n.SpelNode.create("op-eq",e,t,r);return o.getValue=function(e){return t.getValue(e)===r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpNE=void 0;var n=r(0);t.OpNE={create:function(e,t,r){var o=n.SpelNode.create("op-ne",e,t,r);return o.getValue=function(e){return t.getValue(e)!==r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpGE=void 0;var n=r(0);t.OpGE={create:function(e,t,r){var o=n.SpelNode.create("op-ge",e,t,r);return o.getValue=function(e){return t.getValue(e)>=r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpGT=void 0;var n=r(0);t.OpGT={create:function(e,t,r){var o=n.SpelNode.create("op-gt",e,t,r);return o.getValue=function(e){return t.getValue(e)>r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpLE=void 0;var n=r(0);t.OpLE={create:function(e,t,r){var o=n.SpelNode.create("op-le",e,t,r);return o.getValue=function(e){return t.getValue(e)<=r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpLT=void 0;var n=r(0);t.OpLT={create:function(e,t,r){var o=n.SpelNode.create("op-lt",e,t,r);return o.getValue=function(e){return t.getValue(e)<r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpPlus=void 0;var n=r(0);t.OpPlus={create:function(e,t,r){var o=n.SpelNode.create("op-plus",e,t,r);return o.getValue=function(e){return r?t.getValue(e)+r.getValue(e):+t.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMinus=void 0;var n=r(0);t.OpMinus={create:function(e,t,r){var o=n.SpelNode.create("op-minus",e,t,r);return o.getValue=function(e){return r?t.getValue(e)-r.getValue(e):-t.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMultiply=void 0;var n=r(0);t.OpMultiply={create:function(e,t,r){var o=n.SpelNode.create("op-multiply",e,t,r);return o.getValue=function(e){var n=t.getValue(e),o=r.getValue(e);if("number"==typeof n&&"number"==typeof o)return n*o;if("string"==typeof n&&"number"==typeof o){for(var i="",a=0;a<o;a+=1)i+=n;return i}return null},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpDivide=void 0;var n=r(0);t.OpDivide={create:function(e,t,r){var o=n.SpelNode.create("op-divide",e,t,r);return o.getValue=function(e){return t.getValue(e)/r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpModulus=void 0;var n=r(0);t.OpModulus={create:function(e,t,r){var o=n.SpelNode.create("op-modulus",e,t,r);return o.getValue=function(e){return t.getValue(e)%r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpPower=void 0;var n=r(0);t.OpPower={create:function(e,t,r){var o=n.SpelNode.create("op-power",e,t,r);return o.getValue=function(e){return Math.pow(t.getValue(e),r.getValue(e))},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpInc=void 0;var n=r(0);t.OpInc={create:function(e,t,r){var o=n.SpelNode.create("op-inc",e,r);return o.getValue=function(e){var n=r.getValue(e);return r.setValue(n+1,e),t?n:n+1},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpDec=void 0;var n=r(0);t.OpDec={create:function(e,t,r){var o=n.SpelNode.create("op-dec",e,r);return o.getValue=function(e){var n=r.getValue(e);return r.setValue(n-1,e),t?n:n-1},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpNot=void 0;var n=r(0);t.OpNot={create:function(e,t){var r=n.SpelNode.create("op-not",e,t);return r.getValue=function(e){return!t.getValue(e)},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpAnd=void 0;var n=r(0);t.OpAnd={create:function(e,t,r){var o=n.SpelNode.create("op-and",e,t,r);return o.getValue=function(e){return!!t.getValue(e)&&!!r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpOr=void 0;var n=r(0);t.OpOr={create:function(e,t,r){var o=n.SpelNode.create("op-or",e,t,r);return o.getValue=function(e){return!!t.getValue(e)||!!r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMatches=void 0;var n=r(0);t.OpMatches={create:function(e,t,r){var o=n.SpelNode.create("matches",e,t,r);return o.getValue=function(e){var n=t.getValue(e),o=r.getValue(e);try{return!!new RegExp(o).exec(n)}catch(e){throw{name:"EvaluationException",message:e.toString()}}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Ternary=void 0;var n=r(0);t.Ternary={create:function(e,t,r,o){var i=n.SpelNode.create("ternary",e,t,r,o);return i.getValue=function(e){return t.getValue(e)?r.getValue(e):o.getValue(e)},i}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Elvis=void 0;var n=r(0);t.Elvis={create:function(e,t,r){var o=n.SpelNode.create("elvis",e,t,r);return o.getValue=function(e){return null!==t.getValue(e)?t.getValue(e):r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineList=void 0;var n=r(0);t.InlineList={create:function(e,t){var r=n.SpelNode.create("list",e),o=[].concat(t||[]);return r.getRaw=function(){return o},r.getValue=function(e){return o.map((function(t){return t.getValue(e)}))},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineMap=void 0;var n=r(0);t.InlineMap={create:function(e,t){var r=n.SpelNode.create("map",e),o=[].concat(t||[]);return r.getValue=function(e){var t=!0,r=null,n={};return o.forEach((function(o){t?r="property"===o.getType()?o.getName():o.getValue(e):n[r]=o.getValue(e),t=!t})),n},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=void 0;var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o=r(0);function i(e,t,r){var n;return r.activeContext.push(e),n=t.getValue(r),r.activeContext.pop(),n}t.Selection={create:function(e,t,r,a){var s=o.SpelNode.create("selection",r,a);return s.getValue=function(e){var r=e.activeContext.peek();if(r){if(Array.isArray(r))return function(e,t,r,n){var o=e.filter((function(e){return i(e,r,n)}));switch(t){case"ALL":return o;case"FIRST":return o[0]||null;case"LAST":return o.length?o[o.length-1]:null}}(r,t,a,e);if("object"===(void 0===r?"undefined":n(r)))return function(e,t,r,n){var o,a,s={},l=[],u={};for(a in e)e.hasOwnProperty(a)&&i(o={key:a,value:e[a]},r,n)&&l.push(o);switch(t){case"ALL":return l.forEach((function(e){s[e.key]=e.value})),s;case"FIRST":return l.length?(u[l[0].key]=l[0].value,u):null;case"LAST":return l.length?(u[l[l.length-1].key]=l[l.length-1].value,u):null}l.forEach((function(e){s[e.key]=e.value}))}(r,t,a,e)}return null},s},FIRST:"FIRST",LAST:"LAST",ALL:"ALL"}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Projection=void 0;var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o=r(0);function i(e,t,r){return e.map((function(e){var n;return r.activeContext.push(e),n=t.getValue(r),r.activeContext.pop(),n}))}t.Projection={create:function(e,t,r){var a=o.SpelNode.create("projection",t,r);return a.getValue=function(e){var t,o=e.activeContext.peek(),a=[];if(Array.isArray(o))return i(o,r,e);if("object"===(void 0===o?"undefined":n(o))){for(t in o)o.hasOwnProperty(t)&&a.push(o[t]);return i(a,r,e)}return null},a}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpInstanceof=void 0;var n=r(0);t.OpInstanceof={create:function(e,t,r){var o=n.SpelNode.create("instanceof",e,t,r);return o.getValue=function(e){throw{name:"MethodNotImplementedException",message:"OpInstanceOf: Not implemented"}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpBetween=void 0;var n=r(0);t.OpBetween={create:function(e,t,r){var o=n.SpelNode.create("between",e,t,r);return o.getValue=function(e){throw{name:"MethodNotImplementedException",message:"OpBetween: Not implemented"}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TypeReference=void 0;var n=r(0);t.TypeReference={create:function(e,t,r){return(t=n.SpelNode.create("typeref",e,t)).getValue=function(e){throw{name:"MethodNotImplementedException",message:"TypeReference: Not implemented"}},t}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BeanReference=void 0;var n=r(0);t.BeanReference={create:function(e,t){var r=n.SpelNode.create("beanref",e);return r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"BeanReference: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Identifier=void 0;var n=r(0);t.Identifier={create:function(e,t){var r=n.SpelNode.create("identifier",t);return r.getRaw=function(){return e},r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"Identifier: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QualifiedIdentifier=void 0;var n=r(0);t.QualifiedIdentifier={create:function(e,t){var r=n.SpelNode.create.apply(n.SpelNode,["qualifiedidentifier",e].concat(function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)}(t)));return r.getRaw=function(){return t.map((function(e){return e.getRaw()}))},r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"QualifiedIdentifier: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConstructorReference=void 0;var n=r(0),o=r(1);t.ConstructorReference={create:function(e,t,r){var i,a=void 0!==r;a?i=t.length&&t[0]&&"number"===t[0].getType()?t[0].getValue():null:(r=t,t=void 0);var s,l=(s=r,Array.isArray(s)?s:Array.from(s)),u=(l[0],l.slice(1)),c=n.SpelNode.create.apply(n.SpelNode,["constructorref",e].concat(function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)}(r)));return c.getRaw=function(){return i},c.getValue=function(e){if(a&&u.length<=1){var t=[];return u.forEach((function(r){var n=e.activeContext;e.activeContext=new o.Stack,e.activeContext.push(e.rootContext),t.push(r.getValue(e)),e.activeContext=n})),1===u.length?t[0]:i?new Array(i):[]}throw{name:"MethodNotImplementedException",message:"ConstructorReference: Not implemented"}},c}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardContext={create:function(e,t){var r={};return r.authentication=e||{},r.principal=t||{},r.hasRole=function(e){var t=!1;return!!e&&!(!r.authentication&&!Array.isArray(r.authentication.authorities))&&(r.authentication.authorities.forEach((function(r){r.authority.toLowerCase()===e.toLowerCase()&&(t=!0)})),t)},r.hasPermission=function(){var e=Array.prototype.slice.call(arguments);if(1===e.length)return r.hasRole(e[0])},r}}}])},e.exports=t()},9157:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=l(r(1283)),o=l(r(1025)),i=l(r(2520)),a=l(r(9137)),s=l(r(9429));function l(e){return e&&e.__esModule?e:{default:e}}function u(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var c=function(e){return e.replace(/[\t ]+$/,"")},d=function(){function e(t,r,n){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t||{},this.indentation=new i.default(this.cfg.indent),this.inlineBlock=new a.default,this.params=new s.default(this.cfg.params),this.tokenizer=r,this.tokenOverride=n,this.previousReservedWord={},this.tokens=[],this.index=0}var t,r;return t=e,r=[{key:"format",value:function(e){return this.tokens=this.tokenizer.tokenize(e),this.getFormattedQueryFromTokens().trim()}},{key:"getFormattedQueryFromTokens",value:function(){var e=this,t="";return this.tokens.forEach((function(r,n){e.index=n,e.tokenOverride&&(r=e.tokenOverride(r,e.previousReservedWord)||r),r.type===o.default.WHITESPACE||(r.type===o.default.LINE_COMMENT?t=e.formatLineComment(r,t):r.type===o.default.BLOCK_COMMENT?t=e.formatBlockComment(r,t):r.type===o.default.RESERVED_TOP_LEVEL?(t=e.formatTopLevelReservedWord(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED_TOP_LEVEL_NO_INDENT?(t=e.formatTopLevelReservedWordNoIndent(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED_NEWLINE?(t=e.formatNewlineReservedWord(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED?(t=e.formatWithSpaces(r,t),e.previousReservedWord=r):t=r.type===o.default.OPEN_PAREN?e.formatOpeningParentheses(r,t):r.type===o.default.CLOSE_PAREN?e.formatClosingParentheses(r,t):r.type===o.default.PLACEHOLDER?e.formatPlaceholder(r,t):","===r.value?e.formatComma(r,t):":"===r.value?e.formatWithSpaceAfter(r,t):"."===r.value?e.formatWithoutSpaces(r,t):";"===r.value?e.formatQuerySeparator(r,t):e.formatWithSpaces(r,t))})),t}},{key:"formatLineComment",value:function(e,t){return this.addNewline(t+e.value)}},{key:"formatBlockComment",value:function(e,t){return this.addNewline(this.addNewline(t)+this.indentComment(e.value))}},{key:"indentComment",value:function(e){return e.replace(/\n[\t ]*/g,"\n"+this.indentation.getIndent()+" ")}},{key:"formatTopLevelReservedWordNoIndent",value:function(e,t){return this.indentation.decreaseTopLevel(),t=this.addNewline(t)+this.equalizeWhitespace(this.formatReservedWord(e.value)),this.addNewline(t)}},{key:"formatTopLevelReservedWord",value:function(e,t){return this.indentation.decreaseTopLevel(),t=this.addNewline(t),this.indentation.increaseTopLevel(),t+=this.equalizeWhitespace(this.formatReservedWord(e.value)),this.addNewline(t)}},{key:"formatNewlineReservedWord",value:function(e,t){return this.addNewline(t)+this.equalizeWhitespace(this.formatReservedWord(e.value))+" "}},{key:"equalizeWhitespace",value:function(e){return e.replace(/[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]+/g," ")}},{key:"formatOpeningParentheses",value:function(e,t){var r=[o.default.WHITESPACE,o.default.OPEN_PAREN,o.default.LINE_COMMENT];return(0,n.default)(r,this.previousToken().type)||(t=c(t)),t+=this.cfg.uppercase?e.value.toUpperCase():e.value,this.inlineBlock.beginIfPossible(this.tokens,this.index),this.inlineBlock.isActive()||(this.indentation.increaseBlockLevel(),t=this.addNewline(t)),t}},{key:"formatClosingParentheses",value:function(e,t){return e.value=this.cfg.uppercase?e.value.toUpperCase():e.value,this.inlineBlock.isActive()?(this.inlineBlock.end(),this.formatWithSpaceAfter(e,t)):(this.indentation.decreaseBlockLevel(),this.formatWithSpaces(e,this.addNewline(t)))}},{key:"formatPlaceholder",value:function(e,t){return t+this.params.get(e)+" "}},{key:"formatComma",value:function(e,t){return t=c(t)+e.value+" ",this.inlineBlock.isActive()||/^LIMIT$/i.test(this.previousReservedWord.value)?t:this.addNewline(t)}},{key:"formatWithSpaceAfter",value:function(e,t){return c(t)+e.value+" "}},{key:"formatWithoutSpaces",value:function(e,t){return c(t)+e.value}},{key:"formatWithSpaces",value:function(e,t){return t+("reserved"===e.type?this.formatReservedWord(e.value):e.value)+" "}},{key:"formatReservedWord",value:function(e){return this.cfg.uppercase?e.toUpperCase():e}},{key:"formatQuerySeparator",value:function(e,t){return this.indentation.resetIndentation(),c(t)+e.value+"\n".repeat(this.cfg.linesBetweenQueries||1)}},{key:"addNewline",value:function(e){return(e=c(e)).endsWith("\n")||(e+="\n"),e+this.indentation.getIndent()}},{key:"previousToken",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;return this.tokens[this.index-e]||{}}}],r&&u(t.prototype,r),e}();t.default=d,e.exports=t.default},2520:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9901)),o=i(r(8906));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s="top-level",l=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.indent=t||"  ",this.indentTypes=[]}var t,r;return t=e,(r=[{key:"getIndent",value:function(){return(0,n.default)(this.indent,this.indentTypes.length)}},{key:"increaseTopLevel",value:function(){this.indentTypes.push(s)}},{key:"increaseBlockLevel",value:function(){this.indentTypes.push("block-level")}},{key:"decreaseTopLevel",value:function(){(0,o.default)(this.indentTypes)===s&&this.indentTypes.pop()}},{key:"decreaseBlockLevel",value:function(){for(;this.indentTypes.length>0&&this.indentTypes.pop()===s;);}},{key:"resetIndentation",value:function(){this.indentTypes=[]}}])&&a(t.prototype,r),e}();t.default=l,e.exports=t.default},9137:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n,o=(n=r(1025))&&n.__esModule?n:{default:n};function i(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var a=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.level=0}var t,r;return t=e,(r=[{key:"beginIfPossible",value:function(e,t){0===this.level&&this.isInlineBlock(e,t)?this.level=1:this.level>0?this.level++:this.level=0}},{key:"end",value:function(){this.level--}},{key:"isActive",value:function(){return this.level>0}},{key:"isInlineBlock",value:function(e,t){for(var r=0,n=0,i=t;i<e.length;i++){var a=e[i];if((r+=a.value.length)>50)return!1;if(a.type===o.default.OPEN_PAREN)n++;else if(a.type===o.default.CLOSE_PAREN&&0==--n)return!0;if(this.isForbiddenToken(a))return!1}return!1}},{key:"isForbiddenToken",value:function(e){var t=e.type,r=e.value;return t===o.default.RESERVED_TOP_LEVEL||t===o.default.RESERVED_NEWLINE||t===o.default.COMMENT||t===o.default.BLOCK_COMMENT||";"===r}}])&&i(t.prototype,r),e}();t.default=a,e.exports=t.default},9429:(e,t)=>{"use strict";function r(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.params=t,this.index=0}var t,n;return t=e,(n=[{key:"get",value:function(e){var t=e.key,r=e.value;return this.params?t?this.params[t]:this.params[this.index++]:r}}])&&r(t.prototype,n),e}();t.default=n,e.exports=t.default},3202:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=a(r(7969)),o=a(r(8472)),i=a(r(1025));function a(e){return e&&e.__esModule?e:{default:e}}function s(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.WHITESPACE_REGEX=/^([\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]+)/,this.NUMBER_REGEX=/^((\x2D[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]*)?[0-9]+(\.[0-9]+)?|0x[0-9A-Fa-f]+|0b[01]+)\b/,this.OPERATOR_REGEX=/^(!=|<>|==|<=|>=|!<|!>|\|\||::|\x2D>>|\x2D>|~~\*|~~|!~~\*|!~~|~\*|!~\*|!~|:=|(?:[\0-\t\x0B\f\x0E-\u2027\u202A-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]))/,this.BLOCK_COMMENT_REGEX=/^(\/\*(?:[\0-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])*?(?:\*\/|$))/,this.LINE_COMMENT_REGEX=this.createLineCommentRegex(t.lineCommentTypes),this.RESERVED_TOP_LEVEL_REGEX=this.createReservedWordRegex(t.reservedTopLevelWords),this.RESERVED_TOP_LEVEL_NO_INDENT_REGEX=this.createReservedWordRegex(t.reservedTopLevelWordsNoIndent),this.RESERVED_NEWLINE_REGEX=this.createReservedWordRegex(t.reservedNewlineWords),this.RESERVED_PLAIN_REGEX=this.createReservedWordRegex(t.reservedWords),this.WORD_REGEX=this.createWordRegex(t.specialWordChars),this.STRING_REGEX=this.createStringRegex(t.stringTypes),this.OPEN_PAREN_REGEX=this.createParenRegex(t.openParens),this.CLOSE_PAREN_REGEX=this.createParenRegex(t.closeParens),this.INDEXED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.indexedPlaceholderTypes,"[0-9]*"),this.IDENT_NAMED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.namedPlaceholderTypes,"[a-zA-Z0-9._$]+"),this.STRING_NAMED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.namedPlaceholderTypes,this.createStringPattern(t.stringTypes))}var t,r;return t=e,r=[{key:"createLineCommentRegex",value:function(e){return new RegExp("^((?:".concat(e.map((function(e){return(0,o.default)(e)})).join("|"),").*?(?:\r\n|\r|\n|$))"),"u")}},{key:"createReservedWordRegex",value:function(e){var t=e.join("|").replace(/ /g,"\\s+");return new RegExp("^(".concat(t,")\\b"),"iu")}},{key:"createWordRegex",value:function(){return new RegExp("^([\\p{Alphabetic}\\p{Mark}\\p{Decimal_Number}\\p{Connector_Punctuation}\\p{Join_Control}".concat((arguments.length>0&&void 0!==arguments[0]?arguments[0]:[]).join(""),"]+)"),"u")}},{key:"createStringRegex",value:function(e){return new RegExp("^("+this.createStringPattern(e)+")","u")}},{key:"createStringPattern",value:function(e){var t={"``":"((`[^`]*($|`))+)","[]":"((\\[[^\\]]*($|\\]))(\\][^\\]]*($|\\]))*)",'""':'(("[^"\\\\]*(?:\\\\.[^"\\\\]*)*("|$))+)',"''":"(('[^'\\\\]*(?:\\\\.[^'\\\\]*)*('|$))+)","N''":"((N'[^N'\\\\]*(?:\\\\.[^N'\\\\]*)*('|$))+)"};return e.map((function(e){return t[e]})).join("|")}},{key:"createParenRegex",value:function(e){var t=this;return new RegExp("^("+e.map((function(e){return t.escapeParen(e)})).join("|")+")","iu")}},{key:"escapeParen",value:function(e){return 1===e.length?(0,o.default)(e):"\\b"+e+"\\b"}},{key:"createPlaceholderRegex",value:function(e,t){if((0,n.default)(e))return!1;var r=e.map(o.default).join("|");return new RegExp("^((?:".concat(r,")(?:").concat(t,"))"),"u")}},{key:"tokenize",value:function(e){if(!e)return[];for(var t,r=[];e.length;)t=this.getNextToken(e,t),e=e.substring(t.value.length),r.push(t);return r}},{key:"getNextToken",value:function(e,t){return this.getWhitespaceToken(e)||this.getCommentToken(e)||this.getStringToken(e)||this.getOpenParenToken(e)||this.getCloseParenToken(e)||this.getPlaceholderToken(e)||this.getNumberToken(e)||this.getReservedWordToken(e,t)||this.getWordToken(e)||this.getOperatorToken(e)}},{key:"getWhitespaceToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.WHITESPACE,regex:this.WHITESPACE_REGEX})}},{key:"getCommentToken",value:function(e){return this.getLineCommentToken(e)||this.getBlockCommentToken(e)}},{key:"getLineCommentToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.LINE_COMMENT,regex:this.LINE_COMMENT_REGEX})}},{key:"getBlockCommentToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.BLOCK_COMMENT,regex:this.BLOCK_COMMENT_REGEX})}},{key:"getStringToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.STRING,regex:this.STRING_REGEX})}},{key:"getOpenParenToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.OPEN_PAREN,regex:this.OPEN_PAREN_REGEX})}},{key:"getCloseParenToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.CLOSE_PAREN,regex:this.CLOSE_PAREN_REGEX})}},{key:"getPlaceholderToken",value:function(e){return this.getIdentNamedPlaceholderToken(e)||this.getStringNamedPlaceholderToken(e)||this.getIndexedPlaceholderToken(e)}},{key:"getIdentNamedPlaceholderToken",value:function(e){return this.getPlaceholderTokenWithKey({input:e,regex:this.IDENT_NAMED_PLACEHOLDER_REGEX,parseKey:function(e){return e.slice(1)}})}},{key:"getStringNamedPlaceholderToken",value:function(e){var t=this;return this.getPlaceholderTokenWithKey({input:e,regex:this.STRING_NAMED_PLACEHOLDER_REGEX,parseKey:function(e){return t.getEscapedPlaceholderKey({key:e.slice(2,-1),quoteChar:e.slice(-1)})}})}},{key:"getIndexedPlaceholderToken",value:function(e){return this.getPlaceholderTokenWithKey({input:e,regex:this.INDEXED_PLACEHOLDER_REGEX,parseKey:function(e){return e.slice(1)}})}},{key:"getPlaceholderTokenWithKey",value:function(e){var t=e.input,r=e.regex,n=e.parseKey,o=this.getTokenOnFirstMatch({input:t,regex:r,type:i.default.PLACEHOLDER});return o&&(o.key=n(o.value)),o}},{key:"getEscapedPlaceholderKey",value:function(e){var t=e.key,r=e.quoteChar;return t.replace(new RegExp((0,o.default)("\\"+r),"gu"),r)}},{key:"getNumberToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.NUMBER,regex:this.NUMBER_REGEX})}},{key:"getOperatorToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.OPERATOR,regex:this.OPERATOR_REGEX})}},{key:"getReservedWordToken",value:function(e,t){if(!t||!t.value||"."!==t.value)return this.getTopLevelReservedToken(e)||this.getNewlineReservedToken(e)||this.getTopLevelReservedTokenNoIndent(e)||this.getPlainReservedToken(e)}},{key:"getTopLevelReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_TOP_LEVEL,regex:this.RESERVED_TOP_LEVEL_REGEX})}},{key:"getNewlineReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_NEWLINE,regex:this.RESERVED_NEWLINE_REGEX})}},{key:"getTopLevelReservedTokenNoIndent",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_TOP_LEVEL_NO_INDENT,regex:this.RESERVED_TOP_LEVEL_NO_INDENT_REGEX})}},{key:"getPlainReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED,regex:this.RESERVED_PLAIN_REGEX})}},{key:"getWordToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.WORD,regex:this.WORD_REGEX})}},{key:"getTokenOnFirstMatch",value:function(e){var t=e.input,r=e.type,n=e.regex,o=t.match(n);if(o)return{type:r,value:o[1]}}}],r&&s(t.prototype,r),e}();t.default=l,e.exports=t.default},1025:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0,t.default={WHITESPACE:"whitespace",WORD:"word",STRING:"string",RESERVED:"reserved",RESERVED_TOP_LEVEL:"reserved-top-level",RESERVED_TOP_LEVEL_NO_INDENT:"reserved-top-level-no-indent",RESERVED_NEWLINE:"reserved-newline",OPERATOR:"operator",OPEN_PAREN:"open-paren",CLOSE_PAREN:"close-paren",LINE_COMMENT:"line-comment",BLOCK_COMMENT:"block-comment",NUMBER:"number",PLACEHOLDER:"placeholder"},e.exports=t.default},4377:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s,l=["ABS","ACTIVATE","ALIAS","ALL","ALLOCATE","ALLOW","ALTER","ANY","ARE","ARRAY","AS","ASC","ASENSITIVE","ASSOCIATE","ASUTIME","ASYMMETRIC","AT","ATOMIC","ATTRIBUTES","AUDIT","AUTHORIZATION","AUX","AUXILIARY","AVG","BEFORE","BEGIN","BETWEEN","BIGINT","BINARY","BLOB","BOOLEAN","BOTH","BUFFERPOOL","BY","CACHE","CALL","CALLED","CAPTURE","CARDINALITY","CASCADED","CASE","CAST","CCSID","CEIL","CEILING","CHAR","CHARACTER","CHARACTER_LENGTH","CHAR_LENGTH","CHECK","CLOB","CLONE","CLOSE","CLUSTER","COALESCE","COLLATE","COLLECT","COLLECTION","COLLID","COLUMN","COMMENT","COMMIT","CONCAT","CONDITION","CONNECT","CONNECTION","CONSTRAINT","CONTAINS","CONTINUE","CONVERT","CORR","CORRESPONDING","COUNT","COUNT_BIG","COVAR_POP","COVAR_SAMP","CREATE","CROSS","CUBE","CUME_DIST","CURRENT","CURRENT_DATE","CURRENT_DEFAULT_TRANSFORM_GROUP","CURRENT_LC_CTYPE","CURRENT_PATH","CURRENT_ROLE","CURRENT_SCHEMA","CURRENT_SERVER","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_TIMEZONE","CURRENT_TRANSFORM_GROUP_FOR_TYPE","CURRENT_USER","CURSOR","CYCLE","DATA","DATABASE","DATAPARTITIONNAME","DATAPARTITIONNUM","DATE","DAY","DAYS","DB2GENERAL","DB2GENRL","DB2SQL","DBINFO","DBPARTITIONNAME","DBPARTITIONNUM","DEALLOCATE","DEC","DECIMAL","DECLARE","DEFAULT","DEFAULTS","DEFINITION","DELETE","DENSERANK","DENSE_RANK","DEREF","DESCRIBE","DESCRIPTOR","DETERMINISTIC","DIAGNOSTICS","DISABLE","DISALLOW","DISCONNECT","DISTINCT","DO","DOCUMENT","DOUBLE","DROP","DSSIZE","DYNAMIC","EACH","EDITPROC","ELEMENT","ELSE","ELSEIF","ENABLE","ENCODING","ENCRYPTION","END","END-EXEC","ENDING","ERASE","ESCAPE","EVERY","EXCEPTION","EXCLUDING","EXCLUSIVE","EXEC","EXECUTE","EXISTS","EXIT","EXP","EXPLAIN","EXTENDED","EXTERNAL","EXTRACT","FALSE","FENCED","FETCH","FIELDPROC","FILE","FILTER","FINAL","FIRST","FLOAT","FLOOR","FOR","FOREIGN","FREE","FULL","FUNCTION","FUSION","GENERAL","GENERATED","GET","GLOBAL","GOTO","GRANT","GRAPHIC","GROUP","GROUPING","HANDLER","HASH","HASHED_VALUE","HINT","HOLD","HOUR","HOURS","IDENTITY","IF","IMMEDIATE","IN","INCLUDING","INCLUSIVE","INCREMENT","INDEX","INDICATOR","INDICATORS","INF","INFINITY","INHERIT","INNER","INOUT","INSENSITIVE","INSERT","INT","INTEGER","INTEGRITY","INTERSECTION","INTERVAL","INTO","IS","ISOBID","ISOLATION","ITERATE","JAR","JAVA","KEEP","KEY","LABEL","LANGUAGE","LARGE","LATERAL","LC_CTYPE","LEADING","LEAVE","LEFT","LIKE","LINKTYPE","LN","LOCAL","LOCALDATE","LOCALE","LOCALTIME","LOCALTIMESTAMP","LOCATOR","LOCATORS","LOCK","LOCKMAX","LOCKSIZE","LONG","LOOP","LOWER","MAINTAINED","MATCH","MATERIALIZED","MAX","MAXVALUE","MEMBER","MERGE","METHOD","MICROSECOND","MICROSECONDS","MIN","MINUTE","MINUTES","MINVALUE","MOD","MODE","MODIFIES","MODULE","MONTH","MONTHS","MULTISET","NAN","NATIONAL","NATURAL","NCHAR","NCLOB","NEW","NEW_TABLE","NEXTVAL","NO","NOCACHE","NOCYCLE","NODENAME","NODENUMBER","NOMAXVALUE","NOMINVALUE","NONE","NOORDER","NORMALIZE","NORMALIZED","NOT","NULL","NULLIF","NULLS","NUMERIC","NUMPARTS","OBID","OCTET_LENGTH","OF","OFFSET","OLD","OLD_TABLE","ON","ONLY","OPEN","OPTIMIZATION","OPTIMIZE","OPTION","ORDER","OUT","OUTER","OVER","OVERLAPS","OVERLAY","OVERRIDING","PACKAGE","PADDED","PAGESIZE","PARAMETER","PART","PARTITION","PARTITIONED","PARTITIONING","PARTITIONS","PASSWORD","PATH","PERCENTILE_CONT","PERCENTILE_DISC","PERCENT_RANK","PIECESIZE","PLAN","POSITION","POWER","PRECISION","PREPARE","PREVVAL","PRIMARY","PRIQTY","PRIVILEGES","PROCEDURE","PROGRAM","PSID","PUBLIC","QUERY","QUERYNO","RANGE","RANK","READ","READS","REAL","RECOVERY","RECURSIVE","REF","REFERENCES","REFERENCING","REFRESH","REGR_AVGX","REGR_AVGY","REGR_COUNT","REGR_INTERCEPT","REGR_R2","REGR_SLOPE","REGR_SXX","REGR_SXY","REGR_SYY","RELEASE","RENAME","REPEAT","RESET","RESIGNAL","RESTART","RESTRICT","RESULT","RESULT_SET_LOCATOR","RETURN","RETURNS","REVOKE","RIGHT","ROLE","ROLLBACK","ROLLUP","ROUND_CEILING","ROUND_DOWN","ROUND_FLOOR","ROUND_HALF_DOWN","ROUND_HALF_EVEN","ROUND_HALF_UP","ROUND_UP","ROUTINE","ROW","ROWNUMBER","ROWS","ROWSET","ROW_NUMBER","RRN","RUN","SAVEPOINT","SCHEMA","SCOPE","SCRATCHPAD","SCROLL","SEARCH","SECOND","SECONDS","SECQTY","SECURITY","SENSITIVE","SEQUENCE","SESSION","SESSION_USER","SIGNAL","SIMILAR","SIMPLE","SMALLINT","SNAN","SOME","SOURCE","SPECIFIC","SPECIFICTYPE","SQL","SQLEXCEPTION","SQLID","SQLSTATE","SQLWARNING","SQRT","STACKED","STANDARD","START","STARTING","STATEMENT","STATIC","STATMENT","STAY","STDDEV_POP","STDDEV_SAMP","STOGROUP","STORES","STYLE","SUBMULTISET","SUBSTRING","SUM","SUMMARY","SYMMETRIC","SYNONYM","SYSFUN","SYSIBM","SYSPROC","SYSTEM","SYSTEM_USER","TABLE","TABLESAMPLE","TABLESPACE","THEN","TIME","TIMESTAMP","TIMEZONE_HOUR","TIMEZONE_MINUTE","TO","TRAILING","TRANSACTION","TRANSLATE","TRANSLATION","TREAT","TRIGGER","TRIM","TRUE","TRUNCATE","TYPE","UESCAPE","UNDO","UNIQUE","UNKNOWN","UNNEST","UNTIL","UPPER","USAGE","USER","USING","VALIDPROC","VALUE","VARCHAR","VARIABLE","VARIANT","VARYING","VAR_POP","VAR_SAMP","VCAT","VERSION","VIEW","VOLATILE","VOLUMES","WHEN","WHENEVER","WHILE","WIDTH_BUCKET","WINDOW","WITH","WITHIN","WITHOUT","WLM","WRITE","XMLELEMENT","XMLEXISTS","XMLNAMESPACES","YEAR","YEARS"],u=["ADD","AFTER","ALTER COLUMN","ALTER TABLE","DELETE FROM","EXCEPT","FETCH FIRST","FROM","GROUP BY","GO","HAVING","INSERT INTO","INTERSECT","LIMIT","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UPDATE","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","CROSS JOIN","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return s||(s=new o.default({reservedWords:l,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"''","``","[]"],openParens:["("],closeParens:[")"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:[":"],lineCommentTypes:["--"],specialWordChars:["#","@"]})),new n.default(this.cfg,s).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},9445:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s,l=["ALL","ALTER","ANALYZE","AND","ANY","ARRAY","AS","ASC","BEGIN","BETWEEN","BINARY","BOOLEAN","BREAK","BUCKET","BUILD","BY","CALL","CASE","CAST","CLUSTER","COLLATE","COLLECTION","COMMIT","CONNECT","CONTINUE","CORRELATE","COVER","CREATE","DATABASE","DATASET","DATASTORE","DECLARE","DECREMENT","DELETE","DERIVED","DESC","DESCRIBE","DISTINCT","DO","DROP","EACH","ELEMENT","ELSE","END","EVERY","EXCEPT","EXCLUDE","EXECUTE","EXISTS","EXPLAIN","FALSE","FETCH","FIRST","FLATTEN","FOR","FORCE","FROM","FUNCTION","GRANT","GROUP","GSI","HAVING","IF","IGNORE","ILIKE","IN","INCLUDE","INCREMENT","INDEX","INFER","INLINE","INNER","INSERT","INTERSECT","INTO","IS","JOIN","KEY","KEYS","KEYSPACE","KNOWN","LAST","LEFT","LET","LETTING","LIKE","LIMIT","LSM","MAP","MAPPING","MATCHED","MATERIALIZED","MERGE","MISSING","NAMESPACE","NEST","NOT","NULL","NUMBER","OBJECT","OFFSET","ON","OPTION","OR","ORDER","OUTER","OVER","PARSE","PARTITION","PASSWORD","PATH","POOL","PREPARE","PRIMARY","PRIVATE","PRIVILEGE","PROCEDURE","PUBLIC","RAW","REALM","REDUCE","RENAME","RETURN","RETURNING","REVOKE","RIGHT","ROLE","ROLLBACK","SATISFIES","SCHEMA","SELECT","SELF","SEMI","SET","SHOW","SOME","START","STATISTICS","STRING","SYSTEM","THEN","TO","TRANSACTION","TRIGGER","TRUE","TRUNCATE","UNDER","UNION","UNIQUE","UNKNOWN","UNNEST","UNSET","UPDATE","UPSERT","USE","USER","USING","VALIDATE","VALUE","VALUED","VALUES","VIA","VIEW","WHEN","WHERE","WHILE","WITH","WITHIN","WORK","XOR"],u=["DELETE FROM","EXCEPT ALL","EXCEPT","EXPLAIN DELETE FROM","EXPLAIN UPDATE","EXPLAIN UPSERT","FROM","GROUP BY","HAVING","INFER","INSERT INTO","LET","LIMIT","MERGE","NEST","ORDER BY","PREPARE","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UNNEST","UPDATE","UPSERT","USE KEYS","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","XOR"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return s||(s=new o.default({reservedWords:l,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"''","``"],openParens:["(","[","{"],closeParens:[")","]","}"],namedPlaceholderTypes:["$"],lineCommentTypes:["#","--"]})),new n.default(this.cfg,s).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},7881:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=a(r(9157)),o=a(r(3202)),i=a(r(1025));function a(e){return e&&e.__esModule?e:{default:e}}function s(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l,u=["A","ACCESSIBLE","AGENT","AGGREGATE","ALL","ALTER","ANY","ARRAY","AS","ASC","AT","ATTRIBUTE","AUTHID","AVG","BETWEEN","BFILE_BASE","BINARY_INTEGER","BINARY","BLOB_BASE","BLOCK","BODY","BOOLEAN","BOTH","BOUND","BREADTH","BULK","BY","BYTE","C","CALL","CALLING","CASCADE","CASE","CHAR_BASE","CHAR","CHARACTER","CHARSET","CHARSETFORM","CHARSETID","CHECK","CLOB_BASE","CLONE","CLOSE","CLUSTER","CLUSTERS","COALESCE","COLAUTH","COLLECT","COLUMNS","COMMENT","COMMIT","COMMITTED","COMPILED","COMPRESS","CONNECT","CONSTANT","CONSTRUCTOR","CONTEXT","CONTINUE","CONVERT","COUNT","CRASH","CREATE","CREDENTIAL","CURRENT","CURRVAL","CURSOR","CUSTOMDATUM","DANGLING","DATA","DATE_BASE","DATE","DAY","DECIMAL","DEFAULT","DEFINE","DELETE","DEPTH","DESC","DETERMINISTIC","DIRECTORY","DISTINCT","DO","DOUBLE","DROP","DURATION","ELEMENT","ELSIF","EMPTY","END","ESCAPE","EXCEPTIONS","EXCLUSIVE","EXECUTE","EXISTS","EXIT","EXTENDS","EXTERNAL","EXTRACT","FALSE","FETCH","FINAL","FIRST","FIXED","FLOAT","FOR","FORALL","FORCE","FROM","FUNCTION","GENERAL","GOTO","GRANT","GROUP","HASH","HEAP","HIDDEN","HOUR","IDENTIFIED","IF","IMMEDIATE","IN","INCLUDING","INDEX","INDEXES","INDICATOR","INDICES","INFINITE","INSTANTIABLE","INT","INTEGER","INTERFACE","INTERVAL","INTO","INVALIDATE","IS","ISOLATION","JAVA","LANGUAGE","LARGE","LEADING","LENGTH","LEVEL","LIBRARY","LIKE","LIKE2","LIKE4","LIKEC","LIMITED","LOCAL","LOCK","LONG","MAP","MAX","MAXLEN","MEMBER","MERGE","MIN","MINUTE","MLSLABEL","MOD","MODE","MONTH","MULTISET","NAME","NAN","NATIONAL","NATIVE","NATURAL","NATURALN","NCHAR","NEW","NEXTVAL","NOCOMPRESS","NOCOPY","NOT","NOWAIT","NULL","NULLIF","NUMBER_BASE","NUMBER","OBJECT","OCICOLL","OCIDATE","OCIDATETIME","OCIDURATION","OCIINTERVAL","OCILOBLOCATOR","OCINUMBER","OCIRAW","OCIREF","OCIREFCURSOR","OCIROWID","OCISTRING","OCITYPE","OF","OLD","ON","ONLY","OPAQUE","OPEN","OPERATOR","OPTION","ORACLE","ORADATA","ORDER","ORGANIZATION","ORLANY","ORLVARY","OTHERS","OUT","OVERLAPS","OVERRIDING","PACKAGE","PARALLEL_ENABLE","PARAMETER","PARAMETERS","PARENT","PARTITION","PASCAL","PCTFREE","PIPE","PIPELINED","PLS_INTEGER","PLUGGABLE","POSITIVE","POSITIVEN","PRAGMA","PRECISION","PRIOR","PRIVATE","PROCEDURE","PUBLIC","RAISE","RANGE","RAW","READ","REAL","RECORD","REF","REFERENCE","RELEASE","RELIES_ON","REM","REMAINDER","RENAME","RESOURCE","RESULT_CACHE","RESULT","RETURN","RETURNING","REVERSE","REVOKE","ROLLBACK","ROW","ROWID","ROWNUM","ROWTYPE","SAMPLE","SAVE","SAVEPOINT","SB1","SB2","SB4","SEARCH","SECOND","SEGMENT","SELF","SEPARATE","SEQUENCE","SERIALIZABLE","SHARE","SHORT","SIZE_T","SIZE","SMALLINT","SOME","SPACE","SPARSE","SQL","SQLCODE","SQLDATA","SQLERRM","SQLNAME","SQLSTATE","STANDARD","START","STATIC","STDDEV","STORED","STRING","STRUCT","STYLE","SUBMULTISET","SUBPARTITION","SUBSTITUTABLE","SUBTYPE","SUCCESSFUL","SUM","SYNONYM","SYSDATE","TABAUTH","TABLE","TDO","THE","THEN","TIME","TIMESTAMP","TIMEZONE_ABBR","TIMEZONE_HOUR","TIMEZONE_MINUTE","TIMEZONE_REGION","TO","TRAILING","TRANSACTION","TRANSACTIONAL","TRIGGER","TRUE","TRUSTED","TYPE","UB1","UB2","UB4","UID","UNDER","UNIQUE","UNPLUG","UNSIGNED","UNTRUSTED","USE","USER","USING","VALIDATE","VALIST","VALUE","VARCHAR","VARCHAR2","VARIABLE","VARIANCE","VARRAY","VARYING","VIEW","VIEWS","VOID","WHENEVER","WHILE","WITH","WORK","WRAPPED","WRITE","YEAR","ZONE"],c=["ADD","ALTER COLUMN","ALTER TABLE","BEGIN","CONNECT BY","DECLARE","DELETE FROM","DELETE","END","EXCEPT","EXCEPTION","FETCH FIRST","FROM","GROUP BY","HAVING","INSERT INTO","INSERT","LIMIT","LOOP","MODIFY","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","START WITH","UPDATE","VALUES","WHERE"],d=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],p=["AND","CROSS APPLY","CROSS JOIN","ELSE","END","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER APPLY","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","WHEN","XOR"],f=function(e,t){if(e.type===i.default.RESERVED_TOP_LEVEL&&"SET"===e.value&&"BY"===t.value)return e.type=i.default.RESERVED,e},v=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return l||(l=new o.default({reservedWords:u,reservedTopLevelWords:c,reservedNewlineWords:p,reservedTopLevelWordsNoIndent:d,stringTypes:['""',"N''","''","``"],openParens:["(","CASE","BEGIN"],closeParens:[")","END"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:[":"],lineCommentTypes:["--"],specialWordChars:["_","$","#",".","@"]})),new n.default(this.cfg,l,f).format(e)}}])&&s(t.prototype,r),e}();t.default=v,e.exports=t.default},1432:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s,l=["ACCESSIBLE","ACTION","AGAINST","AGGREGATE","ALGORITHM","ALL","ALTER","ANALYSE","ANALYZE","AS","ASC","AUTOCOMMIT","AUTO_INCREMENT","BACKUP","BEGIN","BETWEEN","BINLOG","BOTH","CASCADE","CASE","CHANGE","CHANGED","CHARACTER SET","CHARSET","CHECK","CHECKSUM","COLLATE","COLLATION","COLUMN","COLUMNS","COMMENT","COMMIT","COMMITTED","COMPRESSED","CONCURRENT","CONSTRAINT","CONTAINS","CONVERT","CREATE","CROSS","CURRENT_TIMESTAMP","DATABASE","DATABASES","DAY","DAY_HOUR","DAY_MINUTE","DAY_SECOND","DEFAULT","DEFINER","DELAYED","DELETE","DESC","DESCRIBE","DETERMINISTIC","DISTINCT","DISTINCTROW","DIV","DO","DROP","DUMPFILE","DUPLICATE","DYNAMIC","ELSE","ENCLOSED","END","ENGINE","ENGINES","ENGINE_TYPE","ESCAPE","ESCAPED","EVENTS","EXEC","EXECUTE","EXISTS","EXPLAIN","EXTENDED","FAST","FETCH","FIELDS","FILE","FIRST","FIXED","FLUSH","FOR","FORCE","FOREIGN","FULL","FULLTEXT","FUNCTION","GLOBAL","GRANT","GRANTS","GROUP_CONCAT","HEAP","HIGH_PRIORITY","HOSTS","HOUR","HOUR_MINUTE","HOUR_SECOND","IDENTIFIED","IF","IFNULL","IGNORE","IN","INDEX","INDEXES","INFILE","INSERT","INSERT_ID","INSERT_METHOD","INTERVAL","INTO","INVOKER","IS","ISOLATION","KEY","KEYS","KILL","LAST_INSERT_ID","LEADING","LEVEL","LIKE","LINEAR","LINES","LOAD","LOCAL","LOCK","LOCKS","LOGS","LOW_PRIORITY","MARIA","MASTER","MASTER_CONNECT_RETRY","MASTER_HOST","MASTER_LOG_FILE","MATCH","MAX_CONNECTIONS_PER_HOUR","MAX_QUERIES_PER_HOUR","MAX_ROWS","MAX_UPDATES_PER_HOUR","MAX_USER_CONNECTIONS","MEDIUM","MERGE","MINUTE","MINUTE_SECOND","MIN_ROWS","MODE","MODIFY","MONTH","MRG_MYISAM","MYISAM","NAMES","NATURAL","NOT","NOW()","NULL","OFFSET","ON DELETE","ON UPDATE","ON","ONLY","OPEN","OPTIMIZE","OPTION","OPTIONALLY","OUTFILE","PACK_KEYS","PAGE","PARTIAL","PARTITION","PARTITIONS","PASSWORD","PRIMARY","PRIVILEGES","PROCEDURE","PROCESS","PROCESSLIST","PURGE","QUICK","RAID0","RAID_CHUNKS","RAID_CHUNKSIZE","RAID_TYPE","RANGE","READ","READ_ONLY","READ_WRITE","REFERENCES","REGEXP","RELOAD","RENAME","REPAIR","REPEATABLE","REPLACE","REPLICATION","RESET","RESTORE","RESTRICT","RETURN","RETURNS","REVOKE","RLIKE","ROLLBACK","ROW","ROWS","ROW_FORMAT","SECOND","SECURITY","SEPARATOR","SERIALIZABLE","SESSION","SHARE","SHOW","SHUTDOWN","SLAVE","SONAME","SOUNDS","SQL","SQL_AUTO_IS_NULL","SQL_BIG_RESULT","SQL_BIG_SELECTS","SQL_BIG_TABLES","SQL_BUFFER_RESULT","SQL_CACHE","SQL_CALC_FOUND_ROWS","SQL_LOG_BIN","SQL_LOG_OFF","SQL_LOG_UPDATE","SQL_LOW_PRIORITY_UPDATES","SQL_MAX_JOIN_SIZE","SQL_NO_CACHE","SQL_QUOTE_SHOW_CREATE","SQL_SAFE_UPDATES","SQL_SELECT_LIMIT","SQL_SLAVE_SKIP_COUNTER","SQL_SMALL_RESULT","SQL_WARNINGS","START","STARTING","STATUS","STOP","STORAGE","STRAIGHT_JOIN","STRING","STRIPED","SUPER","TABLE","TABLES","TEMPORARY","TERMINATED","THEN","TO","TRAILING","TRANSACTIONAL","TRUE","TRUNCATE","TYPE","TYPES","UNCOMMITTED","UNIQUE","UNLOCK","UNSIGNED","USAGE","USE","USING","VARIABLES","VIEW","WHEN","WITH","WORK","WRITE","YEAR_MONTH"],u=["ADD","AFTER","ALTER COLUMN","ALTER TABLE","DELETE FROM","EXCEPT","FETCH FIRST","FROM","GROUP BY","GO","HAVING","INSERT INTO","INSERT","LIMIT","MODIFY","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UPDATE","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","CROSS APPLY","CROSS JOIN","ELSE","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER APPLY","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","WHEN","XOR"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return s||(s=new o.default({reservedWords:l,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"N''","''","``","[]"],openParens:["(","CASE"],closeParens:[")","END"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:["@",":"],lineCommentTypes:["#","--"]})),new n.default(this.cfg,s).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},7409:(e,t,r)=>{"use strict";t.Ay=void 0;var n=s(r(4377)),o=s(r(9445)),i=s(r(7881)),a=s(r(1432));function s(e){return e&&e.__esModule?e:{default:e}}var l={format:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};switch(t.language){case"db2":return new n.default(t).format(e);case"n1ql":return new o.default(t).format(e);case"pl/sql":return new i.default(t).format(e);case"sql":case void 0:return new a.default(t).format(e);default:throw Error("Unsupported SQL dialect: ".concat(t.language))}}};t.Ay=l},358:(e,t,r)=>{e.exports=r(3231)},3231:(e,t)=>{var r=t,n=/`/g,o=/\./g,i=/[\0\b\t\n\r\x1a\"\'\\]/g,a={"\0":"\\0","\b":"\\b","\t":"\\t","\n":"\\n","\r":"\\r","":"\\Z",'"':'\\"',"'":"\\'","\\":"\\\\"};function s(e){for(var t,r=i.lastIndex=0,n="";t=i.exec(e);)n+=e.slice(r,t.index)+a[t[0]],r=i.lastIndex;return 0===r?"'"+e+"'":r<e.length?"'"+n+e.slice(r)+"'":"'"+n+"'"}function l(e,t){for(e=e.toString();e.length<t;)e="0"+e;return e}r.escapeId=function(e,t){if(Array.isArray(e)){for(var i="",a=0;a<e.length;a++)i+=(0===a?"":", ")+r.escapeId(e[a],t);return i}return t?"`"+String(e).replace(n,"``")+"`":"`"+String(e).replace(n,"``").replace(o,"`.`")+"`"},r.escape=function(e,t,n){if(null==e)return"NULL";switch(typeof e){case"boolean":return e?"true":"false";case"number":return e+"";case"object":return"[object Date]"===Object.prototype.toString.call(e)?r.dateToString(e,n||"local"):Array.isArray(e)?r.arrayToList(e,n):Buffer.isBuffer(e)?r.bufferToString(e):"function"==typeof e.toSqlString?String(e.toSqlString()):t?s(e.toString()):r.objectToValues(e,n);default:return s(e)}},r.arrayToList=function(e,t){for(var n="",o=0;o<e.length;o++){var i=e[o];Array.isArray(i)?n+=(0===o?"":", ")+"("+r.arrayToList(i,t)+")":n+=(0===o?"":", ")+r.escape(i,!0,t)}return n},r.format=function(e,t,n,o){if(null==t)return e;Array.isArray(t)||(t=[t]);for(var i,a=0,s=/\?+/g,l="",u=0;u<t.length&&(i=s.exec(e));){var c=i[0].length;if(!(c>2)){var d=2===c?r.escapeId(t[u]):r.escape(t[u],n,o);l+=e.slice(a,i.index)+d,a=s.lastIndex,u++}}return 0===a?e:a<e.length?l+e.slice(a):l},r.dateToString=function(e,t){var r,n,o,i,a,u,c,d=new Date(e);if(isNaN(d.getTime()))return"NULL";if("local"===t)r=d.getFullYear(),n=d.getMonth()+1,o=d.getDate(),i=d.getHours(),a=d.getMinutes(),u=d.getSeconds(),c=d.getMilliseconds();else{var p=function(e){if("Z"===e)return 0;var t=e.match(/([\+\-\s])(\d\d):?(\d\d)?/);return!!t&&("-"===t[1]?-1:1)*(parseInt(t[2],10)+(t[3]?parseInt(t[3],10):0)/60)*60}(t);!1!==p&&0!==p&&d.setTime(d.getTime()+6e4*p),r=d.getUTCFullYear(),n=d.getUTCMonth()+1,o=d.getUTCDate(),i=d.getUTCHours(),a=d.getUTCMinutes(),u=d.getUTCSeconds(),c=d.getUTCMilliseconds()}return s(l(r,4)+"-"+l(n,2)+"-"+l(o,2)+" "+l(i,2)+":"+l(a,2)+":"+l(u,2)+"."+l(c,3))},r.bufferToString=function(e){return"X"+s(e.toString("hex"))},r.objectToValues=function(e,t){var n="";for(var o in e){var i=e[o];"function"!=typeof i&&(n+=(0===n.length?"":", ")+r.escapeId(o)+" = "+r.escape(i,!0,t))}return n},r.raw=function(e){if("string"!=typeof e)throw new TypeError("argument sql must be a string");return{toSqlString:function(){return e}}}},1882:e=>{e.exports=function(){var e=document.getSelection();if(!e.rangeCount)return function(){};for(var t=document.activeElement,r=[],n=0;n<e.rangeCount;n++)r.push(e.getRangeAt(n));switch(t.tagName.toUpperCase()){case"INPUT":case"TEXTAREA":t.blur();break;default:t=null}return e.removeAllRanges(),function(){"Caret"===e.type&&e.removeAllRanges(),e.rangeCount||r.forEach((function(t){e.addRange(t)})),t&&t.focus()}}},6089:e=>{"use strict";e.exports=a},7781:t=>{"use strict";t.exports=e},8531:e=>{"use strict";e.exports=r},2007:e=>{"use strict";e.exports=i},3241:e=>{"use strict";e.exports=n},2468:e=>{"use strict";e.exports=s},5959:e=>{"use strict";e.exports=o},200:e=>{"use strict";e.exports=u},7694:e=>{"use strict";e.exports=l},1269:e=>{"use strict";e.exports=t},8911:(e,t,r)=>{var n=r(5992).default;function o(){"use strict";e.exports=o=function(){return r},e.exports.__esModule=!0,e.exports.default=e.exports;var t,r={},i=Object.prototype,a=i.hasOwnProperty,s=Object.defineProperty||function(e,t,r){e[t]=r.value},l="function"==typeof Symbol?Symbol:{},u=l.iterator||"@@iterator",c=l.asyncIterator||"@@asyncIterator",d=l.toStringTag||"@@toStringTag";function p(e,t,r){return Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}),e[t]}try{p({},"")}catch(t){p=function(e,t,r){return e[t]=r}}function f(e,t,r,n){var o=t&&t.prototype instanceof E?t:E,i=Object.create(o.prototype),a=new x(n||[]);return s(i,"_invoke",{value:C(e,r,a)}),i}function v(e,t,r){try{return{type:"normal",arg:e.call(t,r)}}catch(e){return{type:"throw",arg:e}}}r.wrap=f;var h="suspendedStart",g="suspendedYield",y="executing",m="completed",b={};function E(){}function O(){}function S(){}var T={};p(T,u,(function(){return this}));var _=Object.getPrototypeOf,w=_&&_(_(j([])));w&&w!==i&&a.call(w,u)&&(T=w);var R=S.prototype=E.prototype=Object.create(T);function I(e){["next","throw","return"].forEach((function(t){p(e,t,(function(e){return this._invoke(t,e)}))}))}function A(e,t){function r(o,i,s,l){var u=v(e[o],e,i);if("throw"!==u.type){var c=u.arg,d=c.value;return d&&"object"==n(d)&&a.call(d,"__await")?t.resolve(d.__await).then((function(e){r("next",e,s,l)}),(function(e){r("throw",e,s,l)})):t.resolve(d).then((function(e){c.value=e,s(c)}),(function(e){return r("throw",e,s,l)}))}l(u.arg)}var o;s(this,"_invoke",{value:function(e,n){function i(){return new t((function(t,o){r(e,n,t,o)}))}return o=o?o.then(i,i):i()}})}function C(e,r,n){var o=h;return function(i,a){if(o===y)throw Error("Generator is already running");if(o===m){if("throw"===i)throw a;return{value:t,done:!0}}for(n.method=i,n.arg=a;;){var s=n.delegate;if(s){var l=N(s,n);if(l){if(l===b)continue;return l}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(o===h)throw o=m,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);o=y;var u=v(e,r,n);if("normal"===u.type){if(o=n.done?m:g,u.arg===b)continue;return{value:u.arg,done:n.done}}"throw"===u.type&&(o=m,n.method="throw",n.arg=u.arg)}}}function N(e,r){var n=r.method,o=e.iterator[n];if(o===t)return r.delegate=null,"throw"===n&&e.iterator.return&&(r.method="return",r.arg=t,N(e,r),"throw"===r.method)||"return"!==n&&(r.method="throw",r.arg=new TypeError("The iterator does not provide a '"+n+"' method")),b;var i=v(o,e.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,b;var a=i.arg;return a?a.done?(r[e.resultName]=a.value,r.next=e.nextLoc,"return"!==r.method&&(r.method="next",r.arg=t),r.delegate=null,b):a:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,b)}function L(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function P(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function x(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(L,this),this.reset(!0)}function j(e){if(e||""===e){var r=e[u];if(r)return r.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var o=-1,i=function r(){for(;++o<e.length;)if(a.call(e,o))return r.value=e[o],r.done=!1,r;return r.value=t,r.done=!0,r};return i.next=i}}throw new TypeError(n(e)+" is not iterable")}return O.prototype=S,s(R,"constructor",{value:S,configurable:!0}),s(S,"constructor",{value:O,configurable:!0}),O.displayName=p(S,d,"GeneratorFunction"),r.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===O||"GeneratorFunction"===(t.displayName||t.name))},r.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,S):(e.__proto__=S,p(e,d,"GeneratorFunction")),e.prototype=Object.create(R),e},r.awrap=function(e){return{__await:e}},I(A.prototype),p(A.prototype,c,(function(){return this})),r.AsyncIterator=A,r.async=function(e,t,n,o,i){void 0===i&&(i=Promise);var a=new A(f(e,t,n,o),i);return r.isGeneratorFunction(t)?a:a.next().then((function(e){return e.done?e.value:a.next()}))},I(R),p(R,d,"Generator"),p(R,u,(function(){return this})),p(R,"toString",(function(){return"[object Generator]"})),r.keys=function(e){var t=Object(e),r=[];for(var n in t)r.push(n);return r.reverse(),function e(){for(;r.length;){var n=r.pop();if(n in t)return e.value=n,e.done=!1,e}return e.done=!0,e}},r.values=j,x.prototype={constructor:x,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=t,this.done=!1,this.delegate=null,this.method="next",this.arg=t,this.tryEntries.forEach(P),!e)for(var r in this)"t"===r.charAt(0)&&a.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=t)},stop:function(){this.done=!0;var e=this.tryEntries[0].completion;if("throw"===e.type)throw e.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var r=this;function n(n,o){return s.type="throw",s.arg=e,r.next=n,o&&(r.method="next",r.arg=t),!!o}for(var o=this.tryEntries.length-1;o>=0;--o){var i=this.tryEntries[o],s=i.completion;if("root"===i.tryLoc)return n("end");if(i.tryLoc<=this.prev){var l=a.call(i,"catchLoc"),u=a.call(i,"finallyLoc");if(l&&u){if(this.prev<i.catchLoc)return n(i.catchLoc,!0);if(this.prev<i.finallyLoc)return n(i.finallyLoc)}else if(l){if(this.prev<i.catchLoc)return n(i.catchLoc,!0)}else{if(!u)throw Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return n(i.finallyLoc)}}}},abrupt:function(e,t){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&a.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var o=n;break}}o&&("break"===e||"continue"===e)&&o.tryLoc<=t&&t<=o.finallyLoc&&(o=null);var i=o?o.completion:{};return i.type=e,i.arg=t,o?(this.method="next",this.next=o.finallyLoc,b):this.complete(i)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),b},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var r=this.tryEntries[t];if(r.finallyLoc===e)return this.complete(r.completion,r.afterLoc),P(r),b}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var r=this.tryEntries[t];if(r.tryLoc===e){var n=r.completion;if("throw"===n.type){var o=n.arg;P(r)}return o}}throw Error("illegal catch attempt")},delegateYield:function(e,r,n){return this.delegate={iterator:j(e),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=t),b}},r}e.exports=o,e.exports.__esModule=!0,e.exports.default=e.exports},5992:e=>{function t(r){return e.exports=t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},e.exports.__esModule=!0,e.exports.default=e.exports,t(r)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},6834:(e,t,r)=>{var n=r(8911)();e.exports=n;try{regeneratorRuntime=n}catch(e){"object"==typeof globalThis?globalThis.regeneratorRuntime=n:Function("r","regeneratorRuntime = r")(n)}},2584:(e,t)=>{var r;!function(){"use strict";var n={}.hasOwnProperty;function o(){for(var e="",t=0;t<arguments.length;t++){var r=arguments[t];r&&(e=a(e,i(r)))}return e}function i(e){if("string"==typeof e||"number"==typeof e)return e;if("object"!=typeof e)return"";if(Array.isArray(e))return o.apply(null,e);if(e.toString!==Object.prototype.toString&&!e.toString.toString().includes("[native code]"))return e.toString();var t="";for(var r in e)n.call(e,r)&&e[r]&&(t=a(t,r));return t}function a(e,t){return t?e?e+" "+t:e+t:e}e.exports?(o.default=o,e.exports=o):void 0===(r=function(){return o}.apply(t,[]))||(e.exports=r)}()},7016:(e,t,r)=>{"use strict";r.r(t),r.d(t,{__addDisposableResource:()=>j,__assign:()=>i,__asyncDelegator:()=>w,__asyncGenerator:()=>_,__asyncValues:()=>R,__await:()=>T,__awaiter:()=>v,__classPrivateFieldGet:()=>L,__classPrivateFieldIn:()=>x,__classPrivateFieldSet:()=>P,__createBinding:()=>g,__decorate:()=>s,__disposeResources:()=>D,__esDecorate:()=>u,__exportStar:()=>y,__extends:()=>o,__generator:()=>h,__importDefault:()=>N,__importStar:()=>C,__makeTemplateObject:()=>I,__metadata:()=>f,__param:()=>l,__propKey:()=>d,__read:()=>b,__rest:()=>a,__rewriteRelativeImportExtension:()=>k,__runInitializers:()=>c,__setFunctionName:()=>p,__spread:()=>E,__spreadArray:()=>S,__spreadArrays:()=>O,__values:()=>m,default:()=>M});var n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)};function o(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}var i=function(){return i=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},i.apply(this,arguments)};function a(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r}function s(e,t,r,n){var o,i=arguments.length,a=i<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,r):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,r,n);else for(var s=e.length-1;s>=0;s--)(o=e[s])&&(a=(i<3?o(a):i>3?o(t,r,a):o(t,r))||a);return i>3&&a&&Object.defineProperty(t,r,a),a}function l(e,t){return function(r,n){t(r,n,e)}}function u(e,t,r,n,o,i){function a(e){if(void 0!==e&&"function"!=typeof e)throw new TypeError("Function expected");return e}for(var s,l=n.kind,u="getter"===l?"get":"setter"===l?"set":"value",c=!t&&e?n.static?e:e.prototype:null,d=t||(c?Object.getOwnPropertyDescriptor(c,n.name):{}),p=!1,f=r.length-1;f>=0;f--){var v={};for(var h in n)v[h]="access"===h?{}:n[h];for(var h in n.access)v.access[h]=n.access[h];v.addInitializer=function(e){if(p)throw new TypeError("Cannot add initializers after decoration has completed");i.push(a(e||null))};var g=(0,r[f])("accessor"===l?{get:d.get,set:d.set}:d[u],v);if("accessor"===l){if(void 0===g)continue;if(null===g||"object"!=typeof g)throw new TypeError("Object expected");(s=a(g.get))&&(d.get=s),(s=a(g.set))&&(d.set=s),(s=a(g.init))&&o.unshift(s)}else(s=a(g))&&("field"===l?o.unshift(s):d[u]=s)}c&&Object.defineProperty(c,n.name,d),p=!0}function c(e,t,r){for(var n=arguments.length>2,o=0;o<t.length;o++)r=n?t[o].call(e,r):t[o].call(e);return n?r:void 0}function d(e){return"symbol"==typeof e?e:"".concat(e)}function p(e,t,r){return"symbol"==typeof t&&(t=t.description?"[".concat(t.description,"]"):""),Object.defineProperty(e,"name",{configurable:!0,value:r?"".concat(r," ",t):t})}function f(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}function v(e,t,r,n){return new(r||(r=Promise))((function(o,i){function a(e){try{l(n.next(e))}catch(e){i(e)}}function s(e){try{l(n.throw(e))}catch(e){i(e)}}function l(e){var t;e.done?o(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t)}))).then(a,s)}l((n=n.apply(e,t||[])).next())}))}function h(e,t){var r,n,o,i={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]},a=Object.create(("function"==typeof Iterator?Iterator:Object).prototype);return a.next=s(0),a.throw=s(1),a.return=s(2),"function"==typeof Symbol&&(a[Symbol.iterator]=function(){return this}),a;function s(s){return function(l){return function(s){if(r)throw new TypeError("Generator is already executing.");for(;a&&(a=0,s[0]&&(i=0)),i;)try{if(r=1,n&&(o=2&s[0]?n.return:s[0]?n.throw||((o=n.return)&&o.call(n),0):n.next)&&!(o=o.call(n,s[1])).done)return o;switch(n=0,o&&(s=[2&s[0],o.value]),s[0]){case 0:case 1:o=s;break;case 4:return i.label++,{value:s[1],done:!1};case 5:i.label++,n=s[1],s=[0];continue;case 7:s=i.ops.pop(),i.trys.pop();continue;default:if(!((o=(o=i.trys).length>0&&o[o.length-1])||6!==s[0]&&2!==s[0])){i=0;continue}if(3===s[0]&&(!o||s[1]>o[0]&&s[1]<o[3])){i.label=s[1];break}if(6===s[0]&&i.label<o[1]){i.label=o[1],o=s;break}if(o&&i.label<o[2]){i.label=o[2],i.ops.push(s);break}o[2]&&i.ops.pop(),i.trys.pop();continue}s=t.call(e,i)}catch(e){s=[6,e],n=0}finally{r=o=0}if(5&s[0])throw s[1];return{value:s[0]?s[1]:void 0,done:!0}}([s,l])}}}var g=Object.create?function(e,t,r,n){void 0===n&&(n=r);var o=Object.getOwnPropertyDescriptor(t,r);o&&!("get"in o?!t.__esModule:o.writable||o.configurable)||(o={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,o)}:function(e,t,r,n){void 0===n&&(n=r),e[n]=t[r]};function y(e,t){for(var r in e)"default"===r||Object.prototype.hasOwnProperty.call(t,r)||g(t,e,r)}function m(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function b(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}function E(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(b(arguments[t]));return e}function O(){for(var e=0,t=0,r=arguments.length;t<r;t++)e+=arguments[t].length;var n=Array(e),o=0;for(t=0;t<r;t++)for(var i=arguments[t],a=0,s=i.length;a<s;a++,o++)n[o]=i[a];return n}function S(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))}function T(e){return this instanceof T?(this.v=e,this):new T(e)}function _(e,t,r){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var n,o=r.apply(e,t||[]),i=[];return n=Object.create(("function"==typeof AsyncIterator?AsyncIterator:Object).prototype),a("next"),a("throw"),a("return",(function(e){return function(t){return Promise.resolve(t).then(e,u)}})),n[Symbol.asyncIterator]=function(){return this},n;function a(e,t){o[e]&&(n[e]=function(t){return new Promise((function(r,n){i.push([e,t,r,n])>1||s(e,t)}))},t&&(n[e]=t(n[e])))}function s(e,t){try{(r=o[e](t)).value instanceof T?Promise.resolve(r.value.v).then(l,u):c(i[0][2],r)}catch(e){c(i[0][3],e)}var r}function l(e){s("next",e)}function u(e){s("throw",e)}function c(e,t){e(t),i.shift(),i.length&&s(i[0][0],i[0][1])}}function w(e){var t,r;return t={},n("next"),n("throw",(function(e){throw e})),n("return"),t[Symbol.iterator]=function(){return this},t;function n(n,o){t[n]=e[n]?function(t){return(r=!r)?{value:T(e[n](t)),done:!1}:o?o(t):t}:o}}function R(e){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t,r=e[Symbol.asyncIterator];return r?r.call(e):(e=m(e),t={},n("next"),n("throw"),n("return"),t[Symbol.asyncIterator]=function(){return this},t);function n(r){t[r]=e[r]&&function(t){return new Promise((function(n,o){!function(e,t,r,n){Promise.resolve(n).then((function(t){e({value:t,done:r})}),t)}(n,o,(t=e[r](t)).done,t.value)}))}}}function I(e,t){return Object.defineProperty?Object.defineProperty(e,"raw",{value:t}):e.raw=t,e}var A=Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t};function C(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&g(t,e,r);return A(t,e),t}function N(e){return e&&e.__esModule?e:{default:e}}function L(e,t,r,n){if("a"===r&&!n)throw new TypeError("Private accessor was defined without a getter");if("function"==typeof t?e!==t||!n:!t.has(e))throw new TypeError("Cannot read private member from an object whose class did not declare it");return"m"===r?n:"a"===r?n.call(e):n?n.value:t.get(e)}function P(e,t,r,n,o){if("m"===n)throw new TypeError("Private method is not writable");if("a"===n&&!o)throw new TypeError("Private accessor was defined without a setter");if("function"==typeof t?e!==t||!o:!t.has(e))throw new TypeError("Cannot write private member to an object whose class did not declare it");return"a"===n?o.call(e,r):o?o.value=r:t.set(e,r),r}function x(e,t){if(null===t||"object"!=typeof t&&"function"!=typeof t)throw new TypeError("Cannot use 'in' operator on non-object");return"function"==typeof e?t===e:e.has(t)}function j(e,t,r){if(null!=t){if("object"!=typeof t&&"function"!=typeof t)throw new TypeError("Object expected.");var n,o;if(r){if(!Symbol.asyncDispose)throw new TypeError("Symbol.asyncDispose is not defined.");n=t[Symbol.asyncDispose]}if(void 0===n){if(!Symbol.dispose)throw new TypeError("Symbol.dispose is not defined.");n=t[Symbol.dispose],r&&(o=n)}if("function"!=typeof n)throw new TypeError("Object not disposable.");o&&(n=function(){try{o.call(this)}catch(e){return Promise.reject(e)}}),e.stack.push({value:t,dispose:n,async:r})}else r&&e.stack.push({async:!0});return t}var F="function"==typeof SuppressedError?SuppressedError:function(e,t,r){var n=new Error(r);return n.name="SuppressedError",n.error=e,n.suppressed=t,n};function D(e){function t(t){e.error=e.hasError?new F(t,e.error,"An error was suppressed during disposal."):t,e.hasError=!0}var r,n=0;return function o(){for(;r=e.stack.pop();)try{if(!r.async&&1===n)return n=0,e.stack.push(r),Promise.resolve().then(o);if(r.dispose){var i=r.dispose.call(r.value);if(r.async)return n|=2,Promise.resolve(i).then(o,(function(e){return t(e),o()}))}else n|=1}catch(e){t(e)}if(1===n)return e.hasError?Promise.reject(e.error):Promise.resolve();if(e.hasError)throw e.error}()}function k(e,t){return"string"==typeof e&&/^\.\.?\//.test(e)?e.replace(/\.(tsx)$|((?:\.d)?)((?:\.[^./]+?)?)\.([cm]?)ts$/i,(function(e,r,n,o,i){return r?t?".jsx":".js":!n||o&&i?n+o+"."+i.toLowerCase()+"js":e})):e}const M={__extends:o,__assign:i,__rest:a,__decorate:s,__param:l,__esDecorate:u,__runInitializers:c,__propKey:d,__setFunctionName:p,__metadata:f,__awaiter:v,__generator:h,__createBinding:g,__exportStar:y,__values:m,__read:b,__spread:E,__spreadArrays:O,__spreadArray:S,__await:T,__asyncGenerator:_,__asyncDelegator:w,__asyncValues:R,__makeTemplateObject:I,__importStar:C,__importDefault:N,__classPrivateFieldGet:L,__classPrivateFieldSet:P,__classPrivateFieldIn:x,__addDisposableResource:j,__disposeResources:D,__rewriteRelativeImportExtension:k}}},d={};function p(e){var t=d[e];if(void 0!==t)return t.exports;var r=d[e]={id:e,loaded:!1,exports:{}};return c[e].call(r.exports,r,r.exports,p),r.loaded=!0,r.exports}p.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return p.d(t,{a:t}),t},p.d=(e,t)=>{for(var r in t)p.o(t,r)&&!p.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})},p.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),p.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),p.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},p.nmd=e=>(e.paths=[],e.children||(e.children=[]),e);var f={};return(()=>{"use strict";p.r(f),p.d(f,{plugin:()=>Xw});var e={};p.r(e),p.d(e,{applyToJS:()=>Gl,cleanJSX:()=>Kl,deepEqual:()=>kl,deepFreeze:()=>Xl,escapeRegExp:()=>$l,getFirstDefined:()=>eu,getLogger:()=>Zl,getOpCardinality:()=>Dl,isDirtyJSX:()=>Wl,isImmutable:()=>Vl,isImmutableList:()=>Ul,isJSX:()=>zl,isJsonCompatible:()=>Jl,isJsonLogic:()=>Hl,isObject:()=>xl,logger:()=>tu,mergeArraysSmart:()=>Ql,mergeCustomizerNoArrays:()=>ql,omit:()=>Fl,opDefKeysToOmit:()=>Pl,shallowCopy:()=>jl,shallowEqual:()=>Ml,sleep:()=>Yl,toImmutableList:()=>Bl,uuid:()=>Cl,widgetDefKeysToOmit:()=>Ll});var t={};p.r(t),p.d(t,{getItemInListValues:()=>yu,getListValue:()=>Su,getTitleInListValues:()=>mu,getValueInListValues:()=>bu,listValuesToArray:()=>gu,makeCustomListValue:()=>hu,mapListValues:()=>Eu,searchListValue:()=>Ou,toListValue:()=>vu});var r={};p.r(r),p.d(r,{_fixImmutableValue:()=>Du,expandTreePath:()=>Tu,expandTreeSubpath:()=>_u,fixEmptyGroupsInTree:()=>Au,fixPathsInTree:()=>Iu,getFlatTree:()=>Cu,getItemByPath:()=>wu,getLightTree:()=>Pu,getSwitchValues:()=>xu,getTotalReordableNodesCountInTree:()=>Nu,getTotalRulesCountInTree:()=>Lu,hasChildren:()=>Fu,immutableToJs:()=>Gl,isEmptyTree:()=>ju,isImmutable:()=>Vl,jsToImmutable:()=>Bu,removeIsLockedInTree:()=>Ru,toImmutableList:()=>Bl});var n={};p.r(n),p.d(n,{SqlString:()=>Ec,mongoEmptyValue:()=>Sc,spelEscape:()=>_c,spelFixList:()=>Tc,spelFormatConcat:()=>wc,spelImportConcat:()=>Rc,sqlEmptyValue:()=>Oc,stringifyForDisplay:()=>Ic,wrapWithBrackets:()=>Ac});var o={};p.r(o),p.d(o,{_loadFromJsonLogic:()=>rc,_loadFromSpel:()=>nd,getTree:()=>ku,isImmutableTree:()=>Vu,isJsonLogic:()=>Hl,isTree:()=>Uu,jsToImmutable:()=>Bu,loadFromJsonLogic:()=>tc,loadFromSpel:()=>rd,loadTree:()=>Mu});var i={};p.r(i),p.d(i,{createListFromArray:()=>Md,createListWithOneElement:()=>kd,defaultConjunction:()=>Pd,defaultGroupConjunction:()=>Ld,defaultGroupProperties:()=>xd,defaultItemProperties:()=>jd,defaultOperatorOptions:()=>Cd,defaultRoot:()=>Dd,defaultRule:()=>Fd,defaultRuleProperties:()=>Nd,emptyProperties:()=>Vd,getDefaultField:()=>wd,getDefaultFieldSrc:()=>Id,getDefaultOperator:()=>Ad,getDefaultSubField:()=>Rd});var a={};p.r(a),p.d(a,{_validateTree:()=>Mf,checkTree:()=>jf,getNewValueForFieldOp:()=>Hf,getTreeBadFields:()=>xf,isValidTree:()=>Pf,sanitizeTree:()=>Df,translateValidation:()=>If,validateAndFixTree:()=>kf,validateRange:()=>zf,validateTree:()=>Ff,validateValue:()=>$f});var s={};p.r(s),p.d(s,{completeFuncValue:()=>Qf,getCompatibleArgsOnFuncChange:()=>nv,setArgValue:()=>tv,setArgValueSrc:()=>rv,setFunc:()=>Xf,setFuncDefaultArg:()=>Zf});var l={};p.r(l),p.d(l,{calculateValueType:()=>lv,completeValue:()=>Av,filterValueSourcesForField:()=>hv,formatFieldName:()=>mv,getFieldPartsConfigs:()=>dv,getFieldPathLabels:()=>cv,getFirstOperator:()=>sv,getFuncPathLabels:()=>uv,getOneChildOrDescendant:()=>Cv,getOperatorsForField:()=>av,getOperatorsForType:()=>iv,getValueLabel:()=>pv,getValueSourcesForFieldOp:()=>gv,getWidgetForFieldOp:()=>yv,getWidgetsForFieldOp:()=>vv,isEmptyGroupChildren:()=>Tv,isEmptyItem:()=>bv,isEmptyRuleGroupExtPropertiesAndChildren:()=>Ov,isEmptyRuleProperties:()=>wv,selectTypes:()=>ov,whatRulePropertiesAreCompleted:()=>Rv});var u={};p.r(u),p.d(u,{_getFromConfigCache:()=>zh,_saveToConfigCache:()=>Hh,_widgetDefKeysToOmit:()=>xh,applyJsonLogic:()=>Mv,cleanJSX:()=>Kl,compileConfig:()=>nh,compressConfig:()=>th,configKeys:()=>Kv,createConfigMemo:()=>bh,decompressConfig:()=>rh,extendConfig:()=>_h,findExtendedConfigInAllMemos:()=>mh,getCommonMemo:()=>yh,getFieldConfig:()=>Qh,getFieldId:()=>Wh,getFieldParts:()=>qh,getFieldPath:()=>$h,getFieldPathParts:()=>Kh,getFieldRawConfig:()=>kh,getFieldSrc:()=>Yh,getFieldWidgetConfig:()=>Jh,getFirstField:()=>Zh,getFuncArgConfig:()=>Bh,getFuncConfig:()=>Uh,getFuncSignature:()=>Vh,getOperatorConfig:()=>Xh,isDirtyJSX:()=>Wl,isFieldDescendantOfField:()=>Gh,isJSX:()=>zl,iterateFields:()=>Fh,iterateFuncs:()=>jh,normalizeField:()=>Mh});var c={};p.r(c),p.d(c,{_mongodbFormat:()=>Ig,_spelFormat:()=>Dc,_sqlFormat:()=>Vg,elasticSearchFormat:()=>Xg,jsonLogicFormat:()=>cg,mongodbFormat:()=>Rg,queryBuilderFormat:()=>rg,queryString:()=>qd,spelFormat:()=>Fc,sqlFormat:()=>Mg});var d={};p.r(d),p.d(d,{fixListValuesGroupOrder:()=>uy,getListValue:()=>Su,listValueToOption:()=>ly,mergeListValues:()=>iy,optionToListValue:()=>ay,optionsToListValues:()=>sy,simulateAsyncFetch:()=>oy});var v={};p.r(v),p.d(v,{Autocomplete:()=>d,ConfigUtils:()=>u,DefaultUtils:()=>i,ExportUtils:()=>n,FuncUtils:()=>s,ListUtils:()=>t,OtherUtils:()=>e,RuleUtils:()=>l,TreeUtils:()=>r,Validation:()=>a,checkTree:()=>jf,clone:()=>xv(),compressConfig:()=>th,decompressConfig:()=>rh,getSwitchValues:()=>xu,i18n:()=>Af,isValidTree:()=>Pf,moment:()=>qu(),sanitizeTree:()=>Df,uuid:()=>Cl,validateAndFixTree:()=>kf,validateTree:()=>Ff});var h={};p.r(h),p.d(h,{LINEAR_REGRESSION:()=>vy,LOWER:()=>py,NOW:()=>cy,RELATIVE_DATETIME:()=>dy,UPPER:()=>fy});var g={};p.r(g),p.d(g,{addCaseGroup:()=>Em,addDefaultCaseGroup:()=>bm,addGroup:()=>Om,addRule:()=>ym,moveItem:()=>Tm,removeGroup:()=>Sm,removeRule:()=>mm,setTree:()=>gm});var y={};p.r(y),p.d(y,{setConjunction:()=>_m,setLock:()=>Rm,setNot:()=>wm});var m={};p.r(m),p.d(m,{setField:()=>Im,setFieldSrc:()=>Am,setFuncValue:()=>Pm,setOperator:()=>Cm,setOperatorOption:()=>xm,setValue:()=>Nm,setValueSrc:()=>Lm});var b={};p.r(b),p.d(b,{bindActionCreators:()=>ub,isUsingLegacyReactDomRender:()=>ib,liteShouldComponentUpdate:()=>ab,pureShouldComponentUpdate:()=>sb,useOnPropsChanged:()=>lb});var E={};p.r(E),p.d(E,{FuncWidget:()=>iO,ValueFieldWidget:()=>sT,VanillaBooleanWidget:()=>lT,VanillaButton:()=>_T,VanillaButtonGroup:()=>RT,VanillaConjs:()=>ST,VanillaDateTimeWidget:()=>vT,VanillaDateWidget:()=>dT,VanillaFieldSelect:()=>OT,VanillaIcon:()=>wT,VanillaMultiSelectWidget:()=>gT,VanillaNumberWidget:()=>bT,VanillaProvider:()=>NT,VanillaSelectWidget:()=>mT,VanillaSliderWidget:()=>ET,VanillaSwitch:()=>AT,VanillaTextAreaWidget:()=>cT,VanillaTextWidget:()=>uT,VanillaTimeWidget:()=>pT,VanillaValueSources:()=>IT,vanillaConfirm:()=>CT});var O={};p.r(O),p.d(O,{ProximityOperator:()=>xT});var S,T=p(7781);!function(e){e.Timeseries="time_series",e.Table="table"}(S||(S={}));const _=[{label:"Time series",value:"time_series"},{label:"Table",value:"table"}],w=null!==T.toOption&&void 0!==T.toOption?T.toOption:e=>({label:e,value:e});var R=p(1269);function I(e){return"function"==typeof e}var A=function(e,t){return A=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},A(e,t)};function C(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}A(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}function N(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function L(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}function P(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))}Object.create,Object.create,"function"==typeof SuppressedError&&SuppressedError;var x,j,F=(x=function(e){return function(t){e(this),this.message=t?t.length+" errors occurred during unsubscription:\n"+t.map((function(e,t){return t+1+") "+e.toString()})).join("\n  "):"",this.name="UnsubscriptionError",this.errors=t}},j=x((function(e){Error.call(e),e.stack=(new Error).stack})),j.prototype=Object.create(Error.prototype),j.prototype.constructor=j,j);function D(e,t){if(e){var r=e.indexOf(t);0<=r&&e.splice(r,1)}}var k=function(){function e(e){this.initialTeardown=e,this.closed=!1,this._parentage=null,this._finalizers=null}var t;return e.prototype.unsubscribe=function(){var e,t,r,n,o;if(!this.closed){this.closed=!0;var i=this._parentage;if(i)if(this._parentage=null,Array.isArray(i))try{for(var a=N(i),s=a.next();!s.done;s=a.next())s.value.remove(this)}catch(t){e={error:t}}finally{try{s&&!s.done&&(t=a.return)&&t.call(a)}finally{if(e)throw e.error}}else i.remove(this);var l=this.initialTeardown;if(I(l))try{l()}catch(e){o=e instanceof F?e.errors:[e]}var u=this._finalizers;if(u){this._finalizers=null;try{for(var c=N(u),d=c.next();!d.done;d=c.next()){var p=d.value;try{M(p)}catch(e){o=null!=o?o:[],e instanceof F?o=P(P([],L(o)),L(e.errors)):o.push(e)}}}catch(e){r={error:e}}finally{try{d&&!d.done&&(n=c.return)&&n.call(c)}finally{if(r)throw r.error}}}if(o)throw new F(o)}},e.prototype.add=function(t){var r;if(t&&t!==this)if(this.closed)M(t);else{if(t instanceof e){if(t.closed||t._hasParent(this))return;t._addParent(this)}(this._finalizers=null!==(r=this._finalizers)&&void 0!==r?r:[]).push(t)}},e.prototype._hasParent=function(e){var t=this._parentage;return t===e||Array.isArray(t)&&t.includes(e)},e.prototype._addParent=function(e){var t=this._parentage;this._parentage=Array.isArray(t)?(t.push(e),t):t?[t,e]:e},e.prototype._removeParent=function(e){var t=this._parentage;t===e?this._parentage=null:Array.isArray(t)&&D(t,e)},e.prototype.remove=function(t){var r=this._finalizers;r&&D(r,t),t instanceof e&&t._removeParent(this)},e.EMPTY=((t=new e).closed=!0,t),e}();function M(e){I(e)?e():e.unsubscribe()}k.EMPTY;var V=null,U=null,B=!1,G=!1,$={setTimeout:function(e,t){for(var r=[],n=2;n<arguments.length;n++)r[n-2]=arguments[n];var o=$.delegate;return(null==o?void 0:o.setTimeout)?o.setTimeout.apply(o,P([e,t],L(r))):setTimeout.apply(void 0,P([e,t],L(r)))},clearTimeout:function(e){var t=$.delegate;return((null==t?void 0:t.clearTimeout)||clearTimeout)(e)},delegate:void 0};function q(){}var K=W("C",void 0,void 0);function W(e,t,r){return{kind:e,value:t,error:r}}var z=function(e){function t(t){var r,n=e.call(this)||this;return n.isStopped=!1,t?(n.destination=t,((r=t)instanceof k||r&&"closed"in r&&I(r.remove)&&I(r.add)&&I(r.unsubscribe))&&t.add(n)):n.destination=ee,n}return C(t,e),t.create=function(e,t,r){return new X(e,t,r)},t.prototype.next=function(e){this.isStopped?Z(function(e){return W("N",e,void 0)}(e),this):this._next(e)},t.prototype.error=function(e){this.isStopped?Z(W("E",void 0,e),this):(this.isStopped=!0,this._error(e))},t.prototype.complete=function(){this.isStopped?Z(K,this):(this.isStopped=!0,this._complete())},t.prototype.unsubscribe=function(){this.closed||(this.isStopped=!0,e.prototype.unsubscribe.call(this),this.destination=null)},t.prototype._next=function(e){this.destination.next(e)},t.prototype._error=function(e){try{this.destination.error(e)}finally{this.unsubscribe()}},t.prototype._complete=function(){try{this.destination.complete()}finally{this.unsubscribe()}},t}(k),H=Function.prototype.bind;function Y(e,t){return H.call(e,t)}var Q=function(){function e(e){this.partialObserver=e}return e.prototype.next=function(e){var t=this.partialObserver;if(t.next)try{t.next(e)}catch(e){J(e)}},e.prototype.error=function(e){var t=this.partialObserver;if(t.error)try{t.error(e)}catch(e){J(e)}else J(e)},e.prototype.complete=function(){var e=this.partialObserver;if(e.complete)try{e.complete()}catch(e){J(e)}},e}(),X=function(e){function t(t,r,n){var o,i,a=e.call(this)||this;return I(t)||!t?o={next:null!=t?t:void 0,error:null!=r?r:void 0,complete:null!=n?n:void 0}:a&&G?((i=Object.create(t)).unsubscribe=function(){return a.unsubscribe()},o={next:t.next&&Y(t.next,i),error:t.error&&Y(t.error,i),complete:t.complete&&Y(t.complete,i)}):o=t,a.destination=new Q(o),a}return C(t,e),t}(z);function J(e){B||function(e){$.setTimeout((function(){if(!V)throw e;V(e)}))}(e)}function Z(e,t){var r=U;r&&$.setTimeout((function(){return r(e,t)}))}var ee={closed:!0,next:q,error:function(e){throw e},complete:q},te=function(e){function t(t,r,n,o,i,a){var s=e.call(this,t)||this;return s.onFinalize=i,s.shouldUnsubscribe=a,s._next=r?function(e){try{r(e)}catch(e){t.error(e)}}:e.prototype._next,s._error=o?function(e){try{o(e)}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._error,s._complete=n?function(){try{n()}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._complete,s}return C(t,e),t.prototype.unsubscribe=function(){var t;if(!this.shouldUnsubscribe||this.shouldUnsubscribe()){var r=this.closed;e.prototype.unsubscribe.call(this),!r&&(null===(t=this.onFinalize)||void 0===t||t.call(this))}},t}(z);function re(e,t){return r=function(r,n){var o=0;r.subscribe(new te(n,(function(r){n.next(e.call(t,r,o++))}),void 0,void 0,void 0))},function(e){if(function(e){return I(null==e?void 0:e.lift)}(e))return e.lift((function(e){try{return r(e,this)}catch(e){this.error(e)}}));throw new TypeError("Unable to lift unknown Observable type")};var r}var ne=(e=>(e[e.Comparison=0]="Comparison",e[e.Logical=1]="Logical",e))(ne||{}),oe=(e=>(e[e.Value=0]="Value",e[e.Filter=1]="Filter",e[e.Group=2]="Group",e[e.Column=3]="Column",e[e.Table=4]="Table",e))(oe||{}),ie=(e=>(e.Parenthesis="delimiter.parenthesis.sql",e.Whitespace="white.sql",e.Keyword="keyword.sql",e.Delimiter="delimiter.sql",e.Operator="operator.sql",e.Identifier="identifier.sql",e.IdentifierQuote="identifier.quote.sql",e.Type="type.sql",e.Function="predefined.sql",e.Number="number.sql",e.String="string.sql",e.Variable="variable.sql",e))(ie||{}),ae=(e=>(e.Unknown="unknown",e.SelectKeyword="selectKeyword",e.WithKeyword="withKeyword",e.AfterSelectKeyword="afterSelectKeyword",e.AfterSelectArguments="afterSelectArguments",e.AfterSelectFuncFirstArgument="afterSelectFuncFirstArgument",e.SelectAlias="selectAlias",e.AfterFromKeyword="afterFromKeyword",e.AfterTable="afterTable",e.SchemaFuncFirstArgument="schemaFuncFirstArgument",e.SchemaFuncExtraArgument="schemaFuncExtraArgument",e.FromKeyword="fromKeyword",e.AfterFrom="afterFrom",e.WhereKeyword="whereKeyword",e.WhereComparisonOperator="whereComparisonOperator",e.WhereValue="whereValue",e.AfterWhereFunctionArgument="afterWhereFunctionArgument",e.AfterGroupByFunctionArgument="afterGroupByFunctionArgument",e.AfterWhereValue="afterWhereValue",e.AfterGroupByKeywords="afterGroupByKeywords",e.AfterGroupBy="afterGroupBy",e.AfterOrderByKeywords="afterOrderByKeywords",e.AfterOrderByFunction="afterOrderByFunction",e.AfterOrderByDirection="afterOrderByDirection",e.AfterIsOperator="afterIsOperator",e.AfterIsNotOperator="afterIsNotOperator",e.AfterSchema="afterSchema",e))(ae||{}),se=(e=>(e.Schemas="schemas",e.Tables="tables",e.Columns="columns",e.SelectKeyword="selectKeyword",e.WithKeyword="withKeyword",e.FunctionsWithArguments="functionsWithArguments",e.FromKeyword="fromKeyword",e.WhereKeyword="whereKeyword",e.GroupByKeywords="groupByKeywords",e.OrderByKeywords="orderByKeywords",e.FunctionsWithoutArguments="functionsWithoutArguments",e.LimitKeyword="limitKeyword",e.SortOrderDirectionKeyword="sortOrderDirectionKeyword",e.ComparisonOperators="comparisonOperators",e.LogicalOperators="logicalOperators",e.SelectMacro="selectMacro",e.TableMacro="tableMacro",e.FilterMacro="filterMacro",e.GroupMacro="groupMacro",e.BoolValues="boolValues",e.NullValue="nullValue",e.NotKeyword="notKeyword",e.TemplateVariables="templateVariables",e.StarWildCard="starWildCard",e))(se||{}),le=(e=>(e.High="a",e.MediumHigh="d",e.Medium="g",e.MediumLow="k",e.Low="q",e))(le||{}),ue=(e=>(e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet",e))(ue||{}),ce=(e=>(e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet",e))(ce||{}),de=(e=>(e.Builder="builder",e.Code="code",e))(de||{}),pe=p(8531),fe=p(3241);class ve{transformMetricFindResponse(e){const t=[],r=e.fields.find((e=>"__text"===e.name)),n=e.fields.find((e=>"__value"===e.name));if(r&&n)for(let e=0;e<r.values.length;e++)t.push({text:""+r.values[e],value:""+n.values[e]});else for(const r of e.fields)for(const e of r.values)t.push({text:e});return(0,fe.uniqBy)(t,"text")}}var he=p(9728),ge=p(5959),ye=p.n(ge),me=p(7016);function be(){var e=(0,ge.useRef)(!1),t=(0,ge.useCallback)((function(){return e.current}),[]);return(0,ge.useEffect)((function(){return e.current=!0,function(){e.current=!1}}),[]),t}function Ee(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var n=(0,ge.useRef)(0),o=be(),i=(0,ge.useState)(r),a=i[0],s=i[1],l=(0,ge.useCallback)((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var i=++n.current;return a.loading||s((function(e){return(0,me.__assign)((0,me.__assign)({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return o()&&i===n.current&&s({value:e,loading:!1}),e}),(function(e){return o()&&i===n.current&&s({error:e,loading:!1}),e}))}),t);return[a,l]}function Oe(e,t){void 0===t&&(t=[]);var r=Ee(e,t,{loading:!0}),n=r[0],o=r[1];return(0,ge.useEffect)((function(){o()}),[o]),n}var Se,Te,_e=p(2007);!function(e){e.String="string"}(Se||(Se={})),function(e){e.Property="property",e.Operator="operator",e.Or="or",e.And="and",e.GroupBy="groupBy",e.Function="function",e.FunctionParameter="functionParameter"}(Te||(Te={}));const we=e=>{if(!e)return!1;const t=e.some((e=>{var t,r;return(null===(t=e.parameters)||void 0===t?void 0:t.length)||(null===(r=e.parameters)||void 0===r?void 0:r.some((e=>e.name)))})),r=e.some((e=>e.name));return t||r};function Re(e){return{type:Te.GroupBy,property:{type:Se.String,name:e}}}function Ie(e){return{type:Te.Function,name:e,parameters:[]}}function Ae(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Ce(e){let t=(null==e?void 0:e.editorMode)||de.Builder;var r;void 0===(null==e?void 0:e.editorMode)&&void 0!==(null==e?void 0:e.rawSql)&&(t=de.Code);const n=(o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Ae(e,t,r[t])}))}return e}({},e),i=null!=(i={refId:(null==e?void 0:e.refId)||"A",format:void 0!==(null==e?void 0:e.format)?e.format:S.Table,rawSql:(null==e?void 0:e.rawSql)||"",editorMode:t,sql:null!==(r=null==e?void 0:e.sql)&&void 0!==r?r:{columns:[Ie()],groupBy:[Re()],limit:50}})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o);var o,i;return n}var Ne=p(4221),Le=p.n(Ne);const Pe=function(){var e=be(),t=function(e){void 0===e&&(e={});var t=(0,ge.useState)(e),r=t[0],n=t[1];return[r,(0,ge.useCallback)((function(e){n((function(t){return Object.assign({},t,e instanceof Function?e(t):e)}))}),[])]}({value:void 0,error:void 0,noUserInteraction:!0}),r=t[0],n=t[1];return[r,(0,ge.useCallback)((function(t){var r,o;if(e())try{if("string"!=typeof t&&"number"!=typeof t){var i=new Error("Cannot copy typeof "+typeof t+" to clipboard, must be a string");return void n({value:t,error:i,noUserInteraction:!0})}if(""===t)return i=new Error("Cannot copy empty string to clipboard."),void n({value:t,error:i,noUserInteraction:!0});o=t.toString(),r=Le()(o),n({value:o,error:void 0,noUserInteraction:r})}catch(i){n({value:o,error:i,noUserInteraction:r})}}),[])]};var xe=p(709);function je(e,t="latest"){return Fe(e,t.replace(/\-.*/,""))}function Fe(e,t){const r={};for(const[n,o]of Object.entries(e))De(o)?r[n]=Fe(o,t):(Me(o,n),r[n]=ke(o,t));return r}function De(e){if("object"==typeof e){const[t]=Object.keys(e);return!(0,xe.valid)(t)}return!1}function ke(e,t){let r,n=Object.keys(e).sort(xe.compare);if("latest"===t)return e[n[n.length-1]];for(const e of n)(0,xe.gte)(t,e)&&(r=e);return r||(r=n[n.length-1]),e[r]}function Me(e,t){if(!Object.keys(e).every((e=>(0,xe.valid)(e))))throw new Error(`Invalid semver version: '${t}'`)}const Ve="8.5.0",Ue={RadioButton:{container:{"10.2.3":"data-testid radio-button"}},Breadcrumbs:{breadcrumb:{"9.4.0":e=>`data-testid ${e} breadcrumb`}},TimePicker:{openButton:{[Ve]:"data-testid TimePicker Open Button"},overlayContent:{"10.2.3":"data-testid TimePicker Overlay Content"},fromField:{"10.2.3":"data-testid Time Range from field",[Ve]:"Time Range from field"},toField:{"10.2.3":"data-testid Time Range to field",[Ve]:"Time Range to field"},applyTimeRange:{[Ve]:"data-testid TimePicker submit button"},copyTimeRange:{"10.4.0":"data-testid TimePicker copy button"},pasteTimeRange:{"10.4.0":"data-testid TimePicker paste button"},calendar:{label:{"10.2.3":"data-testid Time Range calendar",[Ve]:"Time Range calendar"},openButton:{"10.2.3":"data-testid Open time range calendar",[Ve]:"Open time range calendar"},closeButton:{"10.2.3":"data-testid Close time range Calendar",[Ve]:"Close time range Calendar"}},absoluteTimeRangeTitle:{[Ve]:"data-testid-absolute-time-range-narrow"}},DataSourcePermissions:{form:{"9.5.0":()=>'form[name="addPermission"]'},roleType:{"9.5.0":"Role to add new permission to"},rolePicker:{"9.5.0":"Built-in role picker"},permissionLevel:{"9.5.0":"Permission Level"}},DateTimePicker:{input:{"10.2.3":"data-testid date-time-input"}},DataSource:{TestData:{QueryTab:{scenarioSelectContainer:{[Ve]:"Test Data Query scenario select container"},scenarioSelect:{[Ve]:"Test Data Query scenario select"},max:{[Ve]:"TestData max"},min:{[Ve]:"TestData min"},noise:{[Ve]:"TestData noise"},seriesCount:{[Ve]:"TestData series count"},spread:{[Ve]:"TestData spread"},startValue:{[Ve]:"TestData start value"},drop:{[Ve]:"TestData drop values"}}},DataSourceHttpSettings:{urlInput:{"10.4.0":"data-testid Datasource HTTP settings url",[Ve]:"Datasource HTTP settings url"}},Jaeger:{traceIDInput:{[Ve]:"Trace ID"}},Prometheus:{configPage:{connectionSettings:{[Ve]:"Data source connection URL"},manageAlerts:{"10.4.0":"prometheus-alerts-manager"},scrapeInterval:{"10.4.0":"data-testid scrape interval"},queryTimeout:{"10.4.0":"data-testid query timeout"},defaultEditor:{"10.4.0":"data-testid default editor"},disableMetricLookup:{"10.4.0":"disable-metric-lookup"},prometheusType:{"10.4.0":"data-testid prometheus type"},prometheusVersion:{"10.4.0":"data-testid prometheus version"},cacheLevel:{"10.4.0":"data-testid cache level"},incrementalQuerying:{"10.4.0":"prometheus-incremental-querying"},queryOverlapWindow:{"10.4.0":"data-testid query overlap window"},disableRecordingRules:{"10.4.0":"disable-recording-rules"},customQueryParameters:{"10.4.0":"data-testid custom query parameters"},httpMethod:{"10.4.0":"data-testid http method"},exemplarsAddButton:{"10.3.0":"data-testid Add exemplar config button",[Ve]:"Add exemplar config button"},internalLinkSwitch:{"10.3.0":"data-testid Internal link switch",[Ve]:"Internal link switch"},codeModeMetricNamesSuggestionLimit:{"11.1.0":"data-testid code mode metric names suggestion limit"}},queryEditor:{explain:{"10.4.0":"data-testid prometheus explain switch wrapper"},editorToggle:{"10.4.0":"data-testid QueryEditorModeToggle"},options:{"10.4.0":"data-testid prometheus options"},legend:{"10.4.0":"data-testid prometheus legend wrapper"},format:{"10.4.0":"data-testid prometheus format"},step:{"10.4.0":"prometheus-step"},type:{"10.4.0":"data-testid prometheus type"},exemplars:{"10.4.0":"prometheus-exemplars"},builder:{metricSelect:{"10.4.0":"data-testid metric select"},hints:{"10.4.0":"data-testid prometheus hints"},metricsExplorer:{"10.4.0":"data-testid metrics explorer"},queryAdvisor:{"10.4.0":"data-testid query advisor"}},code:{queryField:{"10.4.0":"data-testid prometheus query field"},metricsCountInfo:{"11.1.0":"data-testid metrics count disclaimer"},metricsBrowser:{openButton:{"10.4.0":"data-testid open metrics browser"},selectMetric:{"10.4.0":"data-testid select a metric"},seriesLimit:{"10.3.1":"data-testid series limit"},metricList:{"10.4.0":"data-testid metric list"},labelNamesFilter:{"10.4.0":"data-testid label names filter"},labelValuesFilter:{"10.4.0":"data-testid label values filter"},useQuery:{"10.4.0":"data-testid use query"},useAsRateQuery:{"10.4.0":"data-testid use as rate query"},validateSelector:{"10.4.0":"data-testid validate selector"},clear:{"10.4.0":"data-testid clear"}}}},exemplarMarker:{"10.3.0":"data-testid Exemplar marker",[Ve]:"Exemplar marker"},variableQueryEditor:{queryType:{"10.4.0":"data-testid query type"},labelnames:{metricRegex:{"10.4.0":"data-testid label names metric regex"}},labelValues:{labelSelect:{"10.4.0":"data-testid label values label select"}},metricNames:{metricRegex:{"10.4.0":"data-testid metric names metric regex"}},varQueryResult:{"10.4.0":"data-testid variable query result"},seriesQuery:{"10.4.0":"data-testid prometheus series query"},classicQuery:{"10.4.0":"data-testid prometheus classic query"}},annotations:{minStep:{"10.4.0":"prometheus-annotation-min-step"},title:{"10.4.0":"data-testid prometheus annotation title"},tags:{"10.4.0":"data-testid prometheus annotation tags"},text:{"10.4.0":"data-testid prometheus annotation text"},seriesValueAsTimestamp:{"10.4.0":"data-testid prometheus annotation series value as timestamp"}}}},Menu:{MenuComponent:{[Ve]:e=>`${e} menu`},MenuGroup:{[Ve]:e=>`${e} menu group`},MenuItem:{[Ve]:e=>`${e} menu item`},SubMenu:{container:{"10.3.0":"data-testid SubMenu container",[Ve]:"SubMenu container"},icon:{"10.3.0":"data-testid SubMenu icon",[Ve]:"SubMenu icon"}}},Panels:{Panel:{title:{[Ve]:e=>`data-testid Panel header ${e}`},content:{"11.1.0":"data-testid panel content"},headerItems:{"10.2.0":e=>`data-testid Panel header item ${e}`},menuItems:{"9.5.0":e=>`data-testid Panel menu item ${e}`},menu:{"9.5.0":e=>`data-testid Panel menu ${e}`},containerByTitle:{[Ve]:e=>`${e} panel`},headerCornerInfo:{[Ve]:e=>`Panel header ${e}`},status:{"10.2.0":e=>`data-testid Panel status ${e}`,[Ve]:e=>"Panel status"},loadingBar:{"10.0.0":()=>"Panel loading bar"},HoverWidget:{container:{"10.1.0":"data-testid hover-header-container",[Ve]:"hover-header-container"},dragIcon:{"10.0.0":"data-testid drag-icon"}},PanelDataErrorMessage:{"10.4.0":"data-testid Panel data error message"}},Visualization:{Graph:{container:{"9.5.0":"Graph container"},VisualizationTab:{legendSection:{[Ve]:"Legend section"}},Legend:{legendItemAlias:{[Ve]:e=>`gpl alias ${e}`},showLegendSwitch:{[Ve]:"gpl show legend"}},xAxis:{labels:{[Ve]:()=>"div.flot-x-axis > div.flot-tick-label"}}},BarGauge:{valueV2:{[Ve]:"data-testid Bar gauge value"}},PieChart:{svgSlice:{"10.3.0":"data testid Pie Chart Slice"}},Text:{container:{[Ve]:()=>".markdown-html"}},Table:{header:{[Ve]:"table header"},footer:{[Ve]:"table-footer"},body:{"10.2.0":"data-testid table body"}}}},VizLegend:{seriesName:{"10.3.0":e=>`data-testid VizLegend series ${e}`}},Drawer:{General:{title:{[Ve]:e=>`Drawer title ${e}`},expand:{[Ve]:"Drawer expand"},contract:{[Ve]:"Drawer contract"},close:{"10.3.0":"data-testid Drawer close",[Ve]:"Drawer close"},rcContentWrapper:{"9.4.0":()=>".rc-drawer-content-wrapper"},subtitle:{"10.4.0":"data-testid drawer subtitle"}},DashboardSaveDrawer:{saveButton:{"11.1.0":"data-testid Save dashboard drawer button"},saveAsButton:{"11.1.0":"data-testid Save as dashboard drawer button"},saveAsTitleInput:{"11.1.0":"Save dashboard title field"}}},PanelEditor:{General:{content:{"11.1.0":"data-testid Panel editor content",[Ve]:"Panel editor content"}},OptionsPane:{content:{"11.1.0":"data-testid Panel editor option pane content",[Ve]:"Panel editor option pane content"},select:{[Ve]:"Panel editor option pane select"},fieldLabel:{[Ve]:e=>`${e} field property editor`},fieldInput:{"11.0.0":e=>`data-testid Panel editor option pane field input ${e}`}},DataPane:{content:{"11.1.0":"data-testid Panel editor data pane content",[Ve]:"Panel editor data pane content"}},applyButton:{"9.2.0":"data-testid Apply changes and go back to dashboard"},toggleVizPicker:{"10.0.0":"data-testid toggle-viz-picker",[Ve]:"toggle-viz-picker"},toggleVizOptions:{"10.1.0":"data-testid toggle-viz-options",[Ve]:"toggle-viz-options"},toggleTableView:{"11.1.0":"data-testid toggle-table-view",[Ve]:"toggle-table-view"},showZoomField:{"10.2.0":"Map controls Show zoom control field property editor"},showAttributionField:{"10.2.0":"Map controls Show attribution field property editor"},showScaleField:{"10.2.0":"Map controls Show scale field property editor"},showMeasureField:{"10.2.0":"Map controls Show measure tools field property editor"},showDebugField:{"10.2.0":"Map controls Show debug field property editor"},measureButton:{"9.2.0":"show measure tools"}},PanelInspector:{Data:{content:{[Ve]:"Panel inspector Data content"}},Stats:{content:{[Ve]:"Panel inspector Stats content"}},Json:{content:{"11.1.0":"data-testid Panel inspector Json content",[Ve]:"Panel inspector Json content"}},Query:{content:{[Ve]:"Panel inspector Query content"},refreshButton:{[Ve]:"Panel inspector Query refresh button"},jsonObjectKeys:{[Ve]:()=>".json-formatter-key"}}},Tab:{title:{"11.2.0":e=>`data-testid Tab ${e}`},active:{[Ve]:()=>'[class*="-activeTabStyle"]'}},RefreshPicker:{runButtonV2:{[Ve]:"data-testid RefreshPicker run button"},intervalButtonV2:{[Ve]:"data-testid RefreshPicker interval button"}},QueryTab:{content:{[Ve]:"Query editor tab content"},queryInspectorButton:{[Ve]:"Query inspector button"},queryHistoryButton:{"10.2.0":"data-testid query-history-button",[Ve]:"query-history-button"},addQuery:{"10.2.0":"data-testid query-tab-add-query",[Ve]:"Query editor add query button"},queryGroupTopSection:{"11.2.0":"data-testid query group top section"},addExpression:{"11.2.0":"data-testid query-tab-add-expression"}},QueryHistory:{queryText:{"9.0.0":"Query text"}},QueryEditorRows:{rows:{[Ve]:"Query editor row"}},QueryEditorRow:{actionButton:{"10.4.0":e=>`data-testid ${e}`},title:{[Ve]:e=>`Query editor row title ${e}`},container:{[Ve]:e=>`Query editor row ${e}`}},AlertTab:{content:{"10.2.3":"data-testid Alert editor tab content",[Ve]:"Alert editor tab content"}},AlertRules:{groupToggle:{"11.0.0":"data-testid group-collapse-toggle"},toggle:{"11.0.0":"data-testid collapse-toggle"},expandedContent:{"11.0.0":"data-testid expanded-content"},previewButton:{"11.1.0":"data-testid alert-rule preview-button"},ruleNameField:{"11.1.0":"data-testid alert-rule name-field"},newFolderButton:{"11.1.0":"data-testid alert-rule new-folder-button"},newFolderNameField:{"11.1.0":"data-testid alert-rule name-folder-name-field"},newFolderNameCreateButton:{"11.1.0":"data-testid alert-rule name-folder-name-create-button"},newEvaluationGroupButton:{"11.1.0":"data-testid alert-rule new-evaluation-group-button"},newEvaluationGroupName:{"11.1.0":"data-testid alert-rule new-evaluation-group-name"},newEvaluationGroupInterval:{"11.1.0":"data-testid alert-rule new-evaluation-group-interval"},newEvaluationGroupCreate:{"11.1.0":"data-testid alert-rule new-evaluation-group-create-button"}},Alert:{alertV2:{[Ve]:e=>`data-testid Alert ${e}`}},TransformTab:{content:{"10.1.0":"data-testid Transform editor tab content",[Ve]:"Transform editor tab content"},newTransform:{"10.1.0":e=>`data-testid New transform ${e}`},transformationEditor:{"10.1.0":e=>`data-testid Transformation editor ${e}`},transformationEditorDebugger:{"10.1.0":e=>`data-testid Transformation editor debugger ${e}`}},Transforms:{card:{"10.1.0":e=>`data-testid New transform ${e}`},disableTransformationButton:{"10.4.0":"data-testid Disable transformation button"},Reduce:{modeLabel:{"10.2.3":"data-testid Transform mode label",[Ve]:"Transform mode label"},calculationsLabel:{"10.2.3":"data-testid Transform calculations label",[Ve]:"Transform calculations label"}},SpatialOperations:{actionLabel:{"9.1.2":"root Action field property editor"},locationLabel:{"10.2.0":"root Location Mode field property editor"},location:{autoOption:{"9.1.2":"Auto location option"},coords:{option:{"9.1.2":"Coords location option"},latitudeFieldLabel:{"9.1.2":"root Latitude field field property editor"},longitudeFieldLabel:{"9.1.2":"root Longitude field field property editor"}},geohash:{option:{"9.1.2":"Geohash location option"},geohashFieldLabel:{"9.1.2":"root Geohash field field property editor"}},lookup:{option:{"9.1.2":"Lookup location option"},lookupFieldLabel:{"9.1.2":"root Lookup field field property editor"},gazetteerFieldLabel:{"9.1.2":"root Gazetteer field property editor"}}}},searchInput:{"10.2.3":"data-testid search transformations",[Ve]:"search transformations"},noTransformationsMessage:{"10.2.3":"data-testid no transformations message"},addTransformationButton:{"10.1.0":"data-testid add transformation button",[Ve]:"add transformation button"},removeAllTransformationsButton:{"10.4.0":"data-testid remove all transformations button"}},NavBar:{Configuration:{button:{"9.5.0":"Configuration"}},Toggle:{button:{"10.2.3":"data-testid Toggle menu",[Ve]:"Toggle menu"}},Reporting:{button:{"9.5.0":"Reporting"}}},NavMenu:{Menu:{"10.2.3":"data-testid navigation mega-menu"},item:{"9.5.0":"data-testid Nav menu item"}},NavToolbar:{container:{"9.4.0":"data-testid Nav toolbar"},commandPaletteTrigger:{"11.4.0":"data-testid Command palette trigger"},shareDashboard:{"11.1.0":"data-testid Share dashboard"},markAsFavorite:{"11.1.0":"data-testid Mark as favorite"},editDashboard:{editButton:{"11.1.0":"data-testid Edit dashboard button"},saveButton:{"11.1.0":"data-testid Save dashboard button"},exitButton:{"11.1.0":"data-testid Exit edit mode button"},settingsButton:{"11.1.0":"data-testid Dashboard settings"},addRowButton:{"11.1.0":"data-testid Add row button"},addLibraryPanelButton:{"11.1.0":"data-testid Add a panel from the panel library button"},addVisualizationButton:{"11.1.0":"data-testid Add new visualization menu item"},pastePanelButton:{"11.1.0":"data-testid Paste panel button"},discardChangesButton:{"11.1.0":"data-testid Discard changes button"},discardLibraryPanelButton:{"11.1.0":"data-testid Discard library panel button"},unlinkLibraryPanelButton:{"11.1.0":"data-testid Unlink library panel button"},saveLibraryPanelButton:{"11.1.0":"data-testid Save library panel button"},backToDashboardButton:{"11.1.0":"data-testid Back to dashboard button"}}},PageToolbar:{container:{[Ve]:()=>".page-toolbar"},item:{[Ve]:e=>`${e}`},itemButton:{"9.5.0":e=>`data-testid ${e}`}},QueryEditorToolbarItem:{button:{[Ve]:e=>`QueryEditor toolbar item button ${e}`}},BackButton:{backArrow:{"10.3.0":"data-testid Go Back",[Ve]:"Go Back"}},OptionsGroup:{group:{"11.1.0":e=>e?`data-testid Options group ${e}`:"data-testid Options group",[Ve]:e=>e?`Options group ${e}`:"Options group"},toggle:{"11.1.0":e=>e?`data-testid Options group ${e} toggle`:"data-testid Options group toggle",[Ve]:e=>e?`Options group ${e} toggle`:"Options group toggle"}},PluginVisualization:{item:{[Ve]:e=>`Plugin visualization item ${e}`},current:{[Ve]:()=>'[class*="-currentVisualizationItem"]'}},Select:{option:{"11.1.0":"data-testid Select option",[Ve]:"Select option"},toggleAllOptions:{"11.3.0":"data-testid toggle all options"},input:{[Ve]:()=>'input[id*="time-options-input"]'},singleValue:{[Ve]:()=>'div[class*="-singleValue"]'}},FieldConfigEditor:{content:{[Ve]:"Field config editor content"}},OverridesConfigEditor:{content:{[Ve]:"Field overrides editor content"}},FolderPicker:{containerV2:{[Ve]:"data-testid Folder picker select container"},input:{"10.4.0":"data-testid folder-picker-input"}},ReadonlyFolderPicker:{container:{[Ve]:"data-testid Readonly folder picker select container"}},DataSourcePicker:{container:{"10.0.0":"data-testid Data source picker select container",[Ve]:"Data source picker select container"},inputV2:{"10.1.0":"data-testid Select a data source",[Ve]:"Select a data source"},dataSourceList:{"10.4.0":"data-testid Data source list dropdown"},advancedModal:{dataSourceList:{"10.4.0":"data-testid Data source list"},builtInDataSourceList:{"10.4.0":"data-testid Built in data source list"}}},TimeZonePicker:{containerV2:{[Ve]:"data-testid Time zone picker select container"},changeTimeSettingsButton:{"11.0.0":"data-testid Time zone picker Change time settings button"}},WeekStartPicker:{containerV2:{[Ve]:"data-testid Choose starting day of the week"},placeholder:{[Ve]:"Choose starting day of the week"}},TraceViewer:{spanBar:{"9.0.0":"data-testid SpanBar--wrapper"}},QueryField:{container:{"10.3.0":"data-testid Query field",[Ve]:"Query field"}},QueryBuilder:{queryPatterns:{"10.3.0":"data-testid Query patterns",[Ve]:"Query patterns"},labelSelect:{"10.3.0":"data-testid Select label",[Ve]:"Select label"},inputSelect:{"11.1.0":"data-testid Select label-input"},valueSelect:{"10.3.0":"data-testid Select value",[Ve]:"Select value"},matchOperatorSelect:{"10.3.0":"data-testid Select match operator",[Ve]:"Select match operator"}},ValuePicker:{button:{"10.3.0":e=>`data-testid Value picker button ${e}`},select:{"10.3.0":e=>`data-testid Value picker select ${e}`}},Search:{sectionV2:{[Ve]:"data-testid Search section"},itemsV2:{[Ve]:"data-testid Search items"},cards:{[Ve]:"data-testid Search cards"},collapseFolder:{[Ve]:e=>`data-testid Collapse folder ${e}`},expandFolder:{[Ve]:e=>`data-testid Expand folder ${e}`},dashboardItem:{[Ve]:e=>`data-testid Dashboard search item ${e}`},dashboardCard:{[Ve]:e=>`data-testid Search card ${e}`},folderHeader:{"9.3.0":e=>`data-testid Folder header ${e}`},folderContent:{"9.3.0":e=>`data-testid Folder content ${e}`},dashboardItems:{[Ve]:"data-testid Dashboard search item"}},DashboardLinks:{container:{[Ve]:"data-testid Dashboard link container"},dropDown:{[Ve]:"data-testid Dashboard link dropdown"},link:{[Ve]:"data-testid Dashboard link"}},LoadingIndicator:{icon:{"10.4.0":"data-testid Loading indicator",[Ve]:"Loading indicator"}},CallToActionCard:{buttonV2:{[Ve]:e=>`data-testid Call to action button ${e}`}},DataLinksContextMenu:{singleLink:{"10.3.0":"data-testid Data link",[Ve]:"Data link"}},CodeEditor:{container:{"10.2.3":"data-testid Code editor container",[Ve]:"Code editor container"}},ReactMonacoEditor:{editorLazy:{"11.1.0":"data-testid ReactMonacoEditor editorLazy"}},DashboardImportPage:{textarea:{[Ve]:"data-testid-import-dashboard-textarea"},submit:{[Ve]:"data-testid-load-dashboard"}},ImportDashboardForm:{name:{[Ve]:"data-testid-import-dashboard-title"},submit:{[Ve]:"data-testid-import-dashboard-submit"}},PanelAlertTabContent:{content:{"10.2.3":"data-testid Unified alert editor tab content",[Ve]:"Unified alert editor tab content"}},VisualizationPreview:{card:{[Ve]:e=>`data-testid suggestion-${e}`}},ColorSwatch:{name:{[Ve]:"data-testid-colorswatch"}},DashboardRow:{title:{[Ve]:e=>`data-testid dashboard-row-title-${e}`}},UserProfile:{profileSaveButton:{[Ve]:"data-testid-user-profile-save"},preferencesSaveButton:{[Ve]:"data-testid-shared-prefs-save"},orgsTable:{[Ve]:"data-testid-user-orgs-table"},sessionsTable:{[Ve]:"data-testid-user-sessions-table"},extensionPointTabs:{"10.2.3":"data-testid-extension-point-tabs"},extensionPointTab:{"10.2.3":e=>`data-testid-extension-point-tab-${e}`}},FileUpload:{inputField:{"9.0.0":"data-testid-file-upload-input-field"},fileNameSpan:{"9.0.0":"data-testid-file-upload-file-name"}},DebugOverlay:{wrapper:{"9.2.0":"debug-overlay"}},OrgRolePicker:{input:{"9.5.0":"Role"}},AnalyticsToolbarButton:{button:{"9.5.0":"Dashboard insights"}},Variables:{variableOption:{"9.5.0":"data-testid variable-option"},variableLinkWrapper:{"11.1.1":"data-testid variable-link-wrapper"}},Annotations:{annotationsTypeInput:{"11.1.0":"data-testid annotations-type-input",[Ve]:"annotations-type-input"},annotationsChoosePanelInput:{"11.1.0":"data-testid choose-panels-input",[Ve]:"choose-panels-input"},editor:{testButton:{"11.0.0":"data-testid annotations-test-button"},resultContainer:{"11.0.0":"data-testid annotations-query-result-container"}}},Tooltip:{container:{"10.2.0":"data-testid tooltip"}},ReturnToPrevious:{buttonGroup:{"11.0.0":"data-testid dismissable button group"},backButton:{"11.0.0":"data-testid back"},dismissButton:{"11.0.0":"data-testid dismiss"}},SQLQueryEditor:{selectColumn:{"11.0.0":"data-testid select-column"},selectAggregation:{"11.0.0":"data-testid select-aggregation"},selectAlias:{"11.0.0":"data-testid select-alias"},filterConjunction:{"11.0.0":"data-testid filter-conjunction"},filterField:{"11.0.0":"data-testid filter-field"},filterOperator:{"11.0.0":"data-testid filter-operator"},headerTableSelector:{"11.0.0":"data-testid header-table-selector"},headerFilterSwitch:{"11.0.0":"data-testid header-filter-switch"},headerGroupSwitch:{"11.0.0":"data-testid header-group-switch"},headerOrderSwitch:{"11.0.0":"data-testid header-order-switch"},headerPreviewSwitch:{"11.0.0":"data-testid header-preview-switch"}},EntityNotFound:{container:{"11.2.0":"data-testid entity-not-found"}}},Be={pages:je({Alerting:{AddAlertRule:{url:{"10.1.0":"/alerting/new/alerting",[Ve]:"/alerting/new"}},EditAlertRule:{url:{[Ve]:e=>`alerting/${e}/edit`}}},Login:{url:{[Ve]:"/login"},username:{"10.2.3":"data-testid Username input field",[Ve]:"Username input field"},password:{"10.2.3":"data-testid Password input field",[Ve]:"Password input field"},submit:{"10.2.3":"data-testid Login button",[Ve]:"Login button"},skip:{"10.2.3":"data-testid Skip change password button"}},Home:{url:{[Ve]:"/"}},DataSource:{name:{"10.3.0":"data-testid Data source settings page name input field",[Ve]:"Data source settings page name input field"},delete:{[Ve]:"Data source settings page Delete button"},readOnly:{"10.3.0":"data-testid Data source settings page read only message",[Ve]:"Data source settings page read only message"},saveAndTest:{"10.0.0":"data-testid Data source settings page Save and Test button",[Ve]:"Data source settings page Save and Test button"},alert:{"10.3.0":"data-testid Data source settings page Alert",[Ve]:"Data source settings page Alert"}},DataSources:{url:{[Ve]:"/datasources"},dataSources:{[Ve]:e=>`Data source list item ${e}`}},EditDataSource:{url:{"9.5.0":e=>`/datasources/edit/${e}`},settings:{"9.5.0":"Datasource settings page basic settings"}},AddDataSource:{url:{[Ve]:"/datasources/new"},dataSourcePluginsV2:{"9.3.1":e=>`Add new data source ${e}`,[Ve]:e=>`Data source plugin item ${e}`}},ConfirmModal:{delete:{"10.0.0":"data-testid Confirm Modal Danger Button",[Ve]:"Confirm Modal Danger Button"}},AddDashboard:{url:{[Ve]:"/dashboard/new"},itemButton:{"9.5.0":e=>`data-testid ${e}`},addNewPanel:{"11.1.0":"data-testid Add new panel",[Ve]:"Add new panel"},itemButtonAddViz:{[Ve]:"Add new visualization menu item"},addNewRow:{"11.1.0":"data-testid Add new row",[Ve]:"Add new row"},addNewPanelLibrary:{"11.1.0":"data-testid Add new panel from panel library",[Ve]:"Add new panel from panel library"},Settings:{Annotations:{List:{url:{[Ve]:"/dashboard/new?orgId=1&editview=annotations"}},Edit:{url:{[Ve]:e=>`/dashboard/new?editview=annotations&editIndex=${e}`}}},Variables:{List:{url:{"11.3.0":"/dashboard/new?orgId=1&editview=variables",[Ve]:"/dashboard/new?orgId=1&editview=templating"}},Edit:{url:{[Ve]:e=>`/dashboard/new?orgId=1&editview=templating&editIndex=${e}`}}}}},Dashboard:{url:{[Ve]:e=>`/d/${e}`},DashNav:{nav:{[Ve]:"Dashboard navigation"},navV2:{[Ve]:"data-testid Dashboard navigation"},publicDashboardTag:{"9.1.0":"data-testid public dashboard tag"},shareButton:{"10.4.0":"data-testid share-button"},scrollContainer:{"11.1.0":"data-testid Dashboard canvas scroll container"},newShareButton:{container:{"11.1.0":"data-testid new share button"},shareLink:{"11.1.0":"data-testid new share link-button"},arrowMenu:{"11.1.0":"data-testid new share button arrow menu"},menu:{container:{"11.1.0":"data-testid new share button menu"},shareInternally:{"11.1.0":"data-testid new share button share internally"},shareExternally:{"11.1.1":"data-testid new share button share externally"},shareSnapshot:{"11.2.0":"data-testid new share button share snapshot"}}},NewExportButton:{container:{"11.2.0":"data-testid new export button"},arrowMenu:{"11.2.0":"data-testid new export button arrow menu"},Menu:{container:{"11.2.0":"data-testid new export button menu"},exportAsJson:{"11.2.0":"data-testid new export button export as json"}}},playlistControls:{prev:{"11.0.0":"data-testid playlist previous dashboard button"},stop:{"11.0.0":"data-testid playlist stop dashboard button"},next:{"11.0.0":"data-testid playlist next dashboard button"}}},Controls:{"11.1.0":"data-testid dashboard controls"},SubMenu:{submenu:{[Ve]:"Dashboard submenu"},submenuItem:{[Ve]:"data-testid template variable"},submenuItemLabels:{[Ve]:e=>`data-testid Dashboard template variables submenu Label ${e}`},submenuItemValueDropDownValueLinkTexts:{[Ve]:e=>`data-testid Dashboard template variables Variable Value DropDown value link text ${e}`},submenuItemValueDropDownDropDown:{[Ve]:"Variable options"},submenuItemValueDropDownOptionTexts:{[Ve]:e=>`data-testid Dashboard template variables Variable Value DropDown option text ${e}`},Annotations:{annotationsWrapper:{"10.0.0":"data-testid annotation-wrapper"},annotationLabel:{"10.0.0":e=>`data-testid Dashboard annotations submenu Label ${e}`},annotationToggle:{"10.0.0":e=>`data-testid Dashboard annotations submenu Toggle ${e}`}}},Settings:{Actions:{close:{"9.5.0":"data-testid dashboard-settings-close"}},General:{deleteDashBoard:{"11.1.0":"data-testid Dashboard settings page delete dashboard button"},sectionItems:{[Ve]:e=>`Dashboard settings section item ${e}`},saveDashBoard:{[Ve]:"Dashboard settings aside actions Save button"},saveAsDashBoard:{[Ve]:"Dashboard settings aside actions Save As button"},title:{"11.2.0":"General"}},Annotations:{Edit:{urlParams:{[Ve]:e=>`editview=annotations&editIndex=${e}`}},List:{url:{[Ve]:e=>`/d/${e}?editview=annotations`},addAnnotationCTAV2:{[Ve]:"data-testid Call to action button Add annotation query"},annotations:{"10.4.0":"data-testid list-annotations"}},Settings:{name:{"11.1.0":"data-testid Annotations settings name input",[Ve]:"Annotations settings name input"}},NewAnnotation:{panelFilterSelect:{"10.0.0":"data-testid annotations-panel-filter"},showInLabel:{"11.1.0":"data-testid show-in-label"},previewInDashboard:{"10.0.0":"data-testid annotations-preview"},delete:{"10.4.0":"data-testid annotations-delete"},apply:{"10.4.0":"data-testid annotations-apply"},enable:{"10.4.0":"data-testid annotation-enable"},hide:{"10.4.0":"data-testid annotation-hide"}}},Variables:{List:{url:{[Ve]:e=>`/d/${e}?editview=templating`},addVariableCTAV2:{[Ve]:"data-testid Call to action button Add variable"},newButton:{[Ve]:"Variable editor New variable button"},table:{[Ve]:"Variable editor Table"},tableRowNameFields:{[Ve]:e=>`Variable editor Table Name field ${e}`},tableRowDefinitionFields:{"10.1.0":e=>`Variable editor Table Definition field ${e}`},tableRowArrowUpButtons:{[Ve]:e=>`Variable editor Table ArrowUp button ${e}`},tableRowArrowDownButtons:{[Ve]:e=>`Variable editor Table ArrowDown button ${e}`},tableRowDuplicateButtons:{[Ve]:e=>`Variable editor Table Duplicate button ${e}`},tableRowRemoveButtons:{[Ve]:e=>`Variable editor Table Remove button ${e}`}},Edit:{urlParams:{[Ve]:e=>`editview=templating&editIndex=${e}`},General:{headerLink:{[Ve]:"Variable editor Header link"},modeLabelNew:{[Ve]:"Variable editor Header mode New"},modeLabelEdit:{[Ve]:"Variable editor Header mode Edit"},generalNameInput:{[Ve]:"Variable editor Form Name field"},generalNameInputV2:{[Ve]:"data-testid Variable editor Form Name field"},generalTypeSelect:{[Ve]:"Variable editor Form Type select"},generalTypeSelectV2:{[Ve]:"data-testid Variable editor Form Type select"},generalLabelInput:{[Ve]:"Variable editor Form Label field"},generalLabelInputV2:{[Ve]:"data-testid Variable editor Form Label field"},generalHideSelect:{[Ve]:"Variable editor Form Hide select"},generalHideSelectV2:{[Ve]:"data-testid Variable editor Form Hide select"},selectionOptionsMultiSwitch:{"10.4.0":"data-testid Variable editor Form Multi switch",[Ve]:"Variable editor Form Multi switch"},selectionOptionsIncludeAllSwitch:{"10.4.0":"data-testid Variable editor Form IncludeAll switch",[Ve]:"Variable editor Form IncludeAll switch"},selectionOptionsCustomAllInput:{"10.4.0":"data-testid Variable editor Form IncludeAll field",[Ve]:"Variable editor Form IncludeAll field"},previewOfValuesOption:{"10.4.0":"data-testid Variable editor Preview of Values option",[Ve]:"Variable editor Preview of Values option"},submitButton:{"10.4.0":"data-testid Variable editor Run Query button",[Ve]:"Variable editor Submit button"},applyButton:{"9.3.0":"data-testid Variable editor Apply button"}},QueryVariable:{queryOptionsDataSourceSelect:{"10.4.0":"data-testid Select a data source","10.0.0":"data-testid Data source picker select container",[Ve]:"Data source picker select container"},queryOptionsRefreshSelect:{[Ve]:"Variable editor Form Query Refresh select"},queryOptionsRefreshSelectV2:{[Ve]:"data-testid Variable editor Form Query Refresh select"},queryOptionsRegExInput:{[Ve]:"Variable editor Form Query RegEx field"},queryOptionsRegExInputV2:{[Ve]:"data-testid Variable editor Form Query RegEx field"},queryOptionsSortSelect:{[Ve]:"Variable editor Form Query Sort select"},queryOptionsSortSelectV2:{[Ve]:"data-testid Variable editor Form Query Sort select"},queryOptionsQueryInput:{"10.4.0":"data-testid Variable editor Form Default Variable Query Editor textarea"},valueGroupsTagsEnabledSwitch:{[Ve]:"Variable editor Form Query UseTags switch"},valueGroupsTagsTagsQueryInput:{[Ve]:"Variable editor Form Query TagsQuery field"},valueGroupsTagsTagsValuesQueryInput:{[Ve]:"Variable editor Form Query TagsValuesQuery field"}},ConstantVariable:{constantOptionsQueryInput:{[Ve]:"Variable editor Form Constant Query field"},constantOptionsQueryInputV2:{[Ve]:"data-testid Variable editor Form Constant Query field"}},DatasourceVariable:{datasourceSelect:{[Ve]:"data-testid datasource variable datasource type"}},TextBoxVariable:{textBoxOptionsQueryInput:{[Ve]:"Variable editor Form TextBox Query field"},textBoxOptionsQueryInputV2:{[Ve]:"data-testid Variable editor Form TextBox Query field"}},CustomVariable:{customValueInput:{[Ve]:"data-testid custom-variable-input"}},IntervalVariable:{intervalsValueInput:{[Ve]:"data-testid interval variable intervals input"},autoEnabledCheckbox:{"10.4.0":"data-testid interval variable auto value checkbox"},stepCountIntervalSelect:{"10.4.0":"data-testid interval variable step count input"},minIntervalInput:{"10.4.0":"data-testid interval variable mininum interval input"}},GroupByVariable:{dataSourceSelect:{"10.4.0":"data-testid Select a data source"},infoText:{"10.4.0":"data-testid group by variable info text"},modeToggle:{"10.4.0":"data-testid group by variable mode toggle"}},AdHocFiltersVariable:{datasourceSelect:{"10.4.0":"data-testid Select a data source"},infoText:{"10.4.0":"data-testid ad-hoc filters variable info text"},modeToggle:{"11.0.0":"data-testid ad-hoc filters variable mode toggle"}}}}},Annotations:{marker:{"10.0.0":"data-testid annotation-marker"}},Rows:{Repeated:{ConfigSection:{warningMessage:{"10.2.0":"data-testid Repeated rows warning message"}}}}},Dashboards:{url:{[Ve]:"/dashboards"},dashboards:{"10.2.0":e=>`Dashboard search item ${e}`}},SaveDashboardAsModal:{newName:{"10.2.0":"Save dashboard title field"},save:{"10.2.0":"Save dashboard button"}},SaveDashboardModal:{save:{"10.2.0":"Dashboard settings Save Dashboard Modal Save button"},saveVariables:{"10.2.0":"Dashboard settings Save Dashboard Modal Save variables checkbox"},saveTimerange:{"10.2.0":"Dashboard settings Save Dashboard Modal Save timerange checkbox"},saveRefresh:{"11.1.0":"Dashboard settings Save Dashboard Modal Save refresh checkbox"}},SharePanelModal:{linkToRenderedImage:{[Ve]:"Link to rendered image"}},ShareDashboardModal:{PublicDashboard:{WillBePublicCheckbox:{"9.1.0":"data-testid public dashboard will be public checkbox"},LimitedDSCheckbox:{"9.1.0":"data-testid public dashboard limited datasources checkbox"},CostIncreaseCheckbox:{"9.1.0":"data-testid public dashboard cost may increase checkbox"},PauseSwitch:{"9.5.0":"data-testid public dashboard pause switch"},EnableAnnotationsSwitch:{"9.3.0":"data-testid public dashboard on off switch for annotations"},CreateButton:{"9.5.0":"data-testid public dashboard create button"},DeleteButton:{"9.3.0":"data-testid public dashboard delete button"},CopyUrlInput:{"9.1.0":"data-testid public dashboard copy url input"},CopyUrlButton:{"9.1.0":"data-testid public dashboard copy url button"},SettingsDropdown:{"10.1.0":"data-testid public dashboard settings dropdown"},TemplateVariablesWarningAlert:{"9.1.0":"data-testid public dashboard disabled template variables alert"},UnsupportedDataSourcesWarningAlert:{"9.5.0":"data-testid public dashboard unsupported data sources alert"},NoUpsertPermissionsWarningAlert:{"9.5.0":"data-testid public dashboard no upsert permissions alert"},EnableTimeRangeSwitch:{"9.4.0":"data-testid public dashboard on off switch for time range"},EmailSharingConfiguration:{Container:{"9.5.0":"data-testid email sharing config container"},ShareType:{"9.5.0":"data-testid public dashboard share type"},EmailSharingInput:{"9.5.0":"data-testid public dashboard email sharing input"},EmailSharingInviteButton:{"9.5.0":"data-testid public dashboard email sharing invite button"},EmailSharingList:{"9.5.0":"data-testid public dashboard email sharing list"},DeleteEmail:{"9.5.0":"data-testid public dashboard delete email button"},ReshareLink:{"9.5.0":"data-testid public dashboard reshare link button"}}},SnapshotScene:{url:{"11.1.0":e=>`/dashboard/snapshot/${e}`},PublishSnapshot:{"11.1.0":"data-testid publish snapshot button"},CopyUrlButton:{"11.1.0":"data-testid snapshot copy url button"},CopyUrlInput:{"11.1.0":"data-testid snapshot copy url input"}}},ShareDashboardDrawer:{ShareInternally:{container:{"11.3.0":"data-testid share internally drawer container"},lockTimeRangeSwitch:{"11.3.0":"data-testid share internally lock time range switch"},shortenUrlSwitch:{"11.3.0":"data-testid share internally shorten url switch"},copyUrlButton:{"11.3.0":"data-testid share internally copy url button"}},ShareExternally:{container:{"11.3.0":"data-testid share externally drawer container"},publicAlert:{"11.3.0":"data-testid public share alert"},emailSharingAlert:{"11.3.0":"data-testid email share alert"},shareTypeSelect:{"11.3.0":"data-testid share externally share type select"},Creation:{PublicShare:{createButton:{"11.3.0":"data-testid public share dashboard create button"},cancelButton:{"11.3.0":"data-testid public share dashboard cancel button"}},EmailShare:{createButton:{"11.3.0":"data-testid email share dashboard create button"},cancelButton:{"11.3.0":"data-testid email share dashboard cancel button"}},willBePublicCheckbox:{"11.3.0":"data-testid share dashboard will be public checkbox"}},Configuration:{enableTimeRangeSwitch:{"11.3.0":"data-testid share externally enable time range switch"},enableAnnotationsSwitch:{"11.3.0":"data-testid share externally enable annotations switch"},copyUrlButton:{"11.3.0":"data-testid share externally copy url button"},revokeAccessButton:{"11.3.0":"data-testid share externally revoke access button"},toggleAccessButton:{"11.3.0":"data-testid share externally pause or resume access button"}}},ShareSnapshot:{url:{"11.3.0":e=>`/dashboard/snapshot/${e}`},container:{"11.3.0":"data-testid share snapshot drawer container"},publishSnapshot:{"11.3.0":"data-testid share snapshot publish button"},copyUrlButton:{"11.3.0":"data-testid share snapshot copy url button"}}},ExportDashboardDrawer:{ExportAsJson:{container:{"11.3.0":"data-testid export as json drawer container"},codeEditor:{"11.3.0":"data-testid export as json code editor"},exportExternallyToggle:{"11.3.0":"data-testid export as json externally switch"},saveToFileButton:{"11.3.0":"data-testid export as json save to file button"},copyToClipboardButton:{"11.3.0":"data-testid export as json copy to clipboard button"},cancelButton:{"11.3.0":"data-testid export as json cancel button"}}},PublicDashboard:{page:{"9.5.0":"public-dashboard-page"},NotAvailable:{container:{"9.5.0":"public-dashboard-not-available"},title:{"9.5.0":"public-dashboard-title"},pausedDescription:{"9.5.0":"public-dashboard-paused-description"}},footer:{"11.0.0":"public-dashboard-footer"}},PublicDashboardScene:{loadingPage:{"11.0.0":"public-dashboard-scene-loading-page"},page:{"11.0.0":"public-dashboard-scene-page"},controls:{"11.0.0":"public-dashboard-controls"}},RequestViewAccess:{form:{"9.5.0":"request-view-access-form"},recipientInput:{"9.5.0":"request-view-access-recipient-input"},submitButton:{"9.5.0":"request-view-access-submit-button"}},PublicDashboardConfirmAccess:{submitButton:{"10.2.0":"data-testid confirm-access-submit-button"}},Explore:{url:{[Ve]:"/explore"},General:{container:{[Ve]:"data-testid Explore"},graph:{[Ve]:"Explore Graph"},table:{[Ve]:"Explore Table"},scrollView:{"9.0.0":"data-testid explorer scroll view"}},QueryHistory:{container:{"11.1.0":"data-testid QueryHistory"}}},SoloPanel:{url:{[Ve]:e=>`/d-solo/${e}`}},PluginsList:{page:{[Ve]:"Plugins list page"},list:{[Ve]:"Plugins list"},listItem:{[Ve]:"Plugins list item"},signatureErrorNotice:{"10.3.0":"data-testid Unsigned plugins notice",[Ve]:"Unsigned plugins notice"}},PluginPage:{page:{[Ve]:"Plugin page"},signatureInfo:{"10.3.0":"data-testid Plugin signature info",[Ve]:"Plugin signature info"},disabledInfo:{"10.3.0":"data-testid Plugin disabled info",[Ve]:"Plugin disabled info"}},PlaylistForm:{name:{[Ve]:"Playlist name"},interval:{[Ve]:"Playlist interval"},itemDelete:{"10.2.0":"data-testid playlist-form-delete-item"}},BrowseDashboards:{table:{body:{"10.2.0":"data-testid browse-dashboards-table"},row:{"10.2.0":e=>`data-testid browse dashboards row ${e}`},checkbox:{"10.0.0":e=>`data-testid ${e} checkbox`}},NewFolderForm:{form:{"10.2.0":"data-testid new folder form"},nameInput:{"10.2.0":"data-testid new-folder-name-input"},createButton:{"10.2.0":"data-testid new-folder-create-button"}}},Search:{url:{"9.3.0":"/?search=openn"},FolderView:{url:{"9.3.0":"/?search=open&layout=folders"}}},PublicDashboards:{ListItem:{linkButton:{"9.3.0":"public-dashboard-link-button"},configButton:{"9.3.0":"public-dashboard-configuration-button"},trashcanButton:{"9.3.0":"public-dashboard-remove-button"},pauseSwitch:{"10.1.0":"data-testid public dashboard pause switch"}}},UserListPage:{tabs:{allUsers:{"10.0.0":"data-testid all-users-tab"},orgUsers:{"10.0.0":"data-testid org-users-tab"},anonUserDevices:{"10.2.3":"data-testid anon-user-devices-tab"},publicDashboardsUsers:{"10.0.0":"data-testid public-dashboards-users-tab"},users:{"10.0.0":"data-testid users-tab"}},org:{url:{"9.5.0":"/org/users"}},admin:{url:{"9.5.0":"/admin/users"}},publicDashboards:{container:{"11.1.0":"data-testid public-dashboards-users-list"}},UserListAdminPage:{container:{"10.0.0":"data-testid user-list-admin-page"}},UsersListPage:{container:{"10.0.0":"data-testid users-list-page"}},UserAnonListPage:{container:{"10.4.0":"data-testid user-anon-list-page"}},UsersListPublicDashboardsPage:{container:{"10.0.0":"data-testid users-list-public-dashboards-page"},DashboardsListModal:{listItem:{"10.0.0":e=>`data-testid dashboards-list-item-${e}`}}}},ProfilePage:{url:{"10.2.0":"/profile"}},Plugin:{url:{[Ve]:e=>`/plugins/${e}`}}}),components:je(Ue)};var Ge=p(6089);const $e=({children:e})=>{const t=(0,_e.useStyles2)(qe);return ye().createElement("div",{className:t.root},e)},qe=e=>({root:(0,Ge.css)({display:"flex",flexWrap:"wrap",alignItems:"center",gap:e.spacing(3),minHeight:e.spacing(4)})});var Ke=Object.defineProperty,We=Object.defineProperties,ze=Object.getOwnPropertyDescriptors,He=Object.getOwnPropertySymbols,Ye=Object.prototype.hasOwnProperty,Qe=Object.prototype.propertyIsEnumerable,Xe=(e,t,r)=>t in e?Ke(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,Je=(e,t)=>{for(var r in t||(t={}))Ye.call(t,r)&&Xe(e,r,t[r]);if(He)for(var r of He(t))Qe.call(t,r)&&Xe(e,r,t[r]);return e},Ze=(e,t)=>We(e,ze(t)),et=(e,t)=>{var r={};for(var n in e)Ye.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&He)for(var n of He(e))t.indexOf(n)<0&&Qe.call(e,n)&&(r[n]=e[n]);return r};function tt(e){var t=e,{label:r}=t,n=et(t,["label"]);const o=(0,_e.useStyles2)(ot),[i]=(0,ge.useState)((()=>Math.random().toString(16).slice(2))),a={SelectContainer:rt,ValueContainer:nt,SingleValue:nt};return ye().createElement("div",{className:o.root},r&&ye().createElement("label",{className:o.label,htmlFor:i},r,":"," "),ye().createElement(_e.Select,Ze(Je({openMenuOnFocus:!0,inputId:i},n),{components:a})))}const rt=e=>{const{children:t}=e,r=(0,_e.useStyles2)(ot);return ye().createElement(_e.SelectContainer,Ze(Je({},e),{className:(0,Ge.cx)(e.className,r.container)}),t)},nt=e=>{const{className:t,children:r}=e,n=(0,_e.useStyles2)(ot);return ye().createElement("div",{className:(0,Ge.cx)(t,n.valueContainer)},r)},ot=e=>({root:(0,Ge.css)({display:"flex",fontSize:12,alignItems:"center"}),label:(0,Ge.css)({color:e.colors.text.secondary,whiteSpace:"nowrap"}),container:(0,Ge.css)({background:"none",borderColor:"transparent"}),valueContainer:(0,Ge.css)({display:"flex",alignItems:"center",flex:"initial",color:e.colors.text.secondary,fontSize:12})}),it=({grow:e,shrink:t})=>ye().createElement("div",{style:{display:"block",flexGrow:e,flexShrink:t}});var at=Object.getOwnPropertySymbols,st=Object.prototype.hasOwnProperty,lt=Object.prototype.propertyIsEnumerable;const ut=e=>{var t=e,{children:r}=t,n=((e,t)=>{var r={};for(var n in e)st.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&at)for(var n of at(e))t.indexOf(n)<0&&lt.call(e,n)&&(r[n]=e[n]);return r})(t,["children"]);const o=(0,_e.useStyles2)((0,ge.useCallback)((e=>ct(e,n)),[n]));return ye().createElement("div",{className:o.root},r)},ct=(e,t)=>{var r,n,o;return{root:(0,Ge.css)({display:"flex",flexDirection:null!=(r=t.direction)?r:"row",flexWrap:null==(n=t.wrap)||n?"wrap":void 0,alignItems:t.alignItems,gap:e.spacing(null!=(o=t.gap)?o:2),flexGrow:t.flexGrow})}},dt=({children:e})=>{const t=(0,_e.useStyles2)(pt);return ye().createElement("div",{className:t.root},ye().createElement(ut,{gap:2},e))},pt=e=>({root:(0,Ge.css)({padding:e.spacing(1),backgroundColor:e.colors.background.secondary,borderRadius:e.shape.borderRadius(1)})}),ft=({v:e=0,h:t=0,layout:r="block"})=>{const n=(0,_e.useStyles2)((0,ge.useCallback)((n=>vt(n,{v:e,h:t,layout:r})),[e,t,r]));return ye().createElement("span",{className:(0,Ge.cx)(n.wrapper)})},vt=(e,t)=>{var r,n;return{wrapper:(0,Ge.css)([{paddingRight:e.spacing(null!=(r=t.h)?r:0),paddingBottom:e.spacing(null!=(n=t.v)?n:0)},"inline"===t.layout&&{display:"inline-block"},"block"===t.layout&&{display:"block"}])}};var ht=Object.defineProperty,gt=Object.getOwnPropertySymbols,yt=Object.prototype.hasOwnProperty,mt=Object.prototype.propertyIsEnumerable,bt=(e,t,r)=>t in e?ht(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const Et=e=>{var t;const r=e,{label:n,optional:o,tooltip:i,tooltipInteractive:a,children:s,width:l}=r,u=((e,t)=>{var r={};for(var n in e)yt.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&gt)for(var n of gt(e))t.indexOf(n)<0&&mt.call(e,n)&&(r[n]=e[n]);return r})(r,["label","optional","tooltip","tooltipInteractive","children","width"]),c=(0,_e.useStyles2)((0,ge.useCallback)((e=>Ot(e,l)),[l])),d=(null==u?void 0:u.htmlFor)||(null==(t=_e.ReactUtils)?void 0:t.getChildId(s)),p=ye().createElement(ye().Fragment,null,ye().createElement("label",{className:c.label,htmlFor:d},n,o&&ye().createElement("span",{className:c.optional}," - optional"),i&&ye().createElement(_e.Tooltip,{placement:"top",content:i,theme:"info",interactive:a},ye().createElement(_e.Icon,{tabIndex:0,name:"info-circle",size:"sm",className:c.icon}))),ye().createElement(ft,{v:.5}));return ye().createElement("div",{className:c.root},ye().createElement(_e.Field,((e,t)=>{for(var r in t||(t={}))yt.call(t,r)&&bt(e,r,t[r]);if(gt)for(var r of gt(t))mt.call(t,r)&&bt(e,r,t[r]);return e})({className:c.field,label:p},u),s))},Ot=(e,t)=>({root:(0,Ge.css)({minWidth:e.spacing(null!=t?t:0)}),label:(0,Ge.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),optional:(0,Ge.css)({fontStyle:"italic",color:e.colors.text.secondary}),field:(0,Ge.css)({marginBottom:0}),icon:(0,Ge.css)({color:e.colors.text.secondary,marginLeft:e.spacing(1),":hover":{color:e.colors.text.primary}})});function St({isOpen:e,onCancel:t,onDiscard:r,onCopy:n}){const o=(0,ge.useRef)(null),i=(0,_e.useStyles2)(Tt);return(0,ge.useEffect)((()=>{var t;e&&(null===(t=o.current)||void 0===t||t.focus())}),[e]),(0,he.jsxs)(_e.Modal,{title:(0,he.jsxs)("div",{className:i.modalHeaderTitle,children:[(0,he.jsx)(_e.Icon,{name:"exclamation-triangle",size:"lg"}),(0,he.jsx)("span",{className:i.titleText,children:"Warning"})]}),onDismiss:t,isOpen:e,children:[(0,he.jsx)("p",{children:"Builder mode does not display changes made in code. The query builder will display the last changes you made in builder mode."}),(0,he.jsx)("p",{children:"Do you want to copy your code to the clipboard?"}),(0,he.jsxs)(_e.Modal.ButtonRow,{children:[(0,he.jsx)(_e.Button,{type:"button",variant:"secondary",onClick:t,fill:"outline",children:"Cancel"}),(0,he.jsx)(_e.Button,{variant:"destructive",type:"button",onClick:r,ref:o,children:"Discard code and switch"}),(0,he.jsx)(_e.Button,{variant:"primary",onClick:n,children:"Copy code and switch"})]})]})}const Tt=e=>({titleText:(0,Ge.css)({paddingLeft:e.spacing(2)}),modalHeaderTitle:(0,Ge.css)({fontSize:e.typography.size.lg,float:"left",paddingTop:e.spacing(1),margin:e.spacing(0,2)})}),_t=()=>!!pe.config.featureToggles.sqlDatasourceDatabaseSelection;function wt(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function Rt(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){wt(i,n,o,a,s,"next",e)}function s(e){wt(i,n,o,a,s,"throw",e)}a(void 0)}))}}const It=({dataset:e,db:t,dialect:r,onChange:n,inputId:o,preconfiguredDataset:i})=>{const a=!!i||"postgres"===r,s=Oe(Rt((function*(){return _t()&&a?(n(w(i)),[w(i)]):(e&&n(w(e)),(yield t.datasets()).map(w))})),[]);return(0,ge.useEffect)((()=>{_t()||(e?s.value&&void 0===s.value.find((t=>t.value===e))&&s.value.length>0&&n(s.value[0]):s.value&&s.value[0]&&n(s.value[0]))}),[s.value,n,e]),(0,he.jsx)(_e.Select,{"aria-label":"Dataset selector",inputId:o,value:e,options:s.value,onChange:n,disabled:s.loading,isLoading:s.loading,menuShouldPortal:!0})};function At(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function Ct(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){At(i,n,o,a,s,"next",e)}function s(e){At(i,n,o,a,s,"throw",e)}a(void 0)}))}}const Nt=({db:e,dataset:t,table:r,className:n,onChange:o,inputId:i})=>{const a=Oe(Ct((function*(){return t?(yield e.tables(t)).map(T.toOption):[]})),[t]);return(0,he.jsx)(_e.Select,{className:n,disabled:a.loading,"aria-label":"Table selector",inputId:i,"data-testid":Be.components.SQLQueryEditor.headerTableSelector,value:r,options:a.value,onChange:o,isLoading:a.loading,menuShouldPortal:!0,placeholder:a.loading?"Loading tables":"Select table"})};function Lt(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Pt(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Lt(e,t,r[t])}))}return e}function xt(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const jt=[{label:"Builder",value:de.Builder},{label:"Code",value:de.Code}];function Ft({db:e,dialect:t,isQueryRunnable:r,onChange:n,onQueryRowChange:o,onRunQuery:i,preconfiguredDataset:a,query:s,queryRowFilter:l}){const{editorMode:u}=s,[c,d]=Pe(),[p,f]=(0,ge.useState)(!1),v=e.toRawSql,h=(0,ge.useId)(),g=(0,ge.useCallback)((e=>{var t;e===de.Code&&(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,selectedEditorMode:de.Code}),u!==de.Code?n(xt(Pt({},s),{editorMode:e})):f(!0)}),[u,n,s]);return(0,he.jsxs)(he.Fragment,{children:[(0,he.jsxs)($e,{children:[(0,he.jsx)(tt,{label:"Format",value:s.format,placeholder:"Select format",menuShouldPortal:!0,onChange:e=>{var t;const r=xt(Pt({},s),{format:void 0!==e.value?e.value:S.Table});(0,pe.reportInteraction)("grafana_sql_format_changed",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,selectedFormat:r.format}),n(r)},options:_}),u===de.Builder&&(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(_e.InlineSwitch,{id:`sql-filter-${h}`,label:"Filter","data-testid":Be.components.SQLQueryEditor.headerFilterSwitch,transparent:!0,showLabel:!0,value:l.filter,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_filter_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(xt(Pt({},l),{filter:e.target.checked})))}}),(0,he.jsx)(_e.InlineSwitch,{id:`sql-group-${h}`,label:"Group","data-testid":Be.components.SQLQueryEditor.headerGroupSwitch,transparent:!0,showLabel:!0,value:l.group,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_group_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(xt(Pt({},l),{group:e.target.checked})))}}),(0,he.jsx)(_e.InlineSwitch,{id:`sql-order-${h}`,label:"Order","data-testid":Be.components.SQLQueryEditor.headerOrderSwitch,transparent:!0,showLabel:!0,value:l.order,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_order_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(xt(Pt({},l),{order:e.target.checked})))}}),(0,he.jsx)(_e.InlineSwitch,{id:`sql-preview-${h}`,label:"Preview","data-testid":Be.components.SQLQueryEditor.headerPreviewSwitch,transparent:!0,showLabel:!0,value:l.preview,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_preview_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(xt(Pt({},l),{preview:e.target.checked})))}})]}),(0,he.jsx)(it,{grow:1}),r?(0,he.jsx)(_e.Button,{icon:"play",variant:"primary",size:"sm",onClick:()=>i(),children:"Run query"}):(0,he.jsx)(_e.Tooltip,{theme:"error",content:(0,he.jsxs)(he.Fragment,{children:["Your query is invalid. Check below for details. ",(0,he.jsx)("br",{}),"However, you can still run this query."]}),placement:"top",children:(0,he.jsx)(_e.Button,{icon:"exclamation-triangle",variant:"secondary",size:"sm",onClick:()=>i(),children:"Run query"})}),(0,he.jsx)(_e.RadioButtonGroup,{options:jt,size:"sm",value:u,onChange:g}),(0,he.jsx)(St,{isOpen:p,onCopy:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=s.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"copy"}),f(!1),d(s.rawSql),n(xt(Pt({},s),{rawSql:v(s),editorMode:de.Builder}))},onDiscard:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=s.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"discard"}),f(!1),n(xt(Pt({},s),{rawSql:v(s),editorMode:de.Builder}))},onCancel:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=s.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"cancel"}),f(!1)}})]}),u===de.Builder&&(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(_e.Space,{v:.5}),(0,he.jsxs)(dt,{children:["influx"!==t&&!(!_t()&&"postgres"===t)&&(0,he.jsx)(Et,{label:"Dataset",width:25,children:(0,he.jsx)(It,{db:e,inputId:`sql-dataset-${h}`,dataset:s.dataset,dialect:t,preconfiguredDataset:a,onChange:e=>{if(e.value===s.dataset)return;const t=xt(Pt({},s),{dataset:e.value,table:void 0,sql:void 0,rawSql:""});n(t)}})}),(0,he.jsx)(Et,{label:"Table",width:25,children:(0,he.jsx)(Nt,{db:e,inputId:`sql-tableselect-${h}`,dataset:s.dataset||a,table:s.table,onChange:e=>{if(e.value===s.table)return;const t=xt(Pt({},s),{table:e.value,sql:void 0,rawSql:""});n(t)}})})]})]})]})}var Dt=function(){},kt="undefined"!=typeof window;const Mt=kt?ge.useLayoutEffect:ge.useEffect;var Vt={x:0,y:0,width:0,height:0,top:0,left:0,bottom:0,right:0};const Ut=kt&&void 0!==window.ResizeObserver?function(){var e=(0,ge.useState)(null),t=e[0],r=e[1],n=(0,ge.useState)(Vt),o=n[0],i=n[1],a=(0,ge.useMemo)((function(){return new window.ResizeObserver((function(e){if(e[0]){var t=e[0].contentRect,r=t.x,n=t.y,o=t.width,a=t.height,s=t.top,l=t.left,u=t.bottom,c=t.right;i({x:r,y:n,width:o,height:a,top:s,left:l,bottom:u,right:c})}}))}),[]);return Mt((function(){if(t)return a.observe(t),function(){a.disconnect()}}),[t]),[r,o]}:function(){return[Dt,Vt]};let Bt;Bt="undefined"!=typeof window?window:"undefined"!=typeof self?self:p.g;let Gt=null,$t=null;const qt=Bt.clearTimeout,Kt=Bt.setTimeout,Wt=Bt.cancelAnimationFrame||Bt.mozCancelAnimationFrame||Bt.webkitCancelAnimationFrame,zt=Bt.requestAnimationFrame||Bt.mozRequestAnimationFrame||Bt.webkitRequestAnimationFrame;null==Wt||null==zt?(Gt=qt,$t=function(e){return Kt(e,20)}):(Gt=function([e,t]){Wt(e),qt(t)},$t=function(e){const t=zt((function(){qt(r),e()})),r=Kt((function(){Wt(t),e()}),20);return[t,r]});class Ht extends ge.Component{constructor(...e){super(...e),this.state={height:this.props.defaultHeight||0,scaledHeight:this.props.defaultHeight||0,scaledWidth:this.props.defaultWidth||0,width:this.props.defaultWidth||0},this._autoSizer=null,this._detectElementResize=null,this._parentNode=null,this._resizeObserver=null,this._timeoutId=null,this._onResize=()=>{this._timeoutId=null;const{disableHeight:e,disableWidth:t,onResize:r}=this.props;if(this._parentNode){const n=window.getComputedStyle(this._parentNode)||{},o=parseFloat(n.paddingLeft||"0"),i=parseFloat(n.paddingRight||"0"),a=parseFloat(n.paddingTop||"0"),s=parseFloat(n.paddingBottom||"0"),l=this._parentNode.getBoundingClientRect(),u=l.height-a-s,c=l.width-o-i,d=this._parentNode.offsetHeight-a-s,p=this._parentNode.offsetWidth-o-i;(e||this.state.height===d&&this.state.scaledHeight===u)&&(t||this.state.width===p&&this.state.scaledWidth===c)||(this.setState({height:d,width:p,scaledHeight:u,scaledWidth:c}),"function"==typeof r&&r({height:d,scaledHeight:u,scaledWidth:c,width:p}))}},this._setRef=e=>{this._autoSizer=e}}componentDidMount(){const{nonce:e}=this.props,t=this._autoSizer?this._autoSizer.parentNode:null;if(null!=t&&t.ownerDocument&&t.ownerDocument.defaultView&&t instanceof t.ownerDocument.defaultView.HTMLElement){this._parentNode=t;const r=t.ownerDocument.defaultView.ResizeObserver;null!=r?(this._resizeObserver=new r((()=>{this._timeoutId=setTimeout(this._onResize,0)})),this._resizeObserver.observe(t)):(this._detectElementResize=function(e){let t,r,n,o,i,a,s;const l="undefined"!=typeof document&&document.attachEvent;if(!l){a=function(e){const t=e.__resizeTriggers__,r=t.firstElementChild,n=t.lastElementChild,o=r.firstElementChild;n.scrollLeft=n.scrollWidth,n.scrollTop=n.scrollHeight,o.style.width=r.offsetWidth+1+"px",o.style.height=r.offsetHeight+1+"px",r.scrollLeft=r.scrollWidth,r.scrollTop=r.scrollHeight},i=function(e){return e.offsetWidth!==e.__resizeLast__.width||e.offsetHeight!==e.__resizeLast__.height},s=function(e){if(e.target.className&&"function"==typeof e.target.className.indexOf&&e.target.className.indexOf("contract-trigger")<0&&e.target.className.indexOf("expand-trigger")<0)return;const t=this;a(this),this.__resizeRAF__&&Gt(this.__resizeRAF__),this.__resizeRAF__=$t((function(){i(t)&&(t.__resizeLast__.width=t.offsetWidth,t.__resizeLast__.height=t.offsetHeight,t.__resizeListeners__.forEach((function(r){r.call(t,e)})))}))};let e=!1,l="";n="animationstart";const u="Webkit Moz O ms".split(" ");let c="webkitAnimationStart animationstart oAnimationStart MSAnimationStart".split(" "),d="";{const t=document.createElement("fakeelement");if(void 0!==t.style.animationName&&(e=!0),!1===e)for(let r=0;r<u.length;r++)if(void 0!==t.style[u[r]+"AnimationName"]){d=u[r],l="-"+d.toLowerCase()+"-",n=c[r],e=!0;break}}r="resizeanim",t="@"+l+"keyframes "+r+" { from { opacity: 0; } to { opacity: 0; } } ",o=l+"animation: 1ms "+r+"; "}return{addResizeListener:function(i,u){if(l)i.attachEvent("onresize",u);else{if(!i.__resizeTriggers__){const l=i.ownerDocument,u=Bt.getComputedStyle(i);u&&"static"===u.position&&(i.style.position="relative"),function(r){if(!r.getElementById("detectElementResize")){const n=(t||"")+".resize-triggers { "+(o||"")+'visibility: hidden; opacity: 0; } .resize-triggers, .resize-triggers > div, .contract-trigger:before { content: " "; display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; z-index: -1; } .resize-triggers > div { background: #eee; overflow: auto; } .contract-trigger:before { width: 200%; height: 200%; }',i=r.head||r.getElementsByTagName("head")[0],a=r.createElement("style");a.id="detectElementResize",a.type="text/css",null!=e&&a.setAttribute("nonce",e),a.styleSheet?a.styleSheet.cssText=n:a.appendChild(r.createTextNode(n)),i.appendChild(a)}}(l),i.__resizeLast__={},i.__resizeListeners__=[],(i.__resizeTriggers__=l.createElement("div")).className="resize-triggers";const c=l.createElement("div");c.className="expand-trigger",c.appendChild(l.createElement("div"));const d=l.createElement("div");d.className="contract-trigger",i.__resizeTriggers__.appendChild(c),i.__resizeTriggers__.appendChild(d),i.appendChild(i.__resizeTriggers__),a(i),i.addEventListener("scroll",s,!0),n&&(i.__resizeTriggers__.__animationListener__=function(e){e.animationName===r&&a(i)},i.__resizeTriggers__.addEventListener(n,i.__resizeTriggers__.__animationListener__))}i.__resizeListeners__.push(u)}},removeResizeListener:function(e,t){if(l)e.detachEvent("onresize",t);else if(e.__resizeListeners__.splice(e.__resizeListeners__.indexOf(t),1),!e.__resizeListeners__.length){e.removeEventListener("scroll",s,!0),e.__resizeTriggers__.__animationListener__&&(e.__resizeTriggers__.removeEventListener(n,e.__resizeTriggers__.__animationListener__),e.__resizeTriggers__.__animationListener__=null);try{e.__resizeTriggers__=!e.removeChild(e.__resizeTriggers__)}catch(e){}}}}}(e),this._detectElementResize.addResizeListener(t,this._onResize)),this._onResize()}}componentWillUnmount(){this._parentNode&&(this._detectElementResize&&this._detectElementResize.removeResizeListener(this._parentNode,this._onResize),null!==this._timeoutId&&clearTimeout(this._timeoutId),this._resizeObserver&&this._resizeObserver.disconnect())}render(){const{children:e,defaultHeight:t,defaultWidth:r,disableHeight:n=!1,disableWidth:o=!1,doNotBailOutOnEmptyChildren:i=!1,nonce:a,onResize:s,style:l={},tagName:u="div",...c}=this.props,{height:d,scaledHeight:p,scaledWidth:f,width:v}=this.state,h={overflow:"visible"},g={};let y=!1;return n||(0===d&&(y=!0),h.height=0,g.height=d,g.scaledHeight=p),o||(0===v&&(y=!0),h.width=0,g.width=v,g.scaledWidth=f),i&&(y=!1),(0,ge.createElement)(u,{ref:this._setRef,style:{...h,...l},...c},!y&&e(g))}}var Yt=Object.defineProperty,Qt=Object.getOwnPropertySymbols,Xt=Object.prototype.hasOwnProperty,Jt=Object.prototype.propertyIsEnumerable,Zt=(e,t,r)=>t in e?Yt(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const er=(e,t,r={})=>((e,t)=>{for(var r in t||(t={}))Xt.call(t,r)&&Zt(e,r,t[r]);if(Qt)for(var r of Qt(t))Jt.call(t,r)&&Zt(e,r,t[r]);return e})({label:e,insertText:e,kind:ue.Field,sortText:le.Medium,range:t},r);var tr=Object.defineProperty,rr=Object.defineProperties,nr=Object.getOwnPropertyDescriptors,or=Object.getOwnPropertySymbols,ir=Object.prototype.hasOwnProperty,ar=Object.prototype.propertyIsEnumerable,sr=(e,t,r)=>t in e?tr(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,lr=(e,t)=>{for(var r in t||(t={}))ir.call(t,r)&&sr(e,r,t[r]);if(or)for(var r of or(t))ar.call(t,r)&&sr(e,r,t[r]);return e};const ur=()=>[{id:ae.SelectKeyword,name:ae.SelectKeyword,kind:[se.SelectKeyword]},{id:ae.WithKeyword,name:ae.WithKeyword,kind:[se.WithKeyword]},{id:ae.AfterSelectKeyword,name:ae.AfterSelectKeyword,kind:[se.StarWildCard,se.FunctionsWithArguments,se.Columns,se.SelectMacro]},{id:ae.AfterSelectFuncFirstArgument,name:ae.AfterSelectFuncFirstArgument,kind:[se.Columns]},{id:ae.AfterGroupByFunctionArgument,name:ae.AfterGroupByFunctionArgument,kind:[se.Columns]},{id:ae.AfterWhereFunctionArgument,name:ae.AfterWhereFunctionArgument,kind:[se.Columns]},{id:ae.AfterSelectArguments,name:ae.AfterSelectArguments,kind:[se.Columns]},{id:ae.AfterFromKeyword,name:ae.AfterFromKeyword,kind:[se.Schemas,se.Tables,se.TableMacro]},{id:ae.AfterSchema,name:ae.AfterSchema,kind:[se.Tables,se.TableMacro]},{id:ae.SelectAlias,name:ae.SelectAlias,kind:[se.Columns,se.FunctionsWithArguments]},{id:ae.FromKeyword,name:ae.FromKeyword,kind:[se.FromKeyword]},{id:ae.AfterFrom,name:ae.AfterFrom,kind:[se.WhereKeyword,se.GroupByKeywords,se.OrderByKeywords,se.LimitKeyword]},{id:ae.AfterTable,name:ae.AfterTable,kind:[se.WhereKeyword,se.GroupByKeywords,se.OrderByKeywords,se.LimitKeyword]},{id:ae.WhereKeyword,name:ae.WhereKeyword,kind:[se.Columns,se.FilterMacro,se.TemplateVariables]},{id:ae.WhereComparisonOperator,name:ae.WhereComparisonOperator,kind:[se.ComparisonOperators]},{id:ae.WhereValue,name:ae.WhereValue,kind:[se.FilterMacro,se.TemplateVariables]},{id:ae.AfterWhereValue,name:ae.AfterWhereValue,kind:[se.LogicalOperators,se.GroupByKeywords,se.OrderByKeywords,se.LimitKeyword,se.Columns,se.TemplateVariables]},{id:ae.AfterGroupByKeywords,name:ae.AfterGroupByKeywords,kind:[se.GroupMacro,se.Columns]},{id:ae.AfterGroupBy,name:ae.AfterGroupBy,kind:[se.OrderByKeywords,se.LimitKeyword]},{id:ae.AfterOrderByKeywords,name:ae.AfterOrderByKeywords,kind:[se.Columns]},{id:ae.AfterOrderByFunction,name:ae.AfterOrderByFunction,kind:[se.SortOrderDirectionKeyword,se.LimitKeyword]},{id:ae.AfterOrderByDirection,name:ae.AfterOrderByDirection,kind:[se.LimitKeyword]},{id:ae.AfterIsOperator,name:ae.AfterOrderByDirection,kind:[se.NotKeyword,se.NullValue,se.BoolValues]},{id:ae.AfterIsNotOperator,name:ae.AfterOrderByDirection,kind:[se.NullValue,se.BoolValues]}];class cr{constructor(e,t,r,n,o){this.type=e,this.value=t,this.range=r,this.previous=n,this.next=o}isKeyword(){return this.type===ie.Keyword}isWhiteSpace(){return this.type===ie.Whitespace}isParenthesis(){return this.type===ie.Parenthesis}isIdentifier(){return this.type===ie.Identifier}isString(){return this.type===ie.String}isNumber(){return this.type===ie.Number}isDoubleQuotedString(){return this.type===ie.Type}isVariable(){return this.type===ie.Variable}isFunction(){return this.type===ie.Function}isOperator(){return this.type===ie.Operator}isTemplateVariable(){return this.type===ie.Variable}is(e,t){const r=this.type===e;return void 0!==t?r&&dr(e,this,t):r}getPreviousNonWhiteSpaceToken(){let e=this.previous;for(;null!=e;){if(!e.isWhiteSpace())return e;e=e.previous}return null}getPreviousOfType(e,t){let r=this.previous;for(;null!=r;){const n=r.type===e;if(void 0!==t?n&&dr(e,r,t):n)return r;r=r.previous}return null}getPreviousUntil(e,t,r){let n=[],o=this.previous;for(;null!=o;){if(t.some((e=>e===(null==o?void 0:o.type)))){o=o.previous;continue}const i=o.type===e;if(void 0!==r?i&&dr(e,o,r):i)return n;o.isWhiteSpace()||n.push(o),o=o.previous}return n}getNextUntil(e,t,r){let n=[],o=this.next;for(;null!=o;){if(t.some((e=>e===(null==o?void 0:o.type)))){o=o.next;continue}const i=o.type===e;if(void 0!==r?i&&dr(e,o,r):i)return n;o.isWhiteSpace()||n.push(o),o=o.next}return n}getPreviousKeyword(){let e=this.previous;for(;null!=e;){if(e.isKeyword())return e;e=e.previous}return null}getNextNonWhiteSpaceToken(){let e=this.next;for(;null!=e;){if(!e.isWhiteSpace())return e;e=e.next}return null}getNextOfType(e,t){let r=this.next;for(;null!=r;){const n=r.type===e;if(void 0!==t?n&&dr(e,r,t):n)return r;r=r.next}return null}}function dr(e,t,r){return e===ie.Keyword||e===ie.Operator?t.value.toLowerCase()===r.toString().toLowerCase():t.value===r}var pr=p(8572);const fr=e=>{var t;const r=(e=>{const t=(e=>{var t;return null!=(t=null==e?void 0:e.getPreviousOfType(ie.Keyword,pr.SELECT))?t:null})(e);return null==t?void 0:t.getNextOfType(ie.Keyword,pr.FROM)})(e),n=null==r?void 0:r.getNextNonWhiteSpaceToken();return(null==n?void 0:n.isVariable())||(null==n?void 0:n.isKeyword())&&(null==(t=n.next)?void 0:t.is(ie.Parenthesis,"("))?null:n},vr=e=>{const t=null==e?void 0:e.value.split(".");return 1===(null==t?void 0:t.length)?{table:t[0]}:2===(null==t?void 0:t.length)?{schema:t[0],table:t[1]}:null},hr={id:"editor.action.triggerSuggest",title:""};var gr,yr=new Uint8Array(16);function mr(){if(!gr&&!(gr="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return gr(yr)}const br=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;for(var Er=[],Or=0;Or<256;++Or)Er.push((Or+256).toString(16).substr(1));const Sr=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(Er[e[t+0]]+Er[e[t+1]]+Er[e[t+2]]+Er[e[t+3]]+"-"+Er[e[t+4]]+Er[e[t+5]]+"-"+Er[e[t+6]]+Er[e[t+7]]+"-"+Er[e[t+8]]+Er[e[t+9]]+"-"+Er[e[t+10]]+Er[e[t+11]]+Er[e[t+12]]+Er[e[t+13]]+Er[e[t+14]]+Er[e[t+15]]).toLowerCase();if(!function(e){return"string"==typeof e&&br.test(e)}(r))throw TypeError("Stringified UUID is invalid");return r},Tr=function(e,t,r){var n=(e=e||{}).random||(e.rng||mr)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,t){r=r||0;for(var o=0;o<16;++o)t[r+o]=n[o];return t}return Sr(n)},_r=(e,t,r)=>()=>[{id:se.SelectKeyword,name:se.SelectKeyword,suggestions:(e,t)=>Promise.resolve([{label:"SELECT <column>",insertText:"SELECT $0",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:hr,sortText:le.Medium},{label:"SELECT <column> FROM <table>",insertText:"SELECT $2 FROM $1",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:hr,sortText:le.Medium}])},{id:se.TemplateVariables,name:se.TemplateVariables,suggestions:(e,t)=>{const r=(0,pe.getTemplateSrv)();return r?Promise.resolve(r.getVariables().map((e=>{const t=`$${e.name}`,n=r.replace(t);return{label:t,detail:`(Template Variable) ${n}`,kind:ue.Snippet,documentation:`(Template Variable) ${n}`,insertText:`\\$${e.name} `,insertTextRules:ce.InsertAsSnippet,command:hr,sortText:le.Low}}))):Promise.resolve([])}},{id:se.SelectMacro,name:se.SelectMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Value||e.type===oe.Column)).map(wr)])},{id:se.TableMacro,name:se.TableMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Table)).map(wr)])},{id:se.GroupMacro,name:se.GroupMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Group)).map(wr)])},{id:se.FilterMacro,name:se.FilterMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Filter)).map(wr)])},{id:se.WithKeyword,name:se.WithKeyword,suggestions:(e,t)=>Promise.resolve([{label:"WITH <alias> AS ( ... )",insertText:"WITH $1  AS ( $2 )",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:hr,sortText:le.Medium}])},{id:se.StarWildCard,name:se.StarWildCard,suggestions:(e,t)=>Promise.resolve([{label:"*",insertText:"* $0",insertTextRules:ce.InsertAsSnippet,kind:ue.Field,command:hr,sortText:le.High}])},{id:se.FunctionsWithArguments,name:se.FunctionsWithArguments,suggestions:(t,r)=>Promise.resolve([...e.list().map((e=>({label:e.name,insertText:`${e.name}($0)`,documentation:e.description,insertTextRules:ce.InsertAsSnippet,kind:ue.Function,command:hr,sortText:le.MediumLow})))])},{id:se.FunctionsWithoutArguments,name:se.FunctionsWithoutArguments,suggestions:(t,r)=>Promise.resolve([...e.list().map((e=>({label:e.name,insertText:`${e.name}()`,documentation:e.description,insertTextRules:ce.InsertAsSnippet,kind:ue.Function,command:hr,sortText:le.MediumHigh})))])},{id:se.FromKeyword,name:se.FromKeyword,suggestions:(e,t)=>Promise.resolve([{label:"FROM",insertText:"FROM $0",command:hr,insertTextRules:ce.InsertAsSnippet,kind:ue.Keyword}])},{id:se.Schemas,name:se.Schemas,suggestions:(e,t)=>Promise.resolve([])},{id:se.Tables,name:se.Tables,suggestions:(e,t)=>Promise.resolve([])},{id:se.Columns,name:se.Columns,suggestions:(e,t)=>Promise.resolve([])},{id:se.LogicalOperators,name:se.LogicalOperators,suggestions:(e,r)=>Promise.resolve(t.list().filter((e=>e.type===ne.Logical)).map((e=>({label:e.operator,insertText:`${e.operator} `,documentation:e.description,command:hr,sortText:le.MediumHigh,kind:ue.Operator}))))},{id:se.WhereKeyword,name:se.WhereKeyword,suggestions:(e,t)=>Promise.resolve([{label:"WHERE",insertText:"WHERE ",command:hr,sortText:le.MediumHigh,kind:ue.Keyword}])},{id:se.ComparisonOperators,name:se.ComparisonOperators,suggestions:(e,r)=>Promise.resolve([...t.list().filter((e=>e.type===ne.Comparison)).map((e=>({label:e.operator,insertText:`${e.operator} `,documentation:e.description,command:hr,sortText:le.MediumHigh,kind:ue.Operator}))),{label:"IN (...)",insertText:"IN ( $0 )",command:hr,sortText:le.Medium,kind:ue.Operator,insertTextRules:ce.InsertAsSnippet},{label:"NOT IN (...)",insertText:"NOT IN ( $0 )",command:hr,sortText:le.Medium,kind:ue.Operator,insertTextRules:ce.InsertAsSnippet},{label:"IS",insertText:"IS",command:hr,sortText:le.Medium,kind:ue.Operator},{label:"IS NOT",insertText:"IS NOT",command:hr,sortText:le.Medium,kind:ue.Operator}])},{id:se.GroupByKeywords,name:se.GroupByKeywords,suggestions:(e,t)=>Promise.resolve([{label:"GROUP BY",insertText:"GROUP BY ",command:hr,sortText:le.MediumHigh,kind:ue.Keyword}])},{id:se.OrderByKeywords,name:se.OrderByKeywords,suggestions:(e,t)=>Promise.resolve([{label:"ORDER BY",insertText:"ORDER BY ",command:hr,sortText:le.Medium,kind:ue.Keyword},{label:"ORDER BY(ascending)",insertText:"ORDER BY $1 ASC ",command:hr,sortText:le.MediumLow,kind:ue.Snippet,insertTextRules:ce.InsertAsSnippet},{label:"ORDER BY(descending)",insertText:"ORDER BY $1 DESC",command:hr,sortText:le.MediumLow,kind:ue.Snippet,insertTextRules:ce.InsertAsSnippet}])},{id:se.LimitKeyword,name:se.LimitKeyword,suggestions:(e,t)=>Promise.resolve([{label:"LIMIT",insertText:"LIMIT ",command:hr,sortText:le.MediumLow,kind:ue.Keyword}])},{id:se.SortOrderDirectionKeyword,name:se.SortOrderDirectionKeyword,suggestions:(e,t)=>Promise.resolve([pr.ASC,pr.DESC].map((e=>({label:e,insertText:`${e} `,command:hr,kind:ue.Keyword}))))},{id:se.NotKeyword,name:se.NotKeyword,suggestions:()=>Promise.resolve([{label:"NOT",insertText:"NOT",command:hr,kind:ue.Keyword,sortText:le.High}])},{id:se.BoolValues,name:se.BoolValues,suggestions:()=>Promise.resolve(["TRUE","FALSE"].map((e=>({label:e,insertText:`${e}`,command:hr,kind:ue.Keyword,sortText:le.Medium}))))},{id:se.NullValue,name:se.NullValue,suggestions:()=>Promise.resolve(["NULL"].map((e=>({label:e,insertText:`${e}`,command:hr,kind:ue.Keyword,sortText:le.Low}))))}];function wr(e){return{label:e.name,insertText:`${"\\"+e.text}${t=e.args,t?"(".concat(t.map(((e,t)=>`\${${t}:${e}}`)).join(", ")).concat(")"):"()"} `,insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,documentation:e.description,command:hr};var t}function Rr(){return[{id:ae.SelectKeyword,name:ae.SelectKeyword,resolve:(e,t,r,n)=>Boolean(null===e||e.isWhiteSpace()&&null===e.previous||e.is(ie.Keyword,pr.SELECT)||e.is(ie.Keyword,pr.SELECT)&&null===e.previous||n||e.isIdentifier()&&(n||null===(null==e?void 0:e.previous))||e.isIdentifier()&&pr.SELECT.startsWith(e.value.toLowerCase()))},{id:ae.WithKeyword,name:ae.WithKeyword,resolve:(e,t,r,n)=>Boolean(null===e||e.isWhiteSpace()&&null===e.previous||e.is(ie.Keyword,pr.WITH)&&null===e.previous||e.isIdentifier()&&pr.WITH.toLowerCase().startsWith(e.value.toLowerCase()))},{id:ae.AfterSelectKeyword,name:ae.AfterSelectKeyword,resolve:(e,t,r,n)=>Boolean((null==r?void 0:r.value.toLowerCase())===pr.SELECT)},{id:ae.AfterSelectArguments,name:ae.AfterSelectArguments,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===pr.SELECT&&","===(null==r?void 0:r.value))},{id:ae.AfterSelectFuncFirstArgument,name:ae.AfterSelectFuncFirstArgument,resolve:(e,t,r,n)=>Boolean(((null==t?void 0:t.value.toLowerCase())===pr.SELECT||(null==t?void 0:t.value.toLowerCase())===pr.AS)&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))},{id:ae.AfterWhereFunctionArgument,name:ae.AfterWhereFunctionArgument,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.is(ie.Keyword,pr.WHERE))&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))},{id:ae.AfterGroupBy,name:ae.AfterGroupBy,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,pr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,pr.GROUP))&&((null==r?void 0:r.isIdentifier())||(null==r?void 0:r.isDoubleQuotedString())||(null==r?void 0:r.is(ie.Parenthesis,")"))||(null==r?void 0:r.is(ie.Parenthesis,"()"))))}},{id:ae.SelectAlias,name:ae.SelectAlias,resolve:(e,t,r,n)=>","===(null==r?void 0:r.value)&&(null==t?void 0:t.value.toLowerCase())===pr.AS},{id:ae.FromKeyword,name:ae.FromKeyword,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===pr.SELECT&&","!==(null==r?void 0:r.value)||((null==e?void 0:e.isKeyword())||(null==e?void 0:e.isIdentifier()))&&pr.FROM.toLowerCase().startsWith(e.value.toLowerCase()))},{id:ae.AfterFromKeyword,name:ae.AfterFromKeyword,resolve:(e,t,r,n)=>Boolean(!(null==e?void 0:e.value.includes("."))&&(null==r?void 0:r.value.toLowerCase())===pr.FROM)},{id:ae.AfterSchema,name:ae.AfterSchema,resolve:(e,t,r,n)=>((null==e?void 0:e.isWhiteSpace())&&(null==e?void 0:e.next)&&(r=(e=null==e?void 0:e.previous).getPreviousNonWhiteSpaceToken()),Boolean((null==e?void 0:e.isIdentifier())&&(null==e?void 0:e.value.endsWith("."))&&(null==r?void 0:r.value.toLowerCase())===pr.FROM))},{id:ae.AfterFrom,name:ae.AfterFrom,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===pr.FROM&&(null==r?void 0:r.isDoubleQuotedString())||(null==t?void 0:t.value.toLowerCase())===pr.FROM&&(null==r?void 0:r.isIdentifier())||(null==t?void 0:t.value.toLowerCase())===pr.FROM&&(null==r?void 0:r.isVariable()))},{id:ae.AfterTable,name:ae.AfterTable,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===pr.FROM&&((null==r?void 0:r.isVariable())||""!==(null==r?void 0:r.value)&&(null==r?void 0:r.value.toLowerCase())!==pr.FROM))},{id:ae.WhereKeyword,name:ae.WhereKeyword,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===pr.WHERE&&((null==r?void 0:r.isKeyword())||(null==r?void 0:r.is(ie.Parenthesis,"("))||(null==r?void 0:r.is(ie.Operator,pr.AND))))},{id:ae.WhereComparisonOperator,name:ae.WhereComparisonOperator,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.value.toLowerCase())===pr.WHERE&&!(null==(o=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:o.isOperator())&&!(null==e?void 0:e.is(ie.Delimiter,"."))&&!(null==e?void 0:e.isParenthesis())&&((null==r?void 0:r.isIdentifier())||(null==r?void 0:r.isDoubleQuotedString())))}},{id:ae.WhereValue,name:ae.WhereValue,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===pr.WHERE&&(null==r?void 0:r.isOperator()))},{id:ae.AfterWhereValue,name:ae.AfterWhereValue,resolve:(e,t,r,n)=>{var o,i,a;return Boolean((null==t?void 0:t.value.toLowerCase())===pr.WHERE&&((null==r?void 0:r.is(ie.Operator,"and"))||(null==r?void 0:r.is(ie.Operator,"or"))||(null==r?void 0:r.isString())||(null==r?void 0:r.isNumber())||(null==r?void 0:r.is(ie.Parenthesis,")"))||(null==r?void 0:r.is(ie.Parenthesis,"()"))||(null==r?void 0:r.isTemplateVariable())||(null==r?void 0:r.is(ie.IdentifierQuote))&&(null==(o=r.getPreviousNonWhiteSpaceToken())?void 0:o.is(ie.Identifier))&&(null==(a=null==(i=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:i.getPreviousNonWhiteSpaceToken())?void 0:a.is(ie.IdentifierQuote))))}},{id:ae.AfterGroupByKeywords,name:ae.AfterGroupByKeywords,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,pr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,pr.GROUP))&&((null==r?void 0:r.is(ie.Keyword,pr.BY))||(null==r?void 0:r.is(ie.Delimiter,","))))}},{id:ae.AfterGroupByFunctionArgument,name:ae.AfterGroupByFunctionArgument,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,pr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,pr.GROUP))&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))}},{id:ae.AfterOrderByKeywords,name:ae.AfterOrderByKeywords,resolve:(e,t,r,n)=>{var o;return Boolean((null==r?void 0:r.is(ie.Keyword,pr.BY))&&(null==(o=null==r?void 0:r.getPreviousKeyword())?void 0:o.is(ie.Keyword,pr.ORDER)))}},{id:ae.AfterOrderByFunction,name:ae.AfterOrderByFunction,resolve:(e,t,r,n)=>{var o,i;return Boolean((null==t?void 0:t.is(ie.Keyword,pr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,pr.ORDER))&&(null==r?void 0:r.is(ie.Parenthesis))&&(null==(i=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:i.is(ie.Function)))}},{id:ae.AfterOrderByDirection,name:ae.AfterOrderByDirection,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.is(ie.Keyword,pr.DESC))||(null==t?void 0:t.is(ie.Keyword,pr.ASC)))},{id:ae.AfterIsOperator,name:ae.AfterIsOperator,resolve:(e,t,r,n)=>Boolean(null==r?void 0:r.is(ie.Operator,"IS"))},{id:ae.AfterIsNotOperator,name:ae.AfterIsNotOperator,resolve:(e,t,r,n)=>{var o;return Boolean((null==r?void 0:r.is(ie.Operator,"NOT"))&&(null==(o=r.getPreviousNonWhiteSpaceToken())?void 0:o.is(ie.Operator,"IS")))}}]}let Ir={logger:()=>{}},Ar=()=>{};_e.attachDebugger&&_e.createLogger&&(Ir=(0,_e.createLogger)("SQLEditor"),Ar=Ir.logger,(0,_e.attachDebugger)("sqleditor",void 0,Ir));const Cr="column",Nr=[{id:"$__timeFilter(dateColumn)",name:"$__timeFilter(dateColumn)",text:"$__timeFilter",args:[Cr],type:oe.Filter,description:"Will be replaced by a time range filter using the specified column name. For example, dateColumn BETWEEN FROM_UNIXTIME(1494410783) AND FROM_UNIXTIME(1494410983)"},{id:"$__timeFrom()",name:"$__timeFrom()",text:"$__timeFrom",args:[],type:oe.Filter,description:"Will be replaced by the start of the currently active time selection. For example, FROM_UNIXTIME(1494410783)"},{id:"$__timeTo()",name:"$__timeTo()",text:"$__timeTo",args:[],type:oe.Filter,description:"Will be replaced by the end of the currently active time selection. For example, FROM_UNIXTIME(1494410983)"},{id:"$__timeGroup(dateColumn, '5m')",name:"$__timeGroup(dateColumn, '5m')",text:"$__timeGroup",args:[Cr,"'5m'"],type:oe.Value,description:"Will be replaced by an expression usable in GROUP BY clause. For example, *cast(cast(UNIX_TIMESTAMP(dateColumn)/(300) as signed)*300 as signed),*"},{id:"$__table",name:"$__table",text:"$__table",args:[],type:oe.Table,description:"Will be replaced by the query table."},{id:"$__column",name:"$__column",text:"$__column",args:[],type:oe.Column,description:"Will be replaced by the query column."}];function Lr(e,t){var r,n,o;const i={triggerCharacters:["."," ","$",",","(","'"]};t&&Array.isArray(t.builtinFunctions)&&(i.supportedFunctions=()=>t.builtinFunctions.map((e=>({id:e,name:e}))));const a=[];return(null==(r=null==t?void 0:t.comparisonOperators)?void 0:r.length)&&a.push(...t.comparisonOperators.map((e=>({id:e.toLocaleLowerCase(),operator:e,type:ne.Comparison})))),t.logicalOperators=null!=(n=t.logicalOperators)?n:t.operators,(null==(o=null==t?void 0:t.logicalOperators)?void 0:o.length)&&a.push(...t.logicalOperators.map((e=>({id:e.toLocaleLowerCase(),operator:e,type:ne.Logical})))),i.supportedOperators=()=>a,i.supportedMacros=()=>Nr,i}const Pr={id:"standardSql",extensions:[".sql"],aliases:["sql"],mimetypes:[],loader:()=>Promise.resolve().then(p.bind(p,8572)),completionProvider:Lr};var xr=Object.defineProperty,jr=Object.defineProperties,Fr=Object.getOwnPropertyDescriptors,Dr=Object.getOwnPropertySymbols,kr=Object.prototype.hasOwnProperty,Mr=Object.prototype.propertyIsEnumerable,Vr=(e,t,r)=>t in e?xr(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,Ur=(e,t)=>{for(var r in t||(t={}))kr.call(t,r)&&Vr(e,r,t[r]);if(Dr)for(var r of Dr(t))Mr.call(t,r)&&Vr(e,r,t[r]);return e},Br=(e,t)=>jr(e,Fr(t));const Gr=new Map,$r=new Map,qr=({children:e,onBlur:t,onChange:r,query:n,language:o={id:"sql"},width:i,height:a})=>{const s=(0,ge.useRef)(null),l=(0,ge.useRef)(),u=(0,ge.useMemo)((()=>{const e=Tr(),t=`${o.id}-${e}`;return l.current=t,t}),[o.id]);(0,ge.useEffect)((()=>()=>{l.current&&$r.delete(l.current),Ar(`Removing instance cache ${l.current}`,!1,$r)}),[]);const c=(0,ge.useCallback)((()=>{s.current&&s.current.getAction("editor.action.formatDocument").run()}),[]);return ye().createElement("div",{style:{width:i}},ye().createElement(_e.CodeEditor,{height:a||"240px",width:i?i-2+"px":void 0,language:u,value:n,onBlur:e=>{r&&r(e,!1),t&&t(e)},showMiniMap:!1,showLineNumbers:!0,onEditorDidMount:(e,t)=>{s.current=e,e.onDidChangeModelContent((t=>{const n=e.getValue();r&&r(n,!1)})),e.addCommand(t.KeyMod.CtrlCmd|t.KeyCode.Enter,(()=>{const t=e.getValue();r&&r(t,!0)})),e.onKeyUp((t=>{84===t.keyCode&&e.trigger(hr.id,hr.id,{})})),Kr(t,o,u)}}),e&&e({formatQuery:c}))},Kr=async(e,t,r)=>{const n=((e,t)=>{if("sql"!==(null==t?void 0:t.id)&&!t.loader){Ar(`Loading language '${null==t?void 0:t.id}' from Monaco registry`,!1);const r=e.languages.getLanguages().find((({id:e})=>e===(null==t?void 0:t.id)));if(!r)throw Error(`Unknown Monaco language ${null==t?void 0:t.id}`);return Ur(Ur({completionProvider:Lr},r),t)}return Ur(Ur({},Pr),t)})(e,t);if(!n.loader)return;const{language:o,conf:i}=await n.loader(e);if(e.languages.register({id:r}),e.languages.setMonarchTokensProvider(r,Ur({},o)),e.languages.setLanguageConfiguration(r,Ur({},i)),n.formatter&&e.languages.registerDocumentFormattingEditProvider(r,{provideDocumentFormattingEdits:e=>{var r;const n=null==(r=t.formatter)?void 0:r.call(t,e.getValue());return[{range:e.getFullModelRange(),text:n||""}]}}),n.completionProvider){const i=n.completionProvider(e,o);!function(e,t,r){var n;Gr.has(e)||function(e){Gr.has(e)||Gr.set(e,{functions:new T.Registry,operators:new T.Registry,suggestionKinds:new T.Registry(ur),positionResolvers:new T.Registry(Rr),macros:new T.Registry}),Gr.get(e)}(e);const o=Gr.get(e);$r.has(t)||$r.set(t,new T.Registry(_r(o.functions,o.operators,o.macros)));const i=$r.get(t);if(r.supportedFunctions)for(const e of r.supportedFunctions())o.functions.getIfExists(e.id)||o.functions.register(e);if(r.supportedOperators)for(const e of r.supportedOperators())o.operators.getIfExists(e.id)||o.operators.register(Br(Ur({},e),{name:e.id}));if(r.supportedMacros)for(const e of r.supportedMacros())o.macros.getIfExists(e.id)||o.macros.register(Br(Ur({},e),{name:e.id}));if(r.customStatementPlacement)for(const e of r.customStatementPlacement()){const t=o.positionResolvers.getIfExists(e.id);if(t){const r=t.resolve;t.resolve=(...t)=>{const n=e.resolve(...t);return e.overrideDefault?n:r(...t)||n}}else o.positionResolvers.register(Br(Ur({},e),{id:e.id,name:e.id})),o.suggestionKinds.register({id:e.id,name:e.id,kind:[]})}if(r.customSuggestionKinds)for(const e of r.customSuggestionKinds()){if(null==(n=e.applyTo)||n.forEach((t=>{const r=o.suggestionKinds.getIfExists(t);r&&-1===r.kind.indexOf(e.id)&&r.kind.push(e.id)})),e.overrideDefault){const t=i.get(e.id);if(void 0!==t){t.suggestions=e.suggestionsResolver;continue}}i.register({id:e.id,name:e.id,suggestions:e.suggestionsResolver})}if(r.schemas){const e=i.get(se.Schemas),t=e.suggestions;e.suggestions=async(e,n)=>{const o=await t(e,n);if(!r.schemas)return[...o];const i=(await r.schemas.resolve()).map((e=>{var t;return{label:e.name,insertText:`${null!=(t=e.completion)?t:e.name}.`,command:hr,kind:ue.Module,sortText:le.High}}));return[...o,...i]}}if(r.tables){const e=i.get(se.Tables),t=e.suggestions;e.suggestions=async(e,n)=>{var o,i,a,s,l;const u=await t(e,n),c=fr(e.currentToken),d=(null!=(i=null==(o=r.tables)?void 0:o.parseName)?i:vr)(c);return[...u,...(null!=(l=await(null==(s=null==(a=r.tables)?void 0:a.resolve)?void 0:s.call(a,d)))?l:[]).map((e=>{var t;return{label:e.name,insertText:`${null!=(t=e.completion)?t:e.name}${e.completion===e.name?" $0":""}`,insertTextRules:ce.InsertAsSnippet,command:hr,kind:ue.Field,sortText:le.MediumHigh}}))]}}if(r.columns){const e=i.get(se.Columns),t=e.suggestions;e.suggestions=async(e,n)=>{var o,i,a;const s=await t(e,n),l=fr(e.currentToken);let u;const c=null!=(i=null==(o=r.tables)?void 0:o.parseName)?i:vr;l&&l.value&&(u=c(l));let d=[];if(u){const e=await(null==(a=r.columns)?void 0:a.resolve(u));d=e?e.map((e=>{var t;return{label:e.name,insertText:null!=(t=e.completion)?t:e.name,kind:ue.Field,sortText:le.High,detail:e.type,documentation:e.description}})):[]}return[...s,...d]}}}(t.id,r,i);const a=Gr.get(t.id),s=$r.get(r),l=async(t,n,o,i)=>{const l=function(e,t,r,n="sql"){var o;let i=null,a=null;const s=e.editor.tokenize(null!=(o=t.getValue())?o:"",n);for(let o=0;o<s.length;o++){const l=s[o];if(!l.length&&a){const e={offset:0,type:ie.Whitespace,language:n,_tokenBrand:void 0};l.push(e)}for(let n=0;n<l.length;n++){const s=l[n];let u=l.length>n+1?l[n+1].offset+1:t.getLineLength(o+1)+1;const c={startLineNumber:o+1,startColumn:0===s.offset?0:s.offset+1,endLineNumber:o+1,endColumn:u},d=t.getValueInRange(c),p=new cr(s.type,d,c,a,null);e.Range.containsPosition(c,r)&&(i=p),a&&(a.next=p),a=p}}return i}(e,t,n,r),u=function(e,t){var r;const n=null==e?void 0:e.getPreviousNonWhiteSpaceToken(),o=null==e?void 0:e.getPreviousKeyword(),i=null==(r=null==e?void 0:e.getPreviousNonWhiteSpaceToken())?void 0:r.is(ie.Operator,"/"),a=t.list(),s=[];for(const t of a)t.resolve(e,null!=o?o:null,null!=n?n:null,Boolean(i))&&s.push(t.id);return 0===s.length?[ae.Unknown]:s}(l,a.positionResolvers),c=function(e,t){let r=[];for(let n=0;n<e.length;n++){const o=t.getIfExists(e[n]);o&&(r=r.concat(o.kind))}return r}(u,a.suggestionKinds);Ar("Statement position",!1,u),Ar("Suggestion kinds",!1,c);const d={position:n,currentToken:l,statementPosition:u,kind:c,range:e.Range.fromPositions(n)},p=await(async(e,t,r,n,o)=>{let i=[];const a=(null==t?void 0:t.isWhiteSpace())||(null==t?void 0:t.isParenthesis())||(null==t?void 0:t.isIdentifier())&&t.value.endsWith(".")||!(null==t?void 0:t.range)?e.Range.fromPositions(n.position):null==t?void 0:t.range;for(const t of[...new Set(r)]){const r=o.getIfExists(t);if(r){const t=await r.suggestions((s=lr({},n),l={range:a},rr(s,nr(l))),e);i=[...i,...t.map((e=>er(e.label,a,lr({kind:e.kind},e))))]}}var s,l;return Promise.resolve(i)})(e,l,c,d,s);return{suggestions:p}};e.languages.registerCompletionItemProvider(r,Br(Ur({},i),{provideCompletionItems:l}))}};function Wr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function zr({children:e,onChange:t,query:r,width:n,height:o,editorLanguageDefinition:i}){const a=(0,ge.useRef)(r);(0,ge.useEffect)((()=>{a.current=r}),[r]);const s=(0,ge.useCallback)(((e,r)=>{const n=(o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Wr(e,t,r[t])}))}return e}({},a.current),i=null!=(i={rawQuery:!0,rawSql:e})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o);var o,i;t(n,r)}),[t]);return(0,he.jsx)(qr,{width:n,height:o,query:r.rawSql,onChange:s,language:i,children:e})}var Hr=p(990);function Yr(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function Qr(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Yr(i,n,o,a,s,"next",e)}function s(e){Yr(i,n,o,a,s,"throw",e)}a(void 0)}))}}function Xr({db:e,query:t,onValidate:r,range:n}){var o;const[i,a]=(0,ge.useState)(),s=(0,_e.useTheme2)(),l=(0,ge.useMemo)((()=>(0,T.getValueFormat)("bytes")),[]),u=(0,ge.useMemo)((()=>({error:(0,Ge.css)({color:s.colors.error.text,fontSize:s.typography.bodySmall.fontSize,fontFamily:s.typography.fontFamilyMonospace}),valid:(0,Ge.css)({color:s.colors.success.text}),info:(0,Ge.css)({color:s.colors.text.secondary})})),[s]),[c,d]=Ee((p=Qr((function*(t){var r;return""===(null===(r=t.rawSql)||void 0===r?void 0:r.trim())?null:yield e.validateQuery(t,n)})),function(e){return p.apply(this,arguments)}),[e]);var p;const[]=(0,Hr.A)(Qr((function*(){const e=yield d(t);return e&&a(e),null})),1e3,[t,d]);if((0,ge.useEffect)((()=>{(null==i?void 0:i.isError)&&r(!1),(null==i?void 0:i.isValid)&&r(!0)}),[i,r]),!c.value&&!c.loading)return null;const f=(null===(o=c.value)||void 0===o?void 0:o.error)?function(e){const t=e.split(":");return t.length>2?t.slice(2).join(":"):e}(c.value.error):"";return(0,he.jsxs)(he.Fragment,{children:[c.loading&&(0,he.jsxs)("div",{className:u.info,children:[(0,he.jsx)(_e.Spinner,{inline:!0,size:"xs"})," Validating query..."]}),!c.loading&&c.value&&(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(he.Fragment,{children:c.value.isValid&&c.value.statistics&&(0,he.jsxs)("div",{className:u.valid,children:[(0,he.jsx)(_e.Icon,{name:"check"})," This query will process"," ",(0,he.jsx)("strong",{children:(0,T.formattedValueToString)(l(c.value.statistics.TotalBytesProcessed))})," ","when run."]})}),(0,he.jsx)(he.Fragment,{children:c.value.isError&&(0,he.jsx)("div",{className:u.error,children:f})})]})]})}function Jr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Zr(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Jr(e,t,r[t])}))}return e}function en(e){var{showTools:t,onFormatCode:r,onExpand:n,isExpanded:o}=e,i=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["showTools","onFormatCode","onExpand","isExpanded"]);const a=(0,_e.useTheme2)(),[s,l]=(0,ge.useState)(),u=(0,ge.useMemo)((()=>({container:(0,Ge.css)({border:`1px solid ${a.colors.border.medium}`,borderTop:"none",padding:a.spacing(.5,.5,.5,.5),display:"flex",flexGrow:1,justifyContent:"space-between",fontSize:a.typography.bodySmall.fontSize}),error:(0,Ge.css)({color:a.colors.error.text,fontSize:a.typography.bodySmall.fontSize,fontFamily:a.typography.fontFamilyMonospace}),valid:(0,Ge.css)({color:a.colors.success.text}),info:(0,Ge.css)({color:a.colors.text.secondary}),hint:(0,Ge.css)({color:a.colors.text.disabled,whiteSpace:"nowrap",cursor:"help"})})),[a]);let c={};return t||void 0!==s||(c={height:0,padding:0,visibility:"hidden"}),(0,he.jsxs)("div",{className:u.container,style:c,children:[(0,he.jsx)("div",{children:i.onValidate&&(0,he.jsx)(Xr,(d=Zr({},i),p={onValidate:e=>{l(e),i.onValidate(e)}},p=null!=p?p:{},Object.getOwnPropertyDescriptors?Object.defineProperties(d,Object.getOwnPropertyDescriptors(p)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(p)).forEach((function(e){Object.defineProperty(d,e,Object.getOwnPropertyDescriptor(p,e))})),d))}),t&&(0,he.jsx)("div",{children:(0,he.jsxs)(_e.HorizontalGroup,{spacing:"sm",children:[r&&(0,he.jsx)(_e.IconButton,{onClick:()=>{var e;(0,pe.reportInteraction)("grafana_sql_query_formatted",{datasource:null===(e=i.query.datasource)||void 0===e?void 0:e.type}),r()},name:"brackets-curly",size:"xs",tooltip:"Format query"}),n&&(0,he.jsx)(_e.IconButton,{onClick:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_expand",{datasource:null===(e=i.query.datasource)||void 0===e?void 0:e.type,expanded:!o}),n(!o)},name:o?"angle-up":"angle-down",size:"xs",tooltip:o?"Collapse editor":"Expand editor"}),(0,he.jsx)(_e.Tooltip,{content:"Hit CTRL/CMD+Return to run query",children:(0,he.jsx)(_e.Icon,{className:u.hint,name:"keyboard"})})]})})]});var d,p}function tn({db:e,query:t,onChange:r,onRunQuery:n,onValidate:o,queryToValidate:i,range:a}){const s=(0,_e.useTheme2)(),l=(0,_e.useStyles2)(rn),[u,c]=(0,ge.useState)(!1),[d,p]=Ut(),[f,v]=Ut(),h=(0,ge.useMemo)((()=>e.getEditorLanguageDefinition()),[e]),g=(n,s)=>(0,he.jsx)(zr,{editorLanguageDefinition:h,query:t,width:n,height:s?s-p.height:void 0,onChange:r,children:({formatQuery:t})=>(0,he.jsx)("div",{ref:d,children:(0,he.jsx)(en,{db:e,query:i,onValidate:o,onFormatCode:t,showTools:!0,range:a,onExpand:c,isExpanded:u})})}),y=(e=!1)=>e?(0,he.jsx)(Ht,{children:({width:e,height:t})=>g(e,t)}):(0,he.jsx)("div",{ref:f,children:g()});return(0,he.jsxs)(he.Fragment,{children:[u?(0,he.jsx)("div",{style:{width:v.width,height:v.height,background:s.colors.background.primary,display:"flex",alignItems:"center",justifyContent:"center"},children:"Editing in expanded code editor"}):y(),u&&(0,he.jsx)(_e.Modal,{title:`Query ${t.refId}`,closeOnBackdropClick:!1,closeOnEscape:!1,className:l.modal,contentClassName:l.modalContent,isOpen:u,onDismiss:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_expand",{datasource:null===(e=t.datasource)||void 0===e?void 0:e.type,expanded:!1}),c(!1)},children:y(!0)})]})}function rn(e){return{modal:(0,Ge.css)({width:"95vw",height:"95vh"}),modalContent:(0,Ge.css)({height:"100%",paddingTop:0})}}const nn=({children:e})=>ye().createElement(ut,{gap:.5,direction:"column"},e);var on=p(7409);function an(e){return on.Ay.format(e).replace(/(\$ \{ .* \})|(\$ __)|(\$ \w+)/g,(e=>e.replace(/\s/g,"")))}function sn({rawSql:e,datasourceType:t}){const[r,n]=Pe(),o=(0,_e.useStyles2)(ln),i=(0,he.jsxs)("div",{className:o.labelWrapper,children:[(0,he.jsx)("span",{className:o.label,children:"Preview"}),(0,he.jsx)(_e.IconButton,{tooltip:"Copy to clipboard",onClick:()=>(e=>{n(e),(0,pe.reportInteraction)("grafana_sql_preview_copied",{datasource:t})})(e),name:"copy"})]});return(0,he.jsx)(_e.Field,{label:i,className:o.grow,children:(0,he.jsx)(_e.CodeEditor,{language:"sql",height:80,value:an(e),monacoOptions:{scrollbar:{vertical:"hidden"},scrollBeyondLastLine:!1},readOnly:!0,showMiniMap:!1})})}function ln(e){return{grow:(0,Ge.css)({flexGrow:1}),label:(0,Ge.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),labelWrapper:(0,Ge.css)({display:"flex",justifyContent:"space-between",paddingBottom:e.spacing(.5)})}}function un(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function cn({query:e,onQueryChange:t,db:r}){const n=(0,ge.useCallback)((n=>{const o=(0,r.toRawSql)({sql:n,dataset:e.dataset,table:e.table,refId:e.refId}),i=(a=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){un(e,t,r[t])}))}return e}({},e),s=null!=(s={sql:n,rawSql:o})?s:{},Object.getOwnPropertyDescriptors?Object.defineProperties(a,Object.getOwnPropertyDescriptors(s)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(s)).forEach((function(e){Object.defineProperty(a,e,Object.getOwnPropertyDescriptor(s,e))})),a);var a,s;t(i)}),[r,t,e]);return{onSqlChange:n}}const dn=ye().forwardRef((function({items:e,renderItem:t,onChange:r},n){return ye().createElement(ut,null,e.map(((n,o)=>ye().createElement("div",{key:o},t(n,(t=>((t,n)=>{const o=[...e];o[t]=n,r(o)})(o,t)),(()=>(t=>{const n=[...e];n.splice(t,1),r(n)})(o)))))),ye().createElement(_e.Button,{ref:n,onClick:()=>{const t=[...e,{}];r(t)},variant:"secondary",size:"md",icon:"plus","aria-label":"Add",type:"button"}))})),pn=({children:e})=>{const t=(0,_e.useStyles2)(vn),r=ge.Children.map(e,(e=>(0,ge.isValidElement)(e)&&e.props.invalid?(0,ge.cloneElement)(e,{className:(0,Ge.cx)(e.props.className,t.invalidChild)}):e));return ye().createElement("div",{className:t.root},r)},fn=["","base","hovered","invalid","focused"],vn=()=>({root:(0,Ge.css)({display:"flex","> *":{"&:not(:first-child)":{marginLeft:-1},"&:first-child":{borderTopRightRadius:0,borderBottomRightRadius:0},"&:last-child":{borderTopLeftRadius:0,borderBottomLeftRadius:0},"&:not(:first-child):not(:last-child)":{borderRadius:0},position:"relative",zIndex:fn.indexOf("base"),"&:hover":{zIndex:fn.indexOf("hovered")},"&:focus-within":{zIndex:fn.indexOf("focused")}}}),invalidChild:(0,Ge.css)({zIndex:fn.indexOf("invalid")})});var hn=Object.defineProperty,gn=Object.defineProperties,yn=Object.getOwnPropertyDescriptors,mn=Object.getOwnPropertySymbols,bn=Object.prototype.hasOwnProperty,En=Object.prototype.propertyIsEnumerable,On=(e,t,r)=>t in e?hn(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const Sn=e=>{var t=e,{className:r}=t,n=((e,t)=>{var r={};for(var n in e)bn.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&mn)for(var n of mn(e))t.indexOf(n)<0&&En.call(e,n)&&(r[n]=e[n]);return r})(t,["className"]);const o=(0,_e.useStyles2)(Tn);return ye().createElement(_e.Button,(i=((e,t)=>{for(var r in t||(t={}))bn.call(t,r)&&On(e,r,t[r]);if(mn)for(var r of mn(t))En.call(t,r)&&On(e,r,t[r]);return e})({},n),a={className:(0,Ge.cx)(r,o.button)},gn(i,yn(a))));var i,a},Tn=e=>({button:(0,Ge.css)({paddingLeft:e.spacing(1.5),paddingRight:e.spacing(1.5)})});function _n(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function wn({sql:e,columns:t,onSqlChange:r}){const n=(0,ge.useCallback)((t=>{const n=t.map((e=>{var t;return Re(null===(t=e.property)||void 0===t?void 0:t.name)})),o=(i=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){_n(e,t,r[t])}))}return e}({},e),a=null!=(a={groupBy:n})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i);var i,a;r(o)}),[r,e]);return(0,he.jsx)(dn,{items:e.groupBy,onChange:n,renderItem:Rn({options:t})})}function Rn({options:e}){return function(t,r,n){var o;return(0,he.jsxs)(pn,{children:[(0,he.jsx)(_e.Select,{value:(null===(o=t.property)||void 0===o?void 0:o.name)?(0,T.toOption)(t.property.name):null,"aria-label":"Group by",options:e,menuShouldPortal:!0,onChange:({value:e})=>e&&r(Re(e))}),(0,he.jsx)(Sn,{title:"Remove group by column",icon:"times",variant:"secondary",onClick:n})]})}}function In({fields:e,query:t,onQueryChange:r,db:n}){const{onSqlChange:o}=cn({query:t,onQueryChange:r,db:n});return(0,he.jsx)(wn,{columns:e,sql:t.sql,onSqlChange:o})}function An(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Cn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){An(e,t,r[t])}))}return e}function Nn(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Ln=[{description:"Sort by ascending",value:"ASC",icon:"sort-amount-up"},{description:"Sort by descending",value:"DESC",icon:"sort-amount-down"}];function Pn({sql:e,onSqlChange:t,columns:r,showOffset:n}){var o,i;const a=(0,ge.useCallback)((r=>{const n=Nn(Cn({},e),{orderByDirection:r});t(n)}),[t,e]),s=(0,ge.useCallback)((r=>{const n=Nn(Cn({},e),{limit:Number.parseInt(r.currentTarget.value,10)});t(n)}),[t,e]),l=(0,ge.useCallback)((r=>{const n=Nn(Cn({},e),{offset:Number.parseInt(r.currentTarget.value,10)});t(n)}),[t,e]),u=(0,ge.useCallback)((r=>{const n=Nn(Cn({},e),{orderBy:(o=null==r?void 0:r.value,{type:Te.Property,property:{type:Se.String,name:o}})});var o;null===r&&(n.orderByDirection=void 0),t(n)}),[t,e]);return(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(Et,{label:"Order by",width:25,children:(0,he.jsxs)(pn,{children:[(0,he.jsx)(_e.Select,{"aria-label":"Order by",options:r,value:(null===(o=e.orderBy)||void 0===o?void 0:o.property.name)?(0,T.toOption)(e.orderBy.property.name):null,isClearable:!0,menuShouldPortal:!0,onChange:u}),(0,he.jsx)(_e.Space,{h:1.5}),(0,he.jsx)(_e.RadioButtonGroup,{options:Ln,disabled:!(null==e||null===(i=e.orderBy)||void 0===i?void 0:i.property.name),value:e.orderByDirection,onChange:a})]})}),(0,he.jsx)(Et,{label:"Limit",optional:!0,width:25,children:(0,he.jsx)(_e.Input,{type:"number",min:0,id:(0,fe.uniqueId)("limit-"),value:e.limit||"",onChange:s})}),n&&(0,he.jsx)(Et,{label:"Offset",optional:!0,width:25,children:(0,he.jsx)(_e.Input,{type:"number",id:(0,fe.uniqueId)("offset-"),value:e.offset||"",onChange:l})})]})}function xn({fields:e,query:t,onQueryChange:r,db:n}){const{onSqlChange:o}=cn({query:t,onQueryChange:r,db:n});let i=[];if(e){var a,s;const r=null===(s=t.sql)||void 0===s||null===(a=s.columns)||void 0===a?void 0:a.map(((e,t)=>{var r,n;const o=e.name?`${e.name}(${null===(r=e.parameters)||void 0===r?void 0:r.map((e=>e.name))})`:null===(n=e.parameters)||void 0===n?void 0:n.map((e=>e.name));return{value:o,label:`${t+1} - ${o}`}}));i=[{value:"",label:"Selected columns",options:r,expanded:!0},...e]}return(0,he.jsx)(Pn,{sql:t.sql,onSqlChange:o,columns:i})}const jn=["AVG","COUNT","MAX","MIN","SUM"],Fn=["$__time","$__timeEpoch","$__timeFilter","$__timeFrom","$__timeTo","$__timeGroup","$__timeGroupAlias","$__unixEpochFilter","$__unixEpochNanoFilter","$__unixEpochNanoFrom","$__unixEpochNanoTo","$__unixEpochGroup","$__unixEpochGroupAlias"];function Dn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function kn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Dn(e,t,r[t])}))}return e}function Mn(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Vn={label:"*",value:"*"};function Un({sql:e,format:t,columns:r,onSqlChange:n,functions:o}){var i;const a=(0,_e.useStyles2)(Bn),s=[Vn,...r||[]],l=[];t===S.Timeseries&&(l.push({label:"time",value:"time"}),l.push({label:"value",value:"value"}));const u=(0,ge.useCallback)(((t,r)=>o=>{var i,a;let s=kn({},t);(null===(i=t.parameters)||void 0===i?void 0:i.length)?s.parameters=t.parameters.map((e=>e.type===Te.FunctionParameter?Mn(kn({},e),{name:o.value}):e)):s.parameters=[{type:Te.FunctionParameter,name:o.value}];const l=Mn(kn({},e),{columns:null===(a=e.columns)||void 0===a?void 0:a.map(((e,t)=>t===r?s:e))});n(l)}),[n,e]),c=(0,ge.useCallback)(((t,r)=>o=>{var i;const a=Mn(kn({},t),{name:null==o?void 0:o.value}),s=Mn(kn({},e),{columns:null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>t===r?a:e))});n(s)}),[n,e]),d=(0,ge.useCallback)(((t,r)=>o=>{var i;let a=kn({},t);var s;null!==o?a=Mn(kn({},t),{alias:`"${null==o||null===(s=o.value)||void 0===s?void 0:s.trim()}"`}):delete a.alias;const l=Mn(kn({},e),{columns:null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>t===r?a:e))});n(l)}),[n,e]),p=(0,ge.useCallback)((t=>()=>{const r=[...e.columns];r.splice(t,1);const o=Mn(kn({},e),{columns:r});n(o)}),[n,e]),f=(0,ge.useCallback)((()=>{const t=Mn(kn({},e),{columns:[...e.columns,Ie()]});n(t)}),[n,e]);return(0,he.jsxs)(ut,{gap:2,wrap:!0,direction:"column",children:[null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>(0,he.jsx)("div",{children:(0,he.jsxs)(ut,{gap:2,alignItems:"end",children:[(0,he.jsx)(Et,{label:"Column",width:25,children:(0,he.jsx)(_e.Select,{value:Gn(e),"data-testid":Be.components.SQLQueryEditor.selectColumn,options:s,inputId:`select-column-${t}-${(0,fe.uniqueId)()}`,menuShouldPortal:!0,allowCustomValue:!0,onChange:u(e,t)})}),(0,he.jsx)(Et,{label:"Aggregation",optional:!0,width:25,children:(0,he.jsx)(_e.Select,{value:e.name?(0,T.toOption)(e.name):null,inputId:`select-aggregation-${t}-${(0,fe.uniqueId)()}`,"data-testid":Be.components.SQLQueryEditor.selectAggregation,isClearable:!0,menuShouldPortal:!0,allowCustomValue:!0,options:o,onChange:c(e,t)})}),(0,he.jsx)(Et,{label:"Alias",optional:!0,width:15,children:(0,he.jsx)(_e.Select,{value:e.alias?(0,T.toOption)(e.alias):null,inputId:`select-alias-${t}-${(0,fe.uniqueId)()}`,"data-testid":Be.components.SQLQueryEditor.selectAlias,options:l,onChange:d(e,t),isClearable:!0,menuShouldPortal:!0,allowCustomValue:!0})}),(0,he.jsx)(_e.Button,{title:"Remove column",type:"button",icon:"trash-alt",variant:"secondary",size:"md",onClick:p(t)})]})},t))),(0,he.jsx)(_e.Button,{type:"button",onClick:f,variant:"secondary",title:"Add column",size:"md",icon:"plus",className:a.addButton})]})}const Bn=()=>({addButton:(0,Ge.css)({alignSelf:"flex-start"})});function Gn({parameters:e}){const t=null==e?void 0:e.find((e=>e.type===Te.FunctionParameter));return(null==t?void 0:t.name)?(0,T.toOption)(t.name):null}function $n({fields:e,query:t,onQueryChange:r,db:n}){var o;const{onSqlChange:i}=cn({query:t,onQueryChange:r,db:n}),a=[...jn,...(null===(o=n.functions)||void 0===o?void 0:o.call(n))||[]].map(T.toOption);return(0,he.jsx)(Un,{columns:e,sql:t.sql,format:t.format,functions:a,onSqlChange:i})}var qn=p(1777);function Kn(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Wn(e){return Wn="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},Wn(e)}function zn(e){var t=function(e,t){if("object"!=Wn(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var n=r.call(e,"string");if("object"!=Wn(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return String(e)}(e);return"symbol"==Wn(t)?t:t+""}function Hn(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,zn(n.key),n)}}function Yn(e,t,r){return t&&Hn(e.prototype,t),r&&Hn(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function Qn(e,t){if(t&&("object"==Wn(t)||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e)}function Xn(e){return Xn=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)},Xn(e)}function Jn(e,t){return Jn=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e},Jn(e,t)}function Zn(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&Jn(e,t)}function eo(e,t,r){return(t=zn(t))in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function to(e){if(Array.isArray(e))return e}function ro(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=Array(t);r<t;r++)n[r]=e[r];return n}function no(e,t){if(e){if("string"==typeof e)return ro(e,t);var r={}.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?ro(e,t):void 0}}function oo(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function io(e,t){return to(e)||function(e,t){var r=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=r){var n,o,i,a,s=[],l=!0,u=!1;try{if(i=(r=r.call(e)).next,0===t){if(Object(r)!==r)return;l=!1}else for(;!(l=(n=i.call(r)).done)&&(s.push(n.value),s.length!==t);l=!0);}catch(e){u=!0,o=e}finally{try{if(!l&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(u)throw o}}return s}}(e,t)||no(e,t)||oo()}function ao(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}function so(e){return function(e){if(Array.isArray(e))return ro(e)}(e)||ao(e)||no(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var lo="delete",uo=5,co=1<<uo,po=co-1,fo={};function vo(e){e&&(e.value=!0)}function ho(){}function go(e){return void 0===e.size&&(e.size=e.__iterate(mo)),e.size}function yo(e,t){if("number"!=typeof t){var r=t>>>0;if(""+r!==t||4294967295===r)return NaN;t=r}return t<0?go(e)+t:t}function mo(){return!0}function bo(e,t,r){return(0===e&&!To(e)||void 0!==r&&e<=-r)&&(void 0===t||void 0!==r&&t>=r)}function Eo(e,t){return So(e,t,0)}function Oo(e,t){return So(e,t,t)}function So(e,t,r){return void 0===e?r:To(e)?t===1/0?t:0|Math.max(0,t+e):void 0===t||t===e?e:0|Math.min(t,e)}function To(e){return e<0||0===e&&1/e==-1/0}var _o="@@__IMMUTABLE_ITERABLE__@@";function wo(e){return Boolean(e&&e[_o])}var Ro="@@__IMMUTABLE_KEYED__@@";function Io(e){return Boolean(e&&e[Ro])}var Ao="@@__IMMUTABLE_INDEXED__@@";function Co(e){return Boolean(e&&e[Ao])}function No(e){return Io(e)||Co(e)}var Lo=function(e){return wo(e)?e:ni(e)},Po=function(e){function t(e){return Io(e)?e:oi(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(Lo),xo=function(e){function t(e){return Co(e)?e:ii(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(Lo),jo=function(e){function t(e){return wo(e)&&!No(e)?e:ai(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(Lo);Lo.Keyed=Po,Lo.Indexed=xo,Lo.Set=jo;var Fo="@@__IMMUTABLE_SEQ__@@";function Do(e){return Boolean(e&&e[Fo])}var ko="@@__IMMUTABLE_RECORD__@@";function Mo(e){return Boolean(e&&e[ko])}function Vo(e){return wo(e)||Mo(e)}var Uo="@@__IMMUTABLE_ORDERED__@@";function Bo(e){return Boolean(e&&e[Uo])}var Go=0,$o=1,qo=2,Ko="function"==typeof Symbol&&Symbol.iterator,Wo="@@iterator",zo=Ko||Wo,Ho=function(e){this.next=e};function Yo(e,t,r,n){var o=0===e?t:1===e?r:[t,r];return n?n.value=o:n={value:o,done:!1},n}function Qo(){return{value:void 0,done:!0}}function Xo(e){return!!Array.isArray(e)||!!ei(e)}function Jo(e){return e&&"function"==typeof e.next}function Zo(e){var t=ei(e);return t&&t.call(e)}function ei(e){var t=e&&(Ko&&e[Ko]||e[Wo]);if("function"==typeof t)return t}Ho.prototype.toString=function(){return"[Iterator]"},Ho.KEYS=Go,Ho.VALUES=$o,Ho.ENTRIES=qo,Ho.prototype.inspect=Ho.prototype.toSource=function(){return this.toString()},Ho.prototype[zo]=function(){return this};var ti=Object.prototype.hasOwnProperty;function ri(e){return!(!Array.isArray(e)&&"string"!=typeof e)||e&&"object"==typeof e&&Number.isInteger(e.length)&&e.length>=0&&(0===e.length?1===Object.keys(e).length:e.hasOwnProperty(e.length-1))}var ni=function(e){function t(e){return null==e?di():Vo(e)?e.toSeq():function(e){var t,r,n=vi(e);if(n)return(r=ei(t=e))&&r===t.entries?n.fromEntrySeq():function(e){var t=ei(e);return t&&t===e.keys}(e)?n.toSetSeq():n;if("object"==typeof e)return new li(e);throw new TypeError("Expected Array or collection object of values, or keyed object: "+e)}(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toSeq=function(){return this},t.prototype.toString=function(){return this.__toString("Seq {","}")},t.prototype.cacheResult=function(){return!this._cache&&this.__iterateUncached&&(this._cache=this.entrySeq().toArray(),this.size=this._cache.length),this},t.prototype.__iterate=function(e,t){var r=this._cache;if(r){for(var n=r.length,o=0;o!==n;){var i=r[t?n-++o:o++];if(!1===e(i[1],i[0],this))break}return o}return this.__iterateUncached(e,t)},t.prototype.__iterator=function(e,t){var r=this._cache;if(r){var n=r.length,o=0;return new Ho((function(){if(o===n)return{value:void 0,done:!0};var i=r[t?n-++o:o++];return Yo(e,i[0],i[1])}))}return this.__iteratorUncached(e,t)},t}(Lo),oi=function(e){function t(e){return null==e?di().toKeyedSeq():wo(e)?Io(e)?e.toSeq():e.fromEntrySeq():Mo(e)?e.toSeq():pi(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toKeyedSeq=function(){return this},t}(ni),ii=function(e){function t(e){return null==e?di():wo(e)?Io(e)?e.entrySeq():e.toIndexedSeq():Mo(e)?e.toSeq().entrySeq():fi(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return t(arguments)},t.prototype.toIndexedSeq=function(){return this},t.prototype.toString=function(){return this.__toString("Seq [","]")},t}(ni),ai=function(e){function t(e){return(wo(e)&&!No(e)?e:ii(e)).toSetSeq()}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return t(arguments)},t.prototype.toSetSeq=function(){return this},t}(ni);ni.isSeq=Do,ni.Keyed=oi,ni.Set=ai,ni.Indexed=ii,ni.prototype[Fo]=!0;var si=function(e){function t(e){this._array=e,this.size=e.length}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return this.has(e)?this._array[yo(this,e)]:t},t.prototype.__iterate=function(e,t){for(var r=this._array,n=r.length,o=0;o!==n;){var i=t?n-++o:o++;if(!1===e(r[i],i,this))break}return o},t.prototype.__iterator=function(e,t){var r=this._array,n=r.length,o=0;return new Ho((function(){if(o===n)return{value:void 0,done:!0};var i=t?n-++o:o++;return Yo(e,i,r[i])}))},t}(ii),li=function(e){function t(e){var t=Object.keys(e).concat(Object.getOwnPropertySymbols?Object.getOwnPropertySymbols(e):[]);this._object=e,this._keys=t,this.size=t.length}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return void 0===t||this.has(e)?this._object[e]:t},t.prototype.has=function(e){return ti.call(this._object,e)},t.prototype.__iterate=function(e,t){for(var r=this._object,n=this._keys,o=n.length,i=0;i!==o;){var a=n[t?o-++i:i++];if(!1===e(r[a],a,this))break}return i},t.prototype.__iterator=function(e,t){var r=this._object,n=this._keys,o=n.length,i=0;return new Ho((function(){if(i===o)return{value:void 0,done:!0};var a=n[t?o-++i:i++];return Yo(e,a,r[a])}))},t}(oi);li.prototype[Uo]=!0;var ui,ci=function(e){function t(e){this._collection=e,this.size=e.length||e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.__iterateUncached=function(e,t){if(t)return this.cacheResult().__iterate(e,t);var r=Zo(this._collection),n=0;if(Jo(r))for(var o;!(o=r.next()).done&&!1!==e(o.value,n++,this););return n},t.prototype.__iteratorUncached=function(e,t){if(t)return this.cacheResult().__iterator(e,t);var r=Zo(this._collection);if(!Jo(r))return new Ho(Qo);var n=0;return new Ho((function(){var t=r.next();return t.done?t:Yo(e,n++,t.value)}))},t}(ii);function di(){return ui||(ui=new si([]))}function pi(e){var t=vi(e);if(t)return t.fromEntrySeq();if("object"==typeof e)return new li(e);throw new TypeError("Expected Array or collection object of [k, v] entries, or keyed object: "+e)}function fi(e){var t=vi(e);if(t)return t;throw new TypeError("Expected Array or collection object of values: "+e)}function vi(e){return ri(e)?new si(e):Xo(e)?new ci(e):void 0}var hi="@@__IMMUTABLE_MAP__@@";function gi(e){return Boolean(e&&e[hi])}function yi(e){return gi(e)&&Bo(e)}function mi(e){return Boolean(e&&"function"==typeof e.equals&&"function"==typeof e.hashCode)}function bi(e,t){if(e===t||e!=e&&t!=t)return!0;if(!e||!t)return!1;if("function"==typeof e.valueOf&&"function"==typeof t.valueOf){if((e=e.valueOf())===(t=t.valueOf())||e!=e&&t!=t)return!0;if(!e||!t)return!1}return!!(mi(e)&&mi(t)&&e.equals(t))}var Ei="function"==typeof Math.imul&&-2===Math.imul(4294967295,2)?Math.imul:function(e,t){var r=65535&(e|=0),n=65535&(t|=0);return r*n+((e>>>16)*n+r*(t>>>16)<<16>>>0)|0};function Oi(e){return e>>>1&1073741824|3221225471&e}var Si=Object.prototype.valueOf;function Ti(e){if(null==e)return _i(e);if("function"==typeof e.hashCode)return Oi(e.hashCode(e));var t,r,n,o=(t=e).valueOf!==Si&&"function"==typeof t.valueOf?t.valueOf(t):t;if(null==o)return _i(o);switch(typeof o){case"boolean":return o?1108378657:1108378656;case"number":return function(e){if(e!=e||e===1/0)return 0;var t=0|e;for(t!==e&&(t^=4294967295*e);e>4294967295;)t^=e/=4294967295;return Oi(t)}(o);case"string":return o.length>ji?(void 0===(n=ki[r=o])&&(n=wi(r),Di===Fi&&(Di=0,ki={}),Di++,ki[r]=n),n):wi(o);case"object":case"function":return function(e){var t;if(Ni&&void 0!==(t=Ci.get(e)))return t;if(void 0!==(t=e[xi]))return t;if(!Ii){if(void 0!==(t=e.propertyIsEnumerable&&e.propertyIsEnumerable[xi]))return t;if(void 0!==(t=function(e){if(e&&e.nodeType>0)switch(e.nodeType){case 1:return e.uniqueID;case 9:return e.documentElement&&e.documentElement.uniqueID}}(e)))return t}if(t=Ai(),Ni)Ci.set(e,t);else{if(void 0!==Ri&&!1===Ri(e))throw new Error("Non-extensible objects are not allowed as keys.");if(Ii)Object.defineProperty(e,xi,{enumerable:!1,configurable:!1,writable:!1,value:t});else if(void 0!==e.propertyIsEnumerable&&e.propertyIsEnumerable===e.constructor.prototype.propertyIsEnumerable)e.propertyIsEnumerable=function(){return this.constructor.prototype.propertyIsEnumerable.apply(this,arguments)},e.propertyIsEnumerable[xi]=t;else{if(void 0===e.nodeType)throw new Error("Unable to set a non-enumerable property on object.");e[xi]=t}}return t}(o);case"symbol":return function(e){var t=Li[e];return void 0!==t||(t=Ai(),Li[e]=t),t}(o);default:if("function"==typeof o.toString)return wi(o.toString());throw new Error("Value type "+typeof o+" cannot be hashed.")}}function _i(e){return null===e?1108378658:1108378659}function wi(e){for(var t=0,r=0;r<e.length;r++)t=31*t+e.charCodeAt(r)|0;return Oi(t)}var Ri=Object.isExtensible,Ii=function(){try{return Object.defineProperty({},"@",{}),!0}catch(e){return!1}}();function Ai(){var e=++Pi;return 1073741824&Pi&&(Pi=0),e}var Ci,Ni="function"==typeof WeakMap;Ni&&(Ci=new WeakMap);var Li=Object.create(null),Pi=0,xi="__immutablehash__";"function"==typeof Symbol&&(xi=Symbol(xi));var ji=16,Fi=255,Di=0,ki={},Mi=function(e){function t(e,t){this._iter=e,this._useKeys=t,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return this._iter.get(e,t)},t.prototype.has=function(e){return this._iter.has(e)},t.prototype.valueSeq=function(){return this._iter.valueSeq()},t.prototype.reverse=function(){var e=this,t=qi(this,!0);return this._useKeys||(t.valueSeq=function(){return e._iter.toSeq().reverse()}),t},t.prototype.map=function(e,t){var r=this,n=$i(this,e,t);return this._useKeys||(n.valueSeq=function(){return r._iter.toSeq().map(e,t)}),n},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t,n){return e(t,n,r)}),t)},t.prototype.__iterator=function(e,t){return this._iter.__iterator(e,t)},t}(oi);Mi.prototype[Uo]=!0;var Vi=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.includes=function(e){return this._iter.includes(e)},t.prototype.__iterate=function(e,t){var r=this,n=0;return t&&go(this),this._iter.__iterate((function(o){return e(o,t?r.size-++n:n++,r)}),t)},t.prototype.__iterator=function(e,t){var r=this,n=this._iter.__iterator($o,t),o=0;return t&&go(this),new Ho((function(){var i=n.next();return i.done?i:Yo(e,t?r.size-++o:o++,i.value,i)}))},t}(ii),Ui=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.has=function(e){return this._iter.includes(e)},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t){return e(t,t,r)}),t)},t.prototype.__iterator=function(e,t){var r=this._iter.__iterator($o,t);return new Ho((function(){var t=r.next();return t.done?t:Yo(e,t.value,t.value,t)}))},t}(ai),Bi=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.entrySeq=function(){return this._iter.toSeq()},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t){if(t){ea(t);var n=wo(t);return e(n?t.get(1):t[1],n?t.get(0):t[0],r)}}),t)},t.prototype.__iterator=function(e,t){var r=this._iter.__iterator($o,t);return new Ho((function(){for(;;){var t=r.next();if(t.done)return t;var n=t.value;if(n){ea(n);var o=wo(n);return Yo(e,o?n.get(0):n[0],o?n.get(1):n[1],t)}}}))},t}(oi);function Gi(e){var t=ra(e);return t._iter=e,t.size=e.size,t.flip=function(){return e},t.reverse=function(){var t=e.reverse.apply(this);return t.flip=function(){return e.reverse()},t},t.has=function(t){return e.includes(t)},t.includes=function(t){return e.has(t)},t.cacheResult=na,t.__iterateUncached=function(t,r){var n=this;return e.__iterate((function(e,r){return!1!==t(r,e,n)}),r)},t.__iteratorUncached=function(t,r){if(t===qo){var n=e.__iterator(t,r);return new Ho((function(){var e=n.next();if(!e.done){var t=e.value[0];e.value[0]=e.value[1],e.value[1]=t}return e}))}return e.__iterator(t===$o?Go:$o,r)},t}function $i(e,t,r){var n=ra(e);return n.size=e.size,n.has=function(t){return e.has(t)},n.get=function(n,o){var i=e.get(n,fo);return i===fo?o:t.call(r,i,n,e)},n.__iterateUncached=function(n,o){var i=this;return e.__iterate((function(e,o,a){return!1!==n(t.call(r,e,o,a),o,i)}),o)},n.__iteratorUncached=function(n,o){var i=e.__iterator(qo,o);return new Ho((function(){var o=i.next();if(o.done)return o;var a=o.value,s=a[0];return Yo(n,s,t.call(r,a[1],s,e),o)}))},n}function qi(e,t){var r=this,n=ra(e);return n._iter=e,n.size=e.size,n.reverse=function(){return e},e.flip&&(n.flip=function(){var t=Gi(e);return t.reverse=function(){return e.flip()},t}),n.get=function(r,n){return e.get(t?r:-1-r,n)},n.has=function(r){return e.has(t?r:-1-r)},n.includes=function(t){return e.includes(t)},n.cacheResult=na,n.__iterate=function(r,n){var o=this,i=0;return n&&go(e),e.__iterate((function(e,a){return r(e,t?a:n?o.size-++i:i++,o)}),!n)},n.__iterator=function(n,o){var i=0;o&&go(e);var a=e.__iterator(qo,!o);return new Ho((function(){var e=a.next();if(e.done)return e;var s=e.value;return Yo(n,t?s[0]:o?r.size-++i:i++,s[1],e)}))},n}function Ki(e,t,r,n){var o=ra(e);return n&&(o.has=function(n){var o=e.get(n,fo);return o!==fo&&!!t.call(r,o,n,e)},o.get=function(n,o){var i=e.get(n,fo);return i!==fo&&t.call(r,i,n,e)?i:o}),o.__iterateUncached=function(o,i){var a=this,s=0;return e.__iterate((function(e,i,l){if(t.call(r,e,i,l))return s++,o(e,n?i:s-1,a)}),i),s},o.__iteratorUncached=function(o,i){var a=e.__iterator(qo,i),s=0;return new Ho((function(){for(;;){var i=a.next();if(i.done)return i;var l=i.value,u=l[0],c=l[1];if(t.call(r,c,u,e))return Yo(o,n?u:s++,c,i)}}))},o}function Wi(e,t,r,n){var o=e.size;if(bo(t,r,o))return e;if(void 0===o&&(t<0||r<0))return Wi(e.toSeq().cacheResult(),t,r,n);var i,a=Eo(t,o),s=Oo(r,o)-a;s==s&&(i=s<0?0:s);var l=ra(e);return l.size=0===i?i:e.size&&i||void 0,!n&&Do(e)&&i>=0&&(l.get=function(t,r){return(t=yo(this,t))>=0&&t<i?e.get(t+a,r):r}),l.__iterateUncached=function(t,r){var o=this;if(0===i)return 0;if(r)return this.cacheResult().__iterate(t,r);var s=0,l=!0,u=0;return e.__iterate((function(e,r){if(!l||!(l=s++<a))return u++,!1!==t(e,n?r:u-1,o)&&u!==i})),u},l.__iteratorUncached=function(t,r){if(0!==i&&r)return this.cacheResult().__iterator(t,r);if(0===i)return new Ho(Qo);var o=e.__iterator(t,r),s=0,l=0;return new Ho((function(){for(;s++<a;)o.next();if(++l>i)return{value:void 0,done:!0};var e=o.next();return n||t===$o||e.done?e:Yo(t,l-1,t===Go?void 0:e.value[1],e)}))},l}function zi(e,t,r,n){var o=ra(e);return o.__iterateUncached=function(o,i){var a=this;if(i)return this.cacheResult().__iterate(o,i);var s=!0,l=0;return e.__iterate((function(e,i,u){if(!s||!(s=t.call(r,e,i,u)))return l++,o(e,n?i:l-1,a)})),l},o.__iteratorUncached=function(o,i){var a=this;if(i)return this.cacheResult().__iterator(o,i);var s=e.__iterator(qo,i),l=!0,u=0;return new Ho((function(){var e,i,c;do{if((e=s.next()).done)return n||o===$o?e:Yo(o,u++,o===Go?void 0:e.value[1],e);var d=e.value;i=d[0],c=d[1],l&&(l=t.call(r,c,i,a))}while(l);return o===qo?e:Yo(o,i,c,e)}))},o}function Hi(e,t,r){var n=ra(e);return n.__iterateUncached=function(o,i){if(i)return this.cacheResult().__iterate(o,i);var a=0,s=!1;return function e(l,u){l.__iterate((function(i,l){return(!t||u<t)&&wo(i)?e(i,u+1):(a++,!1===o(i,r?l:a-1,n)&&(s=!0)),!s}),i)}(e,0),a},n.__iteratorUncached=function(n,o){if(o)return this.cacheResult().__iterator(n,o);var i=e.__iterator(n,o),a=[],s=0;return new Ho((function(){for(;i;){var e=i.next();if(!1===e.done){var l=e.value;if(n===qo&&(l=l[1]),t&&!(a.length<t)||!wo(l))return r?e:Yo(n,s++,l,e);a.push(i),i=l.__iterator(n,o)}else i=a.pop()}return{value:void 0,done:!0}}))},n}function Yi(e,t,r){t||(t=oa);var n=Io(e),o=0,i=e.toSeq().map((function(t,n){return[n,t,o++,r?r(t,n,e):t]})).valueSeq().toArray();return i.sort((function(e,r){return t(e[3],r[3])||e[2]-r[2]})).forEach(n?function(e,t){i[t].length=2}:function(e,t){i[t]=e[1]}),n?oi(i):Co(e)?ii(i):ai(i)}function Qi(e,t,r){if(t||(t=oa),r){var n=e.toSeq().map((function(t,n){return[t,r(t,n,e)]})).reduce((function(e,r){return Xi(t,e[1],r[1])?r:e}));return n&&n[0]}return e.reduce((function(e,r){return Xi(t,e,r)?r:e}))}function Xi(e,t,r){var n=e(r,t);return 0===n&&r!==t&&(null==r||r!=r)||n>0}function Ji(e,t,r,n){var o=ra(e),i=new si(r).map((function(e){return e.size}));return o.size=n?i.max():i.min(),o.__iterate=function(e,t){for(var r,n=this.__iterator($o,t),o=0;!(r=n.next()).done&&!1!==e(r.value,o++,this););return o},o.__iteratorUncached=function(e,o){var i=r.map((function(e){return e=Lo(e),Zo(o?e.reverse():e)})),a=0,s=!1;return new Ho((function(){var r;return s||(r=i.map((function(e){return e.next()})),s=n?r.every((function(e){return e.done})):r.some((function(e){return e.done}))),s?{value:void 0,done:!0}:Yo(e,a++,t.apply(null,r.map((function(e){return e.value}))))}))},o}function Zi(e,t){return e===t?e:Do(e)?t:e.constructor(t)}function ea(e){if(e!==Object(e))throw new TypeError("Expected [K, V] tuple: "+e)}function ta(e){return Io(e)?Po:Co(e)?xo:jo}function ra(e){return Object.create((Io(e)?oi:Co(e)?ii:ai).prototype)}function na(){return this._iter.cacheResult?(this._iter.cacheResult(),this.size=this._iter.size,this):ni.prototype.cacheResult.call(this)}function oa(e,t){return void 0===e&&void 0===t?0:void 0===e?1:void 0===t?-1:e>t?1:e<t?-1:0}function ia(e,t){t=t||0;for(var r=Math.max(0,e.length-t),n=new Array(r),o=0;o<r;o++)n[o]=e[o+t];return n}function aa(e,t){if(!e)throw new Error(t)}function sa(e){aa(e!==1/0,"Cannot perform this action with an infinite size.")}function la(e){if(ri(e)&&"string"!=typeof e)return e;if(Bo(e))return e.toArray();throw new TypeError("Invalid keyPath: expected Ordered Collection or Array: "+e)}Vi.prototype.cacheResult=Mi.prototype.cacheResult=Ui.prototype.cacheResult=Bi.prototype.cacheResult=na;var ua=Object.prototype.toString;function ca(e){if(!e||"object"!=typeof e||"[object Object]"!==ua.call(e))return!1;var t=Object.getPrototypeOf(e);if(null===t)return!0;for(var r=t,n=Object.getPrototypeOf(t);null!==n;)r=n,n=Object.getPrototypeOf(r);return r===t}function da(e){return"object"==typeof e&&(Vo(e)||Array.isArray(e)||ca(e))}function pa(e){try{return"string"==typeof e?JSON.stringify(e):String(e)}catch(t){return JSON.stringify(e)}}function fa(e,t){return Vo(e)?e.has(t):da(e)&&ti.call(e,t)}function va(e,t,r){return Vo(e)?e.get(t,r):fa(e,t)?"function"==typeof e.get?e.get(t):e[t]:r}function ha(e){if(Array.isArray(e))return ia(e);var t={};for(var r in e)ti.call(e,r)&&(t[r]=e[r]);return t}function ga(e,t){if(!da(e))throw new TypeError("Cannot update non-data-structure value: "+e);if(Vo(e)){if(!e.remove)throw new TypeError("Cannot update immutable value without .remove() method: "+e);return e.remove(t)}if(!ti.call(e,t))return e;var r=ha(e);return Array.isArray(r)?r.splice(t,1):delete r[t],r}function ya(e,t,r){if(!da(e))throw new TypeError("Cannot update non-data-structure value: "+e);if(Vo(e)){if(!e.set)throw new TypeError("Cannot update immutable value without .set() method: "+e);return e.set(t,r)}if(ti.call(e,t)&&r===e[t])return e;var n=ha(e);return n[t]=r,n}function ma(e,t,r,n){n||(n=r,r=void 0);var o=ba(Vo(e),e,la(t),0,r,n);return o===fo?r:o}function ba(e,t,r,n,o,i){var a=t===fo;if(n===r.length){var s=a?o:t,l=i(s);return l===s?t:l}if(!a&&!da(t))throw new TypeError("Cannot update within non-data-structure value in path ["+r.slice(0,n).map(pa)+"]: "+t);var u=r[n],c=a?fo:va(t,u,fo),d=ba(c===fo?e:Vo(c),c,r,n+1,o,i);return d===c?t:d===fo?ga(t,u):ya(a?e?Ja():{}:t,u,d)}function Ea(e,t,r){return ma(e,t,fo,(function(){return r}))}function Oa(e,t){return Ea(this,e,t)}function Sa(e,t){return ma(e,t,(function(){return fo}))}function Ta(e){return Sa(this,e)}function _a(e,t,r,n){return ma(e,[t],r,n)}function wa(e,t,r){return 1===arguments.length?e(this):_a(this,e,t,r)}function Ra(e,t,r){return ma(this,e,t,r)}function Ia(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return Ca(this,e)}function Aa(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];if("function"!=typeof e)throw new TypeError("Invalid merger function: "+e);return Ca(this,t,e)}function Ca(e,t,r){for(var n=[],o=0;o<t.length;o++){var i=Po(t[o]);0!==i.size&&n.push(i)}return 0===n.length?e:0!==e.toSeq().size||e.__ownerID||1!==n.length?e.withMutations((function(e){for(var t=r?function(t,n){_a(e,n,fo,(function(e){return e===fo?t:r(e,t,n)}))}:function(t,r){e.set(r,t)},o=0;o<n.length;o++)n[o].forEach(t)})):e.constructor(n[0])}function Na(e,t,r){return La(e,t,function(e){return function t(r,n,o){return da(r)&&da(n)&&(i=n,a=ni(r),s=ni(i),Co(a)===Co(s)&&Io(a)===Io(s))?La(r,[n],t):e?e(r,n,o):n;var i,a,s}}(r))}function La(e,t,r){if(!da(e))throw new TypeError("Cannot merge into non-data-structure value: "+e);if(Vo(e))return"function"==typeof r&&e.mergeWith?e.mergeWith.apply(e,[r].concat(t)):e.merge?e.merge.apply(e,t):e.concat.apply(e,t);for(var n=Array.isArray(e),o=e,i=n?xo:Po,a=n?function(t){o===e&&(o=ha(o)),o.push(t)}:function(t,n){var i=ti.call(o,n),a=i&&r?r(o[n],t,n):t;i&&a===o[n]||(o===e&&(o=ha(o)),o[n]=a)},s=0;s<t.length;s++)i(t[s]).forEach(a);return o}function Pa(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return Na(this,e)}function xa(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return Na(this,t,e)}function ja(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return ma(this,e,Ja(),(function(e){return La(e,t)}))}function Fa(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return ma(this,e,Ja(),(function(e){return Na(e,t)}))}function Da(e){var t=this.asMutable();return e(t),t.wasAltered()?t.__ensureOwner(this.__ownerID):this}function ka(){return this.__ownerID?this:this.__ensureOwner(new ho)}function Ma(){return this.__ensureOwner()}function Va(){return this.__altered}var Ua=function(e){function t(t){return null==t?Ja():gi(t)&&!Bo(t)?t:Ja().withMutations((function(r){var n=e(t);sa(n.size),n.forEach((function(e,t){return r.set(t,e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return Ja().withMutations((function(t){for(var r=0;r<e.length;r+=2){if(r+1>=e.length)throw new Error("Missing value for key: "+e[r]);t.set(e[r],e[r+1])}}))},t.prototype.toString=function(){return this.__toString("Map {","}")},t.prototype.get=function(e,t){return this._root?this._root.get(0,void 0,e,t):t},t.prototype.set=function(e,t){return Za(this,e,t)},t.prototype.remove=function(e){return Za(this,e,fo)},t.prototype.deleteAll=function(e){var t=Lo(e);return 0===t.size?this:this.withMutations((function(e){t.forEach((function(t){return e.remove(t)}))}))},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._root=null,this.__hash=void 0,this.__altered=!0,this):Ja()},t.prototype.sort=function(e){return _s(Yi(this,e))},t.prototype.sortBy=function(e,t){return _s(Yi(this,t,e))},t.prototype.map=function(e,t){var r=this;return this.withMutations((function(n){n.forEach((function(o,i){n.set(i,e.call(t,o,i,r))}))}))},t.prototype.__iterator=function(e,t){return new Ha(this,e,t)},t.prototype.__iterate=function(e,t){var r=this,n=0;return this._root&&this._root.iterate((function(t){return n++,e(t[1],t[0],r)}),t),n},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?Xa(this.size,this._root,e,this.__hash):0===this.size?Ja():(this.__ownerID=e,this.__altered=!1,this)},t}(Po);Ua.isMap=gi;var Ba=Ua.prototype;Ba[hi]=!0,Ba[lo]=Ba.remove,Ba.removeAll=Ba.deleteAll,Ba.setIn=Oa,Ba.removeIn=Ba.deleteIn=Ta,Ba.update=wa,Ba.updateIn=Ra,Ba.merge=Ba.concat=Ia,Ba.mergeWith=Aa,Ba.mergeDeep=Pa,Ba.mergeDeepWith=xa,Ba.mergeIn=ja,Ba.mergeDeepIn=Fa,Ba.withMutations=Da,Ba.wasAltered=Va,Ba.asImmutable=Ma,Ba["@@transducer/init"]=Ba.asMutable=ka,Ba["@@transducer/step"]=function(e,t){return e.set(t[0],t[1])},Ba["@@transducer/result"]=function(e){return e.asImmutable()};var Ga=function(e,t){this.ownerID=e,this.entries=t};Ga.prototype.get=function(e,t,r,n){for(var o=this.entries,i=0,a=o.length;i<a;i++)if(bi(r,o[i][0]))return o[i][1];return n},Ga.prototype.update=function(e,t,r,n,o,i,a){for(var s=o===fo,l=this.entries,u=0,c=l.length;u<c&&!bi(n,l[u][0]);u++);var d=u<c;if(d?l[u][1]===o:s)return this;if(vo(a),(s||!d)&&vo(i),!s||1!==l.length){if(!d&&!s&&l.length>=is)return function(e,t,r,n){e||(e=new ho);for(var o=new Wa(e,Ti(r),[r,n]),i=0;i<t.length;i++){var a=t[i];o=o.update(e,0,void 0,a[0],a[1])}return o}(e,l,n,o);var p=e&&e===this.ownerID,f=p?l:ia(l);return d?s?u===c-1?f.pop():f[u]=f.pop():f[u]=[n,o]:f.push([n,o]),p?(this.entries=f,this):new Ga(e,f)}};var $a=function(e,t,r){this.ownerID=e,this.bitmap=t,this.nodes=r};$a.prototype.get=function(e,t,r,n){void 0===t&&(t=Ti(r));var o=1<<((0===e?t:t>>>e)&po),i=this.bitmap;return i&o?this.nodes[ns(i&o-1)].get(e+uo,t,r,n):n},$a.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=Ti(n));var s=(0===t?r:r>>>t)&po,l=1<<s,u=this.bitmap,c=!!(u&l);if(!c&&o===fo)return this;var d=ns(u&l-1),p=this.nodes,f=c?p[d]:void 0,v=es(f,e,t+uo,r,n,o,i,a);if(v===f)return this;if(!c&&v&&p.length>=as)return function(e,t,r,n,o){for(var i=0,a=new Array(co),s=0;0!==r;s++,r>>>=1)a[s]=1&r?t[i++]:void 0;return a[n]=o,new qa(e,i+1,a)}(e,p,u,s,v);if(c&&!v&&2===p.length&&ts(p[1^d]))return p[1^d];if(c&&v&&1===p.length&&ts(v))return v;var h=e&&e===this.ownerID,g=c?v?u:u^l:u|l,y=c?v?os(p,d,v,h):function(e,t,r){var n=e.length-1;if(r&&t===n)return e.pop(),e;for(var o=new Array(n),i=0,a=0;a<n;a++)a===t&&(i=1),o[a]=e[a+i];return o}(p,d,h):function(e,t,r,n){var o=e.length+1;if(n&&t+1===o)return e[t]=r,e;for(var i=new Array(o),a=0,s=0;s<o;s++)s===t?(i[s]=r,a=-1):i[s]=e[s+a];return i}(p,d,v,h);return h?(this.bitmap=g,this.nodes=y,this):new $a(e,g,y)};var qa=function(e,t,r){this.ownerID=e,this.count=t,this.nodes=r};qa.prototype.get=function(e,t,r,n){void 0===t&&(t=Ti(r));var o=(0===e?t:t>>>e)&po,i=this.nodes[o];return i?i.get(e+uo,t,r,n):n},qa.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=Ti(n));var s=(0===t?r:r>>>t)&po,l=o===fo,u=this.nodes,c=u[s];if(l&&!c)return this;var d=es(c,e,t+uo,r,n,o,i,a);if(d===c)return this;var p=this.count;if(c){if(!d&&--p<ss)return function(e,t,r,n){for(var o=0,i=0,a=new Array(r),s=0,l=1,u=t.length;s<u;s++,l<<=1){var c=t[s];void 0!==c&&s!==n&&(o|=l,a[i++]=c)}return new $a(e,o,a)}(e,u,p,s)}else p++;var f=e&&e===this.ownerID,v=os(u,s,d,f);return f?(this.count=p,this.nodes=v,this):new qa(e,p,v)};var Ka=function(e,t,r){this.ownerID=e,this.keyHash=t,this.entries=r};Ka.prototype.get=function(e,t,r,n){for(var o=this.entries,i=0,a=o.length;i<a;i++)if(bi(r,o[i][0]))return o[i][1];return n},Ka.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=Ti(n));var s=o===fo;if(r!==this.keyHash)return s?this:(vo(a),vo(i),rs(this,e,t,r,[n,o]));for(var l=this.entries,u=0,c=l.length;u<c&&!bi(n,l[u][0]);u++);var d=u<c;if(d?l[u][1]===o:s)return this;if(vo(a),(s||!d)&&vo(i),s&&2===c)return new Wa(e,this.keyHash,l[1^u]);var p=e&&e===this.ownerID,f=p?l:ia(l);return d?s?u===c-1?f.pop():f[u]=f.pop():f[u]=[n,o]:f.push([n,o]),p?(this.entries=f,this):new Ka(e,this.keyHash,f)};var Wa=function(e,t,r){this.ownerID=e,this.keyHash=t,this.entry=r};Wa.prototype.get=function(e,t,r,n){return bi(r,this.entry[0])?this.entry[1]:n},Wa.prototype.update=function(e,t,r,n,o,i,a){var s=o===fo,l=bi(n,this.entry[0]);return(l?o===this.entry[1]:s)?this:(vo(a),s?void vo(i):l?e&&e===this.ownerID?(this.entry[1]=o,this):new Wa(e,this.keyHash,[n,o]):(vo(i),rs(this,e,t,Ti(n),[n,o])))},Ga.prototype.iterate=Ka.prototype.iterate=function(e,t){for(var r=this.entries,n=0,o=r.length-1;n<=o;n++)if(!1===e(r[t?o-n:n]))return!1},$a.prototype.iterate=qa.prototype.iterate=function(e,t){for(var r=this.nodes,n=0,o=r.length-1;n<=o;n++){var i=r[t?o-n:n];if(i&&!1===i.iterate(e,t))return!1}},Wa.prototype.iterate=function(e,t){return e(this.entry)};var za,Ha=function(e){function t(e,t,r){this._type=t,this._reverse=r,this._stack=e._root&&Qa(e._root)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.next=function(){for(var e=this._type,t=this._stack;t;){var r=t.node,n=t.index++,o=void 0;if(r.entry){if(0===n)return Ya(e,r.entry)}else if(r.entries){if(n<=(o=r.entries.length-1))return Ya(e,r.entries[this._reverse?o-n:n])}else if(n<=(o=r.nodes.length-1)){var i=r.nodes[this._reverse?o-n:n];if(i){if(i.entry)return Ya(e,i.entry);t=this._stack=Qa(i,t)}continue}t=this._stack=this._stack.__prev}return{value:void 0,done:!0}},t}(Ho);function Ya(e,t){return Yo(e,t[0],t[1])}function Qa(e,t){return{node:e,index:0,__prev:t}}function Xa(e,t,r,n){var o=Object.create(Ba);return o.size=e,o._root=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function Ja(){return za||(za=Xa(0))}function Za(e,t,r){var n,o;if(e._root){var i={value:!1},a={value:!1};if(n=es(e._root,e.__ownerID,0,void 0,t,r,i,a),!a.value)return e;o=e.size+(i.value?r===fo?-1:1:0)}else{if(r===fo)return e;o=1,n=new Ga(e.__ownerID,[[t,r]])}return e.__ownerID?(e.size=o,e._root=n,e.__hash=void 0,e.__altered=!0,e):n?Xa(o,n):Ja()}function es(e,t,r,n,o,i,a,s){return e?e.update(t,r,n,o,i,a,s):i===fo?e:(vo(s),vo(a),new Wa(t,n,[o,i]))}function ts(e){return e.constructor===Wa||e.constructor===Ka}function rs(e,t,r,n,o){if(e.keyHash===n)return new Ka(t,n,[e.entry,o]);var i,a=(0===r?e.keyHash:e.keyHash>>>r)&po,s=(0===r?n:n>>>r)&po,l=a===s?[rs(e,t,r+uo,n,o)]:(i=new Wa(t,n,o),a<s?[e,i]:[i,e]);return new $a(t,1<<a|1<<s,l)}function ns(e){return e=(e=(858993459&(e-=e>>1&1431655765))+(e>>2&858993459))+(e>>4)&252645135,127&(e+=e>>8)+(e>>16)}function os(e,t,r,n){var o=n?e:ia(e);return o[t]=r,o}var is=co/4,as=co/2,ss=co/4,ls="@@__IMMUTABLE_LIST__@@";function us(e){return Boolean(e&&e[ls])}var cs=function(e){function t(t){var r=ys();if(null==t)return r;if(us(t))return t;var n=e(t),o=n.size;return 0===o?r:(sa(o),o>0&&o<co?gs(0,o,uo,null,new ps(n.toArray())):r.withMutations((function(e){e.setSize(o),n.forEach((function(t,r){return e.set(r,t)}))})))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("List [","]")},t.prototype.get=function(e,t){if((e=yo(this,e))>=0&&e<this.size){var r=Es(this,e+=this._origin);return r&&r.array[e&po]}return t},t.prototype.set=function(e,t){return function(e,t,r){if((t=yo(e,t))!=t)return e;if(t>=e.size||t<0)return e.withMutations((function(e){t<0?Os(e,t).set(0,r):Os(e,0,t+1).set(t,r)}));t+=e._origin;var n=e._tail,o=e._root,i={value:!1};return t>=Ss(e._capacity)?n=ms(n,e.__ownerID,0,t,r,i):o=ms(o,e.__ownerID,e._level,t,r,i),i.value?e.__ownerID?(e._root=o,e._tail=n,e.__hash=void 0,e.__altered=!0,e):gs(e._origin,e._capacity,e._level,o,n):e}(this,e,t)},t.prototype.remove=function(e){return this.has(e)?0===e?this.shift():e===this.size-1?this.pop():this.splice(e,1):this},t.prototype.insert=function(e,t){return this.splice(e,0,t)},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=this._origin=this._capacity=0,this._level=uo,this._root=this._tail=this.__hash=void 0,this.__altered=!0,this):ys()},t.prototype.push=function(){var e=arguments,t=this.size;return this.withMutations((function(r){Os(r,0,t+e.length);for(var n=0;n<e.length;n++)r.set(t+n,e[n])}))},t.prototype.pop=function(){return Os(this,0,-1)},t.prototype.unshift=function(){var e=arguments;return this.withMutations((function(t){Os(t,-e.length);for(var r=0;r<e.length;r++)t.set(r,e[r])}))},t.prototype.shift=function(){return Os(this,1)},t.prototype.concat=function(){for(var t=arguments,r=[],n=0;n<arguments.length;n++){var o=t[n],i=e("string"!=typeof o&&Xo(o)?o:[o]);0!==i.size&&r.push(i)}return 0===r.length?this:0!==this.size||this.__ownerID||1!==r.length?this.withMutations((function(e){r.forEach((function(t){return t.forEach((function(t){return e.push(t)}))}))})):this.constructor(r[0])},t.prototype.setSize=function(e){return Os(this,0,e)},t.prototype.map=function(e,t){var r=this;return this.withMutations((function(n){for(var o=0;o<r.size;o++)n.set(o,e.call(t,n.get(o),o,r))}))},t.prototype.slice=function(e,t){var r=this.size;return bo(e,t,r)?this:Os(this,Eo(e,r),Oo(t,r))},t.prototype.__iterator=function(e,t){var r=t?this.size:0,n=hs(this,t);return new Ho((function(){var o=n();return o===vs?{value:void 0,done:!0}:Yo(e,t?--r:r++,o)}))},t.prototype.__iterate=function(e,t){for(var r,n=t?this.size:0,o=hs(this,t);(r=o())!==vs&&!1!==e(r,t?--n:n++,this););return n},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?gs(this._origin,this._capacity,this._level,this._root,this._tail,e,this.__hash):0===this.size?ys():(this.__ownerID=e,this.__altered=!1,this)},t}(xo);cs.isList=us;var ds=cs.prototype;ds[ls]=!0,ds[lo]=ds.remove,ds.merge=ds.concat,ds.setIn=Oa,ds.deleteIn=ds.removeIn=Ta,ds.update=wa,ds.updateIn=Ra,ds.mergeIn=ja,ds.mergeDeepIn=Fa,ds.withMutations=Da,ds.wasAltered=Va,ds.asImmutable=Ma,ds["@@transducer/init"]=ds.asMutable=ka,ds["@@transducer/step"]=function(e,t){return e.push(t)},ds["@@transducer/result"]=function(e){return e.asImmutable()};var ps=function(e,t){this.array=e,this.ownerID=t};ps.prototype.removeBefore=function(e,t,r){if(r===t?1<<t:0===this.array.length)return this;var n=r>>>t&po;if(n>=this.array.length)return new ps([],e);var o,i=0===n;if(t>0){var a=this.array[n];if((o=a&&a.removeBefore(e,t-uo,r))===a&&i)return this}if(i&&!o)return this;var s=bs(this,e);if(!i)for(var l=0;l<n;l++)s.array[l]=void 0;return o&&(s.array[n]=o),s},ps.prototype.removeAfter=function(e,t,r){if(r===(t?1<<t:0)||0===this.array.length)return this;var n,o=r-1>>>t&po;if(o>=this.array.length)return this;if(t>0){var i=this.array[o];if((n=i&&i.removeAfter(e,t-uo,r))===i&&o===this.array.length-1)return this}var a=bs(this,e);return a.array.splice(o+1),n&&(a.array[o]=n),a};var fs,vs={};function hs(e,t){var r=e._origin,n=e._capacity,o=Ss(n),i=e._tail;return function e(a,s,l){return 0===s?function(e,a){var s=a===o?i&&i.array:e&&e.array,l=a>r?0:r-a,u=n-a;return u>co&&(u=co),function(){if(l===u)return vs;var e=t?--u:l++;return s&&s[e]}}(a,l):function(o,i,a){var s,l=o&&o.array,u=a>r?0:r-a>>i,c=1+(n-a>>i);return c>co&&(c=co),function(){for(;;){if(s){var r=s();if(r!==vs)return r;s=null}if(u===c)return vs;var n=t?--c:u++;s=e(l&&l[n],i-uo,a+(n<<i))}}}(a,s,l)}(e._root,e._level,0)}function gs(e,t,r,n,o,i,a){var s=Object.create(ds);return s.size=t-e,s._origin=e,s._capacity=t,s._level=r,s._root=n,s._tail=o,s.__ownerID=i,s.__hash=a,s.__altered=!1,s}function ys(){return fs||(fs=gs(0,0,uo))}function ms(e,t,r,n,o,i){var a,s=n>>>r&po,l=e&&s<e.array.length;if(!l&&void 0===o)return e;if(r>0){var u=e&&e.array[s],c=ms(u,t,r-uo,n,o,i);return c===u?e:((a=bs(e,t)).array[s]=c,a)}return l&&e.array[s]===o?e:(i&&vo(i),a=bs(e,t),void 0===o&&s===a.array.length-1?a.array.pop():a.array[s]=o,a)}function bs(e,t){return t&&e&&t===e.ownerID?e:new ps(e?e.array.slice():[],t)}function Es(e,t){if(t>=Ss(e._capacity))return e._tail;if(t<1<<e._level+uo){for(var r=e._root,n=e._level;r&&n>0;)r=r.array[t>>>n&po],n-=uo;return r}}function Os(e,t,r){void 0!==t&&(t|=0),void 0!==r&&(r|=0);var n=e.__ownerID||new ho,o=e._origin,i=e._capacity,a=o+t,s=void 0===r?i:r<0?i+r:o+r;if(a===o&&s===i)return e;if(a>=s)return e.clear();for(var l=e._level,u=e._root,c=0;a+c<0;)u=new ps(u&&u.array.length?[void 0,u]:[],n),c+=1<<(l+=uo);c&&(a+=c,o+=c,s+=c,i+=c);for(var d=Ss(i),p=Ss(s);p>=1<<l+uo;)u=new ps(u&&u.array.length?[u]:[],n),l+=uo;var f=e._tail,v=p<d?Es(e,s-1):p>d?new ps([],n):f;if(f&&p>d&&a<i&&f.array.length){for(var h=u=bs(u,n),g=l;g>uo;g-=uo){var y=d>>>g&po;h=h.array[y]=bs(h.array[y],n)}h.array[d>>>uo&po]=f}if(s<i&&(v=v&&v.removeAfter(n,0,s)),a>=p)a-=p,s-=p,l=uo,u=null,v=v&&v.removeBefore(n,0,a);else if(a>o||p<d){for(c=0;u;){var m=a>>>l&po;if(m!==p>>>l&po)break;m&&(c+=(1<<l)*m),l-=uo,u=u.array[m]}u&&a>o&&(u=u.removeBefore(n,l,a-c)),u&&p<d&&(u=u.removeAfter(n,l,p-c)),c&&(a-=c,s-=c)}return e.__ownerID?(e.size=s-a,e._origin=a,e._capacity=s,e._level=l,e._root=u,e._tail=v,e.__hash=void 0,e.__altered=!0,e):gs(a,s,l,u,v)}function Ss(e){return e<co?0:e-1>>>uo<<uo}var Ts,_s=function(e){function t(e){return null==e?Rs():yi(e)?e:Rs().withMutations((function(t){var r=Po(e);sa(r.size),r.forEach((function(e,r){return t.set(r,e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("OrderedMap {","}")},t.prototype.get=function(e,t){var r=this._map.get(e);return void 0!==r?this._list.get(r)[1]:t},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._map.clear(),this._list.clear(),this.__altered=!0,this):Rs()},t.prototype.set=function(e,t){return Is(this,e,t)},t.prototype.remove=function(e){return Is(this,e,fo)},t.prototype.__iterate=function(e,t){var r=this;return this._list.__iterate((function(t){return t&&e(t[1],t[0],r)}),t)},t.prototype.__iterator=function(e,t){return this._list.fromEntrySeq().__iterator(e,t)},t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e),r=this._list.__ensureOwner(e);return e?ws(t,r,e,this.__hash):0===this.size?Rs():(this.__ownerID=e,this.__altered=!1,this._map=t,this._list=r,this)},t}(Ua);function ws(e,t,r,n){var o=Object.create(_s.prototype);return o.size=e?e.size:0,o._map=e,o._list=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function Rs(){return Ts||(Ts=ws(Ja(),ys()))}function Is(e,t,r){var n,o,i=e._map,a=e._list,s=i.get(t),l=void 0!==s;if(r===fo){if(!l)return e;a.size>=co&&a.size>=2*i.size?(n=(o=a.filter((function(e,t){return void 0!==e&&s!==t}))).toKeyedSeq().map((function(e){return e[0]})).flip().toMap(),e.__ownerID&&(n.__ownerID=o.__ownerID=e.__ownerID)):(n=i.remove(t),o=s===a.size-1?a.pop():a.set(s,void 0))}else if(l){if(r===a.get(s)[1])return e;n=i,o=a.set(s,[t,r])}else n=i.set(t,a.size),o=a.set(a.size,[t,r]);return e.__ownerID?(e.size=n.size,e._map=n,e._list=o,e.__hash=void 0,e.__altered=!0,e):ws(n,o)}_s.isOrderedMap=yi,_s.prototype[Uo]=!0,_s.prototype[lo]=_s.prototype.remove;var As="@@__IMMUTABLE_STACK__@@";function Cs(e){return Boolean(e&&e[As])}var Ns=function(e){function t(e){return null==e?js():Cs(e)?e:js().pushAll(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("Stack [","]")},t.prototype.get=function(e,t){var r=this._head;for(e=yo(this,e);r&&e--;)r=r.next;return r?r.value:t},t.prototype.peek=function(){return this._head&&this._head.value},t.prototype.push=function(){var e=arguments;if(0===arguments.length)return this;for(var t=this.size+arguments.length,r=this._head,n=arguments.length-1;n>=0;n--)r={value:e[n],next:r};return this.__ownerID?(this.size=t,this._head=r,this.__hash=void 0,this.__altered=!0,this):xs(t,r)},t.prototype.pushAll=function(t){if(0===(t=e(t)).size)return this;if(0===this.size&&Cs(t))return t;sa(t.size);var r=this.size,n=this._head;return t.__iterate((function(e){r++,n={value:e,next:n}}),!0),this.__ownerID?(this.size=r,this._head=n,this.__hash=void 0,this.__altered=!0,this):xs(r,n)},t.prototype.pop=function(){return this.slice(1)},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._head=void 0,this.__hash=void 0,this.__altered=!0,this):js()},t.prototype.slice=function(t,r){if(bo(t,r,this.size))return this;var n=Eo(t,this.size);if(Oo(r,this.size)!==this.size)return e.prototype.slice.call(this,t,r);for(var o=this.size-n,i=this._head;n--;)i=i.next;return this.__ownerID?(this.size=o,this._head=i,this.__hash=void 0,this.__altered=!0,this):xs(o,i)},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?xs(this.size,this._head,e,this.__hash):0===this.size?js():(this.__ownerID=e,this.__altered=!1,this)},t.prototype.__iterate=function(e,t){var r=this;if(t)return new si(this.toArray()).__iterate((function(t,n){return e(t,n,r)}),t);for(var n=0,o=this._head;o&&!1!==e(o.value,n++,this);)o=o.next;return n},t.prototype.__iterator=function(e,t){if(t)return new si(this.toArray()).__iterator(e,t);var r=0,n=this._head;return new Ho((function(){if(n){var t=n.value;return n=n.next,Yo(e,r++,t)}return{value:void 0,done:!0}}))},t}(xo);Ns.isStack=Cs;var Ls,Ps=Ns.prototype;function xs(e,t,r,n){var o=Object.create(Ps);return o.size=e,o._head=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function js(){return Ls||(Ls=xs(0))}Ps[As]=!0,Ps.shift=Ps.pop,Ps.unshift=Ps.push,Ps.unshiftAll=Ps.pushAll,Ps.withMutations=Da,Ps.wasAltered=Va,Ps.asImmutable=Ma,Ps["@@transducer/init"]=Ps.asMutable=ka,Ps["@@transducer/step"]=function(e,t){return e.unshift(t)},Ps["@@transducer/result"]=function(e){return e.asImmutable()};var Fs="@@__IMMUTABLE_SET__@@";function Ds(e){return Boolean(e&&e[Fs])}function ks(e){return Ds(e)&&Bo(e)}function Ms(e,t){if(e===t)return!0;if(!wo(t)||void 0!==e.size&&void 0!==t.size&&e.size!==t.size||void 0!==e.__hash&&void 0!==t.__hash&&e.__hash!==t.__hash||Io(e)!==Io(t)||Co(e)!==Co(t)||Bo(e)!==Bo(t))return!1;if(0===e.size&&0===t.size)return!0;var r=!No(e);if(Bo(e)){var n=e.entries();return t.every((function(e,t){var o=n.next().value;return o&&bi(o[1],e)&&(r||bi(o[0],t))}))&&n.next().done}var o=!1;if(void 0===e.size)if(void 0===t.size)"function"==typeof e.cacheResult&&e.cacheResult();else{o=!0;var i=e;e=t,t=i}var a=!0,s=t.__iterate((function(t,n){if(r?!e.has(t):o?!bi(t,e.get(n,fo)):!bi(e.get(n,fo),t))return a=!1,!1}));return a&&e.size===s}function Vs(e,t){var r=function(r){e.prototype[r]=t[r]};return Object.keys(t).forEach(r),Object.getOwnPropertySymbols&&Object.getOwnPropertySymbols(t).forEach(r),e}function Us(e){if(!e||"object"!=typeof e)return e;if(!wo(e)){if(!da(e))return e;e=ni(e)}if(Io(e)){var t={};return e.__iterate((function(e,r){t[r]=Us(e)})),t}var r=[];return e.__iterate((function(e){r.push(Us(e))})),r}var Bs=function(e){function t(t){return null==t?Ws():Ds(t)&&!Bo(t)?t:Ws().withMutations((function(r){var n=e(t);sa(n.size),n.forEach((function(e){return r.add(e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.fromKeys=function(e){return this(Po(e).keySeq())},t.intersect=function(e){return(e=Lo(e).toArray()).length?$s.intersect.apply(t(e.pop()),e):Ws()},t.union=function(e){return(e=Lo(e).toArray()).length?$s.union.apply(t(e.pop()),e):Ws()},t.prototype.toString=function(){return this.__toString("Set {","}")},t.prototype.has=function(e){return this._map.has(e)},t.prototype.add=function(e){return qs(this,this._map.set(e,e))},t.prototype.remove=function(e){return qs(this,this._map.remove(e))},t.prototype.clear=function(){return qs(this,this._map.clear())},t.prototype.map=function(e,t){var r=this,n=!1,o=qs(this,this._map.mapEntries((function(o){var i=o[1],a=e.call(t,i,i,r);return a!==i&&(n=!0),[a,a]}),t));return n?o:this},t.prototype.union=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];return 0===(t=t.filter((function(e){return 0!==e.size}))).length?this:0!==this.size||this.__ownerID||1!==t.length?this.withMutations((function(r){for(var n=0;n<t.length;n++)"string"==typeof t[n]?r.add(t[n]):e(t[n]).forEach((function(e){return r.add(e)}))})):this.constructor(t[0])},t.prototype.intersect=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];if(0===t.length)return this;t=t.map((function(t){return e(t)}));var n=[];return this.forEach((function(e){t.every((function(t){return t.includes(e)}))||n.push(e)})),this.withMutations((function(e){n.forEach((function(t){e.remove(t)}))}))},t.prototype.subtract=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];if(0===t.length)return this;t=t.map((function(t){return e(t)}));var n=[];return this.forEach((function(e){t.some((function(t){return t.includes(e)}))&&n.push(e)})),this.withMutations((function(e){n.forEach((function(t){e.remove(t)}))}))},t.prototype.sort=function(e){return dl(Yi(this,e))},t.prototype.sortBy=function(e,t){return dl(Yi(this,t,e))},t.prototype.wasAltered=function(){return this._map.wasAltered()},t.prototype.__iterate=function(e,t){var r=this;return this._map.__iterate((function(t){return e(t,t,r)}),t)},t.prototype.__iterator=function(e,t){return this._map.__iterator(e,t)},t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e);return e?this.__make(t,e):0===this.size?this.__empty():(this.__ownerID=e,this._map=t,this)},t}(jo);Bs.isSet=Ds;var Gs,$s=Bs.prototype;function qs(e,t){return e.__ownerID?(e.size=t.size,e._map=t,e):t===e._map?e:0===t.size?e.__empty():e.__make(t)}function Ks(e,t){var r=Object.create($s);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function Ws(){return Gs||(Gs=Ks(Ja()))}$s[Fs]=!0,$s[lo]=$s.remove,$s.merge=$s.concat=$s.union,$s.withMutations=Da,$s.asImmutable=Ma,$s["@@transducer/init"]=$s.asMutable=ka,$s["@@transducer/step"]=function(e,t){return e.add(t)},$s["@@transducer/result"]=function(e){return e.asImmutable()},$s.__empty=Ws,$s.__make=Ks;var zs,Hs=function(e){function t(e,r,n){if(!(this instanceof t))return new t(e,r,n);if(aa(0!==n,"Cannot step a Range by 0"),e=e||0,void 0===r&&(r=1/0),n=void 0===n?1:Math.abs(n),r<e&&(n=-n),this._start=e,this._end=r,this._step=n,this.size=Math.max(0,Math.ceil((r-e)/n-1)+1),0===this.size){if(zs)return zs;zs=this}}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toString=function(){return 0===this.size?"Range []":"Range [ "+this._start+"..."+this._end+(1!==this._step?" by "+this._step:"")+" ]"},t.prototype.get=function(e,t){return this.has(e)?this._start+yo(this,e)*this._step:t},t.prototype.includes=function(e){var t=(e-this._start)/this._step;return t>=0&&t<this.size&&t===Math.floor(t)},t.prototype.slice=function(e,r){return bo(e,r,this.size)?this:(e=Eo(e,this.size),(r=Oo(r,this.size))<=e?new t(0,0):new t(this.get(e,this._end),this.get(r,this._end),this._step))},t.prototype.indexOf=function(e){var t=e-this._start;if(t%this._step==0){var r=t/this._step;if(r>=0&&r<this.size)return r}return-1},t.prototype.lastIndexOf=function(e){return this.indexOf(e)},t.prototype.__iterate=function(e,t){for(var r=this.size,n=this._step,o=t?this._start+(r-1)*n:this._start,i=0;i!==r&&!1!==e(o,t?r-++i:i++,this);)o+=t?-n:n;return i},t.prototype.__iterator=function(e,t){var r=this.size,n=this._step,o=t?this._start+(r-1)*n:this._start,i=0;return new Ho((function(){if(i===r)return{value:void 0,done:!0};var a=o;return o+=t?-n:n,Yo(e,t?r-++i:i++,a)}))},t.prototype.equals=function(e){return e instanceof t?this._start===e._start&&this._end===e._end&&this._step===e._step:Ms(this,e)},t}(ii);function Ys(e,t,r){for(var n=la(t),o=0;o!==n.length;)if((e=va(e,n[o++],fo))===fo)return r;return e}function Qs(e,t){return Ys(this,e,t)}function Xs(e,t){return Ys(e,t,fo)!==fo}function Js(){sa(this.size);var e={};return this.__iterate((function(t,r){e[r]=t})),e}Lo.isIterable=wo,Lo.isKeyed=Io,Lo.isIndexed=Co,Lo.isAssociative=No,Lo.isOrdered=Bo,Lo.Iterator=Ho,Vs(Lo,{toArray:function(){sa(this.size);var e=new Array(this.size||0),t=Io(this),r=0;return this.__iterate((function(n,o){e[r++]=t?[o,n]:n})),e},toIndexedSeq:function(){return new Vi(this)},toJS:function(){return Us(this)},toKeyedSeq:function(){return new Mi(this,!0)},toMap:function(){return Ua(this.toKeyedSeq())},toObject:Js,toOrderedMap:function(){return _s(this.toKeyedSeq())},toOrderedSet:function(){return dl(Io(this)?this.valueSeq():this)},toSet:function(){return Bs(Io(this)?this.valueSeq():this)},toSetSeq:function(){return new Ui(this)},toSeq:function(){return Co(this)?this.toIndexedSeq():Io(this)?this.toKeyedSeq():this.toSetSeq()},toStack:function(){return Ns(Io(this)?this.valueSeq():this)},toList:function(){return cs(Io(this)?this.valueSeq():this)},toString:function(){return"[Collection]"},__toString:function(e,t){return 0===this.size?e+t:e+" "+this.toSeq().map(this.__toStringMapper).join(", ")+" "+t},concat:function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return Zi(this,function(e,t){var r=Io(e),n=[e].concat(t).map((function(e){return wo(e)?r&&(e=Po(e)):e=r?pi(e):fi(Array.isArray(e)?e:[e]),e})).filter((function(e){return 0!==e.size}));if(0===n.length)return e;if(1===n.length){var o=n[0];if(o===e||r&&Io(o)||Co(e)&&Co(o))return o}var i=new si(n);return r?i=i.toKeyedSeq():Co(e)||(i=i.toSetSeq()),(i=i.flatten(!0)).size=n.reduce((function(e,t){if(void 0!==e){var r=t.size;if(void 0!==r)return e+r}}),0),i}(this,e))},includes:function(e){return this.some((function(t){return bi(t,e)}))},entries:function(){return this.__iterator(qo)},every:function(e,t){sa(this.size);var r=!0;return this.__iterate((function(n,o,i){if(!e.call(t,n,o,i))return r=!1,!1})),r},filter:function(e,t){return Zi(this,Ki(this,e,t,!0))},partition:function(e,t){return function(e,t,r){var n=Io(e),o=[[],[]];e.__iterate((function(i,a){o[t.call(r,i,a,e)?1:0].push(n?[a,i]:i)}));var i=ta(e);return o.map((function(t){return Zi(e,i(t))}))}(this,e,t)},find:function(e,t,r){var n=this.findEntry(e,t);return n?n[1]:r},forEach:function(e,t){return sa(this.size),this.__iterate(t?e.bind(t):e)},join:function(e){sa(this.size),e=void 0!==e?""+e:",";var t="",r=!0;return this.__iterate((function(n){r?r=!1:t+=e,t+=null!=n?n.toString():""})),t},keys:function(){return this.__iterator(Go)},map:function(e,t){return Zi(this,$i(this,e,t))},reduce:function(e,t,r){return nl(this,e,t,r,arguments.length<2,!1)},reduceRight:function(e,t,r){return nl(this,e,t,r,arguments.length<2,!0)},reverse:function(){return Zi(this,qi(this,!0))},slice:function(e,t){return Zi(this,Wi(this,e,t,!0))},some:function(e,t){sa(this.size);var r=!1;return this.__iterate((function(n,o,i){if(e.call(t,n,o,i))return r=!0,!1})),r},sort:function(e){return Zi(this,Yi(this,e))},values:function(){return this.__iterator($o)},butLast:function(){return this.slice(0,-1)},isEmpty:function(){return void 0!==this.size?0===this.size:!this.some((function(){return!0}))},count:function(e,t){return go(e?this.toSeq().filter(e,t):this)},countBy:function(e,t){return function(e,t,r){var n=Ua().asMutable();return e.__iterate((function(o,i){n.update(t.call(r,o,i,e),0,(function(e){return e+1}))})),n.asImmutable()}(this,e,t)},equals:function(e){return Ms(this,e)},entrySeq:function(){var e=this;if(e._cache)return new si(e._cache);var t=e.toSeq().map(il).toIndexedSeq();return t.fromEntrySeq=function(){return e.toSeq()},t},filterNot:function(e,t){return this.filter(al(e),t)},findEntry:function(e,t,r){var n=r;return this.__iterate((function(r,o,i){if(e.call(t,r,o,i))return n=[o,r],!1})),n},findKey:function(e,t){var r=this.findEntry(e,t);return r&&r[0]},findLast:function(e,t,r){return this.toKeyedSeq().reverse().find(e,t,r)},findLastEntry:function(e,t,r){return this.toKeyedSeq().reverse().findEntry(e,t,r)},findLastKey:function(e,t){return this.toKeyedSeq().reverse().findKey(e,t)},first:function(e){return this.find(mo,null,e)},flatMap:function(e,t){return Zi(this,function(e,t,r){var n=ta(e);return e.toSeq().map((function(o,i){return n(t.call(r,o,i,e))})).flatten(!0)}(this,e,t))},flatten:function(e){return Zi(this,Hi(this,e,!0))},fromEntrySeq:function(){return new Bi(this)},get:function(e,t){return this.find((function(t,r){return bi(r,e)}),void 0,t)},getIn:Qs,groupBy:function(e,t){return function(e,t,r){var n=Io(e),o=(Bo(e)?_s():Ua()).asMutable();e.__iterate((function(i,a){o.update(t.call(r,i,a,e),(function(e){return(e=e||[]).push(n?[a,i]:i),e}))}));var i=ta(e);return o.map((function(t){return Zi(e,i(t))})).asImmutable()}(this,e,t)},has:function(e){return this.get(e,fo)!==fo},hasIn:function(e){return Xs(this,e)},isSubset:function(e){return e="function"==typeof e.includes?e:Lo(e),this.every((function(t){return e.includes(t)}))},isSuperset:function(e){return(e="function"==typeof e.isSubset?e:Lo(e)).isSubset(this)},keyOf:function(e){return this.findKey((function(t){return bi(t,e)}))},keySeq:function(){return this.toSeq().map(ol).toIndexedSeq()},last:function(e){return this.toSeq().reverse().first(e)},lastKeyOf:function(e){return this.toKeyedSeq().reverse().keyOf(e)},max:function(e){return Qi(this,e)},maxBy:function(e,t){return Qi(this,t,e)},min:function(e){return Qi(this,e?sl(e):ul)},minBy:function(e,t){return Qi(this,t?sl(t):ul,e)},rest:function(){return this.slice(1)},skip:function(e){return 0===e?this:this.slice(Math.max(0,e))},skipLast:function(e){return 0===e?this:this.slice(0,-Math.max(0,e))},skipWhile:function(e,t){return Zi(this,zi(this,e,t,!0))},skipUntil:function(e,t){return this.skipWhile(al(e),t)},sortBy:function(e,t){return Zi(this,Yi(this,t,e))},take:function(e){return this.slice(0,Math.max(0,e))},takeLast:function(e){return this.slice(-Math.max(0,e))},takeWhile:function(e,t){return Zi(this,function(e,t,r){var n=ra(e);return n.__iterateUncached=function(n,o){var i=this;if(o)return this.cacheResult().__iterate(n,o);var a=0;return e.__iterate((function(e,o,s){return t.call(r,e,o,s)&&++a&&n(e,o,i)})),a},n.__iteratorUncached=function(n,o){var i=this;if(o)return this.cacheResult().__iterator(n,o);var a=e.__iterator(qo,o),s=!0;return new Ho((function(){if(!s)return{value:void 0,done:!0};var e=a.next();if(e.done)return e;var o=e.value,l=o[0],u=o[1];return t.call(r,u,l,i)?n===qo?e:Yo(n,l,u,e):(s=!1,{value:void 0,done:!0})}))},n}(this,e,t))},takeUntil:function(e,t){return this.takeWhile(al(e),t)},update:function(e){return e(this)},valueSeq:function(){return this.toIndexedSeq()},hashCode:function(){return this.__hash||(this.__hash=function(e){if(e.size===1/0)return 0;var t=Bo(e),r=Io(e),n=t?1:0;return function(e,t){return t=Ei(t,3432918353),t=Ei(t<<15|t>>>-15,461845907),t=Ei(t<<13|t>>>-13,5),t=Ei((t=t+3864292196^e)^t>>>16,2246822507),t=Oi((t=Ei(t^t>>>13,3266489909))^t>>>16)}(e.__iterate(r?t?function(e,t){n=31*n+cl(Ti(e),Ti(t))|0}:function(e,t){n=n+cl(Ti(e),Ti(t))|0}:t?function(e){n=31*n+Ti(e)|0}:function(e){n=n+Ti(e)|0}),n)}(this))}});var Zs=Lo.prototype;Zs[_o]=!0,Zs[zo]=Zs.values,Zs.toJSON=Zs.toArray,Zs.__toStringMapper=pa,Zs.inspect=Zs.toSource=function(){return this.toString()},Zs.chain=Zs.flatMap,Zs.contains=Zs.includes,Vs(Po,{flip:function(){return Zi(this,Gi(this))},mapEntries:function(e,t){var r=this,n=0;return Zi(this,this.toSeq().map((function(o,i){return e.call(t,[i,o],n++,r)})).fromEntrySeq())},mapKeys:function(e,t){var r=this;return Zi(this,this.toSeq().flip().map((function(n,o){return e.call(t,n,o,r)})).flip())}});var el=Po.prototype;el[Ro]=!0,el[zo]=Zs.entries,el.toJSON=Js,el.__toStringMapper=function(e,t){return pa(t)+": "+pa(e)},Vs(xo,{toKeyedSeq:function(){return new Mi(this,!1)},filter:function(e,t){return Zi(this,Ki(this,e,t,!1))},findIndex:function(e,t){var r=this.findEntry(e,t);return r?r[0]:-1},indexOf:function(e){var t=this.keyOf(e);return void 0===t?-1:t},lastIndexOf:function(e){var t=this.lastKeyOf(e);return void 0===t?-1:t},reverse:function(){return Zi(this,qi(this,!1))},slice:function(e,t){return Zi(this,Wi(this,e,t,!1))},splice:function(e,t){var r=arguments.length;if(t=Math.max(t||0,0),0===r||2===r&&!t)return this;e=Eo(e,e<0?this.count():this.size);var n=this.slice(0,e);return Zi(this,1===r?n:n.concat(ia(arguments,2),this.slice(e+t)))},findLastIndex:function(e,t){var r=this.findLastEntry(e,t);return r?r[0]:-1},first:function(e){return this.get(0,e)},flatten:function(e){return Zi(this,Hi(this,e,!1))},get:function(e,t){return(e=yo(this,e))<0||this.size===1/0||void 0!==this.size&&e>this.size?t:this.find((function(t,r){return r===e}),void 0,t)},has:function(e){return(e=yo(this,e))>=0&&(void 0!==this.size?this.size===1/0||e<this.size:-1!==this.indexOf(e))},interpose:function(e){return Zi(this,function(e,t){var r=ra(e);return r.size=e.size&&2*e.size-1,r.__iterateUncached=function(r,n){var o=this,i=0;return e.__iterate((function(e){return(!i||!1!==r(t,i++,o))&&!1!==r(e,i++,o)}),n),i},r.__iteratorUncached=function(r,n){var o,i=e.__iterator($o,n),a=0;return new Ho((function(){return(!o||a%2)&&(o=i.next()).done?o:a%2?Yo(r,a++,t):Yo(r,a++,o.value,o)}))},r}(this,e))},interleave:function(){var e=[this].concat(ia(arguments)),t=Ji(this.toSeq(),ii.of,e),r=t.flatten(!0);return t.size&&(r.size=t.size*e.length),Zi(this,r)},keySeq:function(){return Hs(0,this.size)},last:function(e){return this.get(-1,e)},skipWhile:function(e,t){return Zi(this,zi(this,e,t,!1))},zip:function(){return Zi(this,Ji(this,ll,[this].concat(ia(arguments))))},zipAll:function(){return Zi(this,Ji(this,ll,[this].concat(ia(arguments)),!0))},zipWith:function(e){var t=ia(arguments);return t[0]=this,Zi(this,Ji(this,e,t))}});var tl=xo.prototype;tl[Ao]=!0,tl[Uo]=!0,Vs(jo,{get:function(e,t){return this.has(e)?e:t},includes:function(e){return this.has(e)},keySeq:function(){return this.valueSeq()}});var rl=jo.prototype;function nl(e,t,r,n,o,i){return sa(e.size),e.__iterate((function(e,i,a){o?(o=!1,r=e):r=t.call(n,r,e,i,a)}),i),r}function ol(e,t){return t}function il(e,t){return[t,e]}function al(e){return function(){return!e.apply(this,arguments)}}function sl(e){return function(){return-e.apply(this,arguments)}}function ll(){return ia(arguments)}function ul(e,t){return e<t?1:e>t?-1:0}function cl(e,t){return e^t+2654435769+(e<<6)+(e>>2)}rl.has=Zs.includes,rl.contains=rl.includes,rl.keys=rl.values,Vs(oi,el),Vs(ii,tl),Vs(ai,rl);var dl=function(e){function t(e){return null==e?hl():ks(e)?e:hl().withMutations((function(t){var r=jo(e);sa(r.size),r.forEach((function(e){return t.add(e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.fromKeys=function(e){return this(Po(e).keySeq())},t.prototype.toString=function(){return this.__toString("OrderedSet {","}")},t}(Bs);dl.isOrderedSet=ks;var pl,fl=dl.prototype;function vl(e,t){var r=Object.create(fl);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function hl(){return pl||(pl=vl(Rs()))}fl[Uo]=!0,fl.zip=tl.zip,fl.zipWith=tl.zipWith,fl.zipAll=tl.zipAll,fl.__empty=hl,fl.__make=vl;var gl=function(e,t){var r;!function(e){if(Mo(e))throw new Error("Can not call `Record` with an immutable Record as default values. Use a plain javascript object instead.");if(Vo(e))throw new Error("Can not call `Record` with an immutable Collection as default values. Use a plain javascript object instead.");if(null===e||"object"!=typeof e)throw new Error("Can not call `Record` with a non-object as default values. Use a plain javascript object instead.")}(e);var n=function(i){var a=this;if(i instanceof n)return i;if(!(this instanceof n))return new n(i);if(!r){r=!0;var s=Object.keys(e),l=o._indices={};o._name=t,o._keys=s,o._defaultValues=e;for(var u=0;u<s.length;u++){var c=s[u];l[c]=u,o[c]?"object"==typeof console&&console.warn&&console.warn("Cannot define "+bl(this)+' with property "'+c+'" since that property name is part of the Record API.'):Ol(o,c)}}return this.__ownerID=void 0,this._values=cs().withMutations((function(e){e.setSize(a._keys.length),Po(i).forEach((function(t,r){e.set(a._indices[r],t===a._defaultValues[r]?void 0:t)}))})),this},o=n.prototype=Object.create(yl);return o.constructor=n,t&&(n.displayName=t),n};gl.prototype.toString=function(){for(var e,t=bl(this)+" { ",r=this._keys,n=0,o=r.length;n!==o;n++)t+=(n?", ":"")+(e=r[n])+": "+pa(this.get(e));return t+" }"},gl.prototype.equals=function(e){return this===e||Mo(e)&&El(this).equals(El(e))},gl.prototype.hashCode=function(){return El(this).hashCode()},gl.prototype.has=function(e){return this._indices.hasOwnProperty(e)},gl.prototype.get=function(e,t){if(!this.has(e))return t;var r=this._indices[e],n=this._values.get(r);return void 0===n?this._defaultValues[e]:n},gl.prototype.set=function(e,t){if(this.has(e)){var r=this._values.set(this._indices[e],t===this._defaultValues[e]?void 0:t);if(r!==this._values&&!this.__ownerID)return ml(this,r)}return this},gl.prototype.remove=function(e){return this.set(e)},gl.prototype.clear=function(){var e=this._values.clear().setSize(this._keys.length);return this.__ownerID?this:ml(this,e)},gl.prototype.wasAltered=function(){return this._values.wasAltered()},gl.prototype.toSeq=function(){return El(this)},gl.prototype.toJS=function(){return Us(this)},gl.prototype.entries=function(){return this.__iterator(qo)},gl.prototype.__iterator=function(e,t){return El(this).__iterator(e,t)},gl.prototype.__iterate=function(e,t){return El(this).__iterate(e,t)},gl.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._values.__ensureOwner(e);return e?ml(this,t,e):(this.__ownerID=e,this._values=t,this)},gl.isRecord=Mo,gl.getDescriptiveName=bl;var yl=gl.prototype;function ml(e,t,r){var n=Object.create(Object.getPrototypeOf(e));return n._values=t,n.__ownerID=r,n}function bl(e){return e.constructor.displayName||e.constructor.name||"Record"}function El(e){return pi(e._keys.map((function(t){return[t,e.get(t)]})))}function Ol(e,t){try{Object.defineProperty(e,t,{get:function(){return this.get(t)},set:function(e){aa(this.__ownerID,"Cannot set on an immutable record."),this.set(t,e)}})}catch(e){}}yl[ko]=!0,yl[lo]=yl.remove,yl.deleteIn=yl.removeIn=Ta,yl.getIn=Qs,yl.hasIn=Zs.hasIn,yl.merge=Ia,yl.mergeWith=Aa,yl.mergeIn=ja,yl.mergeDeep=Pa,yl.mergeDeepWith=xa,yl.mergeDeepIn=Fa,yl.setIn=Oa,yl.update=wa,yl.updateIn=Ra,yl.withMutations=Da,yl.asMutable=ka,yl.asImmutable=Ma,yl[zo]=yl.entries,yl.toJSON=yl.toObject=Zs.toObject,yl.inspect=yl.toSource=function(){return this.toString()};var Sl,Tl=function(e){function t(e,r){if(!(this instanceof t))return new t(e,r);if(this._value=e,this.size=void 0===r?1/0:Math.max(0,r),0===this.size){if(Sl)return Sl;Sl=this}}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toString=function(){return 0===this.size?"Repeat []":"Repeat [ "+this._value+" "+this.size+" times ]"},t.prototype.get=function(e,t){return this.has(e)?this._value:t},t.prototype.includes=function(e){return bi(this._value,e)},t.prototype.slice=function(e,r){var n=this.size;return bo(e,r,n)?this:new t(this._value,Oo(r,n)-Eo(e,n))},t.prototype.reverse=function(){return this},t.prototype.indexOf=function(e){return bi(this._value,e)?0:-1},t.prototype.lastIndexOf=function(e){return bi(this._value,e)?this.size:-1},t.prototype.__iterate=function(e,t){for(var r=this.size,n=0;n!==r&&!1!==e(this._value,t?r-++n:n++,this););return n},t.prototype.__iterator=function(e,t){var r=this,n=this.size,o=0;return new Ho((function(){return o===n?{value:void 0,done:!0}:Yo(e,t?n-++o:o++,r._value)}))},t.prototype.equals=function(e){return e instanceof t?bi(this._value,e._value):Ms(this,e)},t}(ii);function _l(e,t){return wl([],t||Rl,e,"",t&&t.length>2?[]:void 0,{"":e})}function wl(e,t,r,n,o,i){if("string"!=typeof r&&!Vo(r)&&(ri(r)||Xo(r)||ca(r))){if(~e.indexOf(r))throw new TypeError("Cannot convert circular structure to Immutable");e.push(r),o&&""!==n&&o.push(n);var a=t.call(i,n,ni(r).map((function(n,i){return wl(e,t,n,i,o,r)})),o&&o.slice());return e.pop(),o&&o.pop(),a}return r}function Rl(e,t){return Co(t)?t.toList():Io(t)?t.toMap():t.toSet()}const Il={version:"4.3.7",Collection:Lo,Iterable:Lo,Seq:ni,Map:Ua,OrderedMap:_s,List:cs,Stack:Ns,Set:Bs,OrderedSet:dl,PairSorting:{LeftThenRight:-1,RightThenLeft:1},Record:gl,Range:Hs,Repeat:Tl,is:bi,fromJS:_l,hash:Ti,isImmutable:Vo,isCollection:wo,isKeyed:Io,isIndexed:Co,isAssociative:No,isOrdered:Bo,isValueObject:mi,isPlainObject:ca,isSeq:Do,isList:us,isMap:gi,isOrderedMap:yi,isStack:Cs,isSet:Ds,isOrderedSet:ks,isRecord:Mo,get:va,getIn:Ys,has:fa,hasIn:Xs,merge:function(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return La(e,t)},mergeDeep:function(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return Na(e,t)},mergeWith:function(e,t){for(var r=[],n=arguments.length-2;n-- >0;)r[n]=arguments[n+2];return La(t,r,e)},mergeDeepWith:function(e,t){for(var r=[],n=arguments.length-2;n-- >0;)r[n]=arguments[n+2];return Na(t,r,e)},remove:ga,removeIn:Sa,set:ya,setIn:Ea,update:_a,updateIn:ma};var Al=0;const Cl=function(){var e=((new Date).getTime().toString(16)+"FF").substr(0,11);return"ssssssss-xxxx-4xxx-yxxx-x".replace(/[xys]/g,(function(e){var t="s"===e?Math.floor(16*Math.random()):15&Al++;return("x"===e?t:3&t|8).toString(16)}))+e};function Nl(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}var Ll=["formatValue","mongoFormatValue","sqlFormatValue","jsonLogic","elasticSearchFormatValue","spelFormatValue","spelImportFuncs","spelImportValue"],Pl=["formatOp","mongoFormatOp","sqlFormatOp","jsonLogic","spelFormatOp"],xl=function(e){return"object"===Wn(e)&&null!==e&&"[object Object]"===Object.prototype.toString.call(e)},jl=function(e){if("object"===Wn(e)&&null!==e){if(Array.isArray(e))return so(e);if(xl(e))return function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Nl(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Nl(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({},e)}return e},Fl=function(e,t){return Object.fromEntries(Object.entries(e).filter((function(e){var r=io(e,1)[0];return!t.includes(r)})))},Dl=function(e){var t;return null!==(t=null==e?void 0:e.cardinality)&&void 0!==t?t:1},kl=function(e,t){return e===t||(Ua.isMap(e)?e.equals(t):JSON.stringify(e)==JSON.stringify(t))},Ml=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return e===t||(Array.isArray(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=e.length;if(t.length!==n)return!1;for(var o=0;o<n;o++)if(!(r?Ml(e[o],t[o],r):e[o]===t[o]))return!1;return!0}(e,t,r):Ua.isMap(e)?e.equals(t):"object"==Wn(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=Object.keys(e),o=Object.keys(t),i=n.length;if(o.length!==i)return!1;for(var a=0;a<i;a++){var s=n[a];if(!(r?Ml(e[s],t[s],r):e[s]===t[s]))return!1}return!0}(e,t,r):e===t)};var Vl=function(e){return"object"===Wn(e)&&null!==e&&"function"==typeof e.toJS},Ul=function(e){return Vl(e)&&Il.isList(e)};function Bl(e){return Ul(e)?e:new Il.List(e)}function Gl(e){return Vl(e)?e.toJS():e}var $l=function(e){return e.replace(/[.*+?^${}()|[\]\\/]/g,"\\$&")},ql=function(e,t,r,n,o,i){if(Array.isArray(e))return t},Kl=function e(t){var r;if(t instanceof Array)return t.map((function(t,r){return e(t)}));if("object"===Wn(t)&&null!==t&&Wl(t)){var n,o=Fl(t,["$$typeof","_owner","_store","ref","key"]);return o.type&&(o.type="string"==typeof(r=o.type)?r:"function"==typeof r?r.name:r),null!=o&&null!==(n=o.props)&&void 0!==n&&n.children&&(o.props.children=e(o.props.children)),o}return t},Wl=function(e){return"object"===Wn(e)&&null!==e&&!Array.isArray(e)&&Object.keys(e).includes("type")&&Object.keys(e).includes("props")&&Object.keys(e).includes("key")&&Object.keys(e).includes("ref")&&Object.keys(e).includes("$$typeof")},zl=function(e){return"object"===Wn(e)&&null!==e&&!Array.isArray(e)&&"string"==typeof e.type&&Object.keys(e).includes("props")},Hl=function(e){return"object"===Wn(e)&&null!==e&&!Array.isArray(e)&&1===Object.keys(e).length};function Yl(e){return new Promise((function(t){setTimeout(t,e)}))}function Ql(e,t){return e||(e=[]),t||(t=[]),t.map((function(t){return[t,e.indexOf(t)]})).map((function(e,t,r){var n=io(e,2),o=n[0];if(-1==n[1]){var i=r.slice(t+1),a=r.slice(0,t).reverse().find((function(e){var t=io(e,2);return t[0],-1!=t[1]})),s=i.find((function(e){var t=io(e,2);return t[0],-1!=t[1]}));return s?[o,"before",s[0]]:a?[o,"after",a[0]]:[o,"append",null]}return null})).filter((function(e){return null!==e})).reduce((function(e,t){var r=io(t,3),n=r[0],o=r[1],i=r[2],a=e.indexOf(i);return-1==e.indexOf(n)&&(a>-1?e.splice(a+("after"==o?1:0),0,n):e.splice("append"==o?1/0:0,0,n)),e}),e.slice())}var Xl=function e(t){"object"!==Wn(t)||null===t||Wl(t)||(Object.keys(t).forEach((function(r){"__cache"!==r&&e(t[r])})),Object.freeze(t))},Jl=function e(t,r){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];if(xl(t)){if(t.var)return n[t.var]=r,!0;if(!xl(r))return!1;for(var i in t)if(!e(t[i],r[i],n,[].concat(so(o),[i])))return!1;return!0}if(Array.isArray(t)){if(!Array.isArray(r))return!1;for(var a=0;a<t.length;a++)if(!e(t[a],r[a],n,[].concat(so(o),[a])))return!1;return!0}return t===r},Zl=function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return(null!=e?e:("undefined"!=typeof process&&process.env,0))?console:{error:function(){},log:function(){},warn:function(){},debug:function(){},info:function(){}}},eu=function(){for(var e,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=0;r<t.length;r++){var n=t[r];if(void 0!==n){e=n;break}}return e},tu=Zl(),ru=p(6834),nu=p.n(ru),ou=p(8831),iu=p.n(ou),au=p(8906),su=p.n(au),lu=p(7027),uu=p.n(lu);function cu(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function du(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function pu(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?du(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):du(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var fu=function(e){return"object"==Wn(e)&&null!==e&&!Array.isArray(e)},vu=function(e,t){return null==e||""==e?void 0:fu(e)?pu(pu({},e),{},{title:e.title||e.value}):{value:e,title:void 0!==t?t:""+e}},hu=function(e){var t=vu(e);return fu(t)?pu(pu({},vu(e)),{},{isCustom:!0}):t},gu=function(e){if(Array.isArray(e))return e.map((function(e){return vu(e)}));if(!fu(e))return e;var t=[];for(var r in e){var n=e[r];t.push(vu(r,n))}return t},yu=function(e,t){return Array.isArray(e)?e.map((function(e){return vu(e)})).find((function(e){return""+e.value==""+t})):void 0!==e[t]?vu(t,e[t]):void 0},mu=function(e,t){if(null==e)return t;var r=yu(e,t);return void 0!==r?r.title:t},bu=function(e,t){if(null==e)return t;var r=yu(e,t);return void 0!==r?r.value:t},Eu=function(e,t){var r=[];if(Array.isArray(e)){var n,o=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return cu(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?cu(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(e);try{for(o.s();!(n=o.n()).done;){var i=n.value,a=t(vu(i));null!=a&&r.push(a)}}catch(e){o.e(e)}finally{o.f()}}else for(var s in e){var l=t(vu(s,e[s]));null!=l&&r.push(l)}return r},Ou=function(e,t){return Eu(t,(function(t){return-1!="".concat(t.value).indexOf(e)||-1!=t.title.indexOf(e)?t:null})).filter((function(e){return null!==e})).shift()},Su=function(e,t){return Eu(t,(function(t){return""+t.value==""+e?t:null})).filter((function(e){return null!==e})).shift()},Tu=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return e.interpose("children1").withMutations((function(e){return e.skip(1),e.push.apply(e,r),e}))},_u=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return e.interpose("children1").withMutations((function(e){return e.push.apply(e,r),e}))},wu=function(e,t){var r=new Il.OrderedMap(eo({},e.get("id"),e)),n=e;return t.forEach((function(e){var t;n=r.get(e),r=null===(t=n)||void 0===t?void 0:t.get("children1")})),n},Ru=function(e){var t=e;return function e(r,n){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=n.push(r.get("id")),a=r.getIn(["properties","isLocked"]);o&&a&&(t=t.deleteIn(Tu(i,"properties","isLocked")));var s=r.get("children1");s&&s.map((function(t,r){e(t,i,a||o)}))}(e,new Il.List),t},Iu=function(e){var t=e;return function e(r,n,o,i){if(r){var a=r.get("path"),s=r.get("id"),l=s||i||Cl(),u=n.push(l);a&&a.equals(u)||(t=t.setIn(Tu(u,"path"),u)),s||(t=t.setIn(Tu(u,"id"),l));var c=r.get("children1");c&&("Map"===c.constructor.name&&(t=t.setIn(Tu(u,"children1"),new Il.OrderedMap(c))),c.map((function(t,r){e(t,u,o+1,r)})))}}(e,new Il.List,0),t},Au=function(e){var t=e;return function e(r,n,o,i){if(!r)return!1;var a=r.get("id")||i,s=n.push(a),l=r.get("children1");if(l){var u=l.map((function(t,r){return e(t,s,o+1,r)})).reduce((function(e,t){return e&&t}),!0);if((0==l.size||u)&&o>0)return t=t.deleteIn(Tu(s)),!0}return!1}(e,new Il.List,0),t},Cu=function(e){var t=[],r={},n=[],o=0,i=0,a=0,s={};!function l(u,c,d,p,f,v,h,g){var y=u===e,m=u.get("type"),b=u.get("collapsed"),E=u.get("id"),O=u.get("children1"),S=u.getIn(["properties","isLocked"]),T=O?O.map((function(e,t){return t})).valueSeq().toArray():null,_="rule_group"===m,w="rule"===m,R="group"===m,I="case_group"===m,A=!f&&(!O||_),C=(null==T?void 0:T.length)>0,N=c.length?c[c.length-1]:null,L=I?E:h;I&&(n.push(E),i=0,a=0,s={});var P,x=L?n.indexOf(L):null,j=t.length,F=o;y||((P={}).caseNo=x,P.globalNoByType=I?x:s[m]||0,P.indexPath=[].concat(so(c.slice(1).map((function(e){return r[e].childNo}))),[g]),w?P.globalLeafNo=i:R&&(P.globalGroupNo=a)),t.push(E),r[E]={node:u,index:j,id:E,type:m,parent:N,parentType:N?r[N].type:null,children:T,childNo:g,caseId:L,caseNo:x,path:c.concat(E),lev:v,isLeaf:!O,isAtomicRule:A,isLocked:S||p,top:d?null:F,isDefaultCase:I?!O:void 0,atomicRulesCountInCase:I?0:void 0,position:P,collapsed:b,_top:j,leaf:!O};var D=0,k=0;d||(o+=1,D+=1,!C||b||_||(k+=1),y||I||(R&&a++,w&&i++,s[m]=(s[m]||0)+1)),h&&A&&r[h].atomicRulesCountInCase++;var M=0,V=0;if(C){var U=0;O.map((function(e,t){if(e){l(e,c.concat(E),d||b,p||S,f||_,v+1,L,U);var n=r[t];M=Math.max(M,n.depth||0),V+=n.height,U++}}))}D+=V,k+=M;var B=t.length-j,G=d?null:F+D;Object.assign(r[E],{depth:O?k:void 0,_height:B,height:D,bottom:G})}(e,[],!1,!1,!1,0,null,null);for(var l=0;l<t.length;l++){var u=l>0?t[l-1]:null,c=l<t.length-1?t[l+1]:null,d=r[t[l]];d.prev=u,d.next=c}return{flat:t,items:r,cases:n}},Nu=function(e){if(!e)return-1;var t=0;return function e(r,n,o){var i,a,s;"function"==typeof r.get?(i=r.get("id"),a=r.get("children1"),s=r.get("type")):(i=r.id,a=r.children1,s=r.type),t++,a&&"rule_group"!=s&&a.map((function(t,r){t&&e(t,n.concat(i),o+1)}))}(e,[],0),t-1},Lu=function(e){if(!e)return-1;var t=0;return function e(r,n,o){var i,a,s;"function"==typeof r.get?(i=r.get("id"),a=r.get("children1"),s=r.get("type")):(i=r.id,a=r.children1,s=r.type),"rule"==s||"rule_group"==s?t++:a&&a.map((function(t,r){t&&e(t,n.concat(i),o+1)}))}(e,[],0),t},Pu=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=e;return function e(n,o){t&&n.path&&delete n.path,t&&!r&&o&&delete n.id;var i=n.properties;i&&null==i.operatorOptions&&delete i.operatorOptions;var a=n.children1;if(a){for(var s in a)a[s]&&e(a[s],s);r&&(n.children1=Object.values(a))}}(e,null),n},xu=function(e){var t=[],r=e.get("children1");return r&&r.map((function(e){var r,n=e.getIn(["properties","value"]);n&&1==n.size?(r=n.get(0),Array.isArray(r)&&0==r.length&&(r=null)):r=null,t=[].concat(so(t),[r])})),t},ju=function(e){return!e.get("children1")||0==e.get("children1").size},Fu=function(e,t){return e.getIn(Tu(t,"children1")).size>0},Du=function(e){if(null!=e&&e.toJS){var t,r=null==e||null===(t=e.toJS)||void 0===t?void 0:t.call(e);return null!=r&&r.func?e.toOrderedMap():r}return e},ku=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(e){var n=e;return n=n.toJS(),Pu(n,t,r)}},Mu=function(e){if(Vu(e))return e;if(Uu(e))return Iu(Bu(e));if("string"==typeof e&&e.startsWith('["~#iM"'))throw new Error("You are trying to load query in obsolete serialization format (Immutable string) which is not supported in versions starting from 2.1.17");if("string"==typeof e)return Iu(Bu(JSON.parse(e)));throw new Error("Can't load tree!")},Vu=function(e){return Ua.isMap(e)},Uu=function(e){return"object"==Wn(e)&&("group"==e.type||"switch_group"==e.type)};function Bu(e){var t=_l(e,(function(e,t,r){var n,o=r&&r.length>3&&"value"===r[r.length-1]&&"args"===r[r.length-3],i=r&&r.length>3&&"value"===r[r.length-1]&&"properties"===r[r.length-2];if("properties"==e){n=t.toOrderedMap();for(var a=0;a<2;a++){var s,l,u;null===(null===(s=n.get("value"))||void 0===s||null===(l=(u=s).get)||void 0===l?void 0:l.call(u,a))&&(n=n.setIn(["value",a],void 0))}}else n=o?Du(t):(r?i:"value"==e)&&Il.Iterable.isIndexed(t)?t.map(Du).toList():"asyncListValues"==e?t.toJS():"children1"==e&&Il.Iterable.isIndexed(t)?new Il.OrderedMap(t.map((function(e){return[(null==e?void 0:e.get("id"))||Cl(),e]}))):Il.Iterable.isIndexed(t)?t.toList():t.toOrderedMap();return n}));return t}function Gu(e){return to(e)||ao(e)||no(e)||oo()}var $u=p(2468),qu=p.n($u);function Ku(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Wu(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Ku(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Ku(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function zu(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Hu(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Hu(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Hu(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var Yu="jlField",Qu="jlArgs",Xu=["==","!="],Ju=["<","<=",">",">="],Zu=["multiselect_equals","multiselect_not_equals","multiselect_contains","multiselect_not_contains"],ec=function(e){return{errors:[],settings:null==e?void 0:e.settings}},tc=function(e,t){return rc(e,t,!1)},rc=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=ec();n.settings={allowUnknownFields:!1,returnErrors:r};var o=_h(t,void 0,!1),i=nc(o),a=e?ac(e,i,o,["rule","group","switch"],n):void 0,s=a?Mu(a):void 0;return r?[s,n.errors]:(n.errors.length&&console.warn("Errors while importing from JsonLogic:",n.errors),s)},nc=function(e){var t={},r={};for(var n in e.operators){var o=e.operators[n];if("string"==typeof o.jsonLogic){var i=o.jsonLogic+"/"+Dl(o);t[i]||(t[i]=[]),t[i].push(n)}else if("string"==typeof o.jsonLogic2){var a=o.jsonLogic2+"/"+Dl(o);t[a]||(t[a]=[]),t[a].push(n),r[n]||(r[n]={}),r[n]={template:o.jsonLogic(Yu,n,Qu),jsonLogic2:o.jsonLogic2,_jsonLogicIsExclamationOp:!!o._jsonLogicIsExclamationOp}}}var s={};for(var l in e.conjunctions)s[e.conjunctions[l].jsonLogicConj||l.toLowerCase()]=l;var u,c={},d=zu(jh(e));try{for(d.s();!(u=d.n()).done;){var p=io(u.value,2),f=p[0],v=p[1],h=void 0;v.jsonLogicIsMethod?h="#"+v.jsonLogic:"string"==typeof v.jsonLogic&&(h=v.jsonLogic),h&&(c[h]||(c[h]=[]),c[h].push(f))}}catch(e){d.e(e)}finally{d.f()}var g=e.settings.jsonLogic;return{operators:t,conjunctions:s,funcs:c,varKeys:["var",g.groupVarKey,g.altVarKey],combinationOperators:r}},oc=function(e,t,r){var n,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(null!=t&&t.combinationOperators)for(var i=0,a=Object.entries(t.combinationOperators);i<a.length;i++){var s=io(a[i],2),l=s[0],u=s[1];if(null==o||o.includes(l)){var c=ic(u.template,e);c.match&&(n?r.errors.push("Operator matched against 2 templates: ".concat(n.newOp," and ").concat(l)):n=c,n.newOp=u.jsonLogic2)}}return n},ic=function e(t,r){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{match:!0,jlField:null,jlArgs:[]};if(null==t||null==r)return n.match=!1,n;var o=Object.keys(t),i=Object.keys(r);if(o.length!==i.length)return n.match=!1,n;for(var a=0;a<o.length;a++){var s=o[a],l=t[s];if(s!==i[a])return n.match=!1,n;if(l===Yu&&Hl(r[s]))n.jlField=r[s];else if(l===Qu)n.jlArgs.push(r[s]);else if("object"===Wn(l)&&null!==l||Array.isArray(l))n=e(l,r[s],n);else if(l!==r[s])return n.match=!1,n}return n},ac=function e(t,r,n,o,i){var a,s,l,u=arguments.length>5&&void 0!==arguments[5]&&arguments[5],c=arguments.length>6?arguments[6]:void 0,d=arguments.length>7?arguments[7]:void 0,p=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null;Hl(t)&&(a=Object.keys(t)[0],s=t[a],Array.isArray(s)||(s=[s]));var f=i.errors.length,v=n.settings.jsonLogic.lockedOp,h="!"==a&&1==s.length&&s[0]&&Hl(s[0])&&r.varKeys.includes(Object.keys(s[0])[0]),g=oc(t,r,i);g&&((s=[])[0]=g.jlField,g.jlArgs.forEach((function(e){return s.push(e)})),a=g.newOp);var y="!"==a&&!h,m=v&&a==v,b=o.includes("switch");m?l=e(s[0],r,n,o,i,u,c,d,p,!0):y?l=e(s[0],r,n,o,i,!u,c,d,p):o.includes("val")?l=lc(a,s,r,n,u,i,p)||uc(a,s,r,n,u,c,i,p)||sc(t,c,d,n,i):(o.includes("switch")&&(l=vc(a,s,r,n,u,i,p)),null==l&&o.includes("group")&&(l=cc(a,s,r,n,u,i,p,!1)),null==l&&o.includes("rule")&&(l=fc(a,s,r,n,u,i,p)),l&&b&&!["group","switch_group"].includes(l.type)&&(l=dc(l,n)));var E=i.errors.length;return"!"!=a&&void 0===l&&E==f&&i.errors.push("Can't parse logic ".concat(JSON.stringify(t))),m&&(l.properties.isLocked=!0),l},sc=function(e,t,r,n,o){var i;if(void 0===e&&(e=null==t?void 0:t.defaultValue),void 0!==e){r=r||(null==t?void 0:t.mainWidget);var a=n.widgets[r],s=null==t?void 0:t.type;if(!s||a){if(!Hl(e)){if("time"===s&&"number"==typeof e){var l=Math.floor(e/60/60)%24,u=Math.floor(e/60)%60,c=e%60,d=a.valueFormat;if(d){var p=new Date(e);p.setMilliseconds(0),p.setHours(l),p.setMinutes(u),p.setSeconds(c),e=qu()(p).format(d)}else e="".concat(l,":").concat(u,":").concat(c)}if(["date","datetime"].includes(s)&&e&&!(e instanceof Date))try{var f=new Date(e);f instanceof Date&&f.toISOString()===e&&(e=f)}catch(t){o.errors.push("Can't convert value ".concat(e," as Date")),e=void 0}if(e instanceof Date&&t){var v=a.valueFormat;v&&(e=qu()(e).format(v))}var h;if(e&&null!=t&&null!==(i=t.fieldSettings)&&void 0!==i&&i.asyncFetch&&(h=Array.isArray(e)?e:[e]),null!=a&&a.jsonLogicImport)try{e=a.jsonLogicImport.call(n.ctx,e)}catch(t){var g;o.errors.push("Can't import value ".concat(e," using import func of widget ").concat(r,": ").concat(null!==(g=null==t?void 0:t.message)&&void 0!==g?g:t)),e=void 0}return{valueSrc:"value",value:e,valueType:null==a?void 0:a.type,asyncListValues:h}}o.errors.push("Unexpected logic in value: ".concat(JSON.stringify(e)))}else o.errors.push("No widget for type ".concat(s))}},lc=function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if(r.varKeys.includes(e)&&"string"==typeof t[0]){var s,l=Mh(n,t[0],a),u=Qh(n,l);return u||null!==(s=i.settings)&&void 0!==s&&s.allowUnknownFields?{valueSrc:"field",value:l,valueType:null==u?void 0:u.type}:void i.errors.push("No config for field ".concat(l))}},uc=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=arguments.length>6?arguments[6]:void 0,s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null;if(e){var l,u,c,d="method"==e;if(d){var p,f,v=Gu(t);p=v[0],l=v[1],f=v.slice(2),u=[p].concat(so(f))}else l=e,u=t;var h=(d?"#":"")+l,g=(null==i?void 0:i.type)||(null==i?void 0:i.returnType),y=(r.funcs[h]||[]).filter((function(e){return!i||Uh(n,e).returnType==g}));if(y.length)c=y[0];else{var m,b=eo({},e,t),E=zu(jh(n));try{for(E.s();!(m=E.n()).done;){var O=io(m.value,2),S=O[0],T=O[1];if(T.jsonLogicImport&&(!g||T.returnType==g)){var _=void 0;try{_=T.jsonLogicImport(b)}catch(e){}_&&(c=S,u=_)}}}catch(e){E.e(e)}finally{E.f()}}if(c&&c){var w=Uh(n,c),R=Object.keys(w.args||{}),I=u.reduce((function(e,t,o){var i,l=R[o],u=w.args[l];return u&&(i=ac(t,r,n,["val"],a,!1,u,null,s)),void 0!==i?Wu(Wu({},e),{},eo({},l,i)):e}),{});for(var A in w.args){var C,N=w.args[A],L=I[A];if(void 0===L)if(void 0!==(L=null==N?void 0:N.defaultValue)&&(L={value:L,valueSrc:null!==(C=L)&&void 0!==C&&C.func?"func":"value",valueType:N.type}),void 0===L){if(null==N||!N.isOptional)return void a.errors.push("No value for arg ".concat(A," of func ").concat(c))}else I[A]=L}return{valueSrc:"func",value:{func:c,args:I},valueType:w.returnType}}}},cc=function(e,t,r,n,o,i){var a,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,l=r.conjunctions[e],u=n.settings.fieldSeparator;if(l){var c=t.map((function(e){return ac(e,r,n,["rule","group"],i,!1,null,null,s)})).filter((function(e){return void 0!==e})).reduce((function(e,t){return Wu(Wu({},e),{},eo({},t.id,t))}),{}),d=Object.values(c).map((function(e){var t,r;return"field"==(null==e||null===(t=e.properties)||void 0===t?void 0:t.fieldSrc)&&(null==e||null===(r=e.properties)||void 0===r?void 0:r.field)})).filter((function(e){var t;return null==e||null===(t=e.includes)||void 0===t?void 0:t.call(e,u)})),p=Object.fromEntries((a=d,Array.from(new Set(a))).map((function(e){var t=e.split(u),r=Object.fromEntries(t.slice(0,-1).map((function(e,t,r){return[].concat(so(r.slice(0,t)),[e])})).map((function(e){return[e.join(u),Qh(n,e)]})).filter((function(e){var t=io(e,2),r=(t[0],t[1]);return"!group"==(null==r?void 0:r.type)})));return[e,Object.keys(r)]}))),f={conjunction:l,not:o},v=Cl(),h={},g={};return Object.entries(c).map((function(e){var t=io(e,2),r=t[0],o=t[1];if("group"==(null==o?void 0:o.type)||"rule_group"==(null==o?void 0:o.type))h[r]=o;else{var i,a=null==o||null===(i=o.properties)||void 0===i?void 0:i.field,c=p[a]||[],d=c[c.length-1];if(d){var f=h,v=qh(s,n),y=qh(d,n);Ml(v,y.slice(0,v.length))||(v=[]);var m=d.split(u).slice(v.length).map((function(e,t,r){return[].concat(so(v),so(r.slice(0,t)),[e]).join(u)})).map((function(e){return{f:e,fc:Qh(n,e)||{}}})).filter((function(e){return"!struct"!=e.fc.type}));m.map((function(e,t){var r=e.f,n=e.fc,o=g[r];o||(o=Cl(),g[r]=o,f[o]={type:"rule_group",id:o,children1:{},properties:{conjunction:l,not:!1,field:r,fieldSrc:"field",mode:n.mode}}),f=f[o].children1})),f[r]=o}else o&&(h[r]=o)}})),{type:"group",id:v,children1:h,properties:f}}},dc=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return{type:"group",id:Cl(),children1:eo({},e.id,e),properties:{conjunction:Pd(t),not:r}}},pc=function(e,t,r,n,o,i,a){var s,l=Zu.map((function(e){var t;return null===(t=i.operators[e])||void 0===t?void 0:t.jsonLogic2})).includes(e),u=i.settings.groupOperators.includes(e)&&!l,c=u?0:t-1;u?c=0:Xu.includes(e)&&1==c&&null===r[1]&&(t=1,c=0,r=[r[0]]);var d=e+"/"+c,p=o.operators[d];if(p){var f,v=[];if(Ju.includes(e)&&3==t)f=r[1],v=[r[0],r[2]];else{var h=Gu(r);f=h[0],v=h.slice(1)}if(Hl(f)){var g=function(e,t,r,n,o){var i,a,s,l,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,c=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,d=arguments.length>7?arguments[7]:void 0,p=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null,f=Object.keys(t)[0],v=Object.values(t)[0],h=function(e,t){return function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;Array.isArray(t)||(t=[t]);var s=lc(e,t,r,n,o,i,a);if(s)return{fieldSrc:"field",field:s.value}}(e,t,n,o,u,d,p)||function(e,t,r,n,o){var i=uc(e,t,r,n,o,arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,arguments.length>6?arguments[6]:void 0,arguments.length>7&&void 0!==arguments[7]?arguments[7]:null);if(i)return{fieldSrc:"func",field:i.value}}(e,t,n,o,u,c,d,p)},g=d.errors.length,y=h(f,v);if(y&&(i=y.field,a=y.fieldSrc),e&&(l=!0,s=r[0],r=[]),"reduce"==f&&Array.isArray(v)&&3==v.length){var m=io(v,3),b=m[0],E=m[1],O=m[2];if(Hl(b)&&0==O&&Hl(E)&&Array.isArray(E["+"])&&1==E["+"][0]&&Hl(E["+"][1])&&"accumulator"==E["+"][1].var)if(f=Object.keys(b)[0],v=Object.values(b)[0],"filter"==f){var S=io(v,2),T=S[0],_=S[1];if(Hl(T)){var w=h(f=Object.keys(T)[0],v=Object.values(T)[0]);w&&(i=w.field,a=w.fieldSrc,s=_,l=!0)}}else{var R=h(f,v);R&&(i=R.field,a=R.fieldSrc,l=!0)}}var I=d.errors.length;if(i||I!=g||d.errors.push("Unknown LHS ".concat(JSON.stringify(t))),i)return{field:i,fieldSrc:a,having:s,isGroup:l,args:r}}(u,f,v,o,i,null,null,a,n);if(g){var y=g.field,m=g.fieldSrc,b=g.having,E=(g.isGroup,g.args),O=Qh(i,y);if(O||null!==(s=a.settings)&&void 0!==s&&s.allowUnknownFields){var S=p[0];if(p.length>1&&O&&O.operators){if(0==(p=p.filter((function(e){return O.operators.includes(e)}))).length)return void a.errors.push("No corresponding ops for LHS ".concat(y));S=p[0]}return{field:y,fieldSrc:m,fieldConfig:O,opKey:S,args:E,having:b}}a.errors.push("No config for LHS ".concat(y))}}else a.errors.push("Incorrect operands for ".concat(e,": ").concat(JSON.stringify(r)))}},fc=function e(t,r,n,o,i,a){var s,l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,u=arguments.length>7&&void 0!==arguments[7]&&arguments[7];if(t){var c=Object.values(o.conjunctions).map((function(e){return e.jsonLogicConj})),d=function(e,t,r,n,o,i,a){var s=ec(a),l=pc(e,t,r,n,o,i,s);if(l)return l;a.errors.push(s.errors.join("; ")||"Unknown op ".concat(e,"/").concat(t))}(t,r.length,r,l,n,o,a);if(d){var p,f,v=d.field,h=d.fieldSrc,g=d.fieldConfig,y=d.opKey,m=d.args,b=d.having,E=Qh(o,l),O=o.operators[y],S=!!o.operators[null===(s=O)||void 0===s?void 0:s.reversedOp],T="!group"==g.type,_="!group"==(null==E?void 0:E.type),w=S&&(!!o.settings.reverseOperatorsForNot||T&&!b||!T&&_&&!u),R=i&&w||!1,I=!1,A=!!o.settings.reverseOperatorsForNot;if("!group"==(null==g?void 0:g.type)&&b){p=Object.keys(b)[0],f=b[p],Array.isArray(f)||(f=[f]);for(var C=oc(b,n,a);"!"==p&&!C&&!("!"==p&&1==f.length&&f[0]&&Hl(f[0])&&n.varKeys.includes(Object.keys(f[0])[0]));){I=!I,b=b["!"],p=Object.keys(b)[0],f=b[p],A&&c.includes(p)&&1==f.length&&(b=b[p][0],p=Object.keys(b)[0],f=b[p]),C=oc(b,n,a)||C}Array.isArray(f)||(f=[f]),C&&((f=[])[0]=C.jlField,C.jlArgs.forEach((function(e){return f.push(e)})),p=C.newOp)}R&&(i=!i,y=O.reversedOp,O=o.operators[y]);var N=yv(o,v,y,null),L=m.map((function(e){return ac(e,n,o,["val"],a,!1,g,N,l)}));if(!L.filter((function(e){return void 0===e})).length){var P,x=null==g?void 0:g.type;if("!group"!==x&&"!struct"!==x||(x=null),"!group"==(null==g?void 0:g.type)&&b){var j;if(void 0!==n.conjunctions[p]?P=cc(p,f,n,o,I,a,v,!0):(P=e(p,f,n,o,I,a,v,!0))&&("rule_group"===P.type&&(null===(j=P.properties)||void 0===j?void 0:j.field)!==v&&(P=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:void 0,i=arguments.length>5&&void 0!==arguments[5]&&arguments[5];if(e)return{type:"rule_group",id:Cl(),children1:eo({},e.id,e),properties:{conjunction:o||Ld(n,r),not:i,field:t}}}(P,v,g,o)),Object.assign(P.properties,{conjunction:Ld(o,g)})),!P)return;P.type="rule_group",Object.assign(P.properties,{field:v,mode:g.mode,operator:y}),"array"==g.mode&&Object.assign(P.properties,{value:L.map((function(e){return e.value})),valueSrc:L.map((function(e){return e.valueSrc})),valueType:L.map((function(e){return e.valueType}))}),i&&(P=dc(P,o,i))}else if("!group"!=(null==g?void 0:g.type)||b){var F=L.map((function(e){return e.asyncListValues})).filter((function(e){return null!=e})),D=F.length?F[0]:void 0;P={type:"rule",id:Cl(),properties:Wu({field:v,fieldSrc:h,operator:y,value:L.map((function(e){return e.value})),valueSrc:L.map((function(e){return e.valueSrc})),valueType:L.map((function(e){return e.valueType}))},D?{asyncListValues:D}:{})},(i||u)&&(P=dc(P,o,i))}else P={type:"rule_group",id:Cl(),children1:{},properties:{conjunction:Ld(o,g),not:!1,mode:g.mode,field:v,operator:y}},"array"===g.mode&&Object.assign(P.properties,{value:L.map((function(e){return e.value})),valueSrc:L.map((function(e){return e.valueSrc})),valueType:L.map((function(e){return e.valueType}))}),i&&(P=dc(P,o,i));return P}}}},vc=function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if("if"===(null==e?void 0:e.toLowerCase())){var s=hc(t).map((function(e){var t=io(e,2),o=t[0],s=t[1];return[o?ac(o,r,n,["rule","group"],i,!1,null,null,a):null,yc(n,i,r,s)]})).map((function(e){var t=io(e,2),r=t[0],o=t[1];return gc(r,o,n,i)}));return{type:"switch_group",id:Cl(),children1:s,properties:{}}}},hc=function(e){var t=[];return function e(r){var n=io(r,3),o=n[0],i=n[1],a=n[2];t.push([o,i]);var s=Hl(a)?Object.keys(a)[0]:null;"if"===(null==s?void 0:s.toLowerCase())?e(a[s]):t.push([void 0,a])}(e),t},gc=function(e,t,r,n){var o;return e?(o=Wu({},e)).type?("group"!=o.type&&(o=dc(o,r)),o.type="case_group"):(n.errors.push("Unexpected case: ".concat(JSON.stringify(o))),o=void 0):o={id:Cl(),type:"case_group",properties:{}},o&&(o.properties=Wu(Wu({},o.properties),t)),o},yc=function(e,t,r,n){var o=Qh(e,"!case_value");if(o){var i=o.mainWidget,a=e.widgets[i];if(a){var s=ac(n,r,e,["val","case_val"],t,!1,o,i);if(null!=s){var l=s.value,u=s.valueSrc,c=s.valueType;return{value:[l],valueSrc:[null!=u?u:"value"],valueType:[null!=c?c:null==a?void 0:a.type],field:"!case_value"}}}else t.errors.push("No widget ".concat(i," for case value"))}else t.errors.push("Missing caseValueField in settings")},mc=p(138),bc=p(358),Ec=p.n(bc)();Ec.trim=function(e){return"'"==e.charAt(0)?e.substring(1,e.length-1):e},Ec.escapeLike=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=Ec.escape(e);return"'"+(n=(t?"%":"")+(n=(n=Ec.trim(n)).replace(/[%_]/g,"\\$&"))+(r?"%":""))+"'"};var Oc=function(e){var t="''",r=null==e?void 0:e.type;return"date"==r?t="'0000-00-00'":"datetime"==r?t="'0000-00-00 00:00'":"time"==r?t="'00:00'":"number"==r&&(t="0"),t},Sc=function(e){var t="";return"number"==(null==e?void 0:e.type)&&(t=0),t},Tc=function(e){return"".concat(e,".?[true]")},_c=function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(null==e)return"null";switch(Wn(e)){case"boolean":return e?"true":"false";case"number":if(!Number.isFinite(e)||isNaN(e))return;return e+(!Number.isInteger(e)||t?"f":"");case"object":if(Array.isArray(e))return function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=["int","float"];return e.map((function(e){if(null!=e){if("string"==typeof e)r="String";else{if("number"!=typeof e)throw new Error("spelEscape: Can't use value ".concat(e," in array"));r=Number.isInteger(e)?"int":"float"}if(t){if(t!=r){if(!i.includes(t)||!i.includes(r))throw new Error("spelEscape: Can't use different types in array: found ".concat(t," and ").concat(r));t="float"}}else t=r}})),t||(t="String"),n="float"==t?e.map((function(e){return _c(e,!0)})):e.map((function(e){return _c(e)})),o?"new ".concat(t,"[]{").concat(n.join(", "),"}"):"{".concat(n.join(", "),"}")}(e,r);throw new Error("spelEscape: Object is not supported");default:return function(e){return"'"+e.replace(/'/g,"''")+"'"}(e)}},wc=function(e){return e&&Array.isArray(e)&&e.length?e.map((function(e){return"const"==e.type?_c(e.value):"property"==e.type?""+e.value:"variable"==e.type?"#"+e.value:void 0})).filter((function(e){return null!=e})).join(" + "):"null"},Rc=function(e){if(null==e)return[void 0,[]];var t=[],r="case_value"==e.valueType?e.value:e;return[(Array.isArray(r)?r:[r]).map((function(e){return"value"===e.valueSrc?null===e.value?void 0:{type:"const",value:e.value}:"field"===e.valueSrc?{type:e.isVariable?"variable":"property",value:e.value}:void t.push("Unsupported valueSrc ".concat(e.valueSrc," in concatenation"))})).filter((function(e){return null!=e})),t]},Ic=function(e){return null==e?"NULL":e.toString()},Ac=function(e){return null==e||"("===(null==e?void 0:e[0])&&")"===(null==e?void 0:e[(null==e?void 0:e.length)-1])?e:"("+e+")"};function Cc(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Nc(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Nc(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Nc(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Lc(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Pc(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Lc(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Lc(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var xc="${0}.compareTo(${1})",jc={datetime:!0,time:!0,date:!0},Fc=function(e,t){return Dc(e,t,!1)},Dc=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=_h(t,void 0,!1),i=kc(e,o,n,null);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to SpEL:",n.errors),i)},kc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(e){var o=e.get("type");return"group"===o||"rule_group"===o?Uc(e,t,r,n):"rule"===o?$c(e,t,r,n):"switch_group"==o?Vc(e,t,r,n):"case_group"==o?Mc(e,t,r,n):void 0}},Mc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("type");if("case_group"==o){var i=e.get("properties")||new Ua,a=io(Kc(t,i,r,null,n,"!case_value"),3),s=a[0];return a[1],a[2],[Uc(e,t,r,n),s]}r.errors.push("Unexpected child of type ".concat(o," inside switch"))},Vc=function(e,t,r){e.get("properties")||new Ua;var n=e.get("children1");if(n){var o=n.map((function(e){return Mc(e,t,r,null)})).filter((function(e){return void 0!==e})).valueSeq().toArray();if(o.length){if(1==o.length&&!o[0][0])return o[0][1];for(var i=[],a=0;a<o.length;a++)a==o.length-1||o[a][0]?(i.push(o[a]),a==o.length-1&&o[a][0]&&i.push([void 0,null])):r.errors.push("No condition for case ".concat(a));for(var s="",l="",u=0;u<i.length;u++){var c=io(i[u],2),d=c[0],p=c[1];null==p&&(p="null"),null==d&&(d="true"),u!=i.length-1?(s+="(".concat(d," ? ").concat(p," : "),l+=")"):s+="".concat(p)}return s+l}}},Uc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("type"),i=e.get("properties")||new Ua,a=i.get("mode"),s=e.get("children1")||new cs,l=i.get("field"),u=i.get("conjunction");u||(u=Pd(t));var c=t.conjunctions[u],d=i.get("not"),p="rule_group"===o,f=p&&"struct"!=a,v=f?l:n,h=(Qh(t,v)||{}).isSpelArray,g=t.settings.fieldSeparator,y=i.get("operator");y||a&&"some"!=a||(y="some");var m=Gc(t,y,l),b=m!=y,E=y&&Xh(t,m,l)||null,O=p&&(!m||0==E.cardinality),S=io(Kc(t,i,r,m,n,null),3),T=S[0],_=S[1],w=S[2],R=s.map((function(e){return kc(e,t,r,v)})).filter((function(e){return void 0!==e}));if(f&&!O){if(null==T)return}else if(!R.size)return;var I,A=p,C=R.size?c.spelFormatConj.call(t.ctx,R,u,d,A):null;if(f){var N=zc(r,t,l,n),L=(g||".")+(h?"length":"size()"),P="".concat(N).concat(L),x=C?"".concat(N,".?[").concat(C,"]").concat(L):P;I=Bc(r,t,i,x,O?P:T,m,_,w,b)}else I=C;return I},Bc=function(e,t,r,n,o,i,a,s){var l=arguments.length>8&&void 0!==arguments[8]&&arguments[8],u=r.get("field"),c=Xh(t,i,u)||{},d=Qh(t,u)||{},p=r.get("operatorOptions"),f=c.spelFormatOp||function(e,t,r){var n=t.spelOp;if(n){var o,i=n.includes("${0}"),a=jc[r],s=n,l=Dl(t);return a?o=function(e,t,r,n,o,i,a,u){var c=xc.replace(/\${(\w+)}/g,(function(t,n){return 0==n?e:l>1?r[n-1]:r}));return"".concat(c," ").concat(s," 0")}:i?o=function(e,t,r,o,i,a,s,u){return n.replace(/\${(\w+)}/g,(function(t,n){return 0==n?e:l>1?r[n-1]:r}))}:0==l?o=function(e,t,r,n,o,i,a,l){return"".concat(e," ").concat(s)}:1==l&&(o=function(e,t,r,n,o,i,a,l){return"".concat(e," ").concat(s," ").concat(r)}),o}}(0,c,s);if(f){var v,h=[n,i,o,a,s,Fl(c,Pl),p,d];return v=f.call.apply(f,[t.ctx].concat(h)),l&&(v=t.settings.spelFormatReverse.call(t.ctx,v)),void 0===v&&e.errors.push("Operator ".concat(i," is not supported for value source ").concat(a)),v}e.errors.push("Operator ".concat(i," is not supported"))},Gc=function(e,t,r){if(t){var n=Xh(e,t,r)||{},o=n.reversedOp,i=Xh(e,o,r)||{},a=n.spelOp||n.spelFormatOp,s=i.spelOp||i.spelFormatOp;if(a||s){if(!a&&s){var l=[o,t];t=l[0],o=l[1];var u=[i,n];n=u[0],i=u[1]}return t}}},$c=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("properties")||new Ua,i=o.get("field"),a=o.get("fieldSrc"),s=o.get("operator");if(null!=i&&null!=s){var l=Gc(t,s,i);if(l){var u=l!=s,c=io(Kc(t,o,r,l,n,null),3),d=c[0],p=c[1],f=c[2];if(void 0!==d){var v=qc(r,t,i,a,n);if(void 0!==v)return Bc(r,t,o,v,d,l,p,f,u)}}else r.errors.push("Operator ".concat(s," is not supported"))}},qc=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;return"func"===n?Hc(e,t,r,o):zc(e,t,r,o)},Kc=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=t.get("field"),s=t.get("valueSrc"),l=t.get("valueType");("!case_value"==i||l&&"case_value"==l.get(0))&&(a="!case_value");var u,c=Qh(e,a)||{},d=Xh(e,n,a)||{},p=Dl(d),f=t.get("value"),v=t.get("asyncListValues"),h=[],g=[];if(null!=f){var y=f.map((function(t,i){var u=s?s.get(i):null,p=l?l.get(i):null,f=Av(t,u,e),y=yv(e,a,n,u),m=Jh(e,a,n,y,u,{forExport:!0}),b=Wc(r,e,f,u,p,m,c,n,d,o,v);return void 0!==b&&(h.push(u),g.push(p)),b})),m=y.filter((function(e){return void 0===e})).size>0;y.size<p||m||(u=p>1?y.toArray():1==p?y.first():null)}return[u,h.length>1?h:h[0],g.length>1?g:g[0]]},Wc=function(e,t,r,n,o,i,a,s,l){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,c=arguments.length>10?arguments[10]:void 0;if(void 0!==r){var d;if("field"===n)d=zc(e,t,r,u);else if("func"===n)d=Hc(e,t,r,u);else if("function"==typeof(null==i?void 0:i.spelFormatValue)){var p=i.spelFormatValue,f=[r,Pc(Pc({},iu()(a,["fieldSettings","listValues"])),{},{asyncListValues:c}),Fl(i,Ll)];if(s&&(f.push(s),f.push(l)),"field"==n){var v=Qh(t,r)||{};f.push(v)}d=p.call.apply(p,[t.ctx].concat(f))}else d=_c(r);return d}},zc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(r){var o=t.settings.fieldSeparator,i=Qh(t,r)||{},a=qh(r,t),s=dv(r,t,n),l=t.settings.formatSpelField,u=mv(r,t,e,n),c=s.map((function(e){var t,r=io(e,3),n=r[0],i=r[1],a=r[2];return a&&(t="!struct"==a.type||"!group"==a.type&&"struct"==a.mode?i.isSpelMap?"map":"class":"!group"==a.type?i.isSpelItemMap?"[map]":"[class]":"class"),{key:n,parent:t,isSpelVariable:null==i?void 0:i.isSpelVariable,fieldSeparator:o}}));return l.call(t.ctx,u,n,a,c,i,t)}},Hc=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),s=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),l=Uh(t,a);if(l){var u={},c=[],d=[];for(var p in l.args){var f,v,h=l.args[p],g=Qh(t,h),y=h.defaultValue,m=h.isOptional,b=null!=y&&y.func?"func":"value",E=s?s.get(p):void 0,O=E?E.get("value"):void 0,S=E?E.get("valueSrc"):void 0;"func"!==S&&null!==(f=O)&&void 0!==f&&f.toJS&&(O=O.toJS());var T=E?E.get("asyncListValues"):void 0,_=null===(v=h.spelEscapeForFormat)||void 0===v||v,w=null,R=yv(t,h,w,S),I=Jh(t,h,w,R,S,{forExport:!0}),A=Wc(e,t,O,S,h.type,I,g,null,null,i,T);if(null!=O&&void 0===A)return void("func"!=S&&e.errors.push("Can't format value of arg ".concat(p," for func ").concat(a)));var C=void 0;if(void 0===A&&!m&&null!=y){var N=yv(t,h,w,b),L=Jh(t,h,w,N,b,{forExport:!0});if(void 0===(C=Wc(e,t,y,b,h.type,L,g,null,null,i,T)))return void("func"!=b&&e.errors.push("Can't format default value of arg ".concat(p," for func ").concat(a)))}var P=null!=A?A:C;if(void 0!==P){var x;if(c.length){var j,F=Cc(c);try{for(F.s();!(j=F.n()).done;){var D=j.value;u[D]=void 0}}catch(e){F.e(e)}finally{F.f()}c=[]}u[p]=_?P:null!==(x=O)&&void 0!==x?x:y}else m||d.push(p),c.push(p)}if(!d.length){var k;if("function"==typeof l.spelFormatFunc){var M=l.spelFormatFunc,V=[u];k=M.call.apply(M,[t.ctx].concat(V))}else if(l.spelFunc){k=l.spelFunc.replace(/\${(\w+)}/g,(function(e,t){var r;return null!==(r=u[t])&&void 0!==r?r:e}));var U,B=Object.keys(l.args||{}).reverse().filter((function(e){return!!l.args[e].isOptional})),G=Cc(B);try{for(G.s();!(U=G.n()).done;){var $=U.value;if(null!=u[$])break;k=k.replace(new RegExp("(, )?\\${"+$+"}","g"),"")}}catch(e){G.e(e)}finally{G.f()}k=k.replace(/\${(\w+)}/g,"null")}else e.errors.push("Func ".concat(a," is not supported"));return k}}else e.errors.push("Func ".concat(a," is not defined in config"))};function Yc(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Qc(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Qc(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Qc(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Xc(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Jc(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Xc(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Xc(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Zc={number:"number",string:"text",boolean:"boolean",null:"null"},ed={String:"text"},td=function(e){return"object"==Wn(e)&&null!==e&&!Array.isArray(e)},rd=function(e,t){return nd(e,t,!0)},nd=function(e,t){var r,n,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],i={errors:[]},a=_h(t,void 0,!1),s=ad(a),l=void 0;try{r=mc.SpelExpressionEvaluator.compile(e)._compiledExpression}catch(e){i.errors.push(e)}r&&(n=od(r,i),tu.debug("convertedObj:",n,i),(l=sd(n,s,a,i))&&"group"!=l.type&&"switch_group"!=l.type&&(l=Sd(l,a,n.not)),tu.debug("jsTree:",l));var u=l?Mu(l):void 0;return o?[u,i.errors]:(i.errors.length&&console.warn("Errors while importing from SpEL:",i.errors),u)},od=function e(t,r){var n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,i=t.getType(),a=t.getChildren().map((function(n){return e(n,r,t)}));if("op-or"!=i&&"op-and"!=i||(a=a.reduce((function(e,t){var r=t.type!=i||t.not?[t]:t.children;return[].concat(so(e),so(r))}),[])),"op-not"==i)return 1!=a.length&&r.errors.push("Operator NOT should have 1 child, but got ".concat(a.length,"}")),Jc(Jc({},a[0]),{},{not:!a[0].not});if("compound"==i){var s=(a=a.filter((function(e){return!("selection"==e.type&&1==e.children.length&&"boolean"==e.children[0].type&&1==e.children[0].val)}))).find((function(e){return"selection"==e.type}));s&&1!=s.children.length&&r.errors.push("Selection should have 1 child, but got ".concat(s.children.length));var l=s?s.children[0]:null,u=a[a.length-1],c="method"==u.type&&"size"==u.val.methodName||"!func"==u.type&&"size"==u.methodName,d="property"==u.type&&"length"==u.val,p=a.filter((function(e){return e!==s&&e!==u})),f={type:"compound",children:p};if((c||d)&&null!=ud(p))return{type:"!aggr",filter:l,source:f};if(a=(a=a.filter((function(e){var t="variable"==e.type&&"this"==e.val,r="variable"==e.type&&"root"==e.val;return!(t||r)}))).map((function(e){return"indexer"==e.type&&1==e.children.length?{type:"indexer",val:e.children[0].val,itype:e.children[0].type}:e})),"!func"==u.type){var v={},h=v;do{var g,y;Object.assign(h,u),a=a.filter((function(e){return e!==u})),"!func"==(null===(y=u=a[a.length-1])||void 0===y?void 0:y.type)?(h.obj={},h=h.obj):a.length>1?h.obj={type:"compound",children:a}:h.obj=u}while("!func"==(null===(g=u)||void 0===g?void 0:g.type));return v}}try{t.getRaw?n=t.getRaw():0==t.getValue.length&&(n=t.getValue())}catch(e){tu.error("[spel2js] Error in getValue()",e)}if("ternary"==i&&(n=id(a)),"object"===Wn(n)&&null!==n&&(n.methodName||n.functionName)&&(n.args=n.args.map((function(n){return e(n,r,t)}))),"list"==i&&(n=n.map((function(n){return e(n,r,t)})),!o&&1==n.length))return n[0];if("constructorref"==i){var m=a.find((function(e){return"qualifiedidentifier"==e.type})),b=null==m?void 0:m.val;return b?{type:"!new",cls:b,args:a.filter((function(e){return"qualifiedidentifier"!=e.type}))}:void r.errors.push("Can't find qualifiedidentifier in constructorref children: ".concat(JSON.stringify(a)))}if("typeref"==i){var E=a.find((function(e){return"qualifiedidentifier"==e.type})),O=null==E?void 0:E.val;return O?(a.filter((function(e){return"qualifiedidentifier"!=e.type})),{type:"!type",cls:O}):void r.errors.push("Can't find qualifiedidentifier in typeref children: ".concat(JSON.stringify(a)))}if("function"==i||"method"==i){var S=n,T=S.functionName,_=S.methodName,w=S.args;return{type:"!func",methodName:T||_,isVar:"function"==i,args:w}}return{type:i,children:a,val:n}},id=function(e){var t=[];return function e(r){var n=io(r,3),o=n[0],i=n[1],a=n[2];t.push([o,i]),"ternary"==(null==a?void 0:a.type)?e(a.children):t.push([void 0,a])}(e),t},ad=function(e){var t={},r=function(r){var n=e.operators[r];if(n.spelOps)n.spelOps.forEach((function(e){var n=e;t[n]||(t[n]=[]),t[n].push(r)}));else if(n.spelOp){var o=n.spelOp;t[o]||(t[o]=[]),t[o].push(r)}else tu.log("[spel] No spelOp for operator ".concat(r))};for(var n in e.operators)r(n);var o={};for(var i in e.conjunctions)o[e.conjunctions[i].spelConj||i.toLowerCase()]=i;var a,s={},l=Yc(jh(e));try{var u=function(){var e=io(a.value,2),t=e[0],r=e[1],n=[],o=r.spelFunc;if("string"==typeof o){var i=Object.keys(r.args||{}).reverse().filter((function(e){return!!r.args[e].isOptional||null!=r.args[e].defaultValue})),l=o.replace(/\${(\w+)}/g,(function(e,t){return"?"})),u=i.reduce((function(e,t){return[].concat(so(e),[[t].concat(so(e[e.length-1]||[]))])}),[]).map((function(e){return o.replace(/(?:, )?\${(\w+)}/g,(function(t,r){return e.includes(r)?"":t})).replace(/\${(\w+)}/g,(function(e,t){return"?"}))}));n=[l].concat(so(u))}var c,d=Yc(n);try{for(d.s();!(c=d.n()).done;){var p=c.value;s[p]||(s[p]=[]),s[p].push(t)}}catch(e){d.e(e)}finally{d.f()}};for(l.s();!(a=l.n()).done;)u()}catch(e){l.e(e)}finally{l.f()}var c={};for(var d in e.widgets){var p=e.widgets[d],f=p.spelImportFuncs;if(p.type,f){var v,h=Yc(f);try{for(h.s();!(v=h.n()).done;){var g=v.value;if("string"==typeof g){var y=g.replace(/\${(\w+)}/g,(function(e,t){return"?"})),m=so(g.matchAll(/\${(\w+)}/g)).map((function(e){var t=io(e,2);return t[0],t[1]}));c[y]||(c[y]=[]),c[y].push({w:d,argsOrder:m})}}}catch(e){h.e(e)}finally{h.f()}}}var b={};for(var E in e.operators){var O=e.operators[E].spelOp;if(null!=O&&O.includes("${0}")){var S=O.replace(/\${(\w+)}/g,(function(e,t){return"?"})),T=so(O.matchAll(/\${(\w+)}/g)).map((function(e){var t=io(e,2);return t[0],t[1]}));b[S]||(b[S]=[]),b[S].push({op:E,argsOrder:T})}}return b[xc.replace(/\${(\w+)}/g,(function(e,t){return"?"}))]=[{op:"!compare",argsOrder:["0","1"]}],{operators:t,conjunctions:o,funcs:s,valueFuncs:c,opFuncs:b}},sd=function e(t,r,n,o){var i,a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(t){t._groupField=null!==(i=t._groupField)&&void 0!==i?i:null==a?void 0:a._groupField;var s,l=!0;if(0===t.type.indexOf("op-")||"matches"===t.type)s=ld(t,r,n,o,a);else if("!aggr"==t.type){var u,c=e(t.source,r,n,o,t);t._groupField=null==c?void 0:c.value;var d=e(t.filter,r,n,o,t);"rule"==(null===(u=d)||void 0===u?void 0:u.type)&&(d=Sd(d,n,t.filter.not)),s={groupFilter:d,groupFieldValue:c},a||(s=void 0,o.errors.push("Unexpected !aggr in root"),l=!1)}else if("ternary"==t.type){var p={};t.val.forEach((function(e){var i=io(e,2),a=i[0],s=i[1],l=bd(a,s,r,n,o,t);l&&(p[l.id]=l)})),s={type:"switch_group",id:Cl(),children1:p,properties:{}}}if(!s&&l&&(s=cd(t,r,n,o,a)),s&&!s.type&&!a){var f=md(t,r,n,o);f?s=f:(s=void 0,o.errors.push("Can't convert rule of type ".concat(t.type,", it looks like var/literal")))}return s}},ld=function e(t,r,n,o){var i,a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,s=t.type.startsWith("op-")?t.type.slice(3):t.type;if(("minus"==s||"plus"==s)&&1==t.children.length){var l=t.negative;return"minus"==s&&(l=!l),t.children[0].negative=l,sd(t.children[0],r,n,o,a)}var u="and"==s&&2==t.children.length&&"op-ge"==t.children[0].type&&"op-le"==t.children[1].type,c="or"==s&&2==t.children.length&&"op-lt"==t.children[0].type&&"op-gt"==t.children[1].type;if(u||c){var d=io(t.children[0].children,2),p=d[0],f=d[1],v=io(t.children[1].children,2),h=v[0],g=v[1];if(yd(p,h,t,r,n,o,a)){f.val,g.val;var y={type:"op-between",children:[p,f,g],not:c};return y._groupField=null==a?void 0:a._groupField,e(y,r,n,o,a)}}var m=r.operators[s];"eq"==s&&"null"==t.children[1].type?m=["is_null"]:"ne"==s&&"null"==t.children[1].type?m=["is_not_null"]:"le"==s&&"string"==t.children[1].type&&""==t.children[1].val?m=["is_empty"]:"gt"==s&&"string"==t.children[1].type&&""==t.children[1].val?m=["is_not_empty"]:"between"==s&&(m=["between"]);var b=function(){var e,i=t.children.map((function(e){return sd(e,r,n,o,t)}));return i.length>=2&&"!compare"==(null===(e=i)||void 0===e||null===(e=e[0])||void 0===e?void 0:e.type)&&(i=i[0].children),i};if("and"==s||"or"==s){var E={};b().forEach((function(e){if(e){var t=Cl();e.id=t,null!=e.type?E[t]=e:o.errors.push("Bad item in AND/OR: ".concat(JSON.stringify(e)))}})),i={type:"group",id:Cl(),children1:E,properties:{conjunction:r.conjunctions[s],not:t.not}}}else if(m){var O,S,T,_=b(),w=_[0],R=_.slice(1),I=null==w||null===(O=w.groupFieldValue)||void 0===O?void 0:O.value,A=null===(S=R)||void 0===S?void 0:S[0],C=m[0];if(m.length>1){var N,L,P=(null===(N=_[0])||void 0===N?void 0:N.valueType)||(null===(L=_[1])||void 0===L?void 0:L.valueType),x=null==w?void 0:w.value,j=m.map((function(e){return{op:e,widget:yv(n,x,e)}}));if(tu.warn("[spel] Spel operator ".concat(s," can be mapped to ").concat(m,"."),"widgets:",j,"vals:",_,"valueType=",P),"eq"==s||"ne"==s){var F=j.find((function(e){e.op;var t=e.widget;return t&&"field"!=t}));F&&(C=F.op)}}null!=w&&w.groupFieldValue&&(A&&A.groupFieldValue&&"field"==A.groupFieldValue.valueSrc&&A.groupFieldValue.value==I?(C="all",R=[]):"equal"==C&&"value"==A.valueSrc&&"number"==A.valueType&&0==A.value?(C="none",R=[]):"greater"==C&&"value"==A.valueSrc&&"number"==A.valueType&&0==A.value&&(C="some",R=[]));var D=n.operators[C],k=n.operators[null===(T=D)||void 0===T?void 0:T.reversedOp],M=t.not&&["between"].includes(C),V=!!k&&(!!n.settings.reverseOperatorsForNot||M);(t.not&&V||M)&&(C=D.reversedOp,D=n.operators[C],t.not=!t.not);var U=!!t.not;if(t.not=!1,w)if(w.groupFieldValue)"field"!=w.groupFieldValue.valueSrc&&o.errors.push("Expected group field ".concat(JSON.stringify(w))),i=gd(w,C,R,n,o);else{"field"!=w.valueSrc&&"func"!=w.valueSrc&&o.errors.push("Expected field/func at LHS, but got ".concat(JSON.stringify(w)));var B=w.value;i=hd(n,o,B,C,R,t)}U&&("group"!==i.type?i=Sd(i,n,!0):i.properties.not=!i.properties.not)}else a||(i=md(t,r,n,o));return i},ud=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,o=e.map((function(e){if("variable"==e.type||"property"==e.type||"indexer"==e.type&&"string"==e.itype)return e.val;var o,i;n=!0,r&&(null==t||null===(o=t.errors)||void 0===o||null===(i=o.push)||void 0===i||i.call(o,"Unexpected item in field path compound: ".concat(JSON.stringify(e))))}));return n?void 0:o},cd=function e(t,r,n,o){var i,a,s=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(null!=t){var l=n.settings.fieldSeparator;if(t._groupField=null!==(i=t._groupField)&&void 0!==i?i:null==s?void 0:s._groupField,"variable"==t.type||"property"==t.type){var u=Mh(n,t.val,t._groupField),c=Qh(n,u),d="variable"==t.type;return{valueSrc:"field",valueType:null==c?void 0:c.type,isVariable:d,value:u}}if("compound"==t.type){var p=ud(t.children,o);if(p){var f,v=Mh(n,p.join(l),t._groupField),h=Qh(n,v),g="variable"==(null===(f=t.children)||void 0===f||null===(f=f[0])||void 0===f?void 0:f.type);return{valueSrc:"field",valueType:null==h?void 0:h.type,isVariable:g,value:v}}}else{if(Zc[t.type]){var y=t.val,m=Zc[t.type];return t.negative&&(y=-y),{valueSrc:"value",valueType:m,value:y}}if("!new"==t.type&&ed[t.cls.at(-1)]){var b=t.args.map((function(i){return e(i,r,n,o,t)})),E=null==b?void 0:b[0],O=ed[t.cls.at(-1)];return Jc(Jc({},E),{},{valueType:O})}if("list"==t.type){var S,T=t.val.map((function(i){return e(i,r,n,o,t)}));return T.length&&(null===(S=T[0])||void 0===S||S.valueType),{valueSrc:"value",valueType:"multiselect",value:T.map((function(e){return null==e?void 0:e.value}))}}if("op-plus"===t.type&&"ternary"===(null==s?void 0:s.type)&&"case_value"===(null===(a=n.settings.caseValueField)||void 0===a?void 0:a.type))return Ed(t,r,n,o)}var _=pd(t,r,n,o,s);if(void 0!==_)return _;o.errors.push("Can't convert arg of type ".concat(t.type))}},dd=function e(t,r){var n,o=[],i="",a=t.type,s=t.methodName,l=(t.val,t.obj),u=t.args,c=t.isVar,d=t.cls,p=t.children,f=null==p?void 0:p[p.length-1],v=r[r.length-1];if("!func"===a){for(var h=l;h;){var g,y=io(e(Jc(Jc({},h),{},{obj:null}),[{}]),2),m=y[0],b=y[1];if("?"!==m){var E={s:v.s,params:so(v.params),objs:so(v.objs)};v.objs.unshift("?"),v.params.unshift(h),r.push(E),v=r[r.length-1]}v.objs.unshift(m),(g=v.params).unshift.apply(g,so(b)),h="!func"===h.type?h.obj:null}var O,S=Yc(r);try{for(S.s();!(O=S.n()).done;){var T,_=O.value;o=[].concat(so((null==_?void 0:_.params)||[]),so(u||[])),i="",null!=_&&null!==(T=_.objs)&&void 0!==T&&T.length&&(i+=_.objs.join(".")+"."),i+=(c?"#":"")+s,i+="("+(u||[]).map((function(e){return"?"})).join(", ")+")",_.s=i,_.params=o}}catch(e){S.e(e)}finally{S.f()}}else"!new"===a?(o=u||[],i="new ".concat(d.join("."),"(").concat(o.map((function(e){return"?"})).join(", "),")")):"!type"===a?i="T(".concat(d.join("."),")"):"compound"===a&&"property"===f.type&&(n=f.val,["length"].includes(n))?i=p.map((function(t){var r;if(t===f)return t.val;var n=io(e(Jc(Jc({},t),{},{obj:null}),[{}]),2),i=n[0],a=n[1];return(r=o).push.apply(r,so(a)),i})).join("."):(o=[t],i="?");return v&&(v.s=i,v.params=o),[i,o]},pd=function(e,t,r,n){var o,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=function(o){return sd(o,t,r,n,e)},s=function(e){var t=[{s:"",params:[],objs:[]}];return dd(e,t),t.map((function(e){return{s:e.s,params:e.params}})).reverse().filter((function(e){var t=e.s;return""!==t&&"?"!==t}))}(e),l=null==s||null===(o=s[0])||void 0===o?void 0:o.s;s.length&&tu.debug("Signatures for ",e,":",l,s);var u=fd(e,t,r,n,i,s,a);if(void 0!==u)return u;var c,d,p,f=vd(e,t,r,n,i,s,a);if(void 0!==f)return f;var v,h=Yc(s);try{var g=function(){var e=v.value,n=e.s,o=e.params,i=t.funcs[n];if(i){c=i[0];var s=(d=Uh(r,c)).spelFunc,l=o.map(a),u=so(s.matchAll(/\${(\w+)}/g)).map((function(e){var t=io(e,2);return t[0],t[1]}));return p=Object.fromEntries(u.map((function(e,t){return[e,l[t]]}))),1}};for(h.s();!(v=h.n()).done&&!g(););}catch(e){h.e(e)}finally{h.f()}if(!c){var y,m=Yc(jh(r));try{for(m.s();!(y=m.n()).done;){var b=io(y.value,2),E=b[0],O=b[1];if(O.spelImport){var S=void 0;try{S=O.spelImport(e)}catch(e){}if(S)for(var T in d=Uh(r,c=E),p={},S)p[T]=a(S[T])}}}catch(e){m.e(e)}finally{m.f()}}if(c){var _={};for(var w in d.args){var R,I=d.args[w],A=p[w];if(void 0===A)if(void 0===(A=null==I?void 0:I.defaultValue)){if(null==I||!I.isOptional)return void n.errors.push("No value for arg ".concat(w," of func ").concat(c))}else A={value:A,valueSrc:null!==(R=A)&&void 0!==R&&R.func?"func":"value",valueType:I.type};A&&(_[w]=A)}return{valueSrc:"func",value:{func:c,args:_},valueType:d.returnType}}e.methodName&&n.errors.push("Signature ".concat(l," - failed to convert"))},fd=function(e,t,r,n,o,i,a){var s,l,u,c=[];for(var d in r.widgets){var p=r.widgets[d].spelImportFuncs;if(p)for(var f=0;f<p.length;f++){var v=p[f];if(td(v)){var h={};if(Jl(v,e,h)){for(var g in h)h[g]=a(h[g]);c.push({s:"widgets.".concat(d,".spelImportFuncs[").concat(f,"]"),w:d,argsObj:h})}}}}var y,m=Yc(i);try{for(m.s();!(y=m.n()).done;){var b,E=y.value,O=E.s,S=E.params,T=Yc(t.valueFuncs[O]||[]);try{var _=function(){var e=b.value,t=e.w,r=e.argsOrder,n=S.map(a),o=Object.fromEntries(r.map((function(e,t){return[e,n[t]]})));c.push({s:O,w:t,argsObj:o})};for(T.s();!(b=T.n()).done;)_()}catch(e){T.e(e)}finally{T.f()}}}catch(e){m.e(e)}finally{m.f()}for(var w=0,R=c;w<R.length;w++){var I=R[w],A=I.s,C=I.w,N=I.argsObj,L=r.widgets[C],P=L.spelImportValue,x=L.type;for(var j in u=C,l=A,s=[],N)["value"].includes(N[j].valueSrc)||s.push("".concat(j," has unsupported value src ").concat(N[j].valueSrc));var F=N.v.value;if(P&&!s.length){var D=io(P.call(r.ctx,N.v,L,N),2);F=D[0],(s=D[1])&&!Array.isArray(s)&&(s=[s])}if(!s.length)return{valueSrc:"value",valueType:x,value:F}}u&&s.length&&n.errors.push("Signature ".concat(l," - looks like convertable to ").concat(u,", but: ").concat(s.join("; ")))},vd=function(e,t,r,n,o,i,a){var s,l,u,c,d=Yc(i);try{for(d.s();!(c=d.n()).done;){var p,f=c.value,v=f.s,h=f.params,g=Yc(t.opFuncs[v]||[]);try{var y,m=function(){var t,i=p.value,c=i.op,d=i.argsOrder,f=h.map(a);if(l=c,"!compare"===c){if(o.type.startsWith("op-")&&2==o.children.length&&"number"==o.children[1].type&&0===o.children[1].val)return{v:{type:"!compare",children:f}};s.push("Result of compareTo() should be compared to 0")}u=v,s=[];var g=r.operators[l],y=(g.spelOp,g.valueTypes),m=Object.fromEntries(d.map((function(e,t){return[e,f[t]]}))),b=m[0],E=Object.keys(m).filter((function(e){return parseInt(e)>0})).map((function(e){return m[e]})),O=null===(t=f.filter((function(e){return!!e})).find((function(e){return"value"===e.valueSrc})))||void 0===t?void 0:t.valueType;if(y&&O&&!y.includes(O)&&s.push("Op supports types ".concat(y,", but got ").concat(O)),!s.length)return{v:hd(r,n,b,l,E,e)}};for(g.s();!(p=g.n()).done;)if(y=m())return y.v}catch(e){g.e(e)}finally{g.f()}}}catch(e){d.e(e)}finally{d.f()}l&&s.length&&n.errors.push("Signature ".concat(u," - looks like convertable to ").concat(l,", but: ").concat(s.join("; ")))},hd=function(e,t,r,n,o,i){var a,s;if(!o.filter((function(e){return void 0===e})).length){var l=null!==(a=r)&&void 0!==a&&a.func?"func":"field";td(r)&&r.valueSrc&&(l=r.valueSrc,r=r.value);var u=Qh(e,r);if(u){var c=Qh(e,null==i?void 0:i._groupField),d="!group"==u.type,p=(d&&u.mode,"!group"==(null==c?void 0:c.type)),f=e.operators[n],v=e.operators[null===(s=f)||void 0===s?void 0:s.reversedOp],h=(null==i?void 0:i.not)&&["between"].includes(n),g=!!v&&(!!e.settings.reverseOperatorsForNot||h||!d&&p);((null==i?void 0:i.not)&&g||h)&&(n=f.reversedOp,f=e.operators[n],i.not=!i.not);var y=!(null==i||!i.not),m=yv(e,r,n),b=e.widgets[m||u.mainWidget],E=o.map((function(e){return e.asyncListValues})).filter((function(e){return null!=e})),O=E.length?E[0]:void 0,S={type:"rule",id:Cl(),properties:Jc({field:r,fieldSrc:l,operator:n,value:o.map((function(e){return e.value})),valueSrc:o.map((function(e){return e.valueSrc})),valueType:o.map((function(e){return"value"==e.valueSrc&&((null==b?void 0:b.type)||(null==u?void 0:u.type))||e.valueType}))},O?{asyncListValues:O}:{})};return y&&(S=Sd(S,e,i.not)),S}t.errors.push("No config for field ".concat(r))}},gd=function(e,t,r,n,o){var i=e.groupFilter,a=e.groupFieldValue;if("field"!=a.valueSrc)throw"Bad groupFieldValue: ".concat(JSON.stringify(a));var s=a.value,l=hd(n,o,s,t,r);if(l){var u,c=Qh(n,s),d=null==c?void 0:c.mode;return(u="group"===(null==i?void 0:i.type)?Jc(Jc({},i||{}),{},{type:"rule_group",properties:Jc(Jc(Jc({},l.properties),(null==i?void 0:i.properties)||{}),{},{mode:d})}):Jc(Jc({},l||{}),{},i?{type:"rule_group",children1:[i],properties:Jc(Jc({},l.properties),{},{mode:d})}:{type:"rule_group",properties:Jc(Jc({},l.properties),{},{mode:d})})).id||(u.id=Cl()),u}},yd=function(e,t,r,n,o,i){if(e.type==t.type){if("!aggr"==e.type){var a=io([e.source,t.source].map((function(e){return cd(e,n,o,i,r)})),2),s=a[0],l=a[1];return s.value==l.value}var u=io([e,t].map((function(e){return cd(e,n,o,i,r)})),2),c=u[0],d=u[1];return c.value==d.value}return!1},md=function(e,t,r,n){var o={},i=bd(null,e,t,r,n);return i&&(o[i.id]=i),{type:"switch_group",id:Cl(),children1:o,properties:{}}},bd=function(e,t,r,n,o){var i,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,s=Od(n,o,r,t,a);return e?(i=sd(e,r,n,o,a))&&i.type?("group"!=i.type&&(i=Sd(i,n)),i.type="case_group"):(o.errors.push("Unexpected case: ".concat(JSON.stringify(i))),i=void 0):i={id:Cl(),type:"case_group",properties:{}},i&&(i.properties=Jc(Jc({},i.properties),s)),i},Ed=function(e,t,r,n){var o=[];return function i(a){a.map((function(a){if("op-plus"===a.type)i(a.children);else{var s=cd(a,t,r,n,e);s?o.push(s):n.errors.push("Can't convert ".concat(a.type," in concatenation"))}}))}(e.children),{valueSrc:"value",valueType:"case_value",value:o}},Od=function(e,t,r,n){var o,i,a,s,l,u,c=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,d={},p=Qh(e,"!case_value");"op-plus"===(null==n?void 0:n.type)&&"case_value"===(null===(o=e.settings.caseValueField)||void 0===o?void 0:o.type)?(s="case_value",a=Ed(n,r,e,t)):(s=null==p?void 0:p.mainWidget,l=e.widgets[s],(a=cd(n,r,e,t,c))&&"value"===a.valueSrc&&(a.valueType=(null===(u=l)||void 0===u?void 0:u.type)||(null==p?void 0:p.type)||a.valueType));var f=e.widgets[s];if("case_value"===s){var v=null==f?void 0:f.spelImportValue;if(v){var h,g=io(v.call(e.ctx,a),2),y=g[0];g[1].map((function(e){return t.errors.push(e)})),null!=y&&(d={value:[y],valueSrc:["value"],valueType:[null!==(h=null==f?void 0:f.type)&&void 0!==h?h:"case_value"],field:"!case_value"})}}else null!=a&&null!=(null===(i=a)||void 0===i?void 0:i.value)&&(d={value:[a.value],valueSrc:[a.valueSrc],valueType:[a.valueType],field:"!case_value"});return d},Sd=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return{type:"group",id:Cl(),children1:eo({},e.id,e),properties:{conjunction:Pd(t),not:r||!1}}};function Td(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function _d(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Td(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Td(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var wd=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=e.settings.defaultField,o=(r?Rd(e,r):n)||t&&Zh(e,r)||null;return null==o||"string"==typeof o||Vl(o)||(o=Bu(o)),o},Rd=function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if(!r)return null;var n=(null==e||null===(t=e.settings)||void 0===t?void 0:t.fieldSeparator)||".",o=Qh(e,r),i=null==o?void 0:o.defaultField;return i&&(i=[].concat(so(qh(r)),[i]).join(n)),i},Id=function(e){var t;return(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(null===(t=e.settings.fieldSources)||void 0===t?void 0:t[0])||"field"},Ad=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=Qh(e,t),o=(null==n?void 0:n.operators)||[],i=e.settings.defaultOperator;i&&!o.includes(i)&&(i=null);var a=null==n?void 0:n.defaultOperator,s=null==n?void 0:n.ownDefaultOperator,l=r?sv(e,t):null;return s||i||a||l},Cd=function(e,t,r){var n=t?Xh(e,t,r):null;return n&&n.options?new Il.Map(n.options&&n.options.defaults||{}):null},Nd=function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,a=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],s=arguments.length>4&&void 0!==arguments[4]&&arguments[4],l=null,u=null,c=null,d=e.settings.showErrorMessage;i?(c=null==i||null===(t=i.properties)||void 0===t?void 0:t.fieldSrc,l=null==i||null===(r=i.properties)||void 0===r?void 0:r.field,u=null==i||null===(n=i.properties)||void 0===n?void 0:n.operator):a?(c=(l=wd(e,s,o))?Vl(l)?"func":"field":Id(e),u=Ad(e,l,!0)):c=Id(e);var p=new Il.Map({fieldSrc:c,field:l,operator:u,value:new Il.List,valueSrc:new Il.List,operatorOptions:Cd(e,u,l)});if(d&&(p=p.set("valueError",new Il.List)),l&&u){var f=Hf(e,e,p,l,u,"operator",!1),v=f.newValue,h=f.newValueSrc,g=f.newValueType,y=f.newValueError,m=f.newFieldError;p=p.set("value",v).set("valueSrc",h).set("valueType",g),d&&(p=p.set("valueError",y).set("fieldError",m))}return p},Ld=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=(t=Qh(e,t))&&t.conjunctions||Object.keys(e.conjunctions);return 1==r.length?r[0]:e.settings.defaultGroupConjunction||e.settings.defaultConjunction||r[0]},Pd=function(e){return e.settings.defaultConjunction||Object.keys(e.conjunctions)[0]},xd=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;return new Il.Map({conjunction:Ld(e,t),not:!1})},jd=function(e,t){var r;return t&&"group"==t.type?xd(e,null==t||null===(r=t.properties)||void 0===r?void 0:r.field):Nd(e,null,t)},Fd=function(e,t){return eo({},e,new Il.Map({type:"rule",id:e,properties:Nd(t)}))},Dd=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];return new Il.Map({type:"group",id:Cl(),children1:new Il.OrderedMap(t?_d({},Fd(Cl(),e)):{}),properties:xd(e)})},kd=function(e){return Ul(e)?e:Md([e])},Md=function(e){return Ul(e)?e:new Il.List(e)},Vd=function(){return new Il.Map};function Ud(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Bd(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Bd(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Bd(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Gd(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function $d(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Gd(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Gd(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var qd=function(e,t){var r={errors:[],settings:{isForDisplay:arguments.length>2&&void 0!==arguments[2]&&arguments[2],isDebugMode:arguments.length>3&&void 0!==arguments[3]&&arguments[3]}},n=_h(t,void 0,!1),o=Kd(e,n,r,null);return r.errors.length&&console.warn("Errors while exporting to string:",r.errors),o},Kd=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(e){var o=e.get("type");return e.get("children1"),"group"===o||"rule_group"===o?Wd(e,t,r,n):"rule"===o?zd(e,t,r,n):void 0}},Wd=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=r.settings,s=a.isForDisplay,l=a.isDebugMode,u=e.get("type"),c=e.get("properties")||new Ua,d=c.get("mode"),p=e.get("children1")||new cs,f="rule_group"===u,v=f&&"array"==d?c.get("field"):null,h="rule_group"===u?c.get("operator"):null,g=h?null!==(n=null===(o=t.operators[h])||void 0===o?void 0:o.cardinality)&&void 0!==n?n:1:void 0,y=f&&"array"===d&&g>=1,m=c.get("not"),b=p.map((function(e){return Kd(e,t,r,v)})).filter((function(e){return void 0!==e}));if(y||b.size||l){var E=c.get("conjunction");E||(E=Pd(t));var O,S=t.conjunctions[E],T=b.size?S.formatConj.call(t.ctx,b,E,m,s):null;if(v){var _=zd(e,t,r,i,!0);if(_){var w,R=_.pop(),I=[T].concat(so(_));O=(w=t.settings.formatAggr).call.apply(w,[t.ctx].concat(so(I))),R&&(O=t.settings.formatReverse.call(t.ctx,O,null,null,null,null,s))}}else O=T;return l&&null==O&&(O="?"),O}},zd=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=r.settings,a=i.isForDisplay,s=i.isDebugMode,l=e.get("properties")||new Ua,u=l.get("field"),c=l.get("fieldSrc"),d=l.get("operator"),p=l.get("operatorOptions");if(null!=u&&null!=d||s){var f=Qh(t,u)||{},v=Xh(t,d,u)||{},h=v.reversedOp,g=Xh(t,h,u)||{},y=!1,m=v.formatOp;if(!m&&h&&(m=g.formatOp)){y=!0;var b=[h,d];d=b[0],h=b[1];var E=[g,v];v=E[0],g=E[1]}if(s&&!d&&(d="?"),m||(m=function(e,t,r){var n,o=r.settings.isDebugMode,i=(null==t?void 0:t.labelForFormat)||e,a=Dl(t);return 0==a?n=function(e,t,r,n,o,a,s,l){return"".concat(e," ").concat(i)}:1==a?n=function(e,t,r,n,a,s,l,u){return o&&"?"===t&&"?"===r?e&&"?"!==e?"".concat(e," ?"):"?":"".concat(e," ").concat(i," ").concat(r)}:2==a&&(n=function(e,t,r,n,o,a,s,l){var u,c,d=null==r||null===(u=r.first)||void 0===u?void 0:u.call(r),p=null==r||null===(c=r.get)||void 0===c?void 0:c.call(r,1);return"".concat(e," ").concat(i," ").concat(d," AND ").concat(p)}),n}(d,v,r)),m){var O="func"===c?Qd(t,r,u,n):Yd(t,r,u,n);if(null!=O){var S=function(e,t,r,n,o){var i,a,s=r.settings,l=(s.isForDisplay,s.isDebugMode),u=t.get("field"),c=t.get("valueSrc"),d=t.get("valueType"),p=Qh(e,u)||{},f=n||t.get("operator"),v=Xh(e,f,u)||{},h=Dl(v),g=t.get("value"),y=t.get("asyncListValues"),m=[],b=[];return null!=g&&!((a=g.map((function(t,n){var i=c?c.get(n):null,a=d?d.get(n):null,s=l?t:Av(t,i,e),h=yv(e,u,f,i),g=Jh(e,u,f,h,i,{forExport:!0}),E=Hd(e,r,s,i,a,g,p,f,v,o,y);return void 0!==E&&(m.push(i),b.push(a)),E}))).filter((function(e){return void 0===e})).size>0)&&a.size===h&&(i=1==h?a.first():a),l&&!i&&(i=h>1?new cs(Array.from({length:h}).map((function(e,t){var r,n;return null!==(r=null===(n=a)||void 0===n?void 0:n.get(t))&&void 0!==r?r:"?"}))):"?"),[i,m.length>1?m:m[0],b.length>1?b:b[0]]}(t,l,r,d,n),T=io(S,3),_=T[0],w=T[1],R=T[2];if(void 0!==_){var I=[O,d,_,w,R,Fl(v,Pl),p,a,f,y];if(o)return I;var A,C=(A=m).call.apply(A,[t.ctx].concat(I));return y&&(C=t.settings.formatReverse.call(t.ctx,C,d,h,v,g,a)),C}}}}},Hd=function(e,t,r,n,o,i,a,s,l){var u,c=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,d=arguments.length>10?arguments[10]:void 0,p=t.settings,f=p.isForDisplay,v=p.isDebugMode;if(void 0===r)return v?"array"===(null==i?void 0:i.jsType)?[]:"?":void 0;if("field"==n)u=Yd(e,t,r,c);else if("func"==n)u=Qd(e,t,r,c);else if("function"==typeof(null==i?void 0:i.formatValue)){var h=i.formatValue,g=[r,$d($d({},iu()(a,["fieldSettings","listValues"])),{},{asyncListValues:d}),Fl(i,Ll),f];if(s&&(g.push(s),g.push(l)),"field"==n){var y=Qh(e,r)||{};g.push(y)}u=h.call.apply(h,[e.ctx].concat(g))}else u=r;return u},Yd=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],i=t.settings,a=i.isForDisplay,s=i.isDebugMode,l=e.settings,u=(l.fieldSeparator,l.fieldSeparatorDisplay),c=null;if(r){var d=Qh(e,r)||{},p=qh(r,e),f=cv(r,e,o?n:null),v=f?f.join(u):null,h=d.label2||v;c=(0,e.settings.formatField)(mv(r,e,t,o?n:null,{useTableName:!0}),p,h,d,e,a)}else s&&(c="?");return c},Qd=function(e,t,r){var n,o,i,a=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,s=t.settings,l=s.isForDisplay,u=s.isDebugMode,c=null==r||null===(n=r.get)||void 0===n?void 0:n.call(r,"func");if(!c)return u?"?()":void 0;var d=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),p=Uh(e,c);if(p||u){var f,v=qh(c,e),h=v[v.length-1],g=l&&(null==p?void 0:p.label)||h,y={},m=[],b=[],E={},O=Ud(p?Object.keys(p.args||{}):(null==d||null===(i=d.keySeq)||void 0===i?void 0:i.call(d).toArray())||[]);try{for(O.s();!(f=O.n()).done;){var S,T=f.value,_=null==p?void 0:p.args[T],w=Qh(e,_),R=_||{},I=R.defaultValue,A=R.isOptional,C=null!=I&&I.func?"func":"value",N=l&&(null==_?void 0:_.label)||T,L=d?d.get(T):void 0,P=L?L.get("value"):void 0,x=L?L.get("valueSrc"):void 0;"func"!==x&&null!==(S=P)&&void 0!==S&&S.toJS&&(P=P.toJS());var j=L?L.get("asyncListValues"):void 0,F=Hd(e,t,P,x,null==_?void 0:_.type,w,_,null,null,a,j);null!=P&&void 0===F&&"func"!=x&&t.errors.push("Can't format value of arg ".concat(T," for func ").concat(c));var D=void 0;if(void 0===F&&!A&&null!=I&&void 0===(D=Hd(e,t,I,C,null==_?void 0:_.type,w,_,null,null,a,j)))return void("func"!=C&&t.errors.push("Can't format default value of arg ".concat(T," for func ").concat(c)));var k=null!=F?F:D;if(void 0!==k){if(m.length){var M,V=Ud(T);try{for(V.s();!(M=V.n()).done;){var U=io(M.value,2),B=U[0];U[1],y[B]=void 0}}catch(e){V.e(e)}finally{V.f()}m=[]}y[T]=k,E[N]=k}else A||b.push(T),m.push([T,N])}}catch(e){O.e(e)}finally{O.f()}if(!b.length||u){var G=null;if("function"==typeof(null==p?void 0:p.formatFunc)){var $=p.formatFunc,q=[y,l];G=$.call.apply($,[e.ctx].concat(q))}else{var K=Object.entries(l?E:y).map((function(e){var t=io(e,2),r=t[0],n=t[1];return l?"".concat(r,": ").concat(n):"".concat(n)})).join(", ");G="".concat(g,"(").concat(K,")")}return G}}else t.errors.push("Func ".concat(c," is not defined in config"))},Xd="EMPTY_GROUP",Jd="EMPTY_RULE_GROUP",Zd="EMPTY_QUERY",ep="EMPTY_CASE",tp="NO_CONFIG_FOR_FIELD",rp="NO_CONFIG_FOR_OPERATOR",np="NO_CONFIG_FOR_FUNCTION",op="INVALID_VALUE",ip="INVALID_FUNC_ARG_VALUE",ap="UNSUPPORTED_FIELD_TYPE",sp="UNSUPPORTED_OPERATOR_FOR_FIELD",lp="INVALID_VALUE_SRC",up="INCOMPLETE_RULE",cp="INCOMPLETE_LHS",dp="INCOMPLETE_RHS",pp="BAD_MULTISELECT_VALUES",fp="BAD_SELECT_VALUE",vp="INCORRECT_VALUE_TYPE",hp="INCORRECT_VALUE_JS_TYPE",gp="VALUE_LENGTH_CONSTRAINT_FAIL",yp="VALUE_MIN_CONSTRAINT_FAIL",mp="VALUE_MAX_CONSTRAINT_FAIL",bp="NO_CONFIG_FOR_FIELD_VALUE",Ep="CANT_COMPARE_FIELD_WITH_ITSELF",Op="CANT_COMPARE_FIELD_WITH_FIELD",Sp="INCORRECT_FIELD_TYPE",Tp="UNSUPPORTED_FUNCTION_FOR_FIELD",_p="REQUIRED_FUNCTION_ARG",wp="INCORRECT_FUNCTION_RETURN_TYPE",Rp="INVALID_RANGE",Ip="ITEM_POSITION",Ap="ITEM_POSITION_ROOT",Cp="ITEM_POSITION_WITH_INDEX_PATH",Np="ITEM_POSITION_IN_CASE",Lp="range";const Pp={type:"logger",log(e){this.output("log",e)},warn(e){this.output("warn",e)},error(e){this.output("error",e)},output(e,t){console&&console[e]&&console[e].apply(console,t)}};class xp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.init(e,t)}init(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.prefix=t.prefix||"i18next:",this.logger=e||Pp,this.options=t,this.debug=t.debug}log(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"log","",!0)}warn(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"warn","",!0)}error(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"error","")}deprecate(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"warn","WARNING DEPRECATED: ",!0)}forward(e,t,r,n){return n&&!this.debug?null:("string"==typeof e[0]&&(e[0]=`${r}${this.prefix} ${e[0]}`),this.logger[t](e))}create(e){return new xp(this.logger,{prefix:`${this.prefix}:${e}:`,...this.options})}clone(e){return(e=e||this.options).prefix=e.prefix||this.prefix,new xp(this.logger,e)}}var jp=new xp;class Fp{constructor(){this.observers={}}on(e,t){return e.split(" ").forEach((e=>{this.observers[e]||(this.observers[e]=new Map);const r=this.observers[e].get(t)||0;this.observers[e].set(t,r+1)})),this}off(e,t){this.observers[e]&&(t?this.observers[e].delete(t):delete this.observers[e])}emit(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];this.observers[e]&&Array.from(this.observers[e].entries()).forEach((e=>{let[t,n]=e;for(let e=0;e<n;e++)t(...r)})),this.observers["*"]&&Array.from(this.observers["*"].entries()).forEach((t=>{let[n,o]=t;for(let t=0;t<o;t++)n.apply(n,[e,...r])}))}}const Dp=()=>{let e,t;const r=new Promise(((r,n)=>{e=r,t=n}));return r.resolve=e,r.reject=t,r},kp=e=>null==e?"":""+e,Mp=/###/g,Vp=e=>e&&e.indexOf("###")>-1?e.replace(Mp,"."):e,Up=e=>!e||"string"==typeof e,Bp=(e,t,r)=>{const n="string"!=typeof t?t:t.split(".");let o=0;for(;o<n.length-1;){if(Up(e))return{};const t=Vp(n[o]);!e[t]&&r&&(e[t]=new r),e=Object.prototype.hasOwnProperty.call(e,t)?e[t]:{},++o}return Up(e)?{}:{obj:e,k:Vp(n[o])}},Gp=(e,t,r)=>{const{obj:n,k:o}=Bp(e,t,Object);if(void 0!==n||1===t.length)return void(n[o]=r);let i=t[t.length-1],a=t.slice(0,t.length-1),s=Bp(e,a,Object);for(;void 0===s.obj&&a.length;)i=`${a[a.length-1]}.${i}`,a=a.slice(0,a.length-1),s=Bp(e,a,Object),s&&s.obj&&void 0!==s.obj[`${s.k}.${i}`]&&(s.obj=void 0);s.obj[`${s.k}.${i}`]=r},$p=(e,t)=>{const{obj:r,k:n}=Bp(e,t);if(r)return r[n]},qp=(e,t,r)=>{for(const n in t)"__proto__"!==n&&"constructor"!==n&&(n in e?"string"==typeof e[n]||e[n]instanceof String||"string"==typeof t[n]||t[n]instanceof String?r&&(e[n]=t[n]):qp(e[n],t[n],r):e[n]=t[n]);return e},Kp=e=>e.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&");var Wp={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;","/":"&#x2F;"};const zp=e=>"string"==typeof e?e.replace(/[&<>"'\/]/g,(e=>Wp[e])):e,Hp=[" ",",","?","!",";"],Yp=new class{constructor(e){this.capacity=e,this.regExpMap=new Map,this.regExpQueue=[]}getRegExp(e){const t=this.regExpMap.get(e);if(void 0!==t)return t;const r=new RegExp(e);return this.regExpQueue.length===this.capacity&&this.regExpMap.delete(this.regExpQueue.shift()),this.regExpMap.set(e,r),this.regExpQueue.push(e),r}}(20),Qp=function(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:".";if(!e)return;if(e[t])return e[t];const n=t.split(r);let o=e;for(let e=0;e<n.length;){if(!o||"object"!=typeof o)return;let t,i="";for(let a=e;a<n.length;++a)if(a!==e&&(i+=r),i+=n[a],t=o[i],void 0!==t){if(["string","number","boolean"].indexOf(typeof t)>-1&&a<n.length-1)continue;e+=a-e+1;break}o=t}return o},Xp=e=>e&&e.indexOf("_")>0?e.replace("_","-"):e;class Jp extends Fp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{ns:["translation"],defaultNS:"translation"};super(),this.data=e||{},this.options=t,void 0===this.options.keySeparator&&(this.options.keySeparator="."),void 0===this.options.ignoreJSONStructure&&(this.options.ignoreJSONStructure=!0)}addNamespaces(e){this.options.ns.indexOf(e)<0&&this.options.ns.push(e)}removeNamespaces(e){const t=this.options.ns.indexOf(e);t>-1&&this.options.ns.splice(t,1)}getResource(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};const o=void 0!==n.keySeparator?n.keySeparator:this.options.keySeparator,i=void 0!==n.ignoreJSONStructure?n.ignoreJSONStructure:this.options.ignoreJSONStructure;let a;e.indexOf(".")>-1?a=e.split("."):(a=[e,t],r&&(Array.isArray(r)?a.push(...r):"string"==typeof r&&o?a.push(...r.split(o)):a.push(r)));const s=$p(this.data,a);return!s&&!t&&!r&&e.indexOf(".")>-1&&(e=a[0],t=a[1],r=a.slice(2).join(".")),s||!i||"string"!=typeof r?s:Qp(this.data&&this.data[e]&&this.data[e][t],r,o)}addResource(e,t,r,n){let o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:{silent:!1};const i=void 0!==o.keySeparator?o.keySeparator:this.options.keySeparator;let a=[e,t];r&&(a=a.concat(i?r.split(i):r)),e.indexOf(".")>-1&&(a=e.split("."),n=t,t=a[1]),this.addNamespaces(t),Gp(this.data,a,n),o.silent||this.emit("added",e,t,r,n)}addResources(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{silent:!1};for(const n in r)("string"==typeof r[n]||Array.isArray(r[n]))&&this.addResource(e,t,n,r[n],{silent:!0});n.silent||this.emit("added",e,t,r)}addResourceBundle(e,t,r,n,o){let i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{silent:!1,skipCopy:!1},a=[e,t];e.indexOf(".")>-1&&(a=e.split("."),n=r,r=t,t=a[1]),this.addNamespaces(t);let s=$p(this.data,a)||{};i.skipCopy||(r=JSON.parse(JSON.stringify(r))),n?qp(s,r,o):s={...s,...r},Gp(this.data,a,s),i.silent||this.emit("added",e,t,r)}removeResourceBundle(e,t){this.hasResourceBundle(e,t)&&delete this.data[e][t],this.removeNamespaces(t),this.emit("removed",e,t)}hasResourceBundle(e,t){return void 0!==this.getResource(e,t)}getResourceBundle(e,t){return t||(t=this.options.defaultNS),"v1"===this.options.compatibilityAPI?{...this.getResource(e,t)}:this.getResource(e,t)}getDataByLanguage(e){return this.data[e]}hasLanguageSomeTranslations(e){const t=this.getDataByLanguage(e);return!!(t&&Object.keys(t)||[]).find((e=>t[e]&&Object.keys(t[e]).length>0))}toJSON(){return this.data}}var Zp={processors:{},addPostProcessor(e){this.processors[e.name]=e},handle(e,t,r,n,o){return e.forEach((e=>{this.processors[e]&&(t=this.processors[e].process(t,r,n,o))})),t}};const ef={};class tf extends Fp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};var r,n;super(),r=e,n=this,["resourceStore","languageUtils","pluralResolver","interpolator","backendConnector","i18nFormat","utils"].forEach((e=>{r[e]&&(n[e]=r[e])})),this.options=t,void 0===this.options.keySeparator&&(this.options.keySeparator="."),this.logger=jp.create("translator")}changeLanguage(e){e&&(this.language=e)}exists(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{interpolation:{}};if(null==e)return!1;const r=this.resolve(e,t);return r&&void 0!==r.res}extractFromKey(e,t){let r=void 0!==t.nsSeparator?t.nsSeparator:this.options.nsSeparator;void 0===r&&(r=":");const n=void 0!==t.keySeparator?t.keySeparator:this.options.keySeparator;let o=t.ns||this.options.defaultNS||[];const i=r&&e.indexOf(r)>-1,a=!(this.options.userDefinedKeySeparator||t.keySeparator||this.options.userDefinedNsSeparator||t.nsSeparator||((e,t,r)=>{t=t||"",r=r||"";const n=Hp.filter((e=>t.indexOf(e)<0&&r.indexOf(e)<0));if(0===n.length)return!0;const o=Yp.getRegExp(`(${n.map((e=>"?"===e?"\\?":e)).join("|")})`);let i=!o.test(e);if(!i){const t=e.indexOf(r);t>0&&!o.test(e.substring(0,t))&&(i=!0)}return i})(e,r,n));if(i&&!a){const t=e.match(this.interpolator.nestingRegexp);if(t&&t.length>0)return{key:e,namespaces:o};const i=e.split(r);(r!==n||r===n&&this.options.ns.indexOf(i[0])>-1)&&(o=i.shift()),e=i.join(n)}return"string"==typeof o&&(o=[o]),{key:e,namespaces:o}}translate(e,t,r){if("object"!=typeof t&&this.options.overloadTranslationOptionHandler&&(t=this.options.overloadTranslationOptionHandler(arguments)),"object"==typeof t&&(t={...t}),t||(t={}),null==e)return"";Array.isArray(e)||(e=[String(e)]);const n=void 0!==t.returnDetails?t.returnDetails:this.options.returnDetails,o=void 0!==t.keySeparator?t.keySeparator:this.options.keySeparator,{key:i,namespaces:a}=this.extractFromKey(e[e.length-1],t),s=a[a.length-1],l=t.lng||this.language,u=t.appendNamespaceToCIMode||this.options.appendNamespaceToCIMode;if(l&&"cimode"===l.toLowerCase()){if(u){const e=t.nsSeparator||this.options.nsSeparator;return n?{res:`${s}${e}${i}`,usedKey:i,exactUsedKey:i,usedLng:l,usedNS:s,usedParams:this.getUsedParamsDetails(t)}:`${s}${e}${i}`}return n?{res:i,usedKey:i,exactUsedKey:i,usedLng:l,usedNS:s,usedParams:this.getUsedParamsDetails(t)}:i}const c=this.resolve(e,t);let d=c&&c.res;const p=c&&c.usedKey||i,f=c&&c.exactUsedKey||i,v=Object.prototype.toString.apply(d),h=void 0!==t.joinArrays?t.joinArrays:this.options.joinArrays,g=!this.i18nFormat||this.i18nFormat.handleAsObject;if(g&&d&&"string"!=typeof d&&"boolean"!=typeof d&&"number"!=typeof d&&["[object Number]","[object Function]","[object RegExp]"].indexOf(v)<0&&("string"!=typeof h||!Array.isArray(d))){if(!t.returnObjects&&!this.options.returnObjects){this.options.returnedObjectHandler||this.logger.warn("accessing an object - but returnObjects options is not enabled!");const e=this.options.returnedObjectHandler?this.options.returnedObjectHandler(p,d,{...t,ns:a}):`key '${i} (${this.language})' returned an object instead of string.`;return n?(c.res=e,c.usedParams=this.getUsedParamsDetails(t),c):e}if(o){const e=Array.isArray(d),r=e?[]:{},n=e?f:p;for(const e in d)if(Object.prototype.hasOwnProperty.call(d,e)){const i=`${n}${o}${e}`;r[e]=this.translate(i,{...t,joinArrays:!1,ns:a}),r[e]===i&&(r[e]=d[e])}d=r}}else if(g&&"string"==typeof h&&Array.isArray(d))d=d.join(h),d&&(d=this.extendTranslation(d,e,t,r));else{let n=!1,a=!1;const u=void 0!==t.count&&"string"!=typeof t.count,p=tf.hasDefaultValue(t),f=u?this.pluralResolver.getSuffix(l,t.count,t):"",v=t.ordinal&&u?this.pluralResolver.getSuffix(l,t.count,{ordinal:!1}):"",h=u&&!t.ordinal&&0===t.count&&this.pluralResolver.shouldUseIntlApi(),g=h&&t[`defaultValue${this.options.pluralSeparator}zero`]||t[`defaultValue${f}`]||t[`defaultValue${v}`]||t.defaultValue;!this.isValidLookup(d)&&p&&(n=!0,d=g),this.isValidLookup(d)||(a=!0,d=i);const y=(t.missingKeyNoValueFallbackToKey||this.options.missingKeyNoValueFallbackToKey)&&a?void 0:d,m=p&&g!==d&&this.options.updateMissing;if(a||n||m){if(this.logger.log(m?"updateKey":"missingKey",l,s,i,m?g:d),o){const e=this.resolve(i,{...t,keySeparator:!1});e&&e.res&&this.logger.warn("Seems the loaded translations were in flat JSON format instead of nested. Either set keySeparator: false on init or make sure your translations are published in nested format.")}let e=[];const r=this.languageUtils.getFallbackCodes(this.options.fallbackLng,t.lng||this.language);if("fallback"===this.options.saveMissingTo&&r&&r[0])for(let t=0;t<r.length;t++)e.push(r[t]);else"all"===this.options.saveMissingTo?e=this.languageUtils.toResolveHierarchy(t.lng||this.language):e.push(t.lng||this.language);const n=(e,r,n)=>{const o=p&&n!==d?n:y;this.options.missingKeyHandler?this.options.missingKeyHandler(e,s,r,o,m,t):this.backendConnector&&this.backendConnector.saveMissing&&this.backendConnector.saveMissing(e,s,r,o,m,t),this.emit("missingKey",e,s,r,d)};this.options.saveMissing&&(this.options.saveMissingPlurals&&u?e.forEach((e=>{const r=this.pluralResolver.getSuffixes(e,t);h&&t[`defaultValue${this.options.pluralSeparator}zero`]&&r.indexOf(`${this.options.pluralSeparator}zero`)<0&&r.push(`${this.options.pluralSeparator}zero`),r.forEach((r=>{n([e],i+r,t[`defaultValue${r}`]||g)}))})):n(e,i,g))}d=this.extendTranslation(d,e,t,c,r),a&&d===i&&this.options.appendNamespaceToMissingKey&&(d=`${s}:${i}`),(a||n)&&this.options.parseMissingKeyHandler&&(d="v1"!==this.options.compatibilityAPI?this.options.parseMissingKeyHandler(this.options.appendNamespaceToMissingKey?`${s}:${i}`:i,n?d:void 0):this.options.parseMissingKeyHandler(d))}return n?(c.res=d,c.usedParams=this.getUsedParamsDetails(t),c):d}extendTranslation(e,t,r,n,o){var i=this;if(this.i18nFormat&&this.i18nFormat.parse)e=this.i18nFormat.parse(e,{...this.options.interpolation.defaultVariables,...r},r.lng||this.language||n.usedLng,n.usedNS,n.usedKey,{resolved:n});else if(!r.skipInterpolation){r.interpolation&&this.interpolator.init({...r,interpolation:{...this.options.interpolation,...r.interpolation}});const a="string"==typeof e&&(r&&r.interpolation&&void 0!==r.interpolation.skipOnVariables?r.interpolation.skipOnVariables:this.options.interpolation.skipOnVariables);let s;if(a){const t=e.match(this.interpolator.nestingRegexp);s=t&&t.length}let l=r.replace&&"string"!=typeof r.replace?r.replace:r;if(this.options.interpolation.defaultVariables&&(l={...this.options.interpolation.defaultVariables,...l}),e=this.interpolator.interpolate(e,l,r.lng||this.language||n.usedLng,r),a){const t=e.match(this.interpolator.nestingRegexp);s<(t&&t.length)&&(r.nest=!1)}!r.lng&&"v1"!==this.options.compatibilityAPI&&n&&n.res&&(r.lng=this.language||n.usedLng),!1!==r.nest&&(e=this.interpolator.nest(e,(function(){for(var e=arguments.length,n=new Array(e),a=0;a<e;a++)n[a]=arguments[a];return o&&o[0]===n[0]&&!r.context?(i.logger.warn(`It seems you are nesting recursively key: ${n[0]} in key: ${t[0]}`),null):i.translate(...n,t)}),r)),r.interpolation&&this.interpolator.reset()}const a=r.postProcess||this.options.postProcess,s="string"==typeof a?[a]:a;return null!=e&&s&&s.length&&!1!==r.applyPostProcessor&&(e=Zp.handle(s,e,t,this.options&&this.options.postProcessPassResolved?{i18nResolved:{...n,usedParams:this.getUsedParamsDetails(r)},...r}:r,this)),e}resolve(e){let t,r,n,o,i,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return"string"==typeof e&&(e=[e]),e.forEach((e=>{if(this.isValidLookup(t))return;const s=this.extractFromKey(e,a),l=s.key;r=l;let u=s.namespaces;this.options.fallbackNS&&(u=u.concat(this.options.fallbackNS));const c=void 0!==a.count&&"string"!=typeof a.count,d=c&&!a.ordinal&&0===a.count&&this.pluralResolver.shouldUseIntlApi(),p=void 0!==a.context&&("string"==typeof a.context||"number"==typeof a.context)&&""!==a.context,f=a.lngs?a.lngs:this.languageUtils.toResolveHierarchy(a.lng||this.language,a.fallbackLng);u.forEach((e=>{this.isValidLookup(t)||(i=e,!ef[`${f[0]}-${e}`]&&this.utils&&this.utils.hasLoadedNamespace&&!this.utils.hasLoadedNamespace(i)&&(ef[`${f[0]}-${e}`]=!0,this.logger.warn(`key "${r}" for languages "${f.join(", ")}" won't get resolved as namespace "${i}" was not yet loaded`,"This means something IS WRONG in your setup. You access the t function before i18next.init / i18next.loadNamespace / i18next.changeLanguage was done. Wait for the callback or Promise to resolve before accessing it!!!")),f.forEach((r=>{if(this.isValidLookup(t))return;o=r;const i=[l];if(this.i18nFormat&&this.i18nFormat.addLookupKeys)this.i18nFormat.addLookupKeys(i,l,r,e,a);else{let e;c&&(e=this.pluralResolver.getSuffix(r,a.count,a));const t=`${this.options.pluralSeparator}zero`,n=`${this.options.pluralSeparator}ordinal${this.options.pluralSeparator}`;if(c&&(i.push(l+e),a.ordinal&&0===e.indexOf(n)&&i.push(l+e.replace(n,this.options.pluralSeparator)),d&&i.push(l+t)),p){const r=`${l}${this.options.contextSeparator}${a.context}`;i.push(r),c&&(i.push(r+e),a.ordinal&&0===e.indexOf(n)&&i.push(r+e.replace(n,this.options.pluralSeparator)),d&&i.push(r+t))}}let s;for(;s=i.pop();)this.isValidLookup(t)||(n=s,t=this.getResource(r,e,s,a))})))}))})),{res:t,usedKey:r,exactUsedKey:n,usedLng:o,usedNS:i}}isValidLookup(e){return!(void 0===e||!this.options.returnNull&&null===e||!this.options.returnEmptyString&&""===e)}getResource(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};return this.i18nFormat&&this.i18nFormat.getResource?this.i18nFormat.getResource(e,t,r,n):this.resourceStore.getResource(e,t,r,n)}getUsedParamsDetails(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};const t=["defaultValue","ordinal","context","replace","lng","lngs","fallbackLng","ns","keySeparator","nsSeparator","returnObjects","returnDetails","joinArrays","postProcess","interpolation"],r=e.replace&&"string"!=typeof e.replace;let n=r?e.replace:e;if(r&&void 0!==e.count&&(n.count=e.count),this.options.interpolation.defaultVariables&&(n={...this.options.interpolation.defaultVariables,...n}),!r){n={...n};for(const e of t)delete n[e]}return n}static hasDefaultValue(e){for(const t in e)if(Object.prototype.hasOwnProperty.call(e,t)&&"defaultValue"===t.substring(0,12)&&void 0!==e[t])return!0;return!1}}const rf=e=>e.charAt(0).toUpperCase()+e.slice(1);class nf{constructor(e){this.options=e,this.supportedLngs=this.options.supportedLngs||!1,this.logger=jp.create("languageUtils")}getScriptPartFromCode(e){if(!(e=Xp(e))||e.indexOf("-")<0)return null;const t=e.split("-");return 2===t.length?null:(t.pop(),"x"===t[t.length-1].toLowerCase()?null:this.formatLanguageCode(t.join("-")))}getLanguagePartFromCode(e){if(!(e=Xp(e))||e.indexOf("-")<0)return e;const t=e.split("-");return this.formatLanguageCode(t[0])}formatLanguageCode(e){if("string"==typeof e&&e.indexOf("-")>-1){const t=["hans","hant","latn","cyrl","cans","mong","arab"];let r=e.split("-");return this.options.lowerCaseLng?r=r.map((e=>e.toLowerCase())):2===r.length?(r[0]=r[0].toLowerCase(),r[1]=r[1].toUpperCase(),t.indexOf(r[1].toLowerCase())>-1&&(r[1]=rf(r[1].toLowerCase()))):3===r.length&&(r[0]=r[0].toLowerCase(),2===r[1].length&&(r[1]=r[1].toUpperCase()),"sgn"!==r[0]&&2===r[2].length&&(r[2]=r[2].toUpperCase()),t.indexOf(r[1].toLowerCase())>-1&&(r[1]=rf(r[1].toLowerCase())),t.indexOf(r[2].toLowerCase())>-1&&(r[2]=rf(r[2].toLowerCase()))),r.join("-")}return this.options.cleanCode||this.options.lowerCaseLng?e.toLowerCase():e}isSupportedCode(e){return("languageOnly"===this.options.load||this.options.nonExplicitSupportedLngs)&&(e=this.getLanguagePartFromCode(e)),!this.supportedLngs||!this.supportedLngs.length||this.supportedLngs.indexOf(e)>-1}getBestMatchFromCodes(e){if(!e)return null;let t;return e.forEach((e=>{if(t)return;const r=this.formatLanguageCode(e);this.options.supportedLngs&&!this.isSupportedCode(r)||(t=r)})),!t&&this.options.supportedLngs&&e.forEach((e=>{if(t)return;const r=this.getLanguagePartFromCode(e);if(this.isSupportedCode(r))return t=r;t=this.options.supportedLngs.find((e=>e===r?e:e.indexOf("-")<0&&r.indexOf("-")<0?void 0:e.indexOf("-")>0&&r.indexOf("-")<0&&e.substring(0,e.indexOf("-"))===r||0===e.indexOf(r)&&r.length>1?e:void 0))})),t||(t=this.getFallbackCodes(this.options.fallbackLng)[0]),t}getFallbackCodes(e,t){if(!e)return[];if("function"==typeof e&&(e=e(t)),"string"==typeof e&&(e=[e]),Array.isArray(e))return e;if(!t)return e.default||[];let r=e[t];return r||(r=e[this.getScriptPartFromCode(t)]),r||(r=e[this.formatLanguageCode(t)]),r||(r=e[this.getLanguagePartFromCode(t)]),r||(r=e.default),r||[]}toResolveHierarchy(e,t){const r=this.getFallbackCodes(t||this.options.fallbackLng||[],e),n=[],o=e=>{e&&(this.isSupportedCode(e)?n.push(e):this.logger.warn(`rejecting language code not found in supportedLngs: ${e}`))};return"string"==typeof e&&(e.indexOf("-")>-1||e.indexOf("_")>-1)?("languageOnly"!==this.options.load&&o(this.formatLanguageCode(e)),"languageOnly"!==this.options.load&&"currentOnly"!==this.options.load&&o(this.getScriptPartFromCode(e)),"currentOnly"!==this.options.load&&o(this.getLanguagePartFromCode(e))):"string"==typeof e&&o(this.formatLanguageCode(e)),r.forEach((e=>{n.indexOf(e)<0&&o(this.formatLanguageCode(e))})),n}}let of=[{lngs:["ach","ak","am","arn","br","fil","gun","ln","mfe","mg","mi","oc","pt","pt-BR","tg","tl","ti","tr","uz","wa"],nr:[1,2],fc:1},{lngs:["af","an","ast","az","bg","bn","ca","da","de","dev","el","en","eo","es","et","eu","fi","fo","fur","fy","gl","gu","ha","hi","hu","hy","ia","it","kk","kn","ku","lb","mai","ml","mn","mr","nah","nap","nb","ne","nl","nn","no","nso","pa","pap","pms","ps","pt-PT","rm","sco","se","si","so","son","sq","sv","sw","ta","te","tk","ur","yo"],nr:[1,2],fc:2},{lngs:["ay","bo","cgg","fa","ht","id","ja","jbo","ka","km","ko","ky","lo","ms","sah","su","th","tt","ug","vi","wo","zh"],nr:[1],fc:3},{lngs:["be","bs","cnr","dz","hr","ru","sr","uk"],nr:[1,2,5],fc:4},{lngs:["ar"],nr:[0,1,2,3,11,100],fc:5},{lngs:["cs","sk"],nr:[1,2,5],fc:6},{lngs:["csb","pl"],nr:[1,2,5],fc:7},{lngs:["cy"],nr:[1,2,3,8],fc:8},{lngs:["fr"],nr:[1,2],fc:9},{lngs:["ga"],nr:[1,2,3,7,11],fc:10},{lngs:["gd"],nr:[1,2,3,20],fc:11},{lngs:["is"],nr:[1,2],fc:12},{lngs:["jv"],nr:[0,1],fc:13},{lngs:["kw"],nr:[1,2,3,4],fc:14},{lngs:["lt"],nr:[1,2,10],fc:15},{lngs:["lv"],nr:[1,2,0],fc:16},{lngs:["mk"],nr:[1,2],fc:17},{lngs:["mnk"],nr:[0,1,2],fc:18},{lngs:["mt"],nr:[1,2,11,20],fc:19},{lngs:["or"],nr:[2,1],fc:2},{lngs:["ro"],nr:[1,2,20],fc:20},{lngs:["sl"],nr:[5,1,2,3],fc:21},{lngs:["he","iw"],nr:[1,2,20,21],fc:22}],af={1:e=>Number(e>1),2:e=>Number(1!=e),3:e=>0,4:e=>Number(e%10==1&&e%100!=11?0:e%10>=2&&e%10<=4&&(e%100<10||e%100>=20)?1:2),5:e=>Number(0==e?0:1==e?1:2==e?2:e%100>=3&&e%100<=10?3:e%100>=11?4:5),6:e=>Number(1==e?0:e>=2&&e<=4?1:2),7:e=>Number(1==e?0:e%10>=2&&e%10<=4&&(e%100<10||e%100>=20)?1:2),8:e=>Number(1==e?0:2==e?1:8!=e&&11!=e?2:3),9:e=>Number(e>=2),10:e=>Number(1==e?0:2==e?1:e<7?2:e<11?3:4),11:e=>Number(1==e||11==e?0:2==e||12==e?1:e>2&&e<20?2:3),12:e=>Number(e%10!=1||e%100==11),13:e=>Number(0!==e),14:e=>Number(1==e?0:2==e?1:3==e?2:3),15:e=>Number(e%10==1&&e%100!=11?0:e%10>=2&&(e%100<10||e%100>=20)?1:2),16:e=>Number(e%10==1&&e%100!=11?0:0!==e?1:2),17:e=>Number(1==e||e%10==1&&e%100!=11?0:1),18:e=>Number(0==e?0:1==e?1:2),19:e=>Number(1==e?0:0==e||e%100>1&&e%100<11?1:e%100>10&&e%100<20?2:3),20:e=>Number(1==e?0:0==e||e%100>0&&e%100<20?1:2),21:e=>Number(e%100==1?1:e%100==2?2:e%100==3||e%100==4?3:0),22:e=>Number(1==e?0:2==e?1:(e<0||e>10)&&e%10==0?2:3)};const sf=["v1","v2","v3"],lf=["v4"],uf={zero:0,one:1,two:2,few:3,many:4,other:5};class cf{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.languageUtils=e,this.options=t,this.logger=jp.create("pluralResolver"),this.options.compatibilityJSON&&!lf.includes(this.options.compatibilityJSON)||"undefined"!=typeof Intl&&Intl.PluralRules||(this.options.compatibilityJSON="v3",this.logger.error("Your environment seems not to be Intl API compatible, use an Intl.PluralRules polyfill. Will fallback to the compatibilityJSON v3 format handling.")),this.rules=(()=>{const e={};return of.forEach((t=>{t.lngs.forEach((r=>{e[r]={numbers:t.nr,plurals:af[t.fc]}}))})),e})(),this.pluralRulesCache={}}addRule(e,t){this.rules[e]=t}clearCache(){this.pluralRulesCache={}}getRule(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(this.shouldUseIntlApi())try{const r=Xp("dev"===e?"en":e),n=t.ordinal?"ordinal":"cardinal",o=JSON.stringify({cleanedCode:r,type:n});if(o in this.pluralRulesCache)return this.pluralRulesCache[o];const i=new Intl.PluralRules(r,{type:n});return this.pluralRulesCache[o]=i,i}catch(e){return}return this.rules[e]||this.rules[this.languageUtils.getLanguagePartFromCode(e)]}needsPlural(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};const r=this.getRule(e,t);return this.shouldUseIntlApi()?r&&r.resolvedOptions().pluralCategories.length>1:r&&r.numbers.length>1}getPluralFormsOfKey(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return this.getSuffixes(e,r).map((e=>`${t}${e}`))}getSuffixes(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};const r=this.getRule(e,t);return r?this.shouldUseIntlApi()?r.resolvedOptions().pluralCategories.sort(((e,t)=>uf[e]-uf[t])).map((e=>`${this.options.prepend}${t.ordinal?`ordinal${this.options.prepend}`:""}${e}`)):r.numbers.map((r=>this.getSuffix(e,r,t))):[]}getSuffix(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};const n=this.getRule(e,r);return n?this.shouldUseIntlApi()?`${this.options.prepend}${r.ordinal?`ordinal${this.options.prepend}`:""}${n.select(t)}`:this.getSuffixRetroCompatible(n,t):(this.logger.warn(`no plural rule found for: ${e}`),"")}getSuffixRetroCompatible(e,t){const r=e.noAbs?e.plurals(t):e.plurals(Math.abs(t));let n=e.numbers[r];this.options.simplifyPluralSuffix&&2===e.numbers.length&&1===e.numbers[0]&&(2===n?n="plural":1===n&&(n=""));const o=()=>this.options.prepend&&n.toString()?this.options.prepend+n.toString():n.toString();return"v1"===this.options.compatibilityJSON?1===n?"":"number"==typeof n?`_plural_${n.toString()}`:o():"v2"===this.options.compatibilityJSON||this.options.simplifyPluralSuffix&&2===e.numbers.length&&1===e.numbers[0]?o():this.options.prepend&&r.toString()?this.options.prepend+r.toString():r.toString()}shouldUseIntlApi(){return!sf.includes(this.options.compatibilityJSON)}}const df=function(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:".",o=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],i=((e,t,r)=>{const n=$p(e,r);return void 0!==n?n:$p(t,r)})(e,t,r);return!i&&o&&"string"==typeof r&&(i=Qp(e,r,n),void 0===i&&(i=Qp(t,r,n))),i},pf=e=>e.replace(/\$/g,"$$$$");class ff{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.logger=jp.create("interpolator"),this.options=e,this.format=e.interpolation&&e.interpolation.format||(e=>e),this.init(e)}init(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};e.interpolation||(e.interpolation={escapeValue:!0});const{escape:t,escapeValue:r,useRawValueToEscape:n,prefix:o,prefixEscaped:i,suffix:a,suffixEscaped:s,formatSeparator:l,unescapeSuffix:u,unescapePrefix:c,nestingPrefix:d,nestingPrefixEscaped:p,nestingSuffix:f,nestingSuffixEscaped:v,nestingOptionsSeparator:h,maxReplaces:g,alwaysFormat:y}=e.interpolation;this.escape=void 0!==t?t:zp,this.escapeValue=void 0===r||r,this.useRawValueToEscape=void 0!==n&&n,this.prefix=o?Kp(o):i||"{{",this.suffix=a?Kp(a):s||"}}",this.formatSeparator=l||",",this.unescapePrefix=u?"":c||"-",this.unescapeSuffix=this.unescapePrefix?"":u||"",this.nestingPrefix=d?Kp(d):p||Kp("$t("),this.nestingSuffix=f?Kp(f):v||Kp(")"),this.nestingOptionsSeparator=h||",",this.maxReplaces=g||1e3,this.alwaysFormat=void 0!==y&&y,this.resetRegExp()}reset(){this.options&&this.init(this.options)}resetRegExp(){const e=(e,t)=>e&&e.source===t?(e.lastIndex=0,e):new RegExp(t,"g");this.regexp=e(this.regexp,`${this.prefix}(.+?)${this.suffix}`),this.regexpUnescape=e(this.regexpUnescape,`${this.prefix}${this.unescapePrefix}(.+?)${this.unescapeSuffix}${this.suffix}`),this.nestingRegexp=e(this.nestingRegexp,`${this.nestingPrefix}(.+?)${this.nestingSuffix}`)}interpolate(e,t,r,n){let o,i,a;const s=this.options&&this.options.interpolation&&this.options.interpolation.defaultVariables||{},l=e=>{if(e.indexOf(this.formatSeparator)<0){const o=df(t,s,e,this.options.keySeparator,this.options.ignoreJSONStructure);return this.alwaysFormat?this.format(o,void 0,r,{...n,...t,interpolationkey:e}):o}const o=e.split(this.formatSeparator),i=o.shift().trim(),a=o.join(this.formatSeparator).trim();return this.format(df(t,s,i,this.options.keySeparator,this.options.ignoreJSONStructure),a,r,{...n,...t,interpolationkey:i})};this.resetRegExp();const u=n&&n.missingInterpolationHandler||this.options.missingInterpolationHandler,c=n&&n.interpolation&&void 0!==n.interpolation.skipOnVariables?n.interpolation.skipOnVariables:this.options.interpolation.skipOnVariables;return[{regex:this.regexpUnescape,safeValue:e=>pf(e)},{regex:this.regexp,safeValue:e=>this.escapeValue?pf(this.escape(e)):pf(e)}].forEach((t=>{for(a=0;o=t.regex.exec(e);){const r=o[1].trim();if(i=l(r),void 0===i)if("function"==typeof u){const t=u(e,o,n);i="string"==typeof t?t:""}else if(n&&Object.prototype.hasOwnProperty.call(n,r))i="";else{if(c){i=o[0];continue}this.logger.warn(`missed to pass in variable ${r} for interpolating ${e}`),i=""}else"string"==typeof i||this.useRawValueToEscape||(i=kp(i));const s=t.safeValue(i);if(e=e.replace(o[0],s),c?(t.regex.lastIndex+=i.length,t.regex.lastIndex-=o[0].length):t.regex.lastIndex=0,a++,a>=this.maxReplaces)break}})),e}nest(e,t){let r,n,o,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};const a=(e,t)=>{const r=this.nestingOptionsSeparator;if(e.indexOf(r)<0)return e;const n=e.split(new RegExp(`${r}[ ]*{`));let i=`{${n[1]}`;e=n[0],i=this.interpolate(i,o);const a=i.match(/'/g),s=i.match(/"/g);(a&&a.length%2==0&&!s||s.length%2!=0)&&(i=i.replace(/'/g,'"'));try{o=JSON.parse(i),t&&(o={...t,...o})}catch(t){return this.logger.warn(`failed parsing options string in nesting for key ${e}`,t),`${e}${r}${i}`}return o.defaultValue&&o.defaultValue.indexOf(this.prefix)>-1&&delete o.defaultValue,e};for(;r=this.nestingRegexp.exec(e);){let s=[];o={...i},o=o.replace&&"string"!=typeof o.replace?o.replace:o,o.applyPostProcessor=!1,delete o.defaultValue;let l=!1;if(-1!==r[0].indexOf(this.formatSeparator)&&!/{.*}/.test(r[1])){const e=r[1].split(this.formatSeparator).map((e=>e.trim()));r[1]=e.shift(),s=e,l=!0}if(n=t(a.call(this,r[1].trim(),o),o),n&&r[0]===e&&"string"!=typeof n)return n;"string"!=typeof n&&(n=kp(n)),n||(this.logger.warn(`missed to resolve ${r[1]} for nesting ${e}`),n=""),l&&(n=s.reduce(((e,t)=>this.format(e,t,i.lng,{...i,interpolationkey:r[1].trim()})),n.trim())),e=e.replace(r[0],n),this.regexp.lastIndex=0}return e}}const vf=e=>{const t={};return(r,n,o)=>{let i=o;o&&o.interpolationkey&&o.formatParams&&o.formatParams[o.interpolationkey]&&o[o.interpolationkey]&&(i={...i,[o.interpolationkey]:void 0});const a=n+JSON.stringify(i);let s=t[a];return s||(s=e(Xp(n),o),t[a]=s),s(r)}};class hf{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.logger=jp.create("formatter"),this.options=e,this.formats={number:vf(((e,t)=>{const r=new Intl.NumberFormat(e,{...t});return e=>r.format(e)})),currency:vf(((e,t)=>{const r=new Intl.NumberFormat(e,{...t,style:"currency"});return e=>r.format(e)})),datetime:vf(((e,t)=>{const r=new Intl.DateTimeFormat(e,{...t});return e=>r.format(e)})),relativetime:vf(((e,t)=>{const r=new Intl.RelativeTimeFormat(e,{...t});return e=>r.format(e,t.range||"day")})),list:vf(((e,t)=>{const r=new Intl.ListFormat(e,{...t});return e=>r.format(e)}))},this.init(e)}init(e){const t=(arguments.length>1&&void 0!==arguments[1]?arguments[1]:{interpolation:{}}).interpolation;this.formatSeparator=t.formatSeparator?t.formatSeparator:t.formatSeparator||","}add(e,t){this.formats[e.toLowerCase().trim()]=t}addCached(e,t){this.formats[e.toLowerCase().trim()]=vf(t)}format(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};const o=t.split(this.formatSeparator);if(o.length>1&&o[0].indexOf("(")>1&&o[0].indexOf(")")<0&&o.find((e=>e.indexOf(")")>-1))){const e=o.findIndex((e=>e.indexOf(")")>-1));o[0]=[o[0],...o.splice(1,e)].join(this.formatSeparator)}return o.reduce(((e,t)=>{const{formatName:o,formatOptions:i}=(e=>{let t=e.toLowerCase().trim();const r={};if(e.indexOf("(")>-1){const n=e.split("(");t=n[0].toLowerCase().trim();const o=n[1].substring(0,n[1].length-1);"currency"===t&&o.indexOf(":")<0?r.currency||(r.currency=o.trim()):"relativetime"===t&&o.indexOf(":")<0?r.range||(r.range=o.trim()):o.split(";").forEach((e=>{if(e){const[t,...n]=e.split(":"),o=n.join(":").trim().replace(/^'+|'+$/g,""),i=t.trim();r[i]||(r[i]=o),"false"===o&&(r[i]=!1),"true"===o&&(r[i]=!0),isNaN(o)||(r[i]=parseInt(o,10))}}))}return{formatName:t,formatOptions:r}})(t);if(this.formats[o]){let t=e;try{const a=n&&n.formatParams&&n.formatParams[n.interpolationkey]||{},s=a.locale||a.lng||n.locale||n.lng||r;t=this.formats[o](e,s,{...i,...n,...a})}catch(e){this.logger.warn(e)}return t}return this.logger.warn(`there was no format function for ${o}`),e}),e)}}class gf extends Fp{constructor(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};super(),this.backend=e,this.store=t,this.services=r,this.languageUtils=r.languageUtils,this.options=n,this.logger=jp.create("backendConnector"),this.waitingReads=[],this.maxParallelReads=n.maxParallelReads||10,this.readingCalls=0,this.maxRetries=n.maxRetries>=0?n.maxRetries:5,this.retryTimeout=n.retryTimeout>=1?n.retryTimeout:350,this.state={},this.queue=[],this.backend&&this.backend.init&&this.backend.init(r,n.backend,n)}queueLoad(e,t,r,n){const o={},i={},a={},s={};return e.forEach((e=>{let n=!0;t.forEach((t=>{const a=`${e}|${t}`;!r.reload&&this.store.hasResourceBundle(e,t)?this.state[a]=2:this.state[a]<0||(1===this.state[a]?void 0===i[a]&&(i[a]=!0):(this.state[a]=1,n=!1,void 0===i[a]&&(i[a]=!0),void 0===o[a]&&(o[a]=!0),void 0===s[t]&&(s[t]=!0)))})),n||(a[e]=!0)})),(Object.keys(o).length||Object.keys(i).length)&&this.queue.push({pending:i,pendingCount:Object.keys(i).length,loaded:{},errors:[],callback:n}),{toLoad:Object.keys(o),pending:Object.keys(i),toLoadLanguages:Object.keys(a),toLoadNamespaces:Object.keys(s)}}loaded(e,t,r){const n=e.split("|"),o=n[0],i=n[1];t&&this.emit("failedLoading",o,i,t),!t&&r&&this.store.addResourceBundle(o,i,r,void 0,void 0,{skipCopy:!0}),this.state[e]=t?-1:2,t&&r&&(this.state[e]=0);const a={};this.queue.forEach((r=>{((e,t,r,n)=>{const{obj:o,k:i}=Bp(e,t,Object);o[i]=o[i]||[],o[i].push(r)})(r.loaded,[o],i),((e,t)=>{void 0!==e.pending[t]&&(delete e.pending[t],e.pendingCount--)})(r,e),t&&r.errors.push(t),0!==r.pendingCount||r.done||(Object.keys(r.loaded).forEach((e=>{a[e]||(a[e]={});const t=r.loaded[e];t.length&&t.forEach((t=>{void 0===a[e][t]&&(a[e][t]=!0)}))})),r.done=!0,r.errors.length?r.callback(r.errors):r.callback())})),this.emit("loaded",a),this.queue=this.queue.filter((e=>!e.done))}read(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:this.retryTimeout,i=arguments.length>5?arguments[5]:void 0;if(!e.length)return i(null,{});if(this.readingCalls>=this.maxParallelReads)return void this.waitingReads.push({lng:e,ns:t,fcName:r,tried:n,wait:o,callback:i});this.readingCalls++;const a=(a,s)=>{if(this.readingCalls--,this.waitingReads.length>0){const e=this.waitingReads.shift();this.read(e.lng,e.ns,e.fcName,e.tried,e.wait,e.callback)}a&&s&&n<this.maxRetries?setTimeout((()=>{this.read.call(this,e,t,r,n+1,2*o,i)}),o):i(a,s)},s=this.backend[r].bind(this.backend);if(2!==s.length)return s(e,t,a);try{const r=s(e,t);r&&"function"==typeof r.then?r.then((e=>a(null,e))).catch(a):a(null,r)}catch(e){a(e)}}prepareLoading(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=arguments.length>3?arguments[3]:void 0;if(!this.backend)return this.logger.warn("No backend was added via i18next.use. Will not load resources."),n&&n();"string"==typeof e&&(e=this.languageUtils.toResolveHierarchy(e)),"string"==typeof t&&(t=[t]);const o=this.queueLoad(e,t,r,n);if(!o.toLoad.length)return o.pending.length||n(),null;o.toLoad.forEach((e=>{this.loadOne(e)}))}load(e,t,r){this.prepareLoading(e,t,{},r)}reload(e,t,r){this.prepareLoading(e,t,{reload:!0},r)}loadOne(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"";const r=e.split("|"),n=r[0],o=r[1];this.read(n,o,"read",void 0,void 0,((r,i)=>{r&&this.logger.warn(`${t}loading namespace ${o} for language ${n} failed`,r),!r&&i&&this.logger.log(`${t}loaded namespace ${o} for language ${n}`,i),this.loaded(e,r,i)}))}saveMissing(e,t,r,n,o){let i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{},a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:()=>{};if(this.services.utils&&this.services.utils.hasLoadedNamespace&&!this.services.utils.hasLoadedNamespace(t))this.logger.warn(`did not save key "${r}" as the namespace "${t}" was not yet loaded`,"This means something IS WRONG in your setup. You access the t function before i18next.init / i18next.loadNamespace / i18next.changeLanguage was done. Wait for the callback or Promise to resolve before accessing it!!!");else if(null!=r&&""!==r){if(this.backend&&this.backend.create){const s={...i,isUpdate:o},l=this.backend.create.bind(this.backend);if(l.length<6)try{let o;o=5===l.length?l(e,t,r,n,s):l(e,t,r,n),o&&"function"==typeof o.then?o.then((e=>a(null,e))).catch(a):a(null,o)}catch(e){a(e)}else l(e,t,r,n,a,s)}e&&e[0]&&this.store.addResource(e[0],t,r,n)}}}const yf=()=>({debug:!1,initImmediate:!0,ns:["translation"],defaultNS:["translation"],fallbackLng:["dev"],fallbackNS:!1,supportedLngs:!1,nonExplicitSupportedLngs:!1,load:"all",preload:!1,simplifyPluralSuffix:!0,keySeparator:".",nsSeparator:":",pluralSeparator:"_",contextSeparator:"_",partialBundledLanguages:!1,saveMissing:!1,updateMissing:!1,saveMissingTo:"fallback",saveMissingPlurals:!0,missingKeyHandler:!1,missingInterpolationHandler:!1,postProcess:!1,postProcessPassResolved:!1,returnNull:!1,returnEmptyString:!0,returnObjects:!1,joinArrays:!1,returnedObjectHandler:!1,parseMissingKeyHandler:!1,appendNamespaceToMissingKey:!1,appendNamespaceToCIMode:!1,overloadTranslationOptionHandler:e=>{let t={};if("object"==typeof e[1]&&(t=e[1]),"string"==typeof e[1]&&(t.defaultValue=e[1]),"string"==typeof e[2]&&(t.tDescription=e[2]),"object"==typeof e[2]||"object"==typeof e[3]){const r=e[3]||e[2];Object.keys(r).forEach((e=>{t[e]=r[e]}))}return t},interpolation:{escapeValue:!0,format:e=>e,prefix:"{{",suffix:"}}",formatSeparator:",",unescapePrefix:"-",nestingPrefix:"$t(",nestingSuffix:")",nestingOptionsSeparator:",",maxReplaces:1e3,skipOnVariables:!0}}),mf=e=>("string"==typeof e.ns&&(e.ns=[e.ns]),"string"==typeof e.fallbackLng&&(e.fallbackLng=[e.fallbackLng]),"string"==typeof e.fallbackNS&&(e.fallbackNS=[e.fallbackNS]),e.supportedLngs&&e.supportedLngs.indexOf("cimode")<0&&(e.supportedLngs=e.supportedLngs.concat(["cimode"])),e),bf=()=>{};class Ef extends Fp{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1?arguments[1]:void 0;var r;if(super(),this.options=mf(e),this.services={},this.logger=jp,this.modules={external:[]},r=this,Object.getOwnPropertyNames(Object.getPrototypeOf(r)).forEach((e=>{"function"==typeof r[e]&&(r[e]=r[e].bind(r))})),t&&!this.isInitialized&&!e.isClone){if(!this.options.initImmediate)return this.init(e,t),this;setTimeout((()=>{this.init(e,t)}),0)}}init(){var e=this;let t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},r=arguments.length>1?arguments[1]:void 0;this.isInitializing=!0,"function"==typeof t&&(r=t,t={}),!t.defaultNS&&!1!==t.defaultNS&&t.ns&&("string"==typeof t.ns?t.defaultNS=t.ns:t.ns.indexOf("translation")<0&&(t.defaultNS=t.ns[0]));const n=yf();this.options={...n,...this.options,...mf(t)},"v1"!==this.options.compatibilityAPI&&(this.options.interpolation={...n.interpolation,...this.options.interpolation}),void 0!==t.keySeparator&&(this.options.userDefinedKeySeparator=t.keySeparator),void 0!==t.nsSeparator&&(this.options.userDefinedNsSeparator=t.nsSeparator);const o=e=>e?"function"==typeof e?new e:e:null;if(!this.options.isClone){let t;this.modules.logger?jp.init(o(this.modules.logger),this.options):jp.init(null,this.options),this.modules.formatter?t=this.modules.formatter:"undefined"!=typeof Intl&&(t=hf);const r=new nf(this.options);this.store=new Jp(this.options.resources,this.options);const i=this.services;i.logger=jp,i.resourceStore=this.store,i.languageUtils=r,i.pluralResolver=new cf(r,{prepend:this.options.pluralSeparator,compatibilityJSON:this.options.compatibilityJSON,simplifyPluralSuffix:this.options.simplifyPluralSuffix}),!t||this.options.interpolation.format&&this.options.interpolation.format!==n.interpolation.format||(i.formatter=o(t),i.formatter.init(i,this.options),this.options.interpolation.format=i.formatter.format.bind(i.formatter)),i.interpolator=new ff(this.options),i.utils={hasLoadedNamespace:this.hasLoadedNamespace.bind(this)},i.backendConnector=new gf(o(this.modules.backend),i.resourceStore,i,this.options),i.backendConnector.on("*",(function(t){for(var r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];e.emit(t,...n)})),this.modules.languageDetector&&(i.languageDetector=o(this.modules.languageDetector),i.languageDetector.init&&i.languageDetector.init(i,this.options.detection,this.options)),this.modules.i18nFormat&&(i.i18nFormat=o(this.modules.i18nFormat),i.i18nFormat.init&&i.i18nFormat.init(this)),this.translator=new tf(this.services,this.options),this.translator.on("*",(function(t){for(var r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];e.emit(t,...n)})),this.modules.external.forEach((e=>{e.init&&e.init(this)}))}if(this.format=this.options.interpolation.format,r||(r=bf),this.options.fallbackLng&&!this.services.languageDetector&&!this.options.lng){const e=this.services.languageUtils.getFallbackCodes(this.options.fallbackLng);e.length>0&&"dev"!==e[0]&&(this.options.lng=e[0])}this.services.languageDetector||this.options.lng||this.logger.warn("init: no languageDetector is used and no lng is defined"),["getResource","hasResourceBundle","getResourceBundle","getDataByLanguage"].forEach((t=>{this[t]=function(){return e.store[t](...arguments)}})),["addResource","addResources","addResourceBundle","removeResourceBundle"].forEach((t=>{this[t]=function(){return e.store[t](...arguments),e}}));const i=Dp(),a=()=>{const e=(e,t)=>{this.isInitializing=!1,this.isInitialized&&!this.initializedStoreOnce&&this.logger.warn("init: i18next is already initialized. You should call init just once!"),this.isInitialized=!0,this.options.isClone||this.logger.log("initialized",this.options),this.emit("initialized",this.options),i.resolve(t),r(e,t)};if(this.languages&&"v1"!==this.options.compatibilityAPI&&!this.isInitialized)return e(null,this.t.bind(this));this.changeLanguage(this.options.lng,e)};return this.options.resources||!this.options.initImmediate?a():setTimeout(a,0),i}loadResources(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:bf;const r="string"==typeof e?e:this.language;if("function"==typeof e&&(t=e),!this.options.resources||this.options.partialBundledLanguages){if(r&&"cimode"===r.toLowerCase()&&(!this.options.preload||0===this.options.preload.length))return t();const e=[],n=t=>{t&&"cimode"!==t&&this.services.languageUtils.toResolveHierarchy(t).forEach((t=>{"cimode"!==t&&e.indexOf(t)<0&&e.push(t)}))};r?n(r):this.services.languageUtils.getFallbackCodes(this.options.fallbackLng).forEach((e=>n(e))),this.options.preload&&this.options.preload.forEach((e=>n(e))),this.services.backendConnector.load(e,this.options.ns,(e=>{e||this.resolvedLanguage||!this.language||this.setResolvedLanguage(this.language),t(e)}))}else t(null)}reloadResources(e,t,r){const n=Dp();return"function"==typeof e&&(r=e,e=void 0),"function"==typeof t&&(r=t,t=void 0),e||(e=this.languages),t||(t=this.options.ns),r||(r=bf),this.services.backendConnector.reload(e,t,(e=>{n.resolve(),r(e)})),n}use(e){if(!e)throw new Error("You are passing an undefined module! Please check the object you are passing to i18next.use()");if(!e.type)throw new Error("You are passing a wrong module! Please check the object you are passing to i18next.use()");return"backend"===e.type&&(this.modules.backend=e),("logger"===e.type||e.log&&e.warn&&e.error)&&(this.modules.logger=e),"languageDetector"===e.type&&(this.modules.languageDetector=e),"i18nFormat"===e.type&&(this.modules.i18nFormat=e),"postProcessor"===e.type&&Zp.addPostProcessor(e),"formatter"===e.type&&(this.modules.formatter=e),"3rdParty"===e.type&&this.modules.external.push(e),this}setResolvedLanguage(e){if(e&&this.languages&&!(["cimode","dev"].indexOf(e)>-1))for(let e=0;e<this.languages.length;e++){const t=this.languages[e];if(!(["cimode","dev"].indexOf(t)>-1)&&this.store.hasLanguageSomeTranslations(t)){this.resolvedLanguage=t;break}}}changeLanguage(e,t){var r=this;this.isLanguageChangingTo=e;const n=Dp();this.emit("languageChanging",e);const o=e=>{this.language=e,this.languages=this.services.languageUtils.toResolveHierarchy(e),this.resolvedLanguage=void 0,this.setResolvedLanguage(e)},i=(e,i)=>{i?(o(i),this.translator.changeLanguage(i),this.isLanguageChangingTo=void 0,this.emit("languageChanged",i),this.logger.log("languageChanged",i)):this.isLanguageChangingTo=void 0,n.resolve((function(){return r.t(...arguments)})),t&&t(e,(function(){return r.t(...arguments)}))},a=t=>{e||t||!this.services.languageDetector||(t=[]);const r="string"==typeof t?t:this.services.languageUtils.getBestMatchFromCodes(t);r&&(this.language||o(r),this.translator.language||this.translator.changeLanguage(r),this.services.languageDetector&&this.services.languageDetector.cacheUserLanguage&&this.services.languageDetector.cacheUserLanguage(r)),this.loadResources(r,(e=>{i(e,r)}))};return e||!this.services.languageDetector||this.services.languageDetector.async?!e&&this.services.languageDetector&&this.services.languageDetector.async?0===this.services.languageDetector.detect.length?this.services.languageDetector.detect().then(a):this.services.languageDetector.detect(a):a(e):a(this.services.languageDetector.detect()),n}getFixedT(e,t,r){var n=this;const o=function(e,t){let i;if("object"!=typeof t){for(var a=arguments.length,s=new Array(a>2?a-2:0),l=2;l<a;l++)s[l-2]=arguments[l];i=n.options.overloadTranslationOptionHandler([e,t].concat(s))}else i={...t};i.lng=i.lng||o.lng,i.lngs=i.lngs||o.lngs,i.ns=i.ns||o.ns,""!==i.keyPrefix&&(i.keyPrefix=i.keyPrefix||r||o.keyPrefix);const u=n.options.keySeparator||".";let c;return c=i.keyPrefix&&Array.isArray(e)?e.map((e=>`${i.keyPrefix}${u}${e}`)):i.keyPrefix?`${i.keyPrefix}${u}${e}`:e,n.t(c,i)};return"string"==typeof e?o.lng=e:o.lngs=e,o.ns=t,o.keyPrefix=r,o}t(){return this.translator&&this.translator.translate(...arguments)}exists(){return this.translator&&this.translator.exists(...arguments)}setDefaultNamespace(e){this.options.defaultNS=e}hasLoadedNamespace(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!this.isInitialized)return this.logger.warn("hasLoadedNamespace: i18next was not initialized",this.languages),!1;if(!this.languages||!this.languages.length)return this.logger.warn("hasLoadedNamespace: i18n.languages were undefined or empty",this.languages),!1;const r=t.lng||this.resolvedLanguage||this.languages[0],n=!!this.options&&this.options.fallbackLng,o=this.languages[this.languages.length-1];if("cimode"===r.toLowerCase())return!0;const i=(e,t)=>{const r=this.services.backendConnector.state[`${e}|${t}`];return-1===r||0===r||2===r};if(t.precheck){const e=t.precheck(this,i);if(void 0!==e)return e}return!(!this.hasResourceBundle(r,e)&&this.services.backendConnector.backend&&(!this.options.resources||this.options.partialBundledLanguages)&&(!i(r,e)||n&&!i(o,e)))}loadNamespaces(e,t){const r=Dp();return this.options.ns?("string"==typeof e&&(e=[e]),e.forEach((e=>{this.options.ns.indexOf(e)<0&&this.options.ns.push(e)})),this.loadResources((e=>{r.resolve(),t&&t(e)})),r):(t&&t(),Promise.resolve())}loadLanguages(e,t){const r=Dp();"string"==typeof e&&(e=[e]);const n=this.options.preload||[],o=e.filter((e=>n.indexOf(e)<0&&this.services.languageUtils.isSupportedCode(e)));return o.length?(this.options.preload=n.concat(o),this.loadResources((e=>{r.resolve(),t&&t(e)})),r):(t&&t(),Promise.resolve())}dir(e){if(e||(e=this.resolvedLanguage||(this.languages&&this.languages.length>0?this.languages[0]:this.language)),!e)return"rtl";const t=this.services&&this.services.languageUtils||new nf(yf());return["ar","shu","sqr","ssh","xaa","yhd","yud","aao","abh","abv","acm","acq","acw","acx","acy","adf","ads","aeb","aec","afb","ajp","apc","apd","arb","arq","ars","ary","arz","auz","avl","ayh","ayl","ayn","ayp","bbz","pga","he","iw","ps","pbt","pbu","pst","prp","prd","ug","ur","ydd","yds","yih","ji","yi","hbo","men","xmn","fa","jpr","peo","pes","prs","dv","sam","ckb"].indexOf(t.getLanguagePartFromCode(e))>-1||e.toLowerCase().indexOf("-arab")>1?"rtl":"ltr"}static createInstance(){return new Ef(arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},arguments.length>1?arguments[1]:void 0)}cloneInstance(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:bf;const r=e.forkResourceStore;r&&delete e.forkResourceStore;const n={...this.options,...e,isClone:!0},o=new Ef(n);return void 0===e.debug&&void 0===e.prefix||(o.logger=o.logger.clone(e)),["store","services","language"].forEach((e=>{o[e]=this[e]})),o.services={...this.services},o.services.utils={hasLoadedNamespace:o.hasLoadedNamespace.bind(o)},r&&(o.store=new Jp(this.store.data,n),o.services.resourceStore=o.store),o.translator=new tf(o.services,n),o.translator.on("*",(function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];o.emit(e,...r)})),o.init(n,t),o.translator.options=n,o.translator.backendConnector.services.utils={hasLoadedNamespace:o.hasLoadedNamespace.bind(o)},o}toJSON(){return{options:this.options,store:this.store,language:this.language,languages:this.languages,resolvedLanguage:this.resolvedLanguage}}}const Of=Ef.createInstance();Of.createInstance=Ef.createInstance,Of.createInstance,Of.dir,Of.init,Of.loadResources,Of.reloadResources,Of.use,Of.changeLanguage,Of.getFixedT,Of.t,Of.exists,Of.setDefaultNamespace,Of.hasLoadedNamespace,Of.loadNamespaces,Of.loadLanguages;var Sf,Tf=(eo(eo(eo(eo(eo(eo(eo(eo(eo(eo(Sf={},Xd,"Empty group"),Jd,"No conditions for group field {{field}}"),Zd,"Empty query"),ep,"Empty case"),tp,"No config for field {{field}}"),"FIXED_OPERATOR","Fixed operator {{from}} to {{to}} for field {{field}}"),rp,"No config for operator {{operator}}"),np,"No config for function {{funcKey}}"),op,"Invalid value"),ip,"Invalid value of arg {{argName}} for func {{funcName}}: {{argValidationError}}"),eo(eo(eo(eo(eo(eo(eo(eo(eo(eo(Sf,ap,"Type of field {{field}} is not supported"),sp,"Operator {{operator}} is not supported for field {{field}}"),up,"Incomplete rule"),cp,"Incomplete LHS"),dp,"Incomplete RHS"),lp,"Invalid value src {{valueSrcs, list}}"),pp+"_one","Value {{badValues, list}} is not in the list of allowed values"),pp+"_other","Values {{badValues, list}} are not in the list of allowed values"),fp,"Value {{value}} is not in the list of allowed values"),vp,"Value should have type {{wType}}, but got value of type {{valueType}}"),eo(eo(eo(eo(eo(eo(eo(eo(eo(eo(Sf,hp,"Value should have JS type {{jsType}}, but got value of type {{valueTypeof}}"),gp,"Value {{value}} should have max length {{fieldSettings.maxLength}} but got {{length}}"),yp,"Value {{value}} should be greater than or equal to {{fieldSettings.min}}"),yp+"_"+Lp,"Value {{value}} should be from {{fieldSettings.min}} to {{fieldSettings.max}}"),mp,"Value {{value}} should be less than or equal to {{fieldSettings.max}}"),mp+"_"+Lp,"Value {{value}} should be from {{fieldSettings.min}} to {{fieldSettings.max}}"),bp,"No config for field {{field}}"),Ep,"Can't compare field {{field}} with itself"),Op,"Can't compare field {{leftField}} with {{rightField}}"),Sp,"Field {{field}} is of type {{type}}, but expected {{expected}}"),eo(eo(eo(eo(eo(eo(eo(eo(eo(eo(Sf,Tp,"Unsupported function {{funcKey}} for field {{field}}"),_p,"Value of arg {{argName}} for func {{funcName}} is required"),wp,"Function {{funcKey}} should return value of type {{returnType}}, but got {{valueType}}"),Rp,"Invalid range"),Ap,"Root"),Ip+"__rule","Leaf #{{globalLeafNo}}"),Ip+"__group","Group #{{globalGroupNo}}"),Ip+"__rule_group","Rule-group #{{globalNoByType}}"),Ip+"__case_group","Case #{{globalNoByType}}"),Ip+"__rule__deleted","Deleted leaf #{{globalLeafNo}}"),eo(eo(eo(eo(eo(Sf,Ip+"__group__deleted","Deleted group #{{globalGroupNo}}"),Ip+"__rule_group__deleted","Deleted rule-group #{{globalNoByType}}"),Ip+"__case_group__deleted","Deleted case #{{globalNoByType}}"),Np,"{{str}} in case #{{caseNo}}"),Cp,"{{str}} (index path: {{indexPath, list}})")),_f="raqbvalidation",wf="".concat(_f,":"),Rf=Of.createInstance();Rf.init({fallbackLng:"en"}),Rf.addResources("en",_f,Tf);var If=function e(t,r){return null!=t&&t.str?t.str:null!=t&&t.key?e(t.key,t.args):null===r?t:Rf.t(t.includes(":")?t:wf+t,r)};const Af=Rf;function Cf(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Nf(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Cf(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Cf(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Lf=function(e){return"object"===Wn(e)&&null!==e&&Array.isArray(e)?"array":Wn(e)},Pf=function(e,t){return 0===xf(e,t).length},xf=function(e,t){var r=t.settings.showErrorMessage,n=[];return e&&function e(t,o,i){var a,s,l=t.get("id"),u=t.get("children1"),c=t.getIn(["properties","valueError"]),d=t.getIn(["properties","fieldError"]),p=t.getIn(["properties","field"]),f=null!==(a=null==p||null===(s=p.get)||void 0===s?void 0:s.call(p,"func"))&&void 0!==a?a:p;((null==c?void 0:c.size)>0&&c.filter((function(e){return null!=e})).size>0||!!d)&&r&&n.push(f),u&&u.map((function(t,r){t&&e(t,o.concat(l),i+1)}))}(e,[],0),Array.from(new Set(n))},jf=function(e,t){var r=_h(t,void 0,!0),n={removeEmptyGroups:t.settings.removeEmptyGroupsOnLoad,removeIncompleteRules:t.settings.removeIncompleteRulesOnLoad,removeEmptyRules:t.settings.removeEmptyRulesOnLoad,forceFix:!1},o=Mf(e,null,r,r,n),i=o.fixedTree,a=o.allErrors;return o.isSanitized&&a.length&&console.warn("Tree check errors: ",a),i},Ff=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=_h(t,void 0,!0),o=Nf(Nf({},r),{},{removeEmptyGroups:!1,removeEmptyRules:!1,removeIncompleteRules:!1,forceFix:!1});return Mf(e,null,n,n,o).allErrors},Df=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=_h(t,void 0,!0),o=Nf({removeEmptyGroups:!0,removeEmptyRules:!0,removeIncompleteRules:!0,forceFix:!1},r),i=Mf(e,null,n,n,o);return{fixedTree:i.fixedTree,fixedErrors:i.fixedErrors,nonFixedErrors:i.nonFixedErrors,allErrors:i.allErrors}},kf=function(e,t,r,n,o,i,a){void 0===o&&(o=r.settings.removeEmptyGroupsOnLoad),void 0===i&&(i=r.settings.removeEmptyRulesOnLoad),void 0===a&&(a=r.settings.removeIncompleteRulesOnLoad);var s=Mf(e,t,r,n,{removeEmptyGroups:o,removeEmptyRules:i,removeIncompleteRules:a,forceFix:!1}),l=s.fixedTree,u=(s.allErrors,s.fixedErrors);return s.nonFixedErrors,s.isSanitized&&u.length&&console.warn("Fixed tree errors: ",u),Iu(l)},Mf=function(e,t,r,n,o){if(!e)return{fixedTree:e,allErrors:[],fixedErrors:[],nonFixedErrors:[],isSanitized:!1};var i,a,s=o||{},l=s.removeEmptyGroups,u=s.removeEmptyRules,c=s.removeIncompleteRules,d=s.forceFix,p=s.translateErrors,f=void 0===p||p,v=s.includeStringifiedItems,h=void 0===v||v,g=s.stringifyFixedItems,y=void 0!==g&&g,m=s.stringifyItemsUserFriendly,b=void 0===m||m,E=s.includeItemsPositions,O=void 0===E||E,S={errors:{}},T=Bf(e,[],null,S,{config:r,oldConfig:n,removeEmptyGroups:l,removeEmptyRules:u,removeIncompleteRules:c,forceFix:d}),_=S.sanitized,w=[];for(var R in O&&(i=Cu(T).items),S.errors){var I=S.errors[R],A=I.path,C=I.errors;f&&(C=C.map((function(e){return Nf(Nf({},e),{},{str:If(e)})})));var N={path:A,errors:C};if(h){var L=wu(y?T:e,A);if(1!==A.length&&"group"!==L.get("type")){var P=qd(L,r,b,!0);N.itemStr=P}}if(O){var x=i[R],j=!x;if(j&&(a||(a=Cu(e).items),x=a[R]),x){var F=Nf(Nf({},x.position),{},{index:x.index,type:x.type,isDeleted:j});N.itemPosition=F;var D=x.index?Ip+"__"+x.type+(j?"__deleted":""):Ap,k=Nf({},F);if(b){for(var M,V=0,U=["caseNo","globalLeafNo","globalGroupNo","globalNoByType"];V<U.length;V++){var B=U[V];null!=k[B]&&(k[B]=k[B]+1)}k.indexPath=null===(M=F.indexPath)||void 0===M?void 0:M.map((function(e){return e+1}))}N.itemPositionStr=If(D,k),x.index&&(x.caseId&&"case_group"!==x.type&&(N.itemPositionStr=If(Np,Nf(Nf({},k),{},{str:N.itemPositionStr}))),"case_group"!==x.type&&(N.itemPositionStr=If(Cp,Nf(Nf({},k),{},{str:N.itemPositionStr}))))}}w.push(N)}for(var G=[],$=[],q=0,K=w;q<K.length;q++){var W=K[q],z=W.errors.filter((function(e){return!!e.fixed})),H=W.errors.filter((function(e){return!e.fixed&&"EMPTY_QUERY"!==e.key}));z.length&&G.push(Nf(Nf({},W),{},{errors:z})),H.length&&$.push(Nf(Nf({},W),{},{errors:H}))}return{fixedTree:T,allErrors:w,fixedErrors:G,nonFixedErrors:$,isSanitized:_}};function Vf(e,t,r,n){var o=t.get("id");e.errors[o]||(e.errors[o]={path:[].concat(so(r),[o]),errors:[]}),e.errors[o].errors.push(n)}function Uf(e,t){var r=t.get("id");e.errors[r]&&e.errors[r].errors.map((function(e){e.fixed=!0}))}function Bf(e,t,r,n,o){var i=null==e?void 0:e.get("type");return"group"===i||"rule_group"===i||"case_group"==i||"switch_group"==i?function(e,t,r,n,o){var i,a,s,l,u,c,d=o.removeEmptyGroups,p=o.removeIncompleteRules,f=(o.forceFix,o.config),v=(f.settings.showErrorMessage,e.get("id")),h=e.get("children1"),g=!t.length,y=h,m=e.get("type"),b=e.get("properties"),E=null==b?void 0:b.get("field"),O=null==b?void 0:b.get("mode"),S=null==b||null===(i=b.get)||void 0===i?void 0:i.call(b,"operator"),T="rule_group"===m&&"array"===O,_="case_group"===m,w=_&&null==h,R=S?null!==(a=null===(s=f.operators[S])||void 0===s?void 0:s.cardinality)&&void 0!==a?a:1:void 0,I=_?!w:T?0==R:d,A=T||_;!v&&r&&(v=r,e=e.set("id",v),n.sanitized=!0),A&&(e=Gf(e,t,r,n,o));var C={errors:{}},N=null===(u=h=null===(l=h)||void 0===l?void 0:l.map((function(e,r){return Bf(e,t.concat(v),r,C,o)})))||void 0===u?void 0:u.filter((function(e){return null!=e}));d&&(h=N);var L=C.sanitized||(null==y?void 0:y.size)!=(null===(c=h)||void 0===c?void 0:c.size),P=d&&!g;return T&&E&&(P=p),!(null!=N&&N.size)&&I&&(Vf(n,e,t,{key:g?Zd:_?ep:T?Jd:Xd,args:{field:E},fixed:P}),P&&(Uf(n,e),e=void 0)),L&&(n.sanitized=!0),L&&e&&(e=e.set("children1",h)),n.errors=Nf(Nf({},n.errors),(null==C?void 0:C.errors)||{}),e}(e,t,r,n,o):"rule"===i?Gf(e,t,r,n,o):e}function Gf(e,t,r,n,o){var i=o.removeIncompleteRules,a=o.removeEmptyRules,s=o.forceFix,l=o.config,u=o.oldConfig,c=l.settings.showErrorMessage,d=!c||s,p=e.get("id"),f="case_group"===e.get("type"),v=e.get("properties");if(!v){if(!f)return void Vf(n,e,t,{key:up,args:{},fixed:i||a});v=new Il.Map}var h=v.get("field")||null;f&&(h="!case_value");var g=v.get("fieldSrc")||null,y=v.get("operator")||null,m=v.get("operatorOptions"),b=v.get("valueSrc"),E=v.get("value"),O=v.get("valueError"),S=v.get("fieldError"),T=function(){var e,t;return{field:(null===(e=h)||void 0===e||null===(t=e.toJS)||void 0===t?void 0:t.call(e))||h,fieldSrc:g,operator:y,operatorOptions:m?m.toJS():{},valueSrc:b?b.toJS():null,value:E?E.toJS():null,valueError:O?O.toJS():null,fieldError:S||null}},_=T();!p&&r&&(p=r,e=e.set("id",p),n.sanitized=!0);var w=h?Qh(l,h):null;h&&!w&&(Vf(n,e,t,{key:tp,args:{field:h},side:"lhs",fixed:i||a}),h=null),null!=h||f||(v=["operator","operatorOptions","valueSrc","value","valueError","fieldError","field"].reduce((function(e,t){return e.delete(t)}),v),y=null),g||!h||f||(g=Yh(h),v=v.set("fieldSrc",g)),"range_between"!==y&&"range_not_between"!==y||(y="range_between"===y?"between":"not_between",v=v.set("operator",y));var R=y?Xh(l,y,h):null;y&&!R&&(Vf(n,e,t,{key:rp,args:{operator:y},side:"op",fixed:i||a}),y=null);var I=h?av(l,h):[];h&&!f&&(null!=I&&I.length?y&&-1==I.indexOf(y)&&("is_empty"===y||"is_not_empty"===y?(y="is_empty"===y?"is_null":"is_not_null",v=v.set("operator",y)):(Vf(n,e,t,{key:sp,args:{operator:y,field:h},side:"lhs",fixed:i||a}),y=null)):(Vf(n,e,t,{key:ap,args:{field:h},side:"lhs",fixed:i||a}),y=null)),null!=y||f||(v=["operatorOptions","valueSrc","value","valueError"].reduce((function(e,t){return e.delete(t)}),v)),m=v.get("operatorOptions"),!y||m&&!R.options?(m=null,v=v.delete("operatorOptions")):y&&!m&&R.options&&(m=Cd(l,y,h),v=v.set("operatorOptions",m)),b=v.get("valueSrc"),E=v.get("value");var A=Hf(l,u,v,h,y,null,d,!0),C=A.newValue,N=A.newValueSrc,L=A.newValueError,P=A.validationErrors,x=A.newFieldError,j=A.fixedField;E=C,b=N,O=L,S=x,h=j,v=(v=(v=v.set("field",h)).set("value",E)).set("valueSrc",b),v=c?v.set("valueError",O).set("fieldError",S):v.delete("valueError").delete("fieldError");var F=T(),D=!kl(_,F),k=Rv(v.toObject(),l),M=f?k.parts.value:k.score>=3;if(D&&(n.sanitized=!0,e=e.set("properties",v)),null==P||P.map((function(r){return Vf(n,e,t,r)})),!M)if(f);else{var V=k.score?i:a,U={key:up,args:{}};if(k.parts.field){if(!k.parts.value){var B,G,$,q;U.key=dp,U.side="rhs",null!==(B=F.valueSrc)&&void 0!==B&&B[0]&&(null===(G=F.valueSrc)||void 0===G?void 0:G[0])!=(null===($=_.valueSrc)||void 0===$?void 0:$[0])&&null!=(null===(q=F.value)||void 0===q?void 0:q[0])&&(U.key=lp,U.args={valueSrcs:F.valueSrc})}}else U.key=cp,U.side="lhs";U.fixed=V,Vf(n,e,t,U),V&&(Uf(n,e),e=void 0)}return e}var $f=function(e,t,r,n,o,i,a,s){var l=arguments.length>8&&void 0!==arguments[8]&&arguments[8],u=arguments.length>9&&void 0!==arguments[9]&&arguments[9],c=arguments.length>10&&void 0!==arguments[10]&&arguments[10],d=[],p=o;if(null!=o){var f,v,h,g;if("field"===a){var y=io(Kf(t,r,o,a,i,s,e,n,l,u),2);p=y[0],d=y[1]}else if("func"===a){var m=io(Wf(t,r,o,a,i,s,e,n,l,u,c),2);p=m[0],d=m[1]}else if("value"===a||!a){var b=io(qf(r,o,a,i,s,e,n,l,u),2);p=b[0],d=b[1]}var E=!(null!==(f=d)&&void 0!==f&&f.find((function(e){return!e.fixed})));if(r&&!["field","func"].includes(a)&&(null===(v=d)||void 0===v||!v.length||E)){var O=yv(e,r,n,a),S=n?Xh(e,n,r):null,T=Jh(e,r,n,O,a,{forExport:!0}),_="field"===a?Qh(e,o):null,w=T,R=T.validateValue;if("function"==typeof R){var I=[p,w,n,S];"field"===a&&I.push(_);var A,C,N=R.call.apply(R,[e.ctx].concat(I));"object"!==Wn(N)||null===N||Array.isArray(N)?"boolean"==typeof N?0==N&&d.push({key:op,args:{}}):"string"==typeof N&&d.push({key:N,args:null}):(C=null!==(A=N.error)&&void 0!==A&&A.key?Nf({},N.error):{key:N.error,args:null},void 0!==N.fixedValue&&l&&(C.fixed=!0,C.fixedFrom=p,C.fixedTo=N.fixedValue,p=N.fixedValue),d.push(C))}}if(E=!(null!==(h=d)&&void 0!==h&&h.find((function(e){return!e.fixed}))),null!==(g=d)&&void 0!==g&&g.length&&!E&&l){var L=Qh(e,r),P=null==L?void 0:L.fieldSettings,x=null==P?void 0:P.defaultValue;if(void 0!==x){var j=d[d.length-1];j.fixed=!0,j.fixedFrom=p,j.fixedTo=x,p=x,d.map((function(e){e.fixed=!0}))}}}return[p,d]},qf=function(e,t,r,n,o,i){var a,s,l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,u=arguments.length>7&&void 0!==arguments[7]&&arguments[7],c=[],d=t;if(e){var p=Qh(i,e),f=yv(i,e,l,r),v=i.widgets[f],h=null==v?void 0:v.type,g=null==v?void 0:v.jsType,y=null==p?void 0:p.fieldSettings,m=(null==y?void 0:y.treeValues)||(null==y?void 0:y.listValues),b=!(null==y||!y.asyncFetch),E=m||b;if(n&&h&&n!=h)return c.push({key:vp,args:{wType:h,valueType:n}}),[t,c];if(g&&(s=g,Lf(a=t)!==s&&("number"!==s||isNaN(a)))&&!E)return c.push({key:hp,args:{jsType:g,valueTypeof:Lf(t)}}),[t,c];if(y){var O=o||m;if(O&&!y.allowCustomValues&&"case_value"!==f){var S=function(e,t,r,n,o){var i=Il.List.isList(e)?e.toJS():e instanceof Array?so(e):void 0,a=e,s=[];if(i){var l=i.reduce((function(e,r){var n=io(e,2),o=n[0],i=n[1],a=yu(t,r);return null==a?[o,[].concat(so(i),[r])]:[[].concat(so(o),[a.value]),i]}),[[],[]]),u=io(l,2),c=u[0],d=u[1],p=d.length>0;if(a=(r=r||!0===o)&&p?c:e,d.length){var f=r&&p;s.push({key:pp,args:{badValues:d,count:d.length},fixed:f,fixedFrom:f?i:void 0,fixedTo:f?a:void 0})}return[a,s]}var v=yu(t,e);return null==v?(a=r?null:e,s.push({key:fp,args:{value:e},fixed:r,fixedFrom:r?e:void 0,fixedTo:r?a:void 0})):a=v.value,[a,s]}(t,O,u,0,i.settings.removeInvalidMultiSelectValuesOnLoad),T=io(S,2);d=T[0],c=T[1]}y.maxLength>0&&null!=t&&String(t).length>y.maxLength&&(d=u?String(t).substring(0,y.maxLength):t,c.push({key:gp,args:{value:t,length:String(t).length,fieldSettings:y},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0}));var _=null!=y.min&&null!=y.max?Lp:void 0;null!=y.min&&t<y.min&&(d=u?y.min:t,c.push({key:yp,args:{value:t,fieldSettings:y,context:_},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0})),null!=y.max&&t>y.max&&(d=u?y.max:t,c.push({key:mp,args:{value:t,fieldSettings:y,context:_},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0}))}}return[d,c]},Kf=function(e,t,r,n,o,i,a){var s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,l=[],u=a.settings,c=u.fieldSeparator,d=u.canCompareFieldWithField,p="object"==Wn(t)&&(null==t?void 0:t._isFuncArg),f=Array.isArray(e)?e.join(c):e,v=Qh(a,e),h=Array.isArray(r)?r.join(c):r,g=Qh(a,r);return g?e&&h===f&&!p?(l.push({key:Ep,args:{field:f}}),[r,l]):o&&o!=g.type?(l.push({key:Sp,args:{field:h,type:g.type,expected:o}}),[r,l]):e&&!p&&d&&!d(f,v,h,g,s)?(l.push({key:Op,args:{leftField:f,rightField:h}}),[r,l]):[r]:(l.push({key:bp,args:{field:h}}),[r,l])},Wf=function(e,t,r,n,o,i,a){var s,l,u=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,c=arguments.length>8&&void 0!==arguments[8]&&arguments[8],d=arguments.length>9&&void 0!==arguments[9]&&arguments[9],p=arguments.length>10&&void 0!==arguments[10]&&arguments[10],f=r,v=[];if(!r)return[r];var h=null===(s=r.get)||void 0===s?void 0:s.call(r,"func");if(!h)return[r];var g=Qh(a,t);if(null!=g&&g.funcs&&!g.funcs.includes(h))return v.push({key:Tp,args:{funcKey:h,field:t}}),[r,v];var y=Uh(a,h);if(!y)return v.push({key:np,args:{funcKey:h}}),[r,v];var m=null!==(l=y.label)&&void 0!==l?l:h;if(o&&y.returnType!=o)return v.push({key:wp,args:{funcKey:h,funcName:m,returnType:y.returnType,valueType:o}}),[r,v];for(var b in c=c||p,y.args){var E,O=y.args[b],S=f.get("args"),T=S?S.get(b):void 0,_=Qh(a,O),w=null!==(E=null==_?void 0:_.label)&&void 0!==E?E:b,R=T?T.get("value"):void 0,I=T?T.get("valueSrc"):void 0;if(void 0!==R){var A=io($f(a,e,_,u,R,O.type,I,i,c,d,p),2),C=A[0],N=A[1],L=!(null!=N&&N.length),P=c&&C!==R,x=c&&!L&&!P&&(d||p);if(P&&(f=f.setIn(["args",b,"value"],C)),x&&(f=f.deleteIn(["args",b]),f=Zf(a,f,y,b)),!L){var j,F,D=null!==(j=null!==(F=N.find((function(e){return!e.fixed&&!e.ignore})))&&void 0!==F?F:N.find((function(e){return!e.fixed})))&&void 0!==j?j:N[0],k=P||x,M=0===N.filter((function(e){return!e.ignore})).length;if(D){var V=If(D);v.push({key:ip,args:{funcKey:h,funcName:m,argKey:b,argName:w,argValidationError:V,argErrors:N},ignore:M,fixed:k,fixedFrom:k?R:void 0,fixedTo:k?P?C:O.defaultValue:void 0})}}}else if(!O.isOptional&&(d||p)){var U=c&&void 0!==O.defaultValue&&(d||p);d&&v.push({key:_p,args:{funcKey:h,funcName:m,argKey:b,argName:w},fixed:U,fixedTo:U?O.defaultValue:void 0,ignore:!U}),U&&(f=f.deleteIn(["args",b]),f=Zf(a,f,y,b))}}return[f,v]},zf=function(e,t,r,n,o){var i,a=Xh(e,r,t),s=r?Dl(a):null,l=o.toJS?o.toJS():o,u=n.toJS?n.toJS():n,c=l.filter((function(e){return"value"==e||null==e})).length==s;if(null!=a&&a.validateValues&&c){var d=l[0],p=yv(e,t,r,d),f=Jh(e,t,r,p,d),v=null!=f&&f.toJS?u.map((function(t){var r=f.toJS.call(e.ctx,t,f);return r instanceof Date&&(r=r.getTime()),r})):u,h=a.validateValues(v);"boolean"==typeof h&&0==h&&(i={key:Rp,args:{jsValues:v,values:u}})}return i},Hf=function(e){var t,r,n,o,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,a=arguments.length>2?arguments[2]:void 0,s=arguments.length>3?arguments[3]:void 0,l=arguments.length>4?arguments[4]:void 0,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,c=arguments.length>6&&void 0!==arguments[6]&&arguments[6],d=arguments.length>7&&void 0!==arguments[7]&&arguments[7],p=arguments.length>8&&void 0!==arguments[8]&&arguments[8];i||(i=e);var f=e.settings,v=f.keepInputOnChangeFieldSrc,h=f.convertableWidgets,g=f.clearValueOnChangeField,y=f.clearValueOnChangeOp,m="!case_value"==s,b=a.get("field");!b&&m&&(b=s);var E,O=a.get("fieldType"),S=a.get("fieldSrc"),T=a.get("operator"),_=a.get("value"),w=a.get("valueSrc",new Il.List),R=a.get("valueType",new Il.List),I=a.get("valueError",new Il.List),A=a.get("asyncListValues"),C=m,N=Xh(i,T),L=Xh(e,l,s),P=m?1:T?Dl(N):null,x=m?1:l?Dl(L):null,j=Qh(i,b),F=Qh(e,s),D=!b&&O&&v,k=(null==j?void 0:j.type)||O,M=(null==F?void 0:F.type)||!s&&D&&k,V=null==j?void 0:j.listValuesType,U=null==F?void 0:F.listValuesType,B=(null===(t=b)||void 0===t||null===(r=t.get)||void 0===r?void 0:r.call(t,"func"))||b,G=((null===(n=s)||void 0===n||null===(o=n.get)||void 0===o?void 0:o.call(n,"func"))||s)!=B,$=[],q=(b||D)&&(T&&l||C)&&null!=_;if((!k||!M||k!=M||"field"===u&&G&&g||"operator"===u&&y)&&(q=!1),G&&ov.includes(M)&&(U&&U===V||(q=!1)),C||(null!=_&&_.size||!x)&&(null==_||!_.size||x)||(q=!1),"func"===S&&s){var K=io($f(e,null,null,l,s,M,S,A,c,d,p),2),W=K[0],z=K[1],H=!(null!=z&&z.length),Y=W!==s,Q=!H&&Y&&!z.find((function(e){return!e.fixed})),X=c&&!H&&!Q&&!!u&&s!==b;if(X?s=b:Y&&(s=W),!H){var J=!H&&!Q&&!X,Z=z.find((function(e){return!e.fixed&&!e.ignore}));J&&Z&&(E=If(Z)),z.map((function(e){return $.push(Nf(Nf({side:"lhs"},e),{},{fixed:e.fixed||X||false}))}))}}for(var ee=0;ee<x;ee++){var te=w.get(ee)||null,re=yv(i,b,T,te),ne=yv(e,s,l,te),oe="value"===te?re:yv(i,b,T,"value"),ie="value"===te?ne:yv(e,s,l,"value");ie==oe||(h[oe]||[]).includes(ie)||!oe&&D||(q=!1)}T!=l&&[T,l].includes("proximity")&&(q=!1);var ae=w.first(),se=Jh(e,s,l,null,ae),le=gv(e,s,l,null);!s&&D&&(le=Object.keys(e.settings.valueSourcesInfo));var ue,ce=le[0];1===x&&se&&void 0!==se.type?ue=se.type:1===x&&F&&void 0!==F.type&&(ue="!group"===F.type?"number":F.type);var de=q&&"operator"===u&&1===P&&2===x,pe=[],fe=[],ve=[],he=Array.from({length:x},(function(){return null}));if(q)for(var ge=function(t){var r=_.get(t),n=R.get(t)||null,o=w.get(t)||null;de&&1===t&&(r=void 0!==pe[0]?pe[0]:_.get(0),pe[t]=r,n=R.get(0)||null,o=w.get(0)||null);var i=!o||void 0!==le.find((function(e){return e==o})),a=io($f(e,s,s,l,r,n,o,A,c,d,p),2),u=a[0],f=a[1],v=!(null!=f&&f.length),h=u!==r,g=!v&&h&&!(null!=f&&f.find((function(e){return!e.fixed}))),y=!(null!=f&&f.find((function(e){return!e.fixed&&!e.ignore}))),m=!i||c&&!v&&!g&&(!y||G);v||null==f||f.map((function(e){return $.push(Nf(Nf({side:"rhs",delta:t},e),{},{fixed:e.fixed||m}))})),m&&(pe[t]=null,0===t&&delete pe[1]);var b=!v&&!h,E=null==f?void 0:f.find((function(e){return!e.fixed&&!e.ignore}));b&&E&&(he[t]=If(E)),h&&(pe[t]=u),!de||0!==t||v||h||(de=!1),de&&0===t&&["func","field"].includes(o)&&(de=!1)},ye=0;ye<x;ye++)ge(ye);if(!q)for(var me=0;me<x;me++)if(1===x){var be,Ee=eu([null==F?void 0:F.defaultValue,null==F||null===(be=F.fieldSettings)||void 0===be?void 0:be.defaultValue,null==se?void 0:se.defaultValue]);pe[me]=Ee,null!=Ee&&Ee.func&&(fe[me]="func")}for(var Oe=0;Oe<x;Oe++){var Se,Te,_e=q&&w.get(Oe)||null,we=q&&R.get(Oe)||null;q&&de&&1===Oe&&(_e=null!==(Se=fe[Oe])&&void 0!==Se?Se:w.get(0),we=null!==(Te=ve[Oe])&&void 0!==Te?Te:R.get(0),fe[Oe]=_e,ve[Oe]=we),le.includes(_e)||(fe[Oe]=ce),we||(ve[Oe]=ue)}var Re=_;(pe.length>0||!q)&&(Re=new Il.List(Array.from({length:x},(function(e,t){return void 0!==pe[t]?pe[t]:q?_.get(t):void 0}))));var Ie=w;(fe.length>0||!q)&&(Ie=new Il.List(Array.from({length:x},(function(e,t){var r;return null!==(r=fe[t])&&void 0!==r?r:q&&w.get(t)||null}))));var Ae=R;(ve.length>0||!q)&&(Ae=new Il.List(Array.from({length:x},(function(e,t){var r;return null!==(r=ve[t])&&void 0!==r?r:q&&R.get(t)||null}))));var Ce=zf(e,s,l,Re,Ie);if(Ce){var Ne=If(Ce),Le=c&&x>=2,Pe=Re;Le&&(pe[1]=Re.get(0),Re=Re.set(1,pe[1]),he[1]=he[0]),!Le&&he.push(Ne),$.push(Nf(Nf({side:"rhs",delta:-1},Ce),{},{fixed:Le,fixedFrom:Le?[Pe.get(0),Pe.get(1)]:void 0,fixedTo:Le?[Re.get(0),Re.get(1)]:void 0}))}var xe=I,je=(null==I?void 0:I.size)!==he.length||he.filter((function(e,t){return e!=I.get(t)})).length>0;return je&&(xe=new Il.List(he)),{canReuseValue:q,newValue:Re,newValueSrc:Ie,newValueType:Ae,operatorCardinality:x,fixedField:s,newValueError:xe,newFieldError:E,validationErrors:$}},Yf=function(e){return"object"==Wn(e)&&null!==e&&!Array.isArray(e)},Qf=function(e,t){if(e){var r=e.get("func"),n=r&&Uh(t,r);if(n){var o=e,i=!1;for(var a in n.args){var s=n.args[a],l=s.valueSources,u=s.isOptional,c=s.defaultValue,d=hv(t,l,s),p=o.get("args"),f=1==d.length?d[0]:void 0,v=p?p.get(a):void 0,h=v?v.get("value"):void 0,g=(v?v.get("valueSrc"):void 0)||f;if(void 0!==h){var y=Av(h,g,t);if(void 0===y)return;if(y!==h&&(o=o.setIn(["args",a,"value"],y)),i)return}else if(void 0===c||Yf(c)){if(!u)return;i=!0}else o=(o=o.setIn(["args",a,"value"],ev(s))).setIn(["args",a,"valueSrc"],"value")}return o}}},Xf=function(e,t,r,n){var o=r.settings.fieldSeparator;e=e||new Il.Map,Array.isArray(t)&&(t=t.join(o));var i=e.get("func"),a=e.get("args");e=e.set("func",t);var s=t&&Uh(r,t),l=t&&Vh(r,t),u=i&&Vh(r,i),c=nv(u,l,a,r,n);return e=c.length?Object.keys(l.args).filter((function(e){return!c.includes(e)})).reduce((function(e,t){return e.deleteIn(["args",t])}),e):e.set("args",new Il.Map),Jf(r,e,s)},Jf=function(e,t,r){if(r)for(var n in r.args)t=Zf(e,t,r,n);return t},Zf=function(e,t,r,n){var o=r.args[n],i=o.valueSources,a=o.defaultValue,s=hv(e,i,o),l=s.length?s[0]:void 0,u=(a?Yf(a)&&a.func?"func":"value":void 0)||l;return t.getIn(["args",n])||(void 0!==a&&(t=t.setIn(["args",n,"value"],ev(o))),u&&(t=t.setIn(["args",n,"valueSrc"],u))),t},ev=function(e){var t=e.defaultValue;return Yf(t)&&!Il.Map.isMap(t)&&t.func?Il.fromJS(t,(function(e,t){return Il.Iterable.isIndexed(t)?t.toList():t.toOrderedMap()})):t},tv=function(e,t,r,n,o){if(e&&e.get("func")){var i=(e=e.setIn(["args",t,"value"],r)).getIn(["args",t,"valueSrc"]),a=n.valueSources,s=hv(o,a,n),l=1==s.length?s[0]:void 0;!l&&s.includes("value")&&(l="value"),!i&&l&&(e=e.setIn(["args",t,"valueSrc"],l))}return e},rv=function(e,t,r,n,o){return e&&e.get("func")&&(e=e.setIn(["args",t],new Il.Map({valueSrc:r}))),e},nv=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4];return(null==e?void 0:e.returnType)!=(null==t?void 0:t.returnType)?[]:Object.keys(t.args).filter((function(i,a){var s=t.args[i],l=e.args[i];if(Object.keys(e.args).indexOf(i),!l&&(void 0!==s.defaultValue||s.isOptional))return!0;if((null==l?void 0:l.type)!=s.type)return!1;if(ov.includes(s.type)&&(!l.listValuesType||l.listValuesType!==s.listValuesType))return!1;if(r){var u,c=r.get(i),d=null==c?void 0:c.get("value"),p=null==c?void 0:c.get("valueSrc");if(p&&s.valueSources&&!s.valueSources.includes(p))return!1;var f=io($f(n,null,s,null,d,s.type,p,null,o,!0),2),v=(f[0],f[1]);if(null!=v&&null!==(u=v.filter((function(e){return!e.fixed})))&&void 0!==u&&u.length)return!1}return!0}))},ov=["select","multiselect","treeselect","treemultiselect"],iv=function(e,t){var r;return(null===(r=e.types[t])||void 0===r?void 0:r.operators)||null},av=function(e,t){var r=Qh(e,t);return r?r.operators:[]},sv=function(e,t){var r,n=av(e,t);return null!==(r=null==n?void 0:n[0])&&void 0!==r?r:null},lv=function(e,t,r){var n=null;if(e)if("field"===t){var o=Qh(r,e);o&&(n=o.type)}else if("func"===t){var i=e.get("func");if(i){var a=Uh(r,i);a&&(n=a.returnType||a.type)}}return n},uv=function(e,t){return cv(e,t,arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,"funcs","subfields")},cv=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"fields",o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"subfields";if(!e)return null;var i=t.settings.fieldSeparator,a=qh(e,t),s=qh(r,t);return a.slice(s.length).map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return[].concat(so(s),so(e)).join(i)})).map((function(e){var r=kh(t,e,n,o);return r&&r.label||su()(e.split(i))})).filter((function(e){return null!=e}))},dv=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!e)return null;var n=r&&kh(t,r)||null,o=t.settings.fieldSeparator,i=qh(e,t),a=Gh(e,r,t)?qh(r,t):[];return i.slice(a.length).map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return{part:[].concat(so(a),so(e)).join(o),key:e[e.length-1]}})).map((function(e){var r=e.part;return{key:e.key,cnf:kh(t,r)}})).map((function(e,t,r){return[e.key,e.cnf,t>0?r[t-1].cnf:n]}))},pv=function(e,t,r,n){var o=arguments.length>5&&void 0!==arguments[5]&&arguments[5],i=Jh(e,t,r,null,arguments.length>4&&void 0!==arguments[4]?arguments[4]:null)||{},a=Xh(e,r,t)||{},s=null;if((o?1:a.cardinality)>1){var l=i.valueLabels||a.valueLabels;l&&(s=l[n]),s&&"object"!==Wn(s)&&(s={label:s,placeholder:s}),s||(s={label:e.settings.valueLabel+" "+(n+1),placeholder:e.settings.valuePlaceholder+" "+(n+1)})}else{var u=i.valueLabel,c=i.valuePlaceholder;s={label:u||e.settings.valueLabel,placeholder:c||e.settings.valuePlaceholder}}return s};function fv(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=[],i=[];if(!t)return{widgets:o,valueSrcs:i};var a=Wh(t),s=a?"".concat(a,"__").concat(r,"__").concat(n):null,l=zh(e,"_getWidgetsAndSrcsForFieldOp",s);if(l)return l;var u="object"===Wn(t)&&(!!t.func&&!!t.arg||t._isFuncArg),c=Qh(e,t),d=r?e.operators[r]:null;if(null!=c&&c.widgets){var p=function(){var a=c.widgets[f];if(!e.widgets[f])return 1;var s=e.widgets[f].valueSrc||"value",l=!0;if("field"===f&&(l=l&&hv(e,["field"],c).length>0),"func"===f&&(l=l&&hv(e,["func"],c).length>0),"value"!==n||a.operators||u||"!case_value"===t||(l=!1),a.operators&&r&&(l=l&&-1!=a.operators.indexOf(r)),n&&n!=s&&"const"!==n&&(l=!1),d&&0==d.cardinality&&"value"!==s&&(l=!1),l){var p,v;o.push(f);var h=-1!=(null===(p=c.valueSources)||void 0===p?void 0:p.indexOf(s));-1==(null==d||null===(v=d.valueSources)||void 0===v?void 0:v.indexOf(s))&&(h=!1),h&&!i.find((function(e){return e==s}))&&i.push(s)}};for(var f in c.widgets)p()}var v=function(e){var t=0;return c.preferWidgets?c.preferWidgets.includes(e)&&(t+=10-c.preferWidgets.indexOf(e)):e==c.mainWidget&&(t+=100),"field"===e&&(t-=1),"func"===e&&(t-=2),t};o.sort((function(e,t){return v(t)-v(e)}));var h={widgets:o,valueSrcs:i};return Hh(e,"_getWidgetsAndSrcsForFieldOp",s,h),h}var vv=function(e,t,r){return fv(e,t,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:null).widgets},hv=function(e,t,r){var n;if(!r)return t;var o=null!==(n=r.type)&&void 0!==n?n:r.returnType;return"!group"===o&&(o="number"),t||(t=Object.keys(e.settings.valueSourcesInfo)),t.filter((function(t){var n=!0;if("field"===t&&e.__fieldsCntByType){var i=r._isFuncArg?0:1;n=n&&e.__fieldsCntByType[o]>i}return"func"===t&&(r.funcs&&(n=n&&r.funcs.length>0),e.__funcsCntByType&&(n=n&&e.__funcsCntByType[o]>0)),n}))},gv=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=fv(e,t,r,null).valueSrcs;return hv(e,o,n)},yv=function(e,t,r){var n=fv(e,t,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:null).widgets,o=null;return n.length&&(o=n[0]),o},mv=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:{};if(e){var i=Qh(t,e)||{},a=t.settings.fieldSeparator,s=qh(e,t),l=Array.isArray(e)?e.join(a):e;if(null!=o&&o.useTableName&&i.tableName){var u=so(s);u[0]=i.tableName,l=u.join(a)}if(i.fieldName&&(l=i.fieldName),n){Qh(t,n);var c=n;0==l.indexOf(c+a)?l=l.slice((c+a).length):i.fieldName||r.errors.push("Can't cut group ".concat(c," from field ").concat(l))}return l}},bv=function(e,t){var r=e.get("type"),n=e.getIn(["properties","mode"]);return"rule_group"==r&&"array"==n?Ev(e,t):"group"==r||"rule_group"==r?Sv(e,t):_v(e,t)},Ev=function(e,t){var r=e.get("children1"),n=e.get("properties");return Ov(n.toObject(),r,t)},Ov=function(e,t,r){var n,o,i=e.operator,a=0==(null!==(n=null===(o=r.operators[i])||void 0===o?void 0:o.cardinality)&&void 0!==n?n:1),s=!wv(e,r),l=!Tv(t,r);return!(s&&(!a||l))},Sv=function(e,t){var r=e.get("children1");return Tv(r,t)},Tv=function(e,t){return!((null==e?void 0:e.size)>0&&e.filter((function(e){return!bv(e,t)})).size>0)},_v=function(e,t){var r=e.get("properties");return wv((null==r?void 0:r.toObject())||{},t)},wv=function(e,t){return!(Rv(e,t,!0).score>=3)},Rv=function(e,t){var r,n,o,i=e.field,a=e.fieldSrc,s=(e.fieldType,e.operator),l=e.value,u=e.valueSrc,c=(e.valueType,arguments.length>2&&void 0!==arguments[2]&&arguments[2]),d=null!==(r=null===(n=t.operators[s])||void 0===n?void 0:n.cardinality)&&void 0!==r?r:1,p=null!=u&&u.get?u.toJS():u,f={parts:{},score:0};if(f.parts.field=c?null!=i:Iv(i,a,t),f.parts.operator=!!s,f.parts.value=(null==l||null===(o=l.filter((function(e,r){return Iv(e,null==p?void 0:p[r],t,c)})))||void 0===o?void 0:o.size)>=(c?Math.min(d,1):d),f.score=Object.keys(f.parts).filter((function(e){return!!f.parts[e]})).length,c&&f.score<3){var v=!0;!f.parts.value&&"func"===a&&Iv(i,a,t,!1,v)&&f.score++,f.parts.field||null==l||l.map((function(e,r){"func"===(null==p?void 0:p[r])&&Iv(e,null==p?void 0:p[r],t,!1,v)&&f.score++}))}return f},Iv=function e(t,r,n){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];if(!o&&"func"==r&&t){var a,s=null===(a=t.get)||void 0===a?void 0:a.call(t,"func"),l=Uh(n,s);if(l){var u=t.get("args");for(var c in l.args){var d=l.args[c],p=u?u.get(c):void 0,f=p?p.get("value"):void 0,v=p?p.get("valueSrc"):void 0;if(null==f&&void 0===(null==d?void 0:d.defaultValue)&&(null==d||!d.isOptional))return!1;if(null!=f&&!e(f,v,n,!i||o))return!1}return!0}}return null!=t},Av=function(e,t,r){return"func"==t?Qf(e,r):e},Cv=function e(t){var r=t.get("children1");if(1==(null==r?void 0:r.size)){var n=r.first();return"group"===n.get("type")?e(n):n}return null},Nv=p(4308),Lv=p.n(Nv),Pv=p(3523),xv=p.n(Pv),jv=p(502),Fv=p.n(jv);function Dv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function kv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Dv(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Dv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Mv(e,t){return Fv().apply(e,t)}var Vv={CALL:function(e,t){for(var r=arguments.length,n=new Array(r>2?r-2:0),o=2;o<r;o++)n[o-2]=arguments[o];return e.call.apply(e,[t].concat(n))},JSX:function(e,t){return{type:e,props:t}},mergeObjects:function(e,t){return kv(kv({},e),t)},fromEntries:function(e){return Object.fromEntries(e)},strlen:function(e){return(null==e?void 0:e.length)||0},regexTest:function(e,t,r){return null!=(null==e?void 0:e.match(new RegExp(t,r)))},now:function(){return new Date},date_add:function(e,t,r){return qu()(e).add(t,r).toDate()},toLowerCase:function(e){return e.toLowerCase()},toUpperCase:function(e){return e.toUpperCase()}};function Uv(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Bv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Gv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Bv(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Bv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function $v(e,t,r){var n;try{n=Fv().apply(e,t)}catch(e){throw e.message="".concat(r.join(".")," :: ").concat(e.message),e}return n}function qv(e,t,r,n){var o;try{o=t.call.apply(t,[e].concat(so(r)))}catch(e){throw e.message="".concat(n.join(".")," :: ").concat(e.message),e}return o}!function(){for(var e in Vv)t=e,r=Vv[e],Fv().add_operation(t,r);var t,r}();var Kv=["conjunctions","fields","types","operators","widgets","settings","funcs","ctx"],Wv={asyncFetch:{type:"f",args:["search","offset"]},labelYes:{type:"r"},labelNo:{type:"r"},marks:{type:"r",isArr:!0},validateValue:{type:"f",args:["val","fieldSettings","op","opDef","rightFieldDef"]}},zv=Gv(Gv({},Wv),{},{factory:{type:"rf"},formatValue:{type:"f",args:["val","fieldDef","wgtDef","isForDisplay","op","opDef","rightFieldDef"]},sqlFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef","rightFieldDef"]},spelFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef","rightFieldDef"]},spelImportValue:{type:"f",args:["val","wgtDef","args"]},mongoFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef"]},elasticSearchFormatValue:{type:"f",args:["queryType","val","op","field","config"]},jsonLogic:{type:"f",args:["val","fieldDef","wgtDef","op","opDef"]},jsonLogicImport:{type:"f",args:["val"]},validateValue:{type:"f",args:["val","fieldSettings","op","opDef","rightFieldDef"]},toJS:{type:"f",args:["val"]}}),Hv={options:{factory:{type:"rf"}},formatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","isForDisplay","fieldDef"]},mongoFormatOp:{type:"f",args:["field","op","vals","useExpr","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},sqlFormatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},spelFormatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},jsonLogic:{type:"f",ignore:"string",args:["field","op","vals","opDef","operatorOptions","fieldDef"]},elasticSearchQueryType:{type:"f",ignore:"string",args:["valueType"]},textSeparators:{type:"r",isArr:!0}},Yv={widgetProps:zv,opProps:Hv},Qv=Gv(Gv({},Wv),{},{fieldSettings:Wv}),Xv=Gv(Gv({},Wv),{},{fieldSettings:Wv,widgets:{x:Yv},mainWidgetProps:zv}),Jv={locale:{mui:{type:"f",args:[],invokeWith:[],ignore:"jl"}},caseValueField:Xv,canCompareFieldWithField:{type:"f",args:["leftField","leftFieldConfig","rightField","rightFieldConfig","op"]},formatReverse:{type:"f",args:["q","op","reversedOp","operatorDefinition","revOperatorDefinition","isForDisplay"]},sqlFormatReverse:{type:"f",args:["q"]},spelFormatReverse:{type:"f",args:["q"]},formatField:{type:"f",args:["field","parts","label2","fieldDefinition","config","isForDisplay"]},formatSpelField:{type:"f",args:["field","parentField","parts","partsExt","fieldDefinition","config"]},formatAggr:{type:"f",args:["whereStr","aggrField","operator","value","valueSrc","valueType","opDef","operatorOptions","isForDisplay","aggrFieldDef"]},normalizeListValues:{type:"f",args:["listValues","type","fieldSettings"]},renderConfirm:{type:"f",args:["props"]},useConfirm:{type:"f",args:[]},renderField:{type:"rf"},renderOperator:{type:"rf"},renderFunc:{type:"rf"},renderConjs:{type:"rf"},renderButton:{type:"rf"},renderIcon:{type:"rf"},renderButtonGroup:{type:"rf"},renderValueSources:{type:"rf"},renderFieldSources:{type:"rf"},renderProvider:{type:"rf"},renderSwitch:{type:"rf"},renderSwitchPrefix:{type:"r"},renderItem:{type:"rf"},renderBeforeWidget:{type:"rf"},renderAfterWidget:{type:"rf"},renderBeforeActions:{type:"rf"},renderAfterActions:{type:"rf"},renderBeforeCaseValue:{type:"rf"},renderAfterCaseValue:{type:"rf"},renderRuleError:{type:"rf"}},Zv={fields:{x:Xv},widgets:{x:zv},conjunctions:{x:{formatConj:{type:"f",args:["children","conj","not","isForDisplay"]},sqlFormatConj:{type:"f",args:["children","conj","not"]},spelFormatConj:{type:"f",args:["children","conj","not","omitBrackets"]}}},operators:{x:Hv},types:{x:{widgets:{x:Yv}}},funcs:{x:Gv(Gv(Gv({},Qv),{renderBrackets:{type:"r",isArr:!0},renderSeps:{type:"r",isArr:!0},jsonLogic:{type:"f",ignore:"string",args:["formattedArgs"]},jsonLogicImport:{type:"f",args:["val"]},spelImport:{type:"f",args:["spel"]},formatFunc:{type:"f",args:["formattedArgs","isForDisplay"]},sqlFormatFunc:{type:"f",args:["formattedArgs"]},mongoFormatFunc:{type:"f",args:["formattedArgs"]},spelFormatFunc:{type:"f",args:["formattedArgs"]}}),{},{args:{x:Gv({},Qv)}})},settings:Jv},eh=function(e){return"object"==Wn(e)&&null!==e&&!Array.isArray(e)},th=function(e,t){if(e.__fieldNames)throw new Error("Don't apply `compressConfig()` to extended config");var r=iu()(e,Kv);delete r.ctx;for(var n=function e(t,r,n,o){if(eh(t)){if(Wl(t)&&(t=Kl(t)),"funcs"===n[0]&&!r){var i=n[n.length-1];(r=kh({funcs:o.BasicFuncs},i,"funcs","subfields")||void 0)&&(t.$$key=i)}if(void 0!==r&&eh(r))for(var a in r)Object.prototype.hasOwnProperty.call(r,a)&&(!Object.keys(t).includes(a)||void 0===t[a]&&void 0!==r[a]?t[a]="$$deleted":(t[a]=e(t[a],r[a],[].concat(so(n),[a]),o),void 0===t[a]&&delete t[a]));for(var s in t)if(Object.prototype.hasOwnProperty.call(t,s)){var l;r&&Object.keys(r).includes(s)||(t[s]=e(t[s],null===(l=r)||void 0===l?void 0:l[s],[].concat(so(n),[s]),o)),void 0===t[s]&&delete t[s]}0===Object.keys(t).length&&(t=void 0)}else Array.isArray(t)&&t.forEach((function(r,i){t[i]=e(t[i],void 0,[].concat(so(n),[i]),o)}));if(void 0===r||!Ml(t,r,!0)){if("function"==typeof t)throw new Error("compressConfig: function at ".concat(n.join(".")," should be converted to JsonLogic"));return t}},o=0,i=Kv;o<i.length;o++){var a=i[o];if("ctx"===a);else if("fields"===a)r[a]=xv()(r[a]),n(r[a],{},[a]);else if("funcs"===a)for(var s in r[a]=xv()(r[a]||{}),r[a])n(r[a][s],null,[a,s],{BasicFuncs:h});else r[a]=xv()(r[a]),n(r[a],t[a],[a])}return r},rh=function(e,t,r){if(!e.settings.useConfigCompress)throw new Error("Please enable `useConfigCompress` in config settings to use decompressConfig()");for(var n={},o=function e(t,r,n){if(eh(r))for(var o in eh(t)||(t={}),r)Object.prototype.hasOwnProperty.call(r,o)&&("$$deleted"===r[o]?delete t[o]:t[o]=e(t[o],r[o],[].concat(so(n),[o])));else t=Array.isArray(r)?xv()(r):r;return t},i=function e(t,r,n){var i=!1;if(eh(t)&&Object.prototype.hasOwnProperty.call(t,"$$key")&&t.$$key){var a=kh({funcs:n.BasicFuncs},t.$$key,"funcs","subfields");if(!a)throw new Error("decompressConfig: basic function not found by key ".concat(t.$$key," at ").concat(r.join(".")));delete t.$$key,t=o(xv()(a),t,r),i=!0}if(!i)if(eh(t))for(var s in t)Object.prototype.hasOwnProperty.call(t,s)&&(t[s]=e(t[s],[].concat(so(r),[s]),n));else if(Array.isArray(t)){var l,u=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Uv(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Uv(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(t);try{for(u.s();!(l=u.n()).done;){var c=l.value;t[c]=e(t[c],[].concat(so(r),[c]),n)}}catch(e){u.e(e)}finally{u.f()}}return t},a=0,s=Kv;a<s.length;a++){var l=s[a];"ctx"===l?n[l]=Lv()({},t.ctx||{},r||{}):"funcs"===l?(n[l]=xv()(e[l]||{}),i(n[l],[l],{BasicFuncs:h})):"fields"===l?n[l]=xv()(e[l]||{}):(n[l]=xv()(t[l]||{}),o(n[l],e[l]||{},[l]))}return n},nh=function(e){return e.__compliled||(oh(e=xv()(e),e,{ctx:e.ctx},Zv,[]),Object.defineProperty(e,"__compliled",{enumerable:!1,writable:!1,value:!0})),e};function oh(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:[];if(t)for(var a in i.length,n){var s=n[a],l="x"===a?i:[].concat(so(i),[a]);if("r"===s.type){var u=t,c=u[a];if(s.isArr)for(var d in c){var p=sh(c[d],r,[].concat(so(l),[d]));p!==c[d]&&(o.push("Compiled ".concat(l.join("."),"[").concat(d,"]")),c[d]=p)}else{var f=sh(c,r,l,void 0);f!==c&&(o.push("Compiled R ".concat(l.join("."))),u[a]=f)}}else if("rf"===s.type){var v=t,h=v[a],g=ih(h,r,l,s.ignore);g!==h&&(o.push("Compiled JL-RF ".concat(l.join("."))),v[a]=g)}else if("f"===s.type){var y,m=t,b=m[a],E=ah(b,r,l,s.args,s.ignore);s.invokeWith&&E&&"function"==typeof E&&(E=(y=E).call.apply(y,[null].concat(so(s.invokeWith)))),E!==b&&(o.push("Compiled JL-F ".concat(l.join("."))),m[a]=E)}else if("x"===a)for(var O in t){l=[].concat(so(i),[O]);var S=t[O];oh(e,S,r,s,o,l),S.subfields&&oh(e,S.subfields,r,n,o,l)}else oh(e,t[a],r,s,o,l)}}function ih(e,t,r){return Hl(e)?function(n,o){o=o||(null==t?void 0:t.ctx);var i=$v(e,{props:n,ctx:o},r);return"string"==typeof i&&(i={type:i,props:n}),sh(i,{ctx:o},r)}:"string"==typeof e?function(n,o){o=o||(null==t?void 0:t.ctx);var i=e.split(".").reduce((function(e,t){return null==e?void 0:e[t]}),o);return i?qv(this,i,[n,o],r):sh({type:e,props:n},{ctx:o},r)}:e}function ah(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:void 0;return Hl(e)&&"jl"!==o?function(){for(var o=arguments.length,i=new Array(o),a=0;a<o;a++)i[a]=arguments[a];var s=this||(null==t?void 0:t.ctx),l=(n||[]).reduce((function(e,t,r){return Gv(Gv({},e),{},eo({},t,i[r]))}),{args:i,ctx:s});return $v(e,l,r)}.bind(null==t?void 0:t.ctx):"string"==typeof e&&"string"!==o?function(){var n=this||(null==t?void 0:t.ctx),o=e.split(".").reduce((function(e,t){return null==e?void 0:e[t]}),n);if(o){for(var i=arguments.length,a=new Array(i),s=0;s<i;s++)a[s]=arguments[s];return qv(this,o,a,r)}throw new Error("".concat(r.join(".")," :: Function ").concat(e," is not found in ctx"))}.bind(null==t?void 0:t.ctx):e}function sh(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:void 0;if(zl(e)){var o,i=e.type,a=e.props;if("string"!=typeof i)throw new Error("renderReactElement for ".concat(r.join("."),": type should be string"));var s,l=function(e,t){var r;return(null==t||null===(r=t.components)||void 0===r?void 0:r[e])||t.W[e]||t.O[e]}(i,t.ctx)||i.toLowerCase();return void 0!==n&&(a=Gv(Gv({},a),{},{key:n})),null!==(o=a)&&void 0!==o&&o.children&&(s=sh(a.children,t,r),a=Gv(Gv({},a),{},{children:s})),t.ctx.RCE(l,a)}return e instanceof Array?e.map((function(e,n){return sh(e,t,r,""+n)})):e}var lh=p(2815),uh=p.n(lh),ch={reverseOperatorsForNot:!1,canShortMongoQuery:!0,formatField:function(e,t,r,n,o,i){return i?r:e},caseValueField:{type:"case_value"},fieldSources:["field"],keepInputOnChangeFieldSrc:!0,fieldItemKeysForSearch:["label","path","altLabel","grouplabel"],listKeysForSearch:["title","value"],valueSourcesInfo:{value:{}},fieldSeparator:".",fieldSeparatorDisplay:".",canReorder:!0,canRegroup:!0,canDeleteLocked:!1,canLeaveEmptyGroup:!0,shouldCreateEmptyGroup:!1,exportPreserveGroups:!1,removeEmptyGroupsOnLoad:!0,removeEmptyRulesOnLoad:!0,removeIncompleteRulesOnLoad:!1,removeInvalidMultiSelectValuesOnLoad:!0,showErrorMessage:!1,setOpOnChangeField:["keep","default"],groupOperators:["some","all","none"],defaultGroupConjunction:"AND",locale:{moment:"en"},valueLabel:"Value",valuePlaceholder:"Value",fieldLabel:"Field",operatorLabel:"Operator",funcLabel:"Function",fieldPlaceholder:"Select field",funcPlaceholder:"Select function",operatorPlaceholder:"Select operator",lockLabel:"Lock",lockedLabel:"Locked",deleteLabel:"Delete",addGroupLabel:"Add group",addCaseLabel:"Add condition",addDefaultCaseLabel:"Add default condition",defaultCaseLabel:"Default:",addRuleLabel:"Add rule",addSubRuleLabel:"Add sub rule",delGroupLabel:"Delete",notLabel:"Not",fieldSourcesPopupTitle:"Select source",valueSourcesPopupTitle:"Select value source",removeRuleConfirmOptions:null,removeGroupConfirmOptions:null};function dh(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return ph(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?ph(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function ph(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var fh,vh=0,hh=0,gh={},yh=function(){return fh||(fh=bh({reactIndex:void 0,maxSize:3,canCompile:void 0})),fh},mh=function(e,t){var r;for(var n in gh){var o=gh[n].findExtendedConfig(e,t);if(o){r=o;break}}return r},bh=function(){var e,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{reactIndex:void 0,maxSize:2,canCompile:!0},r=new Map,n=t.maxSize||2,o=++vh,i=function(e,t){r.size+1>n&&r.delete(r.keys().next().value),r.set(e,t)},a=function(e,t){var n,o=dh(r.keys());try{var i,a=function(){var o=n.value;if(Kv.filter((function(t){return o[t]===e[t]})).length===Kv.length&&(!t||o.__compliled))return{v:r.get(o)}};for(o.s();!(n=o.n()).done;)if(i=a())return i.v}catch(e){o.e(e)}finally{o.f()}var s,l=dh(r.values());try{var u,c=function(){var r=s.value;if(Kv.filter((function(t){return r[t]===e[t]})).length===Kv.length&&(!t||r.__compliled))return{v:r}};for(l.s();!(s=l.n()).done;)if(u=c())return u.v}catch(e){l.e(e)}finally{l.f()}return null};return e={getExtendedConfig:function(e){return r=function(e){return iu()(e,Kv)}(e),a(r)||function(e){var r=_h(e,++hh,t.canCompile);return i(e,r),r}(r);var r},findExtendedConfig:a,getBasicConfig:function(e){var t,n=dh(r.keys());try{var o,i=function(){var n=t.value,o=r.get(n);if(0===Kv.map((function(t){return o[t]===e[t]})).filter((function(e){return!e})).length)return{v:n}};for(n.s();!(t=n.n()).done;)if(o=i())return o.v}catch(e){n.e(e)}finally{n.f()}return e},clearConfigMemo:function(){r.clear(),delete gh[o],fh===e&&(fh=void 0)},configId:hh,storeConfigPair:i,getSize:function(){return r.size},configStore:r,memoId:o,meta:t},void 0===t.reactIndex&&(fh=e),gh[o]=e,e};function Eh(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Oh(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Oh(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Oh(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Sh(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Th(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Sh(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Sh(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var _h=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(r=r&&e.settings.useConfigCompress,e.__configId)return e;var n=mh(e,r);if(n)return n;var o=e;(e=r?e.__compliled?xv()(e):nh(e):xv()(e)).settings=uh()({},ch,e.settings,ql),e.__fieldsCntByType={},e.__funcsCntByType={},e.__fieldNames={},function(e,t){for(var r in e)wh(0,e[r],t)}(e.types,e),Rh(e.fields,e),Ih(e.funcs,e);var i=e.settings.caseValueField;i&&Ah(i,e,[],!1,!0);var a=e.settings.locale.moment;return a&&qu().locale(a),Object.defineProperty(e,"__configId",{enumerable:!1,writable:!1,value:t||Cl()}),e.__cache={},Xl(e),yh().storeConfigPair(o,e),e};function wh(e,t,r){var n=null,o=null;t.mainWidget=t.mainWidget||Object.keys(t.widgets).filter((function(e){return"field"!=e&&"func"!=e}))[0];var i=t.excludeOperators||[];for(var a in t.widgets){var s=t.widgets[a],l=s.defaultOperator;s.operators&&(n=Ql(n,s.operators.filter((function(e){return!i.includes(e)})))),l&&!i.includes(l)&&(o&&a!==t.mainWidget||(o=l)),a==t.mainWidget&&(s.widgetProps=Th(Th({},t.mainWidgetProps||{}),s.widgetProps||{})),t.widgets[a]=s}t.valueSources||(t.valueSources=Object.keys(r.settings.valueSourcesInfo));var u,c=Eh(t.valueSources);try{for(c.s();!(u=c.n()).done;){var d=u.value;"value"==d||t.widgets[d]||(t.widgets[d]={})}}catch(e){c.e(e)}finally{c.f()}!t.operators&&n&&(t.operators=Array.from(new Set(n))),!t.defaultOperator&&o&&(t.defaultOperator=o)}function Rh(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];for(var n in e){var o=[].concat(so(r),[n]);Ah(e[n],t,o),e[n].subfields&&Rh(e[n].subfields,t,o)}}function Ih(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];if(e){var o=(null==t||null===(r=t.settings)||void 0===r?void 0:r.fieldSeparator)||".";for(var i in e){var a=[].concat(so(n),[i]),s=a.join(o),l=e[i];if(l.returnType&&(l.type=l.returnType,t.__funcsCntByType[l.returnType]||(t.__funcsCntByType[l.returnType]=0),t.__funcsCntByType[l.returnType]++),Ah(l,t,a,!1),l.args){for(var u in l.args)Ah(l.args[u],t,[].concat(so(a),[u]),!0);var c,d=!0,p=Eh(Object.keys(l.args).reverse());try{for(p.s();!(c=p.n()).done;){var f=c.value,v=l.args[f];!d&&v.isOptional&&(tu.info("Arg ".concat(f," for func ").concat(s," can't be optional")),delete v.isOptional),v.isOptional||(d=!1)}}catch(e){p.e(e)}finally{p.f()}}l.subfields&&Ih(l.subfields,t,[].concat(so(n),[i]))}}}function Ah(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[],o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=arguments.length>4&&void 0!==arguments[4]&&arguments[4],a=t.settings,s=a.showLabels,l=a.fieldSeparator;l=null!==(r=l)&&void 0!==r?r:".";var u=n[n.length-1],c=o?n.slice(0,n.length-1).join(l):n.join(l),d=!!e.returnType,p=e.type||e.returnType,f=t.types[p],v=e.excludeOperators||[],h=(e.operators||(null==f?void 0:f.operators)||[]).filter((function(e){return!v.includes(e)})),g=e.defaultOperator||(null==f?void 0:f.defaultOperator);v.includes(g)&&(g=void 0);var y=!!g&&g==e.defaultOperator;if(y&&(e.ownDefaultOperator=e.defaultOperator),f){o||d||i||(t.__fieldsCntByType[p]||(t.__fieldsCntByType[p]=0),t.__fieldsCntByType[p]++),o&&(e._isFuncArg=!0,e._argKey=u,e._funcKey=c),d&&(e._isFunc=!0,e._funcKey=c),i&&(e._isCaseValue=!0),function(e,t,r){for(var n,o,i=0,a=["listValues","treeValues","allowCustomValues","validateValue"];i<a.length;i++){var s=a[i];e[s]&&(e.fieldSettings||(e.fieldSettings={}),e.fieldSettings[s]=e[s],delete e[s])}null!==(n=e.fieldSettings)&&void 0!==n&&n.listValues&&t.settings.normalizeListValues&&(e.fieldSettings.listValues=t.settings.normalizeListValues.call(t.ctx,e.fieldSettings.listValues,r,e.fieldSettings)),null!==(o=e.fieldSettings)&&void 0!==o&&o.treeValues&&t.settings.normalizeListValues&&(e.fieldSettings.treeValues=t.settings.normalizeListValues.call(t.ctx,e.fieldSettings.treeValues,r,e.fieldSettings))}(e,t,p);var m=["widgets","operators","defaultOperator"];Object.keys(f).filter((function(e){return!m.includes(e)})).map((function(t){e[t]||(e[t]=jl(f[t]))}));var b=f.excludeOperators||[];e.operators&&(b=b.filter((function(t){return!e.operators.includes(t)}))),e.widgets||(e.widgets={});var E=function(){var t=Th({},e.widgets[O]||{}),r=f.widgets[O]||{};if(!o){var n=t.defaultOperator,i=[].concat(so(v),so(b)),a=e.preferWidgets&&("field"===O||e.preferWidgets.includes(O))||i.length>0;if(t.operators){var l=t.operators.filter((function(e){return!i.includes(e)}));t.operators=l,h=Ql(h,l)}else if(a&&r.operators){var c=r.operators.filter((function(e){return!i.includes(e)}));t.operators=c,h=Ql(h,c)}n&&!i.includes(n)&&(g&&(y||O!==e.mainWidget)||(g=n))}O===e.mainWidget?t.widgetProps=Th(Th(Th({},r.widgetProps||{}),e.mainWidgetProps||{}),t.widgetProps||{}):t.widgetProps=Th(Th({},r.widgetProps||{}),t.widgetProps||{});var d=Array.from(new Set([].concat(so(Object.keys(r.opProps||{})),so(Object.keys(t.opProps||{})))));if(d.length){var p,m={},E=Eh(d);try{for(E.s();!(p=E.n()).done;){var S,T,_=p.value;m[_]=Th(Th({},(null===(S=r.opProps)||void 0===S?void 0:S[_])||{}),(null===(T=t.opProps)||void 0===T?void 0:T[_])||{})}}catch(e){E.e(e)}finally{E.f()}t.opProps=m}var w=t,R=w.valueLabel,I=w.valuePlaceholder;o&&(R||(t.valueLabel=e.label||u),I||s||(t.valuePlaceholder=e.label||u)),t=Th(Th({},r),t),e.widgets[O]=t};for(var O in f.widgets)E();if(o||(e.operators||(e.operators=Array.from(new Set(h))),e.defaultOperator||(e.defaultOperator=g)),!o&&!d&&!i){var S=function(e,t){if(!t)return{};var r=e.settings.fieldSeparator,n=so(t).reduce((function(t,n,o,i){var a=t.computedPath,s=t.computed,l=t.inGroup,u=[].concat(so(i.slice(0,o)),[n]),c=kh(e,u);return"!group"===(null==c?void 0:c.type)&&o<i.length-1?(l=u.join(r),a=[]):null!=c&&c.fieldName?(s=!0,a=[c.fieldName]):a=[].concat(so(a),[n]),{computedPath:a,computed:s,inGroup:l}}),{computedPath:[],computed:!1,inGroup:void 0}),o=n.computedPath,i=n.computed,a=n.inGroup;return i?{fieldName:o.join(r),inGroup:a}:{}}(t,n),T=S.fieldName,_=S.inGroup;T&&(e.fieldName=T,t.__fieldNames[T]||(t.__fieldNames[T]=[]),t.__fieldNames[T].push({fullPath:n,inGroup:_}))}}else e.disabled=!0}function Ch(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Nh(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Ch(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Ch(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Lh=nu().mark(jh),Ph=nu().mark(Fh),xh=Ll;function jh(e){return nu().wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return t.delegateYield(Dh(e,e.funcs||{},[]),"t0",1);case 1:case"end":return t.stop()}}),Lh)}function Fh(e){return nu().wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return t.delegateYield(Dh(e,e.fields||{},[]),"t0",1);case 1:case"end":return t.stop()}}),Ph)}function Dh(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"subfields";return nu().mark((function o(i){var a,s,l;return nu().wrap((function(o){for(;;)switch(o.prev=o.next){case 0:a=(null==e||null===(i=e.settings)||void 0===i?void 0:i.fieldSeparator)||".",o.t0=nu().keys(t);case 2:if((o.t1=o.t0()).done){o.next=13;break}if(s=o.t1.value,!(l=t[s])[n]){o.next=9;break}return o.delegateYield(Dh(e,l[n],[].concat(so(r),[s]),n),"t2",7);case 7:o.next=11;break;case 9:return o.next=11,[[].concat(so(r),[s]).join(a),l];case 11:o.next=2;break;case 13:case"end":return o.stop()}}),o)}))()}var kh=function(e,t){var r,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"fields",i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"subfields";if(!t)return null;if("!case_value"===t)return null==e||null===(n=e.settings)||void 0===n?void 0:n.caseValueField;var a=(null==e||null===(r=e.settings)||void 0===r?void 0:r.fieldSeparator)||".",s=qh(t,e),l=e[o];if(!l)return null;for(var u=l,c=null,d=[],p=0;p<s.length;p++){var f=s[p];d.push(f),c=u[d.join(a)],p<s.length-1&&(c&&c[i]?(u=c[i],d=[]):c=null)}return c},Mh=function(e,t){var r,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,i=e.settings.fieldSeparator,a=[o].concat(so(t.split(i))).filter((function(e){return null!=e})),s=t;return((null===(r=e.__fieldNames[s])||void 0===r||null===(n=r.find)||void 0===n||null===(n=n.call(r,(function(e){var t=e.inGroup;return!t||(null==o?void 0:o.startsWith(t))})))||void 0===n?void 0:n.fullPath)||a).join(i)},Vh=function(e,t){if(!t)return null;var r=kh(e,t,"funcs","subfields");if(!r)return null;var n=r.returnType,o=r.args;return{returnType:n,args:Object.fromEntries(Object.entries(o||{}).map((function(e){var t=io(e,2),r=t[0],n=t[1];return[r,iu()(n,["type","valueSources","defaultValue","fieldSettings","isOptional","_funcKey","_argKey","_isFuncArg"])]})))}},Uh=function(e,t){return t&&kh(e,t,"funcs","subfields")||null},Bh=function(e,t,r){var n=Uh(e,t);return n&&(n.args&&n.args[r]||null)||null},Gh=function(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!t)return!1;var o=(null==n||null===(r=n.settings)||void 0===r?void 0:r.fieldSeparator)||".",i=$h(e,n),a=$h(t,n);return i.startsWith(a+o)},$h=function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if("string"==typeof e)return e;var n=(null==r||null===(t=r.settings)||void 0===t?void 0:t.fieldSeparator)||".";return qh(e,r).join(n)},qh=function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if(!e)return[];if(Array.isArray(e))return e;var i,a=(null==o||null===(t=o.settings)||void 0===t?void 0:t.fieldSeparator)||".";return null!=e&&e.func?Array.isArray(e.func)?e.func:e.func.split(a):null!=e&&null!==(r=e.get)&&void 0!==r&&r.call(e,"func")?null==e||null===(i=e.get)||void 0===i?void 0:i.call(e,"func").split(a):(null==e||null===(n=e.split)||void 0===n?void 0:n.call(e,a))||[]},Kh=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(!e)return null;var n=t.settings.fieldSeparator,o=qh(e,t);return r?o:o.map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return e.join(n)}))},Wh=function(e){var t;if("string"==typeof e||Array.isArray(e))return"field:".concat($h(e));if("object"===Wn(e)&&e){if(e._funcKey&&e._argKey)return"arg:".concat($h(e._funcKey),"__").concat(e._argKey);if(e._funcKey)return"func:".concat($h(e._funcKey));if(e.func&&e.arg)return"arg:".concat($h(e.func),"__").concat(e.arg);if(e.func)return"func:".concat($h(e.func));if(e.type)return null}return null!=e&&null!==(t=e.get)&&void 0!==t&&t.call(e,"func")?null!=e&&e.get("arg")?"arg:".concat($h(e.get("func")),"__").concat(e.get("arg")):"func:".concat($h(e.get("func"))):null},zh=function(e,t,r){var n;return null===(n=e.__cache)||void 0===n||null===(n=n[t])||void 0===n?void 0:n[r]},Hh=function(e,t,r,n){e.__cache&&r&&(e.__cache[t]||(e.__cache[t]={}),e.__cache[t][r]=n)},Yh=function(e){var t;if(!e)return null;if("object"===Wn(e)){if(!e.func&&e.type)return"field";if(e.func)return e.func&&e.arg?null:"func"}return null!=e&&null!==(t=e.get)&&void 0!==t&&t.call(e,"func")?null!=e&&e.get("arg")?null:"func":"field"},Qh=function(e,t){var r;if(!t)return null;if("object"==Wn(t)){if(!t.func&&t.type)return t;if(t.func)return t.func&&t.arg?Bh(e,t.func,t.arg):Uh(e,t.func)}return null!=t&&null!==(r=t.get)&&void 0!==r&&r.call(t,"func")?null!=t&&t.get("arg")?Bh(e,t.get("func"),t.get("arg")):Uh(e,t.get("func")):kh(e,t)||null},Xh=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!t)return null;var n=e.operators[t];if(r){var o,i,a=Wh(r),s=a?"".concat(a,"__").concat(t):null,l=zh(e,"getOperatorConfig",s);if(l)return l;var u=Qh(e,r),c=yv(e,r,t,null),d=e.widgets[c]||{},p=(u&&u.widgets?u.widgets[c]:{})||{},f=(null===(o=d.opProps)||void 0===o?void 0:o[t])||{},v=(null===(i=p.opProps)||void 0===i?void 0:i[t])||{},h=Nh(Nh(Nh({},n),f),v);return Hh(e,"getOperatorConfig",s,h),h}return n},Jh=function(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{};if(!t)return null;var s=Qh(e,t),l=Wh(t);o||(o=yv(e,t,n,i));var u=l?"".concat(l,"__").concat(n,"__").concat(o,"__").concat(i):null,c=zh(e,"getFieldWidgetConfig",u);if(c)return c;var d=e.widgets[o]||{},p=(null==s||null===(r=s.widgets)||void 0===r?void 0:r[o])||{},f=p.widgetProps||{},v="value"!==i&&i?{}:null==s?void 0:s.fieldSettings,h=Nh(Nh(Nh(Nh({},d),p),f),v);return Hh(e,"getFieldWidgetConfig",u,h),a.forExport&&(h=Fl(h,"factory")),h},Zh=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=e.settings.fieldSeparator,n=qh(t,e),o=t?kh(e,t):e,i=null,a=[];do{var s,l=o===e?e.fields:null===(s=o)||void 0===s?void 0:s.subfields;if(!l||!Object.keys(l).length){o=i=null;break}i=Object.keys(l)[0],a.push(i),o=l[i]}while("!struct"==o.type||"!group"==o.type);return(n||[]).concat(a).join(r)};function eg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function tg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?eg(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):eg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var rg=function(e,t){var r={usedFields:[]},n=ng(e,t,r);if(n)return tg(tg({},n),r)},ng=function(e,t,r){if(e){var n=e.get("type"),o=e.get("children1");return("group"===n||"rule_group"===n)&&o&&o.size?og(e,t,r):"rule"===n?ig(e,t,r):void 0}},og=function(e,t,r){var n=e.get("properties")||new Ua,o=e.get("children1"),i=e.get("id"),a=o.map((function(e){return ng(e,t,r)})).filter((function(e){return void 0!==e}));if(a.size){var s=n.get("conjunction");s||(s=Pd(t));var l=n.get("not");return{id:i,rules:a.toList(),condition:s.toUpperCase(),not:l}}},ig=function(e,t,r){var n,o=e.get("properties")||new Ua,i=e.get("id"),a=o.get("operator"),s=o.get("operatorOptions"),l=o.get("field"),u=o.get("value"),c=o.get("valueSrc"),d=o.get("valueType"),p=u.filter((function(e){return void 0===e})).size>0;if(null!=l&&null!=a&&!p){var f=Qh(t,l)||{},v=Xh(t,a,l)||{},h=f.type||"undefined",g=Dl(v),y=t.types[f.type]||{},m=mv(l,t,r);if(!(u.size<g)){-1==r.usedFields.indexOf(l)&&r.usedFields.push(l),u=u.toArray(),c=c.toArray(),d=(null===(n=d)||void 0===n?void 0:n.toArray())||[];for(var b=[],E=0;E<u.length;E++){var O={type:d[E],value:u[E]};if(b.push(O),"field"==c[E]){var S=u[E];-1==r.usedFields.indexOf(S)&&r.usedFields.push(S)}}var T=s?s.toJS():null;T&&!Object.keys(T).length&&(T=null);var _={id:i,fieldName:m,type:h,input:y.mainWidget,operator:a};return T&&(_.operatorOptions=T),_.values=b,_}}};function ag(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function sg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?ag(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):ag(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function lg(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return ug(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?ug(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function ug(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var cg=function(e,t){var r,n={usedFields:[],errors:[]},o=_h(t,void 0,!1),i=dg(e,o,n,!1,!0),a=n.errors,s=n.usedFields,l=(o.settings.fieldSeparator,{}),u=lg(s);try{for(u.s();!(r=u.n()).done;)for(var c=r.value,d=qh(c,t),p=(Qh(o,c),l),f=0;f<d.length;f++){var v=d[f],h=Qh(o,d.slice(0,f+1))||{};f!=d.length-1?"!group"==h.type&&"struct"!=h.mode?(p[v]||(p[v]=[{}]),p=p[v][0]):(p[v]||(p[v]={}),p=p[v]):p[v]||(p[v]=null)}}catch(e){u.e(e)}finally{u.f()}return{errors:a,logic:i,data:l}},dg=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;if(e){var a,s=e.get("type"),l=(e.get("properties")||new Ua).get("isLocked"),u=t.settings.jsonLogic.lockedOp;return"group"===s||"rule_group"===s?a=pg(e,t,r,n,o,i):"rule"===s?a=fg(e,t,r,n,i):"switch_group"==s?a=vg(e,t,r,n):"case_group"==s&&(a=hg(e,t,r,n,i)),l&&a&&u&&(a=eo({},u,a)),a}},pg=function(e,t,r){var n,o,i,a,s,l,u=arguments.length>3&&void 0!==arguments[3]&&arguments[3],c=arguments.length>4&&void 0!==arguments[4]&&arguments[4],d=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,p=e.get("type"),f=e.get("properties")||new Ua,v=f.get("mode"),h=e.get("children1")||new cs,g=f.get("field"),y=Qh(t,g),m=f.get("conjunction");m||(m=Pd(t));var b=t.conjunctions[m].jsonLogicConj||m.toLowerCase(),E=!!f.get("not"),O="rule_group"===p&&!c,S=O&&"struct"!=v,T=S?g:d,_=f.get("operator"),w=_&&Xh(t,_,g)||null,R=gg(t,f,r,_,d),I=O&&(!_||0==(null===(n=w)||void 0===n?void 0:n.cardinality)),A=O&&(null==h?void 0:h.size)>0,C=(O&&null!=h&&h.size,E),N=!1;A?(N=E,C=u):u&&(C=!C);var L=!1,P=null===(o=w)||void 0===o?void 0:o.reversedOp,x=Xh(t,P,g),j=!(null!==(i=w)&&void 0!==i&&i.jsonLogic||null===(a=x)||void 0===a||!a.jsonLogic),F=!(null===(s=x)||void 0===s||!s.jsonLogic),D=null===(l=Cv(e))||void 0===l?void 0:l.get("type");if(!!t.settings.reverseOperatorsForNot&&(!O&&C&&"rule"===D||N&&1===(null==h?void 0:h.size))&&(A?N=!N:C=!C,L=!0),C&&O&&F&&(t.settings.reverseOperatorsForNot||j)){C=!C;var k=[P,_];_=k[0],P=k[1];var M=[x,w];w=M[0],x=M[1]}var V=h.map((function(e){return dg(e,t,r,L,!1,T)})).filter((function(e){return void 0!==e})),U=!!t.settings.exportPreserveGroups;if(S&&!I){if(null==R)return}else if(!V.size&&!U)return;var B=c||U||1!=V.size;B||!E||L||(B=h.some((function(e){var r,n,o,i,a=null===(r=e.get("properties"))||void 0===r?void 0:r.get("operator"),s=null===(n=t.operators)||void 0===n||null===(n=n[a])||void 0===n?void 0:n.reversedOp;return null!==(o=null===(i=t.operators)||void 0===i||null===(i=i[s])||void 0===i?void 0:i._jsonLogicIsExclamationOp)&&void 0!==o&&o})));var G={};if(B?G[b]=V.toList().toJS():G=V.first(),N&&(G={"!":G}),S){var $=bg(r,t,g,d);if(I)G=eo({},_||"some",[$,G]);else{var q=V.size?{filter:[$,G]}:$;G=Eg(t,f,{reduce:[q,{"+":[1,{var:"accumulator"}]},0]},R,_,null,y)}}return C&&(G={"!":G}),G},fg=function(e,t,r){var n,o,i,a,s,l,u=arguments.length>3&&void 0!==arguments[3]&&arguments[3],c=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,d=e.get("properties")||new Ua,p=d.get("field"),f=d.get("fieldSrc"),v=d.get("operator"),h=d.get("operatorOptions");if((h=h?h.toJS():null)&&!Object.keys(h).length&&(h=null),null!=p&&null!=v){var g=Qh(t,p),y=Xh(t,v,p),m=null===(n=y)||void 0===n?void 0:n.reversedOp,b=Xh(t,m,p);if(null!==(o=y)&&void 0!==o&&o.jsonLogic||null!==(i=b)&&void 0!==i&&i.jsonLogic){var E=u,O=!(null!==(a=y)&&void 0!==a&&a.jsonLogic||null===(s=b)||void 0===s||!s.jsonLogic),S=!(null===(l=b)||void 0===l||!l.jsonLogic)&&(!!t.settings.reverseOperatorsForNot||O);if(E&&S||O){E=!E;var T=[m,v];v=T[0],m=T[1];var _=[b,y];y=_[0],b=_[1]}var w=gg(t,d,r,v,c);if(void 0!==w){var R="func"===f?mg(r,t,p,c):bg(r,t,p,c);if(void 0!==R)return Eg(t,d,R,w,v,h,g,E)}}else r.errors.push("Operator ".concat(v," is not supported"))}},vg=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=e.get("children1");if(o){for(var i=o.map((function(e){return hg(e,t,r,n,null)})).filter((function(e){return void 0!==e})).valueSeq().toArray(),a=[],s=0;s<i.length;s++)s===i.length-1||i[s][0]?(a.push(i[s]),s===i.length-1&&i[s][0]&&a.push([void 0,null])):r.errors.push("No condition for case ".concat(s));if(a.length){if(1===a.length){var l=io(a[0],2),u=(l[0],l[1]);return null==u&&(u=null),u}for(var c={if:[]},d=c.if,p=io(a[a.length-1],2),f=(p[0],p[1]),v=0;v<a.length-1;v++){var h=v===a.length-2,g=io(a[v],2),y=g[0],m=g[1];null==m&&(m=null),null==y&&(y=!0),d.push(y),d.push(m),h?d.push(f):(d.push({if:[]}),d=d[d.length-1].if)}return c}}},hg=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,i=e.get("type");if("case_group"==i){var a=e.get("properties")||new Ua;return[pg(e,t,r,n,o),gg(t,a,r,null,o,"!case_value")]}r.errors.push("Unexpected child of type ".concat(i," inside switch"))},gg=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=t.get("field"),s=t.get("valueSrc"),l=t.get("valueType");("!case_value"==i||l&&"case_value"==l.get(0))&&(a="!case_value");var u=Qh(e,a),c=Xh(e,n,a),d=Dl(c),p=t.get("value"),f=t.get("asyncListValues");if(null!=p){var v=[],h=[],g=r.usedFields,y=p.map((function(t,i){var d=s?s.get(i):null,p=l?l.get(i):null,g=Av(t,d,e),y=yv(e,a,n,d),m=Jh(e,a,n,y,d,{forExport:!0}),b=yg(r,e,g,d,p,m,u,n,c,o,f);return void 0!==b&&(v.push(d),h.push(p)),b})),m=y.filter((function(e){return void 0===e})).size>0;if(!(y.size<d||m))return d>1?y.toArray():1==d?y.first():null;r.usedFields=g}},yg=function(e,t,r,n,o,i,a,s,l){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,c=arguments.length>10?arguments[10]:void 0;if(void 0!==r){var d;if("field"==n)d=bg(e,t,r,u);else if("func"==n)d=mg(e,t,r,u);else if("function"==typeof(null==i?void 0:i.jsonLogic)){var p=i.jsonLogic,f=[r,sg(sg({},a?iu()(a,["fieldSettings","listValues"]):{}),{},{asyncListValues:c}),Fl(i,Ll)];s&&(f.push(s),f.push(l)),d=p.call.apply(p,[t.ctx].concat(f))}else d=r;return d}},mg=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),s=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),l=Uh(t,a),u=qh(a,t),c=u[u.length-1];if(l)if(null!=l&&l.jsonLogic){var d={},p=[],f=[];for(var v in l.args){var h,g=l.args[v],y=Qh(t,g),m=g.defaultValue,b=g.isOptional,E=null!=m&&m.func?"func":"value",O=s?s.get(v):void 0,S=O?O.get("value"):void 0,T=O?O.get("valueSrc"):void 0;"func"!==T&&null!==(h=S)&&void 0!==h&&h.toJS&&(S=S.toJS());var _=null,w=yv(t,g,_,T),R=Jh(t,g,_,w,T,{forExport:!0}),I=yg(e,t,S,T,g.type,R,y,null,null,i);if(null!=S&&void 0===I)return void("func"!=T&&e.errors.push("Can't format value of arg ".concat(v," for func ").concat(a)));var A=void 0;if(void 0===I&&!b&&null!=m){var C=yv(t,g,_,E),N=Jh(t,g,_,C,E,{forExport:!0});if(void 0===(A=yg(e,t,m,E,g.type,N,y,null,null,i)))return void("func"!=E&&e.errors.push("Can't format default value of arg ".concat(v," for func ").concat(a)))}var L=null!=I?I:A;if(void 0!==L){if(p.length){var P,x=lg(p);try{for(x.s();!(P=x.n()).done;)d[P.value]=void 0}catch(e){x.e(e)}finally{x.f()}p=[]}d[v]=L}else b||f.push(v),p.push(v)}if(!f.length){var j,F=Object.values(d);if("function"==typeof l.jsonLogic){var D=l.jsonLogic,k=[d];j=D.call.apply(D,[t.ctx].concat(k))}else{var M=l.jsonLogic||c;if(l.jsonLogicIsMethod){var V=F[0],U=F.slice(1);j=U.length?{method:[V,M,U]}:{method:[V,M]}}else j=eo({},M,F)}return j}}else e.errors.push("Func ".concat(a," is not supported"));else e.errors.push("Func ".concat(a," is not defined in config"))},bg=function(e,t,r){var n,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=t.settings,a=i.fieldSeparator,s=i.jsonLogic;if(r){Array.isArray(r)&&(r=r.join(a));var l=Qh(t,r)||{},u=mv(r,t,e,o);n=eo({},l.jsonLogicVar||("!group"==l.type?s.groupVarKey:"var"),u),-1==e.usedFields.indexOf(r)&&e.usedFields.push(r)}return n},Eg=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,s=arguments.length>7&&void 0!==arguments[7]&&arguments[7],l=t.get("field"),u=Xh(e,o,l)||{},c="function"==typeof u.jsonLogic?u.jsonLogic:function(e,t,r,n){var o=e,i=Dl(t);"string"==typeof t.jsonLogic&&(o=t.jsonLogic);var a=["<","<=",">",">="],s=["==","!="];return function(e,t,l,u,c){return 0==i&&s.includes(o)?eo({},o,[r,null]):0==i?eo({},o,r):1==i?eo({},o,[r,n]):2==i&&a.includes(o)?eo({},o,[n[0],r,n[1]]):eo({},o,[r].concat(so(n)))}}(o,u,r,n),d=[r,o,n,Fl(u,Pl),i,a],p=c.call.apply(c,[e.ctx].concat(d));return s&&(p={"!":p}),p};function Og(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Sg(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Sg(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Sg(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Tg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function _g(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Tg(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Tg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var wg=function(e){return"object"==Wn(e)&&null!==e&&!Array.isArray(e)},Rg=function(e,t){return Ig(e,t,!1)},Ig=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=_h(t,void 0,!1),i=Ag([],e,o,n);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to MongoDb:",n.errors),i)},Ag=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:void 0,s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:void 0;if(t){var l=t.get("type");return"group"===l||"rule_group"===l?Cg(e,t,r,n,o,i,a,s):"rule"===l?Ng(e,t,r,n,o,i,a,s):void 0}},Cg=function(e,t,r,n){var o,i,a,s,l,u,c,d,p=arguments.length>4&&void 0!==arguments[4]&&arguments[4],f=t.get("type"),v=t.get("properties")||new Ua,h=!!v.get("not"),g=t.get("children1")||new cs,y=r.settings,m=y.canShortMongoQuery,b=y.fieldSeparator,E=e.filter((function(e){return"rule_group"==e.get("type")})).length>0,O=e.filter((function(e){return"rule_group"==e.get("type")})).map((function(e){return e.get("properties").get("field")})).slice(-1).pop(),S=E&&O,T="rule_group"===f,_=T?v.get("field"):null,w=T?v.get("operator"):null,R=w&&Xh(r,w,_)||null,I=w?null!==(o=null===(i=R)||void 0===i?void 0:i.cardinality)&&void 0!==o?o:1:void 0,A=mv(_,r,n,S),C=(Qh(r,_)||{}).mode,N=_&&"array"===C&&I>=1,L=T&&(null==g?void 0:g.size)>0,P=(T&&null!=g&&g.size,!1),x=h,j=!1;L?(j=h,x=p):p&&(x=!x);var F=null===(a=R)||void 0===a?void 0:a.reversedOp,D=Xh(r,F,_),k=!(null!==(s=R)&&void 0!==s&&s.mongoFormatOp||null===(l=D)||void 0===l||!l.mongoFormatOp),M=!(null===(u=D)||void 0===u||!u.mongoFormatOp),V=null===(c=Cv(t))||void 0===c?void 0:c.get("type");if(!!r.settings.reverseOperatorsForNot&&(!T&&x&&"rule"===V||j&&1===(null==g?void 0:g.size))&&(L?j=!j:x=!x,P=!0),x&&T&&M&&(r.settings.reverseOperatorsForNot||k)){x=!x;var U=[F,w];w=U[0],F=U[1];var B=[D,R];R=B[0],D=B[1]}var G=v.get("conjunction");G||(G=Pd(r));var $=r.conjunctions[G];if($){var q=$.reversedConj;x&&"or"===(null===(d=G)||void 0===d?void 0:d.toLowerCase())&&q&&!T&&r.settings.canShortMongoQuery&&r.settings.reverseOperatorsForNot&&(G=q,$=r.conjunctions[G],x=!x,P=!0);var K=$.mongoConj,W=g.map((function(o){return Ag([].concat(so(e),[t]),o,r,n,P,"array"!=C,"array"==C?function(e){return"$$el".concat(b).concat(e)}:void 0)})).filter((function(e){return void 0!==e}));if(N||W.size){var z;if(1==W.size)z=W.first();else if(W.size>1){var H=W.toList().toJS();m&&"$and"==K&&(z=H.reduce((function(e,t){if(e){for(var r in t){if("$"==r[0]){e=void 0;break}if(null==e[r])e[r]=t[r];else{var n=e[r],o=t[r];if(wg(n)||(n={$eq:n}),wg(o)||(o={$eq:o}),Object.keys(n)[0]==Object.keys(o)[0]){e=void 0;break}e[r]=Object.assign({},n,o)}}return e}}),{})),z||(z=eo({},K,H))}if(_)if("array"==C){var Y={$size:{$ifNull:["$"+A,[]]}},Q=z?{$size:{$ifNull:[{$filter:{input:"$"+A,as:"el",cond:z}},[]]}}:Y;z={$expr:z=Ag(e,t.set("type","rule"),r,n,j,!1,(function(e){return Q}),Y)}}else z=eo({},A,{$elemMatch:z});return x&&(z={$not:z}),z}}},Ng=function(e,t,r,n){var o,i,a,s,l,u,c,d=arguments.length>4&&void 0!==arguments[4]&&arguments[4],p=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],f=arguments.length>6&&void 0!==arguments[6]?arguments[6]:void 0,v=arguments.length>7&&void 0!==arguments[7]?arguments[7]:void 0,h=t.get("properties")||new Ua,g=e.filter((function(e){return"rule_group"==e.get("type")})).length>0,y=e.filter((function(e){return"rule_group"==e.get("type")})).map((function(e){return e.get("properties").get("field")})).slice(-1).pop(),m=g&&y,b=h.get("operator"),E=h.get("operatorOptions"),O=h.get("field"),S=h.get("fieldSrc"),T=h.get("value"),_=h.get("valueSrc"),w=h.get("valueType"),R=h.get("asyncListValues");if(null!=O&&null!=b&&void 0!==T){var I=Qh(r,O),A=Xh(r,b,O),C=null===(o=A)||void 0===o?void 0:o.reversedOp,N=Xh(r,C,O),L=Dl(A);if(null!==(i=A)&&void 0!==i&&i.mongoFormatOp||null!==(a=N)&&void 0!==a&&a.mongoFormatOp){var P,x=d,j=!(null!==(s=A)&&void 0!==s&&s.mongoFormatOp||null===(l=N)||void 0===l||!l.mongoFormatOp);if(null!==(u=N)&&void 0!==u&&u.mongoFormatOp&&(r.settings.reverseOperatorsForNot||j)&&x||j){var F=[C,b];b=F[0],C=F[1];var D=[N,A];A=D[0],N=D[1],x=!x}var k=!1;if("func"==S){var M=io(xg(n,r,O,m),2);P=M[0],k=M[1]}else P=mv(O,r,n,m),f&&(k=!0,P=f(P));if(null!=P){var V,U=[],B=[];if(null!=T){var G=T.map((function(e,t){var o=_?_.get(t):null,i=w?w.get(t):null,a=Av(e,o,r),s=yv(r,O,b,o),l=Jh(r,O,b,s,o,{forExport:!0}),u=io(Lg(n,r,a,o,i,l,I,m,b,A,R),2),c=u[0],d=u[1];return void 0!==c&&(k=k||d,U.push(o),B.push(i)),c})),$=G.filter((function(e){return void 0===e})).size>0;if(G.size<L||$)return;V=L>1?G.toArray():1==L?G.first():null}var q=k&&p,K=null===(c=A)||void 0===c?void 0:c.mongoFormatOp,W=[P,b,void 0!==v&&null==V?v:V,k,U.length>1?U:U[0],B.length>1?B:B[0],Fl(A,Pl),E,I],z=K.call.apply(K,[r.ctx].concat(W));return q&&(z={$expr:z}),x&&(z={$not:z}),z}}else n.errors.push("Operator ".concat(b," is not supported"))}},Lg=function(e,t,r,n,o,i,a,s,l,u,c){if(void 0===r)return[void 0,!1];var d,p=!1;if("field"==n){var f=io(Pg(e,t,r,s),2);d=f[0],p=f[1]}else if("func"==n){var v=io(xg(e,t,r,s),2);d=v[0],p=v[1]}else if("function"==typeof(null==i?void 0:i.mongoFormatValue)){var h=i.mongoFormatValue,g=[r,_g(_g({},a?iu()(a,["fieldSettings","listValues"]):{}),{},{asyncListValues:c}),Fl(i,Ll)];l&&(g.push(l),g.push(u)),d=h.call.apply(h,[t.ctx].concat(g))}else d=r;return[d,p]},Pg=function(e,t,r,n){var o,i=t.settings.fieldSeparator;if(r){var a=Qh(t,r)||{},s=qh(r,t),l=cv(r,t),u=l?l.join(i):null;o="$"+(0,t.settings.formatField)(mv(r,t,e,n),s,u,a,t,!1)}return[o,!0]},xg=function(e,t,r,n){var o,i,a,s=null===(o=r.get)||void 0===o?void 0:o.call(r,"func"),l=null===(i=r.get)||void 0===i?void 0:i.call(r,"args"),u=Uh(t,s);if(!u)return e.errors.push("Func ".concat(s," is not defined in config")),[void 0,!1];var c=qh(s,t),d=c[c.length-1],p=u.mongoFunc||d,f=u.mongoArgsAsObject,v={},h=0,g=void 0,y=[],m=[];for(var b in u.args){var E;h++;var O=u.args[b],S=Qh(t,O),T=O.defaultValue,_=O.isOptional,w=null!=T&&T.func?"func":"value",R=l?l.get(b):void 0,I=R?R.get("value"):void 0,A=R?R.get("valueSrc"):void 0;"func"!==A&&null!==(E=I)&&void 0!==E&&E.toJS&&(I=I.toJS());var C=R?R.get("asyncListValues"):void 0,N=null,L=yv(t,O,N,A),P=Jh(t,O,N,L,A,{forExport:!0}),x=io(Lg(e,t,I,A,O.type,P,S,n,null,null,C),2),j=x[0];if(x[1],null!=I&&void 0===j)return"func"!=A&&e.errors.push("Can't format value of arg ".concat(b," for func ").concat(s)),[void 0,!1];var F=void 0;if(void 0===j&&!_&&null!=T){var D=yv(t,O,N,w),k=Jh(t,O,N,D,w,{forExport:!0}),M=io(Lg(e,t,T,w,O.type,k,S,n,null,null,C),2);if(F=M[0],M[1],void 0===F)return"func"!=w&&e.errors.push("Can't format default value of arg ".concat(b," for func ").concat(s)),[void 0,!1]}var V=null!=j?j:F;if(void 0!==V){if(y.length){var U,B=Og(y);try{for(B.s();!(U=B.n()).done;)v[U.value]=void 0}catch(e){B.e(e)}finally{B.f()}y=[]}v[b]=V,g=V}else _||m.push(b),y.push(b)}if(m.length)return[void 0,!1];if("function"==typeof u.mongoFormatFunc){var G=u.mongoFormatFunc,$=[v];a=G.call.apply(G,[t.ctx].concat($))}else{if(null===u.mongoFormatFunc)return e.errors.push("Functon ".concat(p," is not supported")),[void 0,!1];a=eo({},p,f?v:1==h&&void 0!==g?g:Object.values(v))}return[a,!0]};function jg(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Fg(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Fg(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Fg(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Dg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function kg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Dg(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Dg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Mg=function(e,t){return Vg(e,t,!1)},Vg=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=_h(t,void 0,!1),i=Ug(e,o,n);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to SQL:",n.errors),i)},Ug=function(e,t,r){if(e){var n=e.get("type");return e.get("children1"),"group"===n||"rule_group"===n?Bg(e,t,r):"rule"===n?Gg(e,t,r):void 0}},Bg=function(e,t,r){var n=e.get("type"),o=e.get("properties")||new Ua,i=e.get("children1")||new cs,a="rule_group"===n?o.get("field"):null;"array"==(Qh(t,a)||{}).mode&&r.errors.push("Aggregation is not supported for ".concat(a));var s=o.get("not"),l=i.map((function(e){return Ug(e,t,r)})).filter((function(e){return void 0!==e}));if(l.size){var u=o.get("conjunction");return u||(u=Pd(t)),t.conjunctions[u].sqlFormatConj.call(t.ctx,l,u,s)}},Gg=function(e,t,r){var n=e.get("properties")||new Ua,o=n.get("field"),i=n.get("fieldSrc"),a=n.get("operator"),s=n.get("operatorOptions"),l=n.get("valueSrc"),u=n.get("valueType"),c=n.get("value"),d=n.get("asyncListValues");if(null!=o&&null!=a){var p=Qh(t,o)||{},f=Xh(t,a,o)||{},v=f.reversedOp,h=Xh(t,v,o)||{},g=Dl(f),y=!1,m=f.sqlOp||f.sqlFormatOp,b=h.sqlOp||h.sqlFormatOp;if(m||b){if(!m&&b){y=!0;var E=[v,a];a=E[0],v=E[1];var O=[h,f];f=O[0],h=O[1]}var S,T=[],_=[];if(null!=c){var w=c.map((function(e,n){var i=l?l.get(n):null,s=u?u.get(n):null,c=Av(e,i,t),v=yv(t,o,a,i),h=Jh(t,o,a,v,i,{forExport:!0}),g=$g(r,t,c,i,s,h,p,a,f,d);return void 0!==g&&(T.push(i),_.push(s)),g}));if(w.filter((function(e){return void 0===e})).size>0||w.size<g)return;S=1==g?w.first():w}var R=f.sqlFormatOp||function(e,t){var r,n=t.sqlOp||e,o=Dl(t);return 0==o?r=function(e,t,r,o,i,a,s,l){return"".concat(e," ").concat(n)}:1==o?r=function(e,t,r,o,i,a,s,l){return"".concat(e," ").concat(n," ").concat(r)}:2==o&&(r=function(e,t,r,o,i,a,s,l){var u,c,d=null==r||null===(u=r.first)||void 0===u?void 0:u.call(r),p=null==r||null===(c=r.get)||void 0===c?void 0:c.call(r,1);return"".concat(e," ").concat(n," ").concat(d," AND ").concat(p)}),r}(a,f);if(R){var I="func"==i?Kg(r,t,o):qg(r,t,o);if(null!=I){var A,C=[I,a,S,T.length>1?T:T[0],_.length>1?_:_[0],Fl(f,Pl),s,p];if(A=R.call.apply(R,[t.ctx].concat(C)),y&&(A=t.settings.sqlFormatReverse.call(t.ctx,A)),void 0!==A)return A;r.errors.push("Operator ".concat(a," is not supported for value source ").concat(T.join(", ")))}}else r.errors.push("Operator ".concat(a," is not supported"))}else r.errors.push("Operator ".concat(a," is not supported"))}},$g=function(e,t,r,n,o,i,a,s,l,u){if(void 0!==r){var c;if("field"==n)c=qg(e,t,r);else if("func"==n)c=Kg(e,t,r);else if("function"==typeof(null==i?void 0:i.sqlFormatValue)){var d=i.sqlFormatValue,p=[r,kg(kg({},iu()(a,["fieldSettings","listValues"])),{},{asyncListValues:u}),Fl(i,Ll)];if(s&&(p.push(s),p.push(l)),"field"==n){var f=Qh(t,r)||{};p.push(f)}c=d.call.apply(d,[t.ctx].concat(p))}else c=Array.isArray(r)?r.map((function(e){return Ec.escape(e)})):Ec.escape(r);return c}},qg=function(e,t,r){if(r){var n=t.settings.fieldSeparator,o=Qh(t,r)||{},i=qh(r,t),a=cv(r,t),s=a?a.join(n):null;return(0,t.settings.formatField)(mv(r,t,e,null,{useTableName:!0}),i,s,o,t)}},Kg=function(e,t,r){var n,o,i=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),a=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),s=Uh(t,i);if(s){var l=qh(i,t),u=l[l.length-1],c=s.sqlFunc||u,d={},p=[],f=[];for(var v in s.args){var h,g=s.args[v],y=Qh(t,g),m=g.defaultValue,b=g.isOptional,E=null!=m&&m.func?"func":"value",O=a?a.get(v):void 0,S=O?O.get("value"):void 0,T=O?O.get("valueSrc"):void 0;"func"!==T&&null!==(h=S)&&void 0!==h&&h.toJS&&(S=S.toJS());var _=O?O.get("asyncListValues"):void 0,w=$g(e,t,S,T,g.type,y,g,null,null,_);if(null!=S&&void 0===w)return void("func"!=T&&e.errors.push("Can't format value of arg ".concat(v," for func ").concat(i)));var R=void 0;if(void 0===w&&!b&&null!=m&&void 0===(R=$g(e,t,m,E,g.type,y,g,null,null,_)))return void("func"!=E&&e.errors.push("Can't format default value of arg ".concat(v," for func ").concat(i)));var I=null!=w?w:R;if(void 0!==I){if(p.length){var A,C=jg(v);try{for(C.s();!(A=C.n()).done;)d[A.value]=void 0}catch(e){C.e(e)}finally{C.f()}p=[]}d[v]=I}else b||f.push(v),p.push(v)}if(!f.length){var N;if("function"==typeof s.sqlFormatFunc){var L=s.sqlFormatFunc,P=[d];N=L.call.apply(L,[t.ctx].concat(P))}else{var x=Object.entries(d).map((function(e){var t=io(e,2);return t[0],t[1]})).join(", ");N="".concat(c,"(").concat(x,")")}return N}}else e.errors.push("Func ".concat(i," is not defined in config"))};function Wg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function zg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Wg(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Wg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Hg(e,t,r,n,o,i){if(e&&r&&null!=t){var a=r,s=n.operators[a];if(s){var l=s.elasticSearchQueryType,u=!1;!l&&s.reversedOp&&(u=!0,a=s.reversedOp,l=(s=n.operators[a]).elasticSearchQueryType);var c=yv(n,e,a,o),d=n.widgets[c];if(d){var p,f,v=d.elasticSearchFormatValue;if(p="function"==typeof l?l(c):l)return f="function"==typeof v?v(p,t,a,e,n):function(e,t,r,n,o,i){var a=function(e,t){return e}(n);switch(e){case"filter":return{script:o.operators[r].elasticSearchScript(n,t)};case"exists":return{field:n};case"match":return eo({},a,t[0]);case"term":return eo({},n,i===Yg?{value:t[0]}:t[0]);case"geo_bounding_box":return eo({},n,function(e){if(null==e)return null;var t=e.split(",").map(Number);return{top_left:{lat:t[0],lon:t[1]},bottom_right:{lat:t[2],lon:t[3]}}}(t[0]));case"range":return eo({},n,function(e,t){if(e.length>1)return{gte:"".concat(e[0]),lte:"".concat(e[1])};var r=e[0];switch(t){case"on_date":case"not_on_date":case"equal":case"select_equals":case"not_equal":return{gte:"".concat(r,"||/d"),lte:"".concat(r,"||+1d")};case"less_or_equal":return{lte:"".concat(r)};case"greater_or_equal":return{gte:"".concat(r)};case"less":return{lt:"".concat(r)};case"greater":return{gt:"".concat(r)};default:return}}(t,r));case"wildcard":return eo({},n,function(e){return{value:"*"+e+"*"}}(t[0]));case"regexp":return eo({},n,function(e){return{value:e}}(t[0]));default:return}}(p,t,a,e,n,i),u?{bool:{must_not:eo({},p,zg({},f))}}:eo({},p,zg({},f))}}}}var Yg="ES_7_SYNTAX",Qg="ES_6_SYNTAX";function Xg(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:Qg,n=_h(t,void 0,!1);if(e){var o=e.get("type"),i=e.get("properties")||new Map;if("rule"===o&&i.get("field")){var a,s,l,u=i.get("operator"),c=i.get("field"),d=i.get("fieldSrc"),p=null===(a=i.get("value"))||void 0===a?void 0:a.toJS(),f=(null===(s=i.get("valueType"))||void 0===s||s.get(0),null===(l=i.get("valueSrc"))||void 0===l?void 0:l.get(0));if("func"===f||"func"==d)return;return p&&Array.isArray(p[0])?p[0].map((function(e){return Hg(c,[e],u,n,f,r)})):Hg(c,p,u,n,f,r)}if("group"===o||"rule_group"===o){var v=i.get("not"),h=i.get("conjunction");return h||(h=Pd(n)),function(e,t,r,n,o,i){if(e&&e.size){var a=e.valueSeq().toArray(),s=function(e,t){switch(e){case"AND":return t?"must_not":"must";case"OR":return t?"should_not":"should";case"NOT":return t?"must":"must_not";default:return}}(t,r),l=a.map((function(e){return n(e,o,i)})).filter((function(e){return void 0!==e}));if(l.length)return{bool:eo({},s,l.flat(1/0))}}}(e.get("children1"),h,v,Xg,n,r)}}}function Jg(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r={};for(var n in e)if({}.hasOwnProperty.call(e,n)){if(t.includes(n))continue;r[n]=e[n]}return r}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.includes(r)||{}.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}function Zg(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}var ey=["title","value","disabled","groupTitle","grouplabel","renderTitle","children","label","isCustom","isHidden"];function ty(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function ry(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function ny(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?ry(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):ry(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var oy=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1e3;return function(){var n,o=(n=nu().mark((function n(o,i,a){var s,l,u,c,d,p;return nu().wrap((function(n){for(;;)switch(n.prev=n.next){case 0:if(s=null!=(null==a?void 0:a.pageSize)?a.pageSize:t,l=gu(e).filter((function(e){var t=e.title,r=e.value;return null==o||-1!=t.toUpperCase().indexOf(o.toUpperCase())||-1!="".concat(r).toUpperCase().indexOf(o.toUpperCase())})),s&&Math.ceil(l.length/s),u=i||0,s&&Math.ceil(u/s),c=s?l.slice(u,u+s):l,d=s?u+c.length:null,p=!!s&&d<l.length,!r){n.next=11;break}return n.next=11,Yl(r);case 11:return n.abrupt("return",{values:c,hasMore:p});case 12:case"end":return n.stop()}}),n)})),function(){var e=this,t=arguments;return new Promise((function(r,o){var i=n.apply(e,t);function a(e){Zg(i,r,o,a,s,"next",e)}function s(e){Zg(i,r,o,a,s,"throw",e)}a(void 0)}))});return function(e,t,r){return o.apply(this,arguments)}}()},iy=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(!t)return e;var o=e||[],i=t.filter((function(e){return null==o.find((function(t){return""+t.value==""+e.value}))})).map((function(e){return n?ny(ny({},e),{},{isHidden:!0}):e}));return r?[].concat(so(i),so(o)):[].concat(so(o),so(i))},ay=function(e,t,r){var n,o=null==e||""==e?void 0:null!==(n=null==e?void 0:e.value)&&void 0!==n?n:e,i=Su(o,t),a=r&&!i?hu(o):void 0,s=i||a;return[o,s?[s]:void 0]},sy=function(e,t,r){var n=e.map((function(e,n){var o,i=null==e||""==e?void 0:null!==(o=null==e?void 0:e.value)&&void 0!==o?o:e,a=Su(i,t),s=r&&!a?hu(i):void 0;return a||s})).filter((function(e){return null!=e})),o=n.map((function(e){var t;return null!==(t=null==e?void 0:e.value)&&void 0!==t?t:e}));return o.length||(o=void 0),[o,n]},ly=function(e){if(null==e)return null;var t=e.title,r=e.value,n=e.disabled,o=e.groupTitle,i=e.grouplabel,a=e.renderTitle,s=e.children,l=e.label,u=e.isCustom,c=e.isHidden,d=Jg(e,ey),p={value:r,title:t||l||s};return n&&(p.disabled=n),u&&(p.isCustom=u),c&&(p.isHidden=c),(o||i)&&(p.groupTitle=o||i),a&&(p.renderTitle=a),ny(ny({},p),d)},uy=function(e){var t,r=[],n=[],o=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return ty(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?ty(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(e);try{var i=function(){var e=t.value,o=function(e,t){if(e.findLastIndex)return e.findLastIndex(t);var r=so(e).reverse().findIndex(t);return-1==r?-1:e.length-1-r}(r,(function(t){var r,n;return(null!==(r=t.groupTitle)&&void 0!==r?r:"")==(null!==(n=e.groupTitle)&&void 0!==n?n:"")}));null==e.groupTitle||n.includes(e.groupTitle)||(n.push(e.groupTitle),1===n.length&&(r=r.map((function(e){return ny(ny({},e),{},{groupTitle:""})})))),null==e.groupTitle&&n.length&&(e=ny(ny({},e),{},{groupTitle:""})),-1!=o?r.splice(o+1,0,e):r.push(e)};for(o.s();!(t=o.n()).done;)i()}catch(e){o.e(e)}finally{o.f()}return r},cy={label:"Now",returnType:"datetime",jsonLogic:"now",jsonLogicCustomOps:{now:{}},spelFunc:"T(java.time.LocalDateTime).now()",sqlFormatFunc:function(){return"NOW()"},mongoFormatFunc:function(){return new Date},formatFunc:function(){return"NOW"}},dy={label:"Relative",returnType:"datetime",renderBrackets:["",""],renderSeps:["","",""],spelFormatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim,i=r+(o.charAt(0).toUpperCase()+o.slice(1)+"s");return"".concat(t,".").concat(i,"(").concat(n,")")},spelImport:function(e){var t,r,n,o,i=null===(t=e.methodName)||void 0===t?void 0:t.match(/^(minus|plus)(\w+)s$/);if(i&&(o=i[2].toLowerCase(),r=i[1],["minus","plus"].includes(r)&&["day","week","month","year"].includes(o)))return r={type:"string",val:r},o={type:"string",val:o},n=e.args[0],{date:e.obj,op:r,val:n,dim:o}},jsonLogic:function(e){var t=e.date,r=e.op;return{date_add:[t,e.val*("minus"==r?-1:1),e.dim]}},jsonLogicImport:function(e){var t=e.date_add[0],r=Math.abs(e.date_add[1]);return[t,e.date_add[1]>=0?"plus":"minus",r,e.date_add[2]]},jsonLogicCustomOps:{date_add:{}},sqlFormatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim;return"DATE_ADD(".concat(t,", INTERVAL ").concat(parseInt(n)*("minus"==r?-1:1)," ").concat(o.replace(/^'|'$/g,""),")")},mongoFormatFunc:null,formatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim;return n?"".concat(t," ").concat("minus"==r?"-":"+"," ").concat(n," ").concat(o):t},args:{date:{label:"Date",type:"datetime",defaultValue:{func:"NOW",args:[]},valueSources:["func","field","value"],spelEscapeForFormat:!0},op:{label:"Op",type:"select",defaultValue:"plus",valueSources:["value"],mainWidgetProps:{customProps:{showSearch:!1}},fieldSettings:{listValues:{plus:"+",minus:"-"}},spelEscapeForFormat:!1},val:{label:"Value",type:"number",fieldSettings:{min:0},defaultValue:0,valueSources:["value"],spelEscapeForFormat:!1},dim:{label:"Dimension",type:"select",defaultValue:"day",valueSources:["value"],mainWidgetProps:{customProps:{showSearch:!1}},fieldSettings:{listValues:{day:"day",week:"week",month:"month",year:"year"}},spelEscapeForFormat:!1}}},py={label:"Lowercase",mongoFunc:"$toLower",jsonLogic:"toLowerCase",spelFunc:"${str}.toLowerCase()",jsonLogicCustomOps:{toLowerCase:{}},returnType:"text",args:{str:{label:"String",type:"text",valueSources:["value","field","func"]}}},fy={label:"Uppercase",mongoFunc:"$toUpper",jsonLogic:"toUpperCase",spelFunc:"${str}.toUpperCase()",jsonLogicCustomOps:{toUpperCase:{}},returnType:"text",args:{str:{label:"String",type:"text",valueSources:["value","field","func"]}}},vy={label:"Linear regression",returnType:"number",formatFunc:function(e,t){var r=e.coef,n=e.bias,o=e.val;return"(".concat(r," * ").concat(o," + ").concat(n,")")},sqlFormatFunc:function(e){var t=e.coef,r=e.bias,n=e.val;return"(".concat(t," * ").concat(n," + ").concat(r,")")},spelFormatFunc:function(e){var t=e.coef,r=e.bias,n=e.val;return"(".concat(t," * ").concat(n," + ").concat(r,")")},spelImport:function(e){var t,r;if("op-plus"===e.type){var n=io(e.children,2);if(r=n[0],t=n[1],"op-multiply"===r.type){var o=io(r.children,2);return{coef:o[0],val:o[1],bias:t}}}},mongoFormatFunc:function(e){var t=e.coef,r=e.bias;return{$sum:[{$multiply:[t,e.val]},r]}},jsonLogic:function(e){var t=e.coef,r=e.bias;return{"+":[{"*":[t,e.val]},r]}},jsonLogicImport:function(e){return[e["+"][0]["*"][0],e["+"][0]["*"][1],e["+"][1]]},renderBrackets:["",""],renderSeps:[" * "," + "],args:{coef:{label:"Coef",type:"number",defaultValue:1,valueSources:["value"]},val:{label:"Value",type:"number",valueSources:["value","field"]},bias:{label:"Bias",type:"number",defaultValue:0,valueSources:["value"]}}},hy={utils:{SqlString:Ec,moment:qu(),mongoFormatOp1:function(e,t,r,n,o,i,a,s,l,u,c,d){var p="string"!=typeof n||n.startsWith("$")?n:"$"+n,f=t(i,d);if(void 0!==f)return r?a||e&&"$eq"!=e?a?{$not:eo({},e,[p,f])}:eo({},n,{$not:eo({},e,f)}):eo({},n,{$ne:f}):a||e&&"$eq"!=e?a?eo({},e,[p,f]):eo({},n,eo({},e,f)):eo({},n,f)},mongoFormatOp2:function(e,t,r,n,o,i,a,s,l,u,c){var d="string"!=typeof r||r.startsWith("$")?r:"$"+r;return t?i?{$not:{$and:[eo({},e[0],[d,o[0]]),eo({},e[1],[d,o[1]])]}}:eo({},r,{$not:eo(eo({},e[0],o[0]),e[1],o[1])}):i?{$and:[eo({},e[0],[d,o[0]]),eo({},e[1],[d,o[1]])]}:eo({},r,eo(eo({},e[0],o[0]),e[1],o[1]))},mongoEmptyValue:Sc,escapeRegExp:$l,sqlEmptyValue:Oc,stringifyForDisplay:Ic,getTitleInListValues:mu,spelEscape:_c,spelFixList:Tc,wrapWithBrackets:Ac}};const gy=hy;function yy(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function my(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function by(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?my(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):my(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Ey={equal:{label:"==",labelForFormat:"==",sqlOp:"=",spelOp:"==",spelOps:["==","eq"],reversedOp:"not_equal",formatOp:function(e,t,r,n,o,i,a,s,l){var u=s?"=":i.label;return"boolean"==o&&s?"No"==r?"NOT ".concat(e):"".concat(e):"".concat(e," ").concat(u," ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},jsonLogic:"==",elasticSearchQueryType:"term"},not_equal:{isNotOp:!0,label:"!=",labelForFormat:"!=",sqlOp:"<>",spelOp:"!=",spelOps:["!=","ne"],reversedOp:"equal",formatOp:function(e,t,r,n,o,i,a,s,l){return"boolean"==o&&s?"No"==r?"".concat(e):"NOT ".concat(e):"".concat(e," ").concat(i.label," ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},jsonLogic:"!="},less:{label:"<",labelForFormat:"<",sqlOp:"<",spelOp:"<",spelOps:["<","lt"],reversedOp:"greater_or_equal",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$lt",function(e){return e},!1].concat(r))},jsonLogic:"<",elasticSearchQueryType:"range"},less_or_equal:{label:"<=",labelForFormat:"<=",sqlOp:"<=",spelOp:"<=",spelOps:["<=","le"],reversedOp:"greater",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$lte",function(e){return e},!1].concat(r))},jsonLogic:"<=",elasticSearchQueryType:"range"},greater:{label:">",labelForFormat:">",sqlOp:">",spelOp:">",spelOps:[">","gt"],reversedOp:"less_or_equal",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gt",function(e){return e},!1].concat(r))},jsonLogic:">",elasticSearchQueryType:"range"},greater_or_equal:{label:">=",labelForFormat:">=",sqlOp:">=",spelOp:">=",spelOps:[">=","ge"],reversedOp:"less",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gte",function(e){return e},!1].concat(r))},jsonLogic:">=",elasticSearchQueryType:"range"},like:{label:"Contains",labelForFormat:"Contains",reversedOp:"not_like",sqlOp:"LIKE",spelOp:"${0}.contains(${1})",valueTypes:["text"],mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e):void 0},!1].concat(n))},jsonLogic:function(e,t,r){return{in:[r,e]}},jsonLogic2:"#in",valueSources:["value"],elasticSearchQueryType:"regexp"},not_like:{isNotOp:!0,label:"Not contains",reversedOp:"like",labelForFormat:"Not Contains",sqlOp:"NOT LIKE",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e):void 0},!0].concat(n))},jsonLogic:function(e,t,r){return{"!":{in:[r,e]}}},jsonLogic2:"#!in",_jsonLogicIsExclamationOp:!0,valueSources:["value"]},starts_with:{label:"Starts with",labelForFormat:"Starts with",sqlOp:"LIKE",spelOp:"${0}.startsWith(${1})",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?"^"+t.utils.escapeRegExp(e):void 0},!1].concat(n))},jsonLogic:void 0,valueSources:["value"]},ends_with:{label:"Ends with",labelForFormat:"Ends with",sqlOp:"LIKE",spelOp:"${0}.endsWith(${1})",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e)+"$":void 0},!1].concat(n))},jsonLogic:void 0,valueSources:["value"]},between:{label:"Between",labelForFormat:"BETWEEN",sqlOp:"BETWEEN",cardinality:2,formatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1);return s?"".concat(e," BETWEEN ").concat(l," AND ").concat(u):"".concat(e," >= ").concat(l," && ").concat(e," <= ").concat(u)},spelFormatOp:function(e,t,r,n,o,i,a,s){var l=r[0],u=r[1];return"".concat(e," >= ").concat(l," && ").concat(e," <= ").concat(u)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp2.apply(e,[["$gte","$lte"],!1].concat(r))},valueLabels:["Value from","Value to"],textSeparators:[null,"and"],reversedOp:"not_between",jsonLogic:"<=",validateValues:function(e){return null!=e[0]&&null!=e[1]?e[0]<=e[1]:null},elasticSearchQueryType:function(e){return"time"===e?"filter":"range"}},not_between:{isNotOp:!0,label:"Not between",labelForFormat:"NOT BETWEEN",sqlOp:"NOT BETWEEN",cardinality:2,formatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1);return s?"".concat(e," NOT BETWEEN ").concat(l," AND ").concat(u):"(".concat(e," < ").concat(l," || ").concat(e," > ").concat(u,")")},spelFormatOp:function(e,t,r,n,o,i,a,s){var l=r[0],u=r[1];return"(".concat(e," < ").concat(l," || ").concat(e," > ").concat(u,")")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp2.apply(e,[["$gte","$lte"],!0].concat(r))},valueLabels:["Value from","Value to"],textSeparators:[null,"and"],reversedOp:"between",jsonLogic:function(e,t,r){return{"!":{"<=":[Array.isArray(r)?r[0]:r,e,Array.isArray(r)?r[1]:r]}}},jsonLogic2:"!<=",_jsonLogicIsExclamationOp:!0,validateValues:function(e){return null!=e[0]&&null!=e[1]?e[0]<=e[1]:null}},is_empty:{label:"Is empty",labelForFormat:"IS EMPTY",cardinality:0,reversedOp:"is_not_empty",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS EMPTY"):"!".concat(e)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this.utils.sqlEmptyValue(s);return"COALESCE(".concat(e,", ").concat(l,") = ").concat(l)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," <= ''")},mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e,r){return[t.utils.mongoEmptyValue(r),null]},!1].concat(n))},jsonLogic:"!"},is_not_empty:{isNotOp:!0,label:"Is not empty",labelForFormat:"IS NOT EMPTY",cardinality:0,reversedOp:"is_empty",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS NOT EMPTY"):"!!".concat(e)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this.utils.sqlEmptyValue(s);return"COALESCE(".concat(e,", ").concat(l,") <> ").concat(l)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," > ''")},mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$nin",function(e,r){return[t.utils.mongoEmptyValue(r),null]},!1].concat(n))},jsonLogic:"!!",elasticSearchQueryType:"exists"},is_null:{label:"Is null",labelForFormat:"IS NULL",sqlOp:"IS NULL",cardinality:0,reversedOp:"is_not_null",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS NULL"):"!".concat(e)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," == null")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return null},!1].concat(r))},jsonLogic:"=="},is_not_null:{label:"Is not null",labelForFormat:"IS NOT NULL",sqlOp:"IS NOT NULL",cardinality:0,reversedOp:"is_null",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS NOT NULL"):"!!".concat(e)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," != null")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return null},!1].concat(r))},jsonLogic:"!=",elasticSearchQueryType:"exists"},select_equals:{label:"==",labelForFormat:"==",sqlOp:"=",formatOp:function(e,t,r,n,o,i,a,s){var l=s?"=":"==";return"".concat(e," ").concat(l," ").concat(r)},spelOp:"==",spelOps:["==","eq"],mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},reversedOp:"select_not_equals",jsonLogic:"==",elasticSearchQueryType:"term"},select_not_equals:{isNotOp:!0,label:"!=",labelForFormat:"!=",sqlOp:"<>",formatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," != ").concat(r)},spelOp:"!=",spelOps:["!=","ne"],mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},reversedOp:"select_equals",jsonLogic:"!="},select_any_in:{label:"Any in",labelForFormat:"IN",sqlOp:"IN",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," IN (").concat(r.join(", "),")"):"".concat(e," IN (").concat(r,")")},sqlFormatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," IN (").concat(r.join(", "),")"):void 0},valueTypes:["multiselect"],spelOp:"${1}.contains(${0})",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e){return e},!1].concat(r))},reversedOp:"select_not_any_in",jsonLogic:"in",elasticSearchQueryType:"term"},select_not_any_in:{isNotOp:!0,label:"Not in",labelForFormat:"NOT IN",sqlOp:"NOT IN",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," NOT IN (").concat(r.join(", "),")"):"".concat(e," NOT IN (").concat(r,")")},sqlFormatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," NOT IN (").concat(r.join(", "),")"):void 0},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$nin",function(e){return e},!1].concat(r))},reversedOp:"select_any_in",jsonLogic:function(e,t,r){return{"!":{in:[e,r]}}},jsonLogic2:"!in",_jsonLogicIsExclamationOp:!0},multiselect_contains:{label:"Contains",labelForFormat:"CONTAINS",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," CONTAINS [").concat(r.join(", "),"]"):"".concat(e," CONTAINS ").concat(r)},reversedOp:"multiselect_not_contains",jsonLogic2:"some-in",jsonLogic:function(e,t,r){return{some:[e,{in:[{var:""},r]}]}},spelOp:"T(CollectionUtils).containsAny(${0}, ${1})",elasticSearchQueryType:"term",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e){return e},!1].concat(r))}},multiselect_not_contains:{isNotOp:!0,label:"Not contains",labelForFormat:"NOT CONTAINS",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," NOT CONTAINS [").concat(r.join(", "),"]"):"".concat(e," NOT CONTAINS ").concat(r)},reversedOp:"multiselect_contains",jsonLogic2:"!some-in",jsonLogic:function(e,t,r){return{"!":{some:[e,{in:[{var:""},r]}]}}},_jsonLogicIsExclamationOp:!0},multiselect_equals:{label:"Equals",labelForFormat:"==",sqlOp:"=",formatOp:function(e,t,r,n,o,i,a,s){var l=s?"=":"==";return"value"==n?"".concat(e," ").concat(l," [").concat(r.join(", "),"]"):"".concat(e," ").concat(l," ").concat(r)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this;return"value"==n?"".concat(e," = '").concat(r.map((function(e){return l.utils.SqlString.trim(e)})).join(","),"'"):void 0},spelOp:"${0}.equals(${1})",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},reversedOp:"multiselect_not_equals",jsonLogic2:"all-in",jsonLogic:function(e,t,r){return{all:[e,{in:[{var:""},r]}]}},elasticSearchQueryType:"term"},multiselect_not_equals:{isNotOp:!0,label:"Not equals",labelForFormat:"!=",sqlOp:"<>",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," != [").concat(r.join(", "),"]"):"".concat(e," != ").concat(r)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this;return"value"==n?"".concat(e," != '").concat(r.map((function(e){return l.utils.SqlString.trim(e)})).join(","),"'"):void 0},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},reversedOp:"multiselect_equals",jsonLogic2:"!all-in",jsonLogic:function(e,t,r){return{"!":{all:[e,{in:[{var:""},r]}]}}},_jsonLogicIsExclamationOp:!0},proximity:{label:"Proximity search",cardinality:2,valueLabels:[{label:"Word 1",placeholder:"Enter first word"},{label:"Word 2",placeholder:"Enter second word"}],textSeparators:[],formatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1),c=null==a?void 0:a.get("proximity");return"".concat(e," ").concat(l," NEAR/").concat(c," ").concat(u)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1),c=this.utils.SqlString.trim(l),d=this.utils.SqlString.trim(u),p=null==a?void 0:a.get("proximity");return"CONTAINS(".concat(e,", 'NEAR((").concat(c,", ").concat(d,"), ").concat(p,")')")},mongoFormatOp:void 0,jsonLogic:void 0,options:{optionLabel:"Near",optionTextBefore:"Near",optionPlaceholder:"Select words between",minProximity:2,maxProximity:10,defaults:{proximity:2}}},some:{label:"Some",labelForFormat:"SOME",cardinality:0,jsonLogic:"some",spelFormatOp:function(e){return"".concat(e," > 0")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gt",function(e){return 0},!1].concat(r))}},all:{label:"All",labelForFormat:"ALL",cardinality:0,jsonLogic:"all",spelFormatOp:function(e,t,r){return"".concat(e," == ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))}},none:{label:"None",labelForFormat:"NONE",cardinality:0,jsonLogic:"none",spelFormatOp:function(e){return"".concat(e," == 0")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return 0},!1].concat(r))}}},Oy={text:{type:"text",jsType:"string",valueSrc:"value",valueLabel:"String",valuePlaceholder:"Enter string",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},spelFormatValue:function(e,t,r,n,o){return this.utils.spelEscape(e)},sqlFormatValue:function(e,t,r,n,o){return"LIKE"==o.sqlOp||"NOT LIKE"==o.sqlOp?this.utils.SqlString.escapeLike(e,"starts_with"!=n,"ends_with"!=n):this.utils.SqlString.escape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},textarea:{type:"text",jsType:"string",valueSrc:"value",valueLabel:"Text",valuePlaceholder:"Enter text",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return"LIKE"==o.sqlOp||"NOT LIKE"==o.sqlOp?this.utils.SqlString.escapeLike(e,"starts_with"!=n,"ends_with"!=n):this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e},fullWidth:!0},number:{type:"number",jsType:"number",valueSrc:"value",valueLabel:"Number",valuePlaceholder:"Enter number",valueLabels:[{label:"Number from",placeholder:"Enter number from"},{label:"Number to",placeholder:"Enter number to"}],formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e,t,r){var n=r.step&&!Number.isInteger(r.step);return this.utils.spelEscape(e,n)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},slider:{type:"number",jsType:"number",valueSrc:"value",valueLabel:"Number",valuePlaceholder:"Enter number or move slider",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},select:{type:"select",jsType:"string",valueSrc:"value",valueLabel:"Value",valuePlaceholder:"Select value",formatValue:function(e,t,r,n){var o=this.utils.getTitleInListValues(t.fieldSettings.listValues||t.asyncListValues,e);return n?this.utils.stringifyForDisplay(o):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},multiselect:{type:"multiselect",jsType:"array",valueSrc:"value",valueLabel:"Values",valuePlaceholder:"Select values",formatValue:function(e,t,r,n){var o=this,i=e.map((function(e){return o.utils.getTitleInListValues(t.fieldSettings.listValues||t.asyncListValues,e)}));return n?i.map(this.utils.stringifyForDisplay):e.map(JSON.stringify)},sqlFormatValue:function(e,t,r,n,o){var i=this;return e.map((function(e){return i.utils.SqlString.escape(e)}))},spelFormatValue:function(e,t,r,n,o){var i=o&&o.spelOp&&o.spelOp.startsWith("${1}"),a=this.utils.spelEscape(e);return i&&(a=this.utils.spelFixList(a)),a},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},date:{type:"date",jsType:"string",valueSrc:"value",dateFormat:"DD.MM.YYYY",valueFormat:"YYYY-MM-DD",valueLabel:"Date",valuePlaceholder:"Enter date",valueLabels:[{label:"Date from",placeholder:"Enter date from"},{label:"Date to",placeholder:"Enter date to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.dateFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.format("YYYY-MM-DD"))},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("YYYY-MM-DD");return"T(java.time.LocalDate).parse('".concat(i,"', T(java.time.format.DateTimeFormatter).ofPattern('").concat("yyyy-MM-dd","'))")},spelImportFuncs:[{obj:{cls:["java","time","LocalDate"]},methodName:"parse",args:[{var:"v"},{obj:{cls:["java","time","format","DateTimeFormatter"]},methodName:"ofPattern",args:[{var:"fmt"}]}]}],spelImportValue:function(e,t,r){var n,o,i,a;if(!t)return[void 0,"No widget def to get value format"];if(null!=r&&null!==(n=r.fmt)&&void 0!==n&&null!==(n=n.value)&&void 0!==n&&null!==(o=n.includes)&&void 0!==o&&o.call(n," ")||null!==(i=r.fmt)&&void 0!==i&&null!==(i=i.value)&&void 0!==i&&null!==(a=i.toLowerCase)&&void 0!==a&&a.call(i).includes("hh:mm"))return[void 0,"Invalid date format ".concat(JSON.stringify(r.fmt))];var s=this.utils.moment(e.value,this.utils.moment.ISO_8601);return s.isValid()?[s.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){return this.utils.moment(e,r.valueFormat).toDate()},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?r.toDate():void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return n.isValid()?n.toDate():void 0}},time:{type:"time",jsType:"string",valueSrc:"value",timeFormat:"HH:mm",valueFormat:"HH:mm:ss",use12Hours:!1,valueLabel:"Time",valuePlaceholder:"Enter time",valueLabels:[{label:"Time from",placeholder:"Enter time from"},{label:"Time to",placeholder:"Enter time to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.timeFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.format("HH:mm:ss"))},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("HH:mm:ss");return"T(java.time.LocalTime).parse('".concat(i,"')")},spelImportFuncs:["T(java.time.LocalTime).parse(${v})"],spelImportValue:function(e,t,r){var n,o,i;if(!t)return[void 0,"No widget def to get value format"];if(null!=r&&r.fmt&&(null===(n=r.fmt)||void 0===n||null===(n=n.value)||void 0===n||null===(o=n.toLowerCase)||void 0===o||!o.call(n).includes("hh:mm")||null!==(i=r.fmt)&&void 0!==i&&null!==(i=i.value)&&void 0!==i&&i.includes(" ")))return[void 0,"Invalid time format ".concat(JSON.stringify(r.fmt))];var a=this.utils.moment(e.value,"HH:mm:ss");return a.isValid()?[a.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return 60*n.get("hour")*60+60*n.get("minute")+n.get("second")},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?60*r.get("hour")*60+60*r.get("minute")+r.get("second"):void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return 60*n.get("hour")*60+60*n.get("minute")+n.get("second")},elasticSearchFormatValue:function(e,t,r,n){return{script:{script:{source:"doc[".concat(n,"][0].getHour() >== params.min && doc[").concat(n,"][0].getHour() <== params.max"),params:{min:t[0],max:t[1]}}}}}},datetime:{type:"datetime",jsType:"string",valueSrc:"value",timeFormat:"HH:mm",dateFormat:"DD.MM.YYYY",valueFormat:"YYYY-MM-DD HH:mm:ss",use12Hours:!1,valueLabel:"Datetime",valuePlaceholder:"Enter datetime",valueLabels:[{label:"Datetime from",placeholder:"Enter datetime from"},{label:"Datetime to",placeholder:"Enter datetime to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.dateFormat+" "+r.timeFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.toDate())},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("YYYY-MM-DD HH:mm:ss");return"T(java.time.LocalDateTime).parse('".concat(i,"', T(java.time.format.DateTimeFormatter).ofPattern('").concat("yyyy-MM-dd HH:mm:ss","'))")},spelImportFuncs:[{obj:{cls:["java","time","LocalDateTime"]},methodName:"parse",args:[{var:"v"},{obj:{cls:["java","time","format","DateTimeFormatter"]},methodName:"ofPattern",args:[{var:"fmt"}]}]}],spelImportValue:function(e,t,r){var n,o;if(!t)return[void 0,"No widget def to get value format"];if(null==r||null===(n=r.fmt)||void 0===n||null===(n=n.value)||void 0===n||null===(o=n.includes)||void 0===o||!o.call(n," "))return[void 0,"Invalid datetime format ".concat(JSON.stringify(r.fmt))];var i=this.utils.moment(e.value,this.utils.moment.ISO_8601);return i.isValid()?[i.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){return this.utils.moment(e,r.valueFormat).toDate()},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?r.toDate():void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return n.isValid()?n.toDate():void 0}},boolean:{type:"boolean",jsType:"boolean",valueSrc:"value",labelYes:"Yes",labelNo:"No",formatValue:function(e,t,r,n){return n?e?"Yes":"No":JSON.stringify(!!e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e,t,r,n,o){return this.utils.spelEscape(e)},defaultValue:!1,toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},field:{valueSrc:"field",formatValue:function(e,t,r,n,o,i,a){return n&&a.label||e},sqlFormatValue:function(e,t,r,n,o,i){return e},spelFormatValue:function(e,t,r,n,o){return e},valueLabel:"Field to compare",valuePlaceholder:"Select field to compare"},func:{valueSrc:"func",valueLabel:"Function",valuePlaceholder:"Select function"},case_value:{valueSrc:"value",type:"case_value",spelFormatValue:function(e){return this.utils.spelEscape(""===e?null:e)},spelImportValue:function(e){return[e.value,[]]},jsonLogic:function(e){return""===e?null:e}}},Sy=by(by({},ch),{},{convertableWidgets:{number:["slider","rangeslider"],slider:["number","rangeslider"],rangeslider:["number","slider"],text:["textarea"],textarea:["text"]},formatSpelField:function(e,t,r,n,o,i){var a=this,s=n.map((function(e,t){var r=e.key,n=e.parent,o=e.fieldSeparator;return 0==t?"[map]"==n?"#this[".concat(a.utils.spelEscape(r),"]"):r:"map"==n||"[map]"==n?"[".concat(a.utils.spelEscape(r),"]"):"".concat(o).concat(r)})).join("");return o.fieldName&&(s=e),o.isSpelVariable&&(s="#"+s),s},sqlFormatReverse:function(e){if(null!=e)return"NOT"+this.utils.wrapWithBrackets(e)},spelFormatReverse:function(e){if(null!=e)return"!"+this.utils.wrapWithBrackets(e)},formatReverse:function(e,t,r,n,o,i){if(null!=e)return i?"NOT "+this.utils.wrapWithBrackets(e):"!"+this.utils.wrapWithBrackets(e)},formatAggr:function(e,t,r,n,o,i,a,s,l,u){var c=a.labelForFormat,d=a.cardinality;if(0==d){var p=e?" HAVE ".concat(e):"";return"".concat(c," OF ").concat(t).concat(p)}if(null==d||1==d){var f=e?" WHERE ".concat(e):"";return"COUNT OF ".concat(t).concat(f," ").concat(c," ").concat(n)}if(2==d){var v=e?" WHERE ".concat(e):"",h=n.first(),g=n.get(1);return"COUNT OF ".concat(t).concat(v," ").concat(c," ").concat(h," AND ").concat(g)}},jsonLogic:{groupVarKey:"var",altVarKey:"var",lockedOp:"locked"},canCompareFieldWithField:function(e,t,r,n){return!0},valueSourcesInfo:{value:{label:"Value"},field:{label:"Field",widget:"field"},func:{label:"Function",widget:"func"}}}),Ty=function(e,t){var r,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],o={rangeslider:Ry,treeselect:Iy,treemultiselect:Ay,rangeable__date:wy("date","date")},i=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return yy(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?yy(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(t);try{for(i.s();!(r=i.n()).done;){var a=r.value,s=o[a];if(!s)throw new Error("Can't ".concat(n?"add":"remove"," mixin ").concat(a));e=s(e,n)}}catch(e){i.e(e)}finally{i.f()}return e},_y=function(e,t){return Ty(e,t,!0)},wy=function(e,t){return function(r){var n=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],o=r.types;return o=by(by({},o),{},eo({},e,by(by({},o[e]),{},{widgets:by({},o[e].widgets)}))),n?o[e].widgets[t]=by({opProps:{between:{isSpecialRange:!0,textSeparators:[null,null]},not_between:{isSpecialRange:!0,textSeparators:[null,null]}}},o[e].widgets[t]):delete o[e].widgets[t],by(by({},r),{},{types:o})}},Ry=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=by({},r),t?r.rangeslider=by({type:"number",jsType:"number",valueSrc:"value",valueLabel:"Range",valuePlaceholder:"Select range",valueLabels:[{label:"Number from",placeholder:"Enter number from"},{label:"Number to",placeholder:"Enter number to"}],formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},singleWidget:"slider",toJS:function(e,t){return e}},r.rangeslider):delete r.rangeslider,n=by(by({},n),{},{number:by(by({},n.number),{},{widgets:by({},n.number.widgets)})}),t?n.number.widgets.rangeslider=by({opProps:{between:{isSpecialRange:!0},not_between:{isSpecialRange:!0}},operators:["between","not_between","is_null","is_not_null"]},n.number.widgets.rangeslider):delete n.number.widgets.rangeslider,by(by({},e),{},{widgets:r,types:n})},Iy=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=by({},r),t?r.treeselect=by({type:"treeselect",jsType:"string",valueSrc:"value",valueLabel:"Value",valuePlaceholder:"Select value",formatValue:function(e,t,r,n){var o=t.fieldSettings.treeValues||t.fieldSettings.listValues||t.asyncListValues,i=this.utils.getTitleInListValues(o,e);return n?this.utils.stringifyForDisplay(i):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e}},r.treeselect):delete r.treeselect,n=by({},n),t?n.treeselect=by({mainWidget:"treeselect",defaultOperator:"select_equals",widgets:{treeselect:{operators:["select_equals","select_not_equals"]},treemultiselect:{operators:["select_any_in","select_not_any_in"]}}},n.treeselect):delete n.treeselect,by(by({},e),{},{widgets:r,types:n})},Ay=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=by({},r),t?r.treemultiselect=by({type:"treemultiselect",jsType:"array",valueSrc:"value",valueLabel:"Values",valuePlaceholder:"Select values",formatValue:function(e,t,r,n){var o=this,i=t.fieldSettings.treeValues||t.fieldSettings.listValues||t.asyncListValues,a=e.map((function(e){return o.utils.getTitleInListValues(i,e)}));return n?a.map(this.utils.stringifyForDisplay):e.map(JSON.stringify)},sqlFormatValue:function(e,t,r,n,o){var i=this;return e.map((function(e){return i.utils.SqlString.escape(e)}))},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e}},r.treemultiselect):delete r.treemultiselect,n=by({},n),t?n.treemultiselect=by({defaultOperator:"multiselect_equals",widgets:{treemultiselect:{operators:["multiselect_equals","multiselect_not_equals"]}}},n.treemultiselect):delete n.treemultiselect,by(by({},e),{},{widgets:r,types:n})},Cy={addMixins:_y,removeMixins:function(e,t){return Ty(e,t,!1)}},Ny={conjunctions:{AND:{label:"And",mongoConj:"$and",jsonLogicConj:"and",sqlConj:"AND",spelConj:"and",spelConjs:["and","&&"],reversedConj:"OR",formatConj:function(e,t,r,n){var o=e.size>1?e.join(" "+(n?"AND":"&&")+" "):e.first();return(e.size>1||r)&&(o=this.utils.wrapWithBrackets(o)),r&&(o="NOT "+o),o},sqlFormatConj:function(e,t,r){var n=e.size>1?e.join(" AND "):e.first();return(e.size>1||r)&&(n=this.utils.wrapWithBrackets(n)),r&&(n="NOT "+n),n},spelFormatConj:function(e,t,r,n){r&&(n=!1);var o=e.size>1?e.join(" && "):e.first();return(e.size>1||r)&&!n&&(o=this.utils.wrapWithBrackets(o)),r&&(o="!"+o),o}},OR:{label:"Or",mongoConj:"$or",jsonLogicConj:"or",sqlConj:"OR",spelConj:"or",spelConjs:["or","||"],reversedConj:"AND",formatConj:function(e,t,r,n){return e.size>1?(r?"NOT ":"")+"("+e.join(" "+(n?"OR":"||")+" ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},sqlFormatConj:function(e,t,r){return e.size>1?(r?"NOT ":"")+"("+e.join(" OR ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},spelFormatConj:function(e,t,r,n){return r&&(n=!1),e.size>1?(r?"!":"")+(n?"":"(")+e.join(" || ")+(n?"":")"):(r?"!(":"")+e.first()+(r?")":"")}}},operators:Ey,widgets:Oy,types:{text:{defaultOperator:"equal",mainWidget:"text",widgets:{text:{operators:["equal","not_equal","like","not_like","starts_with","ends_with","proximity","is_empty","is_not_empty","is_null","is_not_null"],widgetProps:{},opProps:{}},textarea:{operators:["equal","not_equal","like","not_like","starts_with","ends_with","is_empty","is_not_empty","is_null","is_not_null"],widgetProps:{},opProps:{}},field:{operators:["equal","not_equal","proximity"]}}},number:{defaultOperator:"equal",mainWidget:"number",widgets:{number:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]},slider:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","is_null","is_not_null"]}}},date:{defaultOperator:"equal",widgets:{date:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},time:{defaultOperator:"equal",widgets:{time:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},datetime:{defaultOperator:"equal",widgets:{datetime:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},select:{mainWidget:"select",defaultOperator:"select_equals",widgets:{select:{operators:["select_equals","select_not_equals","is_null","is_not_null"]},multiselect:{operators:["select_any_in","select_not_any_in","is_null","is_not_null"]}}},multiselect:{defaultOperator:"multiselect_equals",widgets:{multiselect:{operators:["multiselect_contains","multiselect_not_contains","multiselect_equals","multiselect_not_equals","is_null","is_not_null"]}}},boolean:{defaultOperator:"equal",widgets:{boolean:{operators:["equal","not_equal","is_null","is_not_null"],widgetProps:{}},field:{operators:["equal","not_equal"]}}},"!group":{defaultOperator:"some",mainWidget:"number",widgets:{number:{widgetProps:{min:0},operators:["some","all","none","equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between"],opProps:{equal:{label:"Count =="},not_equal:{label:"Count !="},less:{label:"Count <"},less_or_equal:{label:"Count <="},greater:{label:"Count >"},greater_or_equal:{label:"Count >="},between:{label:"Count between"},not_between:{label:"Count not between"}}}}},case_value:{mainWidget:"case_value",widgets:{case_value:{widgetProps:{}}}}},settings:Sy,ctx:gy};const Ly=Ny=_y(Ny,["rangeslider","treeselect","treemultiselect"]);var Py="ADD_GROUP",xy="ADD_CASE_GROUP",jy="REMOVE_GROUP",Fy="SET_CONJUNCTION",Dy="SET_NOT",ky="ADD_RULE",My="REMOVE_RULE",Vy="SET_FIELD",Uy="SET_FIELD_SRC",By="SET_OPERATOR",Gy="SET_VALUE",$y="SET_VALUE_SRC",qy="SET_FUNC_VALUE",Ky="SET_OPERATOR_OPTION",Wy="SET_LOCK",zy="SET_TREE",Hy="MOVE_ITEM",Yy="after",Qy="before",Xy="append",Jy="prepend",Zy="SET_DRAG_PROGRESS",em="SET_DRAG_START",tm="SET_DRAG_END",rm=p(1612),nm=p.n(rm);function om(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function im(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?om(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):om(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function am(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return sm(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?sm(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function sm(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var lm=function(e,t,r,n,o,i){var a,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,l=arguments.length>7&&void 0!==arguments[7]?arguments[7]:{};if(!e.getIn(Tu(t)))return e;var u=(null==o||null===(a=o.get)||void 0===a?void 0:a.call(o,"id"))||n,c=i.settings.shouldCreateEmptyGroup,d=t.push(u),p=!c,f=!(null==l||!l.isDefaultCase),v=e;return(e=um(e,t,r,u,xd(i).merge(_l(o)||{}),i,s))!==v&&(s||f||(e=e.setIn(Tu(d,"children1"),new Il.OrderedMap),p&&(e=um(e,d,"rule",Cl(),Nd(i),i))),e=Iu(e)),e},um=function(e,t,r,n,o,i){var a,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if("switch_group"===r)throw new Error("Can't add switch_group programmatically");var l=e.getIn(Tu(t));if(!l)return e;var u,c,d=(null==o||null===(a=o.get)||void 0===a?void 0:a.call(o,"id"))||n,p=i.settings,f=p.maxNumberOfCases,v=p.maxNumberOfRules,h=p.maxNesting,g="switch_group"===e.get("type"),y=g?e.getIn(Tu(t.take(2))):null,m=Tu(t,"children1"),b=e.getIn(m),E=!!b&&b.size,O=E?b.size:null;"case_group"===r?(u=O,c=f):"group"===r?(u=t.size,c=h):"rule_group"===(null==l?void 0:l.get("type"))||(u=Lu(g?y:e),c=v);var S=!c||!u||u<c,T={type:r,id:d,properties:o};vm(i,T,s);var _="case_group"===r&&E&&null==b.last().get("children1");if(S){var w=new Il.OrderedMap(eo({},d,new Il.Map(T)));if(E)if(_){var R=b.last(),I=new Il.OrderedMap(eo(eo({},d,new Il.Map(T)),R.get("id"),R));e=(e=e.deleteIn(Tu(m,"children1",R.get("id")))).mergeIn(m,I)}else e=e.mergeIn(m,w);else e=e.setIn(m,w);e=Iu(e)}return e},cm=function(e,t){return e=e.deleteIn(Tu(t)),Iu(e)},dm=function(e,t,r,n,o){var i,a,s,l,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{},c=e.getIn(Tu(t));if(!c)return{state:e};var d=u.isEndValue,p=u.canDropArgs;if(!r)return{state:e=cm(e,t)};var f=n.settings,v=f.fieldSeparator,h=f.setOpOnChangeField,g=f.showErrorMessage;Array.isArray(r)&&(r=r.join(v));var y=c.get("type"),m=c.get("properties"),b="rule_group"==y,E=null==m?void 0:m.get("fieldSrc"),O=Qh(n,r);if(!O)return console.warn("No config for LHS ".concat(r)),{state:e};var S=O.type;"!group"!==S&&"!struct"!==S||(S=null);var T=null==m?void 0:m.get("operator"),_=null==m?void 0:m.get("operatorOptions"),w=null==m?void 0:m.get("field"),R="!group"==O.type,I=R&&"array"==O.mode,A=b!=R,C=O&&-1!==(null===(i=O.operators)||void 0===i?void 0:i.indexOf(T))?T:null,N="func"===E&&(null==w||null===(a=w.get)||void 0===a?void 0:a.call(w,"func"))===(null===(s=r)||void 0===s||null===(l=s.get)||void 0===l?void 0:l.call(s,"func"))&&!!C,L=null,P="func"===E?iv(n,S):av(n,r);if(P&&1==P.length)L=P[0];else if(N)L=C;else if(P&&P.length>1){var x,j=am(h);try{for(j.s();!(x=j.n()).done;){var F=x.value;if("keep"!=F||A?"default"==F?L=Ad(n,r,!1):"first"==F&&(L=sv(n,r)):L=C,L)break}}catch(e){j.e(e)}finally{j.f()}}if(!R&&!O.operators)return console.warn("Type ".concat(O.type," is not supported")),{state:e};b&&!R&&(e=(e=(e=e.setIn(Tu(t,"type"),"rule")).deleteIn(Tu(t,"children1"))).setIn(Tu(t,"properties"),new Il.OrderedMap)),m||(e=e.setIn(Tu(t,"properties"),new Il.OrderedMap));var D=!g;if(R){e=e.setIn(Tu(t,"type"),"rule_group");var k=Hf(n,n,m,r,L,"field",D,d,p),M=(k.canReuseValue,k.newValue),V=k.newValueSrc,U=k.newValueType,B=k.operatorCardinality,G=xd(n,O).merge({field:r,fieldSrc:"field",mode:O.mode});I&&(G=G.merge({operator:L,value:M,valueSrc:V,valueType:U})),e=(e=e.setIn(Tu(t,"children1"),new Il.OrderedMap)).setIn(Tu(t,"properties"),G),O.initialEmptyWhere&&1==B||(e=um(e,t,"rule",Cl(),Nd(n,r),n)),e=Iu(e)}else e=e.updateIn(Tu(t,"properties"),(function(e){return e.withMutations((function(e){var t=Hf(n,n,e,r,L,"field",D,d,p),o=t.canReuseValue,i=t.newValue,a=t.newValueSrc,s=t.newValueType,l=t.newValueError,u=t.newFieldError,c=t.fixedField,f=r;c!==r&&(f=c),g&&(e=(e=e.set("fieldError",u)).set("valueError",l));var v=o?_:Cd(n,L,f);return e=e.set("field",f).delete("fieldType").set("fieldSrc",E).set("operator",L).set("operatorOptions",v).set("value",i).set("valueSrc",a).set("valueType",s),o||(e=e.delete("asyncListValues")),e}))}));return{state:e}},pm=function(e,t,r,n,o,i,a){var s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:{};if(!e.getIn(Tu(t)))return{state:e};var l=s.canDropArgs,u=s.isEndValue,c=i.settings,d=c.fieldSeparator,p=c.showErrorMessage,f=e.getIn(Tu(t,"properties","valueSrc",r+""))||null;"field"===f&&Array.isArray(n)&&(n=n.join(d));var v=e.getIn(Tu(t,"properties","field"))||null,h=e.getIn(Tu(t,"properties","operator"))||null,g=Xh(i,h,v),y=h?Dl(g):null,m=o||lv(n,f,i),b=io($f(i,v,v,h,n,m,f,a,!p,u,l),2),E=b[0],O=b[1],S=null==O?void 0:O.find((function(e){return!e.fixed&&!e.ignore})),T=S?If(S):null,_=E!==n;_&&(n=E),e=fm(e,t,i,y);var w=Array.from({length:y},(function(o,i){return i==r?n:e.getIn(Tu(t,"properties","value",i+""))||null})),R=Array.from({length:y},(function(r,n){return e.getIn(Tu(t,"properties","valueSrc",n+""))||null})),I=zf(i,v,h,w,R),A=I?If(I):null;return(!!p||!T&&!A||_)&&(e=e.deleteIn(Tu(t,"properties","asyncListValues")),void 0===n?e=(e=e.setIn(Tu(t,"properties","value",r),void 0)).setIn(Tu(t,"properties","valueType",r),null):(a&&(e=e.setIn(Tu(t,"properties","asyncListValues"),a)),e=(e=e.setIn(Tu(t,"properties","value",r),n)).setIn(Tu(t,"properties","valueType",r),m))),p&&(e.getIn(Tu(t,"properties","valueError"))||(e=e.setIn(Tu(t,"properties","valueError"),new Il.List(new Array(y)))),e=e.setIn(Tu(t,"properties","valueError",r),T),y>=2&&(e=e.setIn(Tu(t,"properties","valueError",y),A))),{state:e}},fm=function(e,t,r,n){if(!n){var o=e.getIn(Tu(t,"properties","field"))||null,i=e.getIn(Tu(t,"properties","operator"))||null,a=Xh(r,i,o);n=i?Dl(a):null}for(var s=0,l=["value","valueType","valueError","valueSrc"];s<l.length;s++){var u=l[s];e.getIn(Tu(t,"properties",u))||(e=e.setIn(Tu(t,"properties",u),new Il.List(n?Array.from({length:n}):[])))}return e},vm=function e(t,r,n){n&&Array.isArray(n)&&(r.children1=new Il.OrderedMap(n.reduce((function(r,n){var o,i=null!==(o=n.id)&&void 0!==o?o:Cl(),a=im(im({},n),{},{properties:jd(t,n).merge(_l(n.properties)||{}),id:i});return e(t,a,a.children1),im(im({},r),{},eo({},i,new Il.Map(a)))}),{})))},hm={dragging:{id:null,x:null,y:null,w:null,h:null},mousePos:{},dragStart:{id:null}},gm=function(e,t){return{type:zy,tree:t,config:e}},ym=function(e,t,r){var n=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;return{type:ky,ruleType:arguments.length>3&&void 0!==arguments[3]?arguments[3]:"rule",children:arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,path:Bl(t),id:Cl(),properties:Nd(e,n).merge(_l(r)||{}),config:e}},mm=function(e,t){return{type:My,path:Bl(t),config:e}},bm=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:xy,path:Bl(t),children:n,id:Cl(),properties:xd(e).merge(_l(r)||{}),config:e,meta:{isDefaultCase:!0}}},Em=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:xy,path:Bl(t),children:n,id:Cl(),properties:xd(e).merge(_l(r)||{}),config:e}},Om=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:Py,path:Bl(t),children:n,id:Cl(),properties:xd(e).merge(_l(r)||{}),config:e}},Sm=function(e,t){return{type:jy,path:Bl(t),config:e}},Tm=function(e,t,r,n){return{type:Hy,fromPath:Bl(t),toPath:Bl(r),placement:n,config:e}},_m=function(e,t,r){return{type:Fy,path:Bl(t),conjunction:r}},wm=function(e,t,r){return{type:Dy,path:Bl(t),not:r}},Rm=function(e,t,r){return{type:Wy,path:Bl(t),lock:r}},Im=function(e,t,r,n,o){return{type:Vy,path:Bl(t),field:r,config:e,asyncListValues:n,_meta:o}},Am=function(e,t,r){return{type:Uy,path:Bl(t),srcKey:r,config:e}},Cm=function(e,t,r){return{type:By,path:Bl(t),operator:r,config:e}},Nm=function(e,t,r,n,o,i,a){return{type:Gy,path:Bl(t),delta:r,value:n,valueType:o,asyncListValues:i,config:e,_meta:a}},Lm=function(e,t,r,n,o){return{type:$y,path:Bl(t),delta:r,srcKey:n,config:e,_meta:o}},Pm=function(e,t,r,n,o,i,a,s,l){return{type:qy,path:Bl(t),delta:r,parentFuncs:n,argKey:o,value:i,valueType:a,asyncListValues:s,config:e,_meta:l}},xm=function(e,t,r,n){return{type:Ky,path:Bl(t),name:r,value:n,config:e}};function jm(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Fm(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?jm(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):jm(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Dm=Fm(Fm(Fm({},v),{},{Export:c,Import:o,ConfigMixins:Cy},c),o),km=p(7028),Mm=p.n(km);const Vm=function(e,t,r,n,o){var i=im({tree:t},hm);return function(){var t,a,s=arguments.length>0&&void 0!==arguments[0]?arguments[0]:i,l=arguments.length>1?arguments[1]:void 0,u=null!==(t=null!==(a=null==o?void 0:o())&&void 0!==a?a:null==l?void 0:l.config)&&void 0!==t?t:e,c={},d=function(e,t){if(!e||!e.type)return null;var r,n=[zy,em,Zy,tm],o=nm()(uu()(e,["config","asyncListValues"]),Gl),i=e.path&&function(e,t){return e.getIn(Tu(t,"properties","field"))||null}(t.tree,e.path)||e.field;return i&&(null!==(r=i)&&void 0!==r&&r.toJS&&(i=i.toJS()),o.affectedField=i),(n.includes(e.type)||0==e.type.indexOf("@@redux"))&&(o=null),o}(l,s);switch(null==l?void 0:l.type){case zy:var p=r(u,l.tree);c.tree=p;break;case xy:c.tree=lm(s.tree,l.path,"case_group",l.id,l.properties,u,l.children,l.meta);break;case Py:c.tree=lm(s.tree,l.path,"group",l.id,l.properties,u,l.children,l.meta);break;case jy:c.tree=function(e,t,r){if(!e.getIn(Tu(t)))return e;e=cm(e,t);var n=r.settings.canLeaveEmptyGroup,o=t.slice(0,-1);return Fu(e,o)||n||(e=Au(e),!ju(e)||n)||(e=um(e,new Il.List,"rule",Cl(),Nd(r,void 0,void 0,!1,!1),r)),Iu(e)}(s.tree,l.path,u);break;case ky:c.tree=um(s.tree,l.path,l.ruleType,l.id,l.properties,u,l.children);break;case My:c.tree=function(e,t,r){if(!e.getIn(Tu(t)))return e;e=cm(e,t);var n=r.settings.canLeaveEmptyGroup,o=t.pop(),i=e.getIn(Tu(o)),a=i.getIn(["properties","field"]),s=i.getIn(["properties","operator"]),l=a?Qh(r,a):null,u=s?Xh(r,s,a):null,c=a&&s&&0!=u.cardinality,d="rule_group"==i.get("type"),p=!Fu(e,o),f=d?c&&l.initialEmptyWhere:n;return p&&!f&&(d&&(e=e.deleteIn(Tu(o))),e=Au(e),ju(e)&&!n)&&(e=um(e,new Il.List,"rule",Cl(),Nd(r,void 0,void 0,!1,!1),r)),Iu(e)}(s.tree,l.path,u);break;case Fy:c.tree=function(e,t,r){return e.getIn(Tu(t))?e=e.setIn(Tu(t,"properties","conjunction"),r):e}(s.tree,l.path,l.conjunction);break;case Dy:c.tree=function(e,t,r){return e.getIn(Tu(t))?e=e.setIn(Tu(t,"properties","not"),r):e}(s.tree,l.path,l.not);break;case Vy:var f=dm(s.tree,l.path,l.field,u,l.asyncListValues,l._meta).state;c.tree=f;break;case Uy:c.tree=function(e,t,r,n){var o=e.getIn(Tu(t));if(!o)return e;var i=n.settings.keepInputOnChangeFieldSrc,a=o.get("properties"),s=null==a?void 0:a.get("field"),l=null==a?void 0:a.get("fieldType"),u=Qh(n,s),c=(null==u?void 0:u.type)||l;c&&"!group"!==c&&"!struct"!==c||(c=null);var d=!ov.includes(c);return(e=i&&!bv(o,n)&&d?(e=(e=e.setIn(Tu(t,"properties","field"),null)).deleteIn(Tu(t,"properties","fieldError"))).setIn(Tu(t,"properties","fieldType"),c):e.setIn(Tu(t,"properties"),Nd(n,null,null,!1))).setIn(Tu(t,"properties","fieldSrc"),r)}(s.tree,l.path,l.srcKey,u);break;case Wy:c.tree=function(e,t,r){return e.getIn(Tu(t))?e=Ru(e.setIn(Tu(t,"properties","isLocked"),r)):e}(s.tree,l.path,l.lock);break;case By:c.tree=function(e,t,r,n){var o=e.getIn(Tu(t));if(!o)return e;var i=n.settings.showErrorMessage,a=o.get("properties"),s=o.get("children1"),l=a.get("field"),u=(a.get("fieldSrc"),Qh(n,l)),c="!group"==(null==u?void 0:u.type),d=Xh(n,r,l),p=d?Dl(d):null;return e=e.updateIn(Tu(t,"properties"),(function(e){return e.withMutations((function(e){var t=e.get("field"),o=e.get("operatorOptions"),a=(e.get("value",new Il.List),e.get("valueSrc",new Il.List),e.get("operator"),Hf(n,n,e,t,r,"operator",!0)),s=a.canReuseValue,l=a.newValue,u=a.newValueSrc,c=a.newValueType,d=a.newValueError;i&&(e=e.set("valueError",d));var p=s?o:Cd(n,r,t);return s||(e=e.delete("asyncListValues")),e.set("operator",r).set("operatorOptions",p).set("value",l).set("valueSrc",u).set("valueType",c)}))})),c&&0==p&&0==s.size&&(e=um(e,t,"rule",Cl(),Nd(n,l),n)),e}(s.tree,l.path,l.operator,u);break;case Gy:var v=pm(s.tree,l.path,l.delta,l.value,l.valueType,u,l.asyncListValues,l._meta).state;c.tree=v;break;case qy:var h=function(e,t,r,n,o,i,a,s,l){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:{},c=t.getIn(Tu(r));if(!c)return t;var d,p=-1===n,f=c.get("properties"),v=f.get("field"),h=f.get("value"),g=[],y=p?v:h.getIn([n]),m=am(o||[]);try{for(m.s();!(d=m.n()).done;){var b=io(d.value,2),E=b[0],O=b[1];if(g.push([E,O,y]),E!==y.get("func")){var S=g.map((function(e){var t=io(e,2),r=t[0],n=t[1];return"".concat(r,"(").concat(n,")")})).join("/")||"root";throw new Error("In ".concat(p?"LHS":"RHS"," for path ").concat(S," expected func key ").concat(E," but got ").concat(parent.get("func")))}y=y.getIn(["args",O,"value"])}}catch(e){m.e(e)}finally{m.f()}if(i){var T=y.get("func"),_=Uh(e,T).args[i];y="!valueSrc"===s?rv(y,i,a,_,e):tv(y,i,a,_,e)}else y=Xf(y,a,e,!0),u.canDropArgs=!0;for(var w=y;g.length;){var R=io(g.pop(),3),I=R[0],A=R[1],C=R[2],N=Uh(e,I).args[A];w=tv(C,A,w,N,e)}return p?dm(t,r,w,e,l,u):pm(t,r,n,w,void 0,e,l,u)}(u,s.tree,l.path,l.delta,l.parentFuncs,l.argKey,l.value,l.valueType,l.asyncListValues,l._meta),g=h.state;c.tree=g;break;case $y:c.tree=function(e,t,r,n,o){if(!e.getIn(Tu(t)))return e;var i=o.settings.showErrorMessage,a=e.getIn(Tu(t,"properties","field"))||null,s=e.getIn(Tu(t,"properties","operator"))||null,l=Xh(o,s,a),u=s?Dl(l):null;if(e=(e=(e=(e=fm(e,t,o,u)).setIn(Tu(t,"properties","value",r+""),void 0)).setIn(Tu(t,"properties","valueType",r+""),null)).deleteIn(Tu(t,"properties","asyncListValues")),i&&(e=e.setIn(Tu(t,"properties","valueError",r),null),l.validateValues&&(e=e.setIn(Tu(t,"properties","valueError",u),null))),e=void 0===n?e.setIn(Tu(t,"properties","valueSrc",r+""),null):e.setIn(Tu(t,"properties","valueSrc",r+""),n),n){var c=e.getIn(Tu(t,"properties")),d=Hf(o,o,c,a,s,"valueSrc",!0),p=d.canReuseValue,f=d.newValue,v=d.newValueSrc,h=d.newValueType;d.newValueError,p||v.get(r)!=n||(e=(e=e.setIn(Tu(t,"properties","value",r+""),f.get(r))).setIn(Tu(t,"properties","valueType",r+""),h.get(r)))}return e}(s.tree,l.path,l.delta,l.srcKey,u,l._meta);break;case Ky:c.tree=function(e,t,r,n){return e.getIn(Tu(t))?e.setIn(Tu(t,"properties","operatorOptions",r),n):e}(s.tree,l.path,l.name,l.value);break;case Hy:c.tree=function(e,t,r,n,o){var i=wu(e,t),a=t.pop(),s=t.size>1?wu(e,a):null,l=s?s.get("children1"):null,u=wu(e,r),c=n==Xy||n==Jy?r:r.pop(),d=n==Xy||n==Jy?u:r.size>1?wu(e,c):null,p=d?d.get("children1"):null;if(!s||!d||!i)return e;var f=s.get("id")==d.get("id"),v=c.size<a.size&&kl(c.toArray(),a.toArray().slice(0,c.size)),h=c.size>a.size&&kl(a.toArray(),c.toArray().slice(0,a.size)),g=null,y=null;v?g=Il.List(a.toArray().slice(c.size)):h&&(y=Il.List(c.toArray().slice(a.size)));var m=p,b=l;return h||(b=b.delete(i.get("id"))),f?m=b:v&&(m=m.updateIn(_u(g,"children1"),(function(e){return b}))),n==Qy||n==Yy?m=Il.OrderedMap().withMutations((function(e){var t,r=am(m.entries());try{for(r.s();!(t=r.n()).done;){var o=io(t.value,2),a=o[0],s=o[1];a==(null==u?void 0:u.get("id"))&&n==Qy&&e.set(i.get("id"),i),e.set(a,s),a==(null==u?void 0:u.get("id"))&&n==Yy&&e.set(i.get("id"),i)}}catch(e){r.e(e)}finally{r.f()}})):n==Xy?m=m.merge(Il.OrderedMap(eo({},i.get("id"),i))):n==Jy&&(m=Il.OrderedMap(eo({},i.get("id"),i)).merge(m)),h&&(b=(b=b.updateIn(_u(y,"children1"),(function(e){return m}))).delete(i.get("id"))),f||v||(e=e.updateIn(Tu(a,"children1"),(function(e){return b}))),h||(e=e.updateIn(Tu(c,"children1"),(function(e){return m}))),Iu(e)}(s.tree,l.fromPath,l.toPath,l.placement);break;case em:c.dragStart=l.dragStart,c.dragging=l.dragging,c.mousePos=l.mousePos;break;case Zy:c.mousePos=l.mousePos,c.dragging=l.dragging;break;case tm:c.tree=function(e,t){return t.settings.canLeaveEmptyGroup||(e=Au(e)),e}(s.tree,u),c=im(im({},c),hm)}return d&&(c.__lastAction=d),n&&c.tree&&s.tree&&n(s.tree),im(im(im({},s),{__lastAction:void 0}),c)}},Um=ye().createContext();var Bm=p(7694),Gm=p(200),$m="after",qm="before",Km="append",Wm="prepend",zm=function(e,t){return{type:"SET_DRAG_PROGRESS",mousePos:e,dragging:t}},Hm=function(e,t,r){return{type:"SET_DRAG_START",dragStart:e,dragging:t,mousePos:r}},Ym=function(){return{type:"SET_DRAG_END"}},Qm=g,Xm=y,Jm=m,Zm=function(e,t,r){if(!t||!e||e.length<=t)return e;var n=e.substr(0,t-1);return(r?n.substr(0,n.lastIndexOf(" ")):n)+"..."},eb=function(e,t){return e===t||(null==e?void 0:e.equals(t))},tb=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return e===t||(Array.isArray(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=e.length;if(t.length!==n)return!1;for(var o=0;o<n;o++)if(!(r?tb(e[o],t[o],r):e[o]===t[o]))return!1;return!0}(e,t,r):e&&"function"==typeof e.equals?e.equals(t):"object"===Wn(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=Object.keys(e),o=Object.keys(t),i=n.length;if(o.length!==i)return!1;for(var a=0;a<i;a++){var s=n[a];if(!(r?tb(e[s],t[s],r):e[s]===t[s]))return!1}return!0}(e,t,r):e===t)},rb=function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return(null!=e?e:("undefined"!=typeof process&&process.env,0))?console:{error:function(){},log:function(){},warn:function(){},debug:function(){},info:function(){}}}(),nb=Dm.Validation.validateAndFixTree,ob=function e(t){if(t){var r,n=(r=t)._reactRootContainer?"root":Object.getOwnPropertyNames(r).filter((function(e){return e.startsWith("__reactContainer")})).length>0?"container":void 0;return void 0!==n?n:e(t.parentNode)}},ib=function(e){return"root"===ob(e)},ab=function(e,t){return function(r,n){var o=e.props,i=e.state,a=r!=o||n!=i;if(a&&i==n&&o!=r){var s=[];for(var l in r){var u=r[l]!=o[l];u&&("ignore"==t[l]?u=!1:"shallow_deep"==t[l]?u=!tb(r[l],o[l],!0):"shallow"==t[l]?u=!tb(r[l],o[l]):"function"==typeof t[l]&&(u=t[l](r[l],o[l],r,o))),u&&s.push(l)}s.length||(a=!1)}return a}},sb=function(e){return function(t,r){return!tb(e.props,t)||!tb(e.state,r)}},lb=function(e){if(e.shouldComponentUpdate||(e.shouldComponentUpdate=sb(e)),16==(r=ye().version.split(".").map(parseInt.bind(null,10)))[0]&&r[1]<3||r[0]<16)e.componentWillReceiveProps=function(t){e.onPropsChanged(t)};else{var t=e.shouldComponentUpdate;e.shouldComponentUpdate=function(r,n){return!tb(e.props,r)&&e.onPropsChanged(r),t.call(e,r,n)}.bind(e)}var r},ub=function(e,t,r){return nm()(e,(function(e){return function(){for(var n=arguments.length,o=new Array(n),i=0;i<n;i++)o[i]=arguments[i];return r(e.apply(void 0,[t].concat(o)))}}))};function cb(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function db(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?cb(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):cb(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function pb(e,t,r){return t=Xn(t),Qn(e,fb()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function fb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(fb=function(){return!!e})()}var vb=function(e){function t(e){var r;Kn(this,t),(r=pb(this,t,[e])).shouldComponentUpdate=ab(r,{tree:function(e){return e!==r.oldValidatedTree||r.oldValidatedTree!==r.validatedTree}}),lb(r),r._updateActions(e),r.validatedTree=e.getMemoizedTree(e.config,e.tree,void 0,e.sanitizeTree),r.oldValidatedTree=r.validatedTree;var n=e.getBasicConfig(e.config);return e.onInit&&e.onInit(r.validatedTree,n,void 0,r.actions),r}return Zn(t,e),Yn(t,[{key:"_updateActions",value:function(e){var t=e.config,r=e.dispatch;this.actions=ub(db(db(db({},Qm),Xm),Jm),t,r)}},{key:"onPropsChanged",value:function(e){var t=e.onChange,r=this.props.config,n=e.tree,o=(this.props.tree,e.config);if(this.oldValidatedTree=this.validatedTree,this.validatedTree=n,r!==o&&(this._updateActions(e),this.validatedTree=e.getMemoizedTree(o,n,r)),!eb(this.validatedTree,this.oldValidatedTree)){var i=e.getBasicConfig(o);t&&t(this.validatedTree,i,e.__lastAction,this.actions)}}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.renderBuilder,n=e.dispatch;return r({tree:this.validatedTree,actions:this.actions,config:t,dispatch:n})}}])}(ge.Component);vb.propTypes={config:Mm().object.isRequired,onChange:Mm().func,onInit:Mm().func,renderBuilder:Mm().func,tree:Mm().any};var hb=(0,Gm.connect)((function(e){return{tree:e.tree,__lastAction:e.__lastAction}}),null,null,{context:Um})(vb);hb.displayName="ConnectedQuery";const gb=hb;function yb(e,t,r){return t=Xn(t),Qn(e,mb()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function mb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(mb=function(){return!!e})()}var bb=Dm.DefaultUtils.defaultRoot,Eb=Dm.ConfigUtils.createConfigMemo,Ob=function(e){function t(e,r){var n,o,i;Kn(this,t),(i=yb(this,t,[e,r])).setLastTree=function(e){i.prevTree&&(i.prevprevTree=i.prevTree),i.prevTree=e},i.getConfig=function(){return i.config},i.shouldComponentUpdate=ab(i,{value:function(e,t){return!1}}),lb(i);var a=Eb({reactIndex:null!==(n=null===(o=i._reactInternals)||void 0===o?void 0:o.index)&&void 0!==n?n:-1,maxSize:2,canCompile:!0}),s=a.getExtendedConfig,l=a.getBasicConfig,u=a.clearConfigMemo;i.getMemoizedConfig=s,i.getBasicConfig=l,i.clearConfigMemo=u,i.getMemoizedTree=function(){var e,t,r;return function(n,o){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,a=!(arguments.length>3&&void 0!==arguments[3])||arguments[3];return o?n.__configId===r&&(eb(o,e)||eb(o,t))?t:(r=n.__configId,e=o,t=!1===a?nb(o,null,n,i||n,!1,!1,!1):nb(o,null,n,i||n)):null}}();var c=i.getMemoizedConfig(e),d=c.settings.shouldCreateEmptyGroup,p=bb(c,!d),f=!!e.value,v=e.value||p,h=i.getMemoizedTree(c,v,void 0,f),g=Vm(c,h,i.getMemoizedTree,i.setLastTree,i.getConfig),y=(0,Bm.createStore)(g);return i.config=c,i.state={store:y},i.QueryWrapper=function(e){return c.settings.renderProvider(e,c.ctx)},i}return Zn(t,e),Yn(t,[{key:"componentWillUnmount",value:function(){this.clearConfigMemo()}},{key:"onPropsChanged",value:function(e){var t=this.props,r=this.config,n=this.getMemoizedConfig(e),o=r!==n,i=this.state.store.getState().tree,a=!eb(e.value,this.props.value)&&!eb(e.value,i),s=a?e.value||bb(e):i,l=a&&!eb(e.value,this.prevTree)&&!eb(e.value,this.prevprevTree);if(this.sanitizeTree=l||o,o&&(t.settings.renderProvider!==e.settings.renderProvider&&(this.QueryWrapper=function(e){return n.settings.renderProvider(e,n.ctx)}),this.config=n),a||o){var u=this.getMemoizedTree(n,s,r,this.sanitizeTree);this.state.store.dispatch(Qm.setTree(n,u))}}},{key:"render",value:function(){var e=this.props,t=e.renderBuilder,r=e.get_children,n=e.onChange,o=e.onInit,i=this.state.store,a=this.config,s=this.QueryWrapper;return ye().createElement(s,{config:a},ye().createElement(Gm.Provider,{store:i,context:Um},ye().createElement(gb,{config:a,getMemoizedTree:this.getMemoizedTree,getBasicConfig:this.getBasicConfig,sanitizeTree:this.sanitizeTree,onChange:n,onInit:o,renderBuilder:t||r})))}}])}(ge.Component);function Sb(){return Sb=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)({}).hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},Sb.apply(null,arguments)}Ob.propTypes={conjunctions:Mm().object.isRequired,fields:Mm().object.isRequired,types:Mm().object.isRequired,operators:Mm().object.isRequired,widgets:Mm().object.isRequired,settings:Mm().object.isRequired,ctx:Mm().object.isRequired,onChange:Mm().func,onInit:Mm().func,renderBuilder:Mm().func,value:Mm().any};var Tb=p(2584),_b=p.n(Tb);function wb(e,t,r){return t=Xn(t),Qn(e,Rb()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function Rb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Rb=function(){return!!e})()}var Ib=Dm.ConfigUtils.getFieldConfig;function Ab(e,t,r){return t=Xn(t),Qn(e,Cb()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function Cb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Cb=function(){return!!e})()}var Nb=Dm.clone,Lb=Dm.TreeUtils.getFlatTree,Pb=!1,xb=["isDraggingTempo","isDraggingMe","dragging"];function jb(e,t,r){return t=Xn(t),Qn(e,Fb()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function Fb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Fb=function(){return!!e})()}const Db=function(e){return function(t){var r;return r=function(r){function n(e){var t;return Kn(this,n),(t=jb(this,n,[e])).handleDraggerMouseDown=function(e){var r=t.props.id,n=t.wrapper.current;t.props.onDragStart&&t.props.onDragStart(r,n,e)},t.wrapper=ye().createRef(),t}return Zn(n,r),Yn(n,[{key:"render",value:function(){var r=this.props,n=r.isDraggingTempo,o=r.isDraggingMe,i=r.dragging,a=Jg(r,xb),s=a.isTrueLocked,l={};o&&n&&(Pb||(l={top:i.y,left:i.x,width:i.w}));var u=_b()(e,"group-or-rule",o&&n?"qb-draggable":null,o&&!n?"qb-placeholder":null,s?"locked":null);return ye().createElement("div",{className:u,style:l,ref:this.wrapper,"data-id":this.props.id},ye().createElement(t,Sb({handleDraggerMouseDown:this.handleDraggerMouseDown,isDraggingMe:o,isDraggingTempo:n},a)))}}])}(ge.PureComponent),r.propTypes={isDraggingTempo:Mm().bool,isDraggingMe:Mm().bool,onDragStart:Mm().func,dragging:Mm().object,isLocked:Mm().bool,isTrueLocked:Mm().bool},r}};var kb=p(3790),Mb=p.n(kb),Vb=p(350),Ub=p.n(Vb);function Bb(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Gb(e,t,r){return t=Xn(t),Qn(e,$b()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function $b(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return($b=function(){return!!e})()}var qb=Dm.ConfigUtils,Kb=qb.getFieldConfig,Wb=qb.getOperatorConfig,zb=function(e){function t(e){var r;return Kn(this,t),(r=Gb(this,t,[e])).shouldComponentUpdate=ab(r,{selectedField:function(e,t){return!1}}),lb(r),r.onPropsChanged(e),r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","selectedField","selectedFieldSrc","selectedFieldType","selectedOperator"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t,r=e.config,n=e.selectedField,o=e.selectedFieldType,i=e.selectedOperator,a=Kb(r,n),s=so((null==a?void 0:a.operators)||(null===(t=r.types[o])||void 0===t?void 0:t.operators)||[]);n||s.includes(i)||s.push(i);var l=nm()(Ub()(r.operators,(function(e,t){return-1!==(null==s?void 0:s.indexOf(t))})),(function(e,t){return Wb(r,t,n)})),u=this.buildOptions(r,l,s),c=l[i]||{},d=i?[i]:null;return{placeholder:this.props.config.settings.operatorPlaceholder,items:u,selectedKey:i,selectedKeys:d,selectedPath:d,selectedLabel:c.label,selectedAltLabel:c.label2||c.tooltip,selectedOpts:c,fieldConfig:a}}},{key:"buildOptions",value:function(e,t,r){return t&&r?Mb()(t).sort((function(e,t){return r.indexOf(e)-r.indexOf(t)})).map((function(e){var r=t[e];return{key:e,path:e,label:r.label,altLabel:r.label2,tooltip:r.tooltip}})):null}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setOperator,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderOperator,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Bb(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Bb(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({id:i,groupId:a,config:t,customProps:r,readonly:o,setField:n},this.meta);return l.items?s(l,t.ctx):null}}])}(ge.Component);zb.propTypes={id:Mm().string,groupId:Mm().string,config:Mm().object.isRequired,selectedField:Mm().any,selectedFieldId:Mm().string,selectedFieldType:Mm().string,selectedFieldSrc:Mm().string,selectedOperator:Mm().string,readonly:Mm().bool,customProps:Mm().object,setOperator:Mm().func.isRequired};var Hb=["children"],Yb=function(e){var t=e.children,r=Jg(e,Hb);return ye().createElement("div",r,t)},Qb=function(){},Xb=function(){return ye().createElement("svg",{xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 24 24",fill:"gray",width:"18px",height:"18px"},ye().createElement("path",{d:"M0 0h24v24H0V0z",fill:"none"}),ye().createElement("path",{d:"M3 18h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z"}))},Jb=function(e){return function(t){var r=t.config.settings.useConfirm,n=r?r.call(t.config.ctx,t.config.ctx):null;return ye().createElement(e,Sb({},t,{confirmFn:n}))}},Zb=function(e){var t=e.id,r=e.isLHS,n=e.delta;return[t,r?"L":"R",r?-1:n||0,(e.parentFuncs||[]).map((function(e){var t=io(e,2),r=t[0],n=t[1];return"".concat(r,"(").concat(n,")")})).join("/")].join(":")},eE=function(e,t){var r;return"function"==typeof t?(r=function(r){return null==t?void 0:t(r,e.ctx)}).displayName=t.name:r=t,r};function tE(e,t,r){return t=Xn(t),Qn(e,rE()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function rE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(rE=function(){return!!e})()}var nE=function(e){function t(){return Kn(this,t),tE(this,t,arguments)}return Zn(t,e),Yn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.selectedOperator,a=e.setOperator,s=e.selectedFieldId,l=e.showOperator,u=e.showOperatorLabel,c=e.selectedFieldWidgetConfig,d=e.readonly,p=e.id,f=e.groupId;return[l&&ye().createElement(Yb,{key:"operators-for-"+s,className:"rule--operator"},t.settings.showLabels&&ye().createElement("label",{className:"rule--label"},t.settings.operatorLabel),ye().createElement(zb,{key:"operator",config:t,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,selectedFieldId:s,selectedOperator:i,setOperator:a,customProps:t.settings.customOperatorSelectProps,readonly:d,id:p,groupId:f})),u&&ye().createElement(Yb,{key:"operators-for-"+s,className:"rule--operator"},ye().createElement("div",{className:"rule--operator-wrapper"},t.settings.showLabels?ye().createElement("label",{className:"rule--label"}," "):null,ye().createElement("div",{className:"rule--operator-text-wrapper"},ye().createElement("span",{className:"rule--operator-text"},c.operatorInlineLabel))))]}}])}(ge.PureComponent);function oE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function iE(e,t,r){return t=Xn(t),Qn(e,aE()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function aE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(aE=function(){return!!e})()}var sE=Dm.RuleUtils.getFieldPathLabels,lE=Dm.ConfigUtils,uE=lE.getFieldConfig,cE=lE.getFieldParts,dE=lE.getFieldPathParts,pE=function(e){function t(e){var r;return Kn(this,t),(r=iE(this,t,[e])).setField=function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=r.props.id;if(!n.widgetId){var i=[o,"L",-1].join(":");n.widgetId=i}r.props.setField(e,t,n)},lb(r),r.onPropsChanged(e),r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["selectedField","selectedFieldSrc","selectedFieldType","config","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.selectedField,r=e.selectedFieldType,n=e.config,o=e.parentField,i=t,a=n.settings,s=a.maxLabelsLength,l=a.fieldSeparatorDisplay,u=a.fieldPlaceholder,c=(a.fieldSeparator,!!t),d=c?null:Zm(u,s),p=c?uE(n,i):null,f=p||{},v=dE(i,n),h=dE(i,n,!0),g=this.getFieldLabel(p,i,n),y=sE(i,n),m=y?y.join(l):null;(m==g||o)&&(m=null);var b=f.label2||f.tooltip,E=cE(o,n),O=o?uE(n,o):null,S=o?O&&O.subfields:n.fields,T=!c&&r,_=this.buildOptions(E,n,S,T,E),w=T?"Please select field":null;return i&&"object"===Wn(i)&&(i=void 0),{placeholder:d,items:_,parentField:o,selectedKey:i,selectedKeys:v,selectedPath:h,selectedLabel:g,selectedOpts:f,selectedAltLabel:b,selectedFullLabel:m,errorText:w}}},{key:"getFieldLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=cE(t,r),i=(null==e?void 0:e.label)||su()(o);return Zm(i,n)}},{key:"buildOptions",value:function(e,t,r){var n=this,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:void 0,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;if(!r)return null;var s=t.settings,l=s.fieldSeparator,u=s.fieldSeparatorDisplay,c=null!=i&&i.length?i.join(l)+l:"",d=function e(t){return Object.keys(t||{}).reduce((function(r,n){var i=t[n];return"!struct"===i.type?r+e(i.subfields):r+(i.type===o?1:0)}),0)};return Mb()(r).map((function(s){var l=[].concat(so(null!=i?i:[]),[s]),p=r[s],f=n.getFieldLabel(p,l,t),v=sE(l,t).join(u);(v==f||null!=e&&e.length)&&(v=null);var h=p.label2,g=p.tooltip,y=p.disabled;if(!p.hideForSelect){if("!struct"==p.type){var m=n.buildOptions(e,t,p.subfields,o,l,{label:f,tooltip:g}),b=d(p.subfields)>0;return{disabled:y,key:s,path:c+s,label:f,fullLabel:v,altLabel:h,tooltip:g,items:m,matchesType:b}}var E=void 0!==o?p.type===o:void 0;return{disabled:y,key:s,path:c+s,label:f,fullLabel:v,altLabel:h,tooltip:g,grouplabel:null==a?void 0:a.label,group:a,matchesType:E}}})).filter((function(e){return!!e}))}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setFieldSrc,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderField,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?oE(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):oE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({id:i,groupId:a,config:t,customProps:r,readonly:o,setField:this.setField,setFieldSrc:n},this.meta);return s(l,t.ctx)}}])}(ge.Component);function fE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function vE(e,t,r){return t=Xn(t),Qn(e,hE()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function hE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(hE=function(){return!!e})()}pE.propTypes={id:Mm().string,groupId:Mm().string,config:Mm().object.isRequired,selectedField:Mm().any,selectedFieldSrc:Mm().string,selectedFieldType:Mm().string,parentField:Mm().string,customProps:Mm().object,readonly:Mm().bool,setField:Mm().func.isRequired,setFieldSrc:Mm().func};var gE=Dm.clone,yE=Dm.ConfigUtils,mE=yE.getFieldConfig,bE=yE.getFuncConfig,EE=yE.getFieldParts,OE=yE.getFieldPathParts,SE=Dm.RuleUtils,TE=SE.getFuncPathLabels,_E=SE.getWidgetForFieldOp,wE=Dm.OtherUtils.shallowEqual,RE=function(e){function t(e){var r;return Kn(this,t),r=vE(this,t,[e]),lb(r),r.onPropsChanged(e),r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.items||["config","field","fieldType","fieldSrc","operator","isFuncArg","isLHS","parentFuncs"].map((function(r){return"parentFuncs"===r?!wE(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0;(!this.meta||["config","field","fieldType","fieldSrc","value","isLHS"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),r&&(this.items=this.getItems(e,this.meta))}},{key:"getItems",value:function(e,t){var r=e.config,n=e.field,o=e.fieldType,i=e.isLHS,a=e.operator,s=e.parentFuncs,l=e.fieldDefinition,u=e.isFuncArg,c=t.lookingForFieldType,d=r.settings.canUseFuncForField,p=this.filterFuncs(r,r.funcs,n,o,i,a,d,s,u,l);return this.buildOptions(r,p,c)}},{key:"getMeta",value:function(e){var t=e.config,r=(e._field,e.fieldType),n=e.value,o=e.isLHS,i=e.isFuncArg,a=t.settings,s=a.funcPlaceholder,l=a.fieldSeparatorDisplay,u=n,c=!!n,d=c?null:s,p=c?bE(t,u):null,f=p||{},v=OE(u,t),h=OE(u,t,!0),g=this.getFuncLabel(p,u,t),y=TE(u,t),m=y?y.join(l):null;m==g&&(m=null);var b=o&&!i&&!c&&r;return{placeholder:d,selectedKey:u,selectedKeys:v,selectedPath:h,selectedLabel:g,selectedOpts:f,selectedFullLabel:m,errorText:b?"Please select function":null,lookingForFieldType:b}}},{key:"filterFuncs",value:function(e,t,r,n,o,i,a,s,l,u){t=gE(t);var c,d=e.settings.fieldSeparator,p=mE(e,r),f=p,v=_E(e,r,i,"value");return v&&e.widgets[v],l?(f=u,c=null==u?void 0:u.type):p?c=p.type:o||(c=n),function t(n,o){for(var l in n){var u=n[l].subfields,v=(o||[]).concat(l),h=v.join(d),g=bE(e,h);if("!struct"==g.type)0==t(u,v)&&delete n[l];else{var y,m=!c||g.returnType==c;null!==(y=f)&&void 0!==y&&y.funcs&&(m=m&&f.funcs.includes(h)),a&&(m=m&&a(r,p,h,g,i)),!g.allowSelfNesting&&s&&s.map((function(e){var t=io(e,2),r=t[0];return t[1],r})).includes(h)&&(m=!1),m||delete n[l]}}return Mb()(n).length}(t,[]),t}},{key:"buildOptions",value:function(e,t){var r=this,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!t)return null;var a=e.settings,s=a.fieldSeparator,l=a.fieldSeparatorDisplay,u=null!=o&&o.length?o.join(s)+s:"",c=function e(t){return Object.keys(t||{}).reduce((function(r,o){var i=t[o];return"!struct"===i.type?r+e(i.subfields):r+(i.type===n?1:0)}),0)};return Mb()(t).map((function(a){var s=[].concat(so(null!=o?o:[]),[a]),d=t[a],p=r.getFuncLabel(d,s,e),f=TE(s,e).join(l);f==p&&(f=null);var v=d.tooltip;if("!struct"==d.type){var h=r.buildOptions(e,d.subfields,n,s,{label:p,tooltip:v}),g=c(d.subfields)>0;return{key:a,path:u+a,label:p,fullLabel:f,tooltip:v,items:h,matchesType:g}}var y=void 0!==n?d.returnType===n:void 0;return{key:a,path:u+a,label:p,fullLabel:f,tooltip:v,grouplabel:null==i?void 0:i.label,group:i,matchesType:y}}))}},{key:"getFuncLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=EE(t,r),i=(null==e?void 0:e.label)||su()(o);return Zm(i,n)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setValue,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderFunc,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?fE(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):fE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({config:t,customProps:r,readonly:o,setField:n,items:this.items,id:i,groupId:a},this.meta);return s(l,t.ctx)}}])}(ge.Component);RE.propTypes={id:Mm().string,groupId:Mm().string,config:Mm().object.isRequired,field:Mm().any,fieldType:Mm().string,fieldSrc:Mm().string,operator:Mm().string,customProps:Mm().object,value:Mm().string,setValue:Mm().func.isRequired,readonly:Mm().bool,parentFuncs:Mm().array,fieldDefinition:Mm().object,isFuncArg:Mm().bool,isLHS:Mm().bool};var IE=p(2285),AE=p.n(IE),CE=["widgetFactory"],NE=["factory"];function LE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function PE(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?LE(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):LE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var xE=Dm.ListUtils.getTitleInListValues,jE=Dm.ConfigUtils._widgetDefKeysToOmit,FE=Dm.TreeUtils,DE=FE._fixImmutableValue,kE=FE.isImmutable,ME=(0,ge.memo)((function(e){var t=e.widgetFactory,r=Jg(e,CE),n=r.config,o=r.isFuncArg,i=r.fieldDefinition||{},a=i.fieldSettings,s=i.defaultValue,l=i.valueSources,u=o&&1==(null==l?void 0:l.length)&&"const"===(null==l?void 0:l[0]),c=(null==a?void 0:a.treeValues)||(null==a?void 0:a.listValues);return u&&s?"boolean"==typeof s?s?r.labelYes||"YES":r.labelNo||"NO":c?Array.isArray(s)?s.map((function(e){return xE(c,e)||e})).join(", "):xE(c,s)||s:""+s:t?t(r,n.ctx):"?"}));ME.displayName="WidgetFactoryMemo";var VE=function(e){var t=e.delta,r=e.isFuncArg,n=e.valueSrc,o=e.value,i=e.valueError,a=e.fieldError,s=e.asyncListValues,l=e.isSpecialRange,u=e.fieldDefinition,c=e.widget,d=e.widgetDefinition,p=e.widgetValueLabel,f=e.valueLabels,v=e.textSeparators,h=e.setValue,g=e.setFuncValue,y=e.config,m=e.field,b=e.fieldSrc,E=e.fieldPath,O=e.fieldType,S=e.isLHS,T=e.operator,_=e.readonly,w=e.parentField,R=e.parentFuncs,I=e.id,A=e.groupId,C=e.widgetId,N=d.factory,L=Jg(d,NE),P=o?o.map((function(e){return DE(e)})):void 0,x=(0,ge.useMemo)((function(){if(l){var e=[null==P?void 0:P.get(0),null==P?void 0:P.get(1)];return void 0===e[0]&&void 0===e[1]&&(e=void 0),e}return null==P?void 0:P.get(t)}),[l,o]),j=(0,ge.useMemo)((function(){return i?l?[i.get(0),i.get(1),i.get(2)]:null==i?void 0:i.get(t):null}),[l,o]),F=S?a:j,D=(u||{}).fieldSettings,k=p.label,M=p.placeholder,V=f?f.placeholder:null,U=kE(m)?null:m,B=uu()(PE(PE(PE({},L),D),{},{config:y,field:U,fieldPath:E,fieldSrc:b,fieldType:O,isLHS:S,parentField:w,parentFuncs:R,fieldDefinition:u,operator:T,delta:t,isSpecialRange:l,isFuncArg:r,value:x,valueSrc:n,valueError:j,fieldError:a,errorMessage:F,label:k,placeholder:M,placeholders:V,textSeparators:v,setValue:h,setFuncValue:g,readonly:_,asyncListValues:s,id:I,groupId:A,widgetId:C,widgetFactory:N,widget:c}),[].concat(so(jE),["toJS"]));return ye().createElement(ME,Sb({widgetFactory:N},B))};VE.displayName="WidgetFactory";const UE=VE;function BE(e,t,r){return t=Xn(t),Qn(e,GE()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function GE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(GE=function(){return!!e})()}var $E=Dm.ConfigUtils,qE=$E.getFieldConfig,KE=$E.getOperatorConfig,WE=$E.getFieldWidgetConfig,zE=Dm.RuleUtils,HE=zE.getValueSourcesForFieldOp,YE=zE.getWidgetForFieldOp,QE=zE.getValueLabel,XE=Dm.DefaultUtils.createListWithOneElement,JE=Dm.OtherUtils.shallowEqual,ZE=(Dm.TreeUtils.isImmutable,{cardinality:1}),eO=function(e){function t(e){var r;return Kn(this,t),(r=BE(this,t,[e]))._setValue=function(e,t,n,o,i,a){var s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:{};if(s.widgetId||(s.widgetId=o),e&&Array.isArray(i)){var l=[r.props.value.get(0),r.props.value.get(1)];l[0]!=i[0]&&r.props.setValue(0,i[0],n,a,s),l[1]!=i[1]&&r.props.setValue(1,i[1],n,a,s)}else r.props.setValue(t,i,n,a,s)},r._setValueSrc=function(e,t,n){var o={widgetId:t};r.props.setValueSrc(e,n,o)},r.renderWidget=function(e,t,r){var n=r.config,o=r.isFuncArg,i=r.leftField,a=r.operator,s=r.value,l=r.valueError,u=r.fieldError,c=r.readonly,d=r.parentField,p=r.parentFuncs,f=r.id,v=r.groupId,h=r.fieldSrc,g=r.fieldType,y=r.isLHS,m=r.setFuncValue,b=n.settings,E=t.widgets,O=t.iValues,S=t.aField,T=t.valueSources,_=o?O:s,w=o?i:S,R=E[e],I=R.valueSrc,A=R.valueLabel,C=R.widgetId,N=T.length>1&&!c,L=b.showLabels?ye().createElement("label",{key:"label-"+C,className:"rule--label"},A.label):null;return ye().createElement("div",{key:"wrapper-"+C,className:_b()("func"===I?"widget--func":"widget--widget",N?"widget--has-valuerscs":"widget--has-no-valuerscs")},"func"===I?null:L,ye().createElement(UE,Sb({key:C,id:f,groupId:v,widgetId:C,valueSrc:I,delta:e,value:_,valueError:l,fieldError:u,isFuncArg:o,isLHS:y},iu()(t,["isSpecialRange","fieldDefinition","asyncListValues"]),iu()(E[e],["widget","widgetDefinition","widgetValueLabel","valueLabels","textSeparators","setValue"]),{setFuncValue:m,config:n,field:w,fieldSrc:h,fieldType:g,parentField:d,parentFuncs:p,operator:a,readonly:c})))},r.renderValueSources=function(e,t,n){var o=n.config,i=n.isFuncArg,a=n.leftField,s=n.operator,l=n.readonly,u=o.settings,c=t.valueSources,d=t.widgets,p=t.aField,f=t.valueSourcesOptions,v=i?a:p,h=d[e],g=h.valueSrc,y=h.setValueSrc,m=r.ValueSources,b=u.showLabels?ye().createElement("label",{className:"rule--label"}," "):null;return c.length>1&&!l&&ye().createElement("div",{key:"wrapper-valuesrc-"+e,className:"widget--valuesrc"},b,ye().createElement(m,{key:"valuesrc-"+e,delta:e,valueSources:f,valueSrc:g,config:o,field:v,operator:s,setValueSrc:y,readonly:l,title:u.valueSourcesPopupTitle}))},r.renderSep=function(e,t,r){var n=r.config,o=t.widgets,i=n.settings,a=o[e].sepText,s=i.showLabels?ye().createElement("label",{className:"rule--label"}," "):null;return a&&ye().createElement("div",{key:"widget-separators-"+e,className:_b()("widget--sep",0==e&&"widget--sep-first")},s,ye().createElement("span",null,a))},r.renderWidgetDelta=function(e){return[r.renderSep(e,r.meta,r.props),r.renderValueSources(e,r.meta,r.props),r.renderWidget(e,r.meta,r.props)]},lb(r),r.onPropsChanged(e),r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.ValueSources||(null==t?void 0:t.config)!==(null==e?void 0:e.config),n=["config","id","parentFuncs","field","fieldId","fieldSrc","fieldType","fieldFunc","fieldArg","leftField","operator","valueSrc","asyncListValues","isLHS","isFuncArg","isForRuleGroup","isCaseValue","value"].filter((function(r){return"parentFuncs"===r?!JE(e[r],t[r],!0):"field"===r?e.fieldId!==t.fieldId:e[r]!==t[r]}));if((!this.meta||n.length>0)&&(this.meta=this.getMeta(e,n)),r){var o=e.config,i=o.settings.renderValueSources;this.ValueSources=eE(o,i)}}},{key:"getMeta",value:function(e){var t,r,n,o,i=this,a=e.config,s=e.field,l=(e.fieldSrc,e.fieldType),u=e.fieldFunc,c=e.fieldArg,d=e.operator,p=e.valueSrc,f=e.value,v=e.isForRuleGroup,h=e.isCaseValue,g=e.isFuncArg,y=(e.leftField,e.asyncListValues),m=e.parentFuncs,b=e.isLHS,E=e.id,O=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],S=a.settings.valueSourcesInfo,T=g?{func:u,arg:c}:s,_=!s&&l,w=p,R=f;(g||v||h)&&(w=XE(p),R=XE(f));var I=qE(a,T);!I&&_&&(I=a.types[l]);var A,C=YE(a,T,d);!C&&_&&(C=null===(A=a.types[l])||void 0===A?void 0:A.mainWidget);var N=g?ZE:KE(a,d,T);if((null==I||null==N)&&!h)return null;var L,P,x=null==N?void 0:N.isSpecialRange,j=x&&("field"===(null===(t=w)||void 0===t?void 0:t.get(0))||"field"===(null===(r=w)||void 0===r?void 0:r.get(1))),F=x&&!j,D=F?1:null!==(P=null==(L=N)?void 0:L.cardinality)&&void 0!==P?P:1;if(0===D)return null;var k=null===(n=this.meta)||void 0===n?void 0:n.valueSources,M=null===(o=this.meta)||void 0===o?void 0:o.valueSourcesOptions;k&&!["field","operator","config","fieldDefinition","isForRuleGroup"].filter((function(e){return O.includes(e)})).length||(k=HE(a,T,d,I),v&&(k=["value"]),T||(k=Object.keys(S)),M=k.map((function(e){return[e,{label:S[e].label}]})));var V=AE()(0,D).map((function(e){var t,r,n,o,s=null===(t=i.meta)||void 0===t||null===(t=t.widgets)||void 0===t?void 0:t[e],l=(null===(r=w)||void 0===r?void 0:r.get(e))||null,u=YE(a,T,d,l),c=WE(a,T,d,u,l);j&&(u=c.singleWidget,c=WE(a,T,d,u,l)),!c&&_&&(u=["func","field"].includes(l)?l:C,c=a.widgets[u]);var p=null===(n=c)||void 0===n?void 0:n.type,f=QE(a,T,d,e,l,F),v=QE(a,T,d,e,null,F),h=null!=N&&N.textSeparators?null==N?void 0:N.textSeparators[e]:null,g=null,y=null;x&&(g={placeholder:[(g=[QE(a,T,d,0),QE(a,T,d,1)])[0].placeholder,g[1].placeholder],label:[g[0].label,g[1].label]},y=null==N?void 0:N.textSeparators);var O=Zb({id:E,isLHS:b,delta:e,parentFuncs:m}),S=O+":VS",R=null==s?void 0:s.setValueSrc;R&&(null==s?void 0:s.widgetId)===O||(R=i._setValueSrc.bind(i,e,S));var I=null==s?void 0:s.setValue;return I&&(null==s?void 0:s.widgetId)===O&&(null==s?void 0:s.widgetType)===p&&(null===(o=i.meta)||void 0===o?void 0:o.isSpecialRange)===x||(I=i._setValue.bind(i,x,e,p,O)),{valueSrc:l,valueLabel:f,widget:u,sepText:h,widgetDefinition:c,widgetValueLabel:v,valueLabels:g,textSeparators:y,setValueSrc:R,setValue:I,widgetId:O,widgetType:p}}));return{defaultWidget:C,fieldDefinition:I,operatorDefinition:N,isSpecialRange:F,cardinality:D,valueSources:k,valueSourcesOptions:M,widgets:V,iValues:R,aField:T,asyncListValues:y}}},{key:"render",value:function(){if(!this.meta)return null;var e=this.meta,t=e.defaultWidget,r=e.cardinality;if(!t)return null;var n=t;return ye().createElement(Yb,{className:"rule--widget rule--widget--".concat(n.toUpperCase()),key:"widget-col-"+n},AE()(0,r).map(this.renderWidgetDelta))}}])}(ge.Component);function tO(e,t,r){return t=Xn(t),Qn(e,rO()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function rO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(rO=function(){return!!e})()}eO.propTypes={config:Mm().object.isRequired,value:Mm().any,valueSrc:Mm().any,valueError:Mm().any,fieldError:Mm().string,field:Mm().any,fieldSrc:Mm().string,fieldType:Mm().string,fieldId:Mm().string,operator:Mm().string,readonly:Mm().bool,asyncListValues:Mm().array,id:Mm().string,groupId:Mm().string,setValue:Mm().func,setValueSrc:Mm().func,setFuncValue:Mm().func,isFuncArg:Mm().bool,fieldFunc:Mm().string,fieldArg:Mm().string,leftField:Mm().any,isForRuleGroup:Mm().bool,parentField:Mm().string,parentFuncs:Mm().array,isLHS:Mm().bool,isCaseValue:Mm().bool};var nO=Dm.ConfigUtils.getFuncConfig,oO=Dm.OtherUtils.shallowEqual,iO=function(e){function t(e){var r;return Kn(this,t),(r=tO(this,t,[e])).setFunc=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=r.props,o=n.isLHS,i=n.delta,a=n.parentFuncs,s=n.id;if(!t.widgetId){var l=Zb({id:s,isLHS:o,delta:i,parentFuncs:a});t.widgetId=l}r.props.setFuncValue(o?-1:i||0,a,null,e,"!func",void 0,t)},r.setArgValue=function(e,t,n,o,i){var a=r.props,s=(a.config,a.delta),l=a.isLHS,u=a.parentFuncs;r.props.setFuncValue(l?-1:s||0,u,e,t,n,o,i)},r.setArgValueSrc=function(e,t,n){var o=r.props,i=(o.config,o.delta),a=o.isLHS,s=o.parentFuncs;r.props.setFuncValue(a?-1:i||0,s,e,t,"!valueSrc",void 0,n)},r.renderFuncSelect=function(){var e,t,n=r.props,o=n.config,i=n.field,a=n.fieldType,s=n.fieldSrc,l=n.isLHS,u=n.operator,c=n.customProps,d=n.value,p=n.readonly,f=n.parentFuncs,v=n.id,h=n.groupId,g=n.isFuncArg,y=n.fieldDefinition,m={value:null!==(e=null==d||null===(t=d.get)||void 0===t?void 0:t.call(d,"func"))&&void 0!==e?e:null,setValue:r.setFunc,config:o,field:i,fieldType:a,fieldSrc:s,isLHS:l,operator:u,customProps:c,readonly:p,parentFuncs:f,isFuncArg:g,fieldDefinition:y,id:v,groupId:h},b=o.settings,E=b.showLabels,O=b.funcLabel,S=E?ye().createElement("label",{className:"rule--label"},O):null;return ye().createElement(Yb,{key:"func",className:"rule--func"},S,ye().createElement(RE,m))},r.renderArgLabel=function(e,t){var n=t.valueSources,o=t.type,i=t.showPrefix,a=t.label,s=r.props.config,l=n&&1==n.length&&"const"==n[0];return s.settings.showLabels||"boolean"!=o&&!l||!i?null:ye().createElement(Yb,{className:"rule--func--arg-label"},a||e)},r.renderArgLabelSep=function(e,t){var n=t.valueSources,o=t.type,i=t.showPrefix,a=r.props.config,s=n&&1==n.length&&"const"==n[0];return a.settings.showLabels||"boolean"!=o&&!s||!i?null:ye().createElement(Yb,{className:"rule--func--arg-label-sep"},":")},r.renderArgVal=function(e,t,n){var o=r.props,i=o.config,a=o.field,s=o.fieldType,l=o.fieldSrc,u=o.isLHS,c=(o.operator,o.value),d=o.readonly,p=o.parentFuncs,f=o.id,v=o.groupId,h=o.fieldError,g=o.valueError,y=o.setFuncValue,m=c?c.getIn(["args",t]):null,b=m?m.get("value"):void 0,E=1==n.valueSources.length?n.valueSources[0]:void 0,O={config:i,fieldFunc:e,fieldArg:t,leftField:a,fieldType:s,fieldSrc:l,fieldError:h,valueError:g,isLHS:u,operator:null,value:b,valueSrc:m?m.get("valueSrc")||E||"value":E,setValue:r.setArgValue,setValueSrc:r.setArgValueSrc,setFuncValue:y,funcKey:e,argKey:t,argDefinition:n,readonly:d,parentFuncs:p,id:f,groupId:v};return ye().createElement(Yb,{className:"rule--func--arg-value"},ye().createElement(aO,O))},r.renderArgSep=function(e,t,r,n){var o=n.renderSeps;return r?ye().createElement(Yb,{className:"rule--func--arg-sep"},o?o[r-1]:", "):null},r.renderBracketBefore=function(e){var t=e.renderBrackets;return ye().createElement(Yb,{key:"before_args",className:"rule--func--bracket-before"},t?t[0]:"(")},r.renderBracketAfter=function(e){var t=e.renderBrackets;return ye().createElement(Yb,{key:"after_args",className:"rule--func--bracket-after"},t?t[1]:")")},r.renderFuncArgs=function(){var e=r.meta,t=e.funcDefinition,n=e.funcKey;if(!n)return null;var o=(t||{}).args;return o?ye().createElement(ye().Fragment,null,r.renderBracketBefore(t),ye().createElement(Yb,{key:"args-".concat(n),className:"rule--func--args rule--func--".concat(n,"--args")},Object.keys(o).map((function(e,i){return ye().createElement(Yb,{key:"arg-".concat(e,"-").concat(i),className:"rule--func--arg rule--func--".concat(n,"--arg--").concat(e)},r.renderArgSep(e,o[e],i,t),r.renderArgLabel(e,o[e]),r.renderArgLabelSep(e,o[e]),r.renderArgVal(n,e,o[e]))}))),r.renderBracketAfter(t)):null},lb(r),r.onPropsChanged(e),r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","field","operator","value","fieldSrc","fieldType","isLHS"].map((function(r){return"parentFuncs"===r?!oO(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t,r,n=e.config,o=(e.field,e.operator,e.value),i=null!==(t=null==o||null===(r=o.get)||void 0===r?void 0:r.call(o,"func"))&&void 0!==t?t:null;return{funcDefinition:i?nO(n,i):null,funcKey:i}}},{key:"render",value:function(){var e=this.props.parentFuncs,t=e?e.map((function(e){var t=io(e,2),r=t[0],n=t[1];return"".concat(r,"_").concat(n)})).join("-"):"root",r=(null==e?void 0:e.length)||0;return ye().createElement(Yb,{className:"rule--func--wrapper rule--func--wrapper--under-".concat(t," rule--func--wrapper--lev-").concat(r)},this.renderFuncSelect(),this.renderFuncArgs())}}])}(ge.Component);iO.propTypes={id:Mm().string,groupId:Mm().string,config:Mm().object.isRequired,field:Mm().any,fieldSrc:Mm().string,fieldType:Mm().string,fieldError:Mm().string,operator:Mm().string,customProps:Mm().object,value:Mm().object,setValue:Mm().func.isRequired,setFuncValue:Mm().func,readonly:Mm().bool,parentFuncs:Mm().array,fieldDefinition:Mm().object,isFuncArg:Mm().bool,isLHS:Mm().bool,valueError:Mm().string};var aO=function(e){function t(e){var r;return Kn(this,t),(r=tO(this,t,[e])).setValue=function(e,t,n,o,i){var a=r.props;(0,a.setValue)(a.argKey,t,n,o,i)},r.setValueSrc=function(e,t,n){var o=r.props;(0,o.setValueSrc)(o.argKey,t,n)},lb(r),r.onPropsChanged(e),r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["parentFuncs","funcKey","argKey"].map((function(r){return"parentFuncs"===r?!oO(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.parentFuncs,r=e.funcKey,n=e.argKey;return{parentFuncs:[].concat(so(t||[]),[[r,n]])}}},{key:"render",value:function(){var e=this.meta.parentFuncs;return ye().createElement(eO,Sb({},this.props,{setValue:this.setValue,setValueSrc:this.setValueSrc,isFuncArg:!0,parentFuncs:e}))}}])}(ge.Component);function sO(e,t,r){return t=Xn(t),Qn(e,lO()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function lO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(lO=function(){return!!e})()}aO.propTypes={funcKey:Mm().string.isRequired,argKey:Mm().string.isRequired,setValue:Mm().func.isRequired,setValueSrc:Mm().func.isRequired,readonly:Mm().bool,isLHS:Mm().bool,parentFuncs:Mm().array,id:Mm().string,groupId:Mm().string};var uO=function(e){function t(e){var r;return Kn(this,t),(r=sO(this,t,[e])).renderField=function(){var e=r.props,t=e.config,n=e.classname,o=e.selectedField,i=e.selectedFieldSrc,a=e.selectedFieldType,s=e.setField,l=e.setFuncValue,u=e.parentField,c=e.readonly,d=e.id,p=e.groupId,f=e.fieldError,v=e.valueError;if(!["func","field"].includes(i))return"?";var h="func"===i?ye().createElement(iO,{isLHS:!0,config:t,value:o,fieldSrc:i,fieldType:a,fieldError:f,valueError:v,parentField:u,setValue:s,setFuncValue:l,readonly:c,id:d,groupId:p,key:"field-func-"+d}):ye().createElement(pE,{config:t,selectedField:o,selectedFieldSrc:i,selectedFieldType:a,parentField:u,setField:s,customProps:t.settings.customFieldSelectProps,readonly:c,id:d,groupId:p,key:"field-"+d}),g="func"===i?t.settings.funcLabel:t.settings.fieldLabel,y=t.settings.showLabels&&"func"!==i&&ye().createElement("label",{className:"rule--label"},g);return ye().createElement("div",{key:i,className:n},y,h)},r.renderFieldSources=function(){if(!r.meta)return null;var e=r.props,t=e.config,n=e.readonly,o=e.selectedFieldSrc,i=e.setFieldSrc,a=e.id,s=r.meta.fieldSourcesOptions,l=t.settings,u=r.ValueSources,c=l.showLabels?ye().createElement("label",{className:"rule--label"}," "):null;return s.length>1&&!n&&ye().createElement("div",{key:"fieldsrc",className:"rule--fieldsrc"},c,ye().createElement(u,{key:"fieldsrc-"+a,valueSources:s,valueSrc:o,config:t,setValueSrc:i,readonly:n,title:l.fieldSourcesPopupTitle}))},lb(r),r.onPropsChanged(e),r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.ValueSources||(null==t?void 0:t.config)!==(null==e?void 0:e.config);if((!this.meta||["config"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),r){var n=e.config,o=n.settings.renderValueSources;this.ValueSources=function(e){return o(e,n.ctx)}}}},{key:"getMeta",value:function(e){var t=e.config.settings,r=t.valueSourcesInfo;return{fieldSourcesOptions:t.fieldSources.map((function(e){return[e,{label:r[e].label}]}))}}},{key:"render",value:function(){var e=this.props,t=(e.classname,e.canSelectFieldSource),r=t&&this.renderFieldSources(),n=this.renderField();return t?ye().createElement(Yb,{className:"rule--field-wrapper"},r,n):n}}])}(ge.Component),cO=["factory"];function dO(e,t,r){return t=Xn(t),Qn(e,pO()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function pO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(pO=function(){return!!e})()}var fO=Dm.ConfigUtils.getOperatorConfig,vO=function(e){function t(){return Kn(this,t),dO(this,t,arguments)}return Zn(t,e),Yn(t,[{key:"render",value:function(){if(!this.props.selectedOperator)return null;var e=fO(this.props.config,this.props.selectedOperator,this.props.selectedField);if(void 0===e.options)return null;var t=e.options,r=t.factory,n=Jg(t,cO),o=r(Object.assign({},n,{config:this.props.config,field:this.props.selectedField,fieldSrc:this.props.selectedFieldSrc,operator:this.props.selectedOperator,options:this.props.operatorOptions,setOption:this.props.setOperatorOption,readonly:this.props.readonly}),this.props.config.ctx),i=this.props.selectedOperator;return ye().createElement("div",{className:"rule--operator rule--operator--".concat(i.toUpperCase())},o)}}])}(ge.PureComponent);function hO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function gO(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?hO(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):hO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function yO(e,t,r){return t=Xn(t),Qn(e,mO()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function mO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(mO=function(){return!!e})()}vO.propTypes={config:Mm().object.isRequired,operatorOptions:Mm().any.isRequired,selectedField:Mm().any,selectedFieldSrc:Mm().string,selectedOperator:Mm().string.isRequired,readonly:Mm().bool,setOperatorOption:Mm().func.isRequired};var bO=Dm.ConfigUtils,EO=bO.getFieldConfig,OO=bO.getOperatorConfig,SO=bO.getFieldWidgetConfig,TO=bO.getFieldId,_O=Dm.RuleUtils.isEmptyRuleProperties,wO=function(e){function t(e){var r;return Kn(this,t),r=yO(this,t,[e]),lb(r),r.removeSelf=r.removeSelf.bind(r),r.setLock=r.setLock.bind(r),r.onPropsChanged(e),r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var t=this,r=this.props,n=!this.Icon||(null==r?void 0:r.config)!==(null==e?void 0:e.config);if((!this.meta||["selectedField","selectedFieldSrc","selectedFieldType","selectedOperator","config","reordableNodesCnt","isLocked"].map((function(t){return e[t]!==r[t]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),n){var o=e.config,i=o.settings,a=i.renderIcon,s=i.renderButton,l=i.renderButtonGroup,u=i.renderSwitch,c=i.renderBeforeWidget,d=i.renderAfterWidget,p=i.renderRuleError;this.Icon=eE(o,a),this.Btn=eE(o,s),this.BtnGrp=eE(o,l),this.Switch=eE(o,u),this.BeforeWidget=eE(o,c),this.AfterWidget=eE(o,d),this.RuleError=eE(o,p)}this.doRemove=function(){t.props.removeSelf()}}},{key:"getMeta",value:function(e){var t=e.selectedField,r=e.selectedFieldType,n=e.selectedOperator,o=e.config,i=e.reordableNodesCnt,a=e.isLocked,s=o.settings.keepInputOnChangeFieldSrc,l=TO(t,o),u=EO(o,t),c=u&&"!struct"===u.type,d=!!t||s&&r,p=d&&n,f=OO(o,n,t),v=f&&null!=f.options,h=SO(o,t,n,null,null)||{},g=h.hideOperator;return{selectedFieldId:l,selectedFieldWidgetConfig:h,showDragIcon:o.settings.canReorder&&i>1&&!a,showOperator:d&&!g,showOperatorLabel:d&&g&&h.operatorInlineLabel,showWidget:p&&!c,showOperatorOptions:p&&v}}},{key:"setLock",value:function(e){this.props.setLock(e)}},{key:"removeSelf",value:function(){var e=this.props,t=e.confirmFn,r=e.config,n=r.settings,o=n.renderConfirm,i=n.removeRuleConfirmOptions;i&&!this.isEmptyCurrentRule()?o.call(r.ctx,gO(gO({},i),{},{onOk:this.doRemove,onCancel:null,confirmFn:t}),r.ctx):this.doRemove()}},{key:"_buildWidgetProps",value:function(e,t){var r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.selectedOperator,a=e.operatorOptions,s=e.value,l=e.valueType,u=e.valueSrc,c=e.asyncListValues,d=e.valueError,p=e.fieldError,f=e.parentField;return{field:r,fieldSrc:n,fieldType:o,fieldId:t.selectedFieldId,operator:i,operatorOptions:a,value:s,valueType:l,valueSrc:u,asyncListValues:c,valueError:d,fieldError:p,parentField:f}}},{key:"isEmptyCurrentRule",value:function(){var e=this.props.config,t=this._buildWidgetProps(this.props,this.meta);return _O(t,e)}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.parentField,o=e.groupId,i=e.id,a=e.selectedFieldSrc,s=e.selectedField,l=e.selectedFieldType,u=e.setField,c=e.setFuncValue,d=e.setFieldSrc,p=e.fieldError,f=t.settings.immutableFieldsMode,v=this.meta.selectedFieldId;return ye().createElement(uO,{key:"field",classname:_b()("func"==a?"rule--field--func":"rule--field"),config:t,canSelectFieldSource:!n,selectedField:s,selectedFieldSrc:a,selectedFieldType:l,selectedFieldId:v,fieldError:p,setField:f?Qb:u,setFuncValue:f?Qb:c,setFieldSrc:f?Qb:d,parentField:n,readonly:f||r,id:i,groupId:o})}},{key:"renderOperator",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=this.meta,o=n.selectedFieldId,i=n.selectedFieldWidgetConfig,a=n.showOperator,s=n.showOperatorLabel,l=t.settings.immutableOpsMode;return ye().createElement(nE,{key:"operator",config:t,selectedField:this.props.selectedField,selectedFieldSrc:this.props.selectedFieldSrc,selectedFieldType:this.props.selectedFieldType,selectedFieldId:o,selectedOperator:this.props.selectedOperator,setOperator:l?Qb:this.props.setOperator,showOperator:a,showOperatorLabel:s,selectedFieldWidgetConfig:i,readonly:l||r,id:this.props.id,groupId:this.props.groupId})}},{key:"renderWidget",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=this.meta.showWidget,o=t.settings.immutableValuesMode;if(!n)return null;var i=ye().createElement(eO,Sb({key:"values"},this._buildWidgetProps(this.props,this.meta),{config:t,setValue:o?Qb:this.props.setValue,setValueSrc:o?Qb:this.props.setValueSrc,setFuncValue:o?Qb:this.props.setFuncValue,readonly:o||r,id:this.props.id,groupId:this.props.groupId}));return ye().createElement(Yb,{key:"widget-for-"+this.props.selectedOperator,className:"rule--value"},i)}},{key:"renderOperatorOptions",value:function(){var e=this.props.config,t=this.meta.showOperatorOptions,r=e.settings,n=r.immutableOpsMode,o=r.immutableValuesMode;if(!t)return null;var i=ye().createElement(vO,{key:"operatorOptions",selectedField:this.props.selectedField,selectedOperator:this.props.selectedOperator,operatorOptions:this.props.operatorOptions,setOperatorOption:n?Qb:this.props.setOperatorOption,config:e,readonly:o});return ye().createElement(Yb,{key:"op-options-for-"+this.props.selectedOperator,className:"rule--operator-options"},i)}},{key:"renderBeforeWidget",value:function(){var e=this.BeforeWidget;return e?ye().createElement(Yb,{key:"before-widget-for-"+this.props.selectedOperator,className:"rule--before-widget"},ye().createElement(e,this.props)):null}},{key:"renderAfterWidget",value:function(){var e=this.AfterWidget;return e?ye().createElement(Yb,{key:"after-widget-for-"+this.props.selectedOperator,className:"rule--after-widget"},ye().createElement(e,this.props)):null}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=e.fieldError,o=t.settings.showErrorMessage,i=this.RuleError,a=[n].concat(so((null==r?void 0:r.toArray())||[])).filter((function(e){return!!e})).shift()||null;return o&&a&&ye().createElement("div",{className:"rule--error"},i?ye().createElement(i,{error:a}):a)}},{key:"renderDrag",value:function(){var e=this.props.handleDraggerMouseDown,t=this.meta.showDragIcon,r=this.Icon,n=ye().createElement(r,{type:"drag"});return t&&ye().createElement("div",{key:"rule-drag-icon",onMouseDown:e,className:"qb-drag-handler rule--drag-handler"},n)}},{key:"renderDel",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=t.settings,o=n.deleteLabel,i=n.immutableGroupsMode,a=n.canDeleteLocked,s=this.Icon,l=this.Btn;return!i&&(!r||r&&a)&&ye().createElement(l,{key:"rule-del",type:"delRule",onClick:this.removeSelf,label:o,config:t,renderIcon:s})}},{key:"renderLock",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.isTrueLocked,o=e.id,i=t.settings,a=i.lockLabel,s=i.lockedLabel,l=i.showLock,u=this.Switch;return l&&!(r&&!n)&&ye().createElement(u,{key:"rule-lock",type:"lock",id:o,value:r,setValue:this.setLock,label:a,checkedLabel:s,hideLabel:!0,config:t})}},{key:"render",value:function(){var e=this.meta,t=e.showOperatorOptions,r=e.selectedFieldWidgetConfig,n=this.props,o=n.valueSrc,i=n.value,a=n.config,s="value"==(null==o?void 0:o.first())&&!t&&1==i.size&&r.fullWidth,l=this.BtnGrp,u=[this.renderField(),this.renderOperator(),this.renderBeforeWidget(),this.renderWidget(),this.renderAfterWidget(),this.renderOperatorOptions()],c=ye().createElement("div",{key:"rule-body",className:_b()("rule--body",s&&"can--shrink--value")},u),d=this.renderError(),p=this.renderDrag(),f=this.renderLock(),v=this.renderDel();return ye().createElement(ye().Fragment,null,p,ye().createElement("div",{key:"rule-body-wrapper",className:"rule--body--wrapper"},c,d),ye().createElement("div",{key:"rule-header-wrapper",className:"rule--header"},ye().createElement(l,{key:"rule-header-group",config:a},f,v)))}}])}(ge.Component);wO.propTypes={id:Mm().string.isRequired,groupId:Mm().string,selectedField:Mm().any,selectedFieldSrc:Mm().string,selectedFieldType:Mm().string,selectedOperator:Mm().string,operatorOptions:Mm().object,config:Mm().object.isRequired,value:Mm().any,valueSrc:Mm().any,valueType:Mm().any,asyncListValues:Mm().array,isDraggingMe:Mm().bool,isDraggingTempo:Mm().bool,parentField:Mm().string,valueError:Mm().any,fieldError:Mm().string,isLocked:Mm().bool,isTrueLocked:Mm().bool,handleDraggerMouseDown:Mm().func,setField:Mm().func,setFieldSrc:Mm().func,setOperator:Mm().func,setOperatorOption:Mm().func,setLock:Mm().func,removeSelf:Mm().func,setValue:Mm().func,setValueSrc:Mm().func,setFuncValue:Mm().func,reordableNodesCnt:Mm().number,totalRulesCnt:Mm().number,parentReordableNodesCnt:Mm().number};const RO=function(e){var t=(0,Gm.connect)((function(e){return{dragging:e.dragging}}),null,null,{context:Um})(function(e){var t;return t=function(t){function r(e){var t;return Kn(this,r),(t=wb(this,r,[e])).dummyFn=function(){},t.removeSelf=function(){t.props.actions.removeRule(t.props.path)},t.setLock=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;t.props.actions.setLock(t.props.path,e)},t.setField=function(e,r,n){t.props.actions.setField(t.props.path,e,r,n)},t.setFieldSrc=function(e){t.props.actions.setFieldSrc(t.props.path,e)},t.setOperator=function(e){t.props.actions.setOperator(t.props.path,e)},t.setOperatorOption=function(e,r){t.props.actions.setOperatorOption(t.props.path,e,r)},t.setValue=function(e,r,n,o,i){t.props.actions.setValue(t.props.path,e,r,n,o,i)},t.setValueSrc=function(e,r,n){t.props.actions.setValueSrc(t.props.path,e,r,n)},t.setFuncValue=function(e,r,n,o,i,a,s){t.props.actions.setFuncValue(t.props.path,e,r,n,o,i,a,s)},t.pureShouldComponentUpdate=sb(t),t.dummyFn.isDummyFn=!0,t}return Zn(r,t),Yn(r,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=(e.dragging.id||r.dragging.id)==e.id,a=[];for(var s in e){var l=e[s]!=r[s];"dragging"!=s||i||(l=!1),l&&a.push(s)}a.length||(o=!1)}return o}},{key:"render",value:function(){var t=this.props.dragging.id==this.props.id,r=Ib(this.props.config,this.props.field),n=this.props.fieldType||(null==r?void 0:r.type)||null,o=this.props.config.settings.showErrorMessage,i=(r&&r.type,!t&&this.props.isDraggingTempo),a=this.props,s=a.valueError,l=null!=([a.fieldError].concat(so((null==s?void 0:s.toArray())||[])).filter((function(e){return!!e})).shift()||null)&&o;return ye().createElement("div",{className:_b()("group-or-rule-container","rule-container",l?"rule-with-error":null),"data-id":this.props.id},[t?ye().createElement(e,{key:"dragging",id:this.props.id,groupId:this.props.groupId,isDraggingMe:!0,isDraggingTempo:!0,dragging:this.props.dragging,setField:this.dummyFn,setFieldSrc:this.dummyFn,setFuncValue:this.dummyFn,setOperator:this.dummyFn,setOperatorOption:this.dummyFn,setLock:this.dummyFn,removeSelf:this.dummyFn,setValue:this.dummyFn,setValueSrc:this.dummyFn,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:n,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,value:this.props.value||null,valueSrc:this.props.valueSrc||null,valueType:this.props.valueType||null,valueError:this.props.valueError||null,fieldError:this.props.fieldError||null,operatorOptions:this.props.operatorOptions,config:this.props.config,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,asyncListValues:this.props.asyncListValues,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt}):null,ye().createElement(e,{key:this.props.id,id:this.props.id,groupId:this.props.groupId,isDraggingMe:t,isDraggingTempo:i,onDragStart:this.props.onDragStart,setLock:i?this.dummyFn:this.setLock,removeSelf:i?this.dummyFn:this.removeSelf,setField:i?this.dummyFn:this.setField,setFieldSrc:i?this.dummyFn:this.setFieldSrc,setFuncValue:i?this.dummyFn:this.setFuncValue,setOperator:i?this.dummyFn:this.setOperator,setOperatorOption:i?this.dummyFn:this.setOperatorOption,setValue:i?this.dummyFn:this.setValue,setValueSrc:i?this.dummyFn:this.setValueSrc,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:n,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,value:this.props.value||null,valueSrc:this.props.valueSrc||null,valueType:this.props.valueType||null,valueError:this.props.valueError||null,fieldError:this.props.fieldError||null,operatorOptions:this.props.operatorOptions,config:this.props.config,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,asyncListValues:this.props.asyncListValues,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt})])}}])}(ge.Component),t.propTypes={id:Mm().string.isRequired,groupId:Mm().string,config:Mm().object.isRequired,path:Mm().any.isRequired,operator:Mm().string,field:Mm().any,fieldSrc:Mm().string,fieldType:Mm().string,actions:Mm().object.isRequired,onDragStart:Mm().func,value:Mm().any,valueSrc:Mm().any,asyncListValues:Mm().array,valueError:Mm().any,fieldError:Mm().string,operatorOptions:Mm().object,reordableNodesCnt:Mm().number,parentField:Mm().string,isLocked:Mm().bool,isTrueLocked:Mm().bool,dragging:Mm().object,isDraggingTempo:Mm().bool},t}(e));return t.displayName="ConnectedRuleContainer",t}(Db("rule")(Jb(wO)));var IO=p(3547),AO=p.n(IO);function CO(e,t,r){return t=Xn(t),Qn(e,NO()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function NO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(NO=function(){return!!e})()}var LO=Dm.DefaultUtils.defaultGroupConjunction;const PO=function(e,t){var r=(0,Gm.connect)((function(e){return{dragging:e.dragging}}),null,null,{context:Um})(function(e,t){var r;return r=function(r){function n(e){var r;return Kn(this,n),(r=CO(this,n,[e]))._selectedConjunction=function(e){return(e=e||r.props).conjunction||LO(e.config,e.field)},r.setConjunction=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setConjunction(r.props.path,e)},r.setNot=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setNot(r.props.path,e)},r.setLock=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setLock(r.props.path,e)},r.dummyFn=function(){},r.removeSelf=function(){r.props.actions.removeGroup(r.props.path)},r.addGroup=function(){r.props.actions.addGroup(r.props.path)},r.addCaseGroup=function(){r.props.actions.addCaseGroup(r.props.path)},r.addDefaultCaseGroup=function(){r.props.actions.addDefaultCaseGroup(r.props.path)},r.addRule=function(){var e="rule_group"==t?r.props.field:null;r.props.actions.addRule(r.props.path,void 0,void 0,void 0,e)},r.setField=function(e,t,n){r.props.actions.setField(r.props.path,e,t,n)},r.setOperator=function(e){r.props.actions.setOperator(r.props.path,e)},r.setValue=function(e,t,n,o,i){r.props.actions.setValue(r.props.path,e,t,n,o,i)},r.setValueSrc=function(e,t,n){r.props.actions.setValueSrc(r.props.path,e,t,n)},r.setFuncValue=function(e,t,n,o,i,a,s){r.props.actions.setFuncValue(r.props.path,e,t,n,o,i,a,s)},r.pureShouldComponentUpdate=sb(r),lb(r),r.selectedConjunction=r._selectedConjunction(e),r.conjunctionOptions=r._getConjunctionOptions(e),r.dummyFn.isDummyFn=!0,r}return Zn(n,r),Yn(n,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=(e.dragging.id||r.dragging.id)==e.id,a=[];for(var s in e){var l=e[s]!=r[s];"dragging"!=s||i||(l=!1),l&&a.push(s)}a.length||(o=!1)}return o}},{key:"onPropsChanged",value:function(e){var t=e.config,r=(e.id,e.conjunction),n=this.props.config,o=this.props.conjunction;n==t&&o==r||(this.selectedConjunction=this._selectedConjunction(e),this.conjunctionOptions=this._getConjunctionOptions(e))}},{key:"_getConjunctionOptions",value:function(e){var t=this;return nm()(e.config.conjunctions,(function(r,n){return{id:"conjunction-".concat(e.id,"-").concat(n),name:"conjunction[".concat(e.id,"]"),key:n,label:r.label,checked:n===t._selectedConjunction(e)}}))}},{key:"render",value:function(){var t=this.props.config.settings.showErrorMessage,r=this.props.dragging.id==this.props.id,n=this.props.path.size,o=this.props.config.settings.maxNesting,i=!r&&this.props.isDraggingTempo,a=this.props.fieldType||null,s=this.props.valueError,l=null!=(so((null==s?void 0:s.toArray())||[]).filter((function(e){return!!e})).shift()||null)&&t,u=void 0===o||n<o,c=1==n;return ye().createElement("div",{className:_b()("group-or-rule-container","group-container",l?"group-with-error":null),"data-id":this.props.id},[r?ye().createElement(e,{key:"dragging",id:this.props.id,groupId:this.props.groupId,isDraggingMe:!0,isDraggingTempo:!0,dragging:this.props.dragging,isRoot:c,allowFurtherNesting:u,conjunctionOptions:this.conjunctionOptions,not:this.props.not,selectedConjunction:this.selectedConjunction,setConjunction:this.dummyFn,setNot:this.dummyFn,setLock:this.dummyFn,removeSelf:this.dummyFn,addGroup:this.dummyFn,addCaseGroup:this.dummyFn,addDefaultCaseGroup:this.dummyFn,addRule:this.dummyFn,setField:this.dummyFn,setFuncValue:this.dummyFn,setOperator:this.dummyFn,setValue:this.dummyFn,setValueSrc:this.dummyFn,value:this.props.value||null,valueError:this.props.valueError||null,valueSrc:this.props.valueSrc||null,config:this.props.config,children1:this.props.children1,actions:this.props.actions,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:a,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt}):null,ye().createElement(e,{key:this.props.id,id:this.props.id,groupId:this.props.groupId,isDraggingMe:r,isDraggingTempo:i,onDragStart:this.props.onDragStart,isRoot:c,allowFurtherNesting:u,conjunctionOptions:this.conjunctionOptions,not:this.props.not,selectedConjunction:this.selectedConjunction,setConjunction:i?this.dummyFn:this.setConjunction,setNot:i?this.dummyFn:this.setNot,setLock:i?this.dummyFn:this.setLock,removeSelf:i?this.dummyFn:this.removeSelf,addGroup:i?this.dummyFn:this.addGroup,addCaseGroup:i?this.dummyFn:this.addCaseGroup,addDefaultCaseGroup:i?this.dummyFn:this.addDefaultCaseGroup,addRule:i?this.dummyFn:this.addRule,setField:i?this.dummyFn:this.setField,setFuncValue:i?this.dummyFn:this.setFuncValue,setOperator:i?this.dummyFn:this.setOperator,setValue:i?this.dummyFn:this.setValue,setValueSrc:i?this.dummyFn:this.setValueSrc,value:this.props.value||null,valueError:this.props.valueError||null,valueSrc:this.props.valueSrc||null,config:this.props.config,children1:this.props.children1,actions:this.props.actions,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:a,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt})])}}])}(ge.Component),r.propTypes={config:Mm().object.isRequired,actions:Mm().object.isRequired,path:Mm().any.isRequired,id:Mm().string.isRequired,groupId:Mm().string,not:Mm().bool,conjunction:Mm().string,children1:Mm().any,onDragStart:Mm().func,reordableNodesCnt:Mm().number,field:Mm().any,fieldSrc:Mm().string,fieldType:Mm().string,parentField:Mm().string,value:Mm().any,valueSrc:Mm().any,valueError:Mm().any,isLocked:Mm().bool,isTrueLocked:Mm().bool,dragging:Mm().object,isDraggingTempo:Mm().bool},r}(e,t));return r.displayName="ConnectedGroupContainer",r};function xO(e,t,r){return t=Xn(t),Qn(e,jO()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function jO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(jO=function(){return!!e})()}var FO={topLeft:"group--actions--tl",topCenter:"group--actions--tc",topRight:"group--actions--tr",bottomLeft:"group--actions--bl",bottomCenter:"group--actions--bc",bottomRight:"group--actions--br"},DO=function(e){function t(){return Kn(this,t),xO(this,t,arguments)}return Zn(t,e),Yn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.addGroup,o=e.removeSelf,i=e.setLock,a=e.isLocked,s=e.isTrueLocked,l=e.id,u=e.canAddGroup,c=e.canAddRule,d=e.canDeleteGroup,p=t.settings,f=p.immutableGroupsMode,v=p.addRuleLabel,h=p.addGroupLabel,g=p.delGroupLabel,y=p.groupActionsPosition,m=p.renderButton,b=p.renderIcon,E=p.renderSwitch,O=p.renderButtonGroup,S=p.lockLabel,T=p.lockedLabel,_=p.showLock,w=p.canDeleteLocked,R=function(e){return b(e,t.ctx)},I=function(e){return m(e,t.ctx)},A=function(e){return E(e,t.ctx)},C=function(e){return O(e,t.ctx)},N=FO[y||"topRight"],L=_&&!(a&&!s)&&ye().createElement(A,{type:"lock",id:l,value:a,setValue:i,label:S,checkedLabel:T,config:t}),P=!f&&c&&!a&&ye().createElement(I,{type:"addRule",onClick:r,label:v,readonly:a,config:t,renderIcon:R}),x=!f&&u&&!a&&ye().createElement(I,{type:"addGroup",onClick:n,label:h,readonly:a,config:t,renderIcon:R}),j=!f&&d&&(!a||a&&w)&&ye().createElement(I,{type:"delGroup",onClick:o,label:g,config:t,renderIcon:R});return ye().createElement("div",{className:"group--actions ".concat(N)},ye().createElement(C,{config:t},L,P,x,j))}}])}(ge.PureComponent);function kO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function MO(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?kO(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):kO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function VO(e,t,r){return t=Xn(t),Qn(e,UO()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function UO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(UO=function(){return!!e})()}var BO=Dm.RuleUtils.isEmptyGroupChildren,GO=function(e){function t(e){var r;return Kn(this,t),(r=VO(this,t,[e])).childrenClassName=function(){return""},r.renderBeforeActions=function(){var e=r.BeforeActions;return null==e?null:ye().createElement(e,Sb({key:"group-actions-before"},r.props))},r.renderAfterActions=function(){var e=r.AfterActions;return null==e?null:ye().createElement(e,Sb({key:"group-actions-after"},r.props))},lb(r),r.onPropsChanged(e),r.removeSelf=r.removeSelf.bind(r),r.setLock=r.setLock.bind(r),r.renderItem=r.renderItem.bind(r),r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var t=this,r=this.props;if(!this.Icon||(null==r?void 0:r.config)!==(null==e?void 0:e.config)){var n=e.config,o=n.settings,i=o.renderIcon,a=o.renderConjs,s=o.renderBeforeActions,l=o.renderAfterActions;this.Icon=eE(n,i),this.Conjs=eE(n,a),this.BeforeActions=eE(n,s),this.AfterActions=eE(n,l)}this.doRemove=function(){t.props.removeSelf()}}},{key:"isGroupTopPosition",value:function(){return AO()(this.props.config.settings.groupActionsPosition||"topRight","top")}},{key:"setLock",value:function(e){this.props.setLock(e)}},{key:"removeSelf",value:function(){var e=this.props,t=e.confirmFn,r=e.config,n=r.settings,o=n.renderConfirm,i=n.removeGroupConfirmOptions;i&&!this.isEmptyCurrentGroup()?o.call(r.ctx,MO(MO({},i),{},{onOk:this.doRemove,onCancel:null,confirmFn:t}),r.ctx):this.doRemove()}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props,t=e.children1,r=e.config;return BO(t,r)}},{key:"showNot",value:function(){return this.props.config.settings.showNot}},{key:"showConjs",value:function(){var e=this.props,t=e.conjunctionOptions;return e.children1,e.config,Object.keys(t).length>1||this.showNot()}},{key:"isNoChildren",value:function(){var e=this.props.children1;return!e||0==e.size}},{key:"isOneChild",value:function(){var e=this.props.children1;return!e||e.size<2}},{key:"renderChildrenWrapper",value:function(){return this.props.children1&&ye().createElement("div",{key:"group-children",className:_b()("group--children",this.showConjs()?"":"hide--conjs",this.isOneChild()?"hide--line":"",this.isOneChild()?"one--child":"",this.childrenClassName())},this.renderChildren())}},{key:"renderHeaderWrapper",value:function(){var e=this.isGroupTopPosition();return ye().createElement("div",{key:"group-header",className:_b()("group--header",this.isOneChild()?"one--child":"",this.showConjs()?"":"hide--conjs",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"")},this.renderHeader(),e&&this.renderBeforeActions(),e&&this.renderActions(),e&&this.renderAfterActions())}},{key:"renderFooterWrapper",value:function(){return!this.isGroupTopPosition()&&ye().createElement("div",{key:"group-footer",className:"group--footer"},this.renderBeforeActions(),this.renderActions(),this.renderAfterActions())}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.addGroup,o=e.isLocked,i=e.isTrueLocked,a=e.id;return ye().createElement(DO,{key:"group-actions",config:t,addRule:r,addGroup:n,canAddGroup:this.canAddGroup(),canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}},{key:"canAddGroup",value:function(){return this.props.allowFurtherNesting}},{key:"canAddRule",value:function(){var e=this.props.config.settings.maxNumberOfRules,t=this.props.totalRulesCnt;return!e||t<e}},{key:"canDeleteGroup",value:function(){return!this.props.isRoot}},{key:"renderChildren",value:function(){var e=this.props.children1;return e?e.valueSeq().toArray().map(this.renderItem):null}},{key:"renderItem",value:function(e){if(e){var t=this.props,r=t.config,n=t.actions,o=t.onDragStart,i=t.isLocked,a="group"==e.get("type")&&null!=e.getIn(["properties","field"])?"rule_group":e.get("type");return ye().createElement(VS,Sb({},this.extraPropsForItem(e),{key:e.get("id"),id:e.get("id"),groupId:t.id,path:e.get("path"),type:a,properties:e.get("properties"),config:r,actions:n,children1:e.get("children1"),reordableNodesCnt:this.reordableNodesCntForItem(e),totalRulesCnt:this.totalRulesCntForItem(e),parentReordableNodesCnt:this.reordableNodesCnt(),onDragStart:o,isDraggingTempo:this.props.isDraggingTempo,isParentLocked:i}))}}},{key:"extraPropsForItem",value:function(e){return{}}},{key:"reordableNodesCnt",value:function(){return this.props.isLocked?0:this.props.reordableNodesCnt}},{key:"totalRulesCntForItem",value:function(e){return this.props.totalRulesCnt}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.reordableNodesCnt()}},{key:"showDragIcon",value:function(){var e=this.props,t=e.config,r=e.isRoot,n=e.isLocked,o=this.reordableNodesCnt();return t.settings.canReorder&&!r&&o>1&&!n}},{key:"renderDrag",value:function(){var e=this.props.handleDraggerMouseDown,t=this.Icon,r=ye().createElement(t,{type:"drag"});return this.showDragIcon()&&ye().createElement("div",{key:"group-drag-icon",onMouseDown:e,className:"qb-drag-handler group--drag-handler"},r)}},{key:"conjunctionOptions",value:function(){return this.props.conjunctionOptions}},{key:"renderConjs",value:function(){var e=this.props,t=e.config,r=e.children1,n=e.id,o=e.selectedConjunction,i=e.setConjunction,a=e.not,s=e.setNot,l=e.isLocked,u=t.settings,c=u.immutableGroupsMode,d=(u.renderConjs,u.showNot,u.notLabel),p=this.conjunctionOptions();if(!this.showConjs())return null;if(!r||!r.size)return null;var f={disabled:this.isOneChild(),readonly:c||l,selectedConjunction:o,setConjunction:c?Qb:i,conjunctionOptions:p,config:t,not:a||!1,id:n,setNot:c?Qb:s,notLabel:d,showNot:this.showNot(),isLocked:l},v=this.Conjs;return ye().createElement(v,Sb({key:"group-conjs"},f))}},{key:"renderHeader",value:function(){return ye().createElement("div",{key:"group-conjunctions",className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"render",value:function(){return ye().createElement(ye().Fragment,null,this.renderHeaderWrapper(),this.renderChildrenWrapper(),this.renderFooterWrapper())}}])}(ge.Component);GO.propTypes={reordableNodesCnt:Mm().number,conjunctionOptions:Mm().object.isRequired,allowFurtherNesting:Mm().bool.isRequired,isRoot:Mm().bool.isRequired,not:Mm().bool,selectedConjunction:Mm().string,config:Mm().object.isRequired,id:Mm().string.isRequired,groupId:Mm().string,path:Mm().any,children1:Mm().any,isDraggingMe:Mm().bool,isDraggingTempo:Mm().bool,isLocked:Mm().bool,isTrueLocked:Mm().bool,handleDraggerMouseDown:Mm().func,onDragStart:Mm().func,addRule:Mm().func.isRequired,addGroup:Mm().func.isRequired,removeSelf:Mm().func.isRequired,setConjunction:Mm().func.isRequired,setNot:Mm().func.isRequired,setLock:Mm().func.isRequired,actions:Mm().object.isRequired};const $O=PO(Db("group")(Jb(GO)),"group");function qO(){return qO="undefined"!=typeof Reflect&&Reflect.get?Reflect.get.bind():function(e,t,r){var n=function(e,t){for(;!{}.hasOwnProperty.call(e,t)&&null!==(e=Xn(e)););return e}(e,t);if(n){var o=Object.getOwnPropertyDescriptor(n,t);return o.get?o.get.call(arguments.length<3?e:r):o.value}},qO.apply(null,arguments)}function KO(e,t,r){return t=Xn(t),Qn(e,WO()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function WO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(WO=function(){return!!e})()}var zO=function(e){function t(){return Kn(this,t),KO(this,t,arguments)}return Zn(t,e),Yn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.canAddRule,o=e.canDeleteGroup,i=e.removeSelf,a=e.setLock,s=e.isLocked,l=e.isTrueLocked,u=e.id,c=t.settings,d=c.immutableGroupsMode,p=c.addRuleLabel,f=c.delGroupLabel,v=c.renderButton,h=c.renderIcon,g=c.renderSwitch,y=c.renderButtonGroup,m=c.lockLabel,b=c.lockedLabel,E=c.showLock,O=c.canDeleteLocked,S=function(e){return h(e,t.ctx)},T=function(e){return v(e,t.ctx)},_=function(e){return g(e,t.ctx)},w=function(e){return y(e,t.ctx)},R=E&&!(s&&!l)&&ye().createElement(_,{type:"lock",id:u,value:s,setValue:a,label:m,checkedLabel:b,hideLabel:!0,config:t}),I=!d&&n&&!s&&ye().createElement(T,{type:"addRuleGroup",onClick:r,label:p,readonly:s,config:t,renderIcon:S}),A=!d&&o&&(!s||s&&O)&&ye().createElement(T,{type:"delRuleGroup",onClick:i,label:f,config:t,renderIcon:S});return ye().createElement("div",{className:"group--actions"},ye().createElement(w,{config:t},R,I,A))}}])}(ge.PureComponent);function HO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function YO(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?HO(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):HO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function QO(e,t,r){return t=Xn(t),Qn(e,XO()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function XO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(XO=function(){return!!e})()}var JO=function(e){function t(e){var r;return Kn(this,t),(r=QO(this,t,[e])).childrenClassName=function(){return"rule_group--children"},r.renderHeaderWrapper=function(){return null},r.renderFooterWrapper=function(){return null},r.renderConjs=function(){return null},r.canAddGroup=function(){return!1},r.canAddRule=function(){return!0},r.canDeleteGroup=function(){return!1},r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){qO(Xn(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"reordableNodesCntForItem",value:function(e){if(this.props.isLocked)return 0;var t=this.props.children1;return(null==t?void 0:t.size)||0}},{key:"renderChildrenWrapper",value:function(){return ye().createElement(ye().Fragment,null,this.renderDrag(),this.renderField(),this.renderActions(),qO(Xn(t.prototype),"renderChildrenWrapper",this).call(this))}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.setField,a=e.setFuncValue,s=e.setFieldSrc,l=e.parentField,u=e.id,c=e.groupId,d=e.isLocked,p=t.settings.immutableFieldsMode;return ye().createElement(uO,{key:"field",classname:"group--field",config:t,canSelectFieldSource:!1,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,setField:i,setFuncValue:a,setFieldSrc:s,parentField:l,readonly:p||d,id:u,groupId:c})}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.isLocked,o=e.isTrueLocked,i=e.id;return ye().createElement(zO,{config:t,addRule:r,canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:n,isTrueLocked:o,id:i})}},{key:"extraPropsForItem",value:function(e){return{parentField:this.props.selectedField}}}])}(GO);JO.propTypes=YO(YO({},GO.propTypes),{},{selectedField:Mm().any,selectedFieldSrc:Mm().string,parentField:Mm().string,setField:Mm().func,setFieldSrc:Mm().func});const ZO=PO(Db("group rule_group")(Jb(JO)),"rule_group");function eS(e,t,r){return t=Xn(t),Qn(e,tS()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function tS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(tS=function(){return!!e})()}var rS=function(e){function t(){return Kn(this,t),eS(this,t,arguments)}return Zn(t,e),Yn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.canAddRule,o=e.canDeleteGroup,i=e.removeSelf,a=e.setLock,s=e.isLocked,l=e.isTrueLocked,u=e.id,c=t.settings,d=c.immutableGroupsMode,p=c.addSubRuleLabel,f=c.delGroupLabel,v=c.renderButton,h=c.renderIcon,g=c.renderSwitch,y=c.renderButtonGroup,m=c.lockLabel,b=c.lockedLabel,E=c.showLock,O=c.canDeleteLocked,S=function(e){return h(e,t.ctx)},T=function(e){return v(e,t.ctx)},_=function(e){return g(e,t.ctx)},w=function(e){return y(e,t.ctx)},R=E&&!(s&&!l)&&ye().createElement(_,{type:"lock",id:u,value:s,setValue:a,label:m,checkedLabel:b,config:t}),I=!d&&n&&!s&&ye().createElement(T,{type:"addRuleGroupExt",onClick:r,label:p,readonly:s,config:t,renderIcon:S}),A=!d&&o&&(!s||s&&O)&&ye().createElement(T,{type:"delRuleGroup",onClick:i,label:f,config:t,renderIcon:S});return ye().createElement("div",{className:"group--actions group--actions--tr"},ye().createElement(w,{config:t},R,I,A))}}])}(ge.PureComponent);function nS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function oS(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?nS(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):nS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function iS(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function aS(e,t,r){return t=Xn(t),Qn(e,sS()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function sS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(sS=function(){return!!e})()}var lS=Dm.ConfigUtils,uS=lS.getFieldConfig,cS=lS.getFieldWidgetConfig,dS=Dm.RuleUtils.isEmptyRuleGroupExtPropertiesAndChildren,pS=function(e){function t(e){var r;return Kn(this,t),(r=aS(this,t,[e])).childrenClassName=function(){return"rule_group_ext--children"},r.renderFooterWrapper=function(){return null},r.canAddGroup=function(){return!1},r.canAddRule=function(){return!0},r.canDeleteGroup=function(){return!0},r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){qO(Xn(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"renderHeaderWrapper",value:function(){return ye().createElement("div",{key:"group-header",className:_b()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeader(),this.renderGroupField(),this.renderActions())}},{key:"renderHeader",value:function(){return ye().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderGroupField",value:function(){return ye().createElement("div",{className:"group--field--count--rule"},this.renderField(),this.renderOperator(),this.renderWidget(),this.renderError())}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=t.settings,o=n.renderRuleError,i=n.showErrorMessage,a=so((null==r?void 0:r.toArray())||[]).filter((function(e){return!!e})).shift()||null;return i&&a&&ye().createElement("div",{className:"rule_group--error"},o?o({error:a},t.ctx):a)}},{key:"showNot",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=(e.selectedOperator,uS(t,r)||{});return null!=n.showNot?n.showNot:t.settings.showNot}},{key:"conjunctionOptions",value:function(){var e=this.props,r=e.config,n=e.selectedField,o=(e.selectedOperator,uS(r,n)||{}),i=qO(Xn(t.prototype),"conjunctionOptions",this).call(this);if(o.conjunctions){var a,s={},l=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return iS(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?iS(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(o.conjunctions);try{for(l.s();!(a=l.n()).done;){var u=a.value,c=i[u];c&&(s[u]=c)}}catch(e){l.e(e)}finally{l.f()}i=s}return i}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.setField,a=e.setFieldSrc,s=e.setFuncValue,l=e.parentField,u=e.id,c=e.groupId,d=e.isLocked,p=t.settings.immutableFieldsMode;return ye().createElement(uO,{key:"field",classname:"rule--field",config:t,canSelectFieldSource:!1,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,setField:i,setFuncValue:s,setFieldSrc:a,parentField:l,readonly:p||d,id:u,groupId:c})}},{key:"renderOperator",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedOperator,i=(e.setField,e.setOperator),a=e.isLocked,s=t.settings.immutableFieldsMode,l=cS(t,r,o)||{},u=l.hideOperator,c=r&&u&&l.operatorInlineLabel,d=r&&!u;return ye().createElement(nE,{key:"operator",classname:"group--operator",config:t,selectedField:r,selectedFieldSrc:n,selectedOperator:o,setOperator:i,showOperator:d,showOperatorLabel:c,selectedFieldWidgetConfig:l,readonly:s||a,id:this.props.id,groupId:this.props.groupId})}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props,t=e.children1,r=e.config,n=this._buildWidgetProps(this.props);return dS(n,t,r)}},{key:"_buildWidgetProps",value:function(e){var t=e.selectedField,r=e.selectedFieldSrc,n=e.selectedFieldType,o=e.selectedOperator,i=e.operatorOptions,a=e.value,s=e.valueType,l=(e.valueSrc,e.asyncListValues,e.valueError);return e.fieldError,{field:t,fieldSrc:r,fieldType:n,operator:o,operatorOptions:i,value:a,valueType:s,valueSrc:["value"],valueError:l,fieldError:null,parentField:e.parentField}}},{key:"renderWidget",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedOperator,o=e.isLocked,i=t.settings.immutableValuesMode;if(!r||!n)return null;var a=ye().createElement(eO,Sb({key:"values",isForRuleGroup:!0},this._buildWidgetProps(this.props),{config:t,setValue:i?Qb:this.props.setValue,setValueSrc:Qb,readonly:i||o,id:this.props.id,groupId:this.props.groupId}));return ye().createElement(Yb,{key:"widget-for-"+this.props.selectedOperator,className:"rule--value"},a)}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.isLocked,o=e.isTrueLocked,i=e.id;return ye().createElement(rS,{config:t,addRule:r,canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:n,isTrueLocked:o,id:i})}},{key:"reordableNodesCntForItem",value:function(e){if(this.props.isLocked)return 0;var t=this.props.children1;return(null==t?void 0:t.size)||0}},{key:"extraPropsForItem",value:function(e){return{parentField:this.props.selectedField}}}])}(GO);pS.propTypes=oS(oS({},GO.propTypes),{},{selectedField:Mm().any,selectedFieldSrc:Mm().string,selectedOperator:Mm().string,value:Mm().any,parentField:Mm().string,setField:Mm().func,setFieldSrc:Mm().func,setOperator:Mm().func,setValue:Mm().func,valueError:Mm().any});const fS=PO(Db("group rule_group_ext")(Jb(pS)),"rule_group");function vS(e,t,r){return t=Xn(t),Qn(e,hS()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function hS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(hS=function(){return!!e})()}var gS={topLeft:"group--actions--tl",topCenter:"group--actions--tc",topRight:"group--actions--tr",bottomLeft:"group--actions--bl",bottomCenter:"group--actions--bc",bottomRight:"group--actions--br"},yS=function(e){function t(){return Kn(this,t),vS(this,t,arguments)}return Zn(t,e),Yn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addCaseGroup,n=e.addDefaultCaseGroup,o=e.setLock,i=e.isLocked,a=e.isTrueLocked,s=e.id,l=e.canAddGroup,u=e.canAddDefault,c=t.settings,d=c.immutableGroupsMode,p=c.addCaseLabel,f=c.addDefaultCaseLabel,v=c.groupActionsPosition,h=c.renderButton,g=c.renderIcon,y=c.renderSwitch,m=c.renderButtonGroup,b=c.lockLabel,E=c.lockedLabel,O=c.showLock,S=function(e){return g(e,t.ctx)},T=function(e){return h(e,t.ctx)},_=function(e){return y(e,t.ctx)},w=function(e){return m(e,t.ctx)},R=gS[v||"topRight"],I=O&&!(i&&!a)&&ye().createElement(_,{type:"lock",id:s,value:i,setValue:o,label:b,checkedLabel:E,config:t}),A=!d&&l&&!i&&ye().createElement(T,{type:"addCaseGroup",onClick:r,label:p,readonly:i,config:t,renderIcon:S}),C=!d&&u&&!i&&ye().createElement(T,{type:"addDefaultCaseGroup",onClick:n,label:f,readonly:i,config:t,renderIcon:S});return ye().createElement("div",{className:"group--actions ".concat(R)},ye().createElement(w,{config:t},I,A,C))}}])}(ge.PureComponent);function mS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function bS(e,t,r){return t=Xn(t),Qn(e,ES()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function ES(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(ES=function(){return!!e})()}var OS=Dm.TreeUtils,SS=OS.getTotalReordableNodesCountInTree,TS=OS.getTotalRulesCountInTree,_S=function(e){function t(e){var r;return Kn(this,t),(r=bS(this,t,[e])).childrenClassName=function(){return"switch_group--children"},r.renderFooterWrapper=function(){return null},r.hasDefaultCase=function(){var e;return(null===(e=r.props.children1)||void 0===e?void 0:e.size)&&r.props.children1.filter((function(e){return null==e.get("children1")})).size>0},r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){qO(Xn(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"canAddGroup",value:function(){var e,t=this.props.config.settings.maxNumberOfCases,r=(null===(e=this.props.children1)||void 0===e?void 0:e.size)||0;return!t||r<t}},{key:"canAddRule",value:function(){return!1}},{key:"reordableNodesCnt",value:function(){var e,t=(null===(e=this.props.children1)||void 0===e?void 0:e.size)||0;return this.hasDefaultCase()&&t--,t}},{key:"totalRulesCntForItem",value:function(e){return TS(e)}},{key:"reordableNodesCntForItem",value:function(e){var t;if(this.props.isLocked)return 0;var r=this.props.config.settings,n=r.canLeaveEmptyCase,o=r.canRegroupCases,i=(null===(t=this.props.children1)||void 0===t?void 0:t.size)||0;this.hasDefaultCase()&&i--;var a=SS(e);return 1==a&&o&&n&&i>1&&(a=111),a}},{key:"renderHeaderWrapper",value:function(){return ye().createElement("div",{key:"group-header",className:_b()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag")},this.renderHeader(),this.renderActions())}},{key:"renderHeader",value:function(){return ye().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderConjs",value:function(){return this.props.config.settings.renderSwitchPrefix||null}},{key:"showNot",value:function(){return!1}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addCaseGroup,n=e.addDefaultCaseGroup,o=e.isLocked,i=e.isTrueLocked,a=e.id;return ye().createElement(yS,{config:t,addCaseGroup:r,addDefaultCaseGroup:n,canAddDefault:!this.hasDefaultCase(),canAddGroup:this.canAddGroup(),setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}}])}(GO);_S.propTypes=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?mS(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):mS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({},GO.propTypes);const wS=PO(Db("group switch_group")(Jb(_S)),"switch_group");function RS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function IS(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?RS(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):RS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function AS(e,t,r){return t=Xn(t),Qn(e,CS()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function CS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(CS=function(){return!!e})()}var NS=function(e){function t(e){var r;return Kn(this,t),(r=AS(this,t,[e])).childrenClassName=function(){return"case_group--children"},r.renderFooterWrapper=function(){return null},r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var r=this.props,n=!this.renderBeforeCaseValue||(null==r?void 0:r.config)!==(null==e?void 0:e.config);if(qO(Xn(t.prototype),"onPropsChanged",this).call(this,e),n){var o=e.config,i=o.settings,a=i.renderBeforeCaseValue,s=i.renderAfterCaseValue,l=i.renderRuleError;this.BeforeCaseValue=eE(o,a),this.AfterCaseValue=eE(o,s),this.RuleError=eE(o,l)}}},{key:"isDefaultCase",value:function(){return null==this.props.children1}},{key:"reordableNodesCnt",value:function(){return this.props.parentReordableNodesCnt}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.props.reordableNodesCnt}},{key:"totalRulesCntForItem",value:function(e){return this.props.totalRulesCnt}},{key:"showDragIcon",value:function(){return!this.isDefaultCase()&&qO(Xn(t.prototype),"showDragIcon",this).call(this)}},{key:"renderHeaderWrapper",value:function(){return ye().createElement("div",{key:"group-header",className:_b()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeaderLeft(),this.renderHeaderCenter(),this.renderActions())}},{key:"renderChildrenWrapper",value:function(){return this.isDefaultCase()?null:ye().createElement("div",{className:"case_group--body"},this.renderCondition(),this.renderBeforeValue(),this.renderValue(),this.renderAfterValue())}},{key:"renderHeaderLeft",value:function(){return this.isDefaultCase()?this.props.config.settings.defaultCaseLabel||"":ye().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag(),this.renderError())}},{key:"renderCondition",value:function(){return this.isDefaultCase()?null:qO(Xn(t.prototype),"renderChildrenWrapper",this).call(this)}},{key:"renderHeaderCenter",value:function(){return this.isDefaultCase()?ye().createElement("div",null,this.renderValue(),this.renderError()):null}},{key:"canAddGroup",value:function(){return!this.isDefaultCase()&&qO(Xn(t.prototype),"canAddGroup",this).call(this)}},{key:"canAddRule",value:function(){return!this.isDefaultCase()&&qO(Xn(t.prototype),"canAddRule",this).call(this)}},{key:"renderBeforeValue",value:function(){var e=this.BeforeCaseValue;return null==e?null:ye().createElement(e,Sb({key:"values-before"},this.props))}},{key:"renderAfterValue",value:function(){var e=this.AfterCaseValue;return null==e?null:ye().createElement(e,Sb({key:"values-after"},this.props))}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=t.settings.showErrorMessage,o=this.RuleError,i=so((null==r?void 0:r.toArray())||[]).filter((function(e){return!!e})).shift()||null;return n&&i&&ye().createElement("div",{className:"rule--error"},o?ye().createElement(o,{error:i}):i)}},{key:"renderValue",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.value,o=e.valueSrc,i=e.valueError,a=e.setValue,s=e.setValueSrc,l=e.setFuncValue,u=e.id,c=t.settings.immutableValuesMode,d=ye().createElement(eO,{key:"values",isCaseValue:!0,field:"!case_value",operator:null,value:n,valueSrc:null!=o?o:"value",valueError:i,fieldError:null,config:t,setValue:c?Qb:a,setValueSrc:c?Qb:s,setFuncValue:c?Qb:l,readonly:c||r,id:u,groupId:null});return ye().createElement(Yb,{className:"case_group--value"},d)}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addGroup,n=e.addRule,o=e.isLocked,i=e.isTrueLocked,a=e.id;return ye().createElement(DO,{config:t,addGroup:r,addRule:n,canAddRule:this.canAddRule(),canAddGroup:this.canAddGroup(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props.value,r=e&&e.size?e.get(0):null,n=null!=r&&(!Array.isArray(r)||r.length>0);return qO(Xn(t.prototype),"isEmptyCurrentGroup",this).call(this)&&!n}}])}(GO);NS.propTypes=IS(IS({},GO.propTypes),{},{parentReordableNodesCnt:Mm().number,value:Mm().any,setValue:Mm().func});const LS=PO(Db("group case_group")(Jb(NS)),"case_group");var PS=["type"];function xS(e,t,r){return t=Xn(t),Qn(e,jS()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function jS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(jS=function(){return!!e})()}function FS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function DS(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?FS(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):FS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var kS=function(e){var t,r=(null===(t=e.properties)||void 0===t?void 0:t.toObject())||{},n=DS({},r);return e.isParentLocked&&(n.isLocked=!0),r.isLocked&&(n.isTrueLocked=!0),n},MS={rule:function(e){return ye().createElement(RO,Sb({},kS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,config:e.config,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},group:function(e){return ye().createElement($O,Sb({},kS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))},rule_group:function(e){return ye().createElement(ZO,Sb({},kS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},rule_group_ext:function(e){return ye().createElement(fS,Sb({},kS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},switch_group:function(e){return ye().createElement(wS,Sb({},kS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))},case_group:function(e){return ye().createElement(LS,Sb({},kS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))}},VS=function(e){function t(){return Kn(this,t),xS(this,t,arguments)}return Zn(t,e),Yn(t,[{key:"render",value:function(){var e,t=this.props,r=t.type,n=Jg(t,PS),o="array"==(null===(e=n.properties)||void 0===e?void 0:e.get("mode"))?"_ext":"",i=n.config.settings.renderItem,a=MS[r+o];return i?i(DS(DS({},n),{},{type:r,itemComponent:a}),n.config.ctx):a?a(n):null}}])}(ge.PureComponent);function US(e,t,r){return t=Xn(t),Qn(e,BS()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function BS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(BS=function(){return!!e})()}VS.propTypes={config:Mm().object.isRequired,id:Mm().string.isRequired,groupId:Mm().string,type:Mm().oneOf(["rule","group","rule_group","switch_group","case_group"]).isRequired,path:Mm().any.isRequired,properties:Mm().any,children1:Mm().any,actions:Mm().object.isRequired,reordableNodesCnt:Mm().number,onDragStart:Mm().func,parentField:Mm().string,isDraggingTempo:Mm().bool,isParentLocked:Mm().bool};var GS=Dm.TreeUtils,$S=GS.getTotalReordableNodesCountInTree,qS=GS.getTotalRulesCountInTree,KS=Dm.DefaultUtils,WS=KS.createListWithOneElement,zS=KS.emptyProperties,HS=function(e){function t(e){var r;return Kn(this,t),(r=US(this,t,[e])).pureShouldComponentUpdate=sb(r),r._updPath(e),r}return Zn(t,e),Yn(t,[{key:"shouldComponentUpdate",value:function(e,t){return this.pureShouldComponentUpdate(e,t)}},{key:"_updPath",value:function(e){var t=e.tree.get("id");this.path=WS(t)}},{key:"render",value:function(){var e=this.props,t=e.tree,r=e.config,n=e.actions,o=e.onDragStart,i=t.get("type"),a="switch_group"==i,s=a?null:$S(t),l=a?null:qS(t),u=t.get("id");return ye().createElement(VS,{key:u,id:u,path:this.path,type:i,properties:t.get("properties")||zS(),config:r,actions:n,children1:t.get("children1")||zS(),reordableNodesCnt:s,totalRulesCnt:l,parentReordableNodesCnt:0,onDragStart:o})}}])}(ge.Component);HS.propTypes={tree:Mm().any.isRequired,config:Mm().object.isRequired,actions:Mm().object.isRequired,onDragStart:Mm().func};const YS=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=(0,Gm.connect)((function(e){return{dragging:e.dragging,dragStart:e.dragStart,mousePos:e.mousePos}}),{setDragStart:Hm,setDragProgress:zm,setDragEnd:Ym},null,{context:Um})(function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;return t=function(t){function n(e){var t;return Kn(this,n),(t=Ab(this,n,[e]))._getEventTarget=function(e,t){return e&&e.__mocked_window||document.body||window},t.onDragStart=function(e,r,n){var o=r.closest(".query-builder");void 0===t._isUsingLegacyReactDomRender&&(t._isUsingLegacyReactDomRender=ib(o)),document.body.classList.add("qb-dragging"),o.classList.add("qb-dragging");var i,a=o.closest(".query-builder-container")||o,s=(a=t._getScrollParent(a)||document.body).scrollTop,l=(t._getDraggableNodeEl(o),t._getPlaceholderNodeEl(o),o.querySelectorAll(".group--children")),u=l.length?l[0]:null;u&&(i=window.getComputedStyle(u,null).getPropertyValue("padding-left"),i=parseInt(i));var c={id:e,x:r.offsetLeft,y:r.offsetTop,w:r.offsetWidth,h:r.offsetHeight,itemInfo:t.tree.items[e],paddingLeft:i},d={id:e,x:r.offsetLeft,y:r.offsetTop,scrollTop:s,clientX:n.clientX,clientY:n.clientY,itemInfo:Nb(t.tree.items[e]),treeEl:o,treeElContainer:a},p={clientX:n.clientX,clientY:n.clientY},f=t._getEventTarget(n,d);t.eventTarget=f,f.addEventListener("mousemove",t.onDrag),f.addEventListener("mouseup",t.onDragEnd),t.props.setDragStart(d,c,p)},t.onDrag=function(e){var n=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],o=Object.assign({},t.props.dragging),i=t.props.dragStart,a=o.paddingLeft,s=i.treeElContainer.scrollTop;if(o.itemInfo=t.tree.items[o.id],o.itemInfo){var l={clientX:e.clientX,clientY:e.clientY},u={clientX:i.clientX,clientY:i.clientY};if(e.__mock_dom){var c=i.treeEl,d=t._getDraggableNodeEl(c),p=t._getPlaceholderNodeEl(c);e.__mock_dom({treeEl:c,dragEl:d,plhEl:p})}if(!i.plX){var f=i.treeEl,v=t._getPlaceholderNodeEl(f);v&&(i.plX=v.getBoundingClientRect().left+window.scrollX,i.plY=v.getBoundingClientRect().top+window.scrollY)}var h=i.x,g=i.y,y=i.clientX,m=i.clientY,b=i.scrollTop,E={x:h+(e.clientX-y),y:g+(e.clientY-m)+(s-b)};o.x=E.x,o.y=E.y,o.paddingLeft=a,o.mousePos=l,o.startMousePos=u,t.props.setDragProgress(l,o),n&&t.handleDrag(o,e,r)||e.preventDefault&&e.preventDefault()}},t.onDragEnd=function(){var e=t.props.dragStart.treeEl;t.props.setDragEnd(),e.classList.remove("qb-dragging"),document.body.classList.remove("qb-dragging"),t._cacheEls={};var r=t.eventTarget||t._getEventTarget();r.removeEventListener("mousemove",t.onDrag),r.removeEventListener("mouseup",t.onDragEnd)},t.pureShouldComponentUpdate=sb(t),lb(t),t.onPropsChanged(e),t}return Zn(n,t),Yn(n,[{key:"onPropsChanged",value:function(e){this.tree=Lb(e.tree)}},{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=[];for(var a in e)e[a]!=r[a]&&"dragging"!=a&&"mousePos"!=a&&i.push(a);i.length||(o=!1)}return o}},{key:"componentDidUpdate",value:function(e,t){var r=this.props.dragging,n=this.props.dragStart;if(Pb=!1,n&&n.id&&(r.itemInfo=this.tree.items[r.id],r.itemInfo&&(r.itemInfo.index!=n.itemInfo.index||r.itemInfo.parent!=n.itemInfo.parent))){var o=n.treeEl,i=n.treeElContainer,a=this._getPlaceholderNodeEl(o,!0);if(a){var s=a.getBoundingClientRect().left+window.scrollX,l=a.getBoundingClientRect().top+window.scrollY,u=n.plX,c=n.plY,d=i.scrollTop;n.plX=s,n.plY=l,n.itemInfo=Nb(r.itemInfo),n.y=a.offsetTop,n.x=a.offsetLeft,n.clientY+=l-c,n.clientX+=s-u,i!=document.body&&(n.scrollTop=d),this.onDrag(this.props.mousePos,!1)}}}},{key:"_getNodeElById",value:function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(null==t)return null;this._cacheEls||(this._cacheEls={});var n=this._cacheEls[t];return n&&document.contains(n)&&!r||(n=e.querySelector('.group-or-rule-container[data-id="'+t+'"]'),this._cacheEls[t]=n),n}},{key:"_getDraggableNodeEl",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._cacheEls||(this._cacheEls={});var r=this._cacheEls.draggable;if(r&&document.contains(r)&&!t)return r;var n=e.getElementsByClassName("qb-draggable");return r=n.length?n[0]:null,this._cacheEls.draggable=r,r}},{key:"_getPlaceholderNodeEl",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._cacheEls||(this._cacheEls={});var r=this._cacheEls.placeholder;if(r&&document.contains(r)&&!t)return r;var n=e.getElementsByClassName("qb-placeholder");return r=n.length?n[0]:null,this._cacheEls.placeholder=r,r}},{key:"_isScrollable",value:function(e){var t=window.getComputedStyle(e)["overflow-y"];return("scroll"===t||"auto"===t)&&e.scrollHeight>e.offsetHeight}},{key:"_getScrollParent",value:function(e){return null==e?null:e===document.body||this._isScrollable(e)?e:this._getScrollParent(e.parentNode)}},{key:"handleDrag",value:function(e,t,r){var n,o,i,a,s=this,l=e.itemInfo,u=e.paddingLeft,c=null,d=this.props.dragStart.treeEl,p=e.id,f=this._getDraggableNodeEl(d),v=this._getPlaceholderNodeEl(d);if(f&&v){if(n=f.getBoundingClientRect(),!(o=v.getBoundingClientRect()).width)return;var h={hrz:0,vrt:0};n.top<o.top?h.vrt=-1:n.bottom>o.bottom&&(h.vrt=1),n.left>o.left?h.hrz=1:n.left<o.left&&(h.hrz=-1);var g,y={x:(a=d.getBoundingClientRect()).left+(a.right-a.left)/2,y:h.vrt>=0?n.bottom:n.top};if(t.__mocked_hov_container)g=t.__mocked_hov_container;else{var m=document.elementFromPoint(y.x,y.y-1);if(!(g=m?m.closest(".group-or-rule-container"):null)&&m&&m.classList.contains("query-builder-container")){var b,E=null==m||null===(b=m.firstChild)||void 0===b?void 0:b.firstChild;E&&E.classList.contains("group-or-rule-container")&&(g=E)}}if(g){var O=g.classList.contains("group-container"),S=g.getAttribute("data-id"),T=g,_=!1,w=!1;if(T){var R=(i=T.getBoundingClientRect()).bottom-i.top,I=this.tree.items[S];if(!I)throw new Error("There is an issue with rendering. If you use Next.js, please check getServerSideProps() method.");var A=null,C=null,N=null,L=null;if(0==h.vrt)N=l,(C=v)&&(A=C.getBoundingClientRect());else if(O){if(h.vrt>0){var P=g.getElementsByClassName("group--header"),x=P.length?P[0]:null;if(x){var j=x.getBoundingClientRect(),F=j.bottom-j.top;n.bottom-j.top>3*F/4&&I.top>e.itemInfo.top&&(N=I,A=j,C=x,w=!0)}}else h.vrt<0&&I.lev>=l.lev&&i.bottom-n.top>=2&&I.top<e.itemInfo.top&&(N=I,A=i,C=T,_=!0);(h.vrt<0?i.bottom-n.top>R-5:n.bottom-i.top>R-5)&&(w||_||(N=I,A=i,C=T),L=I)}else(h.vrt<0?i.bottom-n.top>R/2:n.bottom-i.top>R/2)&&(N=I,A=i,C=T);var D=N&&N.id==p;if(A){var k=n.left-a.left,M=(A.left,a.left,Math.max(0,Math.round(k/u))),V=[],U=[];if(D);else{if(O&&(_?V.push([Km,N,N.lev+1]):w&&V.push([Wm,N,N.lev+1]),L)){var B=0==L.lev,G="case_group"==L.type&&"case_group"!=l.type,$=L.prev&&this.tree.items[L.prev].caseId,q=L.next&&this.tree.items[L.next].caseId;l.caseId==$&&($=null),l.caseId==q&&(q=null);var K=$&&this.tree.items[$],W=q&&this.tree.items[q];h.vrt>0?B?U.push([Km,L,L.lev+1]):G&&W?U.push([Wm,W,W.lev+1]):U.push([$m,L,L.lev]):h.vrt<0&&(B?U.push([Wm,L,L.lev+1]):G&&K?U.push([Km,K,K.lev+1]):U.push([qm,L,L.lev]))}_||w||(h.vrt<0?V.push([qm,N,N.lev]):h.vrt>0&&V.push([$m,N,N.lev]))}var z=function(e){var t=e[1],r=l.caseId?s.tree.items[l.caseId]:null,n=t.caseId?s.tree.items[t.caseId]:null;return[].concat(so(e),[r,n])};V=V.map(z),U=U.map(z);var H=null,Y=(V=V.filter((function(e){var t=e[0],r=e[1];if((t==qm||t==$m)&&null==r.parent)return!1;if(r.collapsed&&(t==Km||t==Wm))return!1;var n=r.id==l.id;if(!n)for(var o=r;o.parent;)if((o=s.tree.items[o.parent]).id==l.id){n=!0;break}return!n})).map((function(e){var t=e[0],r=e[1],n=(e[2],e[3],e[4],null);return(n=t==Km||t==Wm?r:s.tree.items[r.parent])&&null==n.parent&&(n=null),e[5]=n,e}))).filter((function(e){return s.canMove(l,e[1],e[0],e[3],e[4],e[5],r)}));0==Y.length&&U.length>0&&(Y=U.filter((function(e){return s.canMove(l,e[1],e[0],e[3],e[4],e[5],r)})));var Q=Y.map((function(e){return e[2]})),X=l.lev,J=Q.concat(X),Z=null;-1!=J.indexOf(M)?Z=M:M>Math.max.apply(Math,so(J))?Z=Math.max.apply(Math,so(J)):M<Math.min.apply(Math,so(J))&&(Z=Math.min.apply(Math,so(J))),H=Y.find((function(e){return e[2]==Z})),D||H||!Y.length||(H=Y[0]),c=H}}}else rb.log("out of tree bounds!")}return!!c&&(this.move(l,c[1],c[0],c[3]),!0)}},{key:"canMove",value:function(e,t,r,n,o,i,a){if(!e||!t)return!1;if(e.id===t.id)return!1;var s=this.props.config.settings,l=s.canRegroup,u=s.canRegroupCases,c=s.maxNesting,d=s.maxNumberOfRules,p=s.canLeaveEmptyCase,f=(i?i.lev+1:t.lev)+(e.depth||0),v=r==qm||r==$m,h=r==Wm||r==Km,g=v&&1==t.lev||h&&0==t.lev,y=e.parent!=t.parent,m=h||y,b="case_group"==e.type&&!g||"rule_group"==e.parentType||"rule_group"==t.type||"rule_group"==t.parentType||"case_group"!=e.type&&"case_group"==t.type&&v||"case_group"!=e.type&&"switch_group"==t.type||!u&&e.caseId!=t.caseId,E=t.isLocked||e.isLocked||i&&i.isLocked;if(c&&f>c)return!1;if(m&&(!l||b||E))return!1;if("case_group"!=e.type&&e.caseId!=t.caseId){var O=!!n&&2==n._height,S=o?o.atomicRulesCountInCase+1:0;if(d&&S>d)return!1;if(O&&!p)return!1}if("case_group"==e.type&&(e.isDefaultCase||t.isDefaultCase||"switch_group"==t.type&&r==Km))return!1;var T=!0;return a&&(T=a(e.node.toJS(),t.node.toJS(),r,i?i.node.toJS():null)),T}},{key:"move",value:function(e,t,r,n){this._isUsingLegacyReactDomRender||(Pb=!0),this.props.actions.moveItem(e.path,t.path,r)}},{key:"render",value:function(){return ye().createElement(e,Sb({},this.props,{onDragStart:this.onDragStart}))}}])}(ge.Component),t.propTypes={tree:Mm().any.isRequired,actions:Mm().object.isRequired},t}(e,t));return r.displayName="ConnectedSortableContainer",r}(HS);function QS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function XS(e,t,r){return t=Xn(t),Qn(e,JS()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function JS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(JS=function(){return!!e})()}var ZS=Dm.clone,eT=Dm.ConfigUtils,tT=eT.getFieldConfig,rT=eT.getFieldParts,nT=eT.getFieldPathParts,oT=Dm.RuleUtils,iT=oT.getFieldPathLabels,aT=oT.getWidgetForFieldOp,sT=function(e){function t(e){var r;return Kn(this,t),r=XS(this,t,[e]),lb(r),r.onPropsChanged(e),r}return Zn(t,e),Yn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.items||["config","field","fieldSrc","fieldType","operator","isFuncArg","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0,n=!this.meta||["config","field","fieldSrc","fieldType","operator","value","placeholder","isFuncArg","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0;r&&(this.items=this.getItems(e)),n&&(this.meta=this.getMeta(e))}},{key:"getItems",value:function(e){var t=e.config,r=e.field,n=e.fieldType,o=e.operator,i=e.parentField,a=e.isFuncArg,s=e.fieldDefinition,l=t.settings.canCompareFieldWithField,u=rT(i,t),c=i?tT(t,i):null,d=i?null==c?void 0:c.subfields:t.fields,p=this.filterFields(t,d,r,i,u,o,l,a,s,n);return this.buildOptions(u,t,p,u)}},{key:"getMeta",value:function(e){var t,r=e.config,n=e.field,o=(e.fieldType,e.operator,e.value),i=e.placeholder,a=e.isFuncArg,s=e.parentField,l=r.settings,u=l.fieldPlaceholder,c=l.fieldSeparatorDisplay,d=o,p=!!o,f=n?tT(r,n):{},v=null==f||null===(t=f.widgets)||void 0===t?void 0:t.field,h=(null==v?void 0:v.widgetProps)||{},g=p?null:a&&i||h.valuePlaceholder||u,y=p?tT(r,d):null,m=y||{},b=nT(d,r),E=nT(d,r,!0),O=this.getFieldLabel(y,d,r),S=iT(d,r),T=S?S.join(c):null;return(T==O||s)&&(T=null),{placeholder:g,selectedKey:d,selectedKeys:b,selectedPath:E,selectedLabel:O,selectedOpts:m,selectedAltLabel:m.label2||m.tooltip,selectedFullLabel:T}}},{key:"filterFields",value:function(e,t,r,n,o,i,a,s,l,u){t=ZS(t);var c,d=e.settings.fieldSeparator,p=tT(e,r),f=aT(e,r,i,"value");return e.widgets[f],c=s?null==l?void 0:l.type:p?p.type:u,function t(n,o){for(var l in n){var u=n[l].subfields,f=(o||[]).concat(l),v=f.join(d),h=tT(e,v);if(h)if("!struct"==h.type||"!group"==h.type)0==t(u,f)&&delete n[l];else{var g=!(c&&h.type!=c||!s&&v==r),y=a||e.settings.canCompareFieldWithField;y&&(g=g&&y(r,p,v,h,i)),g||delete n[l]}else delete n[l]}return Mb()(n).length}(t,o||[]),t}},{key:"buildOptions",value:function(e,t,r){var n=this,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!r)return null;var a=t.settings,s=a.fieldSeparator,l=a.fieldSeparatorDisplay,u=null!=o&&o.length?o.join(s)+s:"";return Mb()(r).map((function(a){var s=[].concat(so(null!=o?o:[]),[a]),c=r[a],d=n.getFieldLabel(c,s,t),p=iT(s,t).join(l);(p==d||e)&&(p=null);var f=c.label2,v=c.tooltip;if(!c.hideForCompare)return"!struct"==c.type||"!group"==c.type?{key:a,path:u+a,label:d,fullLabel:p,altLabel:f,tooltip:v,items:n.buildOptions(e,t,c.subfields,s,{label:d,tooltip:v})}:{key:a,path:u+a,label:d,fullLabel:p,altLabel:f,tooltip:v,grouplabel:null==i?void 0:i.label,group:i}})).filter((function(e){return!!e}))}},{key:"getFieldLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=rT(t,r),i=(null==e?void 0:e.label)||su()(o);return Zm(i,n)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setValue,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderField,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?QS(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):QS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({isValueField:!0,config:t,customProps:r,setField:n,readonly:o,items:this.items,id:i,groupId:a},this.meta);return s(l,t.ctx)}}])}(ge.Component);sT.propTypes={id:Mm().string,groupId:Mm().string,setValue:Mm().func.isRequired,config:Mm().object.isRequired,field:Mm().any,fieldSrc:Mm().string,fieldType:Mm().string,value:Mm().string,operator:Mm().string,customProps:Mm().object,readonly:Mm().bool,parentField:Mm().string,fieldDefinition:Mm().object,isFuncArg:Mm().bool};const lT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.labelYes),o=e.labelNo,i=e.readonly,a=(e.widgetId,e.customProps),s=void 0===a?{}:a,l=s.radioYes||{},u=s.radioNo||{},c=function(e){return r("true"==e.target.value)};return ye().createElement(ye().Fragment,null,ye().createElement("input",Sb({type:"radio",value:!0,checked:!!t,disabled:i,onChange:c},l))," ",n,ye().createElement("input",Sb({type:"radio",value:!1,checked:!t,disabled:i,onChange:c},u))," ",o)},uT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.placeholder,i=e.maxLength,a=e.customProps,s=t||"";return ye().createElement("input",Sb({type:"text",value:s,placeholder:o,disabled:n,onChange:function(e){var t=e.target.value;""===t&&(t=void 0),r(t)},maxLength:i},a))},cT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.placeholder,i=e.maxLength,a=(e.maxRows,e.fullWidth),s=e.customProps,l=t||"";return ye().createElement("textarea",Sb({value:l,placeholder:o,disabled:n,onChange:function(e){var t=e.target.value;""===t&&(t=void 0),r(t)},maxLength:i,style:{width:a?"100%":void 0}},s))};Dm.moment;const dT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.valueFormat,e.readonly),o=e.customProps;return ye().createElement("input",Sb({type:"date",value:t||"",disabled:n,onChange:function(e){var t=e.target.value;""==t&&(t=void 0),r(t)}},o))},pT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.valueFormat,e.use12Hours,e.readonly),o=e.customProps;return ye().createElement("input",Sb({type:"time",value:t||"",disabled:n,onChange:function(e){var t=e.target.value;""==t&&(t=void 0),r(t)}},o))};var fT=Dm.moment;const vT=function(e){var t,r=e.value,n=e.setValue,o=(e.config,e.valueFormat),i=(e.use12Hours,e.readonly),a=e.customProps;return t=r?fT(r).format("YYYY-MM-DDTHH:mm"):"",ye().createElement("input",Sb({type:"datetime-local",value:t,disabled:i,onChange:function(e){var t=e.target.value;t=""==t?void 0:fT(new Date(t)).format(o),n(t)}},a))};var hT=Dm.ListUtils.mapListValues;const gT=function(e){var t=e.listValues,r=e.value,n=e.setValue,o=(e.allowCustomValues,e.readonly),i=e.customProps;return ye().createElement("select",Sb({multiple:!0,onChange:function(e){return n(function(e){for(var t=[],r=e.options,n=0;n<r.length;n++){var o=r[n];o.selected&&t.push(o.value)}return t.length||(t=void 0),t}(e.target))},value:r,disabled:o},uu()(i,["showSearch","input","showCheckboxes"])),hT(t,(function(e){var t=e.title,r=e.value;return ye().createElement("option",{key:r,value:r},t)})))};var yT=Dm.ListUtils.mapListValues;const mT=function(e){var t=e.listValues,r=e.value,n=e.setValue,o=(e.allowCustomValues,e.readonly),i=e.customProps,a=null!=r;return ye().createElement("select",Sb({onChange:function(e){return n(e.target.value)},value:a?r:"",disabled:o},uu()(i,["showSearch","input"])),!a&&ye().createElement("option",{disabled:!0,value:""}),yT(t,(function(e){var t=e.title,r=e.value;return ye().createElement("option",{key:r,value:r},t)})))},bT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.min,i=e.max,a=e.step,s=e.placeholder,l=e.customProps,u=null==t?"":t;return ye().createElement("input",Sb({type:"number",value:u,placeholder:s,disabled:n,min:o,max:i,step:a,onChange:function(e){var t=e.target.value;t=""===t||null===t?void 0:Number(t),r(t)}},l))},ET=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.min,i=e.max,a=e.step,s=e.placeholder,l=e.customProps,u=void 0===l?{}:l,c=u.input||{},d=u.slider||u,p=function(e){var t=e.target.value;t=""===t||null===t?void 0:Number(t),r(t)},f=null==t?"":t;return ye().createElement("div",{style:{display:"inline-flex"}},ye().createElement("input",Sb({key:"number",type:"number",value:f,placeholder:s,disabled:n,min:o,max:i,step:a,onChange:p},c)),ye().createElement("input",Sb({key:"range",type:"range",value:f,disabled:n,min:o,max:i,step:a,onChange:p},d)))},OT=function(e){var t=e.items,r=e.setField,n=e.selectedKey,o=e.readonly,i=e.errorText,a=null!=n;return ye().createElement("select",{onChange:function(e){return r(e.target.value)},value:a?n:"",disabled:o,style:{color:i?"red":null}},!a&&ye().createElement("option",{disabled:!0,value:""}),function e(t){return t.map((function(t){var r=t.items,n=t.path,o=t.label,i=t.disabled,a=t.matchesType;if(r)return ye().createElement("optgroup",{disabled:i,key:n,label:o},e(r));var s=a?{fontWeight:"bold"}:{};return ye().createElement("option",{disabled:i,key:n,value:n,style:s},o)}))}(t))},ST=function(e){var t,r=e.id,n=e.not,o=e.setNot,i=e.conjunctionOptions,a=e.setConjunction,s=e.disabled,l=e.readonly,u=e.config,c=e.showNot,d=e.notLabel,p=Object.keys(i).length,f=s,v=u.settings.forceShowConj||p>1&&!f,h=function(e){return a(e.target.value)};return[c&&(t="not",[ye().createElement("input",{key:r+t,type:"checkbox",id:r+t,checked:n,disabled:l,onChange:function(e){return o(e.target.checked)}}),ye().createElement("label",{key:r+t+"label",htmlFor:r+t},d||"NOT")]),v&&Object.keys(i).map((function(e){var t=i[e],r=t.id,n=t.name,o=t.label,u=t.checked,c=a.isDummyFn?"__dummy":"";return!l&&!s||u?[ye().createElement("input",{key:r+c,type:"radio",id:r+c,name:n+c,checked:u,disabled:l||s,value:e,onChange:h}),ye().createElement("label",{key:r+c+"label",htmlFor:r+c},o)]:null}))]};var TT={addRuleGroup:"+",addRuleGroupExt:"+",delGroup:"x",delRuleGroup:"x",delRule:"x"};const _T=function(e){var t=e.type,r=e.label,n=e.onClick,o=e.readonly,i=r||TT[t];return ye().createElement("button",{onClick:n,type:"button",disabled:o},i)},wT=function(e){var t=e.type,r={}[t]||null;return r||"drag"!==t||(r=ye().createElement(Xb,null)),r},RT=function(e){var t=e.children;return e.config,ye().createElement(ye().Fragment,null,t)},IT=function(e){e.config;var t=e.valueSources,r=e.valueSrc,n=(e.title,e.setValueSrc),o=e.readonly;return ye().createElement("select",{onChange:function(e){return n(e.target.value)},value:r||"",disabled:o},function(e){return e.map((function(e){var t=io(e,2),r=t[0],n=t[1];return ye().createElement("option",{key:r,value:r},n.label)}))}(t))},AT=function(e){var t=e.value,r=e.setValue,n=e.label,o=e.id,i=(e.config,e.type);return[ye().createElement("input",{key:o+i,type:"checkbox",id:o+i,checked:!!t,onChange:function(e){return r(e.target.checked)}}),ye().createElement("label",{key:o+i+"label",htmlFor:o+i},n)]},CT=function(e){var t=e.onOk,r=(e.okText,e.cancelText,e.title);confirm(r)&&t()};var NT=function(e){return e.config,e.children};function LT(e,t,r){return t=Xn(t),Qn(e,PT()?Reflect.construct(t,r||[],Xn(e).constructor):t.apply(e,r))}function PT(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(PT=function(){return!!e})()}var xT=function(e){function t(){var e;Kn(this,t);for(var r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=LT(this,t,[].concat(n))).handleChange=function(t){e.props.setOption("proximity",parseInt(t))},e}return Zn(t,e),Yn(t,[{key:"render",value:function(){var e=this.props,t=e.defaults,r=e.options,n=e.config,o=e.optionLabel,i=e.optionPlaceholder,a=e.customProps,s=e.minProximity,l=e.maxProximity,u=e.optionTextBefore,c=e.readonly,d=n.settings,p=n.widgets,f=n.ctx,v=t?t.proximity:void 0,h=d.showLabels,g=r.get("proximity",v),y=AE()(s,l+1).map((function(e){return{title:e,value:e}})),m=p.select.factory,b=function(e){return m(e,f)};return ye().createElement("div",{className:"operator--PROXIMITY"},ye().createElement("div",{className:"operator--options"},h&&ye().createElement("label",{className:"rule--label"},o),!h&&u&&ye().createElement("div",{className:"operator--options--sep"},ye().createElement("span",null,u)),ye().createElement(b,Sb({config:n,value:g,listValues:y,setValue:this.handleChange,readonly:c,placeholder:i},a))),ye().createElement("div",{className:"operator--widgets"},this.props.children))}}])}(ge.PureComponent);function jT(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function FT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?jT(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):jT(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}xT.propTypes={config:Mm().object.isRequired,setOption:Mm().func.isRequired,options:Mm().any.isRequired,minProximity:Mm().number,maxProximity:Mm().number,optionPlaceholder:Mm().string,optionTextBefore:Mm().string,optionLabel:Mm().string,customProps:Mm().object,readonly:Mm().bool},xT.defaultProps={customProps:{},minProximity:2,maxProximity:10,optionPlaceholder:"Select words between",optionLabel:"Words between",optionTextBefore:null};var DT={conjunctions:FT({},Ly.conjunctions),operators:FT(FT({},Ly.operators),{},{proximity:FT(FT({},Ly.operators.proximity),{},{options:FT(FT({},Ly.operators.proximity.options),{},{factory:function(e,t){return(0,t.RCE)(t.O.ProximityOperator,e)}})})}),widgets:{text:FT(FT({},Ly.widgets.text),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextWidget,e)}}),textarea:FT(FT({},Ly.widgets.textarea),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextAreaWidget,e)}}),number:FT(FT({},Ly.widgets.number),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaNumberWidget,e)}}),slider:FT(FT({},Ly.widgets.slider),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaSliderWidget,e)}}),select:FT(FT({},Ly.widgets.select),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaSelectWidget,e)}}),multiselect:FT(FT({},Ly.widgets.multiselect),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaMultiSelectWidget,e)}}),date:FT(FT({},Ly.widgets.date),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaDateWidget,e)}}),time:FT(FT({},Ly.widgets.time),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTimeWidget,e)}}),datetime:FT(FT({},Ly.widgets.datetime),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaDateTimeWidget,e)}}),boolean:FT(FT({},Ly.widgets.boolean),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaBooleanWidget,e)}}),field:FT(FT({},Ly.widgets.field),{},{factory:function(e,t){return(0,t.RCE)(t.W.ValueFieldWidget,e)},customProps:{showSearch:!0}}),func:FT(FT({},Ly.widgets.func),{},{factory:function(e,t){return(0,t.RCE)(t.W.FuncWidget,e)},customProps:{}}),case_value:FT(FT({},Ly.widgets.case_value),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextWidget,e)}})},types:FT(FT({},Ly.types),{},{select:FT(FT({},Ly.types.select),{},{widgets:FT(FT({},Ly.types.select.widgets),{},{select:FT(FT({},Ly.types.select.widgets.select),{},{widgetProps:{customProps:{showSearch:!0}}})})})}),settings:FT(FT({},Ly.settings),{},{renderField:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderOperator:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderFunc:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderConjs:function(e,t){return(0,t.RCE)(t.W.VanillaConjs,e)},renderSwitch:function(e,t){return(0,t.RCE)(t.W.VanillaSwitch,e)},renderButton:function(e,t){return(0,t.RCE)(t.W.VanillaButton,e)},renderIcon:function(e,t){return(0,t.RCE)(t.W.VanillaIcon,e)},renderButtonGroup:function(e,t){return(0,t.RCE)(t.W.VanillaButtonGroup,e)},renderProvider:function(e,t){return(0,t.RCE)(t.W.VanillaProvider,e)},renderValueSources:function(e,t){return(0,t.RCE)(t.W.VanillaValueSources,e)},renderFieldSources:function(e,t){return(0,t.RCE)(t.W.VanillaValueSources,e)},renderConfirm:function(e,t){return(0,t.W.vanillaConfirm)(e)},renderSwitchPrefix:"IF",renderBeforeCaseValue:function(e,t){return(0,t.RCE)("span",{children:[" then "]})},customFieldSelectProps:{showSearch:!0},customOperatorSelectProps:{},defaultSliderWidth:"200px",defaultSelectWidth:"200px",defaultSearchWidth:"100px",defaultMaxRows:5,renderSize:"small",maxLabelsLength:100,showLock:!1,showNot:!0,forceShowConj:!1,groupActionsPosition:"topRight"}),ctx:FT(FT({},Ly.ctx),{},{W:FT({},E),O:FT({},O),RCE:function(e,t){return ye().createElement(e,t)}})};const kT=DT=Dm.ConfigMixins.removeMixins(DT,["rangeslider","treeselect","treemultiselect"]);p(9517);var MT=Dm.Autocomplete,VT=(MT.mergeListValues,MT.listValueToOption,MT.optionToListValue,MT.optionsToListValues,MT.fixListValuesGroupOrder,Dm.ListUtils);function UT(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function BT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?UT(Object(r),!0).forEach((function(t){eo(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):UT(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}VT.mapListValues,VT.listValuesToArray,VT.getListValue,VT.makeCustomListValue,VT.searchListValue,VT.getItemInListValues;const GT=BT(BT({},Dm),{},{ReactUtils:b,DragIcon:Xb});function $T(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function qT(){return qT=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},qT.apply(this,arguments)}function KT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){$T(e,t,r[t])}))}return e}function WT(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const zT={id:GT.uuid(),type:"group"},HT="timeFilter",YT=[HT],QT=WT(KT({},kT.widgets),{text:WT(KT({},kT.widgets.text),{factory:function(e){return(0,he.jsx)(_e.Input,{value:(null==e?void 0:e.value)||"",placeholder:null==e?void 0:e.placeholder,onChange:t=>null==e?void 0:e.setValue(t.currentTarget.value)})}}),number:WT(KT({},kT.widgets.number),{factory:function(e){return(0,he.jsx)(_e.Input,{value:null==e?void 0:e.value,placeholder:null==e?void 0:e.placeholder,type:"number",onChange:t=>null==e?void 0:e.setValue(Number.parseInt(t.currentTarget.value,10))})}}),datetime:WT(KT({},kT.widgets.datetime),{factory:function(e){if("macros"===(null==e?void 0:e.operator))return(0,he.jsx)(_e.Select,{id:e.id,"aria-label":"Macros value selector",menuShouldPortal:!0,options:YT.map(T.toOption),value:null==e?void 0:e.value,onChange:t=>e.setValue(t.value)});const t=(0,T.dateTime)(null==e?void 0:e.value).isValid()?(0,T.dateTime)(null==e?void 0:e.value).utc():void 0;return(0,he.jsx)(_e.DateTimePicker,{onChange:t=>{null==e||e.setValue(null==t?void 0:t.format(kT.widgets.datetime.valueFormat))},date:t})},sqlFormatValue:(e,t,r,n,o,i)=>{if("macros"===n)return YT.includes(e)?e:void 0;if("string"==typeof kT.widgets.datetime.sqlFormatValue||"object"==typeof kT.widgets.datetime.sqlFormatValue)return;const a=kT.widgets.datetime.sqlFormatValue;return(null==a?void 0:a.call(kT.ctx,e,t,r,n,o,i))||""}})}),XT=WT(KT({},kT.settings),{canRegroup:!1,maxNesting:1,canReorder:!1,showNot:!1,addRuleLabel:"Add",deleteLabel:"Remove",renderConjs:function(e){return(0,he.jsx)(_e.Select,{id:null==e?void 0:e.id,"aria-label":"Conjunction","data-testid":Be.components.SQLQueryEditor.filterConjunction,menuShouldPortal:!0,options:(null==e?void 0:e.conjunctionOptions)?Object.keys(null==e?void 0:e.conjunctionOptions).map(T.toOption):void 0,value:null==e?void 0:e.selectedConjunction,onChange:t=>null==e?void 0:e.setConjunction(t.value)})},renderField:function(e){var t;const r=(null==e||null===(t=e.config)||void 0===t?void 0:t.fields)||{};return(0,he.jsx)(_e.Select,{id:null==e?void 0:e.id,width:25,"aria-label":"Field","data-testid":Be.components.SQLQueryEditor.filterField,menuShouldPortal:!0,options:null==e?void 0:e.items.map((e=>{var t,n;const o=null===(n=r[e.key].mainWidgetProps)||void 0===n||null===(t=n.customProps)||void 0===t?void 0:t.icon;return{label:e.label,value:e.key,icon:o}})),value:null==e?void 0:e.selectedKey,onChange:t=>{null==e||e.setField(t.label)}})},renderButton:function(e){return(0,he.jsx)(_e.Button,{type:"button",title:`${null==e?void 0:e.label} filter`,onClick:null==e?void 0:e.onClick,variant:"secondary",size:"md",icon:"Add"===(null==e?void 0:e.label)?"plus":"times"})},renderOperator:function(e){return(0,he.jsx)(_e.Select,{options:null==e?void 0:e.items.map((e=>({label:e.label,value:e.key}))),"aria-label":"Operator","data-testid":Be.components.SQLQueryEditor.filterOperator,menuShouldPortal:!0,value:null==e?void 0:e.selectedKey,onChange:t=>{null==e||e.setField(t.value||"")}})}}),JT=function(e){const t=qT({},function(e){if(null==e)throw new TypeError("Cannot destructure "+e);return e}(e.operators));return WT(KT({},t),{select_any_in:WT(KT({},t.select_any_in),{sqlFormatOp:(e,r,n,o,i,a,s,l)=>(()=>{const e=t.select_any_in.sqlFormatOp;return i_(e)?e:o_})()(e,r,a_(n),o,i,a,s,l)}),select_not_any_in:WT(KT({},t.select_not_any_in),{sqlFormatOp:(e,r,n,o,i,a,s,l)=>(()=>{const e=t.select_not_any_in.sqlFormatOp;return i_(e)?e:o_})()(e,r,a_(n),o,i,a,s,l)}),macros:{label:"Macros",sqlFormatOp:(e,t,r)=>r===HT?`$__timeFilter(${e})`:r}})}(kT),ZT=kT.types.text.widgets.text,e_=[...ZT.operators||[],"select_any_in","select_not_any_in"],t_=WT(KT({},ZT),{operators:e_}),r_=WT(KT({},kT.types),{text:WT(KT({},kT.types.text),{widgets:WT(KT({},kT.types.text.widgets),{text:t_})}),datetime:WT(KT({},kT.types.datetime),{widgets:WT(KT({},kT.types.datetime.widgets),{datetime:WT(KT({},kT.types.datetime.widgets.datetime),{operators:["macros",...kT.types.datetime.widgets.datetime.operators||[]]})})})}),n_=WT(KT({},kT),{widgets:QT,settings:XT,operators:JT,types:r_}),o_=()=>"",i_=e=>"function"==typeof e;function a_(e){return(0,fe.isString)(e)?e.split(","):e}function s_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function l_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){s_(e,t,r[t])}))}return e}function u_(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function c_({sql:e,config:t,onSqlChange:r}){const[n,o]=(0,ge.useState)(),i=(0,ge.useMemo)((()=>l_({},n_,t)),[t]);(0,ge.useEffect)((()=>{if(!n){var t;const r=GT.checkTree(GT.loadTree(null!==(t=e.whereJsonTree)&&void 0!==t?t:zT),i);o(r)}}),[i,e.whereJsonTree,n]),(0,ge.useEffect)((()=>{e.whereJsonTree||o(GT.checkTree(GT.loadTree(zT),i))}),[i,e.whereJsonTree]);const a=(0,ge.useCallback)(((t,n)=>{o(t);const i=u_(l_({},e),{whereJsonTree:GT.getTree(t),whereString:GT.sqlFormat(t,n)});r(i)}),[r,e]);return n?(0,he.jsx)(Ob,u_(l_({},i),{value:n,onChange:a,renderBuilder:e=>(0,he.jsx)(YS,l_({},e))})):null}function d_(e){return`\n    display: flex;\n    gap: 8px;\n    flex-direction: ${e};`}function p_(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function f_(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){p_(i,n,o,a,s,"next",e)}function s(e){p_(i,n,o,a,s,"throw",e)}a(void 0)}))}}function v_({query:e,fields:t,onQueryChange:r,db:n}){const o=(0,qn.A)(f_((function*(){return function(e){const t={};for(const r of e)t[r.value]={type:r.raqbFieldType||"text",valueSources:["value"],mainWidgetProps:{customProps:{icon:r.icon}}};return t}(t)})),[t]),{onSqlChange:i}=cn({query:e,onQueryChange:r,db:n});return(0,he.jsx)(c_,{config:{fields:o.value||{}},sql:e.sql,onSqlChange:e=>{!function(e,t){var r,n;t.some((t=>(t=>{var r,n;return"multi"in t&&t.multi&&((null===(r=e.whereString)||void 0===r?void 0:r.includes(`\${${t.name}}`))||(null===(n=e.whereString)||void 0===n?void 0:n.includes(`$${t.name}`)))})(t)))&&(e.whereString=null===(r=e.whereString)||void 0===r?void 0:r.replaceAll("')",")"),e.whereString=null===(n=e.whereString)||void 0===n?void 0:n.replaceAll("('","("))}(e,(0,pe.getTemplateSrv)().getVariables()),i(e)}},JSON.stringify(o.value))}function h_(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function g_(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){h_(i,n,o,a,s,"next",e)}function s(e){h_(i,n,o,a,s,"throw",e)}a(void 0)}))}}Ge.injectGlobal`
  .group--header {
    ${d_("row")}
  }

  .group-or-rule {
    ${d_("column")}
    .rule {
      flex-direction: row;
    }
  }

  .rule--body {
    ${d_("row")}
  }

  .group--children {
    ${d_("column")}
  }

  .group--conjunctions:empty {
    display: none;
  }
`;const y_=({query:e,db:t,queryRowFilter:r,onChange:n,onValidate:o,range:i})=>{var a;const s=Oe(g_((function*(){return yield t.fields(e)})),[t,e.dataset,e.table]);return(0,he.jsxs)(he.Fragment,{children:[(0,he.jsxs)(nn,{children:[(0,he.jsx)(dt,{children:(0,he.jsx)($n,{fields:s.value||[],query:e,onQueryChange:n,db:t})}),r.filter&&(0,he.jsx)(dt,{children:(0,he.jsx)(Et,{label:"Filter by column value",optional:!0,children:(0,he.jsx)(v_,{fields:s.value||[],query:e,onQueryChange:n,db:t})})}),r.group&&(0,he.jsx)(dt,{children:(0,he.jsx)(Et,{label:"Group by column",children:(0,he.jsx)(In,{fields:s.value||[],query:e,onQueryChange:n,db:t})})}),r.order&&(0,he.jsx)(dt,{children:(0,he.jsx)(xn,{fields:s.value||[],query:e,onQueryChange:n,db:t})}),r.preview&&e.rawSql&&(0,he.jsx)(dt,{children:(0,he.jsx)(sn,{rawSql:e.rawSql,datasourceType:null===(a=e.datasource)||void 0===a?void 0:a.type})})]}),(0,he.jsx)(en,{db:t,query:e,onValidate:o,range:i})]})};function m_(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function b_(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){m_(i,n,o,a,s,"next",e)}function s(e){m_(i,n,o,a,s,"throw",e)}a(void 0)}))}}function E_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function O_({datasource:e,query:t,onChange:r,onRunQuery:n,range:o,queryHeaderProps:i}){var a,s,l,u,c,d;const[p,f]=(0,ge.useState)(!0),v=e.getDB(),{preconfiguredDatabase:h}=e;var g;const y=null!==(g=null==i?void 0:i.dialect)&&void 0!==g?g:"other",{loading:m,error:b}=Oe(b_((function*(){return()=>{void 0!==e.getDB(e.id).init&&e.getDB(e.id).init()}})),[e]),E=Ce(t),[O,S]=(0,ge.useState)({filter:!!(null===(a=E.sql)||void 0===a?void 0:a.whereString),group:!!(null===(u=E.sql)||void 0===u||null===(l=u.groupBy)||void 0===l||null===(s=l[0])||void 0===s?void 0:s.property.name),order:!!(null===(d=E.sql)||void 0===d||null===(c=d.orderBy)||void 0===c?void 0:c.property.name),preview:!0}),[T,_]=(0,ge.useState)(E);(0,ge.useEffect)((()=>()=>{void 0!==e.getDB(e.id).dispose&&e.getDB(e.id).dispose()}),[e]);const w=(0,ge.useCallback)((e=>{S_(e)&&n&&n()}),[n]),R=(e,t=!0)=>{var n,o,i,a;_(e),r(e),we(null===(n=e.sql)||void 0===n?void 0:n.columns)&&(null===(o=e.sql)||void 0===o?void 0:o.columns.some((e=>e.name)))&&!O.group&&S((i=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){E_(e,t,r[t])}))}return e}({},O),a=null!=(a={group:!0})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i)),t&&w(e)};return m||b?null:(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(Ft,{db:v,preconfiguredDataset:h,onChange:e=>{_(e),r(e)},onRunQuery:n,onQueryRowChange:S,queryRowFilter:O,query:E,isQueryRunnable:p,dialect:y}),(0,he.jsx)(_e.Space,{v:.5}),E.editorMode!==de.Code&&(0,he.jsx)(y_,{db:v,query:E,onChange:e=>R(e,!1),queryRowFilter:O,onValidate:f,range:o}),E.editorMode===de.Code&&(0,he.jsx)(tn,{db:v,query:E,queryToValidate:T,onChange:R,onRunQuery:n,onValidate:f,range:o})]})}const S_=e=>Boolean(e.rawSql);function T_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function __(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){T_(e,t,r[t])}))}return e}function w_(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function R_(e){const t="string"==typeof e.rawQuery?e.rawQuery:null;if(!t)return e;var r;const n=Ce(w_(__({refId:"Annotation"},null!==(r=e.target)&&void 0!==r?r:{}),{rawSql:t}));return w_(__({},e),{rawQuery:void 0,workspace:void 0,subscription:void 0,queryType:void 0,target:n})}function I_(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function A_(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){I_(i,n,o,a,s,"next",e)}function s(e){I_(i,n,o,a,s,"throw",e)}a(void 0)}))}}function C_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function N_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){C_(e,t,r[t])}))}return e}function L_(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}class P_ extends pe.DataSourceWithBackend{getResponseParser(){return this.responseParser}interpolateVariablesInQueries(e,t){let r=e;return e&&e.length>0&&(r=e.map((e=>L_(N_({},e),{datasource:this.getRef(),rawSql:this.templateSrv.replace(e.rawSql,t,this.interpolateVariable),rawQuery:!0})))),r}filterQuery(e){return!e.hide}applyTemplateVariables(e,t){return{refId:e.refId,datasource:this.getRef(),rawSql:this.templateSrv.replace(e.rawSql,t,this.interpolateVariable),format:e.format}}query(e){if(_t()){const t=this.checkForDatabaseIssue(e);if(t){const e=new Error(t);return(0,R.throwError)((()=>e))}}return e.targets.forEach((t=>{var r;e.app!==T.CoreApp.Dashboard&&e.app!==T.CoreApp.PanelViewer&&(0,pe.reportInteraction)("grafana_sql_query_executed",{datasource:null===(r=t.datasource)||void 0===r?void 0:r.type,editorMode:t.editorMode,format:t.format,app:e.app})})),super.query(e)}checkForDatabaseIssue(e){if("postgres"===this.type&&!this.preconfiguredDatabase)return"You do not currently have a default database configured for this data source. Postgres requires a default\n             database with which to connect. Please configure one through the Data Sources Configuration page, or if you\n             are using a provisioning file, update that configuration file with a default database.";if(e.app!==T.CoreApp.Explore&&this.preconfiguredDatabase)for(const t of e.targets)if(t.editorMode===de.Builder&&t.dataset!==this.preconfiguredDatabase)return"The configuration for this panel's data source has been modified. The previous database used in this panel's\n                   saved query is no longer available. Please update the query to use the new database option.\n                   Previous query parameters will be preserved until the query is updated."}metricFindQuery(e,t){var r=this;return A_((function*(){const n=null==t?void 0:t.range;if(null==n)return[];let o="tempvar";t&&t.variable&&t.variable.name&&(o=t.variable.name);const i=N_({},null==t?void 0:t.scopedVars,(0,T.getSearchFilterScopedVar)({query:e,wildcardChar:"%",options:t})),a=r.templateSrv.replace(e,i,r.interpolateVariable),s={refId:o,datasource:r.getRef(),rawSql:a,format:S.Table};let l;try{l=yield r.runMetaQuery(s,n)}catch(e){throw console.error(e),new Error("error when executing the sql query")}return r.getResponseParser().transformMetricFindResponse(l)}))()}runSql(e,t){var r=this;return A_((function*(){const n=(0,T.getDefaultTimeRange)(),o=yield r.runMetaQuery({rawSql:e,format:S.Table,refId:null==t?void 0:t.refId},n);return new T.DataFrameView(o)}))()}runMetaQuery(e,t){const r=e.refId||"meta",n=[L_(N_({},e),{datasource:e.datasource||this.getRef(),refId:r})];return(0,R.lastValueFrom)((0,pe.getBackendSrv)().fetch({url:"/api/ds/query",method:"POST",headers:this.getRequestHeaders(),data:{from:t.from.valueOf().toString(),to:t.to.valueOf().toString(),queries:n},requestId:r}).pipe(re((e=>{var t;return null!==(t=(0,pe.toDataQueryResponse)(e,n).data[0])&&void 0!==t?t:{fields:[]}}))))}targetContainsTemplate(e){let t=e.rawSql;return Fn.forEach((e=>{t=(null==t?void 0:t.replace(e,""))||""})),this.templateSrv.containsTemplate(t)}constructor(e,t=(0,pe.getTemplateSrv)()){super(e),C_(this,"templateSrv",void 0),C_(this,"id",void 0),C_(this,"responseParser",void 0),C_(this,"name",void 0),C_(this,"interval",void 0),C_(this,"db",void 0),C_(this,"preconfiguredDatabase",void 0),C_(this,"interpolateVariable",void 0),this.templateSrv=t,this.interpolateVariable=(e,t)=>"string"==typeof e?t.multi||t.includeAll?this.getQueryModel().quoteLiteral(e):String(e).replace(/'/g,"''"):"number"==typeof e?e:Array.isArray(e)?e.map((e=>this.getQueryModel().quoteLiteral(e))).join(","):e,this.name=e.name,this.responseParser=new ve,this.id=e.id;const r=e.jsonData||{};var n;this.interval=r.timeInterval||"1m",this.db=this.getDB(),this.preconfiguredDatabase=null!==(n=r.database)&&void 0!==n?n:"",this.annotations={prepareAnnotation:R_,QueryEditor:O_}}}var x_=Object.defineProperty,j_=Object.defineProperties,F_=Object.getOwnPropertyDescriptors,D_=Object.getOwnPropertySymbols,k_=Object.prototype.hasOwnProperty,M_=Object.prototype.propertyIsEnumerable,V_=(e,t,r)=>t in e?x_(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,U_=(e,t)=>{for(var r in t||(t={}))k_.call(t,r)&&V_(e,r,t[r]);if(D_)for(var r of D_(t))M_.call(t,r)&&V_(e,r,t[r]);return e};const B_=({children:e,title:t,description:r,isCollapsible:n=!1,isInitiallyOpen:o=!0,kind:i="section",className:a})=>{const{colors:s,typography:l,spacing:u}=(0,_e.useTheme2)(),[c,d]=(0,ge.useState)(!n||o),p=c?"angle-up":"angle-down",f="sub-section"===i,v=`${c?"Collapse":"Expand"} section ${t}`,h={header:(0,Ge.css)({display:"flex",justifyContent:"space-between",alignItems:"center"}),title:(0,Ge.css)({margin:0}),subtitle:(0,Ge.css)({margin:0,fontWeight:l.fontWeightRegular}),descriptionText:(0,Ge.css)((g=U_({marginTop:u(f?.25:.5),marginBottom:0},l.bodySmall),y={color:s.text.secondary},j_(g,F_(y)))),content:(0,Ge.css)({marginTop:u(2)})};var g,y;return ye().createElement("div",{className:a},ye().createElement("div",{className:h.header},"section"===i?ye().createElement("h3",{className:h.title},t):ye().createElement("h6",{className:h.subtitle},t),n&&ye().createElement(_e.IconButton,{name:p,onClick:()=>d(!c),type:"button",size:"xl","aria-label":v})),r&&ye().createElement("p",{className:h.descriptionText},r),c&&ye().createElement("div",{className:h.content},e))};var G_=Object.defineProperty,$_=Object.defineProperties,q_=Object.getOwnPropertyDescriptors,K_=Object.getOwnPropertySymbols,W_=Object.prototype.hasOwnProperty,z_=Object.prototype.propertyIsEnumerable,H_=(e,t,r)=>t in e?G_(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const Y_=e=>{var t,r=e,{children:n}=r,o=((e,t)=>{var r={};for(var n in e)W_.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&K_)for(var n of K_(e))t.indexOf(n)<0&&z_.call(e,n)&&(r[n]=e[n]);return r})(r,["children"]);return ye().createElement(B_,(t=((e,t)=>{for(var r in t||(t={}))W_.call(t,r)&&H_(e,r,t[r]);if(K_)for(var r of K_(t))z_.call(t,r)&&H_(e,r,t[r]);return e})({},o),$_(t,q_({kind:"sub-section"}))),n)};function Q_({value:e,defaultValue:t,onChange:r,width:n}){const[o,i]=(0,ge.useState)(!1);return(0,he.jsx)(_e.Input,{type:"number",placeholder:String(t),value:o?"":e,onChange:e=>{var n;if(""===(null===(n=e.currentTarget.value)||void 0===n?void 0:n.trim()))i(!0),r(t);else{i(!1);const t=Number(e.currentTarget.value);Number.isNaN(t)||r(t)}},width:n})}function X_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function J_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){X_(e,t,r[t])}))}return e}const Z_=e=>{const{onOptionsChange:t,options:r}=e,n=r.jsonData,o=void 0!==n.maxIdleConnsAuto&&n.maxIdleConnsAuto,i=e=>{const o=(i=J_({},r),a=null!=(a={jsonData:J_({},n,e)})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i);var i,a;return t(o)},a=e=>t=>{i({[e]:t})};return(0,he.jsxs)(Y_,{title:"Connection limits",children:[(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(ut,{gap:.5,children:[(0,he.jsx)("span",{children:"Max open"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsxs)("span",{children:["The maximum number of open connections to the database. If ",(0,he.jsx)("i",{children:"Max idle connections"})," is greater than 0 and the ",(0,he.jsx)("i",{children:"Max open connections"})," is less than ",(0,he.jsx)("i",{children:"Max idle connections"}),", then",(0,he.jsx)("i",{children:"Max idle connections"})," will be reduced to match the ",(0,he.jsx)("i",{children:"Max open connections"})," limit. If set to 0, there is no limit on the number of open connections."]}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(Q_,{value:n.maxOpenConns,defaultValue:pe.config.sqlConnectionLimits.maxOpenConns,onChange:e=>{var t;t=e,i(o&&t?{maxOpenConns:t,maxIdleConns:t}:{maxOpenConns:t})},width:40})}),(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(ut,{gap:.5,children:[(0,he.jsx)("span",{children:"Auto max idle"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsxs)("span",{children:["If enabled, automatically set the number of ",(0,he.jsx)("i",{children:"Maximum idle connections"})," to the same value as",(0,he.jsx)("i",{children:" Max open connections"}),". If the number of maximum open connections is not set it will be set to the default (",pe.config.sqlConnectionLimits.maxIdleConns,")."]}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(_e.Switch,{value:o,onChange:()=>{let e,t;o?(t=n.maxOpenConns,e=n.maxIdleConns):void 0!==n.maxOpenConns&&(t=n.maxOpenConns,e=n.maxOpenConns),i({maxIdleConnsAuto:!o,maxIdleConns:e,maxOpenConns:t})}})}),(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(ut,{gap:.5,children:[(0,he.jsx)("span",{children:"Max idle"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsxs)("span",{children:["The maximum number of connections in the idle connection pool.If ",(0,he.jsx)("i",{children:"Max open connections"})," is greater than 0 but less than the ",(0,he.jsx)("i",{children:"Max idle connections"}),", then the ",(0,he.jsx)("i",{children:"Max idle connections"})," ","will be reduced to match the ",(0,he.jsx)("i",{children:"Max open connections"})," limit. If set to 0, no idle connections are retained."]}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:o?(0,he.jsx)(_e.InlineLabel,{width:40,children:r.jsonData.maxIdleConns}):(0,he.jsx)(Q_,{value:n.maxIdleConns,defaultValue:pe.config.sqlConnectionLimits.maxIdleConns,onChange:e=>{a("maxIdleConns")(e)},width:40})}),(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(ut,{gap:.5,children:[(0,he.jsx)("span",{children:"Max lifetime"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsx)("span",{children:"The maximum amount of time in seconds a connection may be reused. If set to 0, connections are reused forever."}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(Q_,{value:n.connMaxLifetime,defaultValue:pe.config.sqlConnectionLimits.connMaxLifetime,onChange:e=>{a("connMaxLifetime")(e)},width:40})})]})},ew=()=>{const e=(0,_e.useStyles2)(tw);return(0,he.jsx)("hr",{className:e.horizontalDivider})},tw=e=>({horizontalDivider:(0,Ge.css)({borderTop:`1px solid ${e.colors.border.weak}`,margin:e.spacing(2,0),width:"100%"})}),rw=e=>{const{editorProps:t,showCACert:r,showKeyPair:n=!0}=e,{secureJsonFields:o}=t.options;return(0,he.jsxs)(he.Fragment,{children:[n?(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(_e.Stack,{gap:.5,children:[(0,he.jsx)("span",{children:"TLS/SSL Client Certificate"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsx)("span",{children:"To authenticate with an TLS/SSL client certificate, provide the client certificate here."}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(_e.SecretTextArea,{placeholder:"-----BEGIN CERTIFICATE-----",cols:45,rows:7,isConfigured:o&&o.tlsClientCert,onChange:(0,T.onUpdateDatasourceSecureJsonDataOption)(t,"tlsClientCert"),onReset:()=>{(0,T.updateDatasourcePluginResetOption)(t,"tlsClientCert")}})}):null,r?(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(_e.Stack,{gap:.5,children:[(0,he.jsx)("span",{children:"TLS/SSL Root Certificate"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsx)("span",{children:"If the selected TLS/SSL mode requires a server root certificate, provide it here."}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(_e.SecretTextArea,{placeholder:"-----BEGIN CERTIFICATE-----",cols:45,rows:7,isConfigured:o&&o.tlsCACert,onChange:(0,T.onUpdateDatasourceSecureJsonDataOption)(t,"tlsCACert"),onReset:()=>{(0,T.updateDatasourcePluginResetOption)(t,"tlsCACert")}})}):null,n?(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(_e.Stack,{gap:.5,children:[(0,he.jsx)("span",{children:"TLS/SSL Client Key"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsx)("span",{children:"To authenticate with a client TLS/SSL certificate, provide the key here."}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(_e.SecretTextArea,{placeholder:"-----BEGIN RSA PRIVATE KEY-----",cols:45,rows:7,isConfigured:o&&o.tlsClientKey,onChange:(0,T.onUpdateDatasourceSecureJsonDataOption)(t,"tlsClientKey"),onReset:()=>{(0,T.updateDatasourcePluginResetOption)(t,"tlsClientKey")}})}):null]})},nw=(0,pe.createMonitoringLogger)("features.plugins.sql");function ow(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function iw(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){ow(e,t,r[t])}))}return e}function aw(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function sw(e){return{ulPadding:(0,Ge.css)({margin:e.spacing(1,0),paddingLeft:e.spacing(5)})}}function lw(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function uw(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){lw(e,t,r[t])}))}return e}function cw(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function dw(e){switch(e){case"TIME":case"DATETIME":case"TIMESTAMP":return"clock-nine";case"BOOLEAN":return"toggle-off";case"INTEGER":case"FLOAT":case"FLOAT64":case"INT":case"SMALLINT":case"BIGINT":case"TINYINT":case"BYTEINT":case"INT64":case"NUMERIC":case"DECIMAL":return"calculator-alt";case"CHAR":case"VARCHAR":case"STRING":case"BYTES":case"TEXT":case"TINYTEXT":case"MEDIUMTEXT":case"LONGTEXT":return"text";case"GEOGRAPHY":return"map";default:return}}function pw({sql:e,dataset:t,table:r}){var n,o,i,a;let s="";return e&&we(e.columns)?(s+=`SELECT ${e.columns.map((e=>{let t="";var r;if(e.name&&e.alias)t+=`${e.name}(${null===(r=e.parameters)||void 0===r?void 0:r.map((e=>`${e.name}`))}) AS ${e.alias}`;else if(e.name){var n;t+=`${e.name}(${null===(n=e.parameters)||void 0===n?void 0:n.map((e=>`${e.name}`))})`}else if(e.alias){var o;t+=`${null===(o=e.parameters)||void 0===o?void 0:o.map((e=>`${e.name}`))} AS ${e.alias}`}else{var i;t+=`${null===(i=e.parameters)||void 0===i?void 0:i.map((e=>`${e.name}`))}`}return t})).join(", ")} `,t&&r&&(s+=`FROM ${t}.${r} `),e.whereString&&(s+=`WHERE ${e.whereString} `),(null===(o=e.groupBy)||void 0===o||null===(n=o[0])||void 0===n?void 0:n.property.name)&&(s+=`GROUP BY ${e.groupBy.map((e=>e.property.name)).filter((e=>!(0,fe.isEmpty)(e))).join(", ")} `),(null===(i=e.orderBy)||void 0===i?void 0:i.property.name)&&(s+=`ORDER BY ${e.orderBy.property.name} `),(null===(a=e.orderBy)||void 0===a?void 0:a.property.name)&&e.orderByDirection&&(s+=`${e.orderByDirection} `),void 0!==e.limit&&e.limit>=0&&(s+=`LIMIT ${e.limit} `),s):s}function fw(e){return function(e){const t=/^[a-zA-Z_][a-zA-Z0-9_$]*$/g.test(e);return!hw.includes(e.toUpperCase())&&t}(e)?e:`\`${e}\``}function vw(e){return"'"+e.replace(/'/g,"''")+"'"}const hw=["ACCESSIBLE","ADD","ALL","ALTER","ANALYZE","AND","AS","ASC","ASENSITIVE","BEFORE","BETWEEN","BIGINT","BINARY","BLOB","BOTH","BY","CALL","CASCADE","CASE","CHANGE","CHAR","CHARACTER","CHECK","COLLATE","COLUMN","CONDITION","CONSTRAINT","CONTINUE","CONVERT","CREATE","CROSS","CUBE","CUME_DIST","CURRENT_DATE","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_USER","CURSOR","DATABASE","DATABASES","DAY_HOUR","DAY_MICROSECOND","DAY_MINUTE","DAY_SECOND","DEC","DECIMAL","DECLARE","DEFAULT","DELAYED","DELETE","DENSE_RANK","DESC","DESCRIBE","DETERMINISTIC","DISTINCT","DISTINCTROW","DIV","DOUBLE","DROP","DUAL","EACH","ELSE","ELSEIF","EMPTY","ENCLOSED","ESCAPED","EXCEPT","EXISTS","EXIT","EXPLAIN","FALSE","FETCH","FIRST_VALUE","FLOAT","FLOAT4","FLOAT8","FOR","FORCE","FOREIGN","FROM","FULLTEXT","FUNCTION","GENERATED","GET","GRANT","GROUP","GROUPING","GROUPS","HAVING","HIGH_PRIORITY","HOUR_MICROSECOND","HOUR_MINUTE","HOUR_SECOND","IF","IGNORE","IN","INDEX","INFILE","INNER","INOUT","INSENSITIVE","INSERT","INT","INT1","INT2","INT3","INT4","INT8","INTEGER","INTERSECT","INTERVAL","INTO","IO_AFTER_GTIDS","IO_BEFORE_GTIDS","IS","ITERATE","JOIN","JSON_TABLE","KEY","KEYS","KILL","LAG","LAST_VALUE","LATERAL","LEAD","LEADING","LEAVE","LEFT","LIKE","LIMIT","LINEAR","LINES","LOAD","LOCALTIME","LOCALTIMESTAMP","LOCK","LONG","LONGBLOB","LONGTEXT","LOOP","LOW_PRIORITY","MASTER_BIND","MASTER_SSL_VERIFY_SERVER_CERT","MATCH","MAXVALUE","MEDIUMBLOB","MEDIUMINT","MEDIUMTEXT","MIDDLEINT","MINUTE_MICROSECOND","MINUTE_SECOND","MOD","MODIFIES","NATURAL","NOT","NO_WRITE_TO_BINLOG","NTH_VALUE","NTILE","NULL","NUMERIC","OF","ON","OPTIMIZE","OPTIMIZER_COSTS","OPTION","OPTIONALLY","OR","ORDER","OUT","OUTER","OUTFILE","OVER","PARTITION","PERCENT_RANK","PRECISION","PRIMARY","PROCEDURE","PURGE","RANGE","RANK","READ","READS","READ_WRITE","REAL","RECURSIVE","REFERENCES","REGEXP","RELEASE","RENAME","REPEAT","REPLACE","REQUIRE","RESIGNAL","RESTRICT","RETURN","REVOKE","RIGHT","RLIKE","ROW","ROWS","ROW_NUMBER","SCHEMA","SCHEMAS","SECOND_MICROSECOND","SELECT","SENSITIVE","SEPARATOR","SET","SHOW","SIGNAL","SMALLINT","SPATIAL","SPECIFIC","SQL","SQLEXCEPTION","SQLSTATE","SQLWARNING","SQL_BIG_RESULT","SQL_CALC_FOUND_ROWS","SQL_SMALL_RESULT","SSL","STARTING","STORED","STRAIGHT_JOIN","SYSTEM","TABLE","TERMINATED","THEN","TINYBLOB","TINYINT","TINYTEXT","TO","TRAILING","TRIGGER","TRUE","UNDO","UNION","UNIQUE","UNLOCK","UNSIGNED","UPDATE","USAGE","USE","USING","UTC_DATE","UTC_TIME","UTC_TIMESTAMP","VALUES","VARBINARY","VARCHAR","VARCHARACTER","VARYING","VIRTUAL","WHEN","WHERE","WHILE","WINDOW","WITH","WRITE","XOR","YEAR_MONTH","ZEROFILL"];function gw(e){return vw(function(e){return'"'===e[0]&&'"'===e[e.length-1]?e.substring(1,e.length-1).replace(/""/g,'"'):"`"===e[0]&&"`"===e[e.length-1]?e.substring(1,e.length-1):e}(e))}function yw(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function mw(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){yw(i,n,o,a,s,"next",e)}function s(e){yw(i,n,o,a,s,"throw",e)}a(void 0)}))}}function bw(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Ew(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){bw(e,t,r[t])}))}return e}function Ow(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Sw=({getMeta:e})=>(t,r)=>Ow(Ew({},r&&Lr(0,r)),{customStatementPlacement:ww,customSuggestionKinds:Rw(e)}),Tw="afterDatabase",_w="FROM",ww=()=>[{id:Tw,resolve:(e,t,r)=>{var n;return Boolean((null==e?void 0:e.is(ie.Delimiter,"."))&&(null==t?void 0:t.value)===_w&&((null==r?void 0:r.is(ie.IdentifierQuote))||(null==r?void 0:r.isIdentifier()))&&1===(null==e||null===(n=e.getPreviousUntil(ie.Keyword,[ie.IdentifierQuote],_w))||void 0===n?void 0:n.filter((e=>e.isIdentifier())).length))}}],Rw=e=>()=>{return[{id:se.Tables,overrideDefault:!0,suggestionsResolver:(t=mw((function*(t){const r=Aw(t.currentToken);return(yield e({schema:r})).map(Iw(t))})),function(e){return t.apply(this,arguments)})},{id:se.Columns,overrideDefault:!0,suggestionsResolver:function(){var t=mw((function*(t){const r=Cw(t.currentToken),n=Aw(r),o=function(e){const t=null==e?void 0:e.getNextOfType(ie.Identifier);return null==t?void 0:t.value}(r);return n&&o?(yield e({schema:n,table:o})).map(Iw(t)):[]}));return function(e){return t.apply(this,arguments)}}()},{id:"tablesWithinDatabase",applyTo:[Tw],suggestionsResolver:function(){var t=mw((function*(t){const r=Aw(t.currentToken);return(yield e({schema:r})).map(Iw(t))}));return function(e){return t.apply(this,arguments)}}()}];var t};function Iw(e){return function(t){var r;return{label:t.name,insertText:null!==(r=t.completion)&&void 0!==r?r:t.name,command:{id:"editor.action.triggerSuggest",title:""},kind:ue.Field,sortText:le.High,range:Ow(Ew({},e.range),{startColumn:e.range.endColumn,endColumn:e.range.endColumn})}}}function Aw(e){return(null==e?void 0:e.isIdentifier())&&"."!==e.value[e.value.length-1]?e.value:(null==e?void 0:e.is(ie.Delimiter,"."))?null===(t=e.getPreviousOfType(ie.Identifier))||void 0===t?void 0:t.value:(null==e?void 0:e.is(ie.IdentifierQuote))?(null===(r=e.getPreviousOfType(ie.Identifier))||void 0===r?void 0:r.value)||(null===(n=e.getNextOfType(ie.Identifier))||void 0===n?void 0:n.value):void 0;var t,r,n}const Cw=e=>{var t;const r=(e=>{var t;const r=null!==(t=null==e?void 0:e.getPreviousOfType(ie.Keyword,"SELECT"))&&void 0!==t?t:null;return null==r?void 0:r.getNextOfType(ie.Keyword,_w)})(e),n=null==r?void 0:r.getNextOfType(ie.Identifier);return(null==n?void 0:n.isKeyword())&&(null===(t=n.next)||void 0===t?void 0:t.is(ie.Parenthesis,"("))?null:n};function Nw(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function Lw(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Nw(i,n,o,a,s,"next",e)}function s(e){Nw(i,n,o,a,s,"throw",e)}a(void 0)}))}}function Pw(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}var xw=Object.defineProperty,jw=Object.defineProperties,Fw=Object.getOwnPropertyDescriptors,Dw=Object.getOwnPropertySymbols,kw=Object.prototype.hasOwnProperty,Mw=Object.prototype.propertyIsEnumerable,Vw=(e,t,r)=>t in e?xw(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,Uw=(e,t)=>{for(var r in t||(t={}))kw.call(t,r)&&Vw(e,r,t[r]);if(Dw)for(var r of Dw(t))Mw.call(t,r)&&Vw(e,r,t[r]);return e};const Bw=({dataSourceName:e,docsLink:t,hasRequiredFields:r=!0,className:n})=>{const o=(0,_e.useTheme2)(),i={container:(0,Ge.css)({p:{margin:0},"p + p":{marginTop:o.spacing(2)}}),text:(0,Ge.css)((a=Uw({},o.typography.body),s={color:o.colors.text.secondary,a:(0,Ge.css)({color:o.colors.text.link,textDecoration:"underline","&:hover":{textDecoration:"none"}})},jw(a,Fw(s))))};var a,s;return ye().createElement("div",{className:(0,Ge.cx)(i.container,n)},ye().createElement("p",{className:i.text},"Before you can use the ",e," data source, you must configure it below or in the config file. For detailed instructions,"," ",ye().createElement("a",{href:t,target:"_blank",rel:"noreferrer"},"view the documentation"),"."),r&&ye().createElement("p",{className:i.text},ye().createElement("i",null,"Fields marked with * are required")))};var Gw=Object.defineProperty,$w=Object.defineProperties,qw=Object.getOwnPropertyDescriptors,Kw=Object.getOwnPropertySymbols,Ww=Object.prototype.hasOwnProperty,zw=Object.prototype.propertyIsEnumerable,Hw=(e,t,r)=>t in e?Gw(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const Yw=e=>{var t,r=e,{children:n}=r,o=((e,t)=>{var r={};for(var n in e)Ww.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&Kw)for(var n of Kw(e))t.indexOf(n)<0&&zw.call(e,n)&&(r[n]=e[n]);return r})(r,["children"]);return ye().createElement(B_,(t=((e,t)=>{for(var r in t||(t={}))Ww.call(t,r)&&Hw(e,r,t[r]);if(Kw)for(var r of Kw(t))zw.call(t,r)&&Hw(e,r,t[r]);return e})({},o),$w(t,qw({kind:"section"}))),n)};function Qw(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const Xw=new T.DataSourcePlugin(class extends P_{getQueryModel(){return{quoteLiteral:vw}}getSqlLanguageDefinition(){if(void 0!==this.sqlLanguageDefinition)return this.sqlLanguageDefinition;const e={getMeta:e=>this.fetchMeta(e)};return this.sqlLanguageDefinition={id:"mysql",completionProvider:Sw(e),formatter:an},this.sqlLanguageDefinition}fetchDatasets(){var e=this;return Lw((function*(){return(yield e.runSql("SELECT DISTINCT TABLE_SCHEMA from information_schema.TABLES where TABLE_TYPE != 'SYSTEM VIEW' ORDER BY TABLE_SCHEMA",{refId:"datasets"})).map((e=>fw(e[0])))}))()}fetchTables(e){var t=this;return Lw((function*(){const r=yield t.runSql(function(e){return`SELECT table_name FROM information_schema.tables WHERE table_schema = ${void 0!==e?gw(e):"database()"} ORDER BY table_name`}(e),{refId:"tables"});return r.map((e=>fw(e[0])))}))()}fetchFields(e){var t=this;return Lw((function*(){if(!e.dataset||!e.table)return[];const r=function(e,t){let r="SELECT column_name, data_type FROM information_schema.columns WHERE ";return r+=function(e,t){let r="";if(e.includes(".")){const t=e.split(".");return r="table_schema = "+gw(t[0]),r+=" AND table_name = "+gw(t[1]),r}return r=`table_schema = ${void 0!==t?gw(t):"database()"} AND table_name = `+gw(e),r}(e,t),r+=" ORDER BY column_name",r}(e.table,e.dataset);return function(e){const t=[];for(const n of e){var r;let e="text";switch(null===(r=n.type)||void 0===r?void 0:r.toUpperCase()){case"BOOLEAN":case"BOOL":e="boolean";break;case"BYTES":case"VARCHAR":case"GEOGRAPHY":e="text";break;case"FLOAT":case"FLOAT64":case"INT":case"INTEGER":case"INT64":case"NUMERIC":case"BIGNUMERIC":e="number";break;case"DATE":e="date";break;case"DATETIME":case"TIMESTAMP":e="datetime";break;case"TIME":e="time"}t.push(cw(uw({},n),{raqbFieldType:e,icon:dw(n.type.toUpperCase())}))}return t}((yield t.runSql(r,{refId:"fields"})).map((e=>({name:e[0],text:e[0],value:fw(e[0]),type:e[1],label:e[0]}))))}))()}fetchMeta(e){var t=this;return Lw((function*(){const r=t.instanceSettings.jsonData.database;return!(null==e?void 0:e.schema)&&r?(yield t.fetchTables(r)).map((e=>({name:e,completion:`${r}.${e}`,kind:ue.Class}))):(null==e?void 0:e.schema)||r?(null==e?void 0:e.table)||r&&!(null==e?void 0:e.schema)?(null==e?void 0:e.table)&&e.schema?(yield t.fetchFields({dataset:e.schema,table:e.table})).map((e=>({name:e.name,completion:e.value,kind:ue.Field}))):[]:(yield t.fetchTables(null==e?void 0:e.schema)).map((e=>({name:e,completion:e,kind:ue.Class}))):(yield t.fetchDatasets()).map((e=>({name:e,completion:`${e}.`,kind:ue.Module})))}))()}getDB(){return void 0!==this.db?this.db:{datasets:()=>this.fetchDatasets(),tables:e=>this.fetchTables(e),fields:e=>this.fetchFields(e),validateQuery:(e,t)=>Promise.resolve({query:e,error:"",isError:!1,isValid:!0}),dsID:()=>this.id,toRawSql:pw,functions:()=>["VARIANCE","STDDEV"],getEditorLanguageDefinition:()=>this.getSqlLanguageDefinition()}}constructor(e){super(e),Pw(this,"instanceSettings",void 0),Pw(this,"sqlLanguageDefinition",void 0),this.instanceSettings=e}}).setQueryEditor(O_).setQueryEditorHelp((function(){const e=(0,_e.useStyles2)(sw);return(0,he.jsxs)("div",{children:[(0,he.jsx)("h2",{children:"MySQL cheat sheet"}),"Time series:",(0,he.jsxs)("ul",{className:e.ulPadding,children:[(0,he.jsx)("li",{children:"return column named time or time_sec (in UTC), as a unix time stamp or any sql native date data type. You can use the macros below."}),(0,he.jsx)("li",{children:"return column(s) with numeric datatype as values"})]}),"Optional:",(0,he.jsxs)("ul",{className:e.ulPadding,children:[(0,he.jsxs)("li",{children:["return column named ",(0,he.jsx)("i",{children:"metric"})," to represent the series name."]}),(0,he.jsx)("li",{children:"If multiple value columns are returned the metric column is used as prefix."}),(0,he.jsx)("li",{children:"If no column named metric is found the column name of the value column is used as series name"})]}),(0,he.jsx)("p",{children:"Resultsets of time series queries need to be sorted by time."}),"Table:",(0,he.jsx)("ul",{className:e.ulPadding,children:(0,he.jsx)("li",{children:"return any set of columns"})}),"Macros:",(0,he.jsxs)("ul",{className:e.ulPadding,children:[(0,he.jsx)("li",{children:"$__time(column) -> UNIX_TIMESTAMP(column) as time_sec"}),(0,he.jsx)("li",{children:"$__timeEpoch(column) -> UNIX_TIMESTAMP(column) as time_sec"}),(0,he.jsx)("li",{children:"$__timeFilter(column) -> column BETWEEN FROM_UNIXTIME(1492750877) AND FROM_UNIXTIME(1492750877)"}),(0,he.jsx)("li",{children:"$__unixEpochFilter(column) -> time_unix_epoch > 1492750877 AND time_unix_epoch < 1492750877"}),(0,he.jsx)("li",{children:"$__unixEpochNanoFilter(column) -> column >= 1494410783152415214 AND column <= 1494497183142514872"}),(0,he.jsx)("li",{children:"$__timeGroup(column,'5m'[, fillvalue]) -> cast(cast(UNIX_TIMESTAMP(column)/(300) as signed)*300 as signed) by setting fillvalue grafana will fill in missing values according to the interval fillvalue can be either a literal value, NULL or previous; previous will fill in the previous seen value or NULL if none has been seen yet"}),(0,he.jsx)("li",{children:"$__timeGroupAlias(column,'5m') -> cast(cast(UNIX_TIMESTAMP(column)/(300) as signed)*300 as signed) AS \"time\""}),(0,he.jsx)("li",{children:"$__unixEpochGroup(column,'5m') -> column DIV 300 * 300"}),(0,he.jsx)("li",{children:"$__unixEpochGroupAlias(column,'5m') -> column DIV 300 * 300 AS \"time\""})]}),(0,he.jsx)("p",{children:"Example of group by and order by with $__timeGroup:"}),(0,he.jsx)("pre",{children:(0,he.jsxs)("code",{children:["$__timeGroupAlias(timestamp_col, '1h'), sum(value_double) as value",(0,he.jsx)("br",{}),"FROM yourtable",(0,he.jsx)("br",{}),"GROUP BY 1",(0,he.jsx)("br",{}),"ORDER BY 1",(0,he.jsx)("br",{})]})}),"Or build your own conditionals using these macros which just return the values:",(0,he.jsxs)("ul",{className:e.ulPadding,children:[(0,he.jsx)("li",{children:"$__timeFrom() -> FROM_UNIXTIME(1492750877)"}),(0,he.jsx)("li",{children:"$__timeTo() -> FROM_UNIXTIME(1492750877)"}),(0,he.jsx)("li",{children:"$__unixEpochFrom() -> 1492750877"}),(0,he.jsx)("li",{children:"$__unixEpochTo() -> 1492750877"}),(0,he.jsx)("li",{children:"$__unixEpochNanoFrom() -> 1494410783152415214"}),(0,he.jsx)("li",{children:"$__unixEpochNanoTo() -> 1494497183142514872"})]})]})})).setConfigEditor((e=>{const[t,r]=(0,ge.useState)(!0),{options:n,onOptionsChange:o}=e,i=n.jsonData;!function({onOptionsChange:e,options:t}){(0,ge.useEffect)((()=>{const r=t.jsonData;let n=iw({},t),o=!1;if(t.database&&(nw.logDebug(`Migrating from options.database with value ${t.database} for ${t.name}`),n.database="",n.jsonData=aw(iw({},r),{database:t.database}),o=!0),void 0===r.maxOpenConns&&void 0===r.maxIdleConns&&void 0===r.maxIdleConnsAuto){const{maxOpenConns:e,maxIdleConns:t}=pe.config.sqlConnectionLimits;nw.logDebug(`Setting default max open connections to ${e} and setting max idle connection to ${t}`),n.jsonData=aw(iw({},n.jsonData),{maxOpenConns:e,maxIdleConns:t,maxIdleConnsAuto:!0}),o=!0}if(void 0===r.connMaxLifetime){const{connMaxLifetime:e}=pe.config.sqlConnectionLimits;n.jsonData=aw(iw({},n.jsonData),{connMaxLifetime:e}),o=!0}o&&e(n)}),[e,t])}(e);const a=e=>t=>{o(function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Qw(e,t,r[t])}))}return e}({},n,{[e]:t.currentTarget.value}))},s=t=>r=>{(0,T.updateDatasourcePluginJsonDataOption)(e,t,r.currentTarget.checked)},l=40;return(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(Bw,{dataSourceName:"MySQL",docsLink:"https://grafana.com/docs/grafana/latest/datasources/mysql/",hasRequiredFields:!0}),(0,he.jsx)(ew,{}),(0,he.jsxs)(_e.Collapse,{collapsible:!0,label:"User Permission",isOpen:t,onToggle:()=>r((e=>!e)),children:["The database user should only be granted SELECT permissions on the specified database & tables you want to query. ",(0,he.jsx)("br",{}),"Grafana does not validate that queries are safe so queries can contain any SQL statement. For example, statements like ",(0,he.jsx)("code",{children:"USE otherdb;"})," and ",(0,he.jsx)("code",{children:"DROP TABLE user;"})," would be executed. ",(0,he.jsx)("br",{}),"To protect against this we ",(0,he.jsx)("strong",{children:"Highly"})," recommend you create a specific MySQL user with restricted permissions. Check out the docs for more information."]}),(0,he.jsx)(ew,{}),(0,he.jsxs)(Yw,{title:"Connection",children:[(0,he.jsx)(_e.Field,{label:"Host URL",required:!0,children:(0,he.jsx)(_e.Input,{width:l,name:"host",type:"text",value:n.url||"",placeholder:"localhost:3306",onChange:a("url")})}),(0,he.jsx)(_e.Field,{label:"Database name",children:(0,he.jsx)(_e.Input,{width:l,name:"database",value:i.database||"",placeholder:"Database",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"database")})})]}),(0,he.jsx)(ew,{}),(0,he.jsxs)(Yw,{title:"Authentication",children:[(0,he.jsx)(_e.Field,{label:"Username",required:!0,children:(0,he.jsx)(_e.Input,{width:l,value:n.user||"",placeholder:"Username",onChange:a("user")})}),(0,he.jsx)(_e.Field,{label:"Password",children:(0,he.jsx)(_e.SecretInput,{width:l,placeholder:"Password",isConfigured:n.secureJsonFields&&n.secureJsonFields.password,onReset:()=>{(0,T.updateDatasourcePluginResetOption)(e,"password")},onBlur:(0,T.onUpdateDatasourceSecureJsonDataOption)(e,"password")})}),(0,he.jsx)(_e.Field,{label:"Use TLS Client Auth",description:"Enables TLS authentication using client cert configured in secure json data.",children:(0,he.jsx)(_e.Switch,{onChange:s("tlsAuth"),value:i.tlsAuth||!1})}),(0,he.jsx)(_e.Field,{label:"With CA Cert",description:"Needed for verifying self-signed TLS Certs.",children:(0,he.jsx)(_e.Switch,{onChange:s("tlsAuthWithCACert"),value:i.tlsAuthWithCACert||!1})}),(0,he.jsx)(_e.Field,{label:"Skip TLS Verification",description:"When enabled, skips verification of the MySQL server's TLS certificate chain and host name.",children:(0,he.jsx)(_e.Switch,{onChange:s("tlsSkipVerify"),value:i.tlsSkipVerify||!1})}),(0,he.jsx)(_e.Field,{label:"Allow Cleartext Passwords",description:"Allows using the cleartext client side plugin if required by an account.",children:(0,he.jsx)(_e.Switch,{onChange:s("allowCleartextPasswords"),value:i.allowCleartextPasswords||!1})})]}),i.tlsAuth||i.tlsAuthWithCACert?(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(ew,{}),(0,he.jsx)(Yw,{title:"TLS/SSL Auth Details",children:i.tlsAuth||i.tlsAuthWithCACert?(0,he.jsx)(rw,{showCACert:i.tlsAuthWithCACert,showKeyPair:i.tlsAuth,editorProps:e,labelWidth:l}):null})]}):null,(0,he.jsx)(ew,{}),(0,he.jsxs)(Yw,{title:"Additional settings",isCollapsible:!0,children:[(0,he.jsxs)(Y_,{title:"MySQL Options",children:[(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(ut,{gap:.5,children:[(0,he.jsx)("span",{children:"Session timezone"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsxs)("span",{children:["Specify the timezone used in the database session, such as ",(0,he.jsx)("code",{children:"Europe/Berlin"})," or",(0,he.jsx)("code",{children:"+02:00"}),". Required if the timezone of the database (or the host of the database) is set to something other than UTC. Set this to ",(0,he.jsx)("code",{children:"+00:00"})," so Grafana can handle times properly. Set the value used in the session with ",(0,he.jsx)("code",{children:"SET time_zone='...'"}),". If you leave this field empty, the timezone will not be updated. You can find more information in the MySQL documentation."]}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(_e.Input,{width:l,value:i.timezone||"",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"timezone"),placeholder:"Europe/Berlin or +02:00"})}),(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(ut,{gap:.5,children:[(0,he.jsx)("span",{children:"Min time interval"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsxs)("span",{children:["A lower limit for the auto group by time interval. Recommended to be set to write frequency, for example",(0,he.jsx)("code",{children:"1m"})," if your data is written every minute."]}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),description:"A lower limit for the auto group by time interval. Recommended to be set to write frequency, for example 1m if your data is written every minute.",children:(0,he.jsx)(_e.Input,{width:l,placeholder:"1m",value:i.timeInterval||"",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"timeInterval")})})]}),(0,he.jsx)(Z_,{options:n,onOptionsChange:o}),pe.config.secureSocksDSProxyEnabled&&(0,he.jsx)(_e.SecureSocksProxySettings,{options:n,onOptionsChange:o})]})]})}))})(),f})()));
//# sourceMappingURL=module.js.map